/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs


/* Copy the first part of user declarations.  */
#line 1 "gram.y" /* yacc.c:339  */


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 2003-2024, PgPool Global Development Group
 * Portions Copyright (c) 1996-2024, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  src/backend/parser/gram.y
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET constraint_exclusion TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */

#include "pool_parser.h"
#include "utils/elog.h"
#include "utils/palloc.h"
#include "utils/pgstrcasecmp.h"
#include <ctype.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "nodes.h"
#include "keywords.h"
#include "gramparse.h"
#include "makefuncs.h"
#include "parser.h"
#include "pg_class.h"
#include "pg_trigger.h"

/*
 * Definition taken from
 * postgreSQL source code file: src/include/commands/trigger.h
 */
#define TRIGGER_FIRES_ON_ORIGIN                         'O'
#define TRIGGER_FIRES_ALWAYS                            'A'
#define TRIGGER_FIRES_ON_REPLICA                        'R'
#define TRIGGER_DISABLED                                'D'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_class.h
 */

#define           REPLICA_IDENTITY_DEFAULT      'd'
#define           REPLICA_IDENTITY_NOTHING      'n'
#define           REPLICA_IDENTITY_FULL         'f'
#define           REPLICA_IDENTITY_INDEX        'i'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/catalog/pg_attribute.h
 */
#define		  ATTRIBUTE_IDENTITY_ALWAYS	'a'
#define		  ATTRIBUTE_IDENTITY_BY_DEFAULT 'd'

/*
 * Definition taken from
 * postgreSQL source code file: src/include/utils/xml.h
 */
typedef enum
{
	XML_STANDALONE_YES,
	XML_STANDALONE_NO,
	XML_STANDALONE_NO_VALUE,
	XML_STANDALONE_OMITTED
} XmlStandaloneType;

/*
 * Location tracking support --- simpler than bison's default, since we only
 * want to track the start position not the end position of each nonterminal.
 */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if ((N) > 0) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (-1); \
	} while (0)

/*
 * The above macro assigns -1 (unknown) as the parse location of any
 * nonterminal that was reduced from an empty rule, or whose leftmost
 * component was reduced from an empty rule.  This is problematic
 * for nonterminals defined like
 *		OptFooList: / * EMPTY * / { ... } | OptFooList Foo { ... } ;
 * because we'll set -1 as the location during the first reduction and then
 * copy it during each subsequent reduction, leaving us with -1 for the
 * location even when the list is not empty.  To fix that, do this in the
 * action for the nonempty rule(s):
 *		if (@$ < 0) @$ = @2;
 * (Although we have many nonterminals that follow this pattern, we only
 * bother with fixing @$ like this when the nonterminal's parse location
 * is actually referenced in some rule.)
 *
 * A cleaner answer would be to make YYLLOC_DEFAULT scan all the Rhs
 * locations until it's found one that's not -1.  Then we'd get a correct
 * location for any nonterminal that isn't entirely empty.  But this way
 * would add overhead to every rule reduction, and so far there's not been
 * a compelling reason to pay that overhead.
 */

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	ObjectType	objtype;
	List	   *objs;
} PrivTarget;

/* Private struct for the result of import_qualification production */
typedef struct ImportQual
{
	ImportForeignSchemaType type;
	List	   *table_names;
} ImportQual;

/* Private struct for the result of opt_select_limit production */
typedef struct SelectLimit
{
	Node	   *limitOffset;
	Node	   *limitCount;
	LimitOption limitOption;
} SelectLimit;

/* Private struct for the result of group_clause production */
typedef struct GroupClause
{
	bool		distinct;
	List	   *list;
} GroupClause;

/* Private structs for the result of key_actions and key_action productions */
typedef struct KeyAction
{
	char		action;
	List	   *cols;
} KeyAction;

typedef struct KeyActions
{
	KeyAction *updateAction;
	KeyAction *deleteAction;
} KeyActions;

/* ConstraintAttributeSpec yields an integer bitmask of these flags: */
#define CAS_NOT_DEFERRABLE			0x01
#define CAS_DEFERRABLE				0x02
#define CAS_INITIALLY_IMMEDIATE		0x04
#define CAS_INITIALLY_DEFERRED		0x08
#define CAS_NOT_VALID				0x10
#define CAS_NO_INHERIT				0x20


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static RawStmt *makeRawStmt(Node *stmt, int stmt_location);
static void updateRawStmtEnd(RawStmt *rs, int end_location);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeFloatConst(char *str, int location);
static Node *makeBoolAConst(bool state, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Node *v, int location);
static RoleSpec *makeRoleSpec(RoleSpecType type, int location);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static List *extractAggrArgTypes(List *aggrargs);
static List *makeOrderedSetArgs(List *directargs, List *orderedargs,
								core_yyscan_t yyscanner);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								SelectLimit *limitClause,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Float *v);
static Node *makeAndExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeOrExpr(Node *lexpr, Node *rexpr, int location);
static Node *makeNotExpr(Node *expr, int location);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod,
								  int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);
static RangeVar *makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner);
static RangeVar *makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
											   core_yyscan_t yyscanner);
static void SplitColQualList(List *qualList,
							 List **constraintList, CollateClause **collClause,
							 core_yyscan_t yyscanner);
static void processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner);
static PartitionStrategy parsePartitionStrategy(char *strategy);
static void preprocess_pubobj_list(List *pubobjspec_list,
								   core_yyscan_t yyscanner);
static Node *makeRecursiveViewSelect(char *relname, List *aliases, Node *query);


#line 325 "gram.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_BASE_YY_GRAM_H_INCLUDED
# define YY_BASE_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int base_yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IDENT = 258,
    UIDENT = 259,
    FCONST = 260,
    SCONST = 261,
    USCONST = 262,
    BCONST = 263,
    XCONST = 264,
    Op = 265,
    ICONST = 266,
    PARAM = 267,
    TYPECAST = 268,
    DOT_DOT = 269,
    COLON_EQUALS = 270,
    EQUALS_GREATER = 271,
    LESS_EQUALS = 272,
    GREATER_EQUALS = 273,
    NOT_EQUALS = 274,
    ABORT_P = 275,
    ABSENT = 276,
    ABSOLUTE_P = 277,
    ACCESS = 278,
    ACTION = 279,
    ADD_P = 280,
    ADMIN = 281,
    AFTER = 282,
    AGGREGATE = 283,
    ALL = 284,
    ALSO = 285,
    ALTER = 286,
    ALWAYS = 287,
    ANALYSE = 288,
    ANALYZE = 289,
    AND = 290,
    ANY = 291,
    ARRAY = 292,
    AS = 293,
    ASC = 294,
    ASENSITIVE = 295,
    ASSERTION = 296,
    ASSIGNMENT = 297,
    ASYMMETRIC = 298,
    ATOMIC = 299,
    AT = 300,
    ATTACH = 301,
    ATTRIBUTE = 302,
    AUTHORIZATION = 303,
    BACKWARD = 304,
    BEFORE = 305,
    BEGIN_P = 306,
    BETWEEN = 307,
    BIGINT = 308,
    BINARY = 309,
    BIT = 310,
    BOOLEAN_P = 311,
    BOTH = 312,
    BREADTH = 313,
    BY = 314,
    CACHE = 315,
    CALL = 316,
    CALLED = 317,
    CASCADE = 318,
    CASCADED = 319,
    CASE = 320,
    CAST = 321,
    CATALOG_P = 322,
    CHAIN = 323,
    CHAR_P = 324,
    CHARACTER = 325,
    CHARACTERISTICS = 326,
    CHECK = 327,
    CHECKPOINT = 328,
    CLASS = 329,
    CLOSE = 330,
    CLUSTER = 331,
    COALESCE = 332,
    COLLATE = 333,
    COLLATION = 334,
    COLUMN = 335,
    COLUMNS = 336,
    COMMENT = 337,
    COMMENTS = 338,
    COMMIT = 339,
    COMMITTED = 340,
    COMPRESSION = 341,
    CONCURRENTLY = 342,
    CONDITIONAL = 343,
    CONFIGURATION = 344,
    CONFLICT = 345,
    CONNECTION = 346,
    CONSTRAINT = 347,
    CONSTRAINTS = 348,
    CONTENT_P = 349,
    CONTINUE_P = 350,
    CONVERSION_P = 351,
    COPY = 352,
    COST = 353,
    CREATE = 354,
    CROSS = 355,
    CSV = 356,
    CUBE = 357,
    CURRENT_P = 358,
    CURRENT_CATALOG = 359,
    CURRENT_DATE = 360,
    CURRENT_ROLE = 361,
    CURRENT_SCHEMA = 362,
    CURRENT_TIME = 363,
    CURRENT_TIMESTAMP = 364,
    CURRENT_USER = 365,
    CURSOR = 366,
    CYCLE = 367,
    DATA_P = 368,
    DATABASE = 369,
    DAY_P = 370,
    DEALLOCATE = 371,
    DEC = 372,
    DECIMAL_P = 373,
    DECLARE = 374,
    DEFAULT = 375,
    DEFAULTS = 376,
    DEFERRABLE = 377,
    DEFERRED = 378,
    DEFINER = 379,
    DELETE_P = 380,
    DELIMITER = 381,
    DELIMITERS = 382,
    DEPENDS = 383,
    DEPTH = 384,
    DESC = 385,
    DETACH = 386,
    DICTIONARY = 387,
    DISABLE_P = 388,
    DISCARD = 389,
    DISTINCT = 390,
    DO = 391,
    DOCUMENT_P = 392,
    DOMAIN_P = 393,
    DOUBLE_P = 394,
    DROP = 395,
    EACH = 396,
    ELSE = 397,
    EMPTY_P = 398,
    ENABLE_P = 399,
    ENCODING = 400,
    ENCRYPTED = 401,
    END_P = 402,
    ENUM_P = 403,
    ERROR_P = 404,
    ESCAPE = 405,
    EVENT = 406,
    EXCEPT = 407,
    EXCLUDE = 408,
    EXCLUDING = 409,
    EXCLUSIVE = 410,
    EXECUTE = 411,
    EXISTS = 412,
    EXPLAIN = 413,
    EXPRESSION = 414,
    EXTENSION = 415,
    EXTERNAL = 416,
    EXTRACT = 417,
    FALSE_P = 418,
    FAMILY = 419,
    FETCH = 420,
    FILTER = 421,
    FINALIZE = 422,
    FIRST_P = 423,
    FLOAT_P = 424,
    FOLLOWING = 425,
    FOR = 426,
    FORCE = 427,
    FOREIGN = 428,
    FORMAT = 429,
    FORWARD = 430,
    FREEZE = 431,
    FROM = 432,
    FULL = 433,
    FUNCTION = 434,
    FUNCTIONS = 435,
    GENERATED = 436,
    GLOBAL = 437,
    GRANT = 438,
    GRANTED = 439,
    GREATEST = 440,
    GROUP_P = 441,
    GROUPING = 442,
    GROUPS = 443,
    HANDLER = 444,
    HAVING = 445,
    HEADER_P = 446,
    HOLD = 447,
    HOUR_P = 448,
    IDENTITY_P = 449,
    IF_P = 450,
    ILIKE = 451,
    IMMEDIATE = 452,
    IMMUTABLE = 453,
    IMPLICIT_P = 454,
    IMPORT_P = 455,
    IN_P = 456,
    INCLUDE = 457,
    INCLUDING = 458,
    INCREMENT = 459,
    INDENT = 460,
    INDEX = 461,
    INDEXES = 462,
    INHERIT = 463,
    INHERITS = 464,
    INITIALLY = 465,
    INLINE_P = 466,
    INNER_P = 467,
    INOUT = 468,
    INPUT_P = 469,
    INSENSITIVE = 470,
    INSERT = 471,
    INSTEAD = 472,
    INT_P = 473,
    INTEGER = 474,
    INTERSECT = 475,
    INTERVAL = 476,
    INTO = 477,
    INVOKER = 478,
    IS = 479,
    ISNULL = 480,
    ISOLATION = 481,
    JOIN = 482,
    JSON = 483,
    JSON_ARRAY = 484,
    JSON_ARRAYAGG = 485,
    JSON_EXISTS = 486,
    JSON_OBJECT = 487,
    JSON_OBJECTAGG = 488,
    JSON_QUERY = 489,
    JSON_SCALAR = 490,
    JSON_SERIALIZE = 491,
    JSON_TABLE = 492,
    JSON_VALUE = 493,
    KEEP = 494,
    KEY = 495,
    KEYS = 496,
    LABEL = 497,
    LANGUAGE = 498,
    LARGE_P = 499,
    LAST_P = 500,
    LATERAL_P = 501,
    LEADING = 502,
    LEAKPROOF = 503,
    LEAST = 504,
    LEFT = 505,
    LEVEL = 506,
    LIKE = 507,
    LIMIT = 508,
    LISTEN = 509,
    LOAD = 510,
    LOCAL = 511,
    LOCALTIME = 512,
    LOCALTIMESTAMP = 513,
    LOCATION = 514,
    LOCK_P = 515,
    LOCKED = 516,
    LOGGED = 517,
    MAPPING = 518,
    MATCH = 519,
    MATCHED = 520,
    MATERIALIZED = 521,
    MAXVALUE = 522,
    MERGE = 523,
    MERGE_ACTION = 524,
    METHOD = 525,
    MINUTE_P = 526,
    MINVALUE = 527,
    MODE = 528,
    MONTH_P = 529,
    MOVE = 530,
    NAME_P = 531,
    NAMES = 532,
    NATIONAL = 533,
    NATURAL = 534,
    NCHAR = 535,
    NESTED = 536,
    NEW = 537,
    NEXT = 538,
    NFC = 539,
    NFD = 540,
    NFKC = 541,
    NFKD = 542,
    NO = 543,
    NONE = 544,
    NORMALIZE = 545,
    NORMALIZED = 546,
    NOT = 547,
    NOTHING = 548,
    NOTIFY = 549,
    NOTNULL = 550,
    NOWAIT = 551,
    NULL_P = 552,
    NULLIF = 553,
    NULLS_P = 554,
    NUMERIC = 555,
    OBJECT_P = 556,
    OF = 557,
    OFF = 558,
    OFFSET = 559,
    OIDS = 560,
    OLD = 561,
    OMIT = 562,
    ON = 563,
    ONLY = 564,
    OPERATOR = 565,
    OPTION = 566,
    OPTIONS = 567,
    OR = 568,
    ORDER = 569,
    ORDINALITY = 570,
    OTHERS = 571,
    OUT_P = 572,
    OUTER_P = 573,
    OVER = 574,
    OVERLAPS = 575,
    OVERLAY = 576,
    OVERRIDING = 577,
    OWNED = 578,
    OWNER = 579,
    PARALLEL = 580,
    PARAMETER = 581,
    PARSER = 582,
    PARTIAL = 583,
    PARTITION = 584,
    PASSING = 585,
    PASSWORD = 586,
    PATH = 587,
    PGPOOL = 588,
    PLACING = 589,
    PLAN = 590,
    PLANS = 591,
    POLICY = 592,
    POSITION = 593,
    PRECEDING = 594,
    PRECISION = 595,
    PRESERVE = 596,
    PREPARE = 597,
    PREPARED = 598,
    PRIMARY = 599,
    PRIOR = 600,
    PRIVILEGES = 601,
    PROCEDURAL = 602,
    PROCEDURE = 603,
    PROCEDURES = 604,
    PROGRAM = 605,
    PUBLICATION = 606,
    QUOTE = 607,
    QUOTES = 608,
    RANGE = 609,
    READ = 610,
    REAL = 611,
    REASSIGN = 612,
    RECHECK = 613,
    RECURSIVE = 614,
    REF_P = 615,
    REFERENCES = 616,
    REFERENCING = 617,
    REFRESH = 618,
    REINDEX = 619,
    RELATIVE_P = 620,
    RELEASE = 621,
    RENAME = 622,
    REPEATABLE = 623,
    REPLACE = 624,
    REPLICA = 625,
    RESET = 626,
    RESTART = 627,
    RESTRICT = 628,
    RETURN = 629,
    RETURNING = 630,
    RETURNS = 631,
    REVOKE = 632,
    RIGHT = 633,
    ROLE = 634,
    ROLLBACK = 635,
    ROLLUP = 636,
    ROUTINE = 637,
    ROUTINES = 638,
    ROW = 639,
    ROWS = 640,
    RULE = 641,
    SAVEPOINT = 642,
    SCALAR = 643,
    SCHEMA = 644,
    SCHEMAS = 645,
    SCROLL = 646,
    SEARCH = 647,
    SECOND_P = 648,
    SECURITY = 649,
    SELECT = 650,
    SEQUENCE = 651,
    SEQUENCES = 652,
    SERIALIZABLE = 653,
    SERVER = 654,
    SESSION = 655,
    SESSION_USER = 656,
    SET = 657,
    SETS = 658,
    SETOF = 659,
    SHARE = 660,
    SHOW = 661,
    SIMILAR = 662,
    SIMPLE = 663,
    SKIP = 664,
    SMALLINT = 665,
    SNAPSHOT = 666,
    SOME = 667,
    SOURCE = 668,
    SQL_P = 669,
    STABLE = 670,
    STANDALONE_P = 671,
    START = 672,
    STATEMENT = 673,
    STATISTICS = 674,
    STDIN = 675,
    STDOUT = 676,
    STORAGE = 677,
    STORED = 678,
    STRICT_P = 679,
    STRING_P = 680,
    STRIP_P = 681,
    SUBSCRIPTION = 682,
    SUBSTRING = 683,
    SUPPORT = 684,
    SYMMETRIC = 685,
    SYSID = 686,
    SYSTEM_P = 687,
    SYSTEM_USER = 688,
    TABLE = 689,
    TABLES = 690,
    TABLESAMPLE = 691,
    TABLESPACE = 692,
    TARGET = 693,
    TEMP = 694,
    TEMPLATE = 695,
    TEMPORARY = 696,
    TEXT_P = 697,
    THEN = 698,
    TIES = 699,
    TIME = 700,
    TIMESTAMP = 701,
    TO = 702,
    TRAILING = 703,
    TRANSACTION = 704,
    TRANSFORM = 705,
    TREAT = 706,
    TRIGGER = 707,
    TRIM = 708,
    TRUE_P = 709,
    TRUNCATE = 710,
    TRUSTED = 711,
    TYPE_P = 712,
    TYPES_P = 713,
    UESCAPE = 714,
    UNBOUNDED = 715,
    UNCONDITIONAL = 716,
    UNCOMMITTED = 717,
    UNENCRYPTED = 718,
    UNION = 719,
    UNIQUE = 720,
    UNKNOWN = 721,
    UNLISTEN = 722,
    UNLOGGED = 723,
    UNTIL = 724,
    UPDATE = 725,
    USER = 726,
    USING = 727,
    VACUUM = 728,
    VALID = 729,
    VALIDATE = 730,
    VALIDATOR = 731,
    VALUE_P = 732,
    VALUES = 733,
    VARCHAR = 734,
    VARIADIC = 735,
    VARYING = 736,
    VERBOSE = 737,
    VERSION_P = 738,
    VIEW = 739,
    VIEWS = 740,
    VOLATILE = 741,
    WHEN = 742,
    WHERE = 743,
    WHITESPACE_P = 744,
    WINDOW = 745,
    WITH = 746,
    WITHIN = 747,
    WITHOUT = 748,
    WORK = 749,
    WRAPPER = 750,
    WRITE = 751,
    XML_P = 752,
    XMLATTRIBUTES = 753,
    XMLCONCAT = 754,
    XMLELEMENT = 755,
    XMLEXISTS = 756,
    XMLFOREST = 757,
    XMLNAMESPACES = 758,
    XMLPARSE = 759,
    XMLPI = 760,
    XMLROOT = 761,
    XMLSERIALIZE = 762,
    XMLTABLE = 763,
    YEAR_P = 764,
    YES_P = 765,
    ZONE = 766,
    FORMAT_LA = 767,
    NOT_LA = 768,
    NULLS_LA = 769,
    WITH_LA = 770,
    WITHOUT_LA = 771,
    MODE_TYPE_NAME = 772,
    MODE_PLPGSQL_EXPR = 773,
    MODE_PLPGSQL_ASSIGN1 = 774,
    MODE_PLPGSQL_ASSIGN2 = 775,
    MODE_PLPGSQL_ASSIGN3 = 776,
    UMINUS = 777
  };
#endif
/* Tokens.  */
#define IDENT 258
#define UIDENT 259
#define FCONST 260
#define SCONST 261
#define USCONST 262
#define BCONST 263
#define XCONST 264
#define Op 265
#define ICONST 266
#define PARAM 267
#define TYPECAST 268
#define DOT_DOT 269
#define COLON_EQUALS 270
#define EQUALS_GREATER 271
#define LESS_EQUALS 272
#define GREATER_EQUALS 273
#define NOT_EQUALS 274
#define ABORT_P 275
#define ABSENT 276
#define ABSOLUTE_P 277
#define ACCESS 278
#define ACTION 279
#define ADD_P 280
#define ADMIN 281
#define AFTER 282
#define AGGREGATE 283
#define ALL 284
#define ALSO 285
#define ALTER 286
#define ALWAYS 287
#define ANALYSE 288
#define ANALYZE 289
#define AND 290
#define ANY 291
#define ARRAY 292
#define AS 293
#define ASC 294
#define ASENSITIVE 295
#define ASSERTION 296
#define ASSIGNMENT 297
#define ASYMMETRIC 298
#define ATOMIC 299
#define AT 300
#define ATTACH 301
#define ATTRIBUTE 302
#define AUTHORIZATION 303
#define BACKWARD 304
#define BEFORE 305
#define BEGIN_P 306
#define BETWEEN 307
#define BIGINT 308
#define BINARY 309
#define BIT 310
#define BOOLEAN_P 311
#define BOTH 312
#define BREADTH 313
#define BY 314
#define CACHE 315
#define CALL 316
#define CALLED 317
#define CASCADE 318
#define CASCADED 319
#define CASE 320
#define CAST 321
#define CATALOG_P 322
#define CHAIN 323
#define CHAR_P 324
#define CHARACTER 325
#define CHARACTERISTICS 326
#define CHECK 327
#define CHECKPOINT 328
#define CLASS 329
#define CLOSE 330
#define CLUSTER 331
#define COALESCE 332
#define COLLATE 333
#define COLLATION 334
#define COLUMN 335
#define COLUMNS 336
#define COMMENT 337
#define COMMENTS 338
#define COMMIT 339
#define COMMITTED 340
#define COMPRESSION 341
#define CONCURRENTLY 342
#define CONDITIONAL 343
#define CONFIGURATION 344
#define CONFLICT 345
#define CONNECTION 346
#define CONSTRAINT 347
#define CONSTRAINTS 348
#define CONTENT_P 349
#define CONTINUE_P 350
#define CONVERSION_P 351
#define COPY 352
#define COST 353
#define CREATE 354
#define CROSS 355
#define CSV 356
#define CUBE 357
#define CURRENT_P 358
#define CURRENT_CATALOG 359
#define CURRENT_DATE 360
#define CURRENT_ROLE 361
#define CURRENT_SCHEMA 362
#define CURRENT_TIME 363
#define CURRENT_TIMESTAMP 364
#define CURRENT_USER 365
#define CURSOR 366
#define CYCLE 367
#define DATA_P 368
#define DATABASE 369
#define DAY_P 370
#define DEALLOCATE 371
#define DEC 372
#define DECIMAL_P 373
#define DECLARE 374
#define DEFAULT 375
#define DEFAULTS 376
#define DEFERRABLE 377
#define DEFERRED 378
#define DEFINER 379
#define DELETE_P 380
#define DELIMITER 381
#define DELIMITERS 382
#define DEPENDS 383
#define DEPTH 384
#define DESC 385
#define DETACH 386
#define DICTIONARY 387
#define DISABLE_P 388
#define DISCARD 389
#define DISTINCT 390
#define DO 391
#define DOCUMENT_P 392
#define DOMAIN_P 393
#define DOUBLE_P 394
#define DROP 395
#define EACH 396
#define ELSE 397
#define EMPTY_P 398
#define ENABLE_P 399
#define ENCODING 400
#define ENCRYPTED 401
#define END_P 402
#define ENUM_P 403
#define ERROR_P 404
#define ESCAPE 405
#define EVENT 406
#define EXCEPT 407
#define EXCLUDE 408
#define EXCLUDING 409
#define EXCLUSIVE 410
#define EXECUTE 411
#define EXISTS 412
#define EXPLAIN 413
#define EXPRESSION 414
#define EXTENSION 415
#define EXTERNAL 416
#define EXTRACT 417
#define FALSE_P 418
#define FAMILY 419
#define FETCH 420
#define FILTER 421
#define FINALIZE 422
#define FIRST_P 423
#define FLOAT_P 424
#define FOLLOWING 425
#define FOR 426
#define FORCE 427
#define FOREIGN 428
#define FORMAT 429
#define FORWARD 430
#define FREEZE 431
#define FROM 432
#define FULL 433
#define FUNCTION 434
#define FUNCTIONS 435
#define GENERATED 436
#define GLOBAL 437
#define GRANT 438
#define GRANTED 439
#define GREATEST 440
#define GROUP_P 441
#define GROUPING 442
#define GROUPS 443
#define HANDLER 444
#define HAVING 445
#define HEADER_P 446
#define HOLD 447
#define HOUR_P 448
#define IDENTITY_P 449
#define IF_P 450
#define ILIKE 451
#define IMMEDIATE 452
#define IMMUTABLE 453
#define IMPLICIT_P 454
#define IMPORT_P 455
#define IN_P 456
#define INCLUDE 457
#define INCLUDING 458
#define INCREMENT 459
#define INDENT 460
#define INDEX 461
#define INDEXES 462
#define INHERIT 463
#define INHERITS 464
#define INITIALLY 465
#define INLINE_P 466
#define INNER_P 467
#define INOUT 468
#define INPUT_P 469
#define INSENSITIVE 470
#define INSERT 471
#define INSTEAD 472
#define INT_P 473
#define INTEGER 474
#define INTERSECT 475
#define INTERVAL 476
#define INTO 477
#define INVOKER 478
#define IS 479
#define ISNULL 480
#define ISOLATION 481
#define JOIN 482
#define JSON 483
#define JSON_ARRAY 484
#define JSON_ARRAYAGG 485
#define JSON_EXISTS 486
#define JSON_OBJECT 487
#define JSON_OBJECTAGG 488
#define JSON_QUERY 489
#define JSON_SCALAR 490
#define JSON_SERIALIZE 491
#define JSON_TABLE 492
#define JSON_VALUE 493
#define KEEP 494
#define KEY 495
#define KEYS 496
#define LABEL 497
#define LANGUAGE 498
#define LARGE_P 499
#define LAST_P 500
#define LATERAL_P 501
#define LEADING 502
#define LEAKPROOF 503
#define LEAST 504
#define LEFT 505
#define LEVEL 506
#define LIKE 507
#define LIMIT 508
#define LISTEN 509
#define LOAD 510
#define LOCAL 511
#define LOCALTIME 512
#define LOCALTIMESTAMP 513
#define LOCATION 514
#define LOCK_P 515
#define LOCKED 516
#define LOGGED 517
#define MAPPING 518
#define MATCH 519
#define MATCHED 520
#define MATERIALIZED 521
#define MAXVALUE 522
#define MERGE 523
#define MERGE_ACTION 524
#define METHOD 525
#define MINUTE_P 526
#define MINVALUE 527
#define MODE 528
#define MONTH_P 529
#define MOVE 530
#define NAME_P 531
#define NAMES 532
#define NATIONAL 533
#define NATURAL 534
#define NCHAR 535
#define NESTED 536
#define NEW 537
#define NEXT 538
#define NFC 539
#define NFD 540
#define NFKC 541
#define NFKD 542
#define NO 543
#define NONE 544
#define NORMALIZE 545
#define NORMALIZED 546
#define NOT 547
#define NOTHING 548
#define NOTIFY 549
#define NOTNULL 550
#define NOWAIT 551
#define NULL_P 552
#define NULLIF 553
#define NULLS_P 554
#define NUMERIC 555
#define OBJECT_P 556
#define OF 557
#define OFF 558
#define OFFSET 559
#define OIDS 560
#define OLD 561
#define OMIT 562
#define ON 563
#define ONLY 564
#define OPERATOR 565
#define OPTION 566
#define OPTIONS 567
#define OR 568
#define ORDER 569
#define ORDINALITY 570
#define OTHERS 571
#define OUT_P 572
#define OUTER_P 573
#define OVER 574
#define OVERLAPS 575
#define OVERLAY 576
#define OVERRIDING 577
#define OWNED 578
#define OWNER 579
#define PARALLEL 580
#define PARAMETER 581
#define PARSER 582
#define PARTIAL 583
#define PARTITION 584
#define PASSING 585
#define PASSWORD 586
#define PATH 587
#define PGPOOL 588
#define PLACING 589
#define PLAN 590
#define PLANS 591
#define POLICY 592
#define POSITION 593
#define PRECEDING 594
#define PRECISION 595
#define PRESERVE 596
#define PREPARE 597
#define PREPARED 598
#define PRIMARY 599
#define PRIOR 600
#define PRIVILEGES 601
#define PROCEDURAL 602
#define PROCEDURE 603
#define PROCEDURES 604
#define PROGRAM 605
#define PUBLICATION 606
#define QUOTE 607
#define QUOTES 608
#define RANGE 609
#define READ 610
#define REAL 611
#define REASSIGN 612
#define RECHECK 613
#define RECURSIVE 614
#define REF_P 615
#define REFERENCES 616
#define REFERENCING 617
#define REFRESH 618
#define REINDEX 619
#define RELATIVE_P 620
#define RELEASE 621
#define RENAME 622
#define REPEATABLE 623
#define REPLACE 624
#define REPLICA 625
#define RESET 626
#define RESTART 627
#define RESTRICT 628
#define RETURN 629
#define RETURNING 630
#define RETURNS 631
#define REVOKE 632
#define RIGHT 633
#define ROLE 634
#define ROLLBACK 635
#define ROLLUP 636
#define ROUTINE 637
#define ROUTINES 638
#define ROW 639
#define ROWS 640
#define RULE 641
#define SAVEPOINT 642
#define SCALAR 643
#define SCHEMA 644
#define SCHEMAS 645
#define SCROLL 646
#define SEARCH 647
#define SECOND_P 648
#define SECURITY 649
#define SELECT 650
#define SEQUENCE 651
#define SEQUENCES 652
#define SERIALIZABLE 653
#define SERVER 654
#define SESSION 655
#define SESSION_USER 656
#define SET 657
#define SETS 658
#define SETOF 659
#define SHARE 660
#define SHOW 661
#define SIMILAR 662
#define SIMPLE 663
#define SKIP 664
#define SMALLINT 665
#define SNAPSHOT 666
#define SOME 667
#define SOURCE 668
#define SQL_P 669
#define STABLE 670
#define STANDALONE_P 671
#define START 672
#define STATEMENT 673
#define STATISTICS 674
#define STDIN 675
#define STDOUT 676
#define STORAGE 677
#define STORED 678
#define STRICT_P 679
#define STRING_P 680
#define STRIP_P 681
#define SUBSCRIPTION 682
#define SUBSTRING 683
#define SUPPORT 684
#define SYMMETRIC 685
#define SYSID 686
#define SYSTEM_P 687
#define SYSTEM_USER 688
#define TABLE 689
#define TABLES 690
#define TABLESAMPLE 691
#define TABLESPACE 692
#define TARGET 693
#define TEMP 694
#define TEMPLATE 695
#define TEMPORARY 696
#define TEXT_P 697
#define THEN 698
#define TIES 699
#define TIME 700
#define TIMESTAMP 701
#define TO 702
#define TRAILING 703
#define TRANSACTION 704
#define TRANSFORM 705
#define TREAT 706
#define TRIGGER 707
#define TRIM 708
#define TRUE_P 709
#define TRUNCATE 710
#define TRUSTED 711
#define TYPE_P 712
#define TYPES_P 713
#define UESCAPE 714
#define UNBOUNDED 715
#define UNCONDITIONAL 716
#define UNCOMMITTED 717
#define UNENCRYPTED 718
#define UNION 719
#define UNIQUE 720
#define UNKNOWN 721
#define UNLISTEN 722
#define UNLOGGED 723
#define UNTIL 724
#define UPDATE 725
#define USER 726
#define USING 727
#define VACUUM 728
#define VALID 729
#define VALIDATE 730
#define VALIDATOR 731
#define VALUE_P 732
#define VALUES 733
#define VARCHAR 734
#define VARIADIC 735
#define VARYING 736
#define VERBOSE 737
#define VERSION_P 738
#define VIEW 739
#define VIEWS 740
#define VOLATILE 741
#define WHEN 742
#define WHERE 743
#define WHITESPACE_P 744
#define WINDOW 745
#define WITH 746
#define WITHIN 747
#define WITHOUT 748
#define WORK 749
#define WRAPPER 750
#define WRITE 751
#define XML_P 752
#define XMLATTRIBUTES 753
#define XMLCONCAT 754
#define XMLELEMENT 755
#define XMLEXISTS 756
#define XMLFOREST 757
#define XMLNAMESPACES 758
#define XMLPARSE 759
#define XMLPI 760
#define XMLROOT 761
#define XMLSERIALIZE 762
#define XMLTABLE 763
#define YEAR_P 764
#define YES_P 765
#define ZONE 766
#define FORMAT_LA 767
#define NOT_LA 768
#define NULLS_LA 769
#define WITH_LA 770
#define WITHOUT_LA 771
#define MODE_TYPE_NAME 772
#define MODE_PLPGSQL_EXPR 773
#define MODE_PLPGSQL_ASSIGN1 774
#define MODE_PLPGSQL_ASSIGN2 775
#define MODE_PLPGSQL_ASSIGN3 776
#define UMINUS 777

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 263 "gram.y" /* yacc.c:355  */

	core_YYSTYPE core_yystype;
	/* these fields must match core_YYSTYPE: */
	int			ival;
	char	   *str;
	const char *keyword;

	char		chr;
	bool		boolean;
	JoinType	jtype;
	DropBehavior dbehavior;
	OnCommitAction oncommit;
	List	   *list;
	Node	   *node;
	ObjectType	objtype;
	TypeName   *typnam;
	FunctionParameter *fun_param;
	FunctionParameterMode fun_param_mode;
	ObjectWithArgs *objwithargs;
	DefElem	   *defelt;
	SortBy	   *sortby;
	WindowDef  *windef;
	JoinExpr   *jexpr;
	IndexElem  *ielem;
	StatsElem  *selem;
	Alias	   *alias;
	RangeVar   *range;
	IntoClause *into;
	WithClause *with;
	InferClause	*infer;
	OnConflictClause *onconflict;
	A_Indices  *aind;
	ResTarget  *target;
	struct PrivTarget *privtarget;
	AccessPriv *accesspriv;
	struct ImportQual *importqual;
	InsertStmt *istmt;
	VariableSetStmt *vsetstmt;
	PartitionElem *partelem;
	PartitionSpec *partspec;
	PartitionBoundSpec *partboundspec;
	RoleSpec   *rolespec;
	PublicationObjSpec *publicationobjectspec;
	struct SelectLimit *selectlimit;
	SetQuantifier setquantifier;
	struct GroupClause *groupclause;
	MergeMatchKind mergematch;
	MergeWhenClause *mergewhen;
	struct KeyActions *keyactions;
	struct KeyAction *keyaction;

#line 1461 "gram.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int base_yyparse (core_yyscan_t yyscanner);

#endif /* !YY_BASE_YY_GRAM_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1491 "gram.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  936
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   123730

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  540
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  728
/* YYNRULES -- Number of rules.  */
#define YYNRULES  3412
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  6472

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   777

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   529,     2,     2,
     534,   535,   527,   525,   538,   526,   536,   528,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   539,   537,
     522,   524,   523,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   532,     2,   533,   530,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   531
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   953,   953,   958,   962,   967,   975,   983,  1003,  1015,
    1029,  1030,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,
    1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,  1081,
    1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,
    1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1122,  1123,  1124,  1125,  1126,  1127,  1128,  1129,  1130,  1131,
    1132,  1133,  1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,
    1142,  1143,  1144,  1145,  1146,  1147,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1159,  1166,  1167,  1171,
    1172,  1176,  1177,  1181,  1182,  1183,  1192,  1208,  1220,  1221,
    1222,  1231,  1232,  1236,  1237,  1241,  1246,  1250,  1260,  1268,
    1272,  1276,  1281,  1285,  1333,  1335,  1339,  1343,  1347,  1351,
    1365,  1384,  1393,  1405,  1406,  1410,  1419,  1428,  1437,  1459,
    1467,  1475,  1483,  1491,  1499,  1517,  1536,  1548,  1549,  1560,
    1571,  1582,  1598,  1617,  1624,  1632,  1633,  1634,  1635,  1636,
    1637,  1651,  1658,  1665,  1672,  1679,  1689,  1698,  1707,  1711,
    1720,  1729,  1737,  1748,  1749,  1758,  1770,  1778,  1787,  1799,
    1808,  1817,  1825,  1835,  1845,  1853,  1854,  1858,  1859,  1862,
    1864,  1868,  1869,  1870,  1871,  1875,  1876,  1877,  1883,  1895,
    1899,  1903,  1920,  1928,  1929,  1930,  1934,  1935,  1936,  1940,
    1941,  1945,  1946,  1955,  1956,  1964,  1972,  1983,  1991,  2002,
    2003,  2008,  2009,  2015,  2021,  2027,  2034,  2041,  2048,  2055,
    2066,  2077,  2078,  2082,  2083,  2091,  2107,  2114,  2121,  2128,
    2135,  2155,  2165,  2175,  2185,  2195,  2207,  2219,  2229,  2239,
    2249,  2261,  2273,  2283,  2293,  2303,  2313,  2323,  2333,  2345,
    2357,  2367,  2380,  2381,  2386,  2400,  2413,  2429,  2446,  2456,
    2466,  2476,  2486,  2496,  2505,  2514,  2524,  2533,  2543,  2553,
    2569,  2579,  2589,  2599,  2609,  2626,  2636,  2646,  2656,  2667,
    2681,  2697,  2706,  2715,  2730,  2739,  2750,  2761,  2769,  2778,
    2787,  2795,  2803,  2812,  2821,  2830,  2838,  2846,  2855,  2863,
    2871,  2880,  2889,  2898,  2907,  2916,  2925,  2936,  2944,  2953,
    2962,  2971,  2980,  2989,  2998,  3006,  3014,  3022,  3029,  3040,
    3041,  3045,  3054,  3058,  3059,  3063,  3071,  3079,  3087,  3098,
    3101,  3102,  3106,  3107,  3112,  3116,  3120,  3125,  3132,  3134,
    3139,  3143,  3147,  3158,  3165,  3166,  3170,  3171,  3176,  3229,
    3242,  3256,  3268,  3275,  3279,  3293,  3306,  3307,  3312,  3322,
    3333,  3344,  3371,  3378,  3412,  3448,  3471,  3472,  3476,  3477,
    3486,  3487,  3488,  3491,  3492,  3497,  3498,  3502,  3506,  3510,
    3514,  3518,  3522,  3526,  3530,  3534,  3538,  3542,  3546,  3550,
    3554,  3558,  3567,  3571,  3575,  3579,  3583,  3584,  3589,  3593,
    3600,  3607,  3608,  3609,  3610,  3611,  3612,  3616,  3620,  3628,
    3639,  3659,  3679,  3700,  3721,  3742,  3776,  3777,  3778,  3779,
    3780,  3787,  3794,  3795,  3799,  3800,  3804,  3805,  3809,  3813,
    3820,  3824,  3831,  3832,  3833,  3837,  3838,  3841,  3865,  3884,
    3906,  3907,  3911,  3912,  3916,  3917,  3921,  3922,  3926,  3927,
    3931,  3939,  3940,  3941,  3973,  3981,  3989,  4002,  4014,  4027,
    4039,  4049,  4073,  4093,  4094,  4095,  4099,  4100,  4119,  4127,
    4135,  4143,  4155,  4167,  4168,  4169,  4173,  4174,  4175,  4176,
    4177,  4178,  4179,  4180,  4181,  4182,  4191,  4199,  4203,  4217,
    4235,  4251,  4268,  4284,  4304,  4339,  4347,  4351,  4365,  4381,
    4382,  4386,  4387,  4391,  4392,  4395,  4401,  4402,  4405,  4409,
    4417,  4422,  4428,  4429,  4433,  4438,  4445,  4446,  4450,  4460,
    4470,  4478,  4487,  4500,  4512,  4519,  4527,  4535,  4543,  4551,
    4561,  4562,  4566,  4567,  4570,  4582,  4583,  4586,  4597,  4608,
    4622,  4623,  4628,  4629,  4630,  4633,  4634,  4635,  4636,  4639,
    4640,  4643,  4644,  4647,  4667,  4680,  4702,  4703,  4706,  4712,
    4718,  4735,  4744,  4766,  4780,  4797,  4813,  4814,  4815,  4827,
    4841,  4858,  4872,  4873,  4885,  4906,  4917,  4931,  4940,  4952,
    4953,  4956,  4957,  4960,  4961,  4964,  4968,  4972,  4976,  4980,
    4984,  4988,  4992,  4996,  5000,  5004,  5009,  5013,  5017,  5023,
    5024,  5028,  5029,  5030,  5037,  5040,  5041,  5053,  5069,  5085,
    5086,  5094,  5095,  5099,  5100,  5104,  5105,  5109,  5110,  5114,
    5115,  5125,  5137,  5138,  5151,  5159,  5177,  5186,  5198,  5201,
    5205,  5209,  5213,  5220,  5232,  5243,  5246,  5250,  5263,  5273,
    5283,  5293,  5303,  5313,  5323,  5333,  5343,  5353,  5363,  5373,
    5383,  5402,  5414,  5415,  5416,  5417,  5421,  5422,  5426,  5427,
    5437,  5446,  5459,  5460,  5464,  5468,  5476,  5480,  5484,  5491,
    5495,  5500,  5505,  5512,  5519,  5524,  5534,  5547,  5563,  5564,
    5569,  5570,  5574,  5575,  5585,  5595,  5604,  5622,  5643,  5664,
    5686,  5720,  5736,  5737,  5741,  5750,  5765,  5775,  5788,  5789,
    5801,  5810,  5828,  5853,  5871,  5886,  5887,  5891,  5892,  5896,
    5897,  5901,  5902,  5906,  5920,  5924,  5925,  5929,  5930,  5931,
    5932,  5933,  5943,  5955,  5956,  5967,  5990,  6022,  6023,  6024,
    6028,  6030,  6052,  6054,  6056,  6058,  6060,  6065,  6066,  6070,
    6071,  6075,  6087,  6088,  6092,  6101,  6105,  6109,  6114,  6124,
    6125,  6129,  6130,  6134,  6135,  6139,  6140,  6144,  6145,  6146,
    6150,  6154,  6155,  6156,  6160,  6161,  6166,  6167,  6194,  6195,
    6196,  6197,  6198,  6199,  6212,  6223,  6238,  6240,  6245,  6250,
    6252,  6257,  6268,  6269,  6270,  6271,  6282,  6301,  6313,  6326,
    6337,  6348,  6360,  6369,  6377,  6385,  6395,  6405,  6415,  6425,
    6435,  6446,  6456,  6469,  6472,  6473,  6476,  6480,  6487,  6488,
    6489,  6490,  6491,  6492,  6495,  6498,  6499,  6507,  6514,  6515,
    6518,  6520,  6531,  6543,  6555,  6567,  6579,  6608,  6609,  6625,
    6641,  6642,  6646,  6659,  6670,  6679,  6689,  6699,  6700,  6703,
    6704,  6707,  6708,  6709,  6712,  6726,  6731,  6742,  6752,  6765,
    6766,  6770,  6779,  6792,  6803,  6817,  6828,  6851,  6862,  6881,
    6892,  6903,  6914,  6925,  6936,  6947,  6958,  6969,  6980,  6991,
    7002,  7017,  7018,  7019,  7020,  7021,  7022,  7023,  7024,  7025,
    7026,  7027,  7028,  7029,  7039,  7040,  7041,  7042,  7043,  7047,
    7048,  7049,  7050,  7051,  7052,  7053,  7054,  7059,  7060,  7061,
    7065,  7066,  7069,  7070,  7073,  7075,  7080,  7081,  7092,  7104,
    7105,  7106,  7116,  7125,  7134,  7143,  7152,  7161,  7170,  7179,
    7188,  7197,  7211,  7220,  7229,  7238,  7247,  7256,  7265,  7274,
    7286,  7287,  7301,  7312,  7323,  7334,  7345,  7356,  7367,  7378,
    7389,  7400,  7413,  7414,  7417,  7418,  7428,  7435,  7444,  7453,
    7462,  7471,  7480,  7489,  7498,  7507,  7516,  7525,  7534,  7543,
    7552,  7561,  7570,  7579,  7590,  7591,  7594,  7595,  7605,  7623,
    7639,  7667,  7669,  7671,  7673,  7681,  7691,  7692,  7695,  7703,
    7711,  7719,  7726,  7737,  7741,  7748,  7752,  7763,  7772,  7781,
    7790,  7799,  7808,  7817,  7826,  7835,  7844,  7853,  7862,  7871,
    7879,  7888,  7897,  7906,  7915,  7924,  7933,  7942,  7955,  7956,
    7960,  7961,  7966,  7967,  7977,  7988,  8002,  8014,  8032,  8033,
    8037,  8044,  8045,  8046,  8049,  8050,  8060,  8071,  8072,  8076,
    8080,  8084,  8095,  8109,  8124,  8142,  8143,  8144,  8145,  8146,
    8147,  8159,  8191,  8226,  8227,  8231,  8232,  8235,  8236,  8241,
    8253,  8272,  8277,  8282,  8289,  8290,  8293,  8294,  8297,  8298,
    8302,  8303,  8304,  8307,  8308,  8309,  8325,  8339,  8354,  8368,
    8385,  8386,  8389,  8390,  8394,  8395,  8399,  8400,  8405,  8419,
    8427,  8435,  8451,  8452,  8456,  8457,  8472,  8482,  8492,  8502,
    8512,  8525,  8526,  8527,  8528,  8529,  8535,  8539,  8554,  8555,
    8561,  8571,  8575,  8580,  8588,  8630,  8634,  8638,  8642,  8650,
    8651,  8655,  8667,  8668,  8673,  8674,  8679,  8680,  8687,  8691,
    8695,  8699,  8703,  8707,  8711,  8715,  8719,  8723,  8727,  8731,
    8735,  8739,  8743,  8747,  8752,  8759,  8763,  8767,  8771,  8775,
    8781,  8782,  8788,  8798,  8802,  8813,  8819,  8828,  8834,  8835,
    8839,  8840,  8844,  8845,  8848,  8861,  8865,  8880,  8889,  8898,
    8911,  8912,  8917,  8918,  8935,  8946,  8957,  8968,  8979,  8990,
    9004,  9015,  9029,  9040,  9054,  9062,  9064,  9066,  9071,  9073,
    9078,  9079,  9084,  9103,  9113,  9114,  9118,  9122,  9134,  9146,
    9158,  9172,  9173,  9174,  9178,  9191,  9192,  9202,  9215,  9219,
    9223,  9227,  9234,  9256,  9269,  9282,  9297,  9298,  9301,  9302,
    9305,  9306,  9316,  9326,  9344,  9354,  9364,  9374,  9384,  9394,
    9404,  9414,  9424,  9434,  9444,  9454,  9464,  9475,  9486,  9496,
    9506,  9516,  9526,  9536,  9546,  9557,  9568,  9579,  9590,  9601,
    9612,  9623,  9634,  9645,  9656,  9667,  9678,  9690,  9702,  9714,
    9726,  9738,  9750,  9761,  9772,  9784,  9796,  9807,  9818,  9827,
    9837,  9847,  9857,  9867,  9877,  9887,  9897,  9907,  9917,  9932,
    9933,  9936,  9937,  9947,  9957,  9967,  9977,  9988,  9998, 10010,
   10011, 10021, 10031, 10041, 10051, 10061, 10071, 10081, 10091, 10101,
   10111, 10121, 10131, 10141, 10151, 10161, 10171, 10181, 10191, 10201,
   10211, 10221, 10231, 10241, 10251, 10261, 10271, 10281, 10300, 10310,
   10311, 10314, 10316, 10318, 10324, 10325, 10326, 10327, 10328, 10340,
   10356, 10365, 10374, 10383, 10392, 10401, 10410, 10419, 10428, 10437,
   10446, 10455, 10464, 10473, 10482, 10491, 10500, 10509, 10518, 10527,
   10536, 10545, 10554, 10563, 10591, 10599, 10608, 10634, 10643, 10650,
   10656, 10683, 10694, 10703, 10711, 10713, 10735, 10743, 10753, 10763,
   10782, 10801, 10811, 10821, 10831, 10842, 10853, 10864, 10875, 10886,
   10904, 10913, 10930, 10948, 10949, 10950, 10955, 10961, 10970, 10971,
   10972, 10973, 10974, 10978, 10979, 10982, 10983, 10984, 10985, 10989,
   10990, 10991, 11003, 11014, 11015, 11018, 11028, 11035, 11055, 11065,
   11074, 11084, 11094, 11103, 11112, 11121, 11130, 11139, 11148, 11157,
   11169, 11178, 11190, 11191, 11192, 11196, 11199, 11202, 11205, 11208,
   11215, 11217, 11219, 11224, 11226, 11230, 11231, 11232, 11244, 11258,
   11272, 11291, 11313, 11314, 11315, 11316, 11326, 11343, 11354, 11355,
   11359, 11360, 11364, 11368, 11372, 11390, 11391, 11392, 11393, 11394,
   11395, 11396, 11403, 11404, 11415, 11423, 11431, 11440, 11450, 11468,
   11477, 11486, 11495, 11507, 11511, 11522, 11534, 11552, 11559, 11576,
   11590, 11600, 11609, 11618, 11628, 11640, 11652, 11663, 11664, 11675,
   11686, 11698, 11710, 11722, 11734, 11744, 11757, 11758, 11772, 11796,
   11805, 11815, 11827, 11839, 11853, 11854, 11866, 11887, 11898, 11910,
   11922, 11926, 11933, 11934, 11938, 11945, 11946, 11947, 11951, 11952,
   11953, 11957, 11958, 11962, 11963, 11966, 11967, 11970, 11971, 11975,
   11976, 11980, 11987, 11989, 11994, 11995, 12008, 12016, 12027, 12035,
   12046, 12047, 12048, 12049, 12050, 12051, 12052, 12053, 12054, 12055,
   12065, 12076, 12077, 12081, 12082, 12083, 12084, 12085, 12095, 12103,
   12121, 12141, 12142, 12152, 12161, 12170, 12179, 12198, 12216, 12220,
   12228, 12234, 12241, 12247, 12254, 12263, 12264, 12268, 12270, 12275,
   12286, 12296, 12306, 12312, 12321, 12330, 12336, 12337, 12348, 12363,
   12364, 12375, 12386, 12387, 12390, 12391, 12392, 12393, 12394, 12395,
   12396, 12397, 12400, 12401, 12405, 12406, 12407, 12418, 12436, 12437,
   12441, 12446, 12470, 12481, 12482, 12494, 12514, 12515, 12525, 12532,
   12539, 12546, 12556, 12569, 12570, 12574, 12575, 12579, 12580, 12584,
   12597, 12610, 12619, 12628, 12637, 12646, 12658, 12670, 12682, 12685,
   12686, 12687, 12688, 12689, 12690, 12693, 12694, 12695, 12743, 12744,
   12748, 12749, 12764, 12765, 12772, 12780, 12788, 12796, 12804, 12812,
   12823, 12824, 12856, 12872, 12889, 12890, 12909, 12913, 12917, 12932,
   12939, 12946, 12956, 12957, 12960, 12976, 12977, 12978, 12982, 12992,
   13003, 13009, 13021, 13034, 13040, 13041, 13045, 13057, 13065, 13070,
   13075, 13080, 13085, 13093, 13101, 13106, 13111, 13118, 13119, 13123,
   13124, 13125, 13132, 13133, 13137, 13138, 13142, 13143, 13147, 13148,
   13152, 13156, 13157, 13160, 13169, 13182, 13187, 13192, 13196, 13208,
   13209, 13213, 13222, 13238, 13247, 13256, 13265, 13277, 13280, 13285,
   13286, 13294, 13314, 13315, 13317, 13322, 13323, 13327, 13328, 13331,
   13332, 13357, 13366, 13376, 13377, 13381, 13382, 13383, 13384, 13385,
   13389, 13402, 13409, 13416, 13423, 13424, 13428, 13429, 13433, 13434,
   13438, 13439, 13443, 13455, 13456, 13457, 13458, 13462, 13463, 13473,
   13480, 13499, 13500, 13504, 13505, 13511, 13516, 13525, 13533, 13542,
   13549, 13557, 13566, 13575, 13579, 13584, 13591, 13620, 13624, 13638,
   13659, 13681, 13694, 13711, 13717, 13722, 13728, 13735, 13736, 13746,
   13752, 13760, 13764, 13768, 13775, 13783, 13788, 13789, 13790, 13791,
   13795, 13796, 13811, 13815, 13823, 13830, 13837, 13844, 13851, 13862,
   13863, 13876, 13880, 13888, 13902, 13916, 13917, 13932, 13943, 13956,
   13961, 13962, 13965, 13966, 13969, 13970, 13975, 13976, 13981, 13982,
   13991, 13996, 13997, 14001, 14005, 14011, 14036, 14047, 14061, 14062,
   14066, 14080, 14137, 14151, 14153, 14158, 14160, 14162, 14164, 14166,
   14171, 14173, 14178, 14186, 14197, 14225, 14226, 14230, 14232, 14237,
   14246, 14266, 14286, 14304, 14316, 14331, 14332, 14336, 14339, 14352,
   14357, 14364, 14369, 14375, 14380, 14389, 14391, 14394, 14398, 14399,
   14400, 14401, 14402, 14403, 14408, 14414, 14429, 14430, 14431, 14432,
   14433, 14444, 14450, 14458, 14459, 14465, 14470, 14475, 14480, 14485,
   14490, 14495, 14500, 14506, 14512, 14518, 14525, 14547, 14556, 14560,
   14568, 14572, 14580, 14592, 14613, 14617, 14623, 14627, 14640, 14648,
   14658, 14660, 14662, 14664, 14666, 14668, 14673, 14674, 14681, 14690,
   14698, 14707, 14718, 14726, 14727, 14728, 14732, 14734, 14736, 14738,
   14740, 14742, 14744, 14749, 14754, 14760, 14768, 14773, 14780, 14787,
   14791, 14795, 14803, 14838, 14839, 14841, 14850, 14857, 14873, 14875,
   14877, 14879, 14881, 14883, 14885, 14887, 14889, 14891, 14893, 14895,
   14897, 14899, 14902, 14904, 14907, 14909, 14911, 14913, 14916, 14921,
   14930, 14935, 14944, 14949, 14958, 14963, 14973, 14982, 14991, 15000,
   15019, 15028, 15037, 15046, 15055, 15072, 15081, 15090, 15099, 15108,
   15117, 15126, 15130, 15134, 15142, 15150, 15158, 15166, 15187, 15210,
   15222, 15229, 15245, 15250, 15256, 15263, 15270, 15278, 15286, 15303,
   15322, 15348, 15350, 15352, 15354, 15356, 15358, 15360, 15362, 15364,
   15366, 15368, 15370, 15372, 15374, 15376, 15378, 15380, 15382, 15384,
   15388, 15392, 15397, 15413, 15414, 15415, 15432, 15445, 15447, 15449,
   15461, 15486, 15498, 15510, 15518, 15529, 15540, 15550, 15556, 15565,
   15575, 15585, 15598, 15608, 15639, 15675, 15685, 15696, 15697, 15698,
   15705, 15712, 15716, 15720, 15724, 15728, 15732, 15736, 15740, 15744,
   15748, 15752, 15756, 15760, 15767, 15771, 15775, 15779, 15781, 15788,
   15795, 15802, 15809, 15820, 15834, 15844, 15855, 15871, 15881, 15888,
   15895, 15902, 15906, 15914, 15923, 15932, 15936, 15940, 15944, 15948,
   15952, 15961, 15965, 15975, 15979, 15983, 15988, 15999, 16005, 16019,
   16030, 16044, 16060, 16072, 16082, 16091, 16100, 16108, 16130, 16146,
   16170, 16172, 16176, 16178, 16180, 16183, 16186, 16189, 16190, 16193,
   16201, 16211, 16212, 16215, 16216, 16217, 16220, 16221, 16222, 16227,
   16231, 16235, 16239, 16246, 16247, 16255, 16256, 16260, 16261, 16269,
   16270, 16274, 16275, 16280, 16289, 16291, 16306, 16309, 16337, 16338,
   16341, 16342, 16350, 16358, 16366, 16375, 16385, 16403, 16449, 16458,
   16467, 16476, 16485, 16497, 16498, 16499, 16500, 16501, 16515, 16516,
   16517, 16520, 16521, 16524, 16527, 16528, 16529, 16532, 16533, 16536,
   16537, 16538, 16539, 16540, 16541, 16542, 16543, 16544, 16545, 16546,
   16547, 16550, 16552, 16557, 16559, 16564, 16566, 16568, 16570, 16572,
   16574, 16586, 16590, 16597, 16601, 16607, 16611, 16621, 16633, 16634,
   16637, 16638, 16641, 16645, 16649, 16655, 16656, 16661, 16671, 16672,
   16673, 16674, 16675, 16676, 16677, 16678, 16682, 16683, 16684, 16685,
   16690, 16695, 16704, 16725, 16729, 16734, 16745, 16762, 16768, 16769,
   16770, 16773, 16781, 16791, 16806, 16807, 16811, 16823, 16824, 16827,
   16828, 16831, 16835, 16842, 16846, 16850, 16859, 16871, 16872, 16876,
   16877, 16881, 16882, 16885, 16886, 16891, 16892, 16896, 16897, 16901,
   16913, 16914, 16915, 16916, 16917, 16918, 16919, 16920, 16921, 16925,
   16927, 16932, 16933, 16934, 16935, 16936, 16937, 16938, 16940, 16944,
   16946, 16948, 16951, 16955, 16958, 16962, 16971, 16988, 16995, 17000,
   17006, 17007, 17008, 17009, 17010, 17014, 17023, 17037, 17038, 17039,
   17040, 17041, 17050, 17051, 17052, 17053, 17054, 17058, 17060, 17070,
   17073, 17079, 17080, 17081, 17085, 17086, 17087, 17091, 17092, 17096,
   17114, 17134, 17135, 17144, 17145, 17149, 17150, 17153, 17161, 17169,
   17177, 17200, 17201, 17212, 17216, 17222, 17224, 17229, 17231, 17233,
   17243, 17245, 17256, 17260, 17264, 17268, 17272, 17281, 17289, 17321,
   17325, 17332, 17340, 17344, 17348, 17354, 17355, 17357, 17358, 17359,
   17363, 17404, 17432, 17436, 17440, 17446, 17448, 17462, 17498, 17511,
   17512, 17515, 17516, 17533, 17534, 17535, 17540, 17541, 17542, 17547,
   17548, 17549, 17550, 17556, 17557, 17558, 17559, 17560, 17566, 17567,
   17587, 17588, 17589, 17590, 17591, 17592, 17593, 17594, 17595, 17596,
   17597, 17598, 17599, 17600, 17601, 17602, 17603, 17604, 17605, 17606,
   17607, 17608, 17609, 17610, 17611, 17612, 17613, 17614, 17615, 17616,
   17617, 17618, 17619, 17620, 17621, 17622, 17623, 17624, 17625, 17626,
   17627, 17628, 17629, 17630, 17631, 17632, 17633, 17634, 17635, 17636,
   17637, 17638, 17639, 17640, 17641, 17642, 17643, 17644, 17645, 17646,
   17647, 17648, 17649, 17650, 17651, 17652, 17653, 17654, 17655, 17656,
   17657, 17658, 17659, 17660, 17661, 17662, 17663, 17664, 17665, 17666,
   17667, 17668, 17669, 17670, 17671, 17672, 17673, 17674, 17675, 17676,
   17677, 17678, 17679, 17680, 17681, 17682, 17683, 17684, 17685, 17686,
   17687, 17688, 17689, 17690, 17691, 17692, 17693, 17694, 17695, 17696,
   17697, 17698, 17699, 17700, 17701, 17702, 17703, 17704, 17705, 17706,
   17707, 17708, 17709, 17710, 17711, 17712, 17713, 17714, 17715, 17716,
   17717, 17718, 17719, 17720, 17721, 17722, 17723, 17724, 17725, 17726,
   17727, 17728, 17729, 17730, 17731, 17732, 17733, 17734, 17735, 17736,
   17737, 17738, 17739, 17740, 17741, 17742, 17743, 17744, 17745, 17746,
   17747, 17748, 17749, 17750, 17751, 17752, 17753, 17754, 17755, 17756,
   17757, 17758, 17759, 17760, 17761, 17762, 17763, 17764, 17765, 17766,
   17767, 17768, 17769, 17770, 17771, 17772, 17773, 17774, 17775, 17776,
   17777, 17778, 17779, 17780, 17781, 17782, 17783, 17784, 17785, 17786,
   17787, 17788, 17789, 17790, 17791, 17792, 17793, 17794, 17795, 17796,
   17797, 17798, 17799, 17800, 17801, 17802, 17803, 17804, 17805, 17806,
   17807, 17808, 17809, 17810, 17811, 17812, 17813, 17814, 17815, 17816,
   17817, 17818, 17819, 17820, 17821, 17822, 17823, 17824, 17825, 17826,
   17827, 17828, 17829, 17830, 17831, 17832, 17833, 17834, 17835, 17836,
   17837, 17838, 17839, 17840, 17841, 17842, 17843, 17844, 17845, 17846,
   17847, 17848, 17849, 17850, 17851, 17852, 17853, 17854, 17855, 17856,
   17857, 17858, 17859, 17860, 17861, 17862, 17863, 17864, 17865, 17866,
   17867, 17868, 17869, 17870, 17871, 17872, 17873, 17874, 17875, 17876,
   17877, 17878, 17879, 17880, 17881, 17882, 17883, 17884, 17885, 17886,
   17887, 17888, 17889, 17890, 17891, 17892, 17893, 17894, 17895, 17896,
   17897, 17898, 17899, 17900, 17901, 17902, 17903, 17904, 17905, 17906,
   17907, 17908, 17909, 17910, 17911, 17912, 17913, 17927, 17928, 17929,
   17930, 17931, 17932, 17933, 17934, 17935, 17936, 17937, 17938, 17939,
   17940, 17941, 17942, 17943, 17944, 17945, 17946, 17947, 17948, 17949,
   17950, 17951, 17952, 17953, 17954, 17955, 17956, 17957, 17958, 17959,
   17960, 17961, 17962, 17963, 17964, 17965, 17966, 17967, 17968, 17969,
   17970, 17971, 17972, 17973, 17974, 17975, 17976, 17977, 17978, 17979,
   17980, 17981, 17982, 17983, 17984, 17985, 17986, 17987, 17988, 17989,
   18003, 18004, 18005, 18006, 18007, 18008, 18009, 18010, 18011, 18012,
   18013, 18014, 18015, 18016, 18017, 18018, 18019, 18020, 18021, 18022,
   18023, 18024, 18025, 18035, 18036, 18037, 18038, 18039, 18040, 18041,
   18042, 18043, 18044, 18045, 18046, 18047, 18048, 18049, 18050, 18051,
   18052, 18053, 18054, 18055, 18056, 18057, 18058, 18059, 18060, 18061,
   18062, 18063, 18064, 18065, 18066, 18067, 18068, 18069, 18070, 18071,
   18072, 18073, 18074, 18075, 18076, 18077, 18078, 18079, 18080, 18081,
   18082, 18083, 18084, 18085, 18086, 18087, 18088, 18089, 18090, 18091,
   18092, 18093, 18094, 18095, 18096, 18097, 18098, 18099, 18100, 18101,
   18102, 18103, 18104, 18105, 18106, 18107, 18108, 18109, 18110, 18111,
   18112, 18125, 18126, 18127, 18128, 18129, 18130, 18131, 18132, 18133,
   18134, 18135, 18136, 18137, 18138, 18139, 18140, 18141, 18142, 18143,
   18144, 18145, 18146, 18147, 18148, 18149, 18150, 18151, 18152, 18153,
   18154, 18155, 18156, 18157, 18158, 18159, 18160, 18161, 18162, 18163,
   18164, 18165, 18166, 18167, 18168, 18169, 18170, 18171, 18172, 18173,
   18174, 18175, 18176, 18177, 18178, 18179, 18180, 18181, 18182, 18183,
   18184, 18185, 18186, 18187, 18188, 18189, 18190, 18191, 18192, 18193,
   18194, 18195, 18196, 18197, 18198, 18199, 18200, 18201, 18202, 18203,
   18204, 18205, 18206, 18207, 18208, 18209, 18210, 18211, 18212, 18213,
   18214, 18215, 18216, 18217, 18218, 18219, 18220, 18221, 18222, 18223,
   18224, 18225, 18226, 18227, 18228, 18229, 18230, 18231, 18232, 18233,
   18234, 18235, 18236, 18237, 18238, 18239, 18240, 18241, 18242, 18243,
   18244, 18245, 18246, 18247, 18248, 18249, 18250, 18251, 18252, 18253,
   18254, 18255, 18256, 18257, 18258, 18259, 18260, 18261, 18262, 18263,
   18264, 18265, 18266, 18267, 18268, 18269, 18270, 18271, 18272, 18273,
   18274, 18275, 18276, 18277, 18278, 18279, 18280, 18281, 18282, 18283,
   18284, 18285, 18286, 18287, 18288, 18289, 18290, 18291, 18292, 18293,
   18294, 18295, 18296, 18297, 18298, 18299, 18300, 18301, 18302, 18303,
   18304, 18305, 18306, 18307, 18308, 18309, 18310, 18311, 18312, 18313,
   18314, 18315, 18316, 18317, 18318, 18319, 18320, 18321, 18322, 18323,
   18324, 18325, 18326, 18327, 18328, 18329, 18330, 18331, 18332, 18333,
   18334, 18335, 18336, 18337, 18338, 18339, 18340, 18341, 18342, 18343,
   18344, 18345, 18346, 18347, 18348, 18349, 18350, 18351, 18352, 18353,
   18354, 18355, 18356, 18357, 18358, 18359, 18360, 18361, 18362, 18363,
   18364, 18365, 18366, 18367, 18368, 18369, 18370, 18371, 18372, 18373,
   18374, 18375, 18376, 18377, 18378, 18379, 18380, 18381, 18382, 18383,
   18384, 18385, 18386, 18387, 18388, 18389, 18390, 18391, 18392, 18393,
   18394, 18395, 18396, 18397, 18398, 18399, 18400, 18401, 18402, 18403,
   18404, 18405, 18406, 18407, 18408, 18409, 18410, 18411, 18412, 18413,
   18414, 18415, 18416, 18417, 18418, 18419, 18420, 18421, 18422, 18423,
   18424, 18425, 18426, 18427, 18428, 18429, 18430, 18431, 18432, 18433,
   18434, 18435, 18436, 18437, 18438, 18439, 18440, 18441, 18442, 18443,
   18444, 18445, 18446, 18447, 18448, 18449, 18450, 18451, 18452, 18453,
   18454, 18455, 18456, 18457, 18458, 18459, 18460, 18461, 18462, 18463,
   18464, 18465, 18466, 18467, 18468, 18469, 18470, 18471, 18472, 18473,
   18474, 18475, 18476, 18477, 18478, 18479, 18480, 18481, 18482, 18483,
   18484, 18485, 18486, 18487, 18488, 18489, 18490, 18491, 18492, 18493,
   18494, 18495, 18496, 18497, 18498, 18499, 18500, 18501, 18502, 18503,
   18504, 18505, 18506, 18507, 18508, 18509, 18510, 18511, 18512, 18513,
   18514, 18515, 18516, 18517, 18518, 18519, 18520, 18521, 18522, 18523,
   18524, 18525, 18526, 18527, 18528, 18529, 18530, 18531, 18532, 18533,
   18534, 18535, 18536, 18537, 18538, 18539, 18540, 18541, 18542, 18543,
   18544, 18545, 18546, 18547, 18548, 18549, 18550, 18551, 18552, 18553,
   18554, 18555, 18556, 18557, 18558, 18559, 18560, 18561, 18562, 18563,
   18564, 18565, 18566, 18567, 18568, 18569, 18570, 18571, 18572, 18573,
   18574, 18575, 18576
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "UIDENT", "FCONST", "SCONST",
  "USCONST", "BCONST", "XCONST", "Op", "ICONST", "PARAM", "TYPECAST",
  "DOT_DOT", "COLON_EQUALS", "EQUALS_GREATER", "LESS_EQUALS",
  "GREATER_EQUALS", "NOT_EQUALS", "ABORT_P", "ABSENT", "ABSOLUTE_P",
  "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER", "AGGREGATE", "ALL",
  "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE", "AND", "ANY", "ARRAY",
  "AS", "ASC", "ASENSITIVE", "ASSERTION", "ASSIGNMENT", "ASYMMETRIC",
  "ATOMIC", "AT", "ATTACH", "ATTRIBUTE", "AUTHORIZATION", "BACKWARD",
  "BEFORE", "BEGIN_P", "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P",
  "BOTH", "BREADTH", "BY", "CACHE", "CALL", "CALLED", "CASCADE",
  "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN", "CHAR_P", "CHARACTER",
  "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS", "CLOSE", "CLUSTER",
  "COALESCE", "COLLATE", "COLLATION", "COLUMN", "COLUMNS", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "COMPRESSION", "CONCURRENTLY",
  "CONDITIONAL", "CONFIGURATION", "CONFLICT", "CONNECTION", "CONSTRAINT",
  "CONSTRAINTS", "CONTENT_P", "CONTINUE_P", "CONVERSION_P", "COPY", "COST",
  "CREATE", "CROSS", "CSV", "CUBE", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DEPENDS", "DEPTH", "DESC", "DETACH",
  "DICTIONARY", "DISABLE_P", "DISCARD", "DISTINCT", "DO", "DOCUMENT_P",
  "DOMAIN_P", "DOUBLE_P", "DROP", "EACH", "ELSE", "EMPTY_P", "ENABLE_P",
  "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ERROR_P", "ESCAPE", "EVENT",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXPRESSION", "EXTENSION", "EXTERNAL", "EXTRACT", "FALSE_P",
  "FAMILY", "FETCH", "FILTER", "FINALIZE", "FIRST_P", "FLOAT_P",
  "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORMAT", "FORWARD", "FREEZE",
  "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GENERATED", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "GROUPING", "GROUPS", "HANDLER",
  "HAVING", "HEADER_P", "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE",
  "IMMEDIATE", "IMMUTABLE", "IMPLICIT_P", "IMPORT_P", "IN_P", "INCLUDE",
  "INCLUDING", "INCREMENT", "INDENT", "INDEX", "INDEXES", "INHERIT",
  "INHERITS", "INITIALLY", "INLINE_P", "INNER_P", "INOUT", "INPUT_P",
  "INSENSITIVE", "INSERT", "INSTEAD", "INT_P", "INTEGER", "INTERSECT",
  "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL", "ISOLATION", "JOIN",
  "JSON", "JSON_ARRAY", "JSON_ARRAYAGG", "JSON_EXISTS", "JSON_OBJECT",
  "JSON_OBJECTAGG", "JSON_QUERY", "JSON_SCALAR", "JSON_SERIALIZE",
  "JSON_TABLE", "JSON_VALUE", "KEEP", "KEY", "KEYS", "LABEL", "LANGUAGE",
  "LARGE_P", "LAST_P", "LATERAL_P", "LEADING", "LEAKPROOF", "LEAST",
  "LEFT", "LEVEL", "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOCKED", "LOGGED", "MAPPING",
  "MATCH", "MATCHED", "MATERIALIZED", "MAXVALUE", "MERGE", "MERGE_ACTION",
  "METHOD", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NESTED", "NEW", "NEXT", "NFC",
  "NFD", "NFKC", "NFKD", "NO", "NONE", "NORMALIZE", "NORMALIZED", "NOT",
  "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P", "NULLIF", "NULLS_P",
  "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET", "OIDS", "OLD", "OMIT",
  "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "ORDINALITY", "OTHERS", "OUT_P", "OUTER_P", "OVER", "OVERLAPS",
  "OVERLAY", "OVERRIDING", "OWNED", "OWNER", "PARALLEL", "PARAMETER",
  "PARSER", "PARTIAL", "PARTITION", "PASSING", "PASSWORD", "PATH",
  "PGPOOL", "PLACING", "PLAN", "PLANS", "POLICY", "POSITION", "PRECEDING",
  "PRECISION", "PRESERVE", "PREPARE", "PREPARED", "PRIMARY", "PRIOR",
  "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "PROCEDURES", "PROGRAM",
  "PUBLICATION", "QUOTE", "QUOTES", "RANGE", "READ", "REAL", "REASSIGN",
  "RECHECK", "RECURSIVE", "REF_P", "REFERENCES", "REFERENCING", "REFRESH",
  "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE", "REPLACE",
  "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURN", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROLLUP", "ROUTINE",
  "ROUTINES", "ROW", "ROWS", "RULE", "SAVEPOINT", "SCALAR", "SCHEMA",
  "SCHEMAS", "SCROLL", "SEARCH", "SECOND_P", "SECURITY", "SELECT",
  "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETS", "SETOF", "SHARE", "SHOW", "SIMILAR",
  "SIMPLE", "SKIP", "SMALLINT", "SNAPSHOT", "SOME", "SOURCE", "SQL_P",
  "STABLE", "STANDALONE_P", "START", "STATEMENT", "STATISTICS", "STDIN",
  "STDOUT", "STORAGE", "STORED", "STRICT_P", "STRING_P", "STRIP_P",
  "SUBSCRIPTION", "SUBSTRING", "SUPPORT", "SYMMETRIC", "SYSID", "SYSTEM_P",
  "SYSTEM_USER", "TABLE", "TABLES", "TABLESAMPLE", "TABLESPACE", "TARGET",
  "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P", "THEN", "TIES", "TIME",
  "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TRANSFORM", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P", "TYPES_P",
  "UESCAPE", "UNBOUNDED", "UNCONDITIONAL", "UNCOMMITTED", "UNENCRYPTED",
  "UNION", "UNIQUE", "UNKNOWN", "UNLISTEN", "UNLOGGED", "UNTIL", "UPDATE",
  "USER", "USING", "VACUUM", "VALID", "VALIDATE", "VALIDATOR", "VALUE_P",
  "VALUES", "VARCHAR", "VARIADIC", "VARYING", "VERBOSE", "VERSION_P",
  "VIEW", "VIEWS", "VOLATILE", "WHEN", "WHERE", "WHITESPACE_P", "WINDOW",
  "WITH", "WITHIN", "WITHOUT", "WORK", "WRAPPER", "WRITE", "XML_P",
  "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLEXISTS", "XMLFOREST",
  "XMLNAMESPACES", "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE",
  "XMLTABLE", "YEAR_P", "YES_P", "ZONE", "FORMAT_LA", "NOT_LA", "NULLS_LA",
  "WITH_LA", "WITHOUT_LA", "MODE_TYPE_NAME", "MODE_PLPGSQL_EXPR",
  "MODE_PLPGSQL_ASSIGN1", "MODE_PLPGSQL_ASSIGN2", "MODE_PLPGSQL_ASSIGN3",
  "'<'", "'>'", "'='", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS",
  "'['", "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept",
  "parse_toplevel", "stmtmulti", "toplevel_stmt", "stmt",
  "opt_single_name", "opt_qualified_name", "opt_concurrently",
  "opt_drop_behavior", "CallStmt", "CreateRoleStmt", "opt_with",
  "OptRoleList", "AlterOptRoleList", "AlterOptRoleElem",
  "CreateOptRoleElem", "CreateUserStmt", "AlterRoleStmt",
  "opt_in_database", "AlterRoleSetStmt", "DropRoleStmt", "CreateGroupStmt",
  "AlterGroupStmt", "add_drop", "CreateSchemaStmt", "OptSchemaEltList",
  "schema_stmt", "VariableSetStmt", "set_rest", "generic_set",
  "set_rest_more", "var_name", "var_list", "var_value", "iso_level",
  "opt_boolean_or_string", "zone_value", "opt_encoding",
  "NonReservedWord_or_Sconst", "VariableResetStmt", "reset_rest",
  "generic_reset", "SetResetClause", "FunctionSetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "partition_cmd",
  "index_partition_cmd", "alter_table_cmd", "alter_column_default",
  "opt_collate_clause", "alter_using", "replica_identity", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem",
  "alter_identity_column_option_list", "alter_identity_column_option",
  "set_statistics_value", "set_access_method_name", "PartitionBoundSpec",
  "hash_partbound_elem", "hash_partbound", "AlterCompositeTypeStmt",
  "alter_type_cmds", "alter_type_cmd", "ClosePortalStmt", "CopyStmt",
  "copy_from", "opt_program", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "copy_delimiter",
  "opt_using", "copy_generic_opt_list", "copy_generic_opt_elem",
  "copy_generic_opt_arg", "copy_generic_opt_arg_list",
  "copy_generic_opt_arg_list_item", "CreateStmt", "OptTemp",
  "OptTableElementList", "OptTypedTableElementList", "TableElementList",
  "TypedTableElementList", "TableElement", "TypedTableElement",
  "columnDef", "columnOptions", "column_compression",
  "opt_column_compression", "column_storage", "opt_column_storage",
  "ColQualList", "ColConstraint", "ColConstraintElem",
  "opt_unique_null_treatment", "generated_when", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "DomainConstraint",
  "DomainConstraintElem", "opt_no_inherit", "opt_column_list",
  "columnList", "columnElem", "opt_c_include", "key_match",
  "ExclusionConstraintList", "ExclusionConstraintElem", "OptWhereClause",
  "key_actions", "key_update", "key_delete", "key_action", "OptInherit",
  "OptPartitionSpec", "PartitionSpec", "part_params", "part_elem",
  "table_access_method_clause", "OptWith", "OnCommitOption",
  "OptTableSpace", "OptConsTableSpace", "ExistingIndex", "CreateStatsStmt",
  "stats_params", "stats_param", "AlterStatsStmt", "CreateAsStmt",
  "create_as_target", "opt_with_data", "CreateMatViewStmt",
  "create_mv_target", "OptNoLog", "RefreshMatViewStmt", "CreateSeqStmt",
  "AlterSeqStmt", "OptSeqOptList", "OptParenthesizedSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateExtensionStmt", "create_extension_opt_list",
  "create_extension_opt_item", "AlterExtensionStmt",
  "alter_extension_opt_list", "alter_extension_opt_item",
  "AlterExtensionContentsStmt", "CreateFdwStmt", "fdw_option",
  "fdw_options", "opt_fdw_options", "AlterFdwStmt",
  "create_generic_options", "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "AlterForeignServerStmt",
  "CreateForeignTableStmt", "ImportForeignSchemaStmt",
  "import_qualification_type", "import_qualification",
  "CreateUserMappingStmt", "auth_ident", "DropUserMappingStmt",
  "AlterUserMappingStmt", "CreatePolicyStmt", "AlterPolicyStmt",
  "RowSecurityOptionalExpr", "RowSecurityOptionalWithCheck",
  "RowSecurityDefaultToRole", "RowSecurityOptionalToRole",
  "RowSecurityDefaultPermissive", "RowSecurityDefaultForCmd",
  "row_security_cmd", "CreateAmStmt", "am_type", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerReferencing", "TriggerTransitions", "TriggerTransition",
  "TransitionOldOrNew", "TransitionRowOrTable", "TransitionRelName",
  "TriggerForSpec", "TriggerForOptEach", "TriggerForType", "TriggerWhen",
  "FUNCTION_or_PROCEDURE", "TriggerFuncArgs", "TriggerFuncArg",
  "OptConstrFromTable", "ConstraintAttributeSpec",
  "ConstraintAttributeElem", "CreateEventTrigStmt",
  "event_trigger_when_list", "event_trigger_when_item",
  "event_trigger_value_list", "AlterEventTrigStmt", "enable_trigger",
  "CreateAssertionStmt", "DefineStmt", "definition", "def_list",
  "def_elem", "def_arg", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list", "AlterEnumStmt",
  "opt_if_not_exists", "CreateOpClassStmt", "opclass_item_list",
  "opclass_item", "opt_default", "opt_opfamily", "opclass_purpose",
  "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "object_type_any_name", "object_type_name", "drop_type_name",
  "object_type_name_on_any_name", "any_name_list", "any_name", "attrs",
  "type_name_list", "TruncateStmt", "opt_restart_seqs", "CommentStmt",
  "comment_text", "SecLabelStmt", "opt_provider", "security_label",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "parameter_name_list", "parameter_name", "privilege_target",
  "grantee_list", "grantee", "opt_grant_grant_option", "GrantRoleStmt",
  "RevokeRoleStmt", "grant_role_opt_list", "grant_role_opt",
  "grant_role_opt_value", "opt_granted_by", "AlterDefaultPrivilegesStmt",
  "DefACLOptionList", "DefACLOption", "DefACLAction",
  "defacl_privilege_target", "IndexStmt", "opt_unique",
  "access_method_clause", "index_params", "index_elem_options",
  "index_elem", "opt_include", "index_including_params", "opt_collate",
  "opt_asc_desc", "opt_nulls_order", "CreateFunctionStmt",
  "opt_or_replace", "func_args", "func_args_list",
  "function_with_argtypes_list", "function_with_argtypes",
  "func_args_with_defaults", "func_args_with_defaults_list", "func_arg",
  "arg_class", "param_name", "func_return", "func_type",
  "func_arg_with_default", "aggr_arg", "aggr_args", "aggr_args_list",
  "aggregate_with_argtypes", "aggregate_with_argtypes_list",
  "opt_createfunc_opt_list", "createfunc_opt_list", "common_func_opt_item",
  "createfunc_opt_item", "func_as", "ReturnStmt", "opt_routine_body",
  "routine_body_stmt_list", "routine_body_stmt", "transform_type_list",
  "opt_definition", "table_func_column", "table_func_column_list",
  "AlterFunctionStmt", "alterfunc_opt_list", "opt_restrict",
  "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt", "oper_argtypes",
  "any_operator", "operator_with_argtypes_list", "operator_with_argtypes",
  "DoStmt", "dostmt_opt_list", "dostmt_opt_item", "CreateCastStmt",
  "cast_context", "DropCastStmt", "opt_if_exists", "CreateTransformStmt",
  "transform_element_list", "DropTransformStmt", "ReindexStmt",
  "reindex_target_relation", "reindex_target_all",
  "opt_reindex_option_list", "AlterTblSpcStmt", "RenameStmt", "opt_column",
  "opt_set_data", "AlterObjectDependsStmt", "opt_no",
  "AlterObjectSchemaStmt", "AlterOperatorStmt", "operator_def_list",
  "operator_def_elem", "operator_def_arg", "AlterTypeStmt",
  "AlterOwnerStmt", "CreatePublicationStmt", "PublicationObjSpec",
  "pub_obj_list", "AlterPublicationStmt", "CreateSubscriptionStmt",
  "AlterSubscriptionStmt", "DropSubscriptionStmt", "RuleStmt",
  "RuleActionList", "RuleActionMulti", "RuleActionStmt",
  "RuleActionStmtOrEmpty", "event", "opt_instead", "NotifyStmt",
  "notify_payload", "ListenStmt", "UnlistenStmt", "TransactionStmt",
  "TransactionStmtLegacy", "opt_transaction", "transaction_mode_item",
  "transaction_mode_list", "transaction_mode_list_or_empty",
  "opt_transaction_chain", "ViewStmt", "opt_check_option", "LoadStmt",
  "CreatedbStmt", "createdb_opt_list", "createdb_opt_items",
  "createdb_opt_item", "createdb_opt_name", "opt_equal",
  "AlterDatabaseStmt", "AlterDatabaseSetStmt", "DropdbStmt",
  "drop_option_list", "drop_option", "AlterCollationStmt",
  "AlterSystemStmt", "CreateDomainStmt", "AlterDomainStmt", "opt_as",
  "AlterTSDictionaryStmt", "AlterTSConfigurationStmt", "any_with",
  "CreateConversionStmt", "ClusterStmt", "cluster_index_specification",
  "VacuumStmt", "AnalyzeStmt", "utility_option_list", "analyze_keyword",
  "utility_option_elem", "utility_option_name", "utility_option_arg",
  "opt_analyze", "opt_verbose", "opt_full", "opt_freeze", "opt_name_list",
  "vacuum_relation", "vacuum_relation_list", "opt_vacuum_relation_list",
  "ExplainStmt", "ExplainableStmt", "PrepareStmt", "prep_type_clause",
  "PreparableStmt", "ExecuteStmt", "execute_param_clause",
  "DeallocateStmt", "InsertStmt", "insert_target", "insert_rest",
  "override_kind", "insert_column_list", "insert_column_item",
  "opt_on_conflict", "opt_conf_expr", "returning_clause", "DeleteStmt",
  "using_clause", "LockStmt", "opt_lock", "lock_type", "opt_nowait",
  "opt_nowait_or_skip", "UpdateStmt", "set_clause_list", "set_clause",
  "set_target", "set_target_list", "MergeStmt", "merge_when_list",
  "merge_when_clause", "merge_when_tgt_matched",
  "merge_when_tgt_not_matched", "opt_merge_when_condition", "merge_update",
  "merge_delete", "merge_insert", "merge_values_clause",
  "DeclareCursorStmt", "cursor_name", "cursor_options", "opt_hold",
  "SelectStmt", "select_with_parens", "select_no_parens", "select_clause",
  "simple_select", "with_clause", "cte_list", "common_table_expr",
  "opt_materialized", "opt_search_clause", "opt_cycle_clause",
  "opt_with_clause", "into_clause", "OptTempTableName", "opt_table",
  "set_quantifier", "distinct_clause", "opt_all_clause",
  "opt_distinct_clause", "opt_sort_clause", "sort_clause", "sortby_list",
  "sortby", "select_limit", "opt_select_limit", "limit_clause",
  "offset_clause", "select_limit_value", "select_offset_value",
  "select_fetch_first_value", "I_or_F_const", "row_or_rows",
  "first_or_next", "group_clause", "group_by_list", "group_by_item",
  "empty_grouping_set", "rollup_clause", "cube_clause",
  "grouping_sets_clause", "having_clause", "for_locking_clause",
  "opt_for_locking_clause", "for_locking_items", "for_locking_item",
  "for_locking_strength", "locked_rels_list", "values_clause",
  "from_clause", "from_list", "table_ref", "joined_table", "alias_clause",
  "opt_alias_clause", "opt_alias_clause_for_join_using",
  "func_alias_clause", "join_type", "opt_outer", "join_qual",
  "relation_expr", "extended_relation_expr", "relation_expr_list",
  "relation_expr_opt_alias", "tablesample_clause", "opt_repeatable_clause",
  "func_table", "rowsfrom_item", "rowsfrom_list", "opt_col_def_list",
  "opt_ordinality", "where_clause", "where_or_current_clause",
  "OptTableFuncElementList", "TableFuncElementList", "TableFuncElement",
  "xmltable", "xmltable_column_list", "xmltable_column_el",
  "xmltable_column_option_list", "xmltable_column_option_el",
  "xml_namespace_list", "xml_namespace_el", "json_table",
  "json_table_path_name_opt", "json_table_column_definition_list",
  "json_table_column_definition", "path_opt",
  "json_table_column_path_clause_opt", "Typename", "opt_array_bounds",
  "SimpleTypename", "ConstTypename", "GenericType", "opt_type_modifiers",
  "Numeric", "opt_float", "Bit", "ConstBit", "BitWithLength",
  "BitWithoutLength", "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "ConstDatetime",
  "ConstInterval", "opt_timezone", "opt_interval", "interval_second",
  "JsonType", "a_expr", "b_expr", "c_expr", "func_application",
  "func_expr", "func_expr_windowless", "func_expr_common_subexpr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_indent_option", "xml_whitespace_option", "xmlexists_argument",
  "xml_passing_mech", "within_group_clause", "filter_clause",
  "window_clause", "window_definition_list", "window_definition",
  "over_clause", "window_specification", "opt_existing_window_name",
  "opt_partition_clause", "opt_frame_clause", "frame_extent",
  "frame_bound", "opt_window_exclusion_clause", "row", "explicit_row",
  "implicit_row", "sub_type", "all_Op", "MathOp", "qual_Op", "qual_all_Op",
  "subquery_Op", "expr_list", "func_arg_list", "func_arg_expr",
  "func_arg_list_opt", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "unicode_normal_form", "overlay_list",
  "position_list", "substr_list", "trim_list", "in_expr", "case_expr",
  "when_clause_list", "when_clause", "case_default", "case_arg",
  "columnref", "indirection_el", "opt_slice_bound", "indirection",
  "opt_indirection", "opt_asymmetric", "json_passing_clause_opt",
  "json_arguments", "json_argument", "json_wrapper_behavior",
  "json_behavior", "json_behavior_type", "json_behavior_clause_opt",
  "json_on_error_clause_opt", "json_value_expr", "json_format_clause",
  "json_format_clause_opt", "json_quotes_clause_opt",
  "json_returning_clause_opt", "json_predicate_type_constraint",
  "json_key_uniqueness_constraint_opt", "json_name_and_value_list",
  "json_name_and_value", "json_object_constructor_null_clause_opt",
  "json_array_constructor_null_clause_opt", "json_value_expr_list",
  "json_aggregate_func", "json_array_aggregate_order_by_clause_opt",
  "opt_target_list", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "attr_name", "file_name",
  "func_name", "AexprConst", "Iconst", "Sconst", "SignedIconst", "RoleId",
  "RoleSpec", "role_list", "PLpgSQL_Expr", "PLAssignStmt",
  "plassign_target", "plassign_equals", "ColId", "type_function_name",
  "NonReservedWord", "ColLabel", "BareColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword",
  "bare_label_keyword", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774,
     775,   776,    60,    62,    61,    43,    45,    42,    47,    37,
      94,   777,    91,    93,    40,    41,    46,    59,    44,    58
};
# endif

#define YYPACT_NINF -5863

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-5863)))

#define YYTABLE_NINF -2992

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-2992)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const int yypact[] =
{
   11769,  1936, 11261, -5863, -5863,  1936, 71964, -5863, 81635,    33,
     901,  1413,   222, 21122, 82144, 93342,  1008,   397, 21011,  1936,
   93342,  2232, 62292, 77563,   373, 93342,  1576,  1177, 62292, 93342,
   93851, 94360,  1432,  1581,  1421, 94869, 82653, 76036,  1885, 93342,
    1612,  1839, 95378, 83162,  1586, 83671,  1177, 57213,   470,  1509,
   95887, 93342,120744,  1839, 84180, 84180, 84180,  2383,  2164,  1717,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863,  1530, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,  2218, -5863,
    1278,  2402,    63,   986,  1726, -5863, -5863,  2277, 71964, 93342,
   93342, 93342,  2008, 93342,  1920, 93342,   980, 71964, 68401, 84689,
    2123,  1907, 53025, 96396, -5863, 71964, 93342, 65856, 71964, 93342,
   93342, 96905, 93342, 97414, 93342,  1990, 80108, 93342,  2069, 93342,
   93342, 66365, 97923,  2287,  1461,   282, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
    2026,  2010, -5863,   307, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, 62801, 93342, 10760,  1576,  2277, -5863,  2383,
   93342,  2301, 93342,  2046, 98432, 93342, -5863, 93342,  2018, 98941,
    1014,  1943, 68401,  2170, 53553,  2270, 93342, 93342, 68401, 99450,
   99959,100468, 93342, 93342, -5863, -5863,  2221, 93342, -5863,  2377,
   68910,  1823,  2393,  2569,  2463,  1334, -5863, 85198, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, 71455,   397, -5863, -5863,
    2403, 72473,  2485, -5863, -5863,100977,121239,  2235, -5863,  1040,
   72982, 69419,  2614,  2231, 54081,  2652, -5863, 73491, -5863, 69928,
   74000, -5863, -5863, -5863, -5863, -5863,101486, -5863,101995,  2329,
    2485, -5863,121734, 70437, -5863,  2505,102504,103013,103522,  2277,
    2222,  1543,  1281, 47318, -5863, -5863, -5863,  2290, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863,   383,  1501,   270,
     273,   308, -5863, -5863,   274,   291,   295,   383,  2756,  2756,
   -5863, 93342, -5863, -5863,  1501,    90,  2349,  2251,  2251,  2251,
    2484,    37, -5863,  2251,  2423, -5863, -5863, -5863, -5863, 83671,
   -5863,  2265,  1576,   257, 85707, 71455,  1576,  2775,104031, 86216,
    2366,  2429,  2552, -5863, -5863,   999, -5863,  1576,  2339,  2850,
    2450, 62801,   964, 93342, -5863, -5863,  2865,  2409,  2700,  2437,
   -5863, -5863,  2627,  2642,   187,   998,  1576,   285, -5863,  2795,
   -5863,  2675, 32161, 32161, 86725,104540, 87234,  2949,  1568, -5863,
   -5863, -5863,  2992,  2549,  2821,  2437,  1461, 49378, -5863, -5863,
    2539,  2010, 83671, -5863, -5863, -5863, 62801,  2895, 35323, 93342,
    2558, -5863,  2553,  2558, -5863, -5863,  2636, -5863,  2636,  2636,
    2598,  2598,  2785,  2656, -5863, -5863, -5863, -5863,  2103,  2636,
    2598, -5863,122724, -5863,  2041,  2054, -5863, -5863,  3116, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863,  2661, -5863,  1019,
   -5863,  2145, -5863, -5863, -5863, 32161, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863,  2665,  2678,    63, -5863, 12510, 62801, 93342,
    1889,  1889,  3106,  1889,  1617,  2021, -5863,  2644, -5863,  3047,
    3007,  3013, 83671,  2730,  1569, -5863,  1477,  2738,   177,  2745,
    1951,  2825, -5863,  1001, 93342,   503,  2748, 87743,  4017,  2758,
    2010,  2773, -5863, -5863, -5863, -5863,  2941,   454, -5863, -5863,
   -5863, -5863,  3108,  3153,  6456,   351, 88252, -5863, -5863, -5863,
   -5863, 93342, 93342, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863,  2777,  1884, -5863, -5863,  2776,  3156,  3010,  4231,
    1416,  3121,  2956,  1799,  9432,  3022,  1718,  3175,  8506,  1863,
    3176,  1976,  2188, 85707, 93342,  3140,  3189,  5558,  1838,   289,
    3039,  1120,  3121,  3179,  2988,  1799,  3200,  6980, 93342, -5863,
    3110,  3237,   131, -5863,   230, -5863, 24838, 35323, 56704, -5863,
    2010, -5863,  1268, -5863, -5863, 61783, -5863,  2893,  3059,    96,
   71964,  2838, 93342, 93342, -5863,120744, 71964, -5863,  3072, 54609,
   71964, -5863, 71964, -5863, -5863,  3205,120744, 93342, 93342, -5863,
   93342, -5863, -5863,  2842, -5863, -5863, -5863, -5863, -5863,  2251,
   93342,  3306,120744,  3089,   196,  1740,  3345, 93342,  3092,  1740,
    2892,105049, -5863, -5863,  1740, -5863, -5863, -5863, 93342, 93342,
    2855,  2285,  3082,   942,  1740,  3100,  3346,  3354,  3109,  2947,
    3114,  2553, -5863,  3316,  3086,  1135,   233,  2302,  1740,  2927,
  105558,106067, 93342,  2929, 93342,  3329, 71964,  2968, 71964, 71964,
   93342,  3251, 93342, -5863,  3080, -5863, -5863,  1264, -5863, -5863,
   -5863, -5863, -5863,  3271, -5863,   237,  3272,  2901,  3281,  1861,
    3282,   302, -5863, -5863,  2945, -5863,  3290,   333, -5863,  3292,
   -5863,  2910,106576, -5863,107085,107594,  3295,   335, -5863, 68401,
    3296,   333,  3297,  2910,  3298,   333,  3299,  1043,  3300, -5863,
    1382,  3287,  3303,   302,  3307,  2340,  2910, -5863,  3308,   375,
   -5863,  3310,   386, -5863,  3315,  3155, -5863, 35323, -5863,  3034,
   -5863,  1509,  2153,  1281,  1501, -5863, 93342,  1501, 93342,  1501,
   93342,  1501, 93342,  1501, 93342, 93342, 93342,  1501, -5863, -5863,
   -5863, 93342,  2946, 93342, -5863, 93342, -5863, -5863, -5863, 78581,
   68401, 79090, -5863, 93342, -5863,   881,  1576, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, 70946,  3360, -5863,  1749, -5863,
    2437,   369,  1576,  2332,  3376, 60256, 60765, 93342, -5863,120744,
    3455, 68401,  3329,  2154, -5863, -5863,  3329, -5863, -5863,  3329,
    3329, -5863, -5863, -5863,  3243,  3327, 78581, 68401,  3328, -5863,
  108103, -5863, 71455,  3188,  2966, -5863, -5863, -5863, -5863, -5863,
    2161,  3496,   263,  3498, 35323,  2971,   263,   263,  2974,  3340,
   -5863, -5863, -5863,   309,  2978,  2981, -5863,   280,   280, -5863,
    2983,  2989, -5863,   283,  2993,  2996,  3527,  3529,   284,   304,
    3011,  3014,  3016,  3017,  3018,  3019,  3023,  3024,  3025,  3027,
    3028,  3031,  3033,  2103,   263,  3035, 35323, -5863,  3038,   280,
    3042,  3048,  3050,  3541,  3052, -5863,  3550,  3055, -5863,   347,
     353,  3056,  3058, -5863,  3294, -5863,   323,  3060,  3061,  3063,
    3064,  3069,  3073,  3074,  3075, 35323, 35323, 35323, -5863, 29521,
    2010,  1576, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
     324, -5863, 51441, -5863,  3118, -5863, -5863,  3261, -5863, -5863,
   35323, -5863, -5863,  3446,   139, -5863,   326, -5863, -5863, -5863,
    2010,  3392,  3078, -5863,  2070,  3079, -5863,  2143, -5863,  3581,
   -5863,  3360,   230, -5863, -5863,  3370, -5863, 93342, -5863, -5863,
    2010,   216,  2174, -5863,  2290, 20763,  2195,  2558, 93342, 93342,
    3585, -5863,  3091, -5863, -5863, 35323, -5863, -5863, -5863,  2756,
   -5863,  2636,  2636, -5863, -5863,  3589,  3182,  3183,  2756, -5863,
    2756, -5863,  3097,  3099,  2756,  3185,  3186,  3187, -5863,  3103,
    3191,  2756, -5863, -5863, 63820,  2186, -5863,  3464,   366, -5863,
   -5863, -5863,  2199, -5863,  3104, -5863,  2553, -5863, -5863,    63,
      63, 35323,    63,   293,  1588, 32688, 35850,  3472,  3341,  1012,
    1890,  3473, -5863,  3347,  1617,  2021, 83671, 93342, 83671,108612,
    3245, 35323, -5863,  3580,  3203,  3204,  3265, 59249, -5863,  3208,
    3173,  3211,  3275,  3124,  3214,  3220,  3277, -5863,  3415, -5863,
   -5863,  3225,  3302,  3590,  3228,109121, -5863, -5863,  1134, -5863,
   -5863, -5863,  1134, -5863,  3157,  1528,  1636,   343,  3232,   336,
    1456,  3588, -5863,  1510, -5863, -5863,  3301, -5863, 21649, 93342,
    3528,  8008,  3378,   351,  3309, -5863, -5863, -5863,  3436,  3241,
   93342,  3242,  3394,   351,   364,109630, -5863, -5863, 93342, -5863,
   -5863, -5863, -5863,  7073,  3565, 28002, -5863,  2060,  3247,  3226,
    3259, 93342, 75018,  1874,  3371,  3393,  1655,  2216,   990,  3320,
   93342,   355,  3403, 93342,  3172,  3260,  3262,  3516,  3180,   751,
    3623,  3184, -5863, -5863, -5863,  3592, -5863,   540,   550,  3397,
   -5863,  3517,  3560,  8236,  3252,  3253,118764, -5863,  3276,   790,
   55137, 93342, 93342,  3283,  3284,110139,  7073,  3600, 79599, 79599,
    3285,  3286, 48863,  3615,  2031,  3288, -5863, -5863, -5863,  2031,
    3289,  3293,110648,  7073,  3606, 93342,  3314,  3318, 93342,122724,
     351, -5863,  3678,   351,   351,  2191,  3679,  3319,   395,  3463,
     663,  1740,  3184,  2979, -5863,  3330,  3334,  1158, -5863,  3430,
   93342,  3335,  3336,   143,  3396,  1576, -5863,  3398, -5863,  3337,
    3399,  3342,    92,  2855, -5863, -5863,  3338, 83671,  3414,  3416,
     355,   290,   747,  3184, -5863,  3343,  3344,  3180,  3180, 93342,
   93342, 93342, 93342, 93342,   310,  3697,   311,  3348,   262,  1215,
    3210, -5863,  2031, 66874,  3351, -5863,  2031, 93342,   275,   754,
    3184,  2158,  2098, -5863, -5863, -5863,  1461, -5863, 35323, 35323,
   35323,  3221, -5863,  1929, 20763,  1067, -5863,   344, 11513,  3216,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, 93342, 62801, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, 93342, -5863, 93342,  3552,
  120744,  3563,  3480,  3569,  3570,   351, 93342, 93342,  3575,  3576,
    3577,120744,  3579,  3582,  3583,  3497,  3361,   206,  3352,  3278,
    3776,  3665, 93342, 63820, -5863,  1134, -5863,120744,  3515,  3667,
   -5863, 93342,  3533,   786, -5863,  3706,  3355, -5863, -5863,   124,
   93342, 78072,  2855, -5863, -5863,  3671, 68401,   412,  3672,  1576,
    3349,  3673,  3523,  1576, 68401,  3574, 93342, 93342, 93342, 93342,
     158, -5863, 66874,  3542, -5863, 93342,  3544,  2979,  3545,  3800,
    1266,  2251,111157,  3668, -5863,111666,  3312, 93342,  3313,  3313,
    3802,120744,  1173,  3599, -5863, -5863,  2451, -5863,  3452, -5863,
   71964, -5863, -5863, 71964, -5863, -5863,120744, 93342,  3317,120744,
  120744, -5863, -5863, 71964, 71964, -5863, 68401, 68401,  3687,   375,
    3688,  3377,  3691,  3381, 55137, 55137, -5863,   392, 71964, -5863,
   68401, 71964, -5863, 93342, -5863, 93342, -5863, -5863, -5863, -5863,
  120744,120744, -5863, 68401, 66874,  3693, 93342, 93342, -5863, 93342,
   93342, -5863, 93342, 93342,  2200,112175,  1281, -5863, 93342, -5863,
   93342, -5863, 93342, -5863, 93342, -5863, 93342, -5863, -5863, -5863,
   93342, -5863, 93342,  2205, -5863, -5863,  2207,  1634, 93342, 93342,
     250, 71964, 93342,  3553, 93342, 71964, 71964, 93342, 93342, 93342,
   93342, 93342,  3408,  3079,   163, -5863,   367,   318, 83671,  3562,
   -5863, -5863, -5863,  1576, -5863, -5863, -5863, -5863, -5863,   345,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863,  3321, -5863, -5863,
   -5863, -5863,  3321, -5863, -5863,  2211,  2383,    53, 93342, -5863,
   93342, 93342, 93342, -5863, 77563,  3680,   200, 79090, 93342, -5863,
   -5863,  6625, 35323,  2010, 31629, -5863, -5863, 20763,  3373, 35323,
   35323,  3331,  2756,  2756, -5863,   365, 35323, 35323, 35323, 28994,
   35323, 35323, 33215, 35323, 35323, 35323, 35323, 35323, 35323,  2756,
    2756,  3326, 35323,  3561, 35323, 55137, 35323, 41120, 25904, 35323,
   35323, 30048,   313,  2983, 35323,  3586, 42168, 35323,  2332,  3591,
   35323,  2332,  3561,  3851,  3851,  2898,  7500,  3332,  2010, -5863,
    2756,   252, -5863,   430,120744, 35323, 35323, 35323, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, 35323, -5863, 63820, -5863, -5863, -5863, -5863,
   -5863, -5863,   883, -5863, -5863, -5863, -5863, -5863, -5863,  2924,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, 93342, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   30575, -5863, -5863, -5863, -5863,  3358, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863,  3467, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, 31102, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863,  3359, -5863, -5863,
   35323, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863,  3422, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863,  1201, 35323, 35323, 35323, 35323, 35323, 35323,
   35323, 35323, 35323, -5863, 35323,   575, -5863, -5863,  3686,  3446,
      69,   465,  3362,  3555, 88761, 32161,  3464, 24838, -5863,   258,
    3464, -5863, -5863, -5863, 93342,  3581,  3426, -5863,  3368,  3682,
    3683,  1043, 93342,  2455, 35323,   883,   296, 93342, 35323,  3358,
    3467, 35323,  3359, 35323,  3422, -5863, 35323, -5863,  2217,   907,
   35323,  2225,  3369, -5863, -5863,  3356,  3099,  3375,  3383,  3374,
    3379,  2756,   269,  3380,  1470,  1443,  3494,  2756,  3621,  3382,
   -5863, 63820, -5863, 44228,  3417, -5863, -5863, -5863,  1839, 93342,
   93342, -5863,  3690, -5863,  3385, -5863, 17973,  3690, -5863, -5863,
   41644,  3502,  3676,  3602, -5863, -5863, -5863,  3387, 20763, 36377,
   36377, -5863,  2125, 20763,  2240, -5863, -5863, -5863, -5863, -5863,
   -5863,  1711, -5863, 93342,   869,  3472,  1890,  3440,  1940,  3870,
    3441, 93342, -5863, 49893,  2236, -5863, 68401, 93342, 93342,  3601,
   -5863,  3860, -5863,122724, -5863,  3395, -5863,122229,117774, -5863,
   -5863,  1032, -5863,   541, 68401, -5863, 93342, 93342, 68401, 93342,
   93342, -5863, 68401, 85707,  3444, 93342, 93342, -5863, -5863, -5863,
   -5863, -5863, 61274,   775, 77563,  3539, 76545, -5863, -5863,  3400,
   93342,  3632, -5863, -5863,112684, -5863,  3634, 68401, 93342, 93342,
   35323,  3635, 93342, 93342, -5863,   988,  3489,  3495, -5863, 93342,
    3499, 71964,  3407,120744, 71964, 55665, 71964, 71964,  3772,120744,
   93342, 93342,  1372, 83671,   338,  1024,  3184,  3648, -5863,   379,
   -5863, 68401, -5863, 93342,  3640, -5863, -5863, -5863, 89270, -5863,
   -5863, -5863,113193, -5863, -5863,  3642, -5863,  2238, -5863, 68401,
   68401, 93342,  8707,  3419,113702, 93342,    34,  3711,  3663,  3717,
    1211, -5863, -5863, -5863,120744, -5863, 93342, 89779, 93342, 93342,
    3708, 93342, 80617,114211,114720,   118,   803,  3709, 93342, 81126,
    3710, -5863,  3578, 93342, -5863, -5863, 64329, 68401, 93342,  1054,
   63820, -5863,  3694, -5863, 93342, -5863,  1430, -5863, 93342,  7336,
    3655, -5863, -5863,  3518,  3532, 93342,   436,  1094,  3184,  3838,
   93342, 93342,  3433,  2244, 68401, 93342, 63820, -5863,  3664,   826,
   68401, 93342, 89270, -5863,  3669, -5863, 83671,  3774, -5863,  3435,
    2251,  2539,  2047,  3435, 68401, 93342, -5863,  3435, 93342,104540,
   -5863, 68401,  1349, -5863, 68401, 93342, 89270, -5863,  3675,  3613,
   68401, 93342, 14139, -5863, -5863, -5863,   351, -5863, -5863, -5863,
   -5863, -5863, 93342, 93342,   351, 93342, 93342,   351,   342, -5863,
   68401, 93342, -5863, -5863, -5863,  3603, 68401, 93342, 93342,   378,
   93342, -5863, 93342, 68401,  3490, 93342, 93342, -5863, -5863, 93342,
    5665, 93342, 93342, 93342, 93342, 93342, 93342, 68401, 93342, -5863,
   -5863,  1393,   103,  2001,  2020,   892, 93342,  3790, 93342,115229,
    1576, 68401, 93342, 93342,  1576, 93342, 63820,  2187, -5863, -5863,
    3593, -5863, 68401,  1349, -5863,  8726, 93342, 93342, 93342,  3546,
    3547,   241,  3646, -5863, -5863, -5863,  1207,  1207,  3689, -5863,
   35323, 35323, 33742,  3469, -5863, -5863, 35323,  2893, -5863, -5863,
   -5863,  1184,  3968,  1184,115738,  1184,  1184,  3784,  3538,  3543,
    1184,  1184,  1184,  3768,  1184,  1184,  1184, 93342,  3666, -5863,
   -5863,  3666,   218, 35323,120744, 93342, -5863,  2255, -5863,  3493,
   -5863, -5863, 63820, 93342,   880,  1062,  3856,  3712, 75527,  1493,
    3847, 93342,  3535, 93342,  3983,  3595,  1803, -5863,  1493, 93342,
   -5863,  2580, 77563, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   93342, -5863, -5863,  3855, 93342, 44743,  3685, -5863,  1576,  2855,
    2855,  2855,  2855,  3500,  2855, 93342,  3639,  3874,  1493,  3505,
    3876, -5863,  2979,  3885,  1341, 93342,  3741, 75527,  3572,  3554,
    3754,  4011,  2251,  1576,  3758,  3744, -5863, 59747, -5863,  2855,
    4027, 28498,  7241,  7996,  3748,  3814, -5863, -5863,  3757,  1096,
   93342,  3868,  3869,  3891, -5863,   237, -5863,  4025,  1861,  3895,
     302, -5863,   333, -5863,  2910, -5863, 93342, -5863, 93342, 93342,
   93342, 93342,   335, -5863, -5863,   333,  2910,   333,  1043, -5863,
    3825,   302,  2910,  3670,  3900,   375, -5863,   386, -5863,  3765,
    1043, -5863,  3783,  2251, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863,  2259, -5863, 93342, -5863,  3877,  3879,  3881,  3892,  3893,
    3558,  3559,  3597, 93342,  3564,  3558,   351,  3566,  3567, -5863,
    3564,  3564,  3558,  3079,  3079,  3558,  3559, 67383,  4018, 63820,
   -5863, -5863,  3658,  3587,  3933,   961, -5863,  1083,   110,  3840,
   -5863, -5863, -5863, -5863,  2756,   252, 61783, -5863,120744, -5863,
   68401,  3620, -5863, -5863, -5863,  3806,  3584, 67383,  1043,   228,
   -5863, 71964, 93342,120744, 71964,  3816, 71964, 71964,120744, 93342,
   93342,  2267, -5863,  2005, -5863,  2030, 35323,   542, -5863, 18286,
    2276, 35323,  3598,  3609, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863,  3610,  3942, -5863,  2278,  2283, 18379,  2536,120744,  1606,
    3614, -5863,  3611,   251,  3811,  3594,  6507,  3650,  2292,  3616,
     286, -5863,  6507,   370,  3612,  7779,  3777,  3617,  2322,  3619,
    3624, -5863,  6732,  6867,  3625, 18471,  3618,  3626,  3628,  3630,
   41120, 41120, 29521,  1017, -5863, 41120,  3633,  3850,  2327, 14658,
    3636,  3637, 18693, 34269, 35323, 34269, 34269, 19070,  3629,  3638,
   -5863,  4040, -5863,  2334, 63820,  3846, 19117,  2344, -5863, 35323,
   63820,  7405, 35323, -5863, 35323,  3645, -5863, -5863,  4848,  4848,
    4848,  3561, -5863, -5863,  3674, -5863, 41120, 41120, -5863,  3291,
   29521, -5863, -5863,  4004, -5863, -5863,   622, -5863, -5863, -5863,
   -5863, -5863,  3483, -5863, -5863, -5863,  3896,  2536,  3372, 55137,
    8956, 35323,   297, 35323,  3358, 35323,  3735,  4848,  4848,  4848,
     469,   469,   321,   321,   321,  2194,   465, -5863, -5863, -5863,
    3649,  3652,  3555,  3656, 35323, -5863,  3696, 50408, -5863,  2400,
    2414, 93342,  3488,  5848,  6318, -5863, -5863, -5863,  3417,  1067,
    3417, -5863,  1461, -5863, -5863, -5863, -5863, -5863, -5863, 93342,
   20763, -5863, -5863,  3926,  3659,  2346, -5863, -5863,  2756, -5863,
   -5863,  2472,  2472,  3661, -5863,  3681, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863,  3662, -5863, -5863, -5863,  3684,  3692, 45258,
    4023,  3695, 43713, 90288,  3713,  2245, -5863, 90288, 90797, 90288,
   90288, -5863,  3698, -5863, -5863,  2010, 35323,  4015, -5863, -5863,
   -5863, 35323, -5863, -5863,  1142,  3714,   121,   863,  2571,  2571,
    2125,  1279, -5863, -5863,  3732, -5863, 35323,  2763, -5863,  2824,
   -5863, -5863, -5863, -5863,  3079, -5863,  3944, -5863, -5863, -5863,
   44228,  3718,  3729,  1939, 48348,  3914, -5863, 93342, 44228, -5863,
   93342,   314, -5863,  3700, -5863, -5863, -5863, -5863, -5863, -5863,
  117774,  2145, -5863,122229, -5863,122229, -5863,  2145,  4168, -5863,
  117774,  2055, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, 68401, 68401,  3923, 93342,  3937,
    3936, 35323,  1575, -5863,  4092,  1043, -5863, -5863,  3805, -5863,
   20763, -5863, -5863, -5863, -5863, -5863, 68401, 93342, -5863, 71455,
   -5863, -5863,120744, -5863, -5863, 93342, 93342, -5863, -5863, -5863,
  120744, -5863, -5863, -5863, 93342,   978,  3810,  3812, 93342, -5863,
    1462,  3430,  9379, 93342, 93342, 93342,  4044, -5863, -5863, -5863,
   -5863,  3964, -5863,  4102, -5863,117774, -5863,  2910,  1469,  3817,
    3184, 35323,  3971, -5863,   249, 93342,  3734,  3736,  4109,  1672,
    4063,  3737, -5863,  3853, -5863,  3878,   904, -5863, -5863,  3882,
   -5863, -5863, -5863, -5863,  4121,  1043,  4122,  1043, 93342, 93342,
   93342, 93342,  3887, -5863, -5863, -5863, -5863,  3890,  4034, -5863,
   63820, 63820, 63820,  2350, -5863, -5863,  1576, -5863, -5863, -5863,
   -5863, -5863, -5863,  4080, -5863,  2352, -5863,  1527, 91306, -5863,
   -5863, -5863, -5863, -5863,  4128, 68401, 93342,  9753, 93342, 93342,
   93342,  3981,  1998,  1721,120744, -5863,119259, -5863, -5863,  2367,
   -5863,  3766, 93342,  3844, 68401,  3820, -5863, -5863, -5863,  4134,
    2251,  3906, 79599,  3808,  3808,  2080, -5863, -5863, -5863, -5863,
   -5863,  4045,  3966, -5863,  1257,  3969, 68401,  3830, -5863, -5863,
   -5863, -5863,  4141,  3859, -5863, -5863,  3861,  1097,  3184,  2979,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,  3884,
   -5863, -5863, -5863, -5863, -5863, -5863,  1916,  1916, -5863, -5863,
   -5863,  1916,  1724,   305,  1188,  3184, -5863,  1063,  1492,  3863,
   -5863,  3864, -5863, -5863, -5863,  4049,  4050,  4052,  3872,  3873,
    3918,  3875,  3880,  3932, -5863,  3883,  3934,  3886,  3935,  3888,
    4197,  1043,120744,  4039,  1576,  3924,  4175,  1043, -5863, -5863,
    3889, -5863,  3901, -5863,  2368,  4287,  4291, -5863, 93342, -5863,
     438,  1220,  3184, -5863,  3902, -5863, 68401, 93342, -5863, -5863,
   -5863, 35323,  3804,  3818,  3821, 20763, 20763, 35323, -5863, -5863,
   20763,  3807, -5863, -5863, -5863, -5863,120744, -5863, 93342,  4119,
   -5863, -5863,  1184, 93342, 93342, -5863, -5863, -5863, 93342, -5863,
   -5863, -5863,  4131, -5863,   586,   586, -5863, -5863,  4169,  8309,
    3822,   199, -5863, 63820, 51969,  3222,   938,  1740, -5863, 71455,
   93342, 71455, -5863,  1062,  4051, 93342, 93342, 93342,  3831,  3834,
   -5863, -5863, -5863, -5863, 68401,   932, 68401,  2756, -5863, -5863,
    3911, -5863, 93342,  2251,  4366,  4202,  3490, -5863,  4327,  3354,
     412,  1875,   327,  2947,  4263,  2553, 35323,   441, -5863, -5863,
    2010, 93342,  3554, -5863, -5863, -5863, -5863,  1576, -5863,  3843,
    3842, -5863, 93342,  4211, 93342, 93342, 93342, 93342,  3620,  3852,
   93342,  3854,120744, 93342,  2542,  3180,  4349,  4233,  2383,  3572,
    3947,  4234, 83671,  3871,  2373, -5863, -5863,  1096, -5863,  2380,
     197, -5863,  1576, 71455,118269,  4225, -5863,  1004,  7996, -5863,
   -5863,  1004,   947, 93342, -5863, -5863, -5863, -5863,  4095,  2348,
   -5863,  4209, -5863, -5863,  2383, -5863,120744,  3865, -5863,  2384,
   -5863, -5863, -5863,   375,  3928,  1043,  3931,  1043, -5863, -5863,
   -5863, -5863, 93342, -5863, 93342, 66874, -5863, -5863, 93342, -5863,
    4247, -5863, -5863,  4016,  4019,  4020,  4021,  4024, 93342,  3558,
   -5863,  3897, 93342, 93342, 68401,  1921, -5863, -5863, 68401,   292,
   -5863,   876, -5863, 83671,  4007, -5863, -5863, -5863, -5863,  4252,
    4257, -5863,  3898, -5863, -5863, -5863, -5863,  1033, -5863, 78581,
     376, -5863, 68401,  4190,  4191,  4192,  4193,   351,  4194,  4196,
    4198,  4200,  4201, -5863, -5863, -5863,  3894, 19147, 35323, -5863,
    4274,120744, -5863,  9205, -5863, -5863, -5863, 35323, -5863, -5863,
    4199, -5863, -5863,  3963,  3972,  3899,  3614,  3777, -5863,  4123,
    4130, 35323,  3777,  4377,   408, 35323, 35323, 35323, -5863, -5863,
    4135,  4137, 35323,  2536,  2536, 35323, -5863,  3904, 35323, -5863,
   -5863, -5863, -5863,  2413, 35323, -5863, 35323, -5863, -5863, 26437,
    4435,  4435,  3913,120744, 41120, 41120, 41120, 41120,  1700,  3042,
   41120, 41120, 41120, 41120, 41120, 41120, 41120, 41120, 41120, 41120,
     560, -5863,  4132, 35323, 35323, 34796, -5863, -5863,120744,  3919,
    3629,  3921,  3925, 35323, -5863, -5863, -5863,  2390, 42683,  3927,
   63820, -5863, 35323, 17823,  2397,  3970, 19455,  2010,  9572,  1576,
   35323,  1239,  1369, 35323,  2401, 35323, -5863, -5863, -5863, -5863,
    4281, -5863, -5863, -5863, -5863, -5863, -5863,  4170,  2536, -5863,
   -5863, 35323,  3930,  3461, 41120, 41120,  3957, -5863,  4178, 35323,
   29521, -5863,  3689, -5863, 26970,  3929, 35323,117265, -5863, -5863,
    1177,  1177,  1177,  1177, -5863, 93342, 93342, 93342,  4015,  3939,
    4015,   230, -5863, -5863,  2383, -5863,  3938, -5863, -5863, -5863,
   -5863, -5863, 35323, 90288, 90797, 90288, 90288,  3941, 43198, 27486,
    2245,  3943, 93342, -5863, -5863,  3946, 44228,  4232,  4145, -5863,
   44228,  4145,  1971,  4145,  4239,  4032, 50923, -5863, -5863,  3955,
   -5863, -5863,  4154, -5863,  2060, 20763,  4413,  4300, -5863,  3958,
   -5863,  3714,  1584, -5863, -5863, -5863,  1326, -5863,  4033, -5863,
   -5863, -5863,  3713, 36904,  4106, -5863, -5863, -5863,  4014,  2405,
   -5863, -5863,  4403,  4106, -5863,  2215, -5863,  2417, 49893,  3718,
   35323,  2010,  2419,  2081, -5863, -5863,117774, -5863,  4037,  2910,
    2910,  1563,  3558,  4326,  1563,  9624, -5863,  1742, 93342, -5863,
   93342, -5863, -5863, -5863,  4460,  4028,  4029,  4256, -5863,  2745,
   -5863, -5863, 68401, 93342, -5863, -5863, -5863,   444,  1415,  3184,
   -5863,  4057, -5863, -5863,  4292, 93342, -5863,  4446,  4072, 93342,
   10166,  4353,  4041, -5863, -5863, 45773, 93342, 93342, 93342, -5863,
   93342, 93342,  1742, 91815, -5863,  4425,  1742,  4093,  4333,  1969,
    3180,   395,  4464, -5863,  1419, -5863, -5863,  4059, -5863, 93342,
   -5863, 93342, -5863, -5863, -5863, -5863, -5863, -5863, -5863,  4124,
   -5863, -5863, -5863, -5863, 64329, -5863, -5863, 93342, -5863, 63820,
   51969, 63820, -5863, -5863, -5863, 93342, -5863,  1751,   502,  1436,
    3184, -5863,  4070, -5863,  4360,  4074,  4075,  4136,   247,   288,
    4079,  4082,  4138,  3995,  3996,  3997, -5863, 63820, 52497,  4166,
   93342,  2910,  4000,  4046, 93342,  3808, 92324, -5863,  4001, -5863,
   -5863,  3808,   383,  1576, -5863, -5863,  1576,  2910,  1576, 93342,
   93342, 93342, 93342,   378, -5863, -5863, -5863,  4477,  4101, 93342,
   93342, 93342, 93342, -5863,  4061, -5863, -5863, -5863, 93342, 93342,
    4369,   260,  2357, 68401, 93342, 93342, 68401, 93342, 93342, 93342,
   93342, 93342, 93342, 93342,  4235, -5863,  4468,  4391,  2448,  4436,
    4096, 93342, -5863, 93342,  1576, -5863,  3430, 93342, 93342, 93342,
   93342, -5863, -5863, -5863, -5863, -5863,  3689, -5863,  4030,  4328,
    1184, -5863,  4330,  4336,  4338,  1184, -5863, -5863,  1740, -5863,
     943, 93342, -5863,  2561, 93342, -5863, -5863, -5863,  3958,   540,
     550, -5863, -5863, -5863, -5863, -5863, -5863,  4035, 93342, 93342,
   41120, -5863,   497,  2147,  1536, -5863,  4323, 93342,  3294, -5863,
   -5863, -5863,   267, 93342, -5863, -5863, -5863, -5863,  4036, -5863,
    1251,  3852, -5863,  4357, 75527,  2910, 68401, 68401,  2910, -5863,
  120744,  4038,  3554, -5863,   265,  4120, -5863, 68401,   412,116247,
    3349,  4076,  4265, 10290, 44228, 44743,  1916, -5863,  4043,  4042,
   -5863, -5863, 93342,  4051, 66874,  2425,  2979,  4536,  1305,  2222,
   -5863, 77054,  4246,  3852,  4357, -5863,  3180,  4276,  4271, -5863,
    2383, 93342,  3620,  3554,  1576, 93342,  4041, 51969, -5863,  4579,
    2362, -5863,117774, 35323, 35323, -5863,  4048, -5863,  4053,  7996,
   -5863,  4133,  4054,  4547, 35323, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863,  4146,  4060, 93342, 93342,  1096, 93342, -5863,
    4062,  3895, -5863,  3895, -5863, 93342, -5863, 93342, -5863,  1043,
   -5863,  4204,  1043, 93342, 93342, 93342, 93342, 93342, 93342,  3558,
     351,  3567, -5863, -5863,  4412, 67383,  4415, -5863, 63820, -5863,
   -5863, -5863, -5863, -5863,  2426, 93342, -5863, -5863,  1576, -5863,
    4487,  4424,  1043,   200,  1276,  1276,  1276,  1276,  4380,  1276,
    1276,  1276,  1276,  1276, -5863, 35323, 20763, -5863,  4071, -5863,
   20763,  4466,  4367,  4371, -5863, -5863,  4083,  4317,  4320, -5863,
    4084, 35323,  3777, 19680, -5863, -5863,  4324,  4325, -5863,  3777,
    3777, 19680, -5863, 19680,  4089, 10867, 19717, -5863,  2430, 35323,
   -5863,  2473,  2473,  2473,  1091,  4449, -5863,  2885,  2473,  2473,
    2473,   407,   407,   271,   271,   271,  4435,   560, 19793, 20100,
   19813,  4094, -5863, -5863, -5863,  3629, -5863, 37431,   130,  4571,
   42168, -5863, -5863, -5863,  4143,  4150,  4099, -5863, 35323, 37958,
    4097,122724,  4321, -5863,  2139, 35323, 35323,  3353, -5863,  5458,
   35323, -5863, -5863,  3353,   577, 35323,  1922,  1991, 35323, 35323,
    4463, 12659,  4105, -5863,  2436, 35323, 12723,  4313, -5863, 93342,
   93342, 93342, 93342, -5863, -5863, -5863,  4300,  1576,  4300,  4108,
   -5863,  4110, -5863, -5863, -5863, -5863, 64838,  4113,  3846, 90288,
    4117, 93342,  2245, 44228, -5863, -5863,  2090, -5863, 44228,  4417,
   -5863, 44228, 71964, -5863, 93342,  4139, 93342, -5863,  1889, 35323,
    4164, 55137, -5863, -5863, -5863, -5863,  4212, -5863,  4355, 20763,
   32161, -5863,  2383,  1882, 93342,  2010,   886, -5863, 35323,  4142,
   93342, -5863,  4106, 20763, -5863,  4205,  2442, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863,  4218, 77563,  4481, -5863, -5863,  2160,
    4461,   238, -5863,  1043, -5863,120744, 93342, 93342, 93342,  3124,
   -5863, -5863, 93342, 93342, 93342, 93342, -5863, -5863, 68401, 93342,
   -5863, -5863, 93342, 35323,  2443, -5863,  4179,  4593,   209,  2447,
   -5863,  2469,  1742, -5863,  2470, -5863, -5863, 92833, -5863,  4051,
     378,   497,  4479,  4480,  4375, -5863,   351, -5863,  4639,   497,
    4381,   378, -5863, -5863, -5863, -5863,  3219, -5863,120744,  1043,
    1043, -5863, -5863, -5863, -5863, -5863,  4155, -5863,  4621,  4245,
   93342, 93342, 93342, 93342, 93342, 68401, 93342, 93342,  2756,  2756,
  120744,  4147, -5863,  2756,  2756,  4148, -5863, 68401, 93342, 93342,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863,  4236, -5863, 35323,  4612, -5863, -5863, -5863, -5863, -5863,
   35323, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, 68401, 93342,  4240, -5863,  4241, -5863,  1027, -5863, -5863,
   93342, 93342, 93342, 93342,  4532, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863, -5863,  4530, 93342, -5863, -5863,
    1576,  1576,120744,  1043,  1043, -5863, -5863, -5863,  4248, -5863,
   -5863,  4157,  4469,  1184, -5863,  1184,  1184,  1184, -5863,  4160,
   -5863,  1740,  4569, -5863,  1742,   352,  4518, -5863, 35323, -5863,
    1176,  1091, -5863,  4578,  4661, -5863, -5863, -5863, -5863,  3490,
    2251,  3490, -5863, -5863, 71964,  1127, -5863,  4499,   880, 63820,
    4399, 75527,  1063,  2057,  4177,  4314, -5863,  2910,  2910,  4242,
   93342,  4674, -5863, -5863, -5863, -5863, -5863, -5863, 68401,  3820,
   -5863,  4426,  1613,  4543, 93342, 44743, -5863,  3713, -5863, -5863,
   -5863,  1576, -5863, -5863,  4322,  3554, -5863,  1435, 93342,  4418,
   75527,  3620,  2480, -5863, -5863, -5863,  4228,  4663,  3572, -5863,
    1063,  4246, -5863, -5863,  4640,  4286,  4238,  4688, -5863,  4286,
    4553,  4427,  4203, -5863,  3871, -5863, 93342, -5863, 20763, 20763,
    1576,123219,  1004,120744,  4561, -5863, 20763, 93342,   944,  4206,
    4372, -5863,  4527,  1043,  2493, -5863,  1043,  1043, -5863, 93342,
   -5863,  3558,  3558,  3558,  3558,  3558, -5863,  4428, -5863, -5863,
   -5863, -5863,  4519, -5863, -5863, 67383, -5863,  1043, -5863, -5863,
   -5863, -5863, -5863, -5863,  1276, -5863, -5863, -5863, -5863, -5863,
   20763, -5863, 93342, -5863, -5863, -5863, -5863, -5863, -5863,  3385,
    4207, 35323,  1387, -5863, -5863,  4210,  4213,  3777,  3777, -5863,
   -5863, 35323, -5863, 13042, 41120,  4563, -5863, 35323, 35323, 35323,
   -5863,  4215,  2499,  2506, -5863, -5863,   130, -5863,  4571, -5863,
   -5863, -5863, 13563,  4270, 20763,  4334,  4216,  1539,  3353,  3353,
    5458,  3353, 35323, 35323,  3353,  3353, 35323, -5863, -5863, -5863,
   13696, -5863,  4694,  3689, -5863, -5863, -5863, -5863,  4164, -5863,
    4164,  4362, 35323, -5863,  2511,  4717, 40066,  4676, -5863, 93342,
    2518, -5863, 35323,  4226, -5863, -5863, 44228,  2090,  4227,  2523,
   93342,  2527,120744, 38485, 20763, 93342,  3689,  4224, -5863, 93342,
    3078, -5863,  1939, -5863, -5863,  4671, 45773,  4628, 20340, 35323,
   -5863, -5863, -5863, -5863, 67383,  4457, 67383,  1742, -5863, -5863,
   -5863, -5863, -5863, -5863,  4237, -5863, -5863, -5863, -5863,  4319,
   -5863, -5863,    84,  3562,  1742, -5863, 13809,  4565, 45773, 56193,
   93342, -5863, 93342, -5863,  4407,  4565,  4565, -5863, -5863, -5863,
   -5863,  4732,  4618,  4620, -5863, -5863,  4244, -5863, -5863, -5863,
    4468, -5863, -5863, 51969, 68401, 93342, -5863,  4332, -5863, -5863,
   -5863, -5863, -5863, -5863, 47833, 55137, -5863,   247,  4250,  4251,
     288, -5863, -5863, -5863, 93342, 14894,  4254, 15090,  1374,  3562,
   93342, 93342,  4258,  4259,  4261,  1926,  1209,  2038,  3558,  4609,
   93342, -5863, -5863, -5863,  4468, -5863, -5863, 93342, -5863,  1184,
   -5863, -5863, -5863, -5863, 63820, -5863,  3325,  4160,  1576, 71964,
    4743,  4743, 15240,  4489, -5863, -5863,   889,  4329,  4533,  4329,
    4262, 93342,   267,  4266,  2529, -5863, 93342,  4269,  4392,  2227,
    2227, 93342, 93342, 93342,  2535,  2383,  2910,  4046,   412,  4649,
   75527,  4695,  4051,   493, -5863, 93342,  4769, 93342,  3620,  3852,
   93342,  4275, -5863, -5863, 77054,  4500,  3222, 93342,  2542,  4246,
    3572,  1505, 93342, -5863,   388, -5863,  2383, -5863, 93342, 83671,
   45773,  4634, -5863,122229, -5863,  2540, -5863, -5863, -5863,  4365,
   21871,  3417,  4405,  4409,  4282,  2258,  4653, 93342,  1275, -5863,
   -5863, -5863, -5863, -5863, -5863, 93342,   376, -5863, -5863, -5863,
   -5863,  4288, -5863,  4787, 35323,  1082, -5863, -5863, -5863, -5863,
   -5863,  4520, -5863,  4294, -5863, -5863,  2613,  1387, 20384, -5863,
    2320, 41120, 20763, 20763, 20763, 35323, -5863, 35323, -5863, -5863,
   -5863, -5863,  1006, -5863, -5863,  4622,  4296,  3353,  3353,  3353,
   -5863, 35323,   245, -5863, -5863,  2261,  4720, 20415,  3698, 64838,
    4301, -5863, 41120,  2544, -5863,  1978, 93342,  2550, -5863, 20763,
   93342, -5863, -5863, 35323, -5863,  2559, -5863,  4304,  1471,  4305,
   25371,  4303, -5863, -5863, -5863, -5863, -5863, 20763,  4306, -5863,
    4796,  1890, -5863, -5863,  4370, 93342,  2565, -5863,   149,   945,
    1320, -5863,  4808,  4808, 20763,  1921,  1563,   523, -5863, 93342,
    4414, -5863,  4593,  4315,  3490, -5863,  4318, -5863, -5863,  1801,
    3180, 93342,  3490,  3490,  3222,  4660, -5863, -5863, 35323,  4385,
   -5863,  1395,  3562, 93342,120744, -5863,   160,  4691, -5863,120744,
  120744, -5863, -5863, -5863, 35323, -5863,  4422, -5863, -5863, -5863,
   35323, 35323, 74509, -5863, -5863, 93342, 93342, 93342, 93342, 93342,
   -5863,  1043, -5863, -5863,  2567, -5863, 46803, -5863, -5863,  3345,
    1576,  3345,  2104, -5863, -5863,  3345,  3345, -5863,  3417, -5863,
    4743,  1644, -5863, -5863,  4575,  4337, 35323,  4667, -5863,  1403,
    4570, -5863,  4344, -5863, 71964,  4874, -5863, 63820,  3852,  4357,
   93342, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863,  2578,  4051,  4718,  3554,  4238, -5863, 93342,
    4389, -5863, 44228,  4051,  2383,  2222, -5863,  4246,  3852,  4357,
   -5863, -5863,  4351,  4271,  3572,  2542,  4502, -5863,  4503, -5863,
    4818,  4580,  4820,  3620, -5863,  4041,  2589, 93342, -5863, -5863,
    7996,123219,120744, -5863, -5863, -5863,  4358,  4760,  4406,  4411,
   -5863, -5863, -5863,  2258, -5863,   802,  4762,  4420, -5863,  4429,
   93342, -5863, -5863,  4051,  1043, 35323, 63820, 20763, -5863, -5863,
    4755, -5863,   281,   277,  1498,  4600,  4378, 35323,  2320,  2591,
    2595,  4433, -5863, -5863, -5863,  3629, 39012, 39012, 39012,  4379,
    4744,  4750, 93342, -5863, 93342,  4589, -5863, -5863, 93342,  1091,
    4383, 40066, 63820,  2599, -5863,119754, -5863,  2601,  2603, -5863,
   35323,  4390, 35323, -5863, 38485, 93342,  4393,  3472,  2383, -5863,
    3417, 45773, -5863,  4523, -5863,  4664, -5863, -5863, 35323,  4485,
    4490, -5863,  4753, -5863, -5863, 93342, -5863, 93342,  4329, 55137,
    3714,  1801,  2251,  4329,  4329,  4337, 15977, 35323, -5863,  4497,
   -5863, -5863,  2605,  1919,  4581,  4581,  2607,  2617, 16352, 93342,
    2619,  2631, -5863,  2633,  2756,  3559,  2038,  3559, -5863,  3558,
   -5863, -5863, 63820, -5863, -5863, 67892, -5863, -5863, -5863,  1576,
   -5863,  1576,  4643, 57722, 58231,  1576,  1576, -5863, -5863, -5863,
   -5863,  4728, -5863,  2979, -5863, 16505,  4505, -5863, -5863, -5863,
     562, -5863,  4636,  4638, -5863,  4419, -5863,  2635, -5863,  1063,
    4552,  4051, -5863, -5863, 93342,  4914,  4918, -5863,  1661, 93342,
    3713, -5863,  4238,  3620,  3572,  1063,  4246,  3222, 46288,  4286,
    2542,  4271, -5863, -5863,  4646, -5863,  4647, -5863,  4430,  4758,
   -5863,  1765,  1004, -5863, -5863, -5863,  1572,  4782,  4783, -5863,
   -5863, -5863,  3345, -5863,   146,  4431,  4807, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863,  4472,   349,   358, -5863,  4473, -5863,
    4616,  4619,  1387,  2491, -5863, 20763, -5863, -5863, -5863, 40593,
    4587,   968, 18064,  4822, -5863,  4822,  4822, -5863,  4921,  4922,
    1447, -5863,  4892,  2641, 42168, -5863, -5863, -5863, 93342,  4662,
    1481,  4944,  4615,  2643, 38485,  2649, -5863, -5863, -5863, -5863,
   -5863, -5863, -5863, 49893,  4927, 20763,   538,  1476, 67383,  3562,
    2666,  3808,  4452, -5863,  3714,  4533, -5863, -5863, -5863, -5863,
   20763, 93342, 71964,  4935, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863,  3562,  4549, -5863, -5863, 74509, -5863, 93342, -5863, -5863,
    2682, -5863, -5863, -5863, 58740, -5863,  4206, -5863,  4206, -5863,
   -5863, -5863,  2931,  4582, 93342,  1187,  1187,  4876, -5863,  4537,
   -5863,  4467, -5863,  4997,  4607, 93342, -5863, -5863,   247,  2383,
   75527,  4051, -5863, -5863,  2542,  4246,  3572, 35323,  2683, -5863,
    4593,   209, -5863,  4271,  4286, -5863, -5863, 45773,  4482,  3294,
    4870, -5863, -5863, -5863,  2577, 71964, 71964, 93342, -5863, -5863,
   -5863, 35323,   267, -5863,  4522, -5863,  4524, -5863, -5863,  4705,
    4706,  4486,  1387, -5863,  4980, -5863, -5863, -5863, -5863, -5863,
    1111, -5863, -5863, -5863, 93342, 93342, 93342,  4488, -5863,  3846,
   -5863, -5863, 41120, 41120,  4723, -5863, 41120,  1481, -5863, 93342,
   -5863,  4491, -5863, -5863,  2687, -5863,   704,  1967, -5863,  4730,
    4625, -5863, -5863,  4735,   215, -5863,   523, -5863, -5863, -5863,
   -5863, -5863,  4570,  1742,  1742,  3562, -5863, 93342, -5863,  4496,
   -5863, -5863, -5863, 67892, -5863,  4206, -5863, -5863, -5863, -5863,
    5007, -5863,  1002, -5863, -5863, -5863, -5863, 93342,  4051,  4147,
    4238, -5863,  4271,  3572,  2542, 16886, -5863, 46288, 93342, 93342,
    4286, -5863,  2688, 45773,  3554,  4648, -5863,  2341, -5863, -5863,
   -5863, -5863, -5863, -5863, -5863,  1010,  4498,  4501, -5863, -5863,
   16907, 71964, -5863, -5863,  4650,  4652, -5863,  4726, 39539,  4651,
   -5863,  4721, -5863,  1592,  1725,  2013,116756,  4961,  1091,  1091,
   -5863,  1091, -5863, -5863, 35323, -5863, -5863, -5863, -5863, -5863,
   49893, -5863,  4568,  1939,  4509, 93342, -5863, -5863,  1742, -5863,
   -5863, -5863, 35323, -5863, -5863,  2251,  2251,  4051, -5863, -5863,
    4286,  2542,  4271,  4593, -5863, -5863, -5863, -5863,  4758, -5863,
    2695,  4286,  4420,  2624, -5863, -5863,  2637,  2678,  4601,  4873,
   -5863,  4521,  4627,  4629,  4904, -5863, -5863, -5863, 93342, 93342,
   65347, 93342,   381,  2696, -5863,120249, 93342, 17244,  4525, -5863,
    4583, 35323,  2701,  1742,  2702, -5863, -5863, -5863, -5863,  4271,
    4286, 93342,  3294, -5863, 45773,  3417,  4900, -5863,  2341,  4644,
    4645, 63311, -5863, -5863, -5863, -5863, -5863,  5051,   348,  4941,
   -5863, -5863,  1576,  1387,116756,  4747,   185,  2707, -5863,  4586,
    2709,   122, -5863,  4286, -5863, -5863,  3554, -5863, -5863,   267,
   -5863,  4574,  4576, -5863,  2715, -5863, -5863, -5863, -5863, 35323,
   65347,  2446,  4531, -5863, -5863,  4736,  1576,  2613,  4736, -5863,
   -5863, -5863,  1939, -5863, -5863,  4286, 71964,  4890,  4891, -5863,
   63311,  1207,  4599, 93342,  4539, -5863,  1387, -5863,  1498,  2613,
    4597,  3417,  4541, 71964, 71964, -5863,  4542, 93342,  4995,116756,
   -5863,  1387,  1498,  4586, -5863, 63311, -5863, -5863,  1576, -5863,
    4544,  2731, -5863,  1387, -5863,  2733,116756, -5863, -5863, -5863,
    2739, -5863
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
    1725,  1464,   670,  1553,  1552,  1464,     0,   275,     0,  1564,
       0,  1464,   443,  1121,     0,     0,     0,     0,   670,  1464,
       0,  1725,     0,     0,     0,     0,     0,  1738,     0,     0,
       0,     0,     0,     0,  1261,     0,     0,     0,  1464,     0,
       0,  1745,     0,     0,     0,     0,  1738,     0,  1566,     0,
       0,     0,     0,  1745,     0,     0,     0,     0,     0,     2,
       9,    10,    45,    80,    81,    38,    37,    98,    63,    24,
      71,   133,   132,   134,    50,    46,    88,    33,    35,    47,
      51,    73,    75,    40,    53,    64,   110,    72,    31,    70,
      76,    96,    58,    19,    20,    59,    21,    60,    22,    61,
     106,    82,    99,    43,    69,    30,    52,    78,    79,    12,
      54,    86,    18,    65,    66,    68,    91,    92,    93,   116,
      94,   128,    49,   125,   103,   104,   122,   105,   123,    16,
     107,    62,    23,   119,   118,   120,    89,    55,    90,    77,
      97,   117,    34,   121,    25,    26,    28,    29,    27,    67,
      36,    74,    39,    95,   124,   114,   109,   129,   127,    11,
     135,   111,    83,    14,    15,   100,    13,    32,    57,    17,
      42,    41,    56,    48,   131,    44,  1564,   102,   115,   101,
      84,   108,    87,   112,   130,   113,    85,   126,  1689,  1688,
    1749,  1692,  1724,     0,  1704,  1463,  1462,  1477,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   669,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1474,  2453,  2470,  2471,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,  2483,
    2484,  2486,  2485,  2487,  2488,  2860,  2489,  2490,  2491,  2797,
    2798,  2861,  2799,  2800,  2492,  2493,  2494,  2495,  2496,  2497,
    2498,  2499,  2500,  2801,  2802,  2501,  2502,  2503,  2504,  2505,
    2803,  2862,  2506,  2507,  2508,  2509,  2510,  2511,  2863,  2512,
    2513,  2514,  2515,  2516,  2517,  2518,  2519,  2520,  2521,  2864,
    2522,  2523,  2524,  2865,  2525,  2526,  2527,  2528,  2529,  2530,
    2804,  2805,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,
    2549,  2550,  2551,  2552,  2553,  2554,  2555,  2556,  2557,  2558,
    2559,  2560,  2806,  2561,  2562,  2563,  2564,  2807,  2565,  2566,
    2567,  2568,  2808,  2569,  2570,  2571,  2572,  2866,  2867,  2573,
    2574,  2575,  2576,  2577,  2809,  2810,  2578,  2579,  2580,  2581,
    2582,  2583,  2584,  2868,  2585,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,  2595,  2596,  2597,  2869,  2811,  2598,
    2599,  2600,  2601,  2812,  2813,  2814,  2602,  2870,  2871,  2603,
    2872,  2815,  2816,  2817,  2818,  2819,  2820,  2821,  2822,  2823,
    2824,  2825,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2826,  2873,  2612,  2874,  2613,  2614,  2615,  2616,  2617,  2618,
    2619,  2620,  2621,  2622,  2623,  2624,  2625,  2827,  2626,  2627,
    2628,  2629,  2630,  2631,  2632,  2633,  2828,  2875,  2829,  2634,
    2635,  2636,  2637,  2638,  2639,  2640,  2641,  2830,  2831,  2642,
    2643,  2644,  2876,  2645,  2832,  2646,  2833,  2647,  2648,  2649,
    2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,  2834,  2877,
    2658,  2878,  2835,  2659,  2660,  2661,  2662,  2663,  2664,  2665,
    2666,  2667,  2668,  2669,  2670,  2671,  2672,  2836,  2673,  2837,
    2676,  2674,  2675,  2677,  2678,  2679,  2680,  2681,  2682,  2683,
    2684,  2685,  2686,  2687,  2838,  2688,  2689,  2690,  2691,  2692,
    2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,
    2703,  2704,  2705,  2706,  2879,  2707,  2708,  2709,  2710,  2711,
    2839,  2712,  2713,  2714,  2715,  2716,  2717,  2718,  2719,  2720,
    2721,  2722,  2723,  2724,  2725,  2726,  2727,  2728,  2840,  2729,
    2730,  2880,  2731,  2732,  2841,  2733,  2734,  2735,  2736,  2737,
    2738,  2739,  2740,  2741,  2742,  2743,  2744,  2745,  2746,  2747,
    2748,  2842,  2749,  2750,  2751,  2752,  2881,  2753,  2754,  2755,
    2756,  2757,  2758,  2759,  2843,  2844,  2760,  2761,  2845,  2762,
    2846,  2763,  2764,  2765,  2766,  2767,  2768,  2770,  2769,  2771,
    2772,  2773,  2774,  2775,  2776,  2777,  2778,  2779,  2780,  2781,
    2847,  2848,  2782,  2882,  2783,  2784,  2785,  2786,  2787,  2788,
    2789,  2790,  2791,  2792,  2793,  2849,  2850,  2851,  2852,  2853,
    2854,  2855,  2856,  2857,  2858,  2859,  2794,  2795,  2796,   146,
       0,     0,  2420,  2454,  2455,  2458,  2453,   413,   412,  1678,
    2417,  2454,  1563,     0,  1542,   670,     0,  1477,   442,  1725,
       0,     0,     0,     0,     0,     0,   887,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   138,
       0,   140,     0,     0,   467,   466,     0,     0,  1093,   472,
       0,     0,     0,     0,     0,   660,  1605,  2674,  1603,  1679,
     276,   279,   280,   277,   278,  2436,     0,  1233,  1234,  1236,
       0,     0,  1246,   927,   928,     0,     0,     0,   941,     0,
       0,     0,   925,     0,     0,     0,   947,     0,   944,     0,
       0,   948,   945,   922,   946,   929,     0,   921,     0,     0,
    1246,   949,     0,     0,   923,     0,     0,     0,     0,  1477,
    1602,   473,  1725,     0,  1586,  1587,  1588,  1564,  1576,  1589,
    1581,  1583,  1582,  1584,  1585,  1580,  2435,  2472,  1017,  1017,
    1017,  1017,  1014,  1015,  1017,  1017,  1017,  2695,     0,     0,
     996,     0,   998,  2437,  1017,  1022,  2480,   552,   552,   552,
       0,  1021,  1026,   552,     0,  1445,  1486,  2419,  1737,     0,
     997,  1444,  2499,   248,  2701,  2707,  2716,  2726,  2727,  2730,
    2843,  2760,  2793,   213,   202,     0,   225,  2760,  1592,     0,
       0,     0,     0,  2714,  1454,   258,  2726,  2843,  2760,   257,
     251,   253,     0,     0,  1021,   552,     0,  1477,  1452,   993,
    1744,  1742,     0,  2404,  2516,  2615,  2726,  2727,  2760,   203,
     208,   269,  2726,  2843,  2760,   265,  1474,     0,  1705,  1855,
    1854,  2413,     0,  1447,  1446,  1565,     0,  1568,     0,  2690,
    1709,  1712,  1570,  1710,  2456,  1948,  1977,  1955,  1977,  1977,
    1944,  1944,  2546,  1957,  1945,  1946,  1982,  2002,     0,  1977,
    1944,  1949,     0,  1947,  1985,  1985,  1972,     3,  1927,  1928,
    1929,  1930,  1958,  1959,  1931,  1964,  1965,  1969,  1932,  1999,
    1935,  1944,  2457,  1746,  1747,  2404,     4,  2450,     5,  2331,
    2449,     6,     7,  1701,     0,     0,     1,  1725,     0,  1575,
    1741,  1741,     0,  1741,     0,  1693,  1701,  1696,  1700,     0,
       0,     0,     0,     0,     0,  1448,     0,     0,     0,   952,
       0,  1489,  1078,     0,     0,     0,     0,     0,  1330,     0,
    1130,  1129,  2459,  2442,  2443,  2444,     0,  2440,  2441,  2460,
    2461,  2462,     0,  2584,  1330,     0,     0,  2247,  2258,  2259,
    2260,  2503,  2565,  2255,  2256,  2257,  2249,  2250,  2251,  2252,
    2253,  2254,     0,     0,  1228,  2248,     0,  2584,     0,  1330,
       0,   173,     0,   150,  1330,     0,     0,  2584,     0,     0,
    2584,     0,     0,     0,     0,     0,  2584,     0,     0,     0,
       0,     0,   173,  2620,     0,   150,  2584,     0,     0,  1468,
       0,     0,     0,  1470,  1473,  1460,     0,  2328,     0,  2329,
    2421,  1557,     0,  1556,  1550,  1560,  1555,  1545,     0,  2413,
       0,     0,     0,     0,   935,     0,     0,   925,     0,     0,
       0,   936,     0,   937,   938,     0,     0,     0,     0,   934,
       0,  1458,  1450,     0,  1594,  1596,  1595,  1597,  1593,   552,
       0,     0,     0,  2584,     0,   150,  1528,     0,  2584,   150,
       0,     0,   471,   470,   150,  2440,   469,   468,  2503,  2565,
       0,  1120,     0,  1203,   150,  2584,     0,   194,  2584,   729,
    2584,  1570,   139,     0,   673,     0,   841,  2620,   150,     0,
       0,     0,     0,     0,     0,   142,     0,     0,     0,     0,
       0,     0,     0,   659,   670,  1606,  1604,     0,  1237,   250,
     249,  1235,   939,  2584,  1162,   145,     0,     0,  2584,  1509,
    2584,   145,   956,   940,     0,   926,  2584,   145,  1126,  2584,
    2445,   183,     0,   924,  2503,  2565,  2584,   145,  1230,     0,
    2584,   145,  2584,   179,  2584,   145,  2584,   145,  2584,   674,
       0,     0,  2584,   145,  2584,  2620,   181,   943,  2584,   145,
     950,  2584,   145,  2415,  2584,     0,  1461,     0,  1598,     0,
    1578,  2847,     0,  1725,  1017,  1016,     0,  1017,     0,  1017,
       0,  1017,     0,  1017,     0,     0,     0,  1017,  2438,  2439,
     999,     0,  1023,     0,  1031,     0,  1030,  1029,  1028,     0,
       0,     0,  1032,     0,  1859,  1633,     0,  1442,   216,   247,
     218,   246,   252,   219,   217,     0,  2494,   201,     0,   264,
     263,     0,     0,     0,     0,     0,     0,     0,  1457,     0,
       0,     0,   142,     0,  1259,  1256,   142,  1258,  1257,   142,
     142,  1453,   256,   254,     0,     0,     0,     0,     0,  1459,
       0,  1451,     0,     0,     0,  2423,  2425,  2426,  2261,  2331,
       0,  2798,  2799,  2800,  2320,     0,  2801,  2802,  2803,  2862,
    2135,  2121,  2130,  2136,  2122,  2124,  2131,  2804,  2805,  2070,
    2806,  2807,  2433,  2808,  2809,  2810,  2812,  2813,  2814,  2815,
    2816,  2817,  2818,  2819,  2820,  2821,  2822,  2823,  2825,  2826,
    2126,  2128,  2827,  2828,  2829,  2831,     0,  2434,  2832,  2833,
    2653,  2835,  2836,  2838,  2839,  2132,  2841,  2842,  2133,  2843,
    2844,  2845,  2846,  2432,   515,  2134,  2848,  2850,  2851,  2852,
    2853,  2855,  2856,  2857,  2858,     0,     0,     0,  2410,     0,
    2099,     0,  1936,  1937,  1960,  1961,  1938,  1966,  1967,  1939,
       0,  1940,  2409,  2003,  2206,  2098,  2116,     0,  2104,  2105,
       0,  2097,  2093,  2208,  1727,  2405,     0,  2094,  2422,  2424,
    2321,  1727,  2403,   271,     0,   272,  2411,  2726,   204,  2501,
     205,     0,   206,   268,   266,     0,  1449,     0,  1857,  1856,
    2414,   961,     0,  1567,  1564,  2271,     0,  1711,     0,     0,
       0,  1976,  1963,  1971,  1970,     0,  1953,  1952,  1951,     0,
    1950,  1977,  1977,  1975,  1954,  1927,     0,     0,     0,  1981,
       0,  1979,  1923,  1919,     0,  1988,  1989,  1990,  1987,  2000,
    1986,     0,  1933,  1991,     0,  1944,  1941,  1812,     0,  1691,
    1690,     8,     0,  1572,  1574,  1548,  1570,  1739,  1740,     0,
       0,     0,     0,     0,     0,     0,     0,  1799,  1757,  1758,
    1760,  1796,  1800,  1808,     0,  1697,     0,     0,     0,  1861,
       0,     0,  1475,     0,     0,     0,     0,     0,  1161,     0,
       0,     0,     0,   953,     0,     0,     0,  1495,     0,  1497,
    1498,  1499,     0,     0,     0,     0,  1500,  1501,  1489,   260,
    1508,  1505,  1488,  1490,  1503,     0,     0,     0,     0,     0,
       0,     0,  1520,     0,   187,   188,     0,   686,   670,     0,
    2584,     0,     0,     0,     0,  1171,  1178,  1329,     0,     0,
       0,     0,     0,     0,     0,     0,  1172,  1170,     0,  1173,
     262,  1183,  1210,  1213,     0,     0,  1128,  1131,     0,     0,
       0,     0,     0,  1320,     0,     0,     0,  1320,     0,     0,
       0,  1329,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   287,   289,   302,   368,     0,   651,     0,     0,     0,
     654,     0,  2584,  1330,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,     0,     0,     0,  1213,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   148,   149,   154,     0,
       0,     0,     0,  1213,     0,     0,     0,     0,     0,     0,
       0,   637,   650,     0,     0,     0,     0,     0,   647,     0,
       0,   150,   292,   627,   633,     0,     0,     0,   736,   735,
       0,     0,     0,     0,     0,     0,  1418,     0,  1417,     0,
       0,     0,     0,     0,  1518,  1517,     0,     0,     0,     0,
       0,  1320,     0,   281,   283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     405,   406,     0,     0,     0,   154,     0,     0,  1320,     0,
     294,     0,     0,  1469,  1466,  1467,     0,  1472,     0,     0,
       0,     0,  2107,     0,  2275,  1749,  2273,  1146,  2327,     0,
    2463,  2883,  2884,  2885,  2886,  2887,  2888,  2889,  2890,  2891,
    2892,  2893,  2894,  2895,  2896,  2897,  2898,  2899,  2900,  2901,
    2902,  2903,  2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,
    2912,  2913,  2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,
    2922,  2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,
    2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,  2941,
    2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,  2951,
    2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,  2324,
    2323,  2418,  2464,  2465,  2466,  2467,  2330,  1540,     0,   236,
     237,   235,  1558,   238,  1559,  1554,     0,  1541,     0,     0,
       0,     0,     0,     0,     0,     0,  2503,  2565,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   849,  1489,  1527,     0,     0,     0,
     679,     0,  2584,     0,   152,   888,     0,   839,   472,     0,
       0,     0,     0,  1394,   152,     0,     0,   190,     0,     0,
     733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   840,     0,     0,   152,     0,  2584,   630,  2584,     0,
     552,   552,     0,     0,   141,   138,     0,     0,     0,     0,
       0,     0,     0,     0,  1683,  1682,  1685,  1684,     0,  1681,
       0,   143,   144,     0,  1220,  1245,     0,     0,     0,     0,
       0,   917,   942,     0,     0,  1214,     0,     0,  2584,   145,
    2584,     0,  2584,     0,     0,     0,  1222,   145,     0,  1216,
       0,     0,  1218,     0,  1420,     0,   933,   931,   930,   932,
       0,     0,   915,     0,     0,     0,     0,     0,   910,     0,
       0,   912,     0,     0,     0,     0,  1725,  1577,     0,  1007,
       0,  1011,     0,  1002,     0,  1008,     0,  1003,  1000,  1001,
       0,  1006,     0,     0,   553,   555,     0,     0,  2528,  2545,
       0,  2573,  2608,  2609,  2663,  2680,  2710,  2716,  2722,     0,
    2753,  2765,     0,  1037,  1075,  1027,   745,     0,     0,  1643,
    1443,   221,   220,     0,   240,   244,   245,   215,   243,     0,
     239,   223,  2192,  2191,   222,   214,   211,   209,   227,   229,
     230,   212,   210,   226,  2280,     0,  1725,     0,     0,  1260,
       0,     0,   138,   255,     0,     0,  1075,     0,  2714,  1456,
     992,   670,     0,  2095,     0,  2102,  2103,  2319,     0,     0,
       0,     0,     0,     0,  2101,     0,     0,     0,     0,  2376,
       0,     0,  2376,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2026,     0,     0,  2279,     0,     0,  2279,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2027,  2008,  2009,  2099,  2271,     0,  2100,  2429,
       0,  1999,  2468,  2261,     0,  2258,  2259,  2260,  2961,  2962,
    2963,  2964,  2965,  2966,  2967,  2968,  2969,  2970,  2971,  2972,
    2973,  2974,  2975,  2976,  2977,     0,  2978,  2979,  2980,  2981,
    2982,  2984,  2983,  2985,  2986,  2987,  2988,  2989,  2990,  2334,
    2992,  2993,  2994,  2995,  2996,  2997,  2998,  2999,  3000,  3001,
    3002,  3003,  3004,  3005,  3006,  3007,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  3018,  3019,  3020,  3021,
    3022,  3023,  3024,  3025,  3026,  3027,  3028,  3029,  3030,  3031,
    3032,  3033,  3034,  3035,  3036,  3037,  3038,  3039,  3040,  3041,
    3042,  3043,  3044,  3045,  3046,  3047,  3048,  3049,  3050,  3051,
    3052,  3053,  3054,  3055,  3056,  3057,  3058,  3059,  3060,  3061,
    3062,  3063,  3064,  3065,  3066,  3067,  3068,  3069,  3070,  3071,
    3072,  3073,  3074,  3075,  3076,  3077,  3078,  3079,  3080,  3081,
    3082,  3083,  3084,  3085,  3086,  3087,  3088,  3089,  3090,  3091,
    3092,  3093,  3094,  3095,  3096,  3097,  3098,  3099,  3100,  3101,
    3102,  3103,  3104,  3105,  3106,  3107,  3108,  3109,  3110,  3111,
    3112,  3113,  3114,  3115,  3116,  3117,  3118,  3119,  3120,  3121,
    3122,  3123,  3124,  3125,  3126,  3127,  3128,  3129,  3130,  3131,
    3132,  3133,  3134,  3135,  3136,  3137,  3138,  3139,  3140,  3141,
    3142,  3143,  3144,  3145,  3146,  3147,  3148,  2041,  3149,  3150,
    3151,  3152,  3153,  3154,  3155,  3156,  3157,  3158,  3159,  3160,
    3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,  3169,  3170,
    3171,  3172,  3173,  3174,  3175,  3176,  3177,  3178,  3179,  3180,
    3181,  3182,  3183,  3184,  3185,  3186,  3187,  3188,  3189,  3190,
    3191,  3192,  3193,  3194,  3195,  3196,  3197,  3198,  3199,  3200,
    3201,  3202,  3203,  3204,  3205,  3206,  3207,  3208,  3209,  3210,
    3211,  3212,  3213,  3214,  2043,  3215,  3216,  3217,  3218,  3219,
    3220,  3221,  3222,  3223,  3224,  3225,  3226,  3227,  3228,  3229,
    3230,  3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,
    3240,  3241,  3242,  3243,  3244,  3245,  3246,  3247,  3248,  3249,
    3250,  3251,  3252,  3255,  3253,  3254,  3256,  3257,  3258,  3259,
    3260,  3261,  3262,  3263,  3264,  3265,  3266,  3267,  3268,  3269,
    3270,  3271,  3272,  3273,  3274,  3275,  3276,  3277,  3278,  3279,
    3280,  3281,  3282,  3283,  3284,  3285,  3286,  3287,  3288,  3289,
    3290,  3291,  3292,  3293,  3294,  3295,  3296,  3297,  3298,  3299,
    3300,  3301,  3302,  3303,  3304,  3305,  3306,  3307,  3308,  3309,
    3310,  3311,  3312,  3314,  3313,  3315,  3316,  3317,  3318,  3319,
    3320,  3321,  3322,  3323,  3324,  3325,  3326,  3327,  3328,  3329,
    3330,  3331,  3332,  3333,  3334,  3335,  3336,  3337,  3338,  3339,
    3340,  3341,  3342,  3343,  3344,  3345,  3346,  3347,  3348,  3349,
    3350,  3351,  3352,  3353,  3354,  3355,  3356,  3357,  3358,  3359,
    3360,  3361,  3362,  3363,  3364,  3365,  3366,  3367,  3368,  3369,
    3371,  3370,  3372,  3373,  3374,  3375,  3376,  3377,  3378,  3379,
    3380,  3381,  3382,  3383,  3384,  3385,  3386,  3387,  3388,  3389,
    3390,  3391,  3392,  3393,  3394,  3395,  3396,  3397,  3398,  3399,
    3400,  3401,  3402,  3403,  3404,  3405,  3406,  3407,  3408,  3409,
    3410,  3411,  3412,     0,  2255,  2256,  2257,  2249,  2250,  2251,
    2252,  2253,  2254,  2265,     0,     0,  2408,  2469,     0,  2208,
       0,  2023,     0,  2216,     0,     0,  1812,     0,  2427,  2322,
    1812,   273,   274,   270,     0,     0,     0,   267,     0,     0,
       0,   145,  1575,  1562,     0,     0,  2334,     0,  2269,     0,
       0,  2267,     0,     0,     0,  1809,     0,  1713,     0,  1717,
       0,     0,     0,  1974,  1973,  1924,  1920,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     954,     0,  1942,     0,  1877,  2451,  2452,  2332,  1745,  1575,
       0,  1571,  1708,  1707,  1750,  1751,  1112,  1706,  1779,  1780,
       0,     0,     0,     0,  1805,  1803,  1770,  1761,  1769,     0,
       0,  1767,     0,  1771,  2003,  1798,  1695,  1755,  1756,  1759,
    1694,     0,  1801,     0,  1646,  1799,  1760,  1630,     0,  1608,
       0,     0,  1862,     0,     0,  1476,     0,     0,     0,  1141,
    1143,     0,  1142,     0,  1145,     0,  1154,     0,     0,  1140,
    1159,     0,  1148,  1146,     0,  1516,     0,     0,     0,     0,
       0,  1496,     0,     0,     0,     0,  2753,   259,  1499,  1504,
    1491,  1502,     0,     0,     0,     0,     0,  1077,  1076,     0,
       0,     0,  1523,   546,     0,   370,     0,     0,     0,     0,
       0,     0,     0,     0,   835,   832,     0,     0,   831,     0,
     684,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   709,     0,  1320,     0,   300,     0,  1180,     0,
    1179,     0,  1184,     0,     0,  1181,  1176,  1177,  2716,   261,
    1182,  1212,     0,  1211,  1207,     0,  1123,     0,  1124,     0,
       0,     0,     0,     0,     0,     0,  2557,     0,  2584,     0,
     515,   308,   332,   537,     0,  1319,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   354,     0,     0,   357,   356,     0,     0,     0,     0,
       0,   362,     0,   340,     0,   341,     0,   361,     0,     0,
       0,   652,   653,     0,     0,     0,  1320,     0,   296,     0,
       0,     0,     0,     0,     0,     0,     0,  1229,     0,   762,
       0,     0,  2716,  1208,     0,  1403,     0,  2752,  1404,  1407,
     552,     0,   552,  1409,     0,     0,  1406,  1408,     0,     0,
     176,     0,   171,   175,     0,     0,  2716,  1209,     0,     0,
       0,     0,     0,   635,   636,   649,     0,   640,   641,   638,
     642,   643,     0,     0,     0,     0,     0,     0,     0,   634,
       0,     0,   731,   730,   734,     0,     0,     0,     0,     0,
       0,  1412,     0,     0,  1203,     0,     0,  1411,  1419,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1263,
    1262,     0,     0,     0,     0,  1330,     0,   878,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   178,   749,
       0,   748,     0,   172,   177,     0,     0,     0,     0,     0,
       0,     0,     0,   234,  1465,  1471,  1749,  1749,  1749,  2113,
       0,     0,     0,     0,  1748,  2325,  2328,  1545,  1551,  1544,
    1543,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   419,   416,
     417,   419,     0,     0,     0,     0,   851,     0,   854,   857,
    1487,   499,     0,     0,   676,   709,     0,     0,   475,   185,
       0,     0,     0,     0,   764,     0,  1203,  1202,   147,   138,
     194,   473,     0,   193,   195,   197,   198,   199,   196,   200,
       0,   728,   732,     0,     0,     0,     0,   672,     0,     0,
       0,     0,     0,     0,     0,  1882,     0,     0,   170,     0,
       0,   625,   629,     0,     0,     0,     0,   475,   591,   381,
    2584,     0,   552,     0,  2584,     0,   137,     0,   838,     0,
       0,     0,  1165,  1165,     0,     0,   778,   777,     0,     0,
       0,     0,     0,     0,  1680,   145,  1163,     0,  1510,     0,
     145,   957,   145,  1127,   184,  2446,     0,   919,     0,     0,
       0,     0,   145,  1231,   907,   145,   180,   145,   145,   675,
       0,   145,   182,     0,     0,   145,   951,   145,  2416,     0,
     145,  1601,  2584,   552,  1579,  1004,  1013,  1012,  1010,  1009,
    1005,     0,  1024,     0,   551,     0,     0,     0,     0,     0,
    1045,  1046,     0,     0,  1042,  1047,     0,  1049,  1033,  1035,
    1043,  1044,  1050,  1039,  1038,  1051,  1052,     0,     0,     0,
    1064,   743,     0,     0,     0,     0,  1640,     0,  1638,     0,
    1860,  1642,  1631,   224,     0,  1999,     0,  1591,     0,  1590,
       0,   618,  1254,  1253,  1255,     0,  1021,     0,   145,     0,
    1455,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2284,     0,  2285,     0,     0,  2318,  2314,     0,
       0,     0,     0,     0,  2288,  2291,  2292,  2293,  2290,  2294,
    2289,     0,     0,  2295,     0,     0,  2369,  2386,     0,  2099,
    2369,  2397,     0,  2396,  2402,     0,  2275,  2003,     0,     0,
    2393,  2387,     0,  2393,     0,     0,  2376,     0,     0,     0,
       0,  2176,     0,     0,     0,  2275,  2278,     0,     0,  2839,
       0,     0,     0,     0,  2071,     0,     0,  2242,     0,  2275,
       0,     0,     0,     0,     0,     0,     0,  2271,  2310,     0,
     513,     0,  2061,     0,     0,     0,  2190,     0,  2187,     0,
       0,     0,     0,  2331,     0,     0,  2430,  2004,  2019,  2020,
    2021,  2024,  2407,  2007,     0,  2333,     0,     0,  2005,  2032,
       0,  2311,  2057,     0,  2062,  2047,  2377,  2296,  2297,  2298,
    2299,  2064,     0,  2040,  2045,  2049,     0,  2386,  2028,     0,
    2025,     0,  2334,  2270,     0,  2268,     0,  2016,  2017,  2018,
    2010,  2011,  2012,  2013,  2014,  2015,  2022,  2246,  2244,  2245,
       0,     0,  2216,     0,     0,  2044,     0,     0,  2115,  2576,
    2615,     0,  1738,  1738,  1738,  1726,  1736,  2406,  1877,  1749,
    1877,  2412,     0,  1858,   959,   960,   958,  1547,  1561,  1575,
    2272,  1569,  1715,     0,     0,     0,  1943,  1956,     0,  1983,
    1984,  1985,  1985,     0,  1925,     0,  1968,  1993,  1994,  1995,
    1996,  1997,  1998,     0,  1992,  1934,   955,  2815,  2824,     0,
    2712,  2859,     0,  1838,  1811,  1813,  1823,  1838,  1845,  1838,
    1838,  2117,  1875,  2118,  2119,  2413,     0,  1782,  2448,  1549,
    1573,     0,  1110,  1111,     0,  1115,  2839,  2712,     0,     0,
       0,     0,  1772,  1806,     0,  1797,     0,  2423,  1773,  2422,
    1774,  1777,  1778,  1768,  1807,  1644,     0,  1802,  1699,  1698,
       0,  1880,     0,     0,     0,  1622,  1610,     0,     0,  1863,
       0,  1812,  1648,     0,  2331,  1810,  1370,  1264,  1331,  1144,
       0,  1944,  1155,     0,  1139,     0,  1138,  1944,     0,  1156,
       0,  1944,  1371,  1265,  1332,  1372,  1266,  1333,  1373,  1507,
    1267,  1506,  1494,  1493,  1492,     0,     0,     0,     0,     0,
       0,     0,     0,   816,  2584,   145,  1521,  1374,     0,  1268,
     369,  1522,  1334,  1526,   834,   833,     0,     0,  1335,     0,
     685,   690,     0,   692,   693,  2503,  2565,   694,   697,   698,
       0,   700,   689,   688,     0,     0,     0,     0,     0,   706,
     711,     0,     0,     0,     0,     0,     0,  1174,  1175,  1375,
    1271,     0,  1336,     0,  1122,     0,  1272,   186,     0,     0,
     288,     0,  2584,   310,     0,     0,     0,     0,     0,     0,
       0,     0,   816,   497,   816,     0,  1322,   307,   338,     0,
     353,   348,   349,   347,  2584,   145,  2584,   145,     0,     0,
       0,     0,     0,   350,   345,   346,   342,     0,     0,   355,
    2475,  2547,  2727,     0,   717,   719,     0,   724,   358,  1292,
     377,   376,   375,     0,   363,     0,   382,   385,     0,   360,
     339,   337,   334,   303,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1224,     0,  1378,  1337,     0,
    1359,  1363,     0,     0,     0,   756,  1381,  1278,  1340,     0,
     552,     0,     0,   567,   567,   552,  1392,  1279,   174,  1309,
     163,     0,     0,   159,     0,     0,     0,     0,   153,  1382,
    1280,  1341,     0,     0,  1383,  1281,     0,     0,   293,   628,
     639,   644,  1286,   648,   645,  1349,   646,  1390,  1282,     0,
    1386,  1312,  1344,   395,   611,   394,  1203,  1203,  1393,  1413,
    1283,  1203,     0,  1320,     0,   282,   284,     0,   142,     0,
    1284,     0,  1342,  1385,  1311,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1529,     0,     0,     0,     0,     0,
       0,   145,     0,     0,     0,  1322,  2584,   145,   876,  1384,
       0,  1317,     0,  1357,     0,     0,     0,   407,     0,  1310,
    1320,     0,   295,  1288,     0,  1351,     0,     0,   232,   231,
     233,     0,     0,     0,     0,  2276,  2277,     0,  2274,  2108,
    2327,     0,  1539,   981,   967,   980,     0,   963,  2545,     0,
     966,   968,     0,     0,     0,   969,   973,   974,     0,   965,
     962,   964,     0,   418,     0,     0,   773,   774,     0,     0,
       0,     0,   853,     0,     0,  1519,     0,   150,   683,     0,
       0,     0,   678,   708,   713,     0,     0,     0,     0,   474,
     478,   482,   483,   484,     0,     0,     0,     0,   164,   151,
       0,   896,     0,   552,     0,   766,  1203,  1396,     0,   194,
     189,     0,     0,   729,     0,  1570,     0,     0,   606,   609,
     608,     0,   381,   848,   846,   845,   847,   869,   844,     0,
    1881,  1883,     0,     0,     0,     0,     0,     0,   618,   477,
       0,     0,   555,     0,   594,     0,     0,     0,     0,   591,
       0,     0,     0,  2456,     0,   865,   837,     0,  1133,     0,
    1151,  1134,     0,     0,     0,     0,  1188,  1195,  1164,  1189,
    1166,  1195,     0,     0,   779,   783,   782,   786,   784,     0,
     780,   657,  1686,  1687,     0,  1221,     0,     0,  1515,     0,
    1513,   918,  1215,   145,     0,   145,     0,   145,  1223,  1217,
    1219,  1421,     0,   916,     0,     0,   909,   911,     0,   913,
       0,  1025,   554,     0,     0,     0,     0,     0,     0,  1041,
     655,  1048,     0,     0,     0,  1063,  1058,  1060,     0,  1075,
    1069,     0,   742,     0,     0,  1641,  1634,  1636,  1635,     0,
       0,  1632,     0,   241,   228,  2281,   908,     0,   624,     0,
    1075,  1066,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1743,  2282,  2283,     0,     0,     0,  2315,
       0,     0,  2152,     0,  2123,  2125,  2138,     0,  2153,  2106,
       0,  2368,  2365,     0,     0,     0,  2369,  2376,  2172,     0,
       0,     0,  2376,     0,  2396,     0,     0,     0,  2167,  2169,
       0,     0,     0,  2386,  2386,     0,  2174,     0,     0,  2154,
    2127,  2129,  2139,     0,     0,  2262,     0,  2142,  2141,     0,
    2073,  2074,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2088,  2143,  2241,     0,     0,     0,  2145,  2144,     0,     0,
    2309,     0,     0,     0,  2150,   514,  2155,     0,     0,     0,
       0,  2161,     0,  2198,     0,     0,     0,  2096,  2272,     0,
       0,     0,     0,     0,     0,     0,  2379,  2380,  2381,  2378,
       0,  2063,  2048,  2066,  2042,  2046,  2050,     0,  2386,  2065,
    2068,     0,     0,  2036,     0,     0,  2034,  2058,  2030,     0,
       0,  2059,     0,  2114,     0,     0,     0,  2219,  2214,  2215,
    1738,  1738,  1738,  1738,  1735,     0,     0,     0,  1782,     0,
    1782,   207,  1546,  1716,  1725,  1962,     0,  1980,  1978,  1921,
    1926,  2001,     0,  1838,  1845,  1838,  1838,     0,     0,  1701,
       0,  1823,     0,  1837,  1821,  1836,     0,     0,  1851,  1849,
       0,  1851,     0,  1851,     0,  1815,     0,  1841,  1817,  1836,
    1819,  1825,     0,  1867,  2414,  1876,     0,  1795,  1752,     0,
    2263,  1115,     0,  1754,  1776,  1775,     0,  1765,     0,  1804,
    1762,  1645,  1629,     0,  1627,  1614,  1616,  1615,     0,     0,
    1617,  2331,     0,  1627,  1609,     0,  1653,     0,     0,  1880,
       0,  1652,     0,  1944,  1136,  1137,     0,  1160,     0,  1080,
    1081,     0,  1079,     0,     0,     0,   545,   548,     0,  1524,
       0,  1391,  1308,   687,     0,     0,     0,     0,   702,   661,
     703,   705,     0,     0,   704,   707,   710,  1320,     0,   301,
    1294,     0,  1355,  1168,     0,     0,  1125,     0,     0,     0,
       0,     0,  1096,   536,  1095,     0,     0,     0,     0,   816,
       0,     0,   540,     0,   496,   493,   333,     0,     0,     0,
       0,   390,     0,   312,   325,   388,   331,     0,   365,     0,
     336,     0,   329,   351,   343,   352,   344,   364,   366,     0,
     721,   722,   720,   716,     0,   723,   725,     0,   379,     0,
       0,     0,   397,   359,   396,     0,  1377,     0,  1320,     0,
     297,  1290,     0,  1353,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1358,     0,     0,     0,
       0,   761,     0,   758,     0,   567,     0,  1405,     0,  1402,
    1400,   567,     0,     0,   156,   155,     0,   162,     0,     0,
       0,     0,     0,     0,  1414,  1415,  1416,     0,     0,     0,
       0,     0,     0,   401,     0,   304,   306,   305,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   408,   372,     0,   872,     0,
       0,     0,   410,     0,     0,  1369,     0,     0,     0,     0,
       0,  1376,  1273,  2111,  2112,  2109,  1749,  2326,     0,     0,
       0,   978,     0,     0,     0,     0,   421,   422,   150,   420,
     445,     0,   816,     0,     0,   850,   855,   863,  2653,  2249,
    2250,   861,   856,   858,   860,   862,   859,     0,     0,     0,
       0,   518,     0,     0,     0,   505,     0,     0,   515,   498,
     501,   502,     0,     0,   679,   682,   680,   681,     0,   701,
       0,   477,   525,   581,     0,   166,     0,     0,   167,   165,
       0,     0,   381,   763,     0,   760,  1395,     0,   192,     0,
     733,     0,     0,     0,     0,     0,  1203,   671,     0,   868,
     870,   842,     0,   713,     0,     0,   630,     0,   552,  1602,
     613,     0,   583,   477,   581,   590,     0,     0,   598,   380,
       0,     0,   618,   381,     0,     0,  1096,     0,   864,     0,
       0,  1132,     0,     0,     0,  1185,  1190,  1186,     0,  1165,
    1147,     0,  1187,     0,     0,  1193,  1118,  1167,  1119,  1437,
    1438,  1435,  1436,     0,     0,     0,     0,     0,     0,  1677,
       0,     0,  1511,     0,   920,     0,   903,     0,   905,   145,
     750,     0,   145,     0,     0,     0,     0,     0,     0,  1040,
       0,  1034,  1036,  1061,     0,     0,  1075,  1074,     0,  1065,
    1073,  1071,  1072,  1070,     0,     0,  1639,  1637,     0,   616,
       0,     0,   145,  1075,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2286,     0,  2317,  2313,     0,  2120,
    2287,  2367,  2383,  2385,  2173,  2375,     0,     0,     0,  2398,
       0,     0,  2376,  2336,  2390,  2389,     0,     0,  2388,  2376,
    2376,  2336,  2175,  2336,     0,     0,     0,  2242,     0,     0,
    2072,  2084,  2085,  2086,  2302,     0,  2091,     0,  2081,  2082,
    2083,  2075,  2076,  2077,  2078,  2079,  2080,  2087,  2306,  2305,
       0,     0,  2147,  2148,  2149,  2308,  2156,     0,  2493,  2199,
       0,  2160,  2189,  2188,     0,     0,     0,  2163,     0,     0,
    2185,     0,  2243,  2431,  2006,     0,     0,  2033,  2312,  2051,
       0,  2067,  2069,  2029,  2262,     0,     0,     0,     0,     0,
    2038,     0,     0,  2239,     0,     0,     0,  2221,  2218,     0,
       0,     0,     0,  1729,  1728,  1734,  1795,  2108,  1795,     0,
    1922,     0,  1822,  1818,  1820,  1826,     0,  2854,     0,  1827,
    1834,     0,  1814,     0,  1850,  1846,     0,  1847,     0,     0,
    1848,     0,     0,  1816,     0,  1834,     0,  1874,  1741,     0,
    2210,     0,  1753,  1113,  1114,  1763,     0,  1766,  2524,  1878,
       0,  1628,     0,     0,     0,  1619,  1625,  1607,     0,     0,
       0,  1649,  1627,  1650,  1157,     0,     0,  1149,  1086,  1087,
    1090,  1088,  1085,  1089,     0,     0,     0,   816,   819,     0,
       0,     0,   817,   145,  1269,     0,     0,     0,     0,   662,
    1389,  1270,     0,     0,     0,     0,  1169,  1323,     0,     0,
    1293,   816,     0,     0,     0,   562,     0,  1109,  1109,     0,
     309,     0,   542,   603,     0,   495,   494,     0,   492,   713,
       0,     0,   316,   326,     0,   321,     0,  1321,     0,     0,
       0,     0,   320,   323,   322,   392,     0,   389,     0,   145,
     145,   367,   718,   378,   383,   384,   387,  1328,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   897,   880,     0,     0,   898,   899,     0,     0,     0,
    1226,  1227,  1225,  1360,  1361,  1367,  1364,  1362,  1366,  1368,
    1365,     0,  1276,     0,     0,   754,  1324,  1397,  1399,  1398,
       0,  1401,   160,   157,   158,   161,  1325,  1306,  1287,  1350,
     612,     0,     0,     0,  1285,     0,  1343,     0,  1302,  1296,
       0,     0,     0,     0,     0,  1388,  1316,  1348,  1387,  1314,
    1346,  1313,  1345,  1315,  1347,  1307,     0,     0,  1885,   877,
       0,     0,     0,   145,   145,   875,   752,  1289,     0,  1352,
    1298,     0,     0,     0,   970,     0,     0,     0,   972,   426,
     446,   150,     0,   772,   836,     0,     0,   852,     0,   503,
       0,   509,   516,     0,     0,   520,   521,   519,   504,  1203,
     552,  1203,   805,   806,     0,     0,   826,     0,   677,     0,
       0,   475,     0,   522,     0,     0,   479,   169,   168,     0,
       0,     0,   767,   771,   769,   768,   770,   765,     0,   756,
     194,  2584,     0,     0,     0,     0,   610,   604,   607,  1410,
     843,     0,  1884,   746,     0,   381,   626,     0,     0,     0,
     475,   618,     0,   480,   485,   486,   499,     0,   591,   582,
       0,   583,   592,   593,     0,   600,  1485,     0,   619,   600,
       0,     0,     0,   867,     0,   866,     0,  1135,  1152,  1153,
       0,     0,  1195,     0,     0,  1197,  1192,     0,     0,   785,
     788,   781,   664,   145,     0,  1514,   145,   145,  1252,     0,
     914,  1055,  1056,  1057,  1054,  1053,   656,     0,  1059,  1018,
    1068,   744,     0,   242,   617,     0,  1019,   145,   995,   987,
     994,   983,   986,   988,     0,   990,   991,   985,   982,   984,
    2316,  2137,     0,  2382,  2384,  2171,  2395,  2394,  2170,  2401,
       0,     0,  2364,  2392,  2391,     0,     0,  2376,  2376,  2140,
    2151,     0,  2241,  2272,     0,     0,  2092,     0,     0,     0,
    2146,  2849,     0,     0,  2203,  2204,     0,  2200,  2201,  2196,
    2197,  2162,     0,  2641,  2180,     0,     0,  2195,  2055,  2053,
    2052,  2037,     0,     0,  2035,  2031,     0,  2060,  2205,  2238,
    2272,  2207,     0,  1749,  1733,  1732,  1731,  1730,  2210,  2428,
    2210,  1720,     0,  1870,     0,  1873,     0,     0,  1824,     0,
       0,  1828,     0,     0,  1830,  1832,     0,     0,     0,     0,
       0,     0,  2417,     0,  1794,     0,  1749,     0,  1764,     0,
    1626,  1611,     0,  1612,  1618,     0,     0,     0,     0,     0,
    1654,  1647,  1150,  1158,     0,     0,     0,   547,   821,   820,
     823,   818,   822,  1525,     0,   695,   696,   699,  1295,     0,
    1356,  1304,     0,  1643,   538,   311,     0,   557,     0,     0,
       0,  1102,   140,  1101,     0,   557,   557,   491,   490,   499,
     319,     0,     0,     0,   313,   391,     0,   393,   314,   318,
     372,   335,   328,     0,     0,     0,  1291,     0,  1354,  1300,
    1327,  1379,  1274,  1338,     0,     0,   886,     0,     0,     0,
       0,  1380,  1275,  1339,     0,     0,     0,     0,     0,  1643,
       0,     0,     0,     0,     0,     0,     0,     0,  1534,     0,
       0,   371,   874,   873,   372,   409,  1318,     0,  2110,     0,
     971,   976,   977,   975,     0,   415,   423,   426,     0,     0,
    1243,  1243,     0,     0,   500,   517,     0,   602,   561,   602,
       0,     0,     0,     0,     0,   714,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   759,   758,   191,     0,
     475,     0,   713,     0,   871,     0,     0,     0,   618,   477,
       0,     0,  1599,   476,     0,     0,   488,     0,   594,   583,
     591,     0,     0,   615,     0,  1478,     0,   621,     0,     0,
       0,   815,  1191,     0,  1205,     0,  1146,  1116,  1200,     0,
    1725,  1877,     0,     0,     0,     0,   798,     0,   668,  1244,
    1512,   904,   906,   751,  1062,     0,  1075,  1067,   989,  2366,
    2400,  2335,  2337,     0,     0,  2358,  2351,  2354,  2352,  2353,
    2355,     0,  2350,     0,  2168,  2399,  2348,  2362,  2301,  2243,
    2089,     0,  2304,  2303,  2307,     0,  2157,     0,  2158,  2202,
    2164,  2181,     0,  2165,  2193,     0,     0,  2056,  2054,  2039,
    2240,     0,  2225,  1703,  1702,     0,  1723,  1906,  1875,     0,
       0,  1869,     0,     0,  1900,     0,     0,     0,  1835,  1853,
       0,  1831,  1829,     0,  1842,     0,  1844,  2523,  2810,  2709,
       0,  1781,  1783,  1786,  1788,  1787,  1789,  1785,  2209,  2211,
       0,  1760,  2264,  1879,     0,     0,     0,  1097,     0,     0,
    1627,  1656,  1668,  1668,  1651,  1063,     0,   145,   691,     0,
       0,   290,  1109,     0,  1203,   563,  2653,   564,  1108,  1112,
     139,     0,  1203,  1203,   487,     0,   317,   327,     0,   374,
     386,     0,  1643,     0,     0,   884,   893,   893,   881,     0,
       0,   900,  1277,   755,     0,   566,     0,   285,  1303,  1297,
       0,     0,     0,  1536,  1537,     0,     0,     0,     0,     0,
    1326,   145,  1299,   979,     0,   448,   456,   427,   431,  1528,
       0,  1528,     0,   428,   432,  1528,  1528,   425,  1877,   444,
    1243,     0,  1240,  1239,   550,   632,     0,     0,   507,     0,
     572,   506,     0,   827,     0,     0,   712,     0,   477,   581,
       0,   535,   526,   527,   528,   529,   531,   530,   532,   533,
     534,   524,   523,     0,   713,   890,   381,  1485,   753,     0,
       0,   726,     0,   713,     0,  1602,   614,   583,   477,   581,
     481,   499,     0,   598,   591,   594,     0,   595,     0,   599,
       0,     0,     0,   618,  1538,  1096,     0,     0,   816,  1204,
    1165,     0,     0,  1194,  1198,  1199,     0,     0,     0,     0,
    1247,   792,   793,   787,   789,     0,   800,   804,   663,     0,
       0,   667,   658,   713,   145,     0,     0,  2349,  2356,  2357,
       0,  2178,     0,     0,  2374,     0,     0,     0,  2090,     0,
       0,  2183,  2182,  2194,  2166,  2220,     0,     0,     0,     0,
       0,     0,     0,  1714,     0,  2336,  1868,  1871,     0,  1903,
       0,     0,     0,     0,  1888,     0,  1833,     0,     0,  1843,
       0,     0,     0,  1790,     0,     0,     0,  1799,     0,  1624,
    1877,     0,  1621,     0,  1663,     0,  1655,  1657,     0,     0,
       0,  1082,     0,  1083,  1305,     0,  1103,     0,   602,     0,
    1115,  1112,   552,   602,   602,   632,     0,     0,   330,     0,
     298,  1301,     0,     0,   895,   895,     0,     0,     0,     0,
       0,     0,   403,     0,     0,  1530,     0,  1531,  1532,  1535,
     411,   424,     0,   454,   453,     0,   451,   450,   452,     0,
     441,     0,     0,     0,     0,     0,     0,   414,  1238,  1242,
    1241,     0,   508,     0,   510,     0,     0,   558,   559,   560,
       0,   512,   568,   569,   824,     0,   829,     0,   715,     0,
       0,   713,   580,   737,     0,     0,     0,  1479,     0,     0,
     605,   747,  1485,   618,   591,     0,   583,   489,     0,   600,
     594,   598,   596,   597,     0,  1482,     0,   620,     0,  1105,
     814,     0,  1195,  1206,  1201,  1196,  1441,     0,     0,   790,
     795,   794,  1528,   799,     0,     0,     0,   666,   665,   741,
    1020,  2338,  2339,  2363,     0,     0,     0,  2342,     0,  2340,
       0,     0,  2362,     0,  2179,  2300,  2186,  2159,  2184,  2797,
    2524,  2768,     0,  2237,  2226,  2237,  2237,  2217,     0,     0,
       0,  1905,     0,     0,     0,  1901,  1902,  1886,     0,     0,
    1890,  1840,  1866,     0,     0,     0,  1784,  2212,  2213,  2447,
    1613,  1623,  1098,     0,  1665,  1667,     0,     0,     0,  1643,
       0,   567,     0,  1099,  1115,   561,   816,   816,   324,   315,
     373,     0,     0,     0,   891,   894,   882,   883,   902,   901,
     757,  1643,     0,   399,   398,     0,   402,     0,   449,   459,
       0,   457,   429,   434,     0,   440,   439,   436,   435,   430,
     433,   549,     0,     0,     0,     0,     0,     0,   570,     0,
     571,     0,   828,     0,     0,     0,   739,   889,     0,     0,
     475,   713,  1480,  1600,   594,   583,   591,     0,     0,   585,
    1109,  1109,   462,   598,   600,  1483,  1484,     0,     0,   515,
       0,  1117,  1440,  1439,  1725,     0,     0,     0,   801,   802,
     797,     0,     0,  2343,     0,  2346,     0,  2347,  2341,  2371,
    2373,     0,  2359,  2360,     0,  2230,  2229,  2228,  2232,  2231,
       0,  2224,  2222,  2223,     0,     0,     0,     0,  1872,     0,
    1889,  1892,     0,     0,     0,  1898,     0,  1891,  1893,     0,
    1852,     0,  1864,  1792,     0,  1791,  1877,     0,  1670,     0,
       0,  1658,  1659,     0,     0,  1660,   145,   291,   556,   816,
     565,  1100,   572,   541,   539,  1643,   885,     0,   286,     0,
     404,  1533,   455,     0,   438,   437,   631,   511,   601,   577,
       0,   576,     0,   574,   573,   825,   830,     0,   713,   879,
    1485,   727,   598,   591,   594,     0,   584,     0,   140,   140,
     600,   460,     0,     0,   381,     0,  1423,  1725,  1422,  1424,
    1432,  1429,  1431,  1430,  1428,     0,  1250,  1251,   791,   796,
       0,     0,  2344,  2345,     0,     0,  2177,     0,     0,     0,
    2234,     0,  2235,     0,     0,     0,     0,     0,  1895,  1896,
    1897,  1899,  1894,  1839,     0,  1793,  1620,  1664,  1666,  1661,
       0,  1662,     0,     0,     0,     0,  1671,  1084,   543,   816,
     299,   892,     0,   458,   575,   552,   552,   713,   738,  1481,
     600,   594,   598,  1109,   586,   588,   587,   464,  1105,  1106,
       0,   600,   804,     0,  1433,  1427,  1701,  1688,     0,     0,
     803,     0,     0,     0,     0,  2227,  2233,  2236,     0,     0,
       0,     0,  2634,     0,  1907,     0,     0,     0,  1669,  1675,
       0,     0,     0,   544,     0,   579,   578,   740,   463,   598,
     600,   140,   515,  1104,     0,  1877,     0,  1425,  1725,     0,
       0,   809,  2370,  2372,  2361,  1719,  1718,  2815,     0,     0,
    1722,  1915,     0,  2364,     0,     0,  1918,     0,  1865,     0,
       0,     0,   400,   600,   461,   589,   381,  1107,  1091,     0,
    1426,     0,     0,   811,     0,   807,   810,   812,   813,     0,
       0,     0,     0,  1908,  1909,  1918,     0,  2348,  1918,  1887,
    1672,  1676,     0,  1673,   465,   600,     0,     0,     0,   775,
       0,  1749,     0,     0,     0,  1904,  2364,  1917,  2374,  2348,
       0,  1877,     0,     0,     0,   808,     0,     0,     0,     0,
    1912,  2362,  2374,     0,  1092,   809,  1248,  1249,     0,  1721,
       0,     0,  1910,  2362,  1674,     0,     0,  1913,  1911,   776,
       0,  1914
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -5863, -5863, -5863,  4144,  -430, -1744, -5158, -1151,  1760, -5863,
   -5863,  -973, -1360,  3357, -1774, -5863, -5863, -5863,  1513, -5863,
   -5863, -5863, -5863,  4107, -5863, -2931, -5863, -5863,   194,  -386,
      75,    74,  3819,  1837, -5863, -1049, -5863, -5863,  -613,     4,
   -5863,   162,   706, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
   -5863,  -691,  2106, -5863,  2198,  1434, -4855, -5863, -5863, -1574,
   -3819, -5863,   682, -5863,   708, -4160, -5863, -4871,  -981, -5863,
   -5863, -5863,  2089, -5863, -5863, -5863,  2036,  1223,  -338, -5863,
   -5863, -5863, -5863, -5863, -5863,  -801, -5863, -5863, -1111,     2,
    -654, -2982, -4383, -5863, -5863,   529,  -379, -1513, -5863,   724,
   -5863,   725, -5863, -4892, -5863,    28, -2777, -4399, -5863, -5863,
   -5863,  -351, -1537,  1466, -5863,  1529, -5863,  -746, -1186,  1909,
   -2470,  -942, -5863,  -244, -3616, -1087,  -816,  -814,  -976, -4400,
   -4908, -5863, -5863, -1116, -3793, -5260, -5492, -4926, -4815,  1474,
   -5863,    -1,   530, -5863,     3, -3689, -3836,     8,   506, -5863,
      10,    14, -5863,   522,  -745,  -974, -1628, -5863,  -917, -5863,
   -5863, -5863, -3503, -5863, -5863, -5863,   189, -5863, -5863, -5863,
   -5863,   565, -5863, -5863, -5863, -5863, -5863, -5863, -3212,  2056,
    2058, -5863, -4426, -5863,  -943, -5863,   731, -3540,  1457, -5863,
   -5863,  1214,  4125,   549, -5863, -5863, -5863, -5863, -5863, -5863,
   -1815, -5863, -5863, -5863, -5863,    23,  -327, -5863, -5863, -5863,
   -5863, -5863, -5863, -5863,    15, -5863,  1174,   488, -5863, -5863,
    -636, -5863, -5863, -5863, -5863, -5863, -5863, -1174, -5242, -1306,
   -1280, -5863, -3470, -5863, -5863, -5863,  -300, -5863, -5863, -5863,
   -5863, -5863,  -887, -5863,  1270, -4202, -5863, -5863,   525, -5863,
   -5863, -5863, -5863, -5863,  -953,  -241,  3274, -5863,  -500,  -724,
   -5863, -5863, -5863,  -238, -5863, -5863, -5863, -5863, -5863,  -533,
   -1283,  5145,  4504, -1130, 15981,  -861,  -572, -5863, -5863, -5863,
   -2898, -5863, -5863, -4296, -5863,  5137,  2630,  1192,    16, -5863,
      48,   107,  3940, -5863,  1138, -1191, -3156,   481,  -458, -5863,
   -5863, -5863,   485, -5863, -2001, -5863, -5863, -5863, -5863, -4157,
      20, -5863, -4427, -5252, -4666, -4176, -1143, -5863, -4402, -5238,
   -4132, -5863,  2085, -5863, -5863,  -561,  -144,  3248, -5863, -1501,
    2431, -1425, -5863, -2552,   548,  1622,  3258, -3304,  -105,  3246,
   -3039, -5863,  -676,  1210, -5863,  -323, -3835, -5863, -5863, -5863,
   -2809,  -582, -5863, -5863,  1662, -1101, -5863, -5863, -5863, -5863,
    -649,  3227,  -172, -5863, -5863,  4475, -5863, -5049, -5863,  4440,
   -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -5863, -1488,
    1378, -5863,  -841, -5863, -5863,  2189,   757, -5863, -5863, -5863,
   -5863,  1464,  -434, -5863, -5863, -5863, -5863, -5863, -5863, -5863,
    -937, -1168, -5863, -5863, -5727, -5863, -5863, -5863, -5863, -5863,
    2528,  -958,  -756,  4335,  -226,    22, -5459, -5863, -5863,  -447,
   -5863,  3660, -5863, -5863, -5863, -5863, -5863,   543,   544, -5863,
   -5863, -5863, -5863, -4547, -5863, -5863, -5112, -5863, -5863,  2166,
   -5863, -5863,  1340,     5,  3367, -5863, -5863, -5863,    -5, -5863,
   -5863, -1021,  2516, -5863, -2407, -5863,  -590, -5863, -5863, -1942,
      25, -4404, -5863,    13, -5863, -5863, -5122, -1086,   334, -5863,
   -5863, -4129,    21, -5863, -5863, -5863, -5863, -5093, -5863,    38,
   -4929,   903, -3376, -5863,    11, -5863,  -408, -5863, -5863,  -409,
   -5863, -5863, -5863, -4014,    32,    46, -5863, -5863,    82,  3520,
     -45,    19,    35,     7,   190,  3778, -5863, -5863, -5863, -5711,
    3815, -5863,    12,  -874,  5174,  5177, -5863,  -946,  -147,   490,
    1727,  -695, -2632,  3723,  3731, -5863,  1714,  2531, -2466, -2465,
   -5863, -1039,  -807,  -612, -5863, -5863, -5863, -5863, -1546,  -689,
   -2648, -5863,  3733, -5863, -5863, -5863, -2401, -3416, -3245,  1755,
   -3327, -3222, -5863,   989,   977,  -972,   -67,   -36, -1503,  -784,
    1782, -5863, -5863,  1766,  -335, -5863, -5863,  -332, -3351,   939,
   -5863, -4622, -2845,  1768, -1097,  -776, -5863,  -924, -5863,  -575,
    1778, -5863, -5253, -1126, -5863, -3532,  5661,  3813,  -837, -5863,
   -5863,  -810, 10919, -5863, -5863, -5863, 11060, 11147, -5863, -5863,
   12536, 12775, -5863,  -587, 12919, 10422,  -794, -1954,  -197, 13749,
   18571, -1899,  3740,    58, -5863, -2922, -2567, -5863, -5863, -5863,
    -296,  1088,   984, -5863, -5863, -4676, -4494, -5863,  2650, -1995,
   -5863,  -584,  1840,  -574, -5863, -5863, -5863, -2737, -5572, -2767,
    2651, -5863, -5863, -5863,  -185, -5863, 18425, -3288, -5863,  -795,
   -1028, -1621,  3154, -3028, -1947, -5863, -5863, -5863, -3147, -5863,
   -5863, -5863,  -638,  1870, -5863, -5863,  1999, -5863, -5863, -5863,
    -991,  2239,  -763, -1208,  1876, -4522, -5863,  -518, -5222, -5047,
   -5863, -5449, -5862, -1848, -1106, -3058, -3976, -1952,  1891, -3131,
   -5863, -1976,  1968,  1180, -5863,  1339, -5863,  4363,  -806,  2660,
    -798, 17024,  -679, 10536, -1296, -5863,  3311, -5838,  1101,  7394,
      44,  -111,  2212,  -360,  2604,  3250, -5863, -5863,    -6,  9566,
    -593,  -873, -5863,  5211, 16552, 15166, -3721, -5863
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    58,    59,    60,    61,  1116,  1121,  1925,  1944,    62,
      63,  1648,  3079,  2932,  3908,  3909,    64,    65,  1644,    66,
      67,    68,    69,  1558,    70,  1897,  3093,    71,  2767,   823,
     860,   825,  2057,  2058,  3024,  2059,  2047,  1250,  1843,  1580,
     840,  1252,  1540,  1581,    73,    74,  1414,  2633,    75,    76,
      77,  1611,  1704,  1612,  1613,  1552,  5048,  5878,  3694,  2887,
    3956,  3695,  3696,  4384,  4385,  3774,  4413,  4475,  5892,  5893,
      78,  1720,  1721,    79,    80,  3061,  3874,  4528,  5435,  5436,
    5697,   670,  5071,  5072,  5684,  5685,  5907,  6080,  6081,  3094,
     701,  3951,  4612,  3899,  5142,  3900,  5143,  3901,  5144,  4938,
    4939,  4374,  4375,  3885,  4559,  4560,  2123,  5084,  4561,  3902,
    5103,  5731,  3903,  2853,  2782,  2783,  5922,  3128,  2016,  2014,
    5634,  5710,  4924,  4925,  4449,  5931,  5932,  5933,  6223,  5105,
    5148,  5149,  6118,  6119,  3954,  4618,  5155,  5493,  5708,  3652,
      82,  3927,  3928,    83,   764,  1919,  4058,   765,  3131,   702,
     766,  3095,    88,  3121,  5924,  3122,  1674,  2946,  4541,  4031,
      89,  1144,  4338,  5518,  5791,  5792,   755,    90,  1905,    91,
      92,  3074,  3892,    93,  2800,  3600,    94,    95,  3619,  3620,
    3621,    96,  4569,  5454,  1614,  3683,  3684,  3685,  3686,  4405,
      97,  1900,  3102,  3103,    98,    99,   100,  3233,  3234,   101,
    3010,   102,   103,   104,   105,  4443,  5005,  5119,  3725,  3915,
    4585,  5117,   106,  3878,  3096,  3149,  3989,  3990,  5516,  5783,
    5784,  5785,  5982,  6258,  5787,  5984,  6140,  5986,  5094,  6404,
    6405,  5768,  4327,  4902,   108,  5095,  5096,  5937,   109,  2798,
     110,   111,  1874,  3067,  3068,  4542,  3138,  3964,  3965,  4598,
    4599,   112,  3814,   113,  4981,  4982,   703,  5945,  5884,  6066,
     114,   115,  4985,  4986,   116,   117,   118,   119,   120,   756,
    1078,  1079,   758,  1199,  1200,  3561,  1161,   121,  2641,   122,
    3854,   123,  1293,  5209,   124,   790,  1215,  1216,  3097,   126,
     800,  3256,   802,  3217,  3218,  2032,  4035,  4036,  4686,   127,
     128,  4039,  4040,  4693,  3230,   129,  1545,  2777,  2778,  4894,
    3098,   704,  3646,  5616,  5361,  5617,  6129,  6320,  5362,  3505,
    4283,   131,   705,  1586,  2837,  1167,  1168,  3142,  3969,  2746,
    2747,  1743,  4639,  2749,  3971,  2750,  1518,  2751,  1154,  1155,
    3977,  3978,  3979,  3980,  4635,  4645,  4646,  5510,  5776,  4642,
    1893,  5504,  5505,   132,  1583,  2834,   133,   134,   135,  1627,
    1002,  1177,  1178,   136,   717,   718,   137,  5702,   138,  1157,
     139,  5514,   140,   141,  1279,  1280,   832,   142,   143,  2857,
    4387,   144,  1584,   145,   146,  3719,  3720,  4997,   147,   148,
     149,  2918,  2919,   150,   151,   152,   153,   154,  6248,  6323,
    6324,  6325,  4653,  6134,   155,  1247,   156,   157,   158,   159,
     197,  1043,  1044,  1045,   955,  3099,  5495,   161,   162,  1541,
    1542,  1543,  1544,  2772,   163,   164,   165,  3999,  4000,   166,
     167,   168,   169,  1877,   170,   171,  5675,   172,   173,  1847,
     174,   175,  1052,  1053,  1054,  1055,  1845,  3449,   664,   877,
    1434,  1440,  1483,  1484,  1485,   177,   768,   178,  1270,  1083,
     769,  1208,   180,   770,  2728,  3535,  4298,  4299,  4300,  4303,
    5327,  4871,   771,  3531,   183,  2039,  3239,  3242,  3527,   772,
    3541,  3542,  3543,  4307,   773,  5620,  5621,  5622,  5623,  5859,
    6191,  6192,  6195,  6296,   774,   792,  1147,  3153,   775,  1380,
     189,   190,   191,   935,   880,   881,  3454,  5576,  5823,   193,
    2626,  3435,   809,  1489,   923,   924,   925,   944,  3034,  2694,
    2695,  2719,  2720,  1498,  1499,  2707,  2711,  2712,  3518,  3511,
    2700,  4277,  5601,  5602,  5603,  5604,  5605,  5606,  4860,  2715,
    2716,  1501,  1502,  1503,  2724,   194,  2684,  3484,  3485,  3486,
    4253,  4254,  6180,  4268,  4264,  4845,  5304,  3487,   869,  1245,
    1510,  4853,  6182,  3488,  5293,  5294,  5581,  4273,  3497,  4294,
    3939,  3940,  3941,  3489,  5833,  5834,  6177,  6178,  5583,  5584,
    3490,  5825,  6343,  6344,  6382,  6417,  2752,  1463,   908,  1381,
     909,  1476,  1382,  1450,   911,  1383,  1384,  1385,   914,  1386,
    1387,  1388,   917,  1442,  1389,  1390,  1459,  1472,  1473,  1391,
    1435,  5585,  1393,  1394,  1395,  3492,  1396,  4790,  5266,  5252,
    3357,  3358,  2054,  5566,  4786,  4169,  4780,  2619,  2623,  5316,
    5608,  5609,  3428,  4218,  4817,  5283,  5819,  6013,  6014,  6161,
    1397,  1398,  1399,  3420,  2613,  1005,  1400,  4544,  2615,  3348,
    3326,  1746,  3327,  2065,  2086,  3275,  3291,  3292,  3396,  3328,
    3336,  3341,  3349,  3382,  1401,  3277,  3278,  4080,  2088,  1402,
    1049,  1749,  1050,  1478,  3377,  5232,  5531,  5532,  5804,  5805,
    5542,  5806,  5543,  5533,  4091,  4092,  6002,  3302,  3397,  4095,
    3310,  3311,  4113,  4102,  3303,  1403,  4104,  1411,  1412,  1405,
    2033,   870,  5300,  1203,  1830,   806,  1406,  1407,  1408,  1409,
    1620,   976,  1170,  1171,   926,   928,   929,  2688,   660,   652,
     978,  3687,  2616,   661,   654,   655,  1835,  2617
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     651,  1504,    81,    84,    72,   176,  1842,   192,    85,   868,
      86,   185,   934,   181,    87,   107,   125,   803,  1745,   805,
     130,   182,   160,   811,   826,   179,   767,  1004,   192,   834,
     826,   845,   186,   848,  2881,  1110,   826,   826,   184,   871,
    1003,   874,  1959,   945,  1673,  2959,  1404,  2013,   930,   930,
     930,  1236,  1237,  1238,   658,  2852,  1415,  1242,   872,  1836,
    1475,   709,  1725,   968,   649,  1455,   794,  1490,  1619,  1492,
    1056,  1009,   794,  3651,  1014,  3258,  1678,  3528,  1202,  2851,
    1446,  1447,   187,  1436,  2838,   843,  1737,  4228,  1431,  4230,
    1454,  2083,  2748,   956,  3529,  2075,  3898,  3116,  1523,  1242,
    1902,  4060,  1422,  1148,  3981,   824,  1012,  1209,  1430,  2864,
     839,  1461,  4610,  4597,  4292,  4344,  3493,   865,  4450,  3028,
    1034,  2068,  1875,  1150,  3249,  2070,  1880,  3313,  2071,  2072,
     801,  1884,  1077,  2989,  2990,  2920,  2920,  3274,  1844,  2920,
    4400,  1894,  4402,  1615,   844,  3857,  4648,  3860,  3861,  4862,
    3309,  3811,  3865,  3866,  3867,  1914,  3869,  3870,  3871,  3920,
    2748,  4267,  5297,  4546,  4306,  3779,  4623,  4896,  1637,  3183,
    1056,   939,  1210,  1654,  4877,  1831,  1181,  5133,  2680,  1185,
    1193,  3135,  4372,  3929,  4376,  5541,  1948,  3366,  5102,  4926,
    1027,   233,   651,   959,   959,  3554,  3556,   959,   841,  5162,
    5614,   970,  1253,   871,  5639,  5141,  1006,  1587,  4965,   970,
    5714,   947,   970,  2985,  5151,   871,  4281,   959,  3333,  5237,
     871,  5238,  1150,  1887,   959,  3438,   871,   948,  5753,  3440,
    5150,  5458,  5309,  5497,  5311,  3447,   859,  4250,  1056,  1911,
    3017,   883,  4097,  5490,  3520,  4197,  4312,  3523,  5766,  1497,
    3297,  3301,  3304,  3305,  5486,  1500,  3314,  4607,  3316,  3317,
    5631,  5959,  5363,   715, -2421,  4265,  4200,  4270,  4271, -1977,
   -2489,  1910,  4099, -2568, -2610,  2811,   668,  3917,  5947,  5489,
     776,   776,  3499,  1056,  4133,  5257, -1944,  5360, -2456, -1957,
   -1982, -2636,  1582,  4305,  5112, -2677,  1430, -2456, -2456,  1217,
    1941,  1443,  1444,  5020,  5677,  5678,  3113,  4110, -2572,  3002,
   -2002,  2639,  1453, -2457,  5998, -2865,  5667,  4633,  5994,   776,
     954,  2843, -2457, -2457, -2865, -2865,  3838,  1672,  3254, -1972,
     715,  5883,   715,  1582,  2144,  6292,  1703,  1221,  1582,  3375,
    3375,  3235,  6415,  1867,  2048,  1056,  1730,  3228,  2060,  2060,
   -2420,   715,  1039, -1985,   715,  2855,  1616,  2996,  2999, -1985,
    5341,  2624,   776,  3212,  1287,  1941,  2645,  1465,  3284,  5995,
    2855,   715,  2044,  1872,  1616,   715,  4534,  1249,  1709,  1183,
     776,  2685,  2983,  3059,  3228,  2855,  6144, -1916,  2920,   776,
    5113,  4110,  5703,  1196,   776,  6146,  1941,  4469,  1941,  2647,
    -150,  5870,  4362,   715, -2417,  4062,  -150,  6250,  4345,  5211,
    5212,  5213,  1994,  5215,  5216,  5217,  5218,  5219,  2855,  1137,
    4133,  1710,  2847,  6255,  3876,  5163,  4978,  3801,  2788,  4099,
   -1777,  5031,  1257,  5816, -2633,  2784,  1232,  6154,  1941,  1836,
    1734,  1082,  5852,  2976,  6422,  1466,  5092,   782,  3350,  1941,
     782,   782,  5760,  3423,  2949,  1941,  1040,  1889,    41, -2247,
    5761,  2698,  1150,  2785,  1737,  2691, -2247,  4983,   782,  6124,
    3802,   783,   782,  3236,   783,   783,  3228,  5644,  2144,  1554,
    3285,  5114,  2144,  3082,  1240,   782,  5630,  2687,  2826,  2045,
    5254,  2683,   783,  6112,  4049,  5961,   783,    45,  3773,  1004,
    3250,  1519,  6379,  3627,  3668,  3803,  3645,  1446,  1447,   783,
    2645,  3091,  3114,  5369,  2645,   662,  2855,  6416,  2855,  3231,
    6250,  6412,  1041,  1467,  2855,  5649,  1468,  2872,  1554,  5082,
    6138,  5439,  2968,  1206,  3088,  2913,  6255,  6293,  3493,  1454,
    1520,    49,  5371,  2647,  1521,  2891,   804,  2647,  4100,  1004,
    5377,   776,  2937,  6151,  3118,  2892,  5083,  4979,  3286,  5880,
    3228,   776,  2969,  2873,  6139,  5440,  1461,   663, -1096,  5681,
    3669,  1104,  6432,  4133,  6450,  1241,  2699,  1114, -1944,  1522,
    4050,  5754,  2855,  4111,  2137,  1042,  1941,  2827,  2640,  1128,
     896,  1957,   715,  2849,  1555,  3092,  1836,    57,  4984,  5817,
    6294,  1831,  3628,  3424,  3417,  3351, -2266,  5255,  3083,  2950,
    1942,  3418, -1777, -2266,  2951,  5093,  1711,  2138,  4594,  5853,
    3232,  1291,  1957,  1997,  1233,  2046,  1873,  1735,  1047,  5032,
    5818,  6240,  1048,  6054,  5711,  2786,  3287,  1873,  1695,  3288,
     716,  6250,  2042,  1555,  5762,  1469,  2818,  2629,   875,  3213,
    2661,  5918,  3877,  3060,  3229,  4129,  2825,  6255,  1059,  4186,
    5115, -1944,  1150,  6188,   871,  2682,   959,  4111,   959,  4980,
    5742,   959,  1150,  1150,  6189,  1942,   192,  2625,  1006,  2080,
    1087,  4345,  1084,  1117,  4078,   959,  2882,  6095,  5595,  4546,
    1085,   959,  3115,  6294,  1626,  2954,  6335,  4090,  2957,  1150,
    6123,  1957,  3237,  3839, -2633,  4100,  1942,  1086,  1942,  3003,
    3026,  3027,  5342,  6381,  2850,   651,  2734,  5000,   934,  1443,
    1444,  4634,  3016,  3238,   970,  1241,  3376,  4204,  1006,  1712,
    1873,   970,  1290,  1873,   970,  5116,  2964,  2984,  1957,  3004,
    6310,  1047,  5996,  2944,  1441,  1048,  2947,  2948,  1942,  6295,
     959,  1088,  4470,  5331,  2038,  2926,   669,  1453,  3289,  1942,
    2658,  1470,  1213,  5111,  5559,  1942,  1241,  1873,  1736,   192,
    2882,  6309,  5999,  1244,  2882,  1943,  5997,  2882,  3025,  1142,
    5370, -2633,  2899,  2789,  6077,  3623,  5158,  2997,  3000,  4101,
    1047,  5379, -2421, -2633,  1048,   788,   789, -1977,  3270,  3033,
    1505,  4148,  3464,   871,  5159,  2977,  2978, -2489,   826,  2725,
   -2568, -2610,   826,   826,  1445,  2726, -2456,  1449, -1982,  1967,
    6360,  1214,  2943,  1219,  4112,  1223,  3201,  1281, -2636,  5007,
    4688,  1227, -2677,   788,   789,  5011,  1244,  1230,  2098,  5954,
    1950, -2457, -2247, -2865,  6145, -2572,  1410,  1410,   871,   826,
     826,  2612,  4308,  6147,  6232, -1944,  3185, -1972,  2140,  5957,
    2627,   871,  1456,  1457,  2663,  2664,   871,  6393,  1456,  1457,
    2816,  1954,  1410,  1965,  3290,  6242,  1617,  1618, -2420,  3244,
    2034,  1458,  6409,  3708,  1004,  4507,  1646,  1460,   839,  3211,
    2686,  4912,  1258,  1260,  1617,  1618,  1942,  1858,  1047,  4932,
    6261,  3226,  1048,   788,   789,  1556,  4546,  2833,   788,   789,
    1647,  2067,  3493,  1987,  4685,  3493,  1509,  4267,  5528,  1410,
    -150,  -150,  1854,  4187,  1990,  2883,  1859,  2076,  1860,  4378,
    1957,  1561,  2898,   871,  4145,  4146,  4147,  4148,  3047,    81,
      84,    72,   176,  3888,   192,    85,   871,    86,   185,  4970,
     181,    87,   107,   125,   947,  1849,  6197,   130,   182,   160,
    2833,   871,   179,  3493,  4521,  1539,  5866,  4464,  4465,   186,
     948,  3493,  4466,  1557,  6312,   184,  4744,  2833,  6208,  4595,
     871,  2907,  4739,  4740,  4607,   959,   959,  3419,  4588, -2266,
    2607,  2608,  2609,  2610,  2611,  2612,  2609,  2610,  2611,  2612,
    3069,  4314,  6462,  4315,   876,  3087,  4526,  4527,  6190,  2883,
    4188,  4842,  4886,  2883,  6468,  4846,  2883,   826,   826,   187,
    3594,  4832,  2865,  4834,  4835,  2810,  1546,  1298,  5073,  3276,
    4133,  4595,  6096,  6122,  4134,  4135,  4136,   710,  4725,  4690,
    1410,  1410,  4232,  3520,  4379,  4286,  5741,  2882,  6116,  1418,
    1420,  6359,  2956,  6051,   651,  4643,   959,  3889,  6056,  6057,
     970,  4685,  5074,  1006,   970, -1944,   970,  4802,  6104,  1437,
    -447,   959,  4649, -1944,  3308,  1445, -1944,  1474,  1274, -1944,
    6315,  6316,  2037,  5705,  6115,  4143,  4144,  4145,  4146,  4147,
    4148,  2769,  2687,   966,  4562,   871,  5747,   839,  1258,  4189,
    2884,  1298,   959,   959,  4133,  6267,  1941,  4586,  4134,  4135,
    4136,   949,  6300,  1891,  6186,  3077,  4045,  2882,  4576,  5798,
    2882,  5512,  6305,   793,   871,   871,   871,  1100,   959,   793,
     651,  2885,   651,   651,  1465,   949,  2986,  1527,  6156,  3373,
    4309,  1547,  5909,  3018,  5911,  1714,  4699,  1836,  5915,  5916,
    4998,  1715,   987,  1164,  3575,  5182,  2886,  6426,  3748,   988,
     989,   990,  5451,  4650,   715,  3525,   959,  4340,   959,   959,
    1275,  6350, -1778,  3452,  3690,  3129,  1264,  1493,  5127,  2905,
    1567,  5650,  4926,  4473,  2884,  1694,  5980,  4691,  2884,  3670,
     715,  2884,  3496,  3723,  5325,  6438,  6461,  2880,  6241,  3453,
    3146,  1410,   950,  6395,  5412,  2923,  6023,  6233,  2927,   665,
    5854,  2882,  1466,  6470,  6269,  2885,  1604,  6452,  4137,  2885,
     192,  3985,  2885,  3147,  1906,  1528,   950,  2015,  5413,  2015,
    3223,  3224,  3691,   871,  4474,   803,  5981,  5855,  4047,  3748,
    2886,  4138,  4308,  2882,  2886,  1056,  3576,  2886,  4547,  1298,
    6219,  3614,  4133,  3402,   951,  3671,  4134,  4135,  4136,  3809,
    1716,  2063,  1999,   715,  2001,  1495,  2003,  1907,  2005,  3890,
    2007,  2008,  2009,  3724,  4795,  4380,  4381,  2011,  3526,  1529,
     871,  2880,   715,  5452,  2079,  2880,  2883,  3271,  2880,  3273,
    1467,  4053,  3372,  1468,  5811,  3280,  4550,  6270,  1410,  6306,
    6440,  3294,  3295,  6022,  1934,  5482,  4382,  6157,  5943,  1288,
    3187,  4577,  3986,  3318,  6317,  4138,  5476,  5951,  1935,  5940,
    3078,  4700,  3553,  3338,  2906,  1548,  3624,  4139,  3374,  3353,
    4692,  3643,  4543,  1933,   934,  5939,  5541,  5507,  5968,  3210,
    1410,  5953,  4651,  3215,   711,  3918,  3558,  3692,  3222,  5956,
    3615,  3225,  3740,  1276, -1778,  5488,  2883,  4552,  3595,  2883,
    2866,  6348,  1136,  3891,  4117,  5955,  4046,  5989,  1549,  1410,
    1410,  1410,  2138,  1410,  2867,  1936,  2868,  3160,  4644,  1298,
     761,   942,  4133,  5799,  6358,  3476,  4134,  4135,  4136,  5541,
    3148,  5513,  3162,  1530,  1410,  6365,  1277,  3403,  1278,  6271,
      15,  4139,  3404,  1550,  4796,   712,  3194,  3175,  3709,  3181,
    3177,  3848,  1469,  3625,   967,  5070,  1942,  4652,  3795,  2038,
    5326,   871,  4640,  5706,  3796,  4563,  1137,  5337,  3070,  2643,
     940,  4130,  4131,  1892,  6394,  6137,  4150,    20,  2882,  1410,
    3741,  1638,  2869,  4927,  1717,  1004,  1265,   713,  1101,   714,
    2883,  5354,  4279,  3405,  4341,  2962,   952,  3086,  2768,  2882,
    3214,  2884,  1908,  4138,  3220,  3221,  3324,  6424,  5443,  5862,
    1509,  1976,  1509,  4555,  1165,  6220,  1551,  4181,  4182,  1937,
     952,  3853,  2883,  3710,  6172,  1410,  4462,  1718,  4048,  1410,
    1410,  5856,  2885,  6277,  2959,  3742,  3740,  3947,   941,  6441,
     871,   871,   871,  2732,  5330,  1410,  3700,  5534,  2692,  2693,
    2122,  2697,  5298,  1138,  1977,  6106,  5812,  2886,  5414,  3904,
    4556,   942,  1719,  1266,   948,   948,  3693,   948,  1470,   826,
    5535,  2884,  1235,  3797,  2884,  1267,  5536,  4557,  3618,  4140,
    4141,  4142,  4143,  4144,  4145,  4146,  4147,  4148,  3269,  4139,
    5537,  3987,  1938,  1471,  4454,  6272,  1639,  3743,  2880,  5455,
    6221,  3614,  2885,  5789,  2822,  2885,  3988,  3559,  3125,   826,
    3560,  1536,   959,  5208,  1537,  1909,  2790,  4472,  5676,  1924,
    5100,  5927,   715,  1039,  3741,   871,  2854,  2886,  4287,  6222,
    2886,  5477,   942,  4138,   871,  3126,  3164,   959,  5301,  3439,
    5172,  6173,  6132,  5305,  3005,  3032,  5307,  5138,  3406,  4509,
    3176,   808,  6193,  4140,  4141,  4142,  4143,  4144,  4145,  4146,
    4147,  4148,  5064,  3182,  1006,  2884,   871,  5068,  2880,   826,
    5756,  2880,  2922,  2922,  5139,  4865,  2922,  1512,  1836,  3742,
    3970,  4558,  5746,  2794,    33,  5757,   826,  2779,  1539,   871,
    2829,  3614,   871,  1539,  2795,  1939,  2885,  2884,  5087,  4476,
    3615,  2980,  4546,  3467,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  3929,   959,  6042,    41,  2883,   782,  4139,
    3744,  2886,  1139,  3650,  5538,  6231,  5919,  1040,  2885,  3493,
    1039,   871,  6194,  3493,  3905,  4870,  3616,  5755,  2883,  2773,
    5673,  3743,   783,   959,   959,   959,   959,   871,  2779,  1978,
    2829,  2774,  2748,  2886,  3470,    45,  2748,  3798,  6238,  6239,
    1140,   871,  2880,  3573,  5674,   681,  1539,  2829,  2780,  2775,
    1539,  5928,  1410,  1410,  1410,  3701,    41,  6000,  6053,  3617,
    1640,  3468,   943,  4888,  5564,  3841,  4428,  1990,  2791,  3006,
    3615,  5790,  4863,  1041,  2880,   829,   666,  5132, -1701,    49,
    3799,  4140,  4141,  4142,  4143,  4144,  4145,  4146,  4147,  4148,
    4288, -1701,    50,  6174,  -708,    45,  5666, -1701,  6175,  1004,
    1004,  5091,  1493,  1641,  1141,  5101,  1142,  5129,  1494,  6133,
    1143,  4381,  4357,  3173,  1040,  3800,    51,  5879,  3493,   683,
    3127,  1514,  6308,  1837,  4914,  6001,  1838,  5619,  1831,  -623,
    3163,  5929,  3745,  6176,  3205,    57,  1042,  4866,  1642,    49,
    3746,  4956,  1979,  3747,  3744,  4972, -1701,  5565,  2701,  4864,
      41,   871,    50,  5088,  2796,  4755,  1469,  4756,  3156,  5140,
    3502,  5539,   871,  5920,  1515,  2792,  5758,   830,  3618,  6166,
     959,   959,  2884,  5540,   849,  3574,    51,  1513,  4543, -1701,
    1041,  4429,   195,  1469,  4898,  3455,   959,  2781,   850,    45,
    1495,  4358,  3906,  2884,  5841,    57,  2702,  2797,   793,  1516,
     793,  6357,   793,  2885,   871,  2922,  4996,  4898,   793,  1228,
    1229,  4140,  4141,  4142,  4143,  4144,  4145,  4146,  4147,  4148,
     959,   959,   959,   959,  2885,  2776,  1455,   196,  2886,   871,
   -1701,  6361,  1957,    49,  5295,  3125,   871,  5946,  1487,  3136,
   -1701,  1496,  6201,  1042,  3907,  3524,    50,  5967,  2781,  2886,
    1004,  3503,  1298,  1957,   651,  4133,  6130,   651,  3618,  4134,
    4135,  4136,  3126,  2703,  3030,  3031,  4889,   970,   970,  2880,
      51,  2701,  4899,  4890,  2855,   831,  3745,  5272,  1006,  1006,
    4891,  5960,   970,  5138,  3746,   970,  2856,  3747,  3759,    57,
    2880,  1218,  1220,  1222,   851,  4899,  1224,  1225,  1226,  1262,
     959,   959,   694,  3206,   695,  3203,  1231,   959,  1298,   871,
    5139,  4133,  4757,  2704,  6338,  4134,  4135,  4136,  4892,  2702,
    1643,  1298,  3240,   192,  4133,  2097,  2015,  3697,  4134,  4135,
    4136,   699,   662,   959,  5788,   970,  5832,  3207,  3219,   970,
     970,  4893,   871,   871,  1488,   959,  5273,  3493,  3493,  3760,
    4900,  3208,   871,  3721,  4901,   866,  4003,  3763,  4689,  2860,
    3766,  2861,  1656,   878,  3195,  4430,  3196,  4467,  3197,  5526,
    3198,  4410,  3199,  4900,  3300,  1493,  3200,  4901,  2705,  4702,
    3532,  5591,   871,  4411,   938,   871,  3136,  6319,   803,  3209,
   -1701,   803,  3260,   192,  4968,  4543,  1410,  1087,  1410,  1084,
    3842,  3843,  3844,  1410,  1410,  1657,   793,  1085,  4431,  2785,
    1410,  1410,  1410,  1410,  1410,  1410,  1410,  1410,  1410,  1410,
    1410,  1410,  1410,  1212,  1086,  3804,  1410,  2862,  1410,  1006,
    1410,  1410,  1410,  1410,  1410,  1410,  2704,  6113,  1410,  5457,
    1410,  1410,  3255,  4432,  1410,  2748,  4468,  6339,  4942,  4714,
    3203,  2959,  -173,  3721,  4356,  2748,  4738,  6131,  1047,  1410,
    1410,  1410,  1048,  1495,  3650,  4726,  4138,  5470,  1088,  4258,
    4730,  3640,  2144,  4969,  3810,  4177,   793,  1410,  5481,  3735,
    5777,  6114,  1705,  4943,   936,  5430, -2440,  5431,  5432,  5433,
    -173,  1273,  1451,  1452,  3733,  1604,  3734,  5938,  5625,  1150,
    5627,  2705,  1129,  4259,  3259,  3997, -1748,  1675,  6397,  5468,
    4257,  1255, -1748,  2631,  1496,  6110,  1265,   959,  4848,  3886,
    4671,  -173,  4138,  3929,  5322,  1706,  4368,  2144,  1628,  1707,
    2748,  5459,  3825,  1684,  2635,  4138,  1432,  2647,  1715,  1130,
    3848,  4261,  3933,  3934,  3935,  3936,  4516,  3938,   846,  2920,
    1676,  1646,  4139,  6063,  1129,  4751,  4752,  4753,  4754,  2645,
    1708,  4758,  4759,  4760,  4761,  4762,  4763,  4764,  4765,  4766,
    4767,  3758,  3966,  4729,   937,  1647,  5721,  1131,  4734,  4735,
    5460,  4944,  3533,  3203,   953,     3,     4,  2632,  4258,  3493,
    5085,  1130,  2647,  1266, -1748,  1524,  3493,    41,  1482,  1685,
    5447,  3493,  5449,  5338,  3493,  1267,  1629,  5988,  4139,  3785,
    1646,  3776,  4829,  3777,  1892,  4471,  2855,  3781,  5971,  4030,
    1681,  4139,  4259,  2949,  1410,  4806,  4807,  1132,  2863,  4589,
    5722,  6064,   954,  5723,  1647,  4257,    45,  4260,  1525,  5820,
    5724,  1686,  4425,  6234,  3832, -1748,  5950,  3826,  1687,  2060,
    1298,   761,  1688,  4133,   195,    41,  4311,  4134,  4135,  4136,
    4261,  3732,  4508,  1682,  5086,  4257,  1677,  5917,  5725,  4263,
    2930,    15,  1646,  1526,   962,  2933,  4041,  5339,  1410,  1132,
      49,  1023,   793,  2872,  1532,  4426,   793,   793,  3805,  4262,
   -1701,  4296,   964,    50,    45,  6420,  1647,  6423,  1683,   196,
    6287,  4619,  1102, -1701,  1103,   195,  3959,  3807,    20, -1701,
    5821,   986,  1024,  4258,  4831,  -150,  5912,    51,  5302,  2873,
    4427,  5913,    36,  3806,  4927,  6288,  1998,  1892,  5726,  2000,
    4297,  2002,  4684,  2004,  1410,  2006,    57,  5673,    49,  2010,
     977,  5727,  3808,  4258,   985,  6321,  2052,  4259,  3008,  1013,
     196,    50,  3014,  2929,  5728,  6199,  4927,  3921, -1701,  6464,
    6311,  5674,  4260,  1035,  4140,  4141,  4142,  4143,  4144,  4145,
    4146,  4147,  4148,  3021,  1990,    51,  5914,  4259,  2950,  4685,
    6340,  1029,  6451,  2951,  1990,  4261,  3022,   681,  4263,  2053,
    1097, -1701,  4260,  1912,  3534,  5050,  6463,  3469,  3471,  3472,
    3637,  4167,  3019,  1298,  6433,  6341,  4133,  4174,     3,     4,
   -2992, -2992, -2992,  4229,  4262,  4261,  3023,  1913,  5051,  6041,
    4140,  4141,  4142,  4143,  4144,  4145,  4146,  4147,  4148,  3521,
    3522,  1984,  1689,  4140,  4141,  4142,  4143,  4144,  4145,  4146,
    4147,  4148, -1701,  4878,  4262,  3020,  1649,  6434,  5033,  5673,
    1038,  5683, -1701,   234,  4029,  1985,  2138,  4132,  4074,   667,
    5781,   683,  1047,  2656, -2992,  1722,  1048,   759,  1726,  4160,
    2662,  1690,  5034,  5674, -1700,  1691,  1456,  1457,  3493,  2669,
    1046,  2670,  5303,  4075,  5782,  2673,   847, -1700,  4076,  1456,
    1457,  1090,  2679, -1700, -2413,  1458,  4284,  6425,  4927,  1047,
    1092,  1235,   776,  1048,  4318,  4184,  6203,  6204,  1460,  1445,
    1692,  2681,  1047,  4263, -2421,    33,  1048,  1693,  1410,  1410,
    1410,  1410,  1410,  1410,  1410,  1410,  1410, -2414,  1410,  1106,
    4885,  1107,  1047,  1125,  1235,  1445,  1048,  2681,   871,  1410,
    1004,  1410, -1700,  4263, -1772, -1772,  5882,    41,   871,  4215,
    4139,  5886,  5887,  3607,  6152,    29,   871,  4477,  1410,  1111,
    6153,   959,  1410,  -622,  -473,  1410,  5729,  1410,  3448,  5730,
    1410,  5081,   791,  1150,  1410, -1700,  4656,  5295,   791,  1133,
    3604,  4657,  3608,  3609,   793,  1134,    45,  4237,  4238,  1135,
    5166,  1636, -1121,  1152,   793,  4657,  1653,  3495,  4346,  1445,
    1156,  1474, -1701,   871,   871,  5199,  4231,  1163,  1996,  2069,
    4313,  1838,  1838,  2084,  1410,    57,  3601,  3387,  3388,  3389,
    3390,  1172,  5207,  1410,  1410,  4159, -1700,  4161,  4162,  2642,
      49,  1179,  1838,  4386,   762,  1173, -1700,   871,  1228,  1229,
    1445,  1190,  2681,    50,   694,  3539,   695,  3544,  3636,  6298,
    2655,  5972,  4274,  2656,  2689,  3191,    41,  1838,  2656,  3493,
    3202,  3491,  3204,  3203,  1836,  3203,  3247,    51,  1197,  3248,
    4202,  2682,  3451,  1888,  4955,  1990,  1207,   826,  4605,  3493,
    3456,   793,   681,  2656,   793,   793,   763,   776,   803,  -473,
     803,  3545,   662,  3634,  2656,    45,  3635,  3622,    41,  3715,
    5230,  1234,  3716,  4139,  1410,  1235, -1094,  5235,  5236,  5134,
    3882,  3493,  1239,  3883,  4021,   651,   940,  3203,   970,  1006,
     970,   970,  4073,  1246,   959,  2656,  4945,   871,  4952, -1749,
    3536,  4082,  1243,  4088,  2656, -1749,  2656,    45,  4089,    49,
    3739,  2656,  3577,  1255,  3580,  5868,   826,  4108,  1527,  6353,
    3841,  4543,    50,  5873,  5874,  6286,   683,   839,  2854,  4220,
    1262,  4221,  4140,  4141,  4142,  4143,  4144,  4145,  4146,  4147,
    4148,  3656,   871,  4222,  4930,  4223,    51,  4119,  3667,  4913,
    2656,    49,  4152,  1263,   941,  2656, -1700,   871,  4701,  4166,
    6246,    29,  2656,  1269,    50,    57, -1434,  1261, -1434,  4171,
    3730,  4235,  4172,  6436,  2656,  4403,  6439,  4408,  4404,   871,
    4409,  2748,  6196,   685,  1105,  5642,  5643, -1749,    51,  4322,
    1105,  3829,  4436,  4505,  4592,  4437,  4437,  2829,  4628,  1271,
     871,  4629,  1105,  1282,  4564,  4631,  1528,    57,  4632,  4662,
    1283,  1951,  4663,   826, -2991,  4776,  1284,  1955,  4777,  4927,
    4971,  4349,  4787,  3493,  1272,  4788,  4798,  1966,  1285,  2656,
    4873,  1969,  3151,  4874,  3152,  1972,   959,  1974, -1749,   959,
    1286,  5769,  4879,  1982,  4884,  4880,   793,  3560,   942,  1988,
    5135,  5201,  1991,  3203,  2038,  5242,  1292,  3375,  2656,  1659,
    1529,  5279,    41,  1267,  2656,   871,   871,  5333,  5357,  5847,
    3560,  5358,  5364,  1294,  4445,  3203,  4333,  1456,  1457,  4451,
    3812,  1660,  3815,  3817,  4535, -2992, -2992, -2992,  4143,  4144,
    4145,  4146,  4147,  4148,  5365,  5366,  1150,  3203,  3203,  1421,
    3069,    45,  3493,  3775,  6398,  5483,  4420,  1659,  5484,   694,
    5245,   695,  5246, -2991,  1410,  1410,  1410,  4093,  5520,  4094,
    1410,  4663, -1121,  4616,  5556,  4617,  6120,  5557,   959,  1660,
    1423,  5558,  5152,  1661,  2656,   698,  5578,  1425,  1888,  5579,
   -1701,   959,  5075,  5588,  5076,    49,  1990,  1410,  5594,   959,
    1424,  4602,  5596, -1701,  5716,  4602,  1429,  5717,    50, -1701,
    5736,  1433,  2854,  3203,  5145,  5770, -2991,   871,  5771,  5830,
    6015,  6016,  5831,  3919,  1530,  5836,   803,  1439,  1990, -2991,
    6454,  1661,    51,  4875,  5839, -2991,  1438,  4602,   959,  3930,
    5850, -2991,  5901,  5851,  5802,  5902,  5803, -2991,   943,  3812,
   -2991,  6247,  3359,  5942, -2991,  3362,  2634,  1441, -1701,   959,
    4066,  3952,  4068,  4069,  5969,  1448,  6006,  5851,  5481,  4172,
    6007,  3970,  1445,  2656,  6027,  1662,  6031,  6028,  6032,  1990,
    6062,  2656,  6068,  3248, -2991,  3248, -2991, -1776, -1776,  1531,
    4708, -1701,  6069,  1462,  6072,  3248,  4063,  2656,  1532,  6367,
     959,  6368,   959,  3491,   959,  1491,  6073,  4582,  6074,  2656,
    6102,  6075,  1479,  6103, -1689,  3493,  6168, -2991,  6183,  4602,
    4929,  2656,  4931,  1662,  6185,  4934,  2687,  2656,  1533,  4826,
    1449,  4828,  1534,  3282,  3283,  1464,    36,  2015,  1663,  6039,
    1479,  6198, -1701,  1664,  3203,  4927,  3948,  2748, -1775, -1775,
    3319,  3320, -1701,  1480,  1004,  4319,  4320,  6212,  6236,  2958,
    6213,  6237,  6285,  6318,  1506,  5844,  5851,  1535, -2991,  1507,
    6363,  6383, -2991,  6364,  6384,  1508,  6391,  6392, -2991,  4874,
    2656,  3365,  6419,  1559,  6421,  6028,  1663,  2656,  6162,  6163,
    6429,  1664,  4596,  6430,  1666,   651,   959,  1659,   970,  4694,
     970,   970,  1536,   959,  1511,  1537,  6467,  2958,  6469,  6384,
    1410,  6430,  1517,  1737,  6471,  1410,  4565,  6384,  4567,  1660,
    5288,  1474,  5290,  1836,  3493,  5546,  5547,   934,  2727,  4847,
    2730,  4850,  1585,  5573,  4547,  5574,  1150,  4782,  1150, -2991,
    4548,  2143,  1666,  1668,  2144,   931,   932, -2458,  1588,  1590,
    1591,  1626,  1630,  1631,  4549,  6120,  1538,   650,  1632,  4280,
    2687,  4927,  1643,  1645,  1410,  1410,  1410,  1669,  4955,  1410,
    1655,  1661,  1658,  1680,  4748,   934,  2645,  1410,  1410,  1410,
    1410,  1696,  4550, -2992,  4551,  5550,  1697,  1713,  1671,  4679,
    1723,  1668,  6244,  1410,  3376,  1724,  1410,  1727,  1410,  1733,
    4637,  1732, -1701,  2143,  4441,  1846,  2144,  1848,  4775,  2647,
    1410,  1410,  1850,  1855,  1410,  1669,  1861,  1866,  1869,  5687,
    1150,  1871,  2143,  1876,  1879,  2144,  4457,  1881, -2991,  1873,
    1890,  3493,  1895,  1006,  1896,  1410,  1671,  1410,  2645,  1410,
    4949,  1898,  -137,  4552,  1899, -2992,  1901,  1903,  4946,  5355,
    1904,  1915, -2991,  1922, -2991, -2991,  1924,  2645,  1410,  4814,
    1927,  4219,  1931,  1662, -2992,   871,  5688,   214,  1940,  1945,
    1047,  2647,  4553,  1479,  1048,  1946, -2991,   934,  1947,  1949,
    1952,  4183,  4927,   871,  4225,  4226,  4227,  1953,  1957,  1956,
    2647,  5689,  1964,  1968,  1970,  1971,  1973,  1975,  1980, -2991,
    1981, -2991, -2991,  1993,  1983,  1986,  6216,  1989,  1995,  5179,
    5690,  2143,  1992,   651,  2144,  5691,  3495,  4255,  4909,  2055,
    2012,  4255,  4269,  4255,  4255,  2043,  1663, -2992, -2755,   934,
    1410,  1664, -2992,  2066,  2073,  1410,  2081,  5692,  2074,  2077,
    2082,  5693, -1948,  2682, -1955,  2089,  2645,  2958,  2090,   957,
    1410,  2091,  2092, -2992,  4554,  2093,  5694,    57,   969,  4555,
     188,  4995,  4201,  2095,  3495,  5794,   969,  2096,  4301,   969,
    2097,  4304,  3495, -1945,  3544, -1946,  3697,  3491,  4966,  2647,
    3491,   188,  1666, -2992,  4575,  2099,  4578, -1949,  2100, -2992,
    2101,  2102,  2103,  2104, -2992,  5069, -1947,  2105,  2106,  2107,
    3493,  2108,  2109,  5056,  3721,  2110,  4556,  2111, -2992,  2112,
    5061,  2143,  2114, -2992,  2144,  1410,  2115,   933,  2145,  2146,
    2147,  2620,  2116,  4557,  2117,  6396,  2118, -2755,  3491,  2119,
    2120,  1668,  2121,  2122,  2124,  2125,  3491,  2126,  2127,   959,
     959,  2652,  3383,  2128,  3384, -2992,  2645,  2129,  2130,  2131,
    2618,  4805,  2622,  2646,  2624,  1669,  2625,  2634,  4190,  2636,
    4191,  2637,  5695,  2659, -2992,  2660,  2665,  2667,  2668,  2671,
    3385,  2672,  2674,  2675,  2676,  1410,  1671,  2677,  2678,  2647,
   -2755,  2683,  2690,  1494,  2721,  1496,  4192,  2733,  2735,  2723,
    2736,  2737,  5808, -2755,  2738,  2754,  2755, -2992,  2756, -2755,
    2681,  2758, -2992,  2652,  2757, -2755,  2760,  2759,  2761,  2764,
    3493, -2755,  2762,  2763, -2755,  2765,  3493,  5696, -2755,  2787,
    2793,  2771,  2652,  5829,  2820,  2813,  2817,  4558,  2821,  2823,
    2799,  2824,  4414,  2835,  2839,  3386,  2841,  2840, -2992,  4280,
    2858,  2859,  4703,  2819,  2870,  2874,  2876,  2877, -2755,  2878,
    2879,  3386,   946, -2992,  2880,  2888,   871,  2895,  2894,  3167,
    2890,  2893,  2889,  2904,  2900,  2901,  2922,  3174,  2914,  2928,
    2910,  2911,  2924,  2925,  2938,  2931,  2934,  2945,  2952,  2955,
    2935, -2755,  1604,  2981,  2998,  2982,  5503,  2970,  3007,  2972,
    2974,  3387,  3388,  3389,  3390,  3036,  3029,  2648,  3391,  3392,
   -2992,  2940,  2649,  5196,  3393,  2941,  2953,  3387,  3388,  3389,
    3390,  2652,  3463,  3465,  4193,  2979,  3041,  2960,  3473, -2992,
    4194,  2961,  2966,  2967,  2973,  2650,  2337,  3043,  3044,  2975,
    2987,  2988, -2755,  3045,  3046,  3001, -2755,  3493,  3012,  3050,
    3051,  3052, -2755,  3054, -2992,  3057,  3055,  3056,  3058,  3062,
    3519,  3519,  3063,  2651,  3064,  4041,  2607,  2608,  2609,  2610,
    2611,  2612,  3065,  3072,  3073,  3076,   676,  3081,  3089,  3100,
    3104,  3105,  1677,  3108,  3117,  1410,  3120,  3123,  3124,  3133,
    3144,  1410,  3150,  3154,  3166,  3168,  3137,  3141,  3170,  3169,
    3184,  3159,   959,  3171,  3216,  3227,  2404,  3257,  3241,  3246,
    3276,  3321,  3354, -2755,  2144,  3281, -2992,  3360, -2992,  3401,
    3364,  2652,  3421,   793,  3427,  3442,  3444,  3445,  2607,  2608,
    2609,  2610,  2611,  2612,  2687, -2992,  3459,  1469,  3458,   871,
     871,   871,  3380,  3399,  3460,  3474,  3426,  2607,  2608,  2609,
    2610,  2611,  2612,  3443,  3457,  3496,   871,  3513,  3537,  3461,
     941,  3515,  3530,  3538,  3462,  3466,  3514,  3475,  3549,  3550,
    1410,  3394,   808,  3501,  5464,  3516,  4626,  3569,  3578,  3583,
    3552,  3586,  3591,  3395,  3581,  3011,  3596,  4195,  2015,   871,
     871,  3602,  3597,  3610,   871,  3626,  3599,  5145,  3631,  4196,
    3633,  3647, -2755,  3641,  5267,  3648,   871,  3649,  3655,  3659,
    3672,  3677,  3678,  3704,  3698,  3705,  3711,  2143,  2654,  3706,
    2144,  3714,  3722,  3732, -2992,  3731, -2755,  3729, -2755, -2755,
    3753,  1892,  5253,  3752,  5313,  3813,  2607,  2608,  2609,  2610,
    2611,  2612,  3828,  3836,  3837,  5191,  5192,  5193,  5194,  5195,
   -2755,  3840,  2645,   942,  3849,  3769,  3856,  1244,  3862, -2992,
    3863,  3868,   959,  3895,  3896,  3864,  3873,  3884,  3910,  3912,
   -2755,  3914,  3494, -2755, -2755, -2755,  3219,  4682,  3924,  5375,
    3916,  3943,   957,  3945,  3937,  2647,  3931,   871,  3942,  3944,
    4622,   969,  3946,  3950,  3953,  3955,  3957,   793,   969,  3958,
    3961,   969,  3962,   871,  3967,   793,  3982,  3983,   793,  3984,
    3992,  3993,  3994,  3996,  5320,  4812,  5871,  3998,  4012,  4014,
     793,  4015,  1410,  4018,  2603,  4020,  4659,  4038,  4023,  1562,
    4024,  1410,  4025,  2604,  2605,  2606,  2607,  2608,  2609,  2610,
    2611,  2612,  4028,  4026,  4027,  1410,  1990,  1987,  5437,  1410,
    1410,  1410,  1954,  4033,  4032,  4042,  1410,  4808,  3090,  1410,
    4044,  4057,  1410,  4051,  4059,  1563,  3107,  4067,  1410,  4087,
    1410,  4043,  1241,  1410,  3011,  4103,  4090,  4107,  1410,  1410,
    1410,  1410,  4105,  4084,  1410,  1410,  1410,  1410,  1410,  1410,
    1410,  1410,  1410,  1410,  4085,  4086,  4098,  1410,  1410,  1410,
    4115,  4109,  3298, -2992,  4120,  4118,  3841,  1410, -2992,  4121,
    4125,  4127,  1410,  4128,  4129,   934,  1410,  2656,  4151,  3165,
   -2239,  4156,  4157,  4164,  1410,  4165,  4168,  1410,  1564,  1410,
    4179,  4185,  4209,  4210,  4216,  4180,  4212,  4199,  2143,   188,
    4214,  2144,  4233,  4234,  4239,  1410,  3011,  4241,  1410,  1410,
    4247,  4276,  4289,  1410,  1410,  4291,  4293,  4295,  1410, -2992,
    1410,  4818,  5317,  4272,  4240,  1565,  5107,  5108,  2098,   871,
     871,   871,  4302,  2645,  4310,  4280,  4242,  4316,  4282,  4248,
   -2992,  4321,  4819,  4820,  4821,  4822,  1410,  4255,  4269,  4255,
    4255,   192,  1410,  4255,  4324,  1087,  4840,  1084,  4323,  4328,
    3495,  4256,  4330,  4280,  3495,  1085,  2647,  4342,  4353,  4343,
    4855,  4354,  4355,  4361,  4359,  1566,  4367,  2652,  4365,  4370,
    4366,  4371,  1086,  6278,  6279,  4373,  4388,  6281,  4389,  4391,
    4377,  4397,   188,   933,  4398,  4399,  4407,  1410,  4415,  4424,
    4438,  4440,  4442,  1562,  4444,  4446,  4448,  4453,  4452,  4458,
    4456,  4459,  3544,  4463,  1410,  1567,  4460,  4485,  4461,  1568,
    4478,  4479,  4480,  4481,  3491,  4482,  1088,   793,  3491,  4483,
    4484,  4488,  4486,  4490,  4492,  4494,  4499,  4487,  4809,  1563,
    4489,  4497,  4501,  4491,  2996,  4493,  4503,  5572,  2999,  4513,
    4517,  1569,  1570,  4520,  5448,  4052,  5503,   793,  4504,  4510,
    1532,  5415,  5416,  4514,  5418,  4525,  4515,  4533,  4531,  4928,
    2015,  2854,  2015,  4568, -2992,  2015,  4573,  4936,  4580,  4583,
    5611,   957,  4574,  4584, -2992,  4587,  4591,   969,  4601, -2992,
    4602,   969,  4604,   969,  1571,  4960,  4611,  4620,    36,  4614,
    4621,  4625,  1564,  1572,  4624,  4627,  4641,  4655,  4658,  4661,
    4665,  3446,  1573,  4667,  4673,  4674,  4695,  4696,  4675,  4676,
    4677,  1574,  4697,  4678,  4704,  4705,  4706,  4707,  4709,  1575,
    4710,  4717,  4711,  3491,  4712,  4713,  2084,  4721,  4722,  1565,
   -2992,  4727,  1576,  4698,  4724,  4680,  4731,  4723,  4728,  4742,
    5009,  1577,  4280,  4736,  3494,  4737,  1578,  1926,  4133,  1928,
    1929,  4749, -2238,  4789,  4772,   946,  4773,   188,  4800,  4843,
    4774,  4801,  4781,  4844,  2959,  4804,  4851,  4815,  4852,  4857,
   -2992,  4830,  4858,  2143,  4827,  4836,  2144,  4867,  4839,  1566,
    4841,  4870,  2607,  2608,  2609,  2610,  2611,  2612,  2652,  4856,
    4859,  4872,  4861,  4876,  4887,  5053,  5012,  4895,  4905,  4908,
    4906,  4907,  1659,  1579,  4915,  4918,  4916,  3775,  2645,  4919,
    4922,  4937,  4940,  3645,  4941, -2992,  4958,  4973,  4961,  1567,
    4974,  4975,  4976,  1568,  1660,  4977,  4987,  4989,   959,  4988,
    4990,  4991,  4992,  5001,  5003,  5010,  5021,  5004,  5022,  5027,
    5030,  2647,   959,  5046,  1410,  5895,  5047,  5897,  5049,  4947,
    4937,   871,  5063,  5052,  5065,  1633,  1570,  5097,  5352,  4236,
    5066,  5686,  5067,  5089,  1532,  5062,  5104,  5118,  2854,  5078,
    5099,  5124,  5110,  5125,  5137,  5147,  1661,  4947,  5130,  5154,
    5131,  5153,  5164,   871,  2790, -2992,  5170,  5171,  3495,  3930,
    5173,  5175,  5174,  5177,  5178,  5197,  3812,  5183,  1634,  3228,
    5204,  5205,    36,  5189,  5214,  5146,  5221,  1572,  5223,  4285,
    4285,  5222,  5224,  5276,  5226,   871,  1573,  5227,  5225,  5228,
    5587,  5233,  5234,  4948,  5239,  1574,  5244,  1410,  1410,  5250,
    5256,  5587,  5259,  1635,  5261,  5265,  6020,  5906,  1410,  5260,
    5278, -2240,  5282,  5291,  5306,  4949,  1576,  5296,  5292,  2015,
     871,  5299,  3491,  3491,  5315,  1577,  5318,  5319,  5336, -2992,
    1578,  5408,  5332,  5733, -2992,  5334,  5329,   871,  1662,  5340,
    5359,  5360,  5374,  5310,  5372,  5373,  1004,  5376,  5378,  5383,
    5384,  6050,  5385,  5404,  5406,  5397,  5400,  5410,  5411,  5419,
    5420, -2992,  5428,  5429,  5434,  5427,  5438,  5441,  5445,  5446,
    5453,  5456,  5156,  2607,  2608,  2609,  2610,  2611,  2612,  1410,
    5637,  5461,  5465,  5462,  5463, -2992,  5471,  1579,  5469,  5485,
    5480,  5475,  5487,  5492,  5491,  1410,  5496,  6086,  6088,  5494,
    5498,  1663,  5509,   188,  5515,  5499,  1664,  5500,  5517,  5524,
    5551,  5525,  5530,  1410,  3203,  5544,  5656,  5561,  5545,  5555,
    5562,  5563,  2958,  5571,  5575,  5580,  4950,  5586,  5466,  5612,
    5590,  5593,  5810,  5615,  5618,  5626,  5629,  5633,  5641,  5908,
    5645,  1410,  5628,  2652,  1410,  5646,  5815,  5647,  5648,  5653,
    5679,  5701,  1410,  1410,  5659,  5660,  5088,  1666,  5664,  1410,
    1410,  5720,  5670,  5671,  1410,  5672,  5712,  5709,  5838,  1410,
    5715,  5707,  1410,  1410,  5719,  2137,  5739,  5744,  5740,  1410,
    5749,  5767,  5751,   871,   871,   871,   871,  5780,  3494,  5778,
    2085,  3494,  5772,  5779,  5786,  5796,  5795,  5813,  5800,  5801,
     651,  5814,  5822,  4255,  5846,  5828,  1668,  3495,  5840,  5842,
    2094,  5844,  3495,  5858,  5845,  3495,   651,  5848,  3812,  5867,
    5312,  5865,  5869,  1410,  5875,  1006,  6079,  5877,  2143,  5889,
    1669,  2144,  5883,  5921,  1410, -2992, -2992, -2992,  4301,  3494,
   -2992,  5923,  1410,  5926,  3544,  5890,  5891,  3494,  5930,  5934,
    5936,  1671,  5944,  4951,  5949,  5958,  4373,  5962,  5963,   803,
    5964,  5965,  5966,  2645,  3491,  5975,  5976,  5977,  6215,  2135,
    2646,  3491,  5978,  5983,  5993,  5987,  3491,  5985,  6003,  3491,
    6008,  5837,  6018,  6004,  6017,  3995,  2854,  1410,  6019,  5231,
    4001,  6024,  4002,  5992,  6034,  6043,  2647,  4217,  6046,  6044,
    6048,  5368,  4008,  6047,  6061,  4009,  6091,  4010,  4011,  6065,
    6084,  4013,  6094,  5335,  6097,  4016,  6099,  4017,  3546,  6092,
    4019,  6105,  6108,  6101,  5321,  5323,  6109,  6125,  6126,  6026,
    6128,  6135,  6136,  6142,  6127,  6141,  3562,  6143,  6148,  6149,
    3565,  6155,  6150,  6167,  3568,  6160, -2992,  6171,  6273,  6274,
    6164,  6165,  6179,  6181,  3775,   793,  6187,  6200,  2607,  2608,
    2609,  2610,  2611,  2612,  6207,  3775,  6209,  1410,  2880,  3587,
    5899,  6095,  6225,  6226,  1410,  6217,  6227,  6096,  4579,   946,
     946,  6245,   946,  6264,  6265,  6268,  6243,  6262,  4061,  6263,
    6280,  6266,  6276,  6289,  5651,  6284,   959,  6290,  6291,  5686,
    6302,  6304,  6322,  3629,  6334,  6336,  6328,  6337,  6332,  6329,
    6333,   959,  6346,  6351,  2648,  6033,  6349,  6035,  6369,  2649,
    6370,  1105,  6372,  6374,  6373,  6371,  6399, -2002,  6401,  6402,
    6389,  6410,  6414,  4308,  6294,  6427,  6435,  6428,  6416,  6443,
    6444,  6447,  1410,  6449,  6453,  6455,  6460,  6458,  6466,  5894,
    5774,  1481,  3013,  4054,  1589,  2062,  3786,  3703,   651,  3688,
    4383,  4964,  4957,  1150,  6210,  2854,  3827,  3875,  4530,  5698,
    2651,  6078,  6303,  5106,  2015,  5750,  4953,  4954,  5444,  5732,
    4363,  4326,  4022,  6202,  5635,  6299,  3717,  6100,  6098,  3930,
    6224,  6314,  3726,  4369,  5473,  5128,  6055,  5157,  5136,  5098,
    6058,  3893,   959,  3894,  3952,  4962,  3736,  4590,  4401,  5123,
    5738,  4630,  5467,  1105,  1679,  5181,  3749,  5979,  6366,  6465,
    6445,  5713,  3754,  4536,  5165,  6229,  5658,  5885,  2652,  3080,
     871,  6067,  5661,   757,  6079,   810,  5198,  5861,   793,  1080,
    4681,   871,  3767,  5200,  1004,  6362,  3922,  3143,  3770,  3555,
    5167,  2035,  4317,  3491,  3139,  3778,  3155,  5775,  4647,  5973,
    1191,  3172,  1151,  4500,  4993,  3824,  4447,  6249,  4280,  3793,
    6400,  1426,  2770,  3852,  5184,  3038,  3500,  5185,  5324,  6352,
    1004,  4881,  5857,  3819,  5860,   852,  2657,   653,   853,  5478,
    6052,  5229,  2718,  5657,  1105,  1410,  2630,  6184,  4278,  2717,
    4290,  3510,  6036,  4833,  2722,  1410,  2714,  4251,  1410,  4849,
    5592,  1410,  1410,  1410,  5827,  4244,  5826,  4245,  4882,  6387,
    5655,   957,  6170,  6282,   957,  2654,  6025,  4246,  6413,  5809,
    4783,  6037,  4213,   922,   969,   969,  1410,  1410,  2666,  3422,
    1410,  3425,  6038,  3340,  4207,  3851,  4079,  5991,  4205,   969,
    6418,  4114,   969,  4198,  4732,  3437,  1410,     0,  1477,     0,
    1410,     0,  3498,     0,     0,  5700,  1410,     0,     0,     0,
    3495,     0,     0,     0,  5312,     0,     0,  1410,     0,  5610,
       0,     0,  1150,     0,     0,     0,     0,     0,     0,     0,
    4928,     0,     0,  1410,     0,     0,     0,     0,     0,     0,
       0,     0,   969,     0,     0,     0,   969,   969,     0,     0,
       0,     0,     0,     0,     0,  4329,     0,     0,     0,     0,
       0,     0,  4928,  1006,   959,     0,   959,     0,     0,     0,
       0,  2603,     0,     0,  3491,  5613,     0,     0,     0,     0,
   -2992, -2992, -2992,  2607,  2608,  2609,  2610,  2611,  2612,     0,
       0,  6431,     0,     0,  3491,     0,     0,     0,   970,  1006,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   653,
       0,     0,     0,     0,     0,     0,  3491,     0,   653,   979,
       0,     0,     0,     0,     0,  4390,   653,  4392,   979,   653,
       0,     0,     0,   970,     0,     0,     0,     0,     0,  4037,
       0,     0,   979,     0,     0,  5097,     0,     0,     0,     0,
     871,     0,     0,     0,     0,   871,     0,     0,     0,     0,
       0,     0,  4056,  5765,  2854,     0,     0,     0,  2143,  4037,
       0,  2144,     0,     0,   871,  2145,  2146,  2147,  5146,     0,
       0,  5752,  5894,     0,     0,  6446,     0,     0,     0,     0,
       0,     0,   959,   871,  4928,     0,     0,     0,  6408,     0,
       0,     0,     0,  2645,     0,     0,     0,  6354,     0,     0,
    2646,   793,    81,    84,    72,   176,   188,   192,    85,     0,
      86,   185,     0,   181,    87,   107,   125,     0,  1410,     0,
     130,   182,   160,     0,     0,   179,  2647,     0,     0,   793,
       0,     0,   186,     0,     0,  1410,     0,  5737,   184,  1410,
       0,  1410,     0,   793,     0,   934,  6390,  6408,  3491,  6355,
    6356,     0,     0,     0,   793,  1410,     0,     0,     0,     0,
       0,  4495,     0,   651,     0,     0,  1410,  4502,  5763,     0,
    5835,     0,  6408,  1592,     0,     0,   188,  1410,     0,  1593,
       0,     0,   187,     0,  1410,  3494,     0,     0,     0,  3494,
       0,     0,     0,     0,  1698,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3299,
    1150,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1595,   871,     0,  3491,     0,     0,
    1228,  1229,  1410,  3352,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2648,     0,     0,     0,  1410,  2649,
       0,     0,     0,     0,  1410,  1410,     0,     0,     0,   959,
     959,   959,   959,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2992, -2992,  1004,     0,     0,     0,     0,  1699,
    1592,  1596,     0,     0,     0,     0,  1593,     0,  1597,     0,
    1410,     0,  1598,     0,  3494,     0,     0,     0,   651,     0,
    2651,  1698,     0,   907,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   793,     0,
    1599,     0,     0,   871,     0,     0,  3495,     0,     0,     0,
       0,  1595,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -2992,     0,     0,     0,     0,     0,     0,
       0,   871,     0,  4664,     0,  4666,  1600,  4668,  2652,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   793,     0,     0,     0,     0,     0,     0,     0,  1410,
       0,     0,     0,     0,     0,     0,  1699,     0,  1596,     0,
    3491,  1410,     0,     0,     0,  1597,     0,     0,  4331,  1598,
    1410,  1410,  1410,     0,     0,     0,  2015,     0,     0,     0,
       0,     0,  3812,     0,     0,  1410,  5952,     0,     0,     0,
       0,     0,     0,     0,  1410,  3381,  1410,  1599,  1410,  5610,
       0,     0,  3307,  3307,     0,  4928,  1700,     0, -2757,     0,
    1602,     0,  1410,     0,     0,     0,     0,  3334,     0,     0,
    1603,  2015,     0,  1006,     0,  2654,  3355,     0,     0,     0,
    1604,  1410,     0,  1600,   979,     0,     0,     0,     0,     0,
       0,     0,  1605,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   979,     0,     0,     0,     0,     0,   979,
       0,     0,     0,     0,     0,     0,     0,  2015,  2015,  3491,
       0,   979,     0,     0,     0,     0,     0,  4416,  6206,     0,
       0,     0,     0,     0,     0,  1701,     0,   979,  1607,  1608,
    6040,     0,   653,  3494,  3494,     0,     0,   922,   959,     0,
       0,   653,   979,     0,     0,     0,     0, -2757,   653,     0,
     979,   653,  6121,  1700,     0,     0,     0,  1602,     0,     0,
    1702,     0,     0,   922,   979,     0,     0,  1603,     0,     0,
       0,  2603,     0,     0,   979,     0,     0,  1604,     0,     0,
    2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  1605,
       0,  6256,  6257,     0,   650,     0,     0,     0,     0,     0,
   -2757,     0,     0,  1410,     0,     0,     0,     0,     0,     0,
       0,     0,     0, -2757,     0,     0,  3491,     0,  1410, -2757,
       0,     0,  5835,     0,     0, -2757,   979,     0,  1410,     0,
       0, -2757,  3783,  1610, -2757,  1607,  1608,  3544, -2757,     0,
       0,   793,   979,     0,     0,     0,     0,   793,  4511,     0,
       0,     0,   793,     0,     0,     0,   970,     0,     0,     0,
       0,     0,     0,   653,   653,     0,     0,  3784, -2757,     0,
       0,   959,     0,     0,     0,     0,     0,     0,  2015,  5394,
    5395,     0,     0,     0,  5398,  5399,     0,   979,     0,   653,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2757,     0,     0,  2854,     0,     0,     0,     0,     0,
       0,  1410,   957,   922,     0,   969,     0,   969,   969,     0,
       0,  4928,     0,     0,     0,     0,     0,     0,     0,   970,
     970,  6259,     0,     0,     0,  1410,   653,     0,     0,     0,
    1610,   192,     0,     0,     0,     0,     0,  6251,     0,   979,
       0,     0, -2757,     0,     0,  6252, -2757,     0,  2015,  2015,
    6275,     0, -2757,     0,     0,     0,  1410,  1410,     0,  3381,
    1410,     0,  6253,  6283,     0,  3494,     0,     0,     0,     0,
       0,     0,  3494,     0,     0,  3491,     0,  3494,     0,     0,
    3494,  6230,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   959,  6327,  3483,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6254,     0,     0,     0,
       0,     0,     0, -2757,     0,     0,     0,  3011,     0,     0,
       0,  6121,   959,   959,     0,     0,     0,  4928,     0,     0,
       0,     0,     0,     0,     0,     0,  4683,     0,   188,     0,
    4687,     0,     0,     0,   192,   651,     0,   653,   653,  1832,
    6251,     0,  1410,     0,     0,     0,   979,     0,  6252,     0,
    6345,   653,     0,     0,     0,     0,   922,   653,  1410,     0,
       0,   653,   808,   653,  3544,  6253,     0,   922,     0,  4301,
       0,     0,     0,     0,     0,  3491,  1410,     0,     0,  6456,
    6457,  3491,     0,   922,     0,     0,     0,     0,     0,     0,
       0,     0, -2757,     0,     0,     0,     0,     0, -2774,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6254,
       0,     0,  6375,  6376,   651,  6380, -2757,     0, -2757, -2757,
    5835,     0,     0,     0,     0,  1410,     0,   653,     0,   653,
     653,     0,     0,     0,     0,   959,     0,     0,  4928,     0,
   -2757,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   192,     0,     0,  6345,     0,
   -2757,  6251,     0, -2757, -2757, -2757,     0,  1162,     0,  6252,
     979,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1410,   651,     0,  6253,     0,     0,     0,
       0,     0,     0,  1162,     0,     0,   650, -2774,   653,     0,
     651,     0,  3491,     0,     0,     0,     0,     0,     0,  5188,
       0,     0,  5190,     0,     0,     0,     0,   970,   970,     0,
    3512,  6459,     0,  6345,     0,     0,     0,     0,     0,     0,
    6254,   979,     0,     0,     0,     0,     0,     0,     0,     0,
    6345,     0,  5206,     0,  3494,     0,   979,     0,     0,     0,
   -2774,     0,     0,     0,     0,     0,   979,   979,     0,     0,
     922,  1592,   979, -2774,   793,     0,     0,  1593,     0, -2774,
       0,     0,     0,     0,     0, -2774,     0,     0,   979,     0,
       0, -2774,  1594,   979, -2774,     0,     0,     0, -2774,     0,
       0,     0,     0,     0,     0,   653,     0,  2143,     0,     0,
    2144,     0,     0,     0,  2145,  2146,  2147,     0,     0,     0,
       0,     0,  1595,     0,     0,     0,     0,     0, -2774,     0,
       0,     0,  2644,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2645,     0,  4910,     0,     0,   653,     0,  2646,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0, -2774,   957,     0,     0,   969,     0,   969,   969,     0,
       0,     0,     0,     0,     0,  2647,   653,   653,   653,  1596,
     653,     0,     0,     0,     0,     0,  1597,     0,     0,     0,
    1598,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   653,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0, -2774,     0,     0,     0, -2774,     0,  1599,     0,
       0,     0, -2774,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   188,  3494,     0,     0,   720,     0,
       0,     0,     0,  3261,     0,     0,   653,     0,     0,     0,
       0,     0,     0,  5343,  1600,  3494,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1832,     0,     0,     0,     0,
       0,     0,     0, -2774,     0,  5035,     0,  3494,  5038,     0,
       0,     0,   653,  2648,   723,  3262,   653,   653,  2649,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5381,
    5382,   724,   653,     0,     0,     0,  1853,     0,   922,     0,
       0,  2650,  2337,     0,     0,     0,     0,  1862,     0,  1064,
       0,     0,  2143,     0,  1601,  2144,     0,     0,  1602,  2145,
    2146,  2147,   808,  1870,     0,     0,     0,     0,  1603,  2651,
       0,     0,     0,  3263,     0,     0,     0,  2644,  1604,     0,
       0,     0,     0,     0,     0,     0,   727,  2645,     0,     0,
    1605,     0, -2774,     0,  2646,   728,     0,   793,     0,     0,
     650,     0,     0,   650,     0,     0,   922,     0,   729,  5120,
       0,     0,  2404,     0,  3264,     0, -2774,     0, -2774, -2774,
    2647,     0,     0,  5425,  5426,     0,  3011,  2652,     0,     0,
    2653,     0,     0,  1606,     0,     0,  1607,  1608,     0,     0,
   -2774,  1067,     0,     0,     0,     0,     0,   922,     0,  3494,
       0,   650,     0,     0,     0,     0,     0,     0,     0,   650,
   -2774,     0,  2135, -2774, -2774, -2774,     0,     0,  1609,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3265,
     922,     0,     0,     0,     0,     0,     0,  2143,     0,     0,
    2144,     0,     0,     0,  2145,  2146,  2147,     0,     0,     0,
       0,   733,     0,     0,     0,     0,     0,  4037,     0,     0,
    2135,     0,  2644,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2645,     0,  2654,     0,     0,     0,  3494,  2646,
       0,     0,     0,     0,  3381,     0,     0,     0,  2648,     0,
    2064,  1610,     0,  2649,   979,     0,     0,     0,     0,     0,
    4211,     0,     0,  5519,     0,  2647,  5521,  5522,     0,   653,
     653,   653,     0,     0,     0,     0,  2650,  2337,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5527,     0,     0,
       0,     0,   214,  3266,     0,     0,   738,     0,     0,     0,
       0,     0,     0,     0,  2651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  6076,     0,     0,     0,  4243,
       0,     0,  4249,     0,  1071,  1592,     0,  3267,     0,     0,
       0,  1593,     0,     0,   742,     0,     0,     0,     0,     0,
    2603,   743,     0,     0,   744,     0,     0,  2404,     0,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,
       0,     0,  2652,     0,   745,  2653,  4106,     0,     0,   979,
    3483,     0,  1073,     0,   933,     0,  1595,     0,  3483,   747,
       0,   922,  1074,  2648,     0,     0,     0,   749,  2649,     0,
    3334,  3334,   922,     0,     0,  3334,     0,     0,     0,     0,
       0,  3494,  3268,     0,  1832,     0,     0,     0,   922,     0,
       0,  2650,  2337,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   979,     0,   754,
       0,     0,     0,  1596,     0,   979,  3334,  3334,     0,  2651,
    1597,     0,     0,   979,  1598,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1562,     0,     0,     0,  2654,
       0,     0,   922,     0,     0,     0,     0,     0,     0,     0,
       0,   653,  1599,     0,   653,     0,     0,   922,     0,     0,
     922,   922,  2404,     0,   653,   653,     0,   979,   979,     0,
       0,  1563,     0,     0,     0,     0,     0,  2652,     0,   653,
    2653,   979,   653,     0,     0,     0,     0,  5391,  1600,     0,
    3494,   922,   922,     0,   979,   979,     0,     0,     0,  5401,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,     0,  1564,     0,   653,   653,     0,     0,
       0,     0,     0,     0,     0,  2603,     0,     0,     0,     0,
       0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,  2609,
    2610,  2611,  2612,     0,     0,     0,     0,  4122,  1700,     0,
    4123,  1565,  1602,     0,  2654,     0,     0,     0,     0,  3972,
       0,     0,  1603,     0,     0,     0,     0,  2903,     0,     0,
       0,     0,  1604,   653,     0,   653,     0,  3494,     0,     0,
     653,   653,     0,  1562,  1605,     0,     0,   653,   653,   653,
     653,   653,   653,   653,   653,   653,   653,   653,   653,   653,
       0,  1566,     0,   653,     0,   653,     0,   653,   653,   653,
     653,   653,   653,     0,     0,   653,     0,   653,   653,  1563,
       0,   653,     0,     0,     0,     0,     0,  1728,     0,     0,
    1607,  1608,     0,     0,     0,   922,   653,   653,   653,     0,
       0,  1592,     0,     0,     0,  1568,     0,  1593,     0,     0,
       0,     0,     0,     0,   653,     0,  1832,     0,     0,     0,
    2603,     0,  1729,     0,     0,     0,     0,  5863,     0,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  1570,     0,
       0,     0,  1564,     0,     0,  4124,  1532,     0,     0,     0,
       0,   719,  1595,     0,     0,  2143,     0,  4037,  2144,     0,
     807,     0,  2145,  2146,  2147,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1565,
    2644,  5900,     0,     0,    36,     0,  2831,     0,     0,  1572,
    2645,     0,     0,     0,     0,  1610,     0,  2646,  1573,     0,
       0,     0,     0,     0,     0,     0,  3494,  1574,     0,  1596,
       0,     0,  6406,     0,     0,  2832,  1597,     0,   188,     0,
    1598,     0,     0,  2647,  3973,     0,     0,     0,  1576,  1566,
       0,     0,     0,     0,     0,     0,     0,  1577,     0,     0,
       0,     0,  1578,     0,     0,     0,     0,     0,  1599,     0,
    2143,  3042,     0,  2144,   188,     0,     0,  2145,  2146,  2147,
       0,   653,  3053,     0,     0,     0,     0,     0,     0,     0,
       0,  6406,     0,  1568,     0,  2644,     0,     0,  3071,     0,
       0,     0,     0,     0,  1600,  2645,  4037,     0,  4037,     0,
       0,     0,  2646,     0,  5990,     0,  6406,     0,     0,  1579,
       0,     0,     0,     0,     0,     0,  1570,   650,     0,     0,
       0,   650,     0,     0,  1532,   653,  3494,     0,  2647,     0,
       0,     0,  3494,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3145,     0,     0,     0,     0,     0,     0,     0,
       0,  2648,     0,     0,     0,     0,  2649,  3157,     0,     0,
    1162,  3161,    36,     0,     0,     0,     0,  3974,     0,     0,
       0,     0,     0,     0,  1700,     0,  1573,     0,  1602,  2650,
    2337,   653,     0,     0,     0,  1574,     0,     0,  1603,     0,
       0,  3180,  1162,  2832,     0,     0,     0,     0,  1604,     0,
       0,     0,     0,     0,     0,     0,  1576,  2651,     0,     0,
    1605,     0,     0,     0,     0,  1577,     0,     0,     0,     0,
    1578,     0,     0,     0,     0,     0,   650,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3975,     0,     0,     0,     0,  2648,     0,     0,     0,
    2404,  2649,     0,  3494,     0,     0,  1607,  1608,     0,     0,
       0,     0,     0,     0,     0,  2652,     0,     0,  2653,     0,
       0,     0,     0,     0,  2650,  2337,     0,  1579,     0,     0,
    2135,  3976,     0,     0,     0,     0,     0,     0,  1609,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2651,     0,   188,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3483,     0,     0,     0,
    3483,     0,     0,     0,     0,     0,     0,     0,     0,  2143,
       0,     0,  2144,     0,     0,  2404,  2145,  2146,  2147,     0,
       0,     0,     0,     0,     0,  3367,     0,     0,     0,     0,
    2652,  1610,  2654,  2653,  2644,   653,   653,   653,   653,   653,
     653,   653,   653,   653,  2645,   653,     0,     0,     0,     0,
       0,  2646,     0,     0,     0,     0,   653,     0,   653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3307,     0,     0,   653,     0,  2647,     0,   653,
       0,     0,   653,     0,   653,     0,     0,   653,     0,     0,
       0,   653,     0,     0,  3334,  3334,  3334,  3334,     0,     0,
    3334,  3334,  3334,  3334,  3334,  3334,  3334,  3334,  3334,  3334,
       0,     0,  1832,     0,   653,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   650,   650,  2654,  4779,     0,
       0,   653,     0,     0,     0,     0,     0,     0,  2603,     0,
     653,   653,     0,     0,     0,     0,     0,  2604,  2605,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,     0,     0,     0,     0,
       0,     0,     0,  4175,  3334,  3334,     0,   979,     0,     0,
       0,     0,     0,     0,   922,     0,  6297,     0,   922,   922,
       0,     0,     0,     0,     0,   979,     0,     0,     0,   979,
       0,     0,     0,   979,     0,  2648,     0,     0,     0,     0,
    2649,     0,     0,   979,     0,     0,     0,     0,  4838,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   979,     0,
       0,   653,     0,  2650,  2337,     0,     0,     0,     0,     0,
       0,     0,   653,  2603,   922,   653,     0,   653,   653,     0,
     922,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,  2651,   979,  1592,  3972,  3363,     0,     0,     0,  1593,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     979,   979,     0,     0,     0,     0,     0,     0,  1562,     0,
    1081,     0,     0,     0,     0,   922,     0,     0,     0,     0,
       0,     0,     0,     0,  2404,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1595,     0,     0,  1832,   979,  2652,
       0,  1832,  2653,     0,  1563,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1149,   719,     0,     0,  3483,   979,     0,  1832,     0,     0,
       0,   979,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   979,     0,     0,     0,     0,
     188,  1596,   979,     0,     0,   979,     0,   650,  1597,     0,
       0,   979,  1598,     0,   650,     0,     0,  1564,     0,   650,
       0,     0,   650,  5308,     0,     0,     0,     0,     0,     0,
       0,   979,     0,     0,     0,     0,     0,   979,     0,     0,
    1599,     0,     0,     0,   979,     0,  2654,     0,     0,     0,
       0,     0,     0,     0,  1565,     0,     0,     0,   979,     0,
       0,     0,     0,     0,     0,     0,  1248,  1251,     0,  1149,
    1254,     0,   979,     0,     0,     0,  1600,  1832,     0,     0,
       0,  1268,     0,   979,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3973,
    1289,   653,   653,   653,  1566,     0,     0,   653,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4037,  1592,     0,     0,     0,     0,     0,  1593,     0,     0,
       0,     0,     0,     0,   653,   922,     0,     0,     0,     0,
       0,     0,     0,  1832,     0,     0,     0,     0,  1568,     0,
    3334,     0,  2603,     0,     0,     0,  1700,     0,     0,     0,
    1602,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
    1603,     0,  1595,     0,  4116,     0,   653,     0,     0,  2143,
    1604,  1570,  2144,     0,     0,     0,  2145,  2146,  2147,  1532,
       0,     0,  1605,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2644,     0,     0,     0,   922,     0,
       0,     0,   922,     0,  2645,     0,     0,     0,     0,     0,
       0,  2646,     0,  3483,     0,     0,     0,    36,  3483,  1596,
       0,  3483,  1572,     0,     0,  2814,  1597,     0,  1607,  1608,
    1598,  1573,     0,     0,     0,     0,     0,  2647,     0,     0,
    1574,     0,   188,   188,     0,     0,     0,     0,  2832,     0,
       0,     0,     0,     0,     0,  5450,     0,     0,  1599,     0,
    2815,  1576,     0,     0,     0,     0,     0,     0,     0,     0,
    1577,     0,     0,     0,     0,  1578,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   650,     0,   979,     0,
    1832,     0,     0,     0,  1600,     0,  3975,     0,     0,  1149,
       0,     0,     0,     0,     0,     0,     0,   979,     0,   922,
       0,   979,     0,     0,  3603,     0,     0,     0,   979,     0,
    3611,     0,   653,     0,   922,   653,     0,   653,   653,   922,
       0,     0,  1579,  1610,     0,     0,  3976,   653,     0,     0,
       0,     0,   653,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2648,     0,     0,     0,   922,
    2649,     0,     0,     0,     0,  3653,     0,     0,     0,     0,
    5258,     0,     0,     0,  1601,     0,     0,     0,  1602,     0,
       0,  1592,     0,  2650,  2337,     0,     0,  1593,  1603,     0,
       0,   653,   653,   653,  1659,     0,   653,     0,  1604,     0,
       0,     0,     0,     0,   653,   653,   653,   653,     0,     0,
    1605,  2651,     0,     0,     0,  1832,  1660,     0,     0,     0,
     653,  1832,     0,   653,     0,   653,     0,     0,     0,     0,
       0,     0,  1595,     0,     0,     0,     0,   653,   653,     0,
       0,   653,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2896,  2404,     0,  1607,  1608,     0,     0,
       0,     0,   653,     0,   653,     0,   653,   650,  1661,  2652,
       0,     0,  2653,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   653,     0,   650,  2897,  1596,
    2040,     0,     0,     0,     0,     0,  1597,     0,     0,  1149,
    1598,     0,     0,     0,     0,  2050,  2051,   188,     0,  1149,
    1149,     0,     0,     0,     0,     0,     0,     0,     0,   650,
       0,     0,     0,     0,     0,     0,     0,     0,  1599,     0,
       0,     0,     0,     0,     0,     0,  1149,     0,     0,     0,
     653,     0,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   969,     0,   653,     0,     0,
    1662,  1610,   653,     0,  1600,     0,  2654,     0,     0,     0,
       0,     0,     0,     0,     0,  3880,     0,   653,     0,     0,
       0,     0,  1592,     0,     0,     0,     0,     0,  1593,     0,
       0,   653,     0,     0,     0,     0,     0,     0,     0,   653,
     969,  1592,     0,     0,     0,     0,     0,  1593,     0,     0,
       0,   922,     0,     0,   922,     0,   922,     0,     0,     0,
       0,   922,     0,  1663,     0,  2139,     0,     0,  1664,     0,
       0,     0,     0,  1595,  2141,     0,   979,   979,     0,     0,
       0,     0,   653,     0,  1665,     0,     0,     0,  1602,     0,
    2628,     0,  1595,     0,     0,     0,     0,   979,  1603,     0,
     979,   650,     0,   922,     0,     0,     0,     0,  1604,     0,
       0,   922,  2603,     0,     0,     0,  3483,     0,     0,  1666,
    1605,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
    1596,     0,     0,     0,  4532,     0,   922,  1597,     0,     0,
       0,  1598,   653,     0,     0,     0,     0,     0,     0,  1596,
       0,     0,     0,     0,     0,     0,  1597,     0,     0,     0,
    1598,     0,     0,  1667,     0,     0,  1607,  1608,  1668,  1599,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     650,  1832,  1832,  1832,     0,     0,     0,     0,  1599,     0,
       0,     0,  1669,     0,     0,     0,     0,     0,  1670,  4055,
       0,     0,     0,     0,     0,  1600,   979,     0,     0,     0,
       0,     0,     0,  1671,  4065,   922,     0,   922,     0,  4070,
       0,     0,     0,     0,  1600,   979,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   979,     0,  4096,
       0,     0,     0,     0,     0,     0,  2143,     0,     0,  2144,
       0,     0,     0,  2145,  2146,  2147,     0,     0,     0,     0,
       0,  1610,     0,     0,  3334,   188,     0,     0,     0,     0,
       0,  2644,     0,     0,     0,  1700,     0,     0,     0,  1602,
       0,  2645,     0,     0,     0,     0,     0,     0,  2646,  1603,
       0,     0,     0,     0,  1700,     0,   188,     0,  1602,  1604,
       0,     0,     0,   922,     0,  5935,     0,     0,  1603,     0,
     188,  1605,     0,     0,  2647,     0,  3334,     0,  1604,     0,
       0,     0,     0,     0,     0,     0,     0,   979,     0,     0,
    1605,     0,   653,   650,     0,     0,     0,     0,   653,     0,
       0,     0,     0,     0,     0,     0,     0,   922,     0,     0,
       0,  2963,     0,     0,  3639,     0,     0,  1607,  1608,  2971,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3830,  1832,   922,  1607,  1608,     0,     0,
     979,     0,   979,     0,     0,     0,     0,     0,     0,  1609,
       0,     0,     0,     0,     0,   979,     0,   979,     0,     0,
    2135,     0,     0,     0,     0,     0,     0,     0,  3831,     0,
       0,     0,     0,     0,     0,     0,     0,   653,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2648,     0,     0,     0,     0,  2649,     0,     0,
       0,     0,   650,   922,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2650,  2337,  1610,     0,   979,   922,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1610,     0,     0,     0,     0,     0,   922,  2651,     0,
       0,     0,     0,     0,     0,  2143,     0,     0,  2144,     0,
       0,     0,  2145,  2146,  2147,     0,   979,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2644,     0,     0,     0,     0,   979,     0,     0,     0,   979,
    2645,  2404,     0,     0,     0,     0,     0,  2646,     0,     0,
       0,     0,  3483,  4334,   188,     0,  2652,     0,     0,   650,
       0,  4337,     0,   979,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2647,     0,     0,     0,     0,     0,   653,
       0,  3334,   922,  3101,     0,     0,     0,  3106,   653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,     0,     0,     0,   653,   653,   653,     0,
       0,     0,  3334,   653,     0,     0,   653,     0,     0,   653,
       0,     0,     0,     0,     0,   653,     0,   653,     0,     0,
     653,     0,     0,     0,   922,   653,   653,   653,   653,     0,
       0,   653,   653,   653,   653,   653,   653,   653,   653,   653,
     653,     0,     0,  2654,   653,   653,   653,     0,   188,   922,
       0,     0,     0,   969,   653,  4433,     0,  4435,     0,   653,
       0,  1832,     0,   653,     0,     0,     0,     0,     0,     0,
       0,   653,     0,     0,   653,     0,   653,     0,     0,     0,
       0,  2648,     0,     0,  1592,     0,  2649,     0,     0,     0,
    1593,     0,   653,     0,     0,   653,   653,     0,     0,     0,
     653,   653,     0,     0,     0,   653,     0,   653,     0,  2650,
    2337,     0,     0,     0,     0,     0,     0,  3243,   650,     0,
       0,     0,     0,  3245,     0,     0,   969,   969,     0,     0,
       0,     0,     0,   653,     0,  1595,     0,  2651,     0,   653,
       0,     0,     0,     0,     0,     0,     0,   653,     0,  2603,
       0,   653,     0,  4496,     0,     0,     0,     0,  2604,  2605,
    2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,  3293,
       0,     0,     0,     0,  1562,     0,     0,     0,     0,     0,
    2404,     0,     0,     0,   653,     0,     0,     0,     0,     0,
       0,     0,  1596,     0,     0,  2652,     0,  4518,  2653,  1597,
       0,   653,     0,  1598,     0,     0,     0,   922,     0,     0,
    1563,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   650,     0,
       0,  1599,     0,   979,   650,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3334,  6331,     0,     0,     0,   653,     0,     0,     0,
       0,     0,  2143,     0,     0,  2144,     0,  1600,     0,  2145,
    2146,  2147,     0,  1564,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2644,     0,     0,
       0,     0,  2654,  3653,     0,  1832,     0,  2645,   921,     0,
    1832,   922,  1832,     0,  2646,     0,     0,     0,     0,   188,
    1565,     0,     0,     0,  2143,     0,     0,  2144,     0,     0,
       0,  2145,  2146,  2147,     0,     0,     0,     0,  1832,   922,
    2647,  6378,     0,     0,   188,     0,     0,  4660,     0,  2644,
       0,     0,     0,     0,     0,     0,     0,  1700,     0,  2645,
       0,  1602,     0,     0,     0,   650,  2646,     0,     0,     0,
    1566,  1603,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1604,     0,     0,   979,     0,     0,   979,     0,     0,
       0,     0,  2647,  1605,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2603,     0,
    1567,  6378,     0,     0,  1568,     0,     0,  2604,  2605,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,     0,  6442,     0,     0,
    4719,     0,  4718,     0,     0,     0,  4347,     0,     0,  1607,
    1608,     0,     0,     0,   969,   969,  1650,  1570,     0,     0,
       0,   653,     0,     0,  6169,  1532,     0,  6326,  2648,     0,
       0,     0,     0,  2649,     0,     0,     0,     0,  1592,     0,
       0,  4348,     0,     0,  1593,     0,     0,   979,   979,     0,
       0,   922,     0,     0,  4750,     0,  2650,  2337,   979,  1651,
       0,     0,     0,    36,     0,   653,   653,     0,  1572,     0,
       0,     0,     0,     0,     0,   979,     0,  1573,     0,  4771,
    2648,     0,     0,     0,  2651,  2649,  1574,     0,     0,  1595,
       0,     0,     0,     0,  1652,     0,     0,     0,   922,     0,
       0,     0,     0,   922,   653,   653,     0,  1576,  2650,  2337,
       0,     0,     0,     0,  1610,   653,  1577,     0,     0,     0,
       0,  1578,     0,     0,     0,     0,     0,  2404,     0,     0,
       0,     0,     0,     0,     0,     0,  2651,     0,     0,     0,
       0,     0,  2652,     0,     0,  2653,  1596,     0,   188,     0,
       0,     0,     0,  1597,     0,     0,   979,  1598,     0,  1832,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3334,  3334,     0,     0,  3334,     0,  1579,  2404,
       0,     0,     0,     0,     0,  1599,   653,     0,     0,     0,
       0,     0,     0,     0,  2652,     0,     0,  2653,     0,     0,
       0,     0,   653,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     653,  1600,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2654,
       0,     0,     0,     0,     0,     0,     0,     0,   653,     0,
       0,   653,     0,     0,     0,     0,     0,     0,     0,   653,
     653,     0,   922,     0,     0,     0,   653,   653,     0,     0,
       0,   653,     0,     0,     0,     0,   653,     0,     0,   653,
     653,     0,     0,     0,     0,     0,   653,     0,     0,     0,
       0,  2654,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1700,     0,     0,     0,  1602,     0,   653,     0,     0,
       0,     0,     0,     0,   653,  1603,     0,     0,     0,   653,
       0,     0,   653,   653,     0,  1604,     0,     0,     0,     0,
     653,     0,     0,     0,     0,     0,     0,  1605,     0,     0,
       0,   653,     0,     0,     0,  2603,     0,     0,     0,   653,
       0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,  2609,
    2610,  2611,  2612,     0,     0,     0,     0,  4792,     0,     0,
       0,     0,     0,     0,     0,     0,   922,     0,     0,     0,
    4418,     0,     0,  1607,  1608,     0,     0,     0,     0,   979,
       0,     0,     0,     0,   653,     0,     0,  2603,     0,     0,
       0,     0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2612,  4419,     0,     0,     0,  4897,
       0,     0,     0,     0,     0,     0,  1149,     0,     0,   922,
       0,     0,     0,     0,     0,     0,  2143,     0,     0,  2144,
       0,     0,     0,  2145,  2146,  2147,   979,     0,     0,     0,
       0,   922,     0,     0,     0,     0,     0,     0,   979,     0,
       0,  2644,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2645,     0,     0,   653,     0,     0,     0,  2646,     0,
       0,   653,  1254,     0,     0,     0,     0,     0,  1610,     0,
       0,     0,   979,     0,     0,     0,     0,     0,     0,     0,
       0,  5109,     0,     0,  2647,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   922,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   653,
       0,     0,   921,     0,     0,     0,     0,     0,     0,     0,
    2143,     0,     0,  2144,     0,   653,  1254,  2145,  2146,  2147,
    1832,     0,     0,     0,     0,     0,     0,     0,   921,     0,
       0,     0,     0,     0,     0,  2644,     0,     0,     0,   979,
    1254,     0,     0,     0,     0,  2645,   653,     0,     0,     0,
       0,     0,  2646,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2648,     0,     0,     0,     0,  2649,  2647,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   922,     0,   922,     0,     0,     0,     0,     0,
    2650,  2337,     0,     0,  3818,     0,     0,     0,  3822,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   979,     0,  2651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3855,     0,  3855,     0,  3855,
    3855,     0,   653,     0,  3855,  3855,  3855,     0,  3855,  3855,
    3855,     0,   653,     0,     0,   653,     0,     0,   653,   653,
     653,  2404,     0,     0,     0,     0,     0,     0,   921,     0,
       0,     0,     0,     0,   919,     0,  2652,     0,     0,  2653,
       0,     0,     0,   653,   653,     0,  2648,   653,     0,     0,
       0,  2649,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3932,   653,     0,     0,     0,   653,     0,     0,
       0,     0,     0,   653,  2650,  2337,     0,   653,     0,     0,
       0,     0,     0,   922,   653,     0,     0,  3960,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   653,     0,     0,
     653,     0,  2651,     0,   659,   979,     0,   979,     0,     0,
     708,   659,     0,     0,     0,     0,   760,     0,   659,     0,
       0,     0,     0,     0,   659,     0,  5344,   828,     0,   653,
       0,     0,     0,  2654,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2404,   882,   882,     0,     0,
       0,     0,     0,     0,   922,   979,     0,     0,     0,     0,
    2652,     0,     0,  2653,     0,   653,     0,     0,     0,     0,
       0,     0,  1747,     0,     0,     0,     0,     0,     0,  5380,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   921,     0,     0,     0,     0,     0,     0,     0,     0,
    1149,  5396,   921,     0,     0,  1832,     0,     0,     0,     0,
     653,     0,     0,     0,     0,     0,     0,     0,   921,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2603,
       0,     0,     0,     0,     0,     0,     0,     0,  2604,  2605,
    2606,  2607,  2608,  2609,  2610,  2611,  2612,  2654,     0,     0,
       0,  4921,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   653,     0,  5424,   922,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   961,     0,     0,
       0,   965,     0,     0,     0,   653,     0,     0,     0,  1008,
       0,     0,  1010,     0,     0,  1015,  1016,     0,  1019,     0,
    1022,     0,   653,  1028,     0,  1030,   653,     0,   653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,   720,     0,     0,     0,     0,  1060,     0,
     653,     0,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2603,   653,     0,     0,     0,     0,     0,
       0,   653,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,     0,     0,     0,     0,  5126,  1061,     0,     0,     0,
       0,     0,     0,     0,  5508,   921,     0,     0,     0,   723,
    1062,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1063,     0,     0,     0,   724,     0,     0,   653,
       0,     0,     0,     0,     0,   922,     0,     0,     0,     0,
     922,   922,     0,     0,  1064,   653,     0,  2143,     0,     0,
    2144,   653,   653,   979,  2145,  2146,  2147,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   979,  1065,     0,
       0,     0,  2644,     0,     0,     0,     0,     0,     0,     0,
       0,   727,  2645,     0,     0,     0,     0,   653,     0,  2646,
     728,     0,     0,     0,     0,   653,     0,     0,  1832,     0,
       0,     0,     0,   729,     0,     0,     0,     0,     0,  1066,
       0,     0,     0,     0,     0,  2647,     0,     0,     0,     0,
       0,     0,     0,   653,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1067,     0,     0,     0,
       0,   910,     0,  4496,     0,     0,     0,     0,     0,     0,
       0,     0,   922,   922,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1149,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1068,     0,   653,  1832,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   653,     0,
       0,     0,     0,     0,     0,     0,   733,   653,   653,   653,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,  1832,     0,     0,   922,     0,     0,     0,
       0,   653,     0,   653,     0,   653,     0,     0,     0,     0,
       0,     0,   653,  2648,     0,     0,     0,     0,  2649,   653,
    1069,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4406,     0,     0,  2753,     0,     0,     0,     0,   653,     0,
       0,  2650,  2337,     0,     0,     0,     0,   736,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   214,  1070,     0,
       0,   738,   912,  1832,     0,     0,   979,     0,     0,  2651,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  4455,  1071,
       0,     0,  1072,     0,     0,     0,   741,     0,   919,   742,
       0,  2753,     0,     0,     0,     0,   743,     0,     0,   744,
       0,     0,  2404,     0,     0,     0,     0,     0,     0,   653,
       0,     0,     0,     0,   919,     0,     0,  2652,     0,   745,
    2653,     0,     0,     0,     0,     0,     0,  1073,     0,     0,
       0,     0,   921,     0,   747,     0,     0,  1074,     0,   913,
    1058,     0,   749,     0,     0,     0,     0,     0,  4498,     0,
    1075,  1095,   751,     0,     0,  1099,     0,  1076,     0,     0,
     653,     0,  1112,  1113,     0,   921,  1119,     0,  1123,  1124,
       0,     0,     0,     0,     0,   653,     0,     0,     0,     0,
       0,     0,     0,  1146,   754,   653,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3855,     0,     0,   979,
       0,  1159,     0,     0,     0,     0,     0,     0,  4529,  4529,
       0,     0,     0,   653,  2654,     0,     0,     0,  4545,     0,
       0,     0,  1187,  1149,  1189,  1149,   979,     0,     0,   198,
       0,     0,     0,     0,  1205,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1747,  1747,  1747,     0,     0,     0,
       0,     0,     0,     0,     0,  2064,     0,     0,     0,     0,
    2064,  2064,     0,     0,   919,     0,     0,   659,   653,     0,
       0,  4600,     0,     0,     0,     0,     0,     0,   653,     0,
     199,     0,     0,     0,     0,     0,   653,   653,     0,     0,
       0,     0,   653,     0,     0,     0,     0,   200,     0,     0,
       0,     0,     0,     0,     0,     0,  4636,  1149,     0,     0,
       0,     0,     0,     0,     0,   201,     0,     0,     0,     0,
    2603,   202,     0,   653,   653,     0,     0,   653,     0,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,   203,
       0,     0,  5240,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   204,     0,     0,   882,   921,     0,     0,     0,
       0,   205,     0,     0,   979,     0,     0,   921,     0,     0,
       0,     0,     0,  5974,   206,     0,     0,     0,     0,     0,
     207,     0,     0,   921,     0,     0,     0,   208,   653,     0,
       0,     0,     0,     0,   653,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   209,     0,     0,
       0,     0,   653,     0,     0,     0,     0,     0,     0,   653,
       0,     0,     0,     0,     0,     0,     0,   919,     0,     0,
       0,     0,     0,     0,     0,   653,  6030,   921,   919,     0,
    1553,     0,     0,     0,     0,   210,     0,     0,     0,     0,
       0,     0,   921,   653,   919,   921,   921,     0,     0,     0,
       0,     0,     0,  2143,     0,     0,  2144,   211,     0,     0,
    2145,  2146,  2147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   921,   921,  2644,     0,
       0,   653,     0,     0,     0,     0,   922,     0,  2645,     0,
       0,     0,   653,     0,     0,  2646,     0,     0,     0,     0,
       0,   212,     0,  4793,  1731,   653,     0,     0,     0,     0,
       0,     0,  1832,     0,     0,     0,     0,     0,     0,     0,
       0,  2647,     0,     0,     0,     0,     0,     0,   213,  1852,
       0,     0,     0,     0,     0,     0,     0,     0,   214,   215,
       0,     0,   216,     0,  1864,     0,  1865,     0,     0,     0,
     653,   653,     0,     0,     0,     0,  1868,     0,     0,     0,
       0,     0,     0,  1878,     0,     0,     0,   653,     0,     0,
     217,  1832,     0,   218,     0,   910,     0,   219,     0,     0,
     220,     0,     0,     0,   653,   653,     0,   221,     0,     0,
     222,     0,     0,     0,     0,     0,  1832,     0,  1747,     0,
       0,   910,     0,     0,     0,     0,  1930,     0,  1932,     0,
     223,     0,  1747,  2049,     0,  1747,     0,     0,   224,     0,
       0,   919,     0,   225,     0,   226,     0,     0,   227,     0,
       0,     0,     0,   228,     0,     0,     0,     0,     0,  2648,
     921,     0,     0,   229,  2649,     0,     0,     0,   230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   231,     0,     0,     0,     0,  2650,  2337,     0,
       0,     0,     0,     0,     0,   232,     0,     0,     0,     0,
       0,     0,   659,     0,   659,     0,   659,     0,   659,     0,
     659,   659,   659,     0,     0,  2651,     0,   659,     0,  -136,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2036,
       0,     0,     0,     0,     0,     0,   912,     0,     0,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     0,     3,     4,  4545,     0,     0,     0,  2404,     0,
       0,     0,   912,     0,     0,     0,     0,     0,     0,     0,
       5,   910,     0,  2652,     0,     0,  2653,     0,     0,     0,
       6,     0,  4999,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     7,     0,     8,     9,     0,  5013,     0,     0,
    5014,    10,  5015,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,     0,    13,     0,
       0,     0,     0,   913,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    14,     0,     0,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5055,   913,
       0,     0,     0,    16,     0,    17,     0,     0,     0,    18,
       0,     0,     0,     0,  3855,     0,    19,     0,     0,  3855,
    2654,     0,     0,     0,     0,    20,     0,    21,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,   919,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   912,     0,     0,     0,     0,     0,     0,    24,
       0,     0,     0,     0,   882,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   910,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  6386,   919,     0,     0,
       0,   910,     0,     0,     0,     0,     0,     0,  5160,     0,
       0,  4545,     0,    25,    26,     0,  2603,     0,     0,    27,
       0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,    28,     0,  3035,     0,   919,   913,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    29,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   919,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5203,     0,     0,  2812,     0,     0,  5210,  5210,
    5210,  5210,    30,  5210,  5210,  5210,  5210,  5210,     0,     0,
       0,    31,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   912,    32,     0,     0,     0,
       0,     0,    33,    34,     0,    35,   912,     0,     0,     0,
      36,     0,     0,     0,     0,     0,    37,     0,     0,    38,
       0,     0,   912,     0,     0,     0,    39,     0,     0,     0,
       0,     0,     0,    40,    41,     0,     0,  2908,     0,     0,
       0,    42,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    44,     0,   910,     0,
       0,     0,     0,  1747,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,   913,     0,     0,     0,     0,     0,     0,     0,
       0,  5289,     0,   913,    46,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    47,     0,     0,   913,
       0,     0,    48,     0,     0,     0,     0,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      50,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   919,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   919,    51,     0,    52,    53,    54,    55,
      56,     0,     0,     0,     0,     0,     0,     0,     0,   919,
       0,     0,     0,    57,     0,     0,  -136,     0,     0,  3551,
       0,     0,     0,  2753,  3557,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   912,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   919,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   919,   921,
       0,   919,   919,     0,     0,   921,     0,     0,     0,     0,
       0,     0,  3039,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   919,   919,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   913,  3075,     0,     0,
     921,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   910,     0,     0,     0,
       0,     0,     0,     0,  5422,  5423,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3855,     0,  3855,
    3855,  3855,     0,  3140,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3158,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,     0,     0,  3178,
    -136,  3179,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5474,  3188,     0,  3189,     0,
       1,     0,     0,     0,   659,     0,   659,     0,   659,     0,
     659,     2,   659,     3,     4,   910,   659,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     5,     0,     0,  5502,     0,   919,     0,     0,     0,
       0,     6,     0,     0,     0,     0,     0,   912,   910,     0,
       0,     0,     0,     7,     0,     8,     9,     0,   915,     0,
       0,     0,    10,     0,    11,     0,     0,     0,  1747,     0,
       0,     0,     0,     0,     0,     0,  3252,    12,  5210,    13,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    14,     0,     0,    15,
     921,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,   912,    17,     0,     0,     0,
      18,     0,     0,     0,     0,     0,     0,    19,     0,     0,
       0,     0,     0,     0,   913,     0,    20,     0,    21,  2143,
       0,     0,  2144,     0,     0,    22,  2145,  2146,  2147,     0,
       0,     0,     0,     0,     0,     0,   912,     0,     0,     0,
       0,     0,     0,    23,  2644,     0,     0,     0,     0,     0,
       0,     0,     0,  2753,  2645,     0,     0,  2753,     0,     0,
      24,  2646,     0,     0,     0,     0,     0,     0,     0,   912,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   913,  2143,     0,     0,  2144,  2647,     0,     0,
    2145,  2146,  2147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,     0,     0,     0,    25,    26,     0,     0,  2645,   910,
      27,     0,     0,   913,     0,  2646,     0,  4545,     0,     0,
     910,     0,     0,     0,     0,    28,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   910,     0,     0,     0,
       0,  2647,     0,     0,    29,     0,   913,     0,     0,     0,
       0,     0,     0,     0,   921,     0,     0,     0,     0,     0,
       0,     0,     0,  3855,     0,     0,     0,   916,     0,   921,
       0,     0,  5699,     0,   921,     0,     0,     0,     0,     0,
       0,     0,     0,    30,     0,     0,     0,     0,     0,     0,
     910,     0,    31,     0,     0,  2648,     0,     0,     0,     0,
    2649,     0,     0,     0,   921,   910,     0,    32,   910,   910,
       0,     0,     0,    33,    34,     0,    35,     0,     0,     0,
       0,    36,     0,  2650,  2337,     0,     0,    37,     0,     0,
      38,     0,     0,     0,     0,     0,     0,    39,     0,   910,
     910,     0,     0,     0,    40,    41,     0,     0,     0,     0,
     912,  2651,    42,     0,     0,     0,    43,     0,     0,  2648,
       0,   912,     0,     0,  2649,     0,     0,    44,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,     0,     0,    45,     0,     0,  2650,  2337,     0,
       0,     0,     0,     0,  2404,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,  2652,
       0,   918,  2653,     0,     0,  2651,     0,    47,     0,     0,
       0,     0,     0,    48,     0,     0,     0,     0,    49,     0,
       0,   912,     0,     0,     0,     0,     0,   913,     0,     0,
       0,    50,     0,     0,     0,     0,   912,     0,   913,   912,
     912,     0,     0,     0,     0,     0,     0,     0,  2404,     0,
       0,     0,     0,     0,   913,    51,     0,     0,     0,     0,
       0,     0,     0,  2652,     0,     0,  2653,     0,     0,     0,
     912,   912,     0,     0,    57,     0,     0,  -136,     0,     0,
       0,     0,  2143,     0,     0,  2144,     0,     0,     0,  2145,
    2146,  2147,     0,   910,     0,     0,  2654,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2644,   913,     0,
    1149,     0,     0,     0,  5910,     0,     0,  2645,     0,     0,
       0,     0,     0,   913,  2646,     0,   913,   913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2753,     0,     0,  3557,
    2647,  3557,     0,     0,     0,     0,  2753,   913,   913,     0,
    2654,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   919,     0,     0,   921,   919,
     919,     0,  2603,     0,     0,     0,   921,     0,     0,     0,
       0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
       0,     0,     0,     0,  5277,     0,     0,     0,     0,     0,
       0,  2753,     0,     0,   912,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   919,     0,     0,     0,     0,
       0,   919,     0,     0,     0,     0,  2603,     0,  2648,     0,
       0,     0,     0,  2649,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,     0,     0,     0,     0,  5281,     0,
       0,     0,   915,     0,     0,     0,  2650,  2337,     0,     0,
       0,     0,     0,  3547,  3548,     0,   919,     0,     0,     0,
     921,     0,   921,     0,     0,     0,     0,     0,   915,     0,
       0,   913,  3563,  3564,  2651,  3566,  3567,     0,     0,  1149,
       0,  3570,  3571,  6082,     0,  6083,     0,     0,     0,  6089,
    6090,     0,     0,     0,     0,     0,  3582,     0,     0,     0,
    3585,     0,     0,     0,  3588,  3589,     0,     0,  3592,  3593,
       0,     0,     0,     0,     0,  3598,     0,  2404,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3613,     0,     0,
       0,     0,  2652,     0,     0,  2653,     0,     0,     0,  3630,
       0,     0,     0,     0,  3632,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3638,   921,     0,
       0,  3644,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3654,     0,     0,  3658,     0,  3660,  3663,  3665,
       0,     0,     0,     0,  3673,  3676,     0,  1747,     0,     0,
       0,     0,     0,  1747,  3689,     0,     0,     0,     0,     0,
    3699,     0,   921,     0,  3702,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3712,  3713,   915,     0,
       0,  3718,     0,     0,     0,     0,     0,  3727,  3728,  2654,
    3557,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3737,     0,     0,  3738,     0,     0,     0,     0,     0,
       0,  3750,  3751,     0,     0,     0,     0,  3755,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,     0,  3762,
       0,     0,  3765,     0,     0,     0,     0,  3768,     0,     0,
       0,   916,     0,  3771,  3772,     0,     0,     0,     0,     0,
       0,  3780,     0,     0,     0,  3782,     0,     0,   921,  3789,
    3790,  3791,  3792,     0,  3794,     0,     0,   916,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3820,  3821,
    3557,  3823,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3833,  3834,  3835,  2603,     0,     0,     0,   919,
       0,     0,   921,   919,  2604,  2605,  2606,  2607,  2608,  2609,
    2610,  2611,  2612,  2143,     0,     0,  2144,  5549,     0,     0,
    2145,  2146,  2147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,   915,     0,     0,     0,     0,     0,  1149,  2645,  3887,
       0,     0,   915,     0,     0,  2646,     0,  3911,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,  3923,     0,     0,     0,
       0,  2647,     0,     0,     0,   918,     0,   921,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,   910,   910,     0,     0,
     919,   918,     0,     0,     0,     0,     0,   916,     0,     0,
       0,     0,     0,     0,     0,   919,  3991,     0,     0,     0,
     919,     0,     0,     0,     0,     0,     0,     0,     0,   921,
       0,     0,     0,     0,     0,  4005,  2143,  4007,     0,  2144,
       0,     0,     0,  2145,  2146,  2147,     0,     0,     0,     0,
     919,     0,   910,     0,   921,     0,     0,     0,   910,     0,
       0,  2644,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2645,     0,     0,     0,     0,     0,     0,  2646,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2648,
       0,     0,     0,     0,  2649,  6407,     0,     0,     0,     0,
       0,     0,  2628,   910,  2647,     0,  6411,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2650,  2337,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   920,     0,   912,     0,   915,  4072,   912,   912,     0,
    6437,     0,     0,     0,     0,  2651,     0,     0,     0,  2143,
       0,   918,  2144,     0,  6407,     0,  2145,  2146,  2147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     916,     0,     0,     0,  2644,     0,     0,     0,     0,  6407,
       0,   916,  5289,     0,  2645,     0,     0,     0,  2404,     0,
       0,  2646,     0,   912,     0,     0,     0,   916,     0,   912,
       0,     0,     0,  2652,     0,     0,  2653,     0,     0,     0,
       0,     0,  2753,     0,     0,     0,     0,  2647,     0,     0,
     913,     0,  2648,     0,   913,   913,     0,  2649,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   912,     0,     0,     0,     0,     0,
    2650,  2337,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2651,     0,
     913,     0,     0,     0,     0,     0,   913,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2654,     0,   919,     0,     0,   919,  3557,   919,     0,     0,
       0,     0,   919,   910,   918,     0,     0,     0,     0,     0,
       0,  2404,     0,     0,     0,   918,     0,     0,     0,     0,
       0,   913,     0,     0,  3557,  2648,  2652,     0,     0,  2653,
    2649,   918,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   919,     0,     0,     0,     0,     0,
       0,     0,   919,  2650,  2337,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   916,     0,     0,     0,     0,     0,
       0,     0,     0,   915,     0,     0,   910,   919,     0,     0,
     910,  2651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2603,     0,     0,     0,
       0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,     0,     0,     0,     0,  5560,     0,
       0,     0,     0,  2654,  2404,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2652,
       0,   915,  2653,     0,   912,     0,     0,     0,     0,     0,
       0,     0,     0,  4332,     0,     0,   919,     0,   919,     0,
       0,     0,     0,     0,     0,     0,   921,     0,     0,     0,
    4339,     0,     0,     0,  4339,     0,     0,     0,     0,  4350,
    4351,  4352,   915,     0,  1592,     0,     0,   910,     0,     0,
    1593,     0,     0,     0,     0,     0,     0,  1659,     0,     0,
       0,  4364,   910,     0,     0,     0,     0,   910,   918,     0,
       0,     0,     0,  3557,     0,   915,     0,   912,  2753,  1660,
       0,   912,     0,     0,  4393,  4394,  4395,  4396,     0,  2603,
       0,   913,     0,     0,     0,  1595,  2654,   910,  2604,  2605,
    2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,     0,
       0,  5570,     0,     0,   919,     0,     0,     0,     0,     0,
       0,     0,  4417,     0,  4421,  4422,  4423,     0,     0,     0,
       0,  1661,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1596,     0,     0,     0,     0,     0,   919,  1597,
       0,     0,     0,  1598,   913,     0,     0,     0,   913,     0,
       0,     0,   916,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   919,     0,   912,     0,
       0,  1599,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2603,   912,     0,     0,     0,     0,   912,     0,
       0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
       0,     0,     0,  1662,  5632,     0,     0,  1600,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   921,   912,     0,
     916,     0,     0,     0,  4506,     0,     0,     0,     0,     0,
       0,     0,     0,  4512,   919,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   915,     0,     0,     0,
       0,     0,     0,     0,     0,   913,   919,   915,     0,  4522,
    4523,   916,     0,     0,  4524,     0,  1663,     0,     0,     0,
     913,  1664,     0,   915,     0,   913,     0,     0,   919,     0,
       0,     0,     0,     0,     0,     0,  4566,  1665,     0,     0,
       0,  1602,     0,     0,   916,     0,   918,     0,     0,     0,
       0,  1603,     0,     0,     0,   913,     0,     0,     0,     0,
       0,  1604,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1666,  1605,     0,     0,     0,   915,     0,   910,
       0,   921,   910,     0,   910,   920,     0,     0,  4603,   910,
       0,     0,   915,  4609,     0,   915,   915,     0,     0,  4615,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   920,     0,   919,   918,     0,  3756,     0,     0,  1607,
    1608,  1668,     0,     0,     0,     0,   915,   915,     0,  4654,
       0,   910,     0,     0,   921,     0,     0,     0,     0,   910,
       0,     0,     0,     0,     0,  1669,     0,     0,     0,     0,
       0,  3757,     0,     0,     0,   918,   921,     0,  4669,     0,
    4670,     0,     0,     0,   910,   919,  1671,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   918,     0,
     919,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     912,     0,     0,   912,  1610,   912,     0,     0,   921,     0,
     912,     0,     0,     0,     0,   916,     0,     0,     0,     0,
       0,     0,     0,   910,     0,   910,   916,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   920,   916,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   912,     0,     0,     0,     0,     0,  2143,     0,
     912,  2144,     0,     0,     0,  2145,  2146,  2147,     0,     0,
     915,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2644,     0,   912,     0,   913,     0,     0,
     913,     0,   913,  2645,     0,     0,   916,   913,     0,     0,
    2646,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   916,     0,     0,   916,   916,     0,     0,     0,     0,
       0,   910,     0,     0,     0,     0,  2647,  5506,   919,   921,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   913,
       0,     0,     0,     0,     0,   916,   916,   913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
       0,     0,     0,     0,   912,   910,   912,     0,     0,     0,
     918,     0,   913,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   918,     0,     0,     0,
       0,     0,     0,   910,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   920,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   920,     0,     0,     0,  4153,
       0,     0,   919,     0,     0,  4154,     0,     0,     0,     0,
       0,   920,     0,     0,     0,     0,     0,     0,     0,     0,
     918,     0,     0,     0,  2648,     0,     0,     0,     0,  2649,
     919,   913,     0,   913,  4903,   918,  4904,     0,   918,   918,
       0,   910,   912,     0,     0,     0,     0,     0,   921,  4911,
       0,     0,  2650,  2337,     0,     0,     0,     0,     0,     0,
       0,  4917,     0,   910,     0,  4920,     0,     0,     0,   918,
     918,     0,     0,     0,  2143,     0,  4933,  2144,     0,     0,
    2651,  2145,  2146,  2147,     0,   910,   912,     0,     0,   916,
       0,     0,     0,     0,     0,  4959,     0,     0,     0,  2644,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2645,
       0,     0,     0,  4963,   912,     0,  2646,     0,     0,  3557,
       0,  4967,     0,  2404,     0,     0,     0,     0,     0,   913,
       0,     0,     0,     0,     0,     0,     0,     0,  2652,     0,
       0,  2653,  2647,     0,     0,     0,  5002,     0,     0,     0,
    5006,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5016,  5017,  5018,  5019,     0,
     910,     0,   919,   913,     0,  5023,  5024,  5025,  5026,     0,
       0,     0,   912,     0,  5028,  5029,     0,     0,   920,     0,
    5036,  5037,     0,  5039,  5040,  5041,  5042,  5043,  5044,  5045,
       0,   913,     0,     0,   912,     0,     0,     0,     0,  5054,
       0,     0,     0,  5057,  5058,  5059,  5060,     0,     0,   919,
       0,     0,   910,     0,   919,     0,   912,     0,     0,     0,
       0,     0,     0,   918,     0,  4155,     0,  4339,     0,  3557,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,     0,     0,     0,     0,  5080,     0,     0,     0,     0,
    2648,     0,     0,     0,     0,  2649,     0,     0,     0,   913,
    2143,     0,     0,  2144,     0,     0,     0,  2145,  2146,  2147,
       0,     0,     0,     0,     0,     0,     0,     0,  2650,  2337,
       0,   913,     0,     0,     0,  2644,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2645,     0,     0,     0,     0,
       0,   912,  2646,   913,     0,     0,  2651,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5161,     0,     0,     0,     0,     0,     0,  2647,     0,
       0,  2603,     0,     0,     0,     0,     0,     0,     0,     0,
    2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  2404,
       0,     0,     0,   912,  4339,     0,     0,     0,     0,     0,
       0,  5186,     0,  5187,  2652,     0,     0,  2653,     0,     0,
       0,     0,     0,   919,     0,     0,     0,     0,   912,     0,
     921,     0,     0,     0,     0,   921,   921,     0,   913,     0,
       0,  5202,     0,     0,     0,   910,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2143,     0,     0,  2144,     0,     0,     0,  2145,  2146,  2147,
       0,     0,     0,     0,     0,     0,   920,     0,     0,     0,
       0,     0,     0,     0,     0,  2644,     0,     0,     0,   915,
     913,     0,     0,   915,   915,  2645,  2648,     0,     0,     0,
       0,  2649,  2646,     0,     0,     0,     0,     0,     0,     0,
       0,  2654,     0,     0,     0,   913,     0,     0,     0,     0,
       0,     0,     0,     0,  2650,  2337,     0,     0,  2647,     0,
       0,     0,     0,     0,     0,     0,     0,   919,     0,   910,
       0,     0,     0,     0,   920,     0,     0,  5506,   921,   915,
       0,     0,  2651,     0,     0,   915,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   971,   981,   920,   912,     0,     0,     0,
     919,   971,     0,   981,   971,  2404,     0,     0,     0,     0,
     915,     0,     0,     0,     0,     0,     0,   981,     0,     0,
    2652,   921,   919,  2653,     0,     0,     0,  2603,   920,     0,
       0,     0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2612,     0,     0,     0,     0,  5663,
       0,     0,     0,     0,     0,     0,  2648,     0,     0,     0,
       0,  2649,  5345,  5346,  5347,     0,     0,     0,  5348,  5349,
    5350,  5351,     0,     0,     0,  5353,     0,     0,     0,     0,
       0,     0,     0,   913,  2650,  2337,     0,     0,     0,     0,
     912,     0,     0,     0,   919,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2651,     0,     0,     0,     0,  2654,   912,   910,
       0,     0,     0,     0,     0,     0,  5386,  5387,  5388,  5389,
    5390,     0,  5392,  5393,     0,     0,     0,     0,   916,     0,
       0,     0,   916,   916,  5402,  5403,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   910,     0,     0,     0,
    2652,   910,     0,  2653,     0,     0,     0,   913,  5409,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   916,     0,
       0,     0,     0,     0,   916,   913,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   919,     0,     0,     0,   920,
     915,     0,     0,  2603,     0,     0,     0,     0,     0,     0,
     920,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,     0,     0,     0,     0,  5665,   920,     0,     0,   916,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     912,     0,     0,     0,     0,     0,     0,  2654,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5472,     0,   918,     0,     0,     0,   918,   918,     0,     0,
       0,     0,     0,   915,     0,     0,     0,   915,     0,     0,
     920,     0,     0,     0,     0,     0,     0,   912,     0,     0,
       0,     0,   912,     0,     0,   920,     0,     0,   920,   920,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     910,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   918,     0,     0,  5523,     0,   913,   918,   920,
     920,     0,     0,     0,   919,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2603,     0,     0,     0,     0,  5529,     0,
       0,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,     0,     0,   918,   913,  5704,     0,     0,     0,   913,
       0,     0,     0,     0,   915,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   915,
       0,     0,     0,     0,   915,   919,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   910,     0,     0,     0,     0,   981,
       0,     0,     0,     0,   915,     0,     0,     0,     0,   916,
       0,     0,     0,     0,     0,     0,     0,     0,   981,     0,
       0,   912,     0,     0,   981,   659,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   981,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   910,     0,     0,
       0,     0,   981,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   920,     0,     0,   971,   981,     0,   910,
       0,     0,     0,   971,     0,   981,   971,     0,     0,     0,
       0,   921,   916,     0,     0,     0,   916,     0,     0,   981,
       0,  5652,     0,     0,     0,   919,     0,     0,     0,   981,
       0,     0,     0,     0,     0,     0,     0,     0,   913,     0,
    5662,     0,     0,     0,     0,     0,  5668,  5669,     0,     0,
       0,     0,     0,     0,     0,     0,  5680,     0,     0,     0,
       0,     0,     0,  5682,     0,   912,     0,     0,     0,     0,
       0,   910,     0,     0,     0,  1747,     0,     0,     0,     0,
       0,   981,     0,   918,     0,     0,     0,  2143,     0,     0,
    2144,     0,     0,     0,  2145,  2146,  2147,   981,  5734,  5735,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5743,  2644,  5745,     0,     0,     0,     0,   912,     0,
       0,     0,  2645,   916,     0,     0,     0,     0,  5759,  2646,
       0,     0,     0,     0,     0,     0,     0,     0,   916,     0,
     912,     0,   981,   916,     0,     0,     0,     0,     0,     0,
       0,     0,   913,  4339,     0,  2647,   918,     0,     0,     0,
     918,  5793,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   916,     0,     0,   919,     0,     0,     0,
       0,   919,   919,     0,     0,     0,   915,     0,     0,   915,
       0,   915,   910,     0,     0,     0,   915,     0,     0,     0,
       0,     0,     0,     0,   981,   913,     0,     0,     0,     0,
       0,     0,   912,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   913,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,   915,     0,     0,     0,
       0,  5849,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5864,     0,   918,     0,     0,
       0,   915,     0,  2648,     0,     0,     0,     0,  2649,     0,
     958,   960,   918,     0,   963,     0,     0,   918,     0,  5881,
       0,     0,     0,     0,   919,     0,     0,     0,     0,   913,
       0,  2650,  2337,     0,  1021,     0,     0,     0,     0,     0,
       0,  1031,     0,     0,  1834,     0,     0,   918,     0,     0,
       0,   981,     0,     0,     0,     0,     0,     0,     0,  2651,
       0,   910,   971,   912,     0,     0,   971,     0,   971,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     915,     0,   915,     0,     0,     0,  5941,   919,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2652,     0,     0,
    2653,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   910,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     913,     0,     0,     0,     0,   916,  4339,     0,   916,     0,
     916,     0,     0,     0,     0,   916,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   981,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6021,     0,  2143,     0,     0,  2144,     0,     0,     0,  2145,
    2146,  2147,   912,     0,     0,     0,     0,   916,     0,     0,
       0,     0,     0,     0,  2654,   916,     0,  2644,     0,     0,
       0,     0,   915,     0,     0,     0,     0,  2645,     0,     0,
       0,  6049,     0,     0,  2646,     0,   981,     0,     0,     0,
     916,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     915,   981,   910,     0,     0,  6071,     0,     0,     0,     0,
    2647,   981,   981,     0,     0,     0,     0,   981,     0,     0,
       0,     0,     0,   912,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   981,     0,     0,     0,     0,   981,   913,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   918,
       0,     0,   918,     0,   918,     0,     0,     0,     0,   918,
       0,     0,     0,     0,     0,  6111,     0,     0,   915,   916,
    2603,   916,   920,     0,     0,     0,   920,   920,     0,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,
     915,     0,  6059,     0,     0,  2143,     0,     0,  2144,     0,
       0,   918,  2145,  2146,  2147,     0,     0,     0,     0,   918,
     913,     0,   915,     0,     0,     0,     0,     0,     0,     0,
    2644,     0,     0,     0,     0,     0,     0,     0,  2648,     0,
    2645,     0,   920,  2649,   918,     0,     0,  2646,   920,     0,
       0,     0,     0,   912,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   910,     0,     0,  2650,  2337,   910,   910,
       0,     0,     0,  2647,     0,     0,     0,   916,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6205,     0,     0,
       0,     0,     0,   920,  2651,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   915,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6218,   916,     0,   918,     0,   918,     0,     0,     0,     0,
    1834,  6228,     0,     0,     0,     0,     0,  2404,     0,     0,
     913,     0,     0,  1091,     0,  1094,     0,     0,  1096,   916,
       0,     0,  2652,     0,     0,  2653,     0,     0,     0,   915,
       0,     0,  1122,     0,     0,     0,     0,     0,  1126,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   910,     0,     0,   915,     0,     0,     0,     0,     0,
       0,  2648,     0,     0,     0,     0,  2649,     0,     0,     0,
       0,     0,     0,     0,   912,     0,     0,     0,     0,   912,
     912,     0,     0,     0,     0,     0,     0,   916,     0,  2650,
    2337,   918,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   916,
       0,     0,     0,     0,   910,     0,     0,  2651,     0,  2654,
     980,     0,     0,  6307,     0,     0,     0,   919,     0,   980,
       0,   916,     0,     0,     0,   918,     0,     0,     0,     0,
       0,     0,     0,   980,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2404,   913,     0,   918,     0,     0,   913,   913,     0,     0,
       0,     0,     0,   920,     0,  2652,     0,     0,  2653,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   912,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   915,     0,     0,     0,   916,     0,     0,     0,
       0,     0,     0,     0,     0,  2603,     0,     0,     0,     0,
       0,   918,     0,     0,  2604,  2605,  2606,  2607,  2608,  2609,
    2610,  2611,  2612,     0,     0,     0,   920,  6070,     0,   981,
     920,     0,     0,   918,     0,   912,  2143,     0,     0,  2144,
       0,     0,     0,  2145,  2146,  2147,     0,     0,   916,     0,
       0,     0,  2654,     0,     0,   918,     0,  2143,     0,   913,
    2144,  2644,     0,     0,  2145,  2146,  2147,     0,     0,     0,
       0,  2645,     0,   916,     0,     0,     0,     0,  2646,     0,
       0,     0,  2644,     0,     0,     0,   915,     0,     0,     0,
       0,     0,  2645,     0,     0,     0,     0,     0,     0,  2646,
       0,     0,     0,     0,  2647,     0,     0,     0,     0,  6448,
       0,     0,  1624,  1625,   915,     0,     0,     0,     0,     0,
       0,     0,   913,     0,     0,  2647,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   920,     0,     0,
     918,     0,     0,     0,   981,     0,     0,     0,     0,     0,
       0,     0,   920,     0,     0,     0,     0,   920,  2603,     0,
       0,     0,     0,     0,     0,     0,     0,  2604,  2605,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,     0,     0,     0,  1834,
    6093,     0,     0,  1851,     0,     0,     0,   920,     0,     0,
       0,     0,   918,     0,     0,     0,     0,     0,  1863,     0,
       0,     0,   981,     0,     0,     0,     0,     0,     0,     0,
     981,     0,     0,     0,     0,     0,     0,   918,   981,     0,
       0,     0,  2648,     0,     0,     0,     0,  2649,     0,  1885,
    1886,   916,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2648,     0,     0,     0,     0,  2649,     0,
    2650,  2337,     0,     0,     0,  1923,   915,     0,     0,   971,
     971,     0,   981,   981,     0,     0,     0,     0,     0,     0,
       0,  2650,  2337,     0,   971,     0,   981,   971,  2651,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   981,
     981,     0,     0,     0,     0,  1961,  1963,     0,     0,  2651,
       0,     0,     0,   915,     0,     0,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2404,     0,     0,     0,   916,     0,   971,     0,     0,
       0,   971,   971,     0,     0,     0,  2652,     0,     0,  2653,
       0,     0,  2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   916,     0,   980,     0,  2652,     0,     0,
    2653,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   984,   980,   918,     0,     0,     0,     0,
     980,     0,     0,     0,     0,  1018,     0,     0,     0,     0,
       0,     0,   980,     0,  2143,     0,  1037,  2144,     0,     0,
       0,  2145,  2146,  2147,   910,     0,     0,     0,   980,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2644,
       0,     0,     0,   980,     0,     0,     0,     0,     0,  2645,
       0,   980,     0,  2654,     0,     0,  2646,     0,     0,   920,
       0,     0,   920,     0,   920,   980,     0,     0,     0,   920,
       0,     0,     0,     0,  2654,   980,     0,     0,     0,     0,
       0,     0,  2647,     0,     0,     0,     0,   915,     0,   918,
       0,  1834,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   920,     0,     0,     0,   916,     0,   918,     0,   920,
       0,     0,     0,     0,     0,     0,     0,   980,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   980,   920,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2603,
       0,     0,   916,     0,     0,   912,     0,   916,  2604,  2605,
    2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,     0,
    2603,  6313,     0,     0,     0,     0,     0,     0,   980,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,
    2648,   915,  6330,     0,     0,  2649,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   920,     0,   920,     0,     0,  2650,  2337,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     980,     0,   913,     0,   915,     0,  2651,     0,     0,   918,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   915,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2404,
       0,     0,     0,     0,     0,     0,   918,     0,     0,     0,
       0,   918,     0,     0,  2652,     0,     0,  2653,     0,  2830,
       0,   920,     0,     0,     0,     0,   916,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2875,     0,     0,     0,   915,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1833,     0,     0,     0,     0,   920,     0,   980,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   920,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2654,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2965,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     916,     0,     0,     0,     0,     0,     0,     0,  1057,     0,
    2991,  2992,  2993,  2994,  1089,     0,     0,     0,     0,     0,
       0,   920,     0,     0,     0,     0,     0,     0,     0,   915,
     918,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   920,     0,     0,     0,     0,     0,     0,
       0,   980,     0,   916,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   920,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   916,     0,  2603,     0,     0,
       0,     0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2612,     0,     0,     0,     0,  6388,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   980,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   980,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   980,   980,     0,
       0,     0,     0,   980,   918,     0,     0,   916,     0,     0,
     920,     0,     0,  2143,     0,     0,  2144,  3048,  3049,   980,
    2145,  2146,  2147,     0,   980,     0,     0,  1834,   915,     0,
       0,     0,     0,  3066,     0,     0,     0,     0,  2644,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2645,     0,
       0,     0,     0,     0,     0,  2646,     0,   918,  1416,     0,
       0,     0,   920,     0,     0,     0,     0,  3109,  3110,  3111,
    3112,  1428,     0,     0,     0,     0,     0,     0,     0,   918,
       0,  2647,   981,     0,     0,     0,     0,   920,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   915,
     981,     0,     0,     0,   981,     0,     0,     0,   981,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   981,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   916,     0,
       0,     0,     0,   981,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1486,     0,     0,     0,     0,  3186,     0,
     971,   918,   971,   971,  3190,     0,     0,     0,     0,     0,
       0,     0,     0,  2143,     0,     0,  2144,   981,     0,     0,
    2145,  2146,  2147,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   981,   981,     0,  2644,     0,
    1623,     0,  3502,     0,     0,     0,     0,     0,  2645,  2648,
       0,     0,     0,     0,  2649,  2646,  1833,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   915,
       0,     0,  1834,   981,     0,     0,  1834,  2650,  2337,     0,
       0,  2647,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   920,     0,     0,     0,     0,
     981,     0,  1834,     0,  2143,  2651,   981,  2144,     0,     0,
       0,  2145,  2146,  2147,     0,     0,     0,   916,     0,     0,
     981,     0,   918,     0,     0,     0,     0,   981,     0,  2644,
     981,     0,     0,  3503,     0,     0,   981,     0,     0,  2645,
       0,     0,     0,     0,     0,     0,  2646,     0,  2404,     0,
       0,     0,     0,     0,     0,  1883,   981,     0,     0,     0,
       0,     0,   981,  2652,     0,     0,  2653,     0,     0,   981,
       0,     0,  2647,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   981,  1917,  1920,  1921,     0,   916,   920,
       0,     0,     0,     0,  4784,     0,     0,   981,     0,  2648,
       0,     0,  1834,     0,  2649,     0,     0,     0,   981,     0,
       0,     0,     0,     0,  3378,     0,     0,   920,     0,     0,
     915,     0,     0,     0,     0,   915,   915,  2650,  2337,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2651,     0,     0,     0,     0,
    2654,   918,     0,     0,  6158,     0,     0,     0,  1834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4785,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2648,     0,     0,  1416,     0,  2649,     0,     0,  2404,     0,
       0,     0,     0,     0,     0,   980,     0,     0,   916,     0,
       0,     0,     0,  2652,     0,     0,  2653,     0,  2650,  2337,
       0,     0,     0,     0,     0,     0,  2143,     0,     0,  2144,
       0,     0,   918,  2145,  2146,  2147,     0,     0,   915,     0,
    1416,     0,     0,     0,     0,     0,  2651,     0,     0,     0,
       0,  2644,     0,     0,  4081,     0,     0,     0,     0,   920,
       0,  2645,     0,     0,     0,     0,  2603,     0,  2646,     0,
       0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,     0,     0,     0,     0,     0,  2404,
       0,     0,     0,     0,  2647,     0,     0,     0,     0,     0,
       0,   915,     0,     0,  2652,     0,   920,  2653,     0,     0,
    2654,   920,     0,     0,     0,     0,     0,     0,     0,  2143,
     980,     0,  2144,   981,     0,  1834,  2145,  2146,  2147,     0,
       0,     0,     0,  6159,     0,     0,     0,     0,     0,     0,
       0,     0,   981,     0,  2644,     0,   981,     0,     0,     0,
       0,     0,   918,   981,  2645,  1833,     0,     0,     0,   916,
     971,  2646,   971,   971,   916,   916,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3504,     0,     0,   980,     0,
       0,  2638,     0,     0,     0,     0,   980,  2647,     0,     0,
       0,     0,     0,     0,   980,     0,     0,     0,     0,     0,
       0,  2654,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2143,  2648,     0,  2144,     0,  2603,  2649,  2145,  2146,
    2147,     0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,     0,     0,  2644,     0,   980,   980,
    2650,  2337,     0,     0,     0,     0,  2645,     0,     0,     0,
    1834,     0,   980,  2646,     0,     0,  1834,     0,     0,     0,
       0,  2729,     0,     0,     0,   980,   980,     0,  2651,     0,
     920,     0,     0,     0,     0,     0,     0,   916,     0,  2647,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   918,     0,  2648,     0,  2603,   918,   918,
    2649,  2404,     0,     0,     0,     0,  2604,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2612,     0,  2652,     0,     0,  2653,
       0,     0,     0,  2650,  2337,     0,     0,     0,     0,     0,
     916,     0,     0,     0,     0,  2842,     0,     0,     0,     0,
       0,     0,     0,     0,  2871,     0,     0,     0,  3378,     0,
       0,  2651,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   920,     0,  2909,     0,     0,     0,
       0,     0,  2921,  2921,     0,     0,  2921,  2648,     0,     0,
       0,     0,  2649,     0,  2404,     0,     0,     0,     0,  2939,
       0,     0,  2942,     0,     0,     0,     0,     0,     0,  2652,
       0,   918,  2653,  2654,     0,  2650,  2337,     0,     0,     0,
       0,     0,     0,  2143,     0,     0,  2144,   920,     0,     0,
    2145,  2146,  2147,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,  2651,     0,     0,     0,     0,  2644,   920,
       0,  4158,     0,     0,     0,     0,     0,  2995,  2645,     0,
       0,   981,   981,     0,     0,  2646,     0,     0,     0,     0,
       0,  3015,     0,     0,   918,     0,     0,     0,     0,     0,
       0,     0,   981,     0,     0,   981,  2404,     0,     0,     0,
       0,  2647,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2652,     0,     0,  2653,     0,  2654,     0,     0,     0,
       0,  3612,     0,     0,     0,     0,     0,     0,     0,  2603,
       0,   920,     0,     0,     0,  4126,     0,     0,  2604,  2605,
    2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1834,  1834,  1834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3037,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   981,  3040,     0,     0,     0,     0,     0,  2654,     0,
       0,   915,     0,     0,     0,     0,     0,     0,     0,  2648,
     981,  4090,  2603,     0,  2649,     0,     0,     0,     0,     0,
       0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,
       0,     0,   981,     0,  3084,  2921,     0,  2650,  2337,     0,
       0,     0,   920,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3761,     0,     0,  3764,     0,     0,  3119,
       0,     0,     0,     0,     0,  2651,  3132,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2603,     0,     0,     0,  2404,     0,
       0,     0,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,
    2611,  2612,   981,  2652,     0,     0,  2653,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3193,
       0,     0,     0,     0,     0,  3859,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  3872,     0,
       0,     0,     0,     0,     0,     0,  3881,     0,     0,  1834,
       0,     0,  1416,  1416,     0,   981,     0,   981,     0,     0,
       0,   920,     0,     0,     0,     0,     0,     0,     0,     0,
     981,     0,   981,     0,     0,     0,     0,     0,     0,     0,
    2143,     0,     0,  2144,     0,  3925,     0,  2145,  2146,  2147,
       0,     0,  3251,     0,     0,  3253,     0,     0,     0,     0,
    2654,     0,     0,     0,     0,  2644,  3949,     0,     0,     0,
       0,     0,     0,     0,     0,  2645,     0,     0,     0,     0,
     916,     0,  2646,     0,     0,     0,     0,  2143,     0,     0,
    2144,     0,   920,     0,  2145,  2146,  2147,     0,     0,   981,
       0,     0,     0,     0,     0,     0,     0,     0,  2647,  4004,
       0,  4006,  2644,     0,     0,  4170,     0,  2143,     0,     0,
    2144,     0,  2645,     0,  2145,  2146,  2147,     0,     0,  2646,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   981,  2644,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2645,     0,     0,  2647,     0,     0,     0,  2646,
     981,     0,     0,     0,   981,     0,  2603,     0,     0,     0,
       0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,     0,  2647,     0,     0,   981,     0,
       0,     0,     0,  1833,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4064,     0,     0,     0,  4163,     0,     0,
    4071,     0,   920,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   918,     0,  2648,     0,     0,     0,
       0,  2649,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   980,     0,
       0,     0,     0,     0,  2650,  2337,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   980,     0,     0,     0,
     980,     0,     0,  2648,   980,     0,     0,     0,  2649,     0,
       0,     0,  2651,     0,   980,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1834,     0,     0,   980,
       0,  2650,  2337,  2648,     0,     0,     0,     0,  2649,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2404,     0,     0,     0,  2651,
       0,  2650,  2337,   980,     0,     0,     0,     0,     0,     0,
    2652,     0,     0,  2653,     0,     0,     0,     0,     0,     0,
       0,   980,   980,     0,     0,     0,     0,     0,     0,  2651,
       0,     0,     0,   920,     0,     0,     0,     0,   920,   920,
       0,     0,  2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1392,  1392,     0,     0,  2652,  1833,   980,
    2653,     0,  1833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2404,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   980,  2652,  1833,     0,
    2653,     0,   980,     0,     0,  2143,     0,     0,  2144,     0,
       0,     0,  2145,  2146,  2147,     0,   980,  2654,     0,     0,
       0,     0,     0,   980,     0,     0,   980,     0,     0,     0,
    2644,     0,   980,  4791,     0,     0,  1392,     0,     0,     0,
    2645,     0,     0,     0,     0,     0,     0,  2646,   981,     0,
       0,     0,   980,     0,     0,     0,     0,     0,   980,     0,
       0,   920,     0,     0,  2654,   980,     0,     0,     0,     0,
       0,     0,     0,  2647,     0,     0,     0,     0,     0,   980,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   980,  2654,     0,     0,     0,  1833,     0,
       0,     0,     0,     0,   980,     0,     0,     0,     0,     0,
    1834,     0,     0,     0,     0,  1834,     0,  1834,     0,     0,
       0,     0,     0,  2603,   920,     0,  4335,  4336,     0,     0,
    4715,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,     0,     0,  1834,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1744,  1748,     0,
       0,     0,     0,     0,  1833,     0,     0,     0,     0,     0,
    2603,     0,     0,     0,     0,     0,     0,     0,     0,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  3436,   981,
       0,  2648,   981,     0,     0,     0,  2649,     0,  3441,     0,
    2603,     0,     0,     0,     0,     0,  1486,     0,     0,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,  2650,
    2337,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2143,     0,     0,  2144,     0,     0,     0,  2145,  2146,  2147,
       0,     0,     0,     0,     0,     0,     0,  2651,     0,     0,
       0,     0,     0,  1486,  1486,  2644,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2645,     0,  2143,     0,     0,
    2144,     0,  2646,     0,  2145,  2146,  2147,     0,     0,     0,
       0,     0,   981,   981,     0,     0,     0,  1416,     0,     0,
    2404,     0,  2644,   981,     0,     0,     0,     0,  2647,     0,
       0,     0,  2645,     0,     0,  2652,     0,     0,  2653,  2646,
     981,     0,     0,     0,     0,     0,     0,     0,     0,   980,
       0,  1833,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2647,     0,     0,   980,     0,
       0,     0,   980,  2143,     0,     0,  2144,     0,     0,   980,
    2145,  2146,  2147,     0,     0,     0,     0,  2614,     0,     0,
       0,     0,     0,  2143,     0,     0,  2144,     0,  2644,     0,
    2145,  2146,  2147,     0,     0,     0,     0,     0,  2645,  4519,
       0,     0,     0,     0,     0,  2646,     0,     0,  2644,     0,
       0,   981,     0,     0,  1834,     0,     0,     0,  2645,     0,
    2614,     0,  2654,     0,     0,  2646,     0,     0,     0,     0,
       0,  2647,     0,     0,     0,  2087,  2648,     0,     0,     0,
       0,  2649,  3657,     0,     0,     0,     0,     0,     0,     0,
       0,  2647,     0,     0,  5241,     0,     0,  3679,     0,     0,
       0,     0,     0,     0,  2650,  2337,  1833,     0,     0,     0,
       0,     0,  1833,  2648,     0,     0,     0,  2113,  2649,  3707,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2651,     0,     0,     0,     0,     0,     0,     0,
       0,  2650,  2337,     0,     0,     0,  2132,  2133,  2134,     0,
    2136,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5249,     0,     0,     0,     0,  2603,  2651,
    5247,  2621,     0,     0,     0,  2404,     0,  2604,  2605,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,     0,     0,     0,  2648,
    2652,     0,     0,  2653,  2649,     0,     0,     0,     0,  4672,
       0,     0,     0,     0,     0,  3787,  3788,     0,     0,  2648,
    5231,     0,  2404,     0,  2649,     0,     0,  2650,  2337,     0,
       0,     0,     0,     0,     0,     0,     0,  2652,     0,     0,
    2653,     0,     0,     0,     0,     0,     0,  2650,  2337,     0,
       0,     0,     0,     0,     0,  2651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2696,     0,     0,  2651,  2708,  2713,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   981,     0,     0,  2654,  2404,     0,
       0,     0,     0,     0,   920,     0,     0,     0,     0,     0,
       0,     0,     0,  2652,     0,     0,  2653,  3913,  2404,     0,
    2143,     0,     0,  2144,     0,     0,     0,  2145,  2146,  2147,
       0,     0,     0,  2652,  2654,     0,  2653,   980,   980,     0,
       0,     0,     0,     0,     0,  2644,     0,     0,     0,     0,
       0,   981,     0,     0,     0,  2645,     0,     0,   980,     0,
       0,   980,  2646,   981,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2614,
       0,     0,     0,  2614,     0,     0,     0,     0,  2647,     0,
       0,     0,     0,     0,     0,     0,     0,   981,     0,     0,
       0,     0,     0,  2603,     0,     0,     0,     0,     0,     0,
    2654,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2654,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2603,     0,  1833,  1833,  1833,     0,     0,     0,     0,  2604,
    2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   980,     0,     0,
       0,     0,     0,     0,     0,  1834,     0,     0,     0,     0,
       0,  5248,     0,     0,     0,     0,   980,     0,     0,     0,
       0,     0,     0,     0,   981,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2648,     0,   980,     0,
       0,  2649,     0,     0,     0,     0,  2603,     0,     0,  1744,
    1744,  1744,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,  2650,  2337,  2603,     0,     0,     0,
       0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,     0,     0,     0,     0,     0,     0,
    2143,     0,  2651,  2144,     0,     0,     0,  2145,  2146,  2147,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   981,     0,     0,     0,  2644,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2645,     0,     0,   980,     0,
       0,     0,  2646,     0,  2143,  2404,     0,  2144,     0,     0,
       0,  2145,  2146,  2147,     0,     0,     0,     0,     0,     0,
    2652,     0,     0,  2653,     0,     0,     0,     0,  2647,  2644,
       0,     0,     0,     0,     0,  2143,     0,     0,  2144,  2645,
       0,     0,  2145,  2146,  2147,  1833,  2646,     0,     0,     0,
       0,   980,     0,   980,     0,     0,     0,     0,     0,     0,
    2644,     0,     0,  5824,     0,  4224,   980,     0,   980,     0,
    2645,     0,  2647,     0,     0,     0,     0,  2646,     0,     0,
       0,     0,     0,  1486,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2647,     0,     0,     0,     0,     0,     0,
     981,     0,   981,     0,     0,     0,     0,  2654,     0,     0,
       0,     0,  2614,     0,     0,  5077,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   980,     0,     0,     0,  5079,
       0,     0,     0,     0,     0,     0,  2648,     0,  2614,     0,
       0,  2649,  3335,     0,     0,     0,     0,     0,     0,     0,
     981,     0,     0,     0,     0,  5807,     0,  2614,  2614,  2614,
     971,  2614,     0,     0,  2650,  2337,     0,   980,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2648,     0,     0,     0,     0,  2649,   980,     0,     0,     0,
     980,     0,  2651,     0,     0,     0,     0,     0,     0,     0,
    1834,     0,     0,     0,     0,   971,     0,     0,  2650,  2337,
       0,  2648,     0,  2603,   980,     0,  2649,     0,     0,     0,
       0,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,     0,     0,     0,     0,  2404,  2651,     0,     0,  2650,
    2337,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2652,     0,     0,  2653,     0,     0,     0,     0,     0,     0,
    3279,     0,     0,     0,     0,     0,     0,  2651,     0,  3296,
    3296,  3296,  3296,  3306,  3312,  3296,  3315,  3296,  3296,  2404,
       0,     0,     0,  3322,     0,  3323,     0,  3325,     0,     0,
    3339,  3342,  3347,     0,  2652,     0,     0,  2653,  3356,     0,
       0,  3361,     0,     0,     0,     0,     0,     0,     0,     0,
    2404,     0,     0,     0,     0,     0,  3368,  3369,  3370,     0,
       0,     0,  1833,     0,     0,  2652,     0,     0,  2653,     0,
       0,     0,     0,     0,  3371,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4439,  2654,     0,     0,
       0,     0,     0,     0,     0,     0,  2921,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2143,     0,     0,  2144,     0,     0,     0,
    2145,  2146,  2147,     0,     0,     0,     0,     0,     0,     0,
       0,  2654,     0,     0,     0,     0,     0,     0,  2644,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2645,     0,
       0,     0,     0,     0,     0,  2646,     0,     0,     0,     0,
       0,     0,  2654,     0,     0,     0,     0,  5619,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   981,     0,
       0,  2647,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   981,  2603,     0,     0,     0,     0,     0,     0,
       0,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,
    2612,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3379,     0,  1834,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   980,     0,     0,  2603,     0,     0,
       0,     0,     0,     0,     0,     0,  2604,  2605,  2606,  2607,
    2608,  2609,  2610,  2611,  2612,     0,     0,     0,     0,  4570,
    4571,  4572,     0,     0,     0,     0,     0,     0,  2603,     0,
       0,     0,     0,     0,     0,  3398,  4581,  2604,  2605,  2606,
    2607,  2608,  2609,  2610,  2611,  2612,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1833,     0,     0,  2648,
       0,  1833,  1834,  1833,  2649,     0,     0,     0,     0,  4606,
    4608,     0,     0,     0,  4613,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2650,  2337,  1833,
       0,  3400,     0,     0,     0,     0,     0,     0,  1834,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5417,     0,  2651,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  5421,     0,
       0,     0,     0,     0,   720,   980,     0,     0,   980,   721,
       0,     0,     0,     0,     0,     0,  2614,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2404,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1834,     0,
       0,   981,     0,  2652,     0,     0,  2653,   722,     0,     0,
       0,     0,     0,  1416,     0,     0,     0,     0,     0,     0,
     723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   724,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5479,
       0,  2614,     0,     0,     0,   725,     0,     0,   980,   980,
       0,     0,     0,  2614,     0,     0,     0,     0,  2614,   980,
       0,     0,     0,     0,     0,   671,     0,     0,     0,   726,
       0,     0,     0,     0,     0,     0,   980,     0,     0,     0,
       0,     0,   727,   672,     0,     0,     0,     0,     0,     0,
    2654,   728,     0,     0,     0,  3407,  3408,  3409,  3410,  3411,
    3412,  3413,  3414,  3415,   729,  3416,     0,     0,   673,     0,
     730,     0,     0,     0,     0,     0,  1392,   731,  1744,     0,
       0,   674,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   981,  3371,     0,   732,  -888,  3379,
       0,     0,  3398,     0,  3400,     0,     0,  3450,   971,     0,
       0,     0,     0,     0,     0,     0,   675,   980,     0,     0,
    1833,   981,   676,     0,     0,     0,     0,     0,     0,  4823,
    4824,  4825,     0,     0,     0,     0,     0,     0,     0,     0,
     677,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   678,     0,     0,  2603,   733,     0,     0,
    2133,  2134,   679,     0,     0,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,     0,   680,     0,     0,     0,     0,
       0,   971,   971,     0,   681,     0,     0,     0,   682,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   734,     0,     0,     0,     0,     0,     0, -1094,     0,
       0,     0,     0,     0,   735,     0,     0,     0,     0,     0,
       0,  5638,     0,  5640,     0,     0,     0,     0,   736,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   214,   737,
       0,  3590,   738,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   683,   981,
       0,     0,     0,     0,     0,     0,     0,     0,  -623,     0,
     739,     0,     0,   740,     0,     0,     0,   741,     0,     0,
     742,     0,     0,     0,     0,     0,     0,   743,     0,     0,
     744,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     745,     0,   684,     0,     0,   685,     0,     0,   746,     0,
       0,     0,     0,     0,     0,   747,     0,     0,   748,     0,
       0,     0,     0,   749,     0,     0,     0,     0,     0,   686,
       0,   750,     0,   751,     0,     0,     0,     0,   752,     0,
     980,     0,     0,   687,     0,     0,     0,     0,     0,  5764,
       0,  -473,   753,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   754,     0,     0,     0,     0,
       0,   688,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   689,     0,     0,     0,     0,     0,     0,  -473,     0,
       0,   690,     0,     0,     0,     0,     0,   980,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1834,     0,   980,
       0,   691,     0,     0,     0,     0,     0,     0,     0,   692,
       0,     0,     0,     0,     0,     0,  -473,     0,     0,   693,
       0,   694,     0,   695,   696,     0,     0,     0,     0,     0,
       0,     0,     0,   980,     0,     0,     0,     0,     0,   697,
       0,  5090,     0,     0,     0,     0,     0,   698,     0,     0,
     699,     0,     0,   700,     0,     0,  1834,     0,     0,     0,
       0,  3845,  3846,  1744,     0,     0,  -473,  3850,     0,   971,
     971,     0,     0,  5122,     0,     0,     0,     0,     0,     0,
       0,  1834,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  3879,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3132,     0,     0,     0,     0,
       0,  1833,     0,     0,     0,     0,     0,  5896,     0,  5898,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     980,     0,   720,     0,     0,     0,     0,  2801,     0,     0,
    5180,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3193,     0,     0,
       0,     0,     0,     0,  2614,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2802,     0,     0,     0,     0,
       0,  2614,     0,     0,     0,     0,     0,     0,   723,     0,
       0,  2614,     0,     0,     0,     0,     0,  2614,     0,     0,
    2614,     0,     0,     0,     0,   724,     0,  2614,  2614,     0,
    2614,     0,     0,     0,     0,  3335,  3335,   980,  4149,     0,
    3335,     0,     0,  1064,  2614,     0,     0,  2614,     0,     0,
       0,     0,  2614,     0,     0,     0,     0,     0,     0,     0,
       0,  2614,     0,     0,     0,     0,  2614,  2803,     0,     0,
       0,     0,     0,  2614,  2614,  2614,  2614,     0,     0,     0,
     727,  3335,  3335,     0,  2614,     0,     0,     0,     0,   728,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   729,  2614,     0,  2614,     0,     0,  2804,     0,
       0,     0,  2614,  2614,  2614,  2614,  2614,  2614,  2614,  2614,
    2614,  2614,     0,  5284,  5285,  5286,  5287,  4077,     0,     0,
       0,     0,  4083,     0,     0,  1067,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2614,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   980,     0,   980,     0,
       0,     1,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,  2136,     3,     4,     0,     0,     0,     0,
       0,     0,     0,     0,  3347,   733,  3347,  3347,     0,     0,
       0,     0,     0,     0,     0,  6107,     0,     0,     0,     0,
    4173,     0,     6,  4176,     0,  4178,   980,     0,     0,     0,
       0,     0,     0,     0,     7,     0,     8,     9,     0,     0,
       0,     0,     0,    10,     0,    11,     0,     0,     0,  2805,
       0,     0,     0,     0,     0,     0,     0,     0,    12,     0,
      13,     0,  4203,     0,  4206,     0,  4208,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1833,    14,     0,     0,
      15,     0,     0,     0,     0,     0,   214,  2806,     0,     0,
     738,     0,     0,     0,     0,    16,     0,    17,     0,     0,
       0,    18,     0,     0,     0,  2614,     0,     0,  5773,     0,
       0,     0,     0,     0,     0,     0,     0,    20,  1071,    21,
       0,  2807,     0,     0,     0,     0,    22,     0,   742,     0,
       0,     0,     0,     0,     0,   743,     0,     0,   744,     0,
       0,     0,     0,     0,    23,     0,     0,     0,  6211,     0,
       0,     0,     0,     0,     0,     0,     0,  4275,   745,     0,
       0,    24,  2696,     0,     0,     0,  1073,     0,     0,     0,
       0,     0,     0,   747,     0,     0,  1074,  2713,     0,     0,
       0,   749,     0,     0,     0,     0,     0,     0,     0,  2808,
       0,     0,     0,     0,     0,     0,  2809,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,    26,     0,     0,     0,
       0,    27,     0,   754,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,     0,
       0,     0,  4325,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    29,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6301,     0,
    5501,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  5511,     0,     0,    30,     0,     0,     0,     0,     0,
       0,     0,  4360,    31,     0,     0,     0,     0,     0,  1122,
    1122,     0,     0,     0,   980,     0,     0,     0,    32,     0,
       0,     0,     0,     0,    33,    34,     0,    35,   980,     0,
       0,     0,    36,     0,     0,  4644,     0,     0,    37,     0,
       0,    38,     0,     0,     0,     0,     0,     0,    39,     0,
       0,     0,     0,     0,     0,    40,    41,     0,     0,  1833,
    2614,  2614,     0,    42,     0,  2614,     0,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    44,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2614,    45,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    47,     0,
       0,     0,  1122,     0,    48,     0,     0,     0,  1833,    49,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    50,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1833,     0,    51,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    57,     0,     0,  -136,     0,
       0,     0,  1744,     0,     0,     0,     0,     0,  1744,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1833,     0,     0,   980,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5718,     0,     0,     0,     0,  1416,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4593,     0,     0,
       0,     0,  2614,     0,  5748,     0,     0,     0,  2614,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4149,  4149,     0,     0,  3335,
    3335,  3335,  3335,     0,     0,  3335,  3335,  3335,  3335,  3335,
    3335,  3335,  3335,  3335,  3335,  4149,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2614,     0,
     980,  2614,     0,  2614,     0,     0,  4149,  4149,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   980,  2614,  3335,
    3335,  2614,     0,  2614,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4716,
       0,     0,     0,     0,     0,     0,     0,     0,  4720,     0,
       0,     0,     0,     0,     0,  5872,     0,     0,     0,     0,
       0,     0,  3296,     0,     0,     0,  4733,  3296,  3296,     0,
       0,     0,     0,  3312,     0,     0,  4741,     0,     0,  4743,
       0,     0,     0,     0,     0,  4745,     0,  4746,     0,     0,
    2614,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4768,  4769,  4770,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3356,     0,     0,     0,     0,     0,     0,
    2614,  4794,     0,     0,  4797,     0,  4799,     0,     0,     0,
       0,     0,     0,  5948,     0,   980,     0,     0,     0,     0,
       0,     0,  4803,     0,     0,     0,     0,     0,     0,     0,
    4810,  4811,     0,     0,     0,  2614,     0,  4816,     0,     0,
       0,  5970,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3296,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4869,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1833,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3335,     0,     0,     0,     0,
       0,     0,  1833,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1833,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2614,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2614,     0,     0,     0,  2614,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2614,     0,
       0,     0,     0,     0,     0,     0,  2614,     0,  2614,     0,
    2614,  2614,     0,     0,     0,     0,  4149,  4149,  4149,  4149,
       0,     0,     0,  4149,  4149,  4149,  4149,  4149,  4149,  4149,
    4149,  4149,  4149,  2614,  2614,  2614,     0,     0,     0,     0,
       0,     0,     0,     0,  5168,  5169,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5176,     0,     0,     0,  2614,
       0,     0,  2614,     0,  2614,     0,     0,     0,  2614,     0,
       0,  4149,  4149,     0,     0,  2614,  2614,     0,     0,     0,
       0,  2614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  5220,     0,     0,     0,
       0,     0,     0,     0,  2614,     0,     0,     0,     0,     0,
       0,     0,  2696,     0,     0,     0,     0,     0,  2614,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5243,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5262,
    5264,     0,     0,     0,     0,     0,  5268,  5269,     0,     0,
       0,  5270,     0,     0,     0,     0,  5271,     0,     0,  5274,
    5275,     0,     0,     0,     0,     0,  5280,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5314,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1392,     0,     0,     0,     0,     0,     0,     0,  5328,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5356,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  4149,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5405,     0,     0,     0,     0,     0,
       0,  5407,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2614,  2614,     0,     0,     0,     0,     0,
       0,  2614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2614,     0,     0,     0,  5442,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2614,  3335,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2614,     0,  2614,
       0,     0,     0,  2614,  2614,  2614,  2614,     0,     0,  2614,
    2614,     0,     0,     0,     0,  2614,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3335,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2614,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2614,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3296,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  5548,     0,     0,     0,     0,     0,  5552,  5553,
    5554,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2614,     0,  2614,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5567,  5568,     0,     0,  5569,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  5577,     0,     0,     0,  2614,     0,     0,
       0,     0,     0,  5589,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  5607,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    5624,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2614,     0,  4149,  3335,  2614,  2614,  2614,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2614,  2614,  2614,     0,     0,     0,     0,     0,
       0,     0,  2614,     0,     0,     0,     0,  3335,     0,     0,
    4149,     0,     0,     0,  2614,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2614,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2614,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5797,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3356,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2136,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  5876,
       0,     0,  2614,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4149,     0,  5888,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4149,     0,  3335,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5925,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2614,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2614,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2614,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3296,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6005,     0,
       0,     0,     0,     0,     0,     0,     0,  6012,  6012,  6012,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  5607,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6045,
    2614,     0,     0,     0,     0,     0,     0,  2614,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6060,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2614,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2614,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    6012,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3335,  3335,     0,
       0,  3335,     0,     0,     0,  5607,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2614,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2614,     0,     0,  6235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4149,  4149,     0,  4149,     0,     0,     0,
       0,     0,  6260,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2614,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6012,
       0,   235,     0,  1295,   715,     0,  1296,  1297,  1298,   776,
    1299,     0,     0,     0,     0,  6347,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  1738,   245,   246,
     247,     0,     0,     0,     0,  1300,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1301,   261,  1302,  1303,     0,   264,   265,   266,   267,
     268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,  1317,  1318,   312,  1319,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,  1739,     0,   325,   326,   892,   328,   329,
    1744,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1320,   343,   344,   345,   346,
    1321,  1322,   348,     0,   349,   350,   351,  1323,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,  1325,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1326,  1327,     0,  1328,
       0,   396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,  1343,   447,  1344,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
    1346,   460,   461,   462,   463,  1347,  1348,   465,  1349,   467,
     468,   469,     0,   470,   471,   472,     0,     0,  1350,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1353,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  1354,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,  1356,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1359,  1360,     0,     0,   596,   597,  1361,
     599,  1362,  1363,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  1364,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,  1366,  1740,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
       0,  1375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1376,  1377,  1741,     0,     0,     0,     0,
       0,     0,  1379,  1742,   235,     0,  1295,   715,     0,  1296,
    1297,  1298,   776,  1299,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1300,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1301,   261,  1302,  1303,     0,   264,
     265,   266,   267,   268,   269,   270,  1304,  1305,   271,   272,
    1306,  1307,   275,     0,   276,   277,   278,   279,  1308,     0,
    1309,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1310,  1311,  1312,  1313,  1314,
    1315,  1316,   304,   305,   306,   307,   308,   309,  1317,  1318,
     312,  1319,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     892,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1320,   343,
     344,   345,   346,  1321,  1322,   348,     0,   349,   350,   351,
    1323,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1324,     0,  1325,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1326,
    1327,     0,  1328,     0,   396,   397,   398,   399,   400,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1339,   421,   422,   423,     0,   424,   425,   426,  1340,  1341,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1342,   438,   439,   440,   441,   442,   443,   444,   445,  1343,
     447,  1344,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1345,   459,  1346,   460,   461,   462,   463,  1347,  1348,
     465,  1349,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1350,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1351,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1352,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1353,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1354,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,    41,   551,   552,   553,
     554,   555,  1355,   556,   557,   558,   559,   560,   561,   562,
     563,  1356,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1357,
     582,     0,   583,   584,  1358,    45,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1359,  1360,     0,     0,
     596,   597,  1361,   599,  1362,  1363,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1364,   610,   611,   612,
     613,   614,  1365,     0,   615,   616,   617,   618,   619,  1211,
    1366,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,    50,   629,   630,   631,   632,   633,   634,   635,
    1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,   645,
     646,   647,   648,     0,  1375,     0,    51,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1376,  1377,     0,     0,
       0,     0,     0,     0,     0,  1379,  5843,   235,     0,  1295,
     715,     0,  1296,  1297,  1298,   776,  1299,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1300,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1301,   261,  1302,
    1303,     0,   264,   265,   266,   267,   268,   269,   270,  1304,
    1305,   271,   272,  1306,  1307,   275,     0,   276,   277,   278,
     279,  1308,     0,  1309,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,  1310,  1311,
    1312,  1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,
     309,  1317,  1318,   312,  1319,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1320,   343,   344,   345,   346,  1321,  1322,   348,     0,
     349,   350,   351,  1323,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1324,
       0,  1325,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1326,  1327,     0,  1328,     0,   396,   397,   398,
     399,   400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,   410,  1338,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1339,   421,   422,   423,     0,   424,   425,
     426,  1340,  1341,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1342,   438,   439,   440,   441,   442,   443,
     444,   445,  1343,   447,  1344,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1345,   459,  1346,   460,   461,   462,
     463,  1347,  1348,   465,  1349,   467,   468,   469,     0,   470,
     471,   472,     0,     0,  1350,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1351,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1352,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1353,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1354,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1355,   556,   557,   558,   559,
     560,   561,   562,   563,  1356,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1357,   582,     0,   583,   584,  1358,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1359,
    1360,     0,     0,   596,   597,  1361,   599,  1362,  1363,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  1364,
     610,   611,   612,   613,   614,  1365,     0,   615,   616,   617,
     618,   619,   620,  1366,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,
    1373,  1374,   645,   646,   647,   648,     0,  1375,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1376,
    1377,     0,     0,     0,     0,     0,     0,     0,  1379,  3337,
     235,     0,  1295,   715,     0,  1296,  1297,  1298,   776,  1299,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1300,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1301,   261,  1302,  1303,     0,   264,   265,   266,   267,   268,
     269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,     0,
     276,   277,   278,   279,  1308,     0,  1309,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,   305,
     306,   307,   308,   309,  1317,  1318,   312,  1319,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   892,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1320,   343,   344,   345,   346,  1321,
    1322,   348,     0,   349,   350,   351,  1323,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1324,     0,  1325,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1326,  1327,     0,  1328,     0,
     396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,  1333,
    1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1339,   421,   422,   423,
       0,   424,   425,   426,  1340,  1341,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1342,   438,   439,   440,
     441,   442,   443,   444,   445,  1343,   447,  1344,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1345,   459,  1346,
     460,   461,   462,   463,  1347,  1348,   465,  1349,   467,   468,
     469,     0,   470,   471,   472,     0,     0,  1350,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,  1351,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,  1352,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1353,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1354,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1355,   556,
     557,   558,   559,   560,   561,   562,   563,  1356,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1357,   582,     0,   583,   584,
    1358,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,  1359,  1360,     0,     0,   596,   597,  1361,   599,
    1362,  1363,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,  1364,   610,   611,   612,   613,   614,  1365,     0,
     615,   616,   617,   618,   619,   620,  1366,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,  1367,  1368,  1369,  1370,
     640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,     0,
    1375,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1376,  1377,     0,     0,     0,     0,     0,     0,
       0,  1379,  4747,   235,     0,  1295,   715,     0,  1296,  1297,
    1298,   776,  1299,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1300,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1301,   261,  1302,  1303,     0,   264,   265,
     266,   267,   268,   269,   270,  1304,  1305,   271,   272,  1306,
    1307,   275,     0,   276,   277,   278,   279,  1308,     0,  1309,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,  1310,  1311,  1312,  1313,  1314,  1315,
    1316,   304,   305,   306,   307,   308,   309,  1317,  1318,   312,
    1319,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   892,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,  1320,   343,   344,
     345,   346,  1321,  1322,   348,     0,   349,   350,   351,  1323,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,  1324,     0,  1325,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1326,  1327,
       0,  1328,     0,   396,   397,   398,   399,   400,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,  1339,
     421,   422,   423,     0,   424,   425,   426,  1340,  1341,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1342,
     438,   439,   440,   441,   442,   443,   444,   445,  1343,   447,
    1344,   449,   450,   451,   452,   453,   454,   455,   456,   457,
    1345,   459,  1346,   460,   461,   462,   463,  1347,  1348,   465,
    1349,   467,   468,   469,     0,   470,   471,   472,     0,     0,
    1350,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,  1351,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,  1352,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1353,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  1354,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1355,   556,   557,   558,   559,   560,   561,   562,   563,
    1356,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,  1357,   582,
       0,   583,   584,  1358,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,  1359,  1360,     0,     0,   596,
     597,  1361,   599,  1362,  1363,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,  1364,   610,   611,   612,   613,
     614,  1365,     0,   615,   616,   617,   618,   619,   620,  1366,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,  1367,
    1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,   645,   646,
     647,   648,     0,  1375,     0,     0,     0,     0,     0,   656,
       0,     0,     0,     0,     0,  1376,  1377,     0,     0,     0,
       0,     0,     0,     0,  1379,  4813,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,  4252,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0, -1838,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0, -1838,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386, -1838,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399, -1838,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420, -1838,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446, -1838,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533, -1838,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,     0,   884,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1479,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,     0,   885,   261,   886,   887,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   888,   889,   275,     0,   276,   277,   278,   279,     0,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,     0,     0,     0,   303,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   890,
     891,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   892,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,     0,
     343,   344,   345,   346,     0,     0,   348,     0,   349,   350,
     351,   893,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,     0,     0,     0,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,  2739,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,  2740,   389,   390,   391,   392,
     894,   895,     0,   896,     0,   396,   397,   398,   399,   400,
     897,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,     0,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,     0,   438,   439,   440,   441,   442,   443,   444,   445,
     898,   447,   899,   449,   450,   451,   452,   453,   454,   455,
     456,     0,     0,   459,     0,   460,   461,   462,   463,     0,
       0,   465,   900,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,  2742,
     479,   480,   481,     0,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
       0,   498,     0,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   901,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,  2743,   559,   560,   561,
     562,   563,   903,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
       0,   582,     0,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,   904,   905,     0,
       0,   596,   597,     0,   599,     0,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
       0,   906,  2744,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
       0,   884,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   646,   647,   648,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,  2836,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
       0,   885,   261,   886,   887,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   888,   889,   275,
       0,   276,   277,   278,   279,     0,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,     0,     0,     0,   303,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   890,   891,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   892,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,     0,   343,   344,   345,   346,
       0,     0,   348,     0,   349,   350,   351,   893,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,     0,     0,     0,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,  2739,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,  2740,   389,   390,   391,   392,   894,   895,     0,   896,
       0,   396,   397,   398,   399,   400,   897,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,     0,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,     0,   438,   439,
     440,   441,   442,   443,   444,   445,   898,   447,   899,   449,
     450,   451,   452,   453,   454,   455,   456,     0,     0,   459,
       0,   460,   461,   462,   463,     0,     0,   465,   900,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,  2742,   479,   480,   481,     0,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,     0,   498,     0,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   901,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,     0,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,  2743,   559,   560,   561,   562,   563,   903,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,     0,   582,     0,   583,
     584,     0,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   904,   905,     0,     0,   596,   597,     0,
     599,     0,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,     0,   906,  2744,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,     0,   235,     0,  1295,
     715,     0,  1296,  1297,  1298,   776,  1299,   646,   647,   648,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1300,     0,  3968,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1301,   261,  1302,
    1303,     0,   264,   265,   266,   267,   268,   269,   270,  1304,
    1305,   271,   272,  1306,  1307,   275,     0,   276,   277,   278,
     279,  1308,     0,  1309,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,  1310,  1311,
    1312,  1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,
     309,  1317,  1318,   312,  1319,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1320,   343,   344,   345,   346,  1321,  1322,   348,     0,
     349,   350,   351,  1323,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1324,
       0,  1325,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1326,  1327,     0,  1328,     0,   396,   397,   398,
     399,   400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,   410,  1338,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1339,   421,   422,   423,     0,   424,   425,
     426,  1340,  1341,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1342,   438,   439,   440,   441,   442,   443,
     444,   445,  1343,   447,  1344,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1345,   459,  1346,   460,   461,   462,
     463,  1347,  1348,   465,  1349,   467,   468,   469,     0,   470,
     471,   472,     0,     0,  1350,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1351,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1352,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1353,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,  3298,
     532,   533,   534,   535,   536,   537,   538,   539,  1354,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,    41,
     551,   552,   553,   554,   555,  1355,   556,   557,   558,   559,
     560,   561,   562,   563,  1356,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1357,   582,     0,   583,   584,  1358,    45,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1359,
    1360,     0,     0,   596,   597,  1361,   599,  1362,  1363,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  1364,
     610,   611,   612,   613,   614,  1365,     0,   615,   616,   617,
     618,   619,  1211,  1366,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,    50,   629,   630,   631,   632,
     633,   634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,
    1373,  1374,   645,   646,   647,   648,     0,  1375,     0,    51,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1376,
    1377,     0,     0,     0,   235,     0,  1295,   715,  1379,  1296,
    1297,  1298,   776,  1299,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1300,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1301,   261,  1302,  1303,     0,   264,
     265,   266,   267,   268,   269,   270,  1304,  1305,   271,   272,
    1306,  1307,   275,     0,   276,   277,   278,   279,  1308,     0,
    1309,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1310,  1311,  1312,  1313,  1314,
    1315,  1316,   304,   305,   306,   307,   308,   309,  1317,  1318,
     312,  1319,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     892,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1320,   343,
     344,   345,   346,  1321,  1322,   348,     0,   349,   350,   351,
    1323,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1324,     0,  1325,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1326,
    1327,     0,  1328,     0,   396,   397,   398,   399,   400,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1339,   421,   422,   423,     0,   424,   425,   426,  1340,  1341,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1342,   438,   439,   440,   441,   442,   443,   444,   445,  1343,
     447,  1344,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1345,   459,  1346,   460,   461,   462,   463,  1347,  1348,
     465,  1349,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1350,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1351,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1352,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1353,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1354,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,    41,   551,   552,   553,
     554,   555,  1355,   556,   557,   558,   559,   560,   561,   562,
     563,  1356,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1357,
     582,     0,   583,   584,  1358,    45,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1359,  1360,     0,     0,
     596,   597,  1361,   599,  1362,  1363,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1364,   610,   611,   612,
     613,   614,  1365,     0,   615,   616,   617,   618,   619,  1211,
    1366,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,    50,   629,   630,   631,   632,   633,   634,   635,
    1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,   645,
     646,   647,   648,     0,  1375,     0,    51,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1376,  1377,     0,     0,
       0,   235,     0,  1295,   715,  1379,  1296,  1297,  1298,   776,
    1299,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1300,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1301,   261,  1302,  1303,  3343,   264,   265,   266,   267,
     268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,  1317,  1318,   312,  1319,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   892,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1320,   343,   344,   345,   346,
    1321,  1322,   348,     0,   349,   350,   351,  1323,   353,     0,
     354,     0,   355,   356,   357,  3344,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,  1325,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1326,  1327,     0,  1328,
       0,   396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,  3345,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,  1343,   447,  1344,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
    1346,   460,   461,   462,   463,  1347,  1348,   465,  1349,   467,
     468,   469,     0,   470,   471,   472,     0,     0,  1350,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1353,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  1354,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,  1356,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1359,  1360,     0,  3346,   596,   597,  1361,
     599,  1362,  1363,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  1364,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,  1366,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
       0,  1375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1376,  1377,     0,     0,     0,   235,     0,
    1295,   715,  1379,  1296,  1297,  1298,   776,  1299,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244, -2269,   245,   246,   247,     0,     0,
       0, -2269,  1300,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1301,   261,
    1302,  1303,     0,   264,   265,   266,   267,   268,   269,   270,
    1304,  1305,   271,   272,  1306,  1307,   275,     0,   276,   277,
     278,   279,  1308,     0,  1309,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,  1310,
    1311,  1312,  1313,  1314,  1315,  1316,   304,   305,   306,   307,
     308,   309,  1317,  1318,   312,  1319,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   892,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1320,   343,   344,   345,   346,  1321,  1322,   348,
       0,   349,   350,   351,  1323,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1324,     0,  1325,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1326,  1327,     0,  1328,     0,   396,   397,
     398,   399,   400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,   410,  1338,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1339,   421,   422,   423,     0,   424,
     425,   426,  1340,  1341,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1342,   438,   439,   440,   441,   442,
     443,   444,   445,  1343,   447,  1344,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1345,   459,  1346,   460,   461,
     462,   463,  1347,  1348,   465,  1349,   467,   468,   469,     0,
     470,   471,   472,     0,     0,  1350,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,  1351,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,  1352,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1353,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,  1354,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1355,   556,   557,   558,
     559,   560,   561,   562,   563,  1356,   565, -2269,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1357,   582,     0,   583,   584,  1358,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
    1359,  1360,     0,     0,   596,   597,  1361,   599,  1362,  1363,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
    1364,   610,   611,   612,   613,   614,  1365,     0,   615,   616,
     617,   618,   619,   620,  1366,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,  1367,  1368,  1369,  1370,   640,  1371,
    1372,  1373,  1374,   645,   646,   647,   648,     0,  1375,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1376,  1377,     0,     0,     0,   235,     0,  1295,   715,  1379,
    1296,  1297,  1298,   776,  1299,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244, -2267,   245,   246,   247,     0,     0,     0, -2267,  1300,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1301,   261,  1302,  1303,     0,
     264,   265,   266,   267,   268,   269,   270,  1304,  1305,   271,
     272,  1306,  1307,   275,     0,   276,   277,   278,   279,  1308,
       0,  1309,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,  1310,  1311,  1312,  1313,
    1314,  1315,  1316,   304,   305,   306,   307,   308,   309,  1317,
    1318,   312,  1319,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   892,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1320,
     343,   344,   345,   346,  1321,  1322,   348,     0,   349,   350,
     351,  1323,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1324,     0,  1325,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1326,  1327,     0,  1328,     0,   396,   397,   398,   399,   400,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,
    1338,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1339,   421,   422,   423,     0,   424,   425,   426,  1340,
    1341,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1342,   438,   439,   440,   441,   442,   443,   444,   445,
    1343,   447,  1344,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1345,   459,  1346,   460,   461,   462,   463,  1347,
    1348,   465,  1349,   467,   468,   469,     0,   470,   471,   472,
       0,     0,  1350,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,  1351,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
    1352,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1353,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1354,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1355,   556,   557,   558,   559,   560,   561,
     562,   563,  1356,   565, -2267,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
    1357,   582,     0,   583,   584,  1358,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,  1359,  1360,     0,
       0,   596,   597,  1361,   599,  1362,  1363,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,  1364,   610,   611,
     612,   613,   614,  1365,     0,   615,   616,   617,   618,   619,
     620,  1366,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,
     645,   646,   647,   648,     0,  1375,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1376,  1377,     0,
       0,     0,   235,     0,  1295,   715,  1379,  1296,  1297,  1298,
     776,  1299,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1300,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1301,   261,  1302,  1303,     0,   264,   265,   266,
     267,   268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,
     275,     0,   276,   277,   278,   279,  1308,     0,  1309,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,
     304,   305,   306,   307,   308,   309,  1317,  1318,   312,  1319,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,  1320,   343,   344,   345,
     346,  1321,  1322,   348,     0,   349,   350,   351,  1323,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,  1324,     0,  1325,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1326,  1327,     0,
    1328,     0,   396,   397,   398,   399,   400,  1329,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1339,   421,
     422,   423,     0,   424,   425,   426,  1340,  1341,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1342,   438,
     439,   440,   441,   442,   443,   444,   445,  1343,   447,  1344,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1345,
     459,  1346,   460,   461,   462,   463,  1347,  1348,   465,  1349,
     467,   468,   469,     0,   470,   471,   472,     0,     0,  1350,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
    1351,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,  1352,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1353,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  1354,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1355,   556,   557,   558,   559,   560,   561,   562,   563,  1356,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1357,   582,     0,
     583,   584,  1358,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,  1359,  1360,     0,     0,   596,   597,
    1361,   599,  1362,  1363,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,  1364,   610,   611,   612,   613,   614,
    1365,     0,   615,   616,   617,   618,   619,   620,  1366,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,  1367,  1368,
    1369,  1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,
     648,     0,  1375,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1376,  1377,     0,     0,     0,     0,
       0,  2084,  3272,  1379,   235,     0,  1295,   715,     0,  1296,
    1297,  1298,   776,  1299,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1300,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1301,   261,  1302,  1303,     0,   264,
     265,   266,   267,   268,   269,   270,  1304,  1305,   271,   272,
    1306,  1307,   275,     0,   276,   277,   278,   279,  1308,     0,
    1309,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1310,  1311,  1312,  1313,  1314,
    1315,  1316,   304,   305,   306,   307,   308,   309,  1317,  1318,
     312,  1319,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     892,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1320,   343,
     344,   345,   346,  1321,  1322,   348,     0,   349,   350,   351,
    1323,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1324,     0,  1325,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1326,
    1327,     0,  1328,     0,   396,   397,   398,   399,   400,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1339,   421,   422,   423,     0,   424,   425,   426,  1340,  1341,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1342,   438,   439,   440,   441,   442,   443,   444,   445,  1343,
     447,  1344,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1345,   459,  1346,   460,   461,   462,   463,  1347,  1348,
     465,  1349,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1350,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1351,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1352,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1353,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1354,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1355,   556,   557,   558,   559,   560,   561,   562,
     563,  1356,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1357,
     582,     0,   583,   584,  1358,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1359,  1360,     0,     0,
     596,   597,  1361,   599,  1362,  1363,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1364,   610,   611,   612,
     613,   614,  1365,     0,   615,   616,   617,   618,   619,   620,
    1366,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
    1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,   645,
     646,   647,   648,     0,  1375,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1376,  1377,  1378,     0,
       0,   235,     0,  1295,   715,  1379,  1296,  1297,  1298,   776,
    1299,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  2706,   245,   246,
     247,     0,     0,     0,     0,  1300,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1301,   261,  1302,  1303,     0,   264,   265,   266,   267,
     268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,  1317,  1318,   312,  1319,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   892,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1320,   343,   344,   345,   346,
    1321,  1322,   348,     0,   349,   350,   351,  1323,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,  1325,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1326,  1327,     0,  1328,
       0,   396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,  1343,   447,  1344,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
    1346,   460,   461,   462,   463,  1347,  1348,   465,  1349,   467,
     468,   469,     0,   470,   471,   472,     0,     0,  1350,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1353,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  1354,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,  1356,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1359,  1360,     0,     0,   596,   597,  1361,
     599,  1362,  1363,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  1364,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,  1366,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
       0,  1375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1376,  1377,     0,     0,     0,   235,     0,
    1295,   715,  1379,  1296,  1297,  1298,   776,  1299,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1300,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1301,   261,
    1302,  1303,     0,   264,   265,   266,   267,   268,   269,   270,
    1304,  1305,   271,   272,  1306,  1307,   275,     0,   276,   277,
     278,   279,  1308,     0,  1309,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,  1310,
    1311,  1312,  1313,  1314,  1315,  1316,   304,   305,   306,   307,
     308,   309,  1317,  1318,   312,  1319,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   892,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1320,   343,   344,   345,   346,  1321,  1322,   348,
       0,   349,   350,   351,  1323,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1324,     0,  1325,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1326,  1327,     0,  1328,     0,   396,   397,
     398,   399,   400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,   410,  1338,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1339,   421,   422,   423,     0,   424,
     425,   426,  1340,  1341,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1342,   438,   439,   440,   441,   442,
     443,   444,   445,  1343,   447,  1344,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1345,   459,  1346,   460,   461,
     462,   463,  1347,  1348,   465,  1349,   467,   468,   469,     0,
     470,   471,   472,     0,     0,  1350,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,  1351,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,  1352,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1353,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
    3298,   532,   533,   534,   535,   536,   537,   538,   539,  1354,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1355,   556,   557,   558,
     559,   560,   561,   562,   563,  1356,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1357,   582,     0,   583,   584,  1358,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
    1359,  1360,     0,     0,   596,   597,  1361,   599,  1362,  1363,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
    1364,   610,   611,   612,   613,   614,  1365,     0,   615,   616,
     617,   618,   619,   620,  1366,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,  1367,  1368,  1369,  1370,   640,  1371,
    1372,  1373,  1374,   645,   646,   647,   648,     0,  1375,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1376,  1377,     0,     0,     0,   235,     0,  1295,   715,  1379,
    1296,  1297,  1298,   776,  1299,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1300,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,  1301,   261,  1302,  1303,     0,
     264,   265,   266,   267,   268,   269,   270,  1304,  1305,   271,
     272,  1306,  1307,   275,     0,   276,   277,   278,   279,  1308,
       0,  1309,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,  1310,  1311,  1312,  1313,
    1314,  1315,  1316,   304,   305,   306,   307,   308,   309,  1317,
    1318,   312,  1319,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   892,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1320,
     343,   344,   345,   346,  1321,  1322,   348,     0,   349,   350,
     351,  1323,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1324,     0,  1325,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1326,  1327,     0,  1328,     0,   396,   397,   398,   399,   400,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,
    1338,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1339,   421,   422,   423,     0,   424,   425,   426,  1340,
    1341,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1342,   438,   439,   440,   441,   442,   443,   444,   445,
    1343,   447,  1344,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1345,   459,  1346,   460,   461,   462,   463,  1347,
    1348,   465,  1349,   467,   468,   469,     0,   470,   471,   472,
       0,     0,  1350,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,  1351,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
    1352,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1353,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1354,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1355,   556,   557,   558,   559,   560,   561,
     562,   563,  1356,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
    1357,   582,     0,   583,   584,  1358,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,  1359,  1360,     0,
       0,   596,   597,  1361,   599,  1362,  1363,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,  1364,   610,   611,
     612,   613,   614,  1365,     0,   615,   616,   617,   618,   619,
     620,  1366,  3847,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,
     645,   646,   647,   648,     0,  1375,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1376,  1377,     0,
       0,     0,   235,     0,  1295,   715,  1379,  1296,  1297,  1298,
     776,  1299,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1300,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1301,   261,  1302,  1303,     0,   264,   265,   266,
     267,   268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,
     275,     0,   276,   277,   278,   279,  1308,     0,  1309,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,
     304,   305,   306,   307,   308,   309,  1317,  1318,   312,  1319,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,  1320,   343,   344,   345,
     346,  1321,  1322,   348,     0,   349,   350,   351,  1323,   353,
       0,   354,     0,   355,   356,   357,  3344,   358,   359,   360,
     361,   362,     0,   363,  1324,     0,  1325,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1326,  1327,     0,
    1328,     0,   396,   397,   398,   399,   400,  1329,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1339,   421,
     422,   423,     0,   424,   425,   426,  1340,  1341,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1342,   438,
     439,   440,   441,   442,   443,   444,   445,  1343,   447,  1344,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1345,
     459,  1346,   460,   461,   462,   463,  1347,  1348,   465,  1349,
     467,   468,   469,     0,   470,   471,   472,     0,     0,  1350,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
    1351,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,  1352,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1353,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  1354,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1355,   556,   557,   558,   559,   560,   561,   562,   563,  1356,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1357,   582,     0,
     583,   584,  1358,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,  1359,  1360,     0,     0,   596,   597,
    1361,   599,  1362,  1363,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,  1364,   610,   611,   612,   613,   614,
    1365,     0,   615,   616,   617,   618,   619,   620,  1366,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,  1367,  1368,
    1369,  1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,
     648,     0,  1375,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1376,  1377,     0,     0,     0,   235,
       0,  1295,   715,  1379,  1296,  1297,  1298,   776,  1299,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,  1300,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,  1301,
     261,  1302,  1303,     0,   264,   265,   266,   267,   268,   269,
     270,  1304,  1305,   271,   272,  1306,  1307,   275,     0,   276,
     277,   278,   279,  1308,     0,  1309,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
    1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,   305,   306,
     307,   308,   309,  1317,  1318,   312,  1319,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   892,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1320,   343,   344,   345,   346,  1321,  1322,
     348,     0,   349,   350,   351,  1323,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1324,     0,  1325,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1326,  1327,     0,  1328,     0,   396,
     397,   398,   399,   400,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,   410,  1338,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1339,   421,   422,   423,     0,
     424,   425,   426,  1340,  1341,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1342,   438,   439,   440,   441,
     442,   443,   444,   445,  1343,   447,  1344,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1345,   459,  1346,   460,
     461,   462,   463,  1347,  1348,   465,  1349,   467,   468,   469,
       0,   470,   471,   472,     0,     0,  1350,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1351,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1352,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1353,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
    1354,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1355,   556,   557,
     558,   559,   560,   561,   562,   563,  1356,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1357,   582,     0,   583,   584,  1358,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,  1359,  1360,  3401,     0,   596,   597,  1361,   599,  1362,
    1363,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,  1364,   610,   611,   612,   613,   614,  1365,     0,   615,
     616,   617,   618,   619,   620,  1366,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,  1367,  1368,  1369,  1370,   640,
    1371,  1372,  1373,  1374,   645,   646,   647,   648,     0,  1375,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1376,  1377,     0,     0,     0,   235,     0,  1295,   715,
    1379,  1296,  1297,  1298,   776,  1299,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1300,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,  1301,   261,  1302,  1303,
       0,   264,   265,   266,   267,   268,   269,   270,  1304,  1305,
     271,   272,  1306,  1307,   275,     0,   276,   277,   278,   279,
    1308,     0,  1309,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,   309,
    1317,  1318,   312,  1319,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   892,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1320,   343,   344,   345,   346,  1321,  1322,   348,     0,   349,
     350,   351,  1323,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1324,     0,
    1325,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1326,  1327,     0,  1328,     0,   396,   397,   398,   399,
     400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
     410,  1338,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1339,   421,   422,   423,     0,   424,   425,   426,
    1340,  1341,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1342,   438,   439,   440,   441,   442,   443,   444,
     445,  1343,   447,  1344,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1345,   459,  1346,   460,   461,   462,   463,
    1347,  1348,   465,  1349,   467,   468,   469,     0,   470,   471,
     472,     0,     0,  1350,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1351,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1352,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1353,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  1354,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1355,   556,   557,   558,   559,   560,
     561,   562,   563,  1356,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1357,   582,     0,   583,   584,  1358,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,  1359,  1360,
       0,     0,   596,   597,  1361,   599,  1362,  1363,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,  1364,   610,
     611,   612,   613,   614,  1365,     0,   615,   616,   617,   618,
     619,   620,  1366,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,
    1374,   645,   646,   647,   648,     0,  1375,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1376,  1377,
       0,     0,     0,   235,     0,  1295,   715,  1379,  1296,  1297,
    1298,   776,  1299,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1300,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1301,   261,  1302,  1303,     0,   264,   265,
     266,   267,   268,   269,   270,  1304,  1305,   271,   272,  1306,
    1307,   275,     0,   276,   277,   278,   279,  1308,     0,  1309,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,  1310,  1311,  1312,  1313,  1314,  1315,
    1316,   304,   305,   306,   307,   308,   309,  1317,  1318,   312,
    1319,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   892,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,  1320,   343,   344,
     345,   346,  1321,  1322,   348,     0,   349,   350,   351,  1323,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,  1324,     0,  1325,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1326,  1327,
       0,  1328,     0,   396,   397,   398,   399,   400,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,  1339,
     421,   422,   423,     0,   424,   425,   426,  1340,  1341,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1342,
     438,   439,   440,   441,   442,   443,   444,   445,  1343,   447,
    1344,   449,   450,   451,   452,   453,   454,   455,   456,   457,
    1345,   459,  1346,   460,   461,   462,   463,  1347,  1348,   465,
    1349,   467,   468,   469,     0,   470,   471,   472,     0,     0,
    1350,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,  1351,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,  1352,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1353,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  1354,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1355,   556,   557,   558,   559,   560,   561,   562,   563,
    1356,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,  1357,   582,
       0,   583,   584,  1358,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,  1359,  1360,     0,     0,   596,
     597,  1361,   599,  1362,  1363,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,  1364,   610,   611,   612,   613,
     614,  1365,     0,   615,   616,   617,   618,   619,   620,  1366,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,  1367,
    1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,   645,   646,
     647,   648,     0,  1375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2709,  2710,     0,     0,     0,
     235,     0,  3517,   715,  1379,  1296,  1297,  1298,   776,  1299,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,  1300,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1301,   261,  1302,  1303,     0,   264,   265,   266,   267,   268,
     269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,     0,
     276,   277,   278,   279,  1308,     0,  1309,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,   305,
     306,   307,   308,   309,  1317,  1318,   312,  1319,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   892,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,  1320,   343,   344,   345,   346,  1321,
    1322,   348,     0,   349,   350,   351,  1323,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,  1324,     0,  1325,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1326,  1327,     0,  1328,     0,
     396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,  1333,
    1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,  1339,   421,   422,   423,
       0,   424,   425,   426,  1340,  1341,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,  1342,   438,   439,   440,
     441,   442,   443,   444,   445,  1343,   447,  1344,   449,   450,
     451,   452,   453,   454,   455,   456,   457,  1345,   459,  1346,
     460,   461,   462,   463,  1347,  1348,   465,  1349,   467,   468,
     469,     0,   470,   471,   472,     0,     0,  1350,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,  1351,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,  1352,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1353,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,  1354,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,  1355,   556,
     557,   558,   559,   560,   561,   562,   563,  1356,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,  1357,   582,     0,   583,   584,
    1358,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,  1359,  1360,     0,     0,   596,   597,  1361,   599,
    1362,  1363,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,  1364,   610,   611,   612,   613,   614,  1365,     0,
     615,   616,   617,   618,   619,   620,  1366,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,  1367,  1368,  1369,  1370,
     640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,     0,
    1375,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1376,  1377,     0,     0,     0,   235,     0,  1295,
     715,  1379,  1296,  1297,  1298,   776,  1299,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1300,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1301,   261,  1302,
    1303,     0,   264,   265,   266,   267,   268,   269,   270,  1304,
    1305,   271,   272,  1306,  1307,   275,     0,   276,   277,   278,
     279,  1308,     0,  1309,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,  4868,  1310,  1311,
    1312,  1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,
     309,  1317,  1318,   312,  1319,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1320,   343,   344,   345,   346,  1321,  1322,   348,     0,
     349,   350,   351,  1323,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1324,
       0,  1325,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1326,  1327,     0,  1328,     0,   396,   397,   398,
     399,   400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,   410,  1338,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1339,   421,   422,   423,     0,   424,   425,
     426,  1340,  1341,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1342,   438,   439,   440,   441,   442,   443,
     444,   445,  1343,   447,  1344,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1345,   459,  1346,   460,   461,   462,
     463,  1347,  1348,   465,  1349,   467,   468,   469,     0,   470,
     471,   472,     0,     0,  1350,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1351,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1352,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1353,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  1354,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1355,   556,   557,   558,   559,
     560,   561,   562,   563,  1356,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1357,   582,     0,   583,   584,  1358,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1359,
    1360,     0,     0,   596,   597,  1361,   599,  1362,  1363,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  1364,
     610,   611,   612,   613,   614,  1365,     0,   615,   616,   617,
     618,   619,   620,  1366,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,
    1373,  1374,   645,   646,   647,   648,     0,  1375,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1376,
    1377,     0,     0,     0,   235,     0,  1295,   715,  1379,  1296,
    1297,  1298,   776,  1299,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,  1300,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,  1301,   261,  1302,  1303,     0,   264,
     265,   266,   267,   268,   269,   270,  1304,  1305,   271,   272,
    1306,  1307,   275,     0,   276,   277,   278,   279,  1308,     0,
    1309,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,  1310,  1311,  1312,  1313,  1314,
    1315,  1316,   304,   305,   306,   307,   308,   309,  1317,  1318,
     312,  1319,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     892,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,  1320,   343,
     344,   345,   346,  1321,  1322,   348,     0,   349,   350,   351,
    1323,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,  1324,     0,  1325,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,  1326,
    1327,     0,  1328,     0,   396,   397,   398,   399,   400,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
    1339,   421,   422,   423,     0,   424,   425,   426,  1340,  1341,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
    1342,   438,   439,   440,   441,   442,   443,   444,   445,  1343,
     447,  1344,   449,   450,   451,   452,   453,   454,   455,   456,
     457,  1345,   459,  1346,   460,   461,   462,   463,  1347,  1348,
     465,  1349,   467,   468,   469,     0,   470,   471,   472,     0,
       0,  1350,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,  1351,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,  1352,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,  1353,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,  1354,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,  1355,   556,   557,   558,   559,   560,   561,   562,
     563,  1356,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,  1357,
     582,     0,   583,   584,  1358,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,  1359,  1360,     0,     0,
     596,   597,  1361,   599,  1362,  1363,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,  1364,   610,   611,   612,
     613,   614,  1365,     0,   615,   616,   617,   618,   619,   620,
    1366,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,  5251,
    1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,   645,
     646,   647,   648,     0,  1375,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1376,  1377,     0,     0,
       0,   235,     0,  1295,   715,  1379,  1296,  1297,  1298,   776,
    1299,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1300,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1301,   261,  1302,  1303,     0,   264,   265,   266,   267,
     268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,  1317,  1318,   312,  1319,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   892,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1320,   343,   344,   345,   346,
    1321,  1322,   348,     0,   349,   350,   351,  1323,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,  1325,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1326,  1327,     0,  1328,
       0,   396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,  1343,   447,  1344,   449,
     450,   451,   452,   453,   454,   455,  5263,   457,  1345,   459,
    1346,   460,   461,   462,   463,  1347,  1348,   465,  1349,   467,
     468,   469,     0,   470,   471,   472,     0,     0,  1350,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1353,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  1354,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,  1356,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1359,  1360,     0,     0,   596,   597,  1361,
     599,  1362,  1363,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  1364,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,  1366,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
       0,  1375,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1376,  1377,     0,     0,     0,   235,     0,
    1295,   715,  1379,  1296,  1297,  1298,   776,  1299,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,  1300,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,  1301,   261,
    1302,  1303,     0,   264,   265,   266,   267,   268,   269,   270,
    1304,  1305,   271,   272,  1306,  1307,   275,     0,   276,   277,
     278,   279,  1308,     0,  1309,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,  5597,   302,  1310,
    1311,  1312,  1313,  1314,  1315,  1316,   304,   305,   306,   307,
     308,   309,  1317,  1318,   312,  1319,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   892,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,  1320,   343,   344,   345,   346,  1321,  1322,   348,
       0,   349,   350,   351,  1323,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
    1324,     0,  5598,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,  1326,  1327,     0,  1328,     0,   396,   397,
     398,   399,   400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,   410,  1338,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,  1339,   421,   422,   423,     0,   424,
     425,   426,  1340,  1341,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,  1342,   438,   439,   440,   441,   442,
     443,   444,   445,  1343,   447,  1344,   449,   450,   451,   452,
     453,   454,   455,   456,   457,  1345,   459,  1346,   460,   461,
     462,   463,  1347,  1348,   465,  1349,   467,   468,   469,     0,
     470,   471,   472,     0,     0,  1350,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,  1351,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,  1352,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,  1353,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,  5599,   538,   539,  1354,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,  1355,   556,   557,   558,
     559,   560,   561,   562,   563,  1356,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,  1357,   582,     0,   583,   584,  1358,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
    1359,  1360,     0,     0,   596,   597,  1361,   599,  1362,  1363,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
    1364,   610,   611,   612,   613,   614,  1365,     0,   615,   616,
     617,   618,   619,   620,  1366,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,  1367,  1368,  1369,  1370,   640,  1371,
    1372,  1373,  1374,   645,   646,   647,   648,     0,  1375,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1376,  1377,     0,     0,     0,   235,     0,  1295,   715,  5600,
    1296,  1297,  1298,   776,  1299,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,  1300,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,  6009,  1301,   261,  1302,  1303,     0,
     264,   265,   266,   267,   268,   269,   270,  1304,  1305,   271,
     272,  1306,  1307,   275,     0,   276,   277,   278,   279,  1308,
       0,  1309,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,  6010,  1310,  1311,  1312,  1313,
    1314,  1315,  1316,   304,   305,   306,   307,   308,   309,  1317,
    1318,   312,  1319,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   892,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,  1320,
     343,   344,   345,   346,  1321,  1322,   348,     0,   349,   350,
     351,  1323,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,  1324,     0,  1325,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
    1326,  1327,     0,  1328,     0,   396,   397,   398,   399,   400,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,
    1338,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,  1339,   421,   422,   423,     0,   424,   425,   426,  1340,
    1341,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,  1342,   438,   439,   440,   441,   442,   443,   444,   445,
    1343,   447,  1344,   449,   450,   451,   452,   453,   454,   455,
     456,   457,  1345,   459,  1346,   460,   461,   462,   463,  1347,
    1348,   465,  1349,   467,   468,   469,     0,   470,   471,   472,
       0,     0,  1350,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,  1351,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
    1352,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,  1353,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,  1354,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,  1355,   556,   557,   558,   559,   560,   561,
     562,   563,  1356,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
    1357,   582,     0,   583,   584,  1358,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,  1359,  1360,     0,
       0,   596,   597,  1361,   599,  1362,  1363,   601,   602,   603,
     604,   605,  6011,   607,   608,   609,     0,  1364,   610,   611,
     612,   613,   614,  1365,     0,   615,   616,   617,   618,   619,
     620,  1366,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,
     645,   646,   647,   648,     0,  1375,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1376,  1377,     0,
       0,     0,   235,     0,  1295,   715,  1379,  1296,  1297,  1298,
     776,  1299,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,  1300,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,  1301,   261,  1302,  1303,     0,   264,   265,   266,
     267,   268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,
     275,     0,   276,   277,   278,   279,  1308,     0,  1309,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,  6010,  1310,  1311,  1312,  1313,  1314,  1315,  1316,
     304,   305,   306,   307,   308,   309,  1317,  1318,   312,  1319,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,  1320,   343,   344,   345,
     346,  1321,  1322,   348,     0,   349,   350,   351,  1323,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,  1324,     0,  1325,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,  1326,  1327,     0,
    1328,     0,   396,   397,   398,   399,   400,  1329,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,  1339,   421,
     422,   423,     0,   424,   425,   426,  1340,  1341,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,  1342,   438,
     439,   440,   441,   442,   443,   444,   445,  1343,   447,  1344,
     449,   450,   451,   452,   453,   454,   455,   456,   457,  1345,
     459,  1346,   460,   461,   462,   463,  1347,  1348,   465,  1349,
     467,   468,   469,     0,   470,   471,   472,     0,     0,  1350,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
    1351,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,  1352,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,  1353,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,  1354,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
    1355,   556,   557,   558,   559,   560,   561,   562,   563,  1356,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,  1357,   582,     0,
     583,   584,  1358,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,  1359,  1360,     0,     0,   596,   597,
    1361,   599,  1362,  1363,   601,   602,   603,   604,   605,  6011,
     607,   608,   609,     0,  1364,   610,   611,   612,   613,   614,
    1365,     0,   615,   616,   617,   618,   619,   620,  1366,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,  1367,  1368,
    1369,  1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,
     648,     0,  1375,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1376,  1377,     0,     0,     0,   235,
       0,  1295,   715,  1379,  1296,  1297,  1298,   776,  1299,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,  1300,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,  1301,
     261,  1302,  1303,     0,   264,   265,   266,   267,   268,   269,
     270,  1304,  1305,   271,   272,  1306,  1307,   275,     0,   276,
     277,   278,   279,  1308,     0,  1309,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
    1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,   305,   306,
     307,   308,   309,  1317,  1318,   312,  5582,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   892,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,  1320,   343,   344,   345,   346,  1321,  1322,
     348,     0,   349,   350,   351,  1323,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,  1324,     0,  1325,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,  1326,  1327,     0,  1328,     0,   396,
     397,   398,   399,   400,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,   410,  1338,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,  1339,   421,   422,   423,     0,
     424,   425,   426,  1340,  1341,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,  1342,   438,   439,   440,   441,
     442,   443,   444,   445,  1343,   447,  1344,   449,   450,   451,
     452,   453,   454,   455,   456,   457,  1345,   459,     0,   460,
     461,   462,   463,  1347,  1348,   465,  1349,   467,   468,   469,
       0,   470,   471,   472,     0,     0,  1350,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,  1351,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,  1352,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,  1353,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
    3329,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,  1355,   556,   557,
     558,   559,   560,   561,   562,   563,  1356,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,  1357,   582,     0,   583,   584,  1358,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,  1359,  1360,     0,     0,   596,   597,  1361,   599,  1362,
    1363,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,  1365,     0,   615,
     616,   617,   618,   619,   620,  1366,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,  1367,  1368,  1369,  1370,   640,
    1371,  1372,  1373,  1374,   645,   646,   647,   648,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3330,  3331,     0,     0,     0,   235,     0,  1295,   715,
    3332,  1296,  1297,  1298,   776,  1299,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1300,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258, -2992,  1301,   261,  1302,  1303,
       0,   264,   265,   266,   267,   268,   269,   270,  1304,  1305,
     271,   272,  1306,  1307,   275,     0,   276,   277,   278,   279,
    1308,     0,  1309,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,  6010,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,   309,
    1317,  1318,   312,  1319,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   892,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1320,   343,   344,   345,   346,  1321,  1322,   348,     0,   349,
     350,   351,  1323,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1324,     0,
    1325,   366,   367,     0,   368,   369,   370,   371,   372, -2992,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1326,  1327,     0,  1328,     0,   396,     0,     0,   399,
     400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
     410,  1338,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1339,   421,   422, -2992,     0,   424,   425,   426,
    1340,  1341,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1342,   438,   439,   440,   441,   442,   443,   444,
     445,  1343,   447,  1344,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1345,   459,  1346,   460,   461,     0,   463,
    1347,  1348,   465,  1349,   467,   468,   469,     0,   470,   471,
     472,     0,     0,  1350,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1351,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1352,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1353,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  1354,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1355,   556,   557,   558,   559,   560,
   -2992,   562,   563,  1356,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1357,   582,     0,   583,   584,  1358,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,  1359,  1360,
       0,     0,   596,   597,  1361,   599,  1362,  1363,   601,   602,
     603,   604,   605,  6011,   607,   608,   609,     0,  1364,   610,
     611,   612,   613,   614,  1365,     0,   615,   616,   617,   618,
     619,   620,  1366,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,
    1374,   645,   646,   647,   648,     0, -2992,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1376,  1377,
       0,     0,     0,   235,     0,  1295,   715,  1379,  1296,  1297,
    1298,   776,  1299,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,  1300,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,  1301,   261,  1302,  1303,     0,   264,   265,
     266,   267,   268,   269,   270,  1304,  1305,   271,   272,  1306,
    1307,   275,     0,   276,   277,   278,   279,  1308,     0,  1309,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,  1310,  1311,  1312,  1313,  1314,  1315,
    1316,   304,   305,   306,   307,   308,   309,  1317,  1318,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   892,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,  1320,   343,   344,
     345,   346,  1321,  1322,   348,     0,   349,   350,   351,  1323,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,  1324,     0,  1325,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,  1326,  1327,
       0,  1328,     0,   396,   397,   398,   399,   400,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,   410,  1338,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,  1339,
     421,   422,   423,     0,   424,   425,   426,  1340,  1341,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,  1342,
     438,   439,   440,   441,   442,   443,   444,   445,  1343,   447,
    1344,   449,   450,   451,   452,   453,   454,   455,   456,   457,
    1345,   459,     0,   460,   461,   462,   463,  1347,  1348,   465,
    1349,   467,   468,   469,     0,   470,   471,   472,     0,     0,
    1350,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,  1351,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,  1352,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,  1353,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,  3329,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,  1355,   556,   557,   558,   559,   560,   561,   562,   563,
    1356,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,  1357,   582,
       0,   583,   584,  1358,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,  1359,  1360,     0,     0,   596,
     597,  1361,   599,  1362,  1363,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,  1365,     0,   615,   616,   617,   618,   619,   620,  1366,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,  1367,
    1368,  1369,  1370,   640,  1371,  1372,  1373,  1374,   645,   646,
     647,   648,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3330,  3331,   235,     0,  1295,
     715,     0,  1296,  1297,  3332,   776,  1299,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,  1300,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,  1301,   261,  1302,
    1303,     0,   264,   265,   266,   267,   268,   269,   270,  1304,
    1305,   271,   272,  1306,  1307,   275,     0,   276,   277,   278,
     279,  1308,     0,  1309,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,  1310,  1311,
    1312,  1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,
     309,  1317,  1318,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,  1320,   343,   344,   345,   346,  1321,  1322,   348,     0,
     349,   350,   351,  1323,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,  1324,
       0,  1325,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,  1326,  1327,     0,  1328,     0,   396,   397,   398,
     399,   400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,   410,  1338,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,  1339,   421,   422,   423,     0,   424,   425,
     426,  1340,  1341,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,  1342,   438,   439,   440,   441,   442,   443,
     444,   445,  1343,   447,  1344,   449,   450,   451,   452,   453,
     454,   455,   456,   457,  1345,   459,     0,   460,   461,   462,
     463,  1347,  1348,   465,  1349,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,  1351,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,  1352,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
    1353,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,  3506,  3507,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,  1355,   556,   557,   558,   559,
     560,   561,   562,   563,  1356,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,  1357,   582,     0,   583,   584,  1358,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,  1359,
    1360,     0,     0,   596,   597,  1361,   599,  1362,  1363,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,  1365,     0,   615,   616,   617,
     618,   619,   620,  1366,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,
    1373,  1374,   645,   646,   647,   648,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3508,
    3509,   235,     0,  1295,   715,     0,  1296,  1297,  3332,   776,
    1299,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1300,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1301,   261,  1302,  1303,     0,   264,   265,   266,   267,
     268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,  1317,  1318,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   892,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1320,   343,   344,   345,   346,
    1321,  1322,   348,     0,   349,   350,   351,  1323,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,  1325,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1326,  1327,     0,  1328,
       0,   396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,  1343,   447,  1344,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
       0,   460,   461,   462,   463,  1347,  1348,   465,  1349,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1353,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  3329,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,  1356,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1359,  1360,     0,     0,   596,   597,  1361,
     599,  1362,  1363,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,  1366,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
       0,     0,     0,     0,     0,     0,   235,     0,  1295,   715,
       0,  1296,  1297,     0,   776,  1299,     0,     0,     0,     0,
       0,     0,  3332,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
    1300,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,  1301,   261,  1302,  1303,
       0,   264,  4778,   266,   267,   268,   269,   270,  1304,  1305,
     271,   272,  1306,  1307,   275,     0,   276,   277,   278,   279,
    1308,     0,  1309,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,   309,
    1317,  1318,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   892,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
    1320,   343,   344,   345,   346,  1321,  1322,   348,     0,   349,
     350,   351,  1323,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1324,     0,
    1325,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,  1326,  1327,     0,  1328,     0,   396,   397,   398,   399,
     400,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
     410,  1338,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1339,   421,   422,   423,     0,   424,   425,   426,
    1340,  1341,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1342,   438,   439,   440,   441,   442,   443,   444,
     445,  1343,   447,  1344,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1345,   459,     0,   460,   461,   462,   463,
    1347,  1348,   465,  1349,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1351,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1352,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,  1353,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,  3329,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1355,   556,   557,   558,   559,   560,
     561,   562,   563,  1356,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1357,   582,     0,   583,   584,  1358,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,  1359,  1360,
       0,     0,   596,   597,  1361,   599,  1362,  1363,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,  1365,     0,   615,   616,   617,   618,
     619,   620,  1366,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,
    1374,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,   235,     0,  1295,   715,     0,  1296,  1297,     0,   776,
    1299,     0,     0,     0,     0,     0,     0,  3332,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,  1300,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,  1301,   261,  1302,  1303,     0,   264,   265,   266,   267,
     268,   269,   270,  1304,  1305,   271,   272,  1306,  1307,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,  1317,  1318,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   892,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,  1320,   343,   344,   345,   346,
    1321,  1322,   348,     0,   349,   350,   351,  1323,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,  1325,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,  1326,  1327,     0,  1328,
       0,   396,   397,   398,   399,   400,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,  1343,   447,  1344,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
       0,   460,   461,   462,   463,  1347,  1348,   465,  1349,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,  1353,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,  3329,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,  1356,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,  1359,  1360,     0,     0,   596,   597,  1361,
     599,  1362,  1363,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,  1366,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,  4837,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
       0,     0,     0,     0,     0,     0,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3332,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,  1305,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
    1308,     0,  1309,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,  1321,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1324,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,  3477,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    3478,  1338,   412,   413,   414,   415,   416,   417,   418,  3479,
       0,   419,  1339,   421,   422,   423,     0,   424,   425,   426,
    1340,  1341,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1342,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1345,   459,     0,   460,   461,   462,   463,
       0,  1348,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,   867,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1351,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1352,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,  3480,   542,
     543,   544,   545,   546,   547,   548,   549,   550,    41,   551,
     552,   553,   554,   555,  1355,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1357,   582,     0,   583,   584,  1358,    45,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,  1361,   599,  1362,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,  1365,     0,   615,   616,   617,   618,
     619,  1211,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,    50,   629,   630,   631,   632,   633,
     634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,
    1374,  3481,   646,   647,   648,     0,     0,     0,    51,     0,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3482,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,  1305,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
    1321,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,  3477,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,  3478,  1338,   412,   413,   414,
     415,   416,   417,   418,  3479,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
       0,   460,   461,   462,   463,     0,  1348,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,   867,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,  3480,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,  1361,
     599,  1362,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,  3481,   646,   647,   648,
       0,     0,     0,     0,     0,     0,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3482,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,  1305,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
    1308,     0,  1309,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,  1321,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1324,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,  3477,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
     410,  1338,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1339,   421,   422,   423,     0,   424,   425,   426,
    1340,  1341,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1342,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1345,   459,     0,   460,   461,   462,   463,
       0,  1348,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1351,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1352,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1355,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1357,   582,     0,   583,   584,  1358,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,  1361,   599,  1362,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,  1365,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,
    1374,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3926,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,  1305,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
    1321,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,  3477,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,  3478,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
       0,   460,   461,   462,   463,     0,  1348,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,  3480,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,  1361,
     599,  1362,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,  3481,   646,   647,   648,
       0,     0,     0,     0,     0,     0,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,  1305,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
    1308,     0,  1309,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,  1310,  1311,  1312,
    1313,  1314,  1315,  1316,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,  1321,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,  1324,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,  3477,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
     410,  1338,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,  1339,   421,   422,   423,     0,   424,   425,   426,
    1340,  1341,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1342,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,  1345,   459,     0,   460,   461,   462,   463,
       0,  1348,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,  1351,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,  1352,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,  1355,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,  1357,   582,     0,   583,   584,  1358,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,  1361,   599,  1362,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,  1365,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,  1367,  1368,  1369,  1370,   640,  1371,  1372,  1373,
    1374,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  4923,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,  1305,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
    1321,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,  3477,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
       0,   460,   461,   462,   463,     0,  1348,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,  1361,
     599,  1362,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
       0,     0,     0,     0,     0,     0,   972,     0,  1616,   715,
       0,     0,     0,     0,   776,     0,     0,     0,     0,     0,
       0,     0,  6117,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,     0,     0,     0,
     303,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,  5903,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1839,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,  1840,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,  1841,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,   972,     0,     0,     0,     0,     0,     0,  1617,  1618,
    5904,     0,     0,     0,     0,     0,     0,  5905,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     3,     4,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,     0,     0,     0,   303,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,    41,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,    45,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,  1211,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,    50,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
    1051,     0,     0,    51,     0,     0,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,     0,     0,     0,
     303,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  5654,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,    41,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,    45,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,  1211,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,    50,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
       0,     0,     0,    51,     0,     0,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    57,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
    2915,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,   867,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,  2916,  2917,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1873,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
       0,     0,     0,     0,     0,     0,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1427,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3540,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
       0,     0,     0,     0,     0,     0,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4217,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2142,     0,     0,     0,     0,     0,
       0,  2143,     0,     0,  2144,     0,     0,  4854,  2145,  2146,
    2147,  2148,  2149,  2150,  2151,  2152,  2153,  2154,  2155,  2156,
    2157,  2158,  2159,  2160,  2161,  2162,  2163,  2164,     0,  2165,
    2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,  2175,
    2176,  2177,  2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,
    2186,  2187,  2188,  2189,  2190,  2191,  2192,  2193,  2194,  2195,
       0,     0,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,
    2204,  2205,  2206,  2207,  2208,  2209,  2210,  2211,  2212,  2213,
    2214,  2215,  2216,  2217,  2218,  2219,  2220,  2221,  2222,  2223,
       0,  2224,  2225,  2226,  2227,  2228,  2229,  2230,  2231,  2232,
    2233,  2234,  2235,  2236,  2237,  2238,     0,  2239,  2240,  2241,
    2242,  2243,  2244,  2245,  2246,  2247,  2248,  2249,  2250,  2251,
    2252,  2253,  2254,  2255,  2256,  2257,  2258,  2259,  2260,  2261,
    2262,  2263,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,
    2272,  2273,  2274,     0,  2275,  2276,  2277,  2278,  2279,  2280,
    2281,  2282,  2283,  2284,  2285,  2286,     0,     0,  2287,  2288,
    2289,  2290,     0,  2291,  2292,  2293,  2294,  2295,     0,  2296,
    2297,  2298,  2299,  2300,     0,  2301,  2302,     0,  2303,  2304,
    2305,     0,  2306,  2307,     0,  2308,  2309,  2310,  2311,  2312,
    2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,  2321,  2322,
    2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,
    2333,     0,  2334,     0,  2335,  2336,  2337,  2338,  2339,  2340,
    2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,     0,  2365,  2366,  2367,  2368,  2369,
    2370,  2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,
    2380,  2381,     0,  2382,  2383,     0,  2384,  2385,  2386,  2387,
    2388,  2389,  2390,  2391,  2392,  2393,  2394,  2395,  2396,  2397,
    2398,  2399,  2400,  2401,  2402,  2403,  2404,  2405,  2406,  2407,
    2408,  2409,  2410,  2411,  2412,     0,  2413,  2414,  2415,     0,
    2416,  2417,  2418,  2419,  2420,     0,  2421,  2422,  2423,  2424,
       0,     0,  2425,  2426,  2427,  2428,  2429,  2430,  2431,  2432,
    2433,  2434,  2435,  2436,     0,  2437,  2438,  2439,  2440,  2441,
    2442,     0,  2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,
    2451,  2452,  2453,  2454,  2455,  2456,  2457,  2458,  2459,  2460,
    2461,  2462,  2463,  2464,  2465,  2466,  2467,  2468,  2469,  2470,
    2471,  2472,  2473,  2474,  2475,  2476,     0,  2477,  2478,  2479,
    2480,  2481,  2482,  2483,  2484,  2485,  2486,  2487,  2488,  2489,
    2490,  2491,  2492,  2493,     0,  2494,  2495,  2496,  2497,  2498,
    2499,  2500,  2501,  2502,  2503,  2504,  2505,  2506,  2507,  2508,
    2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,  2517,  2518,
    2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,  2528,
    2529,  2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,     0,  2547,
    2548,  2549,  2550,  2551,  2552,  2553,  2554,  2555,  2556,  2557,
    2558,  2559,  2560,  2561,  2562,     0,  2563,  2564,  2565,  2566,
    2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,  2575,  2576,
    2577,  2578,     0,  2579,  2580,  2581,  2582,  2583,  2584,     0,
    2585,     0,     0,     0,     0,  2586,  2587,  2588,  2589,  2590,
    2591,  2592,  2593,  2594,  2595,  2596,  2597,  2598,  2599,  2600,
       0,  2601,  2602,     0,  2603,     0,     0,     0,     0,     0,
       0,     0,     0,  2604,  2605,  2606,  2607,  2608,  2609,  2610,
    2611,  2612,   884,     0,  1616,   715,     0,     0,     0,   987,
     776,     0,     0,     0,     0,     0,   988,   989,   990,   236,
     237,   238,   239,   240,   241,   242,   243,   244,  1751,   245,
     246,   247,  1752,  1753,  1754,  1755,  1756,  1757,  1758,   248,
     249,   250,  1759,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   885,   261,   886,   887,  1760,   264,   265,   266,
     267,   268,   269,   270,  1761,  1762,   271,   272,   888,   889,
     275,  1763,   276,   277,   278,   279,     0,  1764,   281,  1765,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,  1766,   293,   294,   295,   296,   297,   298,  1767,   299,
     300,   301,   302,  1768,  1769,  1770,   303,  1771,  1772,  1773,
     304,   305,   306,   307,   308,   309,   890,   891,   312,  1774,
     313,  1775,   314,   315,   316,   317,   318,   319,   320,  1776,
     321,   322,   323,   324,  1777,  1778,   325,   326,   892,   328,
     329,  1779,   330,   331,   332,   333,  1780,   334,   335,   336,
     337,  1781,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,  1782,   348,  1783,   349,   350,   351,   893,   353,
    1784,   354,  1785,   355,   356,   357,  1786,   358,   359,   360,
     361,   362,  1787,   363,     0,  1788,     0,   366,   367,  1789,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1790,   378,   379,   380,   381,   382,   383,   384,   385,  1791,
     386,   387,     0,   389,   390,   391,   392,   894,   895,  1792,
     896,  1793,   396,   397,   398,   399,   400,   897,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,  1794,  1795,   419,     0,   421,
     422,   423,  1796,   424,   425,   426,  1797,  1798,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   898,   447,   899,
     449,   450,   451,   452,   453,   454,   455,   456,  4537,     0,
     459,  1799,   460,   461,   462,   463,  1800,     0,   465,   900,
     467,   468,   469,  1801,   470,   471,   472,  1802,  1803,  4538,
     474,   475,  1804,  1805,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,  1806,   494,   495,   496,     0,   498,     0,
     500,   501,   502,  1807,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   901,   515,   516,   517,   518,
    1808,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  1809,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1810,   551,   552,   553,   554,   555,
    1811,   556,   557,  2743,   559,   560,   561,   562,   563,   903,
     565,  1812,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,  1813,
     583,   584,  1814,  1815,   585,   586,   587,   588,   589,   590,
     591,   592,  1816,   593,   904,   905,  1817,  1818,   596,   597,
       0,   599,     0,  1819,   601,   602,   603,   604,   605,   606,
     607,   608,   609,  1820,  1821,   610,   611,   612,   613,   614,
    1822,  1823,   615,   616,   617,   618,   619,     0,   906,  1824,
     622,   623,   624,   625,   626,   627,  1825,  1826,   628,  1827,
    1828,   629,   630,   631,   632,   633,   634,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   993,   994,   995,  4539,  4540,   998,   999,  1000,  1001,
     884,     0,  1616,   715,     0,     0,     0,   987,   776,     0,
       0,     0,     0,     0,   988,   989,   990,   236,   237,   238,
     239,   240,   241,   242,   243,   244,  1751,   245,   246,   247,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,   248,   249,   250,
    1759,   251,   252,   253,   254,   255,   256,   257,   258,     0,
     885,   261,   886,   887,  1760,   264,   265,   266,   267,   268,
     269,   270,  1761,  1762,   271,   272,   888,   889,   275,  1763,
     276,   277,   278,   279,     0,  1764,   281,  1765,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,  1766,
     293,   294,   295,   296,   297,   298,  1767,   299,   300,   301,
     302,  1768,  1769,  1770,   303,  1771,  1772,  1773,   304,   305,
     306,   307,   308,   309,   890,   891,   312,  1774,   313,  1775,
     314,   315,   316,   317,   318,   319,   320,  1776,   321,   322,
     323,   324,  1777,  1778,   325,   326,   892,   328,   329,  1779,
     330,   331,   332,   333,  1780,   334,   335,   336,   337,  1781,
     338,   339,   340,   341,     0,   343,   344,   345,   346,     0,
    1782,   348,  1783,   349,   350,   351,   893,   353,  1784,   354,
    1785,   355,   356,   357,  1786,   358,   359,   360,   361,   362,
    1787,   363,     0,  1788,     0,   366,   367,  1789,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  1790,   378,
     379,   380,   381,   382,   383,   384,   385,  1791,   386,   387,
       0,   389,   390,   391,   392,   894,   895,  1792,   896,  1793,
     396,   397,   398,   399,   400,   897,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   412,   413,   414,   415,
     416,   417,   418,  1794,  1795,   419,     0,   421,   422,   423,
    1796,   424,   425,   426,  1797,  1798,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   438,   439,   440,
     441,   442,   443,   444,   445,   898,   447,   899,   449,   450,
     451,   452,   453,   454,   455,   456,  4994,     0,   459,  1799,
     460,   461,   462,   463,  1800,     0,   465,   900,   467,   468,
     469,  1801,   470,   471,   472,  1802,  1803,  4538,   474,   475,
    1804,  1805,   476,   477,     0,   479,   480,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,  1806,   494,   495,   496,     0,   498,     0,   500,   501,
     502,  1807,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   901,   515,   516,   517,   518,  1808,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,  1809,   532,   533,   534,   535,   536,   537,   538,
     539,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,  1810,   551,   552,   553,   554,   555,  1811,   556,
     557,  2743,   559,   560,   561,   562,   563,   903,   565,  1812,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,     0,   582,  1813,   583,   584,
    1814,  1815,   585,   586,   587,   588,   589,   590,   591,   592,
    1816,   593,   904,   905,  1817,  1818,   596,   597,     0,   599,
       0,  1819,   601,   602,   603,   604,   605,   606,   607,   608,
     609,  1820,  1821,   610,   611,   612,   613,   614,  1822,  1823,
     615,   616,   617,   618,   619,     0,   906,  1824,   622,   623,
     624,   625,   626,   627,  1825,  1826,   628,  1827,  1828,   629,
     630,   631,   632,   633,   634,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   646,   647,   648,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   993,
     994,   995,  4539,  4540,   998,   999,  1000,  1001,   656,     0,
       0,     0,     0,     0,     0,   987,     0,     0,     0,     0,
       0,     0,   988,   989,   990,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   991,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   992,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,   656,     0,     0,     0,
       0,     0,     0,   987,     0,     0,     0,     0,     0,     0,
     988,   989,   990,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,  1108,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,  1109,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,   656,     0,     0,     0,     0,     0,
       0,   987,     0,     0,     0,     0,     0,     0,   988,   989,
     990,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,  1174,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,  1175,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1176,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,   656,     0,     0,     0,     0,     0,     0,   987,
       0,     0,     0,     0,     0,     0,   988,   989,   990,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,  1856,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,  1857,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   993,   994,   995,   996,   997,   998,   999,  1000,  1001,
     656,     0,     0,     0,     0,     0,     0,   987,     0,     0,
       0,     0,     0,     0,   988,   989,   990,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,   656,     0,
       0,     0,     0,     0,     0,   987,     0,     0,     0,     0,
       0,     0,   988,   989,   990,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,  3605,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,  3606,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,   656,     0,     0,     0,
       0,     0,     0,   987,     0,     0,     0,     0,     0,     0,
     988,   989,   990,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,  5636,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,     0,     0,  1750,     0,     0,
       0,     0,     0,     0,     0,   993,   994,   995,   996,   997,
     998,   999,  1000,  1001,   236,   237,   238,   239,   240,   241,
     242,   243,   244,  1751,   245,   246,   247,  1752,  1753,  1754,
    1755,  1756,  1757,  1758,   248,   249,   250,  1759,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,  1760,   264,   265,   266,   267,   268,   269,   270,  1761,
    1762,   271,   272,   273,   274,   275,  1763,   276,   277,   278,
     279,   280,  1764,   281,  1765,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,  1766,   293,   294,   295,
     296,   297,   298,  1767,   299,   300,   301,   302,  1768,  1769,
    1770,   303,  1771,  1772,  1773,   304,   305,   306,   307,   308,
     309,   310,   311,   312,  1774,   313,  1775,   314,   315,   316,
     317,   318,   319,   320,  1776,   321,   322,   323,   324,  1777,
    1778,   325,   326,   327,   328,   329,  1779,   330,   331,   332,
     333,  1780,   334,   335,   336,   337,  1781,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,  1782,   348,  1783,
     349,   350,   351,   352,   353,  1784,   354,  1785,   355,   356,
     357,  1786,   358,   359,   360,   361,   362,  1787,   363,   364,
    1788,   365,   366,   367,  1789,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  1790,   378,   379,   380,   381,
     382,   383,   384,   385,  1791,   386,   387,   388,   389,   390,
     391,   392,   393,   394,  1792,   395,  1793,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
    1794,  1795,   419,   420,   421,   422,   423,  1796,   424,   425,
     426,  1797,  1798,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,  1799,   460,   461,   462,
     463,  1800,   464,   465,   466,   467,   468,   469,  1801,   470,
     471,   472,  1802,  1803,   473,   474,   475,  1804,  1805,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,  1806,   494,
     495,   496,   497,   498,   499,   500,   501,   502,  1807,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,  1808,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,  1809,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,  1810,
     551,   552,   553,   554,   555,  1811,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,  1812,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,  1813,   583,   584,  1814,  1815,   585,
     586,   587,   588,   589,   590,   591,   592,  1816,   593,   594,
     595,  1817,  1818,   596,   597,   598,   599,   600,  1819,   601,
     602,   603,   604,   605,   606,   607,   608,   609,  1820,  1821,
     610,   611,   612,   613,   614,  1822,  1823,   615,   616,   617,
     618,   619,   620,   621,  1824,   622,   623,   624,   625,   626,
     627,  1825,  1826,   628,  1827,  1828,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1829,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     873,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  6085,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  6087,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  6214,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   885,   261,   886,   887,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   888,   889,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   890,   891,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   893,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    2739,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,  2740,   389,   390,   391,   392,   894,   895,     0,
     896,     0,   396,   397,   398,   399,   400,   897,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   898,   447,   899,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   900,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,  2741,   476,   477,  2742,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   901,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  2743,   559,   560,   561,   562,   563,   903,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   904,   905,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   906,  2744,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,     0,     0,     0,
    3963,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,  2745,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,     0,
     885,   261,   886,   887,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   888,   889,   275,     0,
     276,   277,   278,   279,     0,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,     0,     0,     0,   303,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   890,   891,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   892,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,     0,   343,   344,   345,   346,     0,
       0,   348,     0,   349,   350,   351,   893,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,     0,     0,     0,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,  2739,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
    2740,   389,   390,   391,   392,   894,   895,     0,   896,     0,
     396,   397,   398,   399,   400,   897,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,     0,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,     0,   438,   439,   440,
     441,   442,   443,   444,   445,   898,   447,   899,   449,   450,
     451,   452,   453,   454,   455,   456,     0,     0,   459,     0,
     460,   461,   462,   463,     0,     0,   465,   900,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,  2741,   476,   477,  2742,   479,   480,   481,     0,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,     0,   498,     0,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   901,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,  2743,   559,   560,   561,   562,   563,   903,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,     0,   582,     0,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,   904,   905,     0,     0,   596,   597,     0,   599,
       0,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,     0,   906,  2744,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   646,   647,   648,   972,
       0,  1616,   715,     0,     0,     0,     0,   776,     0,     0,
       0,     0,     0,     0,  2745,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,     0,   303,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  2056,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,  1839,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,  1840,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
    1841,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   972,     0,
    1616,   715,     0,     0,     0,     0,   776,     0,     0,     0,
       0,  1617,  1618,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,     0,
       0,     0,   303,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,  2061,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,  1839,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,  1840,     0,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,  1841,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   972,     0,  1616,
     715,     0,     0,     0,     0,   776,     0,     0,     0,     0,
    1617,  1618,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,  3572,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,  1839,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,  1840,     0,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,  1841,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   972,     0,  1616,   715,
       0,     0,     0,     0,   776,     0,     0,     0,     0,  1617,
    1618,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,     0,     0,     0,
     303,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,  1839,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,  1840,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,  1841,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,   776,     0,     0,     0,     0,  1617,  1618,
       0,     0,   236,   237,   777,   239,   240,   241,   242,   243,
     244,   778,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   779,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     780,   352,   353,     0,   354,     0,   355,   781,     0,   782,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,   783,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   784,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   785,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   786,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   787,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   972,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   788,   789,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     3,     4,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,     0,     0,     0,   303,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,  1051,  1750,     0,  6403,   715,     0,     0,
       0,     0,   776,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
    1751,   245,   246,   247,  1752,  1753,  1754,  1755,  1756,  1757,
    1758,   248,   249,   250,  1759,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,  1760,   264,
     265,   266,   267,   268,   269,   270,  1761,  1762,   271,   272,
     273,   274,   275,  1763,   276,   277,   278,   279,   280,  1764,
     281,  1765,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,  1766,   293,   294,   295,   296,   297,   298,
    1767,   299,   300,   301,   302,  1768,  1769,  1770,   303,  1771,
    1772,  1773,   304,   305,   306,   307,   308,   309,   310,   311,
     312,  1774,   313,  1775,   314,   315,   316,   317,   318,   319,
     320,  1776,   321,   322,   323,   324,  1777,  1778,   325,   326,
     327,   328,   329,  1779,   330,   331,   332,   333,  1780,   334,
     335,   336,   337,  1781,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,  1782,   348,  1783,   349,   350,   351,
     352,   353,  1784,   354,  1785,   355,   356,   357,  1786,   358,
     359,   360,   361,   362,  1787,   363,   364,  1788,   365,   366,
     367,  1789,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,  1790,   378,   379,   380,   381,   382,   383,   384,
     385,  1791,   386,   387,   388,   389,   390,   391,   392,   393,
     394,  1792,   395,  1793,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,  1794,  1795,   419,
     420,   421,   422,   423,  1796,   424,   425,   426,  1797,  1798,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,  1799,   460,   461,   462,   463,  1800,   464,
     465,   466,   467,   468,   469,  1801,   470,   471,   472,  1802,
    1803,   473,   474,   475,  1804,  1805,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,  1806,   494,   495,   496,   497,
     498,   499,   500,   501,   502,  1807,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,  1808,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,  1809,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,  1810,   551,   552,   553,
     554,   555,  1811,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,  1812,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,  1813,   583,   584,  1814,  1815,   585,   586,   587,   588,
     589,   590,   591,   592,  1816,   593,   594,   595,  1817,  1818,
     596,   597,   598,   599,   600,  1819,   601,   602,   603,   604,
     605,   606,   607,   608,   609,  1820,  1821,   610,   611,   612,
     613,   614,  1822,  1823,   615,   616,   617,   618,   619,   620,
     621,  1824,   622,   623,   624,   625,   626,   627,  1825,  1826,
     628,  1827,  1828,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,  1750,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,  1751,
     245,   246,   247,  1752,  1753,  1754,  1755,  1756,  1757,  1758,
     248,   249,   250,  1759,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,  1760,   264,   265,
     266,   267,   268,   269,   270,  1761,  1762,   271,   272,   273,
     274,   275,  1763,   276,   277,   278,   279,   280,  1764,   281,
    1765,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,  1766,   293,   294,   295,   296,   297,   298,  1767,
     299,   300,   301,   302,  1768,  1769,  1770,   303,  1771,  1772,
    1773,   304,   305,   306,   307,   308,   309,   310,   311,   312,
    1774,   313,  1775,   314,   315,   316,   317,   318,   319,   320,
    1776,   321,   322,   323,   324,  1777,  1778,   325,   326,   327,
     328,   329,  1779,   330,   331,   332,   333,  1780,   334,   335,
     336,   337,  1781,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,  1782,   348,  1783,   349,   350,   351,   352,
     353,  1784,   354,  1785,   355,   356,   357,  1786,   358,   359,
     360,   361,   362,  1787,   363,   364,  1788,   365,   366,   367,
    1789,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,  1790,   378,   379,   380,   381,   382,   383,   384,   385,
    1791,   386,   387,   388,   389,   390,   391,   392,   393,   394,
    1792,   395,  1793,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,  1794,  1795,   419,   420,
     421,   422,   423,  1796,   424,   425,   426,  1797,  1798,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,  1799,   460,   461,   462,   463,  1800,   464,   465,
     466,   467,   468,   469,  1801,   470,   471,   472,  1802,  1803,
     473,   474,   475,  1804,  1805,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,  1806,   494,   495,   496,   497,   498,
     499,   500,   501,   502,  1807,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,  1808,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,  1809,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,  1810,   551,   552,   553,   554,
     555,  1811,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,  1812,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
    1813,   583,   584,  1814,  1815,   585,   586,   587,   588,   589,
     590,   591,   592,  1816,   593,   594,   595,  1817,  1818,   596,
     597,   598,   599,   600,  1819,   601,   602,   603,   604,   605,
     606,   607,   608,   609,  1820,  1821,   610,   611,   612,   613,
     614,  1822,  1823,   615,   616,   617,   618,   619,   620,   621,
    1824,   622,   623,   624,   625,   626,   627,  1825,  1826,   628,
    1827,  1828,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,  1750,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,  3680,   242,   243,   244,  1751,   245,
     246,   247,  1752,  1753,  1754,  1755,  1756,  1757,  1758,   248,
     249,   250,  1759,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,  1760,   264,   265,   266,
     267,   268,   269,   270,  1761,  1762,   271,   272,   273,   274,
     275,  1763,   276,   277,   278,   279,   280,  1764,   281,  1765,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,  1766,   293,   294,   295,   296,   297,   298,  1767,   299,
     300,   301,   302,  1768,  1769,  1770,   303,  1771,  1772,  1773,
     304,   305,   306,   307,   308,   309,   310,   311,   312,  1774,
     313,  1775,   314,   315,   316,   317,   318,   319,   320,  1776,
     321,   322,   323,   324,  1777,  1778,   325,   326,   327,  3681,
     329,  1779,   330,   331,   332,   333,  1780,   334,   335,   336,
     337,  1781,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,  1782,   348,  1783,   349,   350,   351,   352,   353,
    1784,   354,  1785,   355,   356,   357,  1786,   358,   359,   360,
     361,   362,  1787,   363,   364,  1788,   365,   366,   367,  1789,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
    1790,   378,   379,   380,   381,   382,   383,   384,   385,  1791,
     386,   387,   388,   389,   390,   391,   392,   393,   394,  1792,
     395,  1793,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,  1794,  1795,   419,   420,   421,
     422,   423,  1796,   424,   425,   426,  1797,  1798,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,  1799,   460,   461,   462,   463,  1800,   464,   465,   466,
     467,   468,   469,  1801,   470,   471,   472,  1802,  1803,   473,
     474,   475,  1804,  1805,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,  1806,   494,   495,   496,   497,   498,   499,
     500,   501,   502,  1807,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
    1808,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,  1809,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,  1810,   551,   552,   553,   554,   555,
    1811,  3682,   557,   558,   559,   560,   561,   562,   563,   564,
     565,  1812,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,  1813,
     583,   584,  1814,  1815,   585,   586,   587,   588,   589,   590,
     591,   592,  1816,   593,   594,   595,  1817,  1818,   596,   597,
     598,   599,   600,  1819,   601,   602,   603,   604,   605,   606,
     607,   608,   609,  1820,  1821,   610,   611,   612,   613,   614,
    1822,  1823,   615,   616,   617,   618,   619,   620,   621,  1824,
     622,   623,   624,   625,   626,   627,  1825,  1826,   628,  1827,
    1828,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   235,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,  1305,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,  1308,     0,  1309,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,  1310,  1311,  1312,  1313,  1314,  1315,  1316,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
    1321,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,  1324,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,  3477,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,   410,  1338,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,  1339,   421,   422,
     423,     0,   424,   425,   426,  1340,  1341,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,  1342,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,  1345,   459,
       0,   460,   461,   462,   463,     0,  1348,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,  1351,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,  1352,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,  1355,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,  1357,   582,     0,   583,
     584,  1358,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,  1361,
     599,  1362,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,  1365,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,  1367,  1368,  1369,
    1370,   640,  1371,  1372,  1373,  1374,   645,   646,   647,   648,
     235,     0,  1295,   715,     0,  1296,  1297,     0,   776,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
    1301,   261,  1302,  1303,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,  1306,  1307,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,     0,     0,     0,   303,     0,     0,     0,   304,   305,
     306,   307,   308,   309,  1317,  1318,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   892,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
    1322,   348,     0,   349,   350,   351,  1323,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,  1326,  1327,     0,  1328,     0,
     396,   397,   398,   399,   400,  6377,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,  1343,   447,  1344,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,  1347,   464,   465,  1349,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,  1353,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,   561,   562,   563,  1356,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,  1359,  1360,     0,     0,   596,   597,   598,   599,
     600,  1363,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,  1366,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   972,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,  1011,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,   973,   303,     0,     0,   974,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,   975,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   972,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,  1032,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,     0,
       0,   973,   303,     0,     0,   974,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,  1033,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,   975,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   972,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
     973,   303,     0,     0,   974,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,   975,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,  3009,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   972,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,     0,     0,   973,
     303,     0,     0,   974,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,  4034,
     365,   366,   367,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,   975,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   972,     0,     0,   715,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,     0,     0,     0,   303,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,  1839,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
    1840,     0,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,  1841,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   972,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,     0,     0,   973,   303,     0,
       0,   974,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,   975,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   972,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,     0,     0,   973,   303,     0,     0,
     974,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,  1127,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,   975,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   972,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,   973,   303,     0,     0,   974,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1169,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
     975,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   972,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,   281,     0,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,   299,   300,
     301,   302,     0,     0,   973,   303,     0,     0,   974,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,   357,     0,   358,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1182,   373,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
     387,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,   421,   422,
     423,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,   462,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,   975,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,   586,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
     623,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     972,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,   299,   300,   301,
     302,     0,     0,   973,   303,     0,     0,   974,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,   357,     0,   358,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1194,   373,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,   387,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,   421,   422,   423,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
    1195,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,   462,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,   975,   556,
     557,   558,   559,   560,   561,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,   586,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,   623,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   972,
       0,     0,   715,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,   299,   300,   301,   302,
       0,     0,     0,   303,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  2041,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,   357,     0,   358,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,   387,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,   421,   422,   423,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,   462,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,   586,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,   623,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   972,     0,
       0,   715,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,   299,   300,   301,   302,     0,
       0,     0,   303,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,   357,     0,   358,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,   387,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,   421,   422,   423,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
     462,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,   586,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,   623,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   235,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,   462,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   235,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,   299,   300,   301,   302,     0,     0,     0,
     303,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,   357,
       0,   358,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1153,   373,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,   387,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,   421,   422,   423,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,   462,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
     561,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,   586,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,   623,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,   281,     0,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,   299,   300,   301,   302,     0,     0,     0,   303,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,   357,     0,
     358,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1166,   373,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,   387,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,   421,   422,   423,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,   462,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,   561,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,   586,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,   623,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   235,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,   299,   300,   301,   302,     0,     0,     0,   303,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,   357,     0,   358,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1180,   373,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,   387,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,   421,   422,   423,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,   462,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,   561,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,   586,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,   623,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   235,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,   281,
       0,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
     299,   300,   301,   302,     0,     0,     0,   303,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,   357,     0,   358,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1184,   373,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,   387,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
     421,   422,   423,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,   462,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,   586,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,   623,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   972,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,   462,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
    2843,   276,   277,   278,   279,   280,     0,     0,  2844,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
    2845,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,  2846,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,  2847,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  2848,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,  2849,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,  2850,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,  2843,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,  2845,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
    2846,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
    2847,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,  3897,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,  2849,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,  2850,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   795,   245,   796,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,   797,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,   842,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,   798,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   799,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   795,   245,   796,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,   797,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,  3579,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,   798,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     799,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,  2843,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,  2845,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,  2846,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,  2847,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,  2849,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,  2850,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   795,   245,   796,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,   797,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   798,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   799,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,  3085,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,  2915,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,   867,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,  2916,  2917,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
    2017,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,  2018,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,  2019,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,  2020,   355,   356,     0,     0,     0,
    2021,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,  2022,  2023,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,  2024,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,  2025,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,  2026,   539,   540,   541,   542,   543,   544,
    2027,   546,   547,   548,   549,   550,     0,  2028,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,  2029,   585,     0,  2030,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,  2031,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   796,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,   797,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   798,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   799,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,  2915,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,   867,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,  2916,  2917,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  1025,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1026,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,   867,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,  3661,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,  3662,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,  3674,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,  3675,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   657,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   706,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   707,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   835,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   836,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   837,   595,
       0,     0,   838,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   861,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   862,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   863,   595,     0,
       0,   864,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
     867,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,   927,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   982,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   983,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,  1145,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   835,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,  1259,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,  1413,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,  1255,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   812,   272,   273,   274,  1419,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   813,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   815,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   816,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,  1417,     0,   857,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   820,
     595,     0,     0,   858,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   822,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1560,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,   867,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,  1621,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1622,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,  3429,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,  3430,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,  3431,   585,     0,   587,   588,
    3432,   590,  3433,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,  3434,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,   715,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
     776,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,  4252,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,  4266,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,  4412,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,  4935,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,  5008,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,   372,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,  5367,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   812,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   813,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   814,   529,   530,   531,     0,   532,   533,     0,
     815,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     816,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   817,     0,   818,   557,   558,   559,   819,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   820,   595,     0,     0,
     821,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   822,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   827,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   833,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   812,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   854,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   855,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   813,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   815,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   816,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   856,     0,
     857,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   820,   595,     0,     0,   858,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   822,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,   372,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   879,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1007,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1017,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1020,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1036,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1093,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  1098,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  1115,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1118,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1120,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1158,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1186,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1188,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1198,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,  1201,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  1204,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,  1256,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   812,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   813,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   815,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   816,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
    1417,     0,   857,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   820,   595,     0,     0,   858,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   822,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  1882,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,  1916,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  1918,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  1958,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    1960,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  1962,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     271,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   535,   536,   537,   538,   539,   540,   541,   542,
    2078,   544,   545,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   555,     0,   556,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   594,   595,
       0,     0,   596,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
    2731,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,   372,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,     0,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   812,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,   372,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   813,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     815,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     816,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,  1417,     0,   857,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,  2766,   588,
     589,   590,   591,   592,     0,   593,   820,   595,     0,     0,
     858,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   822,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   812,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,   372,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   813,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   815,
     536,   537,   538,   539,   540,   541,   542,   543,   544,  2828,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     817,     0,   857,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   820,   595,     0,     0,   821,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   822,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   812,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,   372,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   813,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   815,   536,
     537,   538,   539,   540,   541,   542,   543,   544,  2912,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   817,
       0,   857,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   820,   595,     0,     0,   821,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   822,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   812,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,   326,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   813,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   815,   536,   537,
     538,   539,   540,   541,   542,   543,   544,  2936,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   817,     0,
     857,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   820,   595,     0,     0,   821,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   822,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  3130,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,  3134,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,   366,   367,     0,   368,   369,   370,   371,
    3192,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,   512,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   656,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,     0,   256,   257,   258,   259,   260,     0,   262,
     263,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   273,   274,   275,     0,   276,   277,   278,
     279,   280,     0,     0,     0,   282,   283,   284,   285,   286,
     287,     0,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,     0,   300,   301,   302,     0,     0,
       0,     0,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   310,   311,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   327,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,     0,   348,     0,
     349,   350,   351,   352,   353,     0,   354,     0,   355,   356,
       0,     0,     0,   359,   360,   361,   362,     0,   363,   364,
       0,   365,   366,   367,     0,   368,   369,   370,   371,  3584,
       0,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,     0,   388,   389,   390,
     391,   392,   393,   394,     0,   395,     0,   396,     0,     0,
     399,     0,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,   420,     0,   422,     0,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,     0,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,     0,   460,   461,     0,
     463,     0,   464,   465,   466,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,   478,     0,   480,     0,   482,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,   497,   498,   499,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,     0,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   558,   559,
     560,     0,   562,   563,   564,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,   581,   582,     0,   583,   584,     0,     0,   585,
       0,   587,   588,   589,   590,   591,   592,     0,   593,   594,
     595,     0,     0,   596,   597,   598,   599,   600,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,   620,   621,     0,   622,     0,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     643,   644,   645,   646,   647,   648,   656,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   236,   237,   238,   239,   240,   241,   242,
     243,   244,     0,   245,   246,   247,     0,     0,     0,     0,
       0,     0,     0,   248,   249,   250,     0,   251,   252,   253,
     254,     0,   256,   257,   258,   259,   260,     0,   262,   263,
       0,   264,   265,   266,   267,   268,   269,   270,     0,     0,
     812,   272,   273,   274,   275,     0,   276,   277,   278,   279,
     280,     0,     0,     0,   282,   283,   284,   285,   286,   287,
       0,   289,   290,   291,   292,     0,   293,   294,   295,   296,
     297,   298,     0,     0,   300,   301,   302,     0,     0,     0,
       0,     0,     0,     0,   304,   305,   306,   307,   308,   309,
     310,   311,   312,     0,   313,     0,   314,   315,   316,   317,
     318,   319,   320,     0,   321,   322,   323,   324,     0,     0,
     325,   326,   327,   328,   329,     0,   330,   331,   332,   333,
       0,   334,   335,   336,   337,     0,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,     0,   348,     0,   349,
     350,   351,   352,   353,     0,   354,     0,   355,   356,     0,
       0,     0,   359,   360,   361,   362,     0,   363,   364,     0,
     365,   366,   367,     0,   368,   369,   370,   371,   372,     0,
     374,   375,   376,   377,     0,   378,   379,   380,   381,   382,
     383,   384,   385,     0,   386,     0,   388,   389,   390,   391,
     392,   393,   394,     0,   395,     0,   396,     0,     0,   399,
       0,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,     0,
       0,   419,   420,     0,   422,     0,     0,   424,   425,   426,
       0,     0,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     813,   446,     0,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,     0,   460,   461,     0,   463,
       0,   464,   465,   466,   467,   468,   469,     0,   470,   471,
     472,     0,     0,   473,   474,   475,     0,     0,   476,   477,
     478,     0,   480,     0,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,     0,     0,   494,   495,
     496,   497,   498,   499,   500,   501,   502,     0,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,     0,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,     0,   532,
     533,     0,   815,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   816,   546,   547,   548,   549,   550,     0,   551,
     552,   553,   554,   817,     0,   857,   557,   558,   559,   560,
       0,   562,   563,   564,   565,     0,   566,   567,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,     0,   583,   584,     0,     0,   585,     0,
     587,   588,   589,   590,   591,   592,     0,   593,   820,   595,
       0,     0,   821,   597,   598,   599,   600,     0,   601,   602,
     603,   604,   605,   606,   607,   608,   609,     0,     0,   610,
     611,   612,   613,   614,     0,     0,   615,   616,   617,   618,
     619,   620,   621,     0,   622,     0,   624,   625,   626,   627,
       0,     0,   628,     0,     0,   629,   630,   631,   632,   633,
     822,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   656,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   236,   237,   238,   239,   240,   241,   242,   243,
     244,     0,   245,   246,   247,     0,     0,     0,     0,     0,
       0,     0,   248,   249,   250,     0,   251,   252,   253,   254,
       0,   256,   257,   258,   259,   260,     0,   262,   263,     0,
     264,   265,   266,   267,   268,   269,   270,     0,     0,   271,
     272,   273,   274,   275,     0,   276,   277,   278,   279,   280,
       0,     0,     0,   282,   283,   284,   285,   286,   287,     0,
     289,   290,   291,   292,     0,   293,   294,   295,   296,   297,
     298,     0,     0,   300,   301,   302,     0,     0,     0,     0,
       0,     0,     0,   304,   305,   306,   307,   308,   309,   310,
     311,   312,     0,   313,     0,   314,   315,   316,   317,   318,
     319,   320,     0,   321,   322,   323,   324,     0,     0,   325,
     326,   327,   328,   329,     0,   330,   331,   332,   333,     0,
     334,   335,   336,   337,     0,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,     0,   348,     0,   349,   350,
     351,   352,   353,     0,   354,     0,   355,   356,     0,     0,
       0,   359,   360,   361,   362,     0,   363,   364,     0,   365,
     366,   367,     0,   368,   369,   370,   371,  3642,     0,   374,
     375,   376,   377,     0,   378,   379,   380,   381,   382,   383,
     384,   385,     0,   386,     0,   388,   389,   390,   391,   392,
     393,   394,     0,   395,     0,   396,     0,     0,   399,     0,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,     0,     0,
     419,   420,     0,   422,     0,     0,   424,   425,   426,     0,
       0,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,     0,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,     0,   460,   461,     0,   463,     0,
     464,   465,   466,   467,   468,   469,     0,   470,   471,   472,
       0,     0,   473,   474,   475,     0,     0,   476,   477,   478,
       0,   480,     0,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,     0,     0,   494,   495,   496,
     497,   498,   499,   500,   501,   502,     0,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,     0,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,     0,   532,   533,
       0,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,     0,   551,   552,
     553,   554,   555,     0,   556,   557,   558,   559,   560,     0,
     562,   563,   564,   565,     0,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   575,   576,   577,   578,   579,   580,
     581,   582,     0,   583,   584,     0,     0,   585,     0,   587,
     588,   589,   590,   591,   592,     0,   593,   594,   595,     0,
       0,   596,   597,   598,   599,   600,     0,   601,   602,   603,
     604,   605,   606,   607,   608,   609,     0,     0,   610,   611,
     612,   613,   614,     0,     0,   615,   616,   617,   618,   619,
     620,   621,     0,   622,     0,   624,   625,   626,   627,     0,
       0,   628,     0,     0,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   656,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,   244,
       0,   245,   246,   247,     0,     0,     0,     0,     0,     0,
       0,   248,   249,   250,     0,   251,   252,   253,   254,     0,
     256,   257,   258,   259,   260,     0,   262,   263,     0,   264,
     265,   266,   267,   268,   269,   270,     0,     0,   271,   272,
     273,   274,   275,     0,   276,   277,   278,   279,   280,     0,
       0,     0,   282,   283,   284,   285,   286,   287,     0,   289,
     290,   291,   292,     0,   293,   294,   295,   296,   297,   298,
       0,     0,   300,   301,   302,     0,     0,     0,     0,     0,
       0,     0,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,   313,     0,   314,   315,   316,   317,   318,   319,
     320,     0,   321,   322,   323,   324,     0,     0,   325,   326,
     327,   328,   329,     0,   330,   331,   332,   333,     0,   334,
     335,   336,   337,     0,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,     0,   348,     0,   349,   350,   351,
     352,   353,     0,   354,     0,   355,   356,     0,     0,     0,
     359,   360,   361,   362,     0,   363,   364,     0,   365,   366,
     367,     0,   368,   369,   370,   371,  3664,     0,   374,   375,
     376,   377,     0,   378,   379,   380,   381,   382,   383,   384,
     385,     0,   386,     0,   388,   389,   390,   391,   392,   393,
     394,     0,   395,     0,   396,     0,     0,   399,     0,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   415,   416,   417,   418,     0,     0,   419,
     420,     0,   422,     0,     0,   424,   425,   426,     0,     0,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,   443,   444,   445,   446,
       0,   448,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,     0,   460,   461,     0,   463,     0,   464,
     465,   466,   467,   468,   469,     0,   470,   471,   472,     0,
       0,   473,   474,   475,     0,     0,   476,   477,   478,     0,
     480,     0,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,     0,     0,   494,   495,   496,   497,
     498,   499,   500,   501,   502,     0,   503,   504,   505,   506,
     507,   508,   509,   510,   511,   512,   513,   514,   515,   516,
     517,   518,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,     0,   532,   533,     0,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,     0,   551,   552,   553,
     554,   555,     0,   556,   557,   558,   559,   560,     0,   562,
     563,   564,   565,     0,   566,   567,   568,   569,   570,   571,
     572,   573,   574,   575,   576,   577,   578,   579,   580,   581,
     582,     0,   583,   584,     0,     0,   585,     0,   587,   588,
     589,   590,   591,   592,     0,   593,   594,   595,     0,     0,
     596,   597,   598,   599,   600,     0,   601,   602,   603,   604,
     605,   606,   607,   608,   609,     0,     0,   610,   611,   612,
     613,   614,     0,     0,   615,   616,   617,   618,   619,   620,
     621,     0,   622,     0,   624,   625,   626,   627,     0,     0,
     628,     0,     0,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   647,   648,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     236,   237,   238,   239,   240,   241,   242,   243,   244,     0,
     245,   246,   247,     0,     0,     0,     0,     0,     0,     0,
     248,   249,   250,     0,   251,   252,   253,   254,     0,   256,
     257,   258,   259,   260,     0,   262,   263,     0,   264,   265,
     266,   267,   268,   269,   270,     0,     0,   271,   272,   273,
     274,   275,     0,   276,   277,   278,   279,   280,     0,     0,
       0,   282,   283,   284,   285,   286,   287,     0,   289,   290,
     291,   292,     0,   293,   294,   295,   296,   297,   298,     0,
       0,   300,   301,   302,     0,     0,     0,     0,     0,     0,
       0,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,   313,     0,   314,   315,   316,   317,   318,   319,   320,
       0,   321,   322,   323,   324,     0,     0,   325,   326,   327,
     328,   329,     0,   330,   331,   332,   333,     0,   334,   335,
     336,   337,     0,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,     0,   348,     0,   349,   350,   351,   352,
     353,     0,   354,     0,   355,   356,     0,     0,     0,   359,
     360,   361,   362,     0,   363,   364,     0,   365,   366,   367,
       0,   368,   369,   370,   371,  3666,     0,   374,   375,   376,
     377,     0,   378,   379,   380,   381,   382,   383,   384,   385,
       0,   386,     0,   388,   389,   390,   391,   392,   393,   394,
       0,   395,     0,   396,     0,     0,   399,     0,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,     0,     0,   419,   420,
       0,   422,     0,     0,   424,   425,   426,     0,     0,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     438,   439,   440,   441,   442,   443,   444,   445,   446,     0,
     448,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,     0,   460,   461,     0,   463,     0,   464,   465,
     466,   467,   468,   469,     0,   470,   471,   472,     0,     0,
     473,   474,   475,     0,     0,   476,   477,   478,     0,   480,
       0,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,     0,     0,   494,   495,   496,   497,   498,
     499,   500,   501,   502,     0,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,     0,   519,   520,   521,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   531,     0,   532,   533,     0,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,     0,   551,   552,   553,   554,
     555,     0,   556,   557,   558,   559,   560,     0,   562,   563,
     564,   565,     0,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,   578,   579,   580,   581,   582,
       0,   583,   584,     0,     0,   585,     0,   587,   588,   589,
     590,   591,   592,     0,   593,   594,   595,     0,     0,   596,
     597,   598,   599,   600,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,     0,     0,   610,   611,   612,   613,
     614,     0,     0,   615,   616,   617,   618,   619,   620,   621,
       0,   622,     0,   624,   625,   626,   627,     0,     0,   628,
       0,     0,   629,   630,   631,   632,   633,   634,   635,   636,
     637,   638,   639,   640,   641,   642,   643,   644,   645,   646,
     647,   648,   656,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,     0,   256,   257,
     258,   259,   260,     0,   262,   263,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   273,   274,
     275,     0,   276,   277,   278,   279,   280,     0,     0,     0,
     282,   283,   284,   285,   286,   287,     0,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,     0,
     300,   301,   302,     0,     0,     0,     0,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   310,   311,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,     0,   348,     0,   349,   350,   351,   352,   353,
       0,   354,     0,   355,   356,     0,     0,     0,   359,   360,
     361,   362,     0,   363,   364,     0,   365,   366,   367,     0,
     368,   369,   370,   371,  3816,     0,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,     0,   388,   389,   390,   391,   392,   393,   394,     0,
     395,     0,   396,     0,     0,   399,     0,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,   420,     0,
     422,     0,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,     0,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,     0,   460,   461,     0,   463,     0,   464,   465,   466,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,   478,     0,   480,     0,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,   497,   498,   499,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   514,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,     0,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   558,   559,   560,     0,   562,   563,   564,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,     0,
     583,   584,     0,     0,   585,     0,   587,   588,   589,   590,
     591,   592,     0,   593,   594,   595,     0,     0,   596,   597,
     598,   599,   600,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,   620,   621,     0,
     622,     0,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,   642,   643,   644,   645,   646,   647,
     648,   656,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,   241,   242,   243,   244,     0,   245,   246,
     247,     0,     0,     0,     0,     0,     0,     0,   248,   249,
     250,     0,   251,   252,   253,   254,     0,   256,   257,   258,
     259,   260,     0,   262,   263,     0,   264,   265,   266,   267,
     268,   269,   270,     0,     0,   271,   272,   273,   274,   275,
       0,   276,   277,   278,   279,   280,     0,     0,     0,   282,
     283,   284,   285,   286,   287,     0,   289,   290,   291,   292,
       0,   293,   294,   295,   296,   297,   298,     0,     0,   300,
     301,   302,     0,     0,     0,     0,     0,     0,     0,   304,
     305,   306,   307,   308,   309,   310,   311,   312,     0,   313,
       0,   314,   315,   316,   317,   318,   319,   320,     0,   321,
     322,   323,   324,     0,     0,   325,  3858,   327,   328,   329,
       0,   330,   331,   332,   333,     0,   334,   335,   336,   337,
       0,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,     0,   348,     0,   349,   350,   351,   352,   353,     0,
     354,     0,   355,   356,     0,     0,     0,   359,   360,   361,
     362,     0,   363,   364,     0,   365,   366,   367,     0,   368,
     369,   370,   371,   372,     0,   374,   375,   376,   377,     0,
     378,   379,   380,   381,   382,   383,   384,   385,     0,   386,
       0,   388,   389,   390,   391,   392,   393,   394,     0,   395,
       0,   396,     0,     0,   399,     0,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,     0,     0,   419,   420,     0,   422,
       0,     0,   424,   425,   426,     0,     0,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,     0,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
       0,   460,   461,     0,   463,     0,   464,   465,   466,   467,
     468,   469,     0,   470,   471,   472,     0,     0,   473,   474,
     475,     0,     0,   476,   477,   478,     0,   480,     0,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,     0,     0,   494,   495,   496,   497,   498,   499,   500,
     501,   502,     0,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,     0,
     519,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   531,     0,   532,   533,     0,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,     0,   551,   552,   553,   554,   555,     0,
     556,   557,   558,   559,   560,     0,   562,   563,   564,   565,
       0,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,     0,   583,
     584,     0,     0,   585,     0,   587,   588,   589,   590,   591,
     592,     0,   593,   594,   595,     0,     0,   596,   597,   598,
     599,   600,     0,   601,   602,   603,   604,   605,   606,   607,
     608,   609,     0,     0,   610,   611,   612,   613,   614,     0,
       0,   615,   616,   617,   618,   619,   620,   621,     0,   622,
       0,   624,   625,   626,   627,     0,     0,   628,     0,     0,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     656,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   244,     0,   245,   246,   247,
       0,     0,     0,     0,     0,     0,     0,   248,   249,   250,
       0,   251,   252,   253,   254,     0,   256,   257,   258,   259,
     260,     0,   262,   263,     0,   264,   265,   266,   267,   268,
     269,   270,     0,     0,   271,   272,   273,   274,   275,     0,
     276,   277,   278,   279,   280,     0,     0,     0,   282,   283,
     284,   285,   286,   287,     0,   289,   290,   291,   292,     0,
     293,   294,   295,   296,   297,   298,     0,     0,   300,   301,
     302,     0,     0,     0,     0,     0,     0,     0,   304,   305,
     306,   307,   308,   309,   310,   311,   312,     0,   313,     0,
     314,   315,   316,   317,   318,   319,   320,     0,   321,   322,
     323,   324,     0,     0,   325,   326,   327,   328,   329,     0,
     330,   331,   332,   333,     0,   334,   335,   336,   337,     0,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
       0,   348,     0,   349,   350,   351,   352,   353,     0,   354,
       0,   355,   356,     0,     0,     0,   359,   360,   361,   362,
       0,   363,   364,     0,   365,   366,   367,     0,   368,   369,
     370,   371,  5121,     0,   374,   375,   376,   377,     0,   378,
     379,   380,   381,   382,   383,   384,   385,     0,   386,     0,
     388,   389,   390,   391,   392,   393,   394,     0,   395,     0,
     396,     0,     0,   399,     0,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,     0,     0,   419,   420,     0,   422,     0,
       0,   424,   425,   426,     0,     0,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,     0,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,     0,
     460,   461,     0,   463,     0,   464,   465,   466,   467,   468,
     469,     0,   470,   471,   472,     0,     0,   473,   474,   475,
       0,     0,   476,   477,   478,     0,   480,     0,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
       0,     0,   494,   495,   496,   497,   498,   499,   500,   501,
     502,     0,   503,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   513,   514,   515,   516,   517,   518,     0,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,     0,   532,   533,     0,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,     0,   551,   552,   553,   554,   555,     0,   556,
     557,   558,   559,   560,     0,   562,   563,   564,   565,     0,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,     0,   583,   584,
       0,     0,   585,     0,   587,   588,   589,   590,   591,   592,
       0,   593,   594,   595,     0,     0,   596,   597,   598,   599,
     600,     0,   601,   602,   603,   604,   605,   606,   607,   608,
     609,     0,     0,   610,   611,   612,   613,   614,     0,     0,
     615,   616,   617,   618,   619,   620,   621,     0,   622,     0,
     624,   625,   626,   627,     0,     0,   628,     0,     0,   629,
     630,   631,   632,   633,   634,   635,   636,   637,   638,   639,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   656,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   236,   237,   238,   239,
     240,   241,   242,   243,   244,     0,   245,   246,   247,     0,
       0,     0,     0,     0,     0,     0,   248,   249,   250,     0,
     251,   252,   253,   254,     0,   256,   257,   258,   259,   260,
       0,   262,   263,     0,   264,   265,   266,   267,   268,   269,
     270,     0,     0,   271,   272,   273,   274,   275,     0,   276,
     277,   278,   279,   280,     0,     0,     0,   282,   283,   284,
     285,   286,   287,     0,   289,   290,   291,   292,     0,   293,
     294,   295,   296,   297,   298,     0,     0,   300,   301,   302,
       0,     0,     0,     0,     0,     0,     0,   304,   305,   306,
     307,   308,   309,   310,   311,   312,     0,   313,     0,   314,
     315,   316,   317,   318,   319,   320,     0,   321,   322,   323,
     324,     0,     0,   325,   326,   327,   328,   329,     0,   330,
     331,   332,   333,     0,   334,   335,   336,   337,     0,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,     0,
     348,     0,   349,   350,   351,   352,   353,     0,   354,     0,
     355,   356,     0,     0,     0,   359,   360,   361,   362,     0,
     363,   364,     0,   365,   366,   367,     0,   368,   369,   370,
     371,   372,     0,   374,   375,   376,   377,     0,   378,   379,
     380,   381,   382,   383,   384,   385,     0,   386,     0,   388,
     389,   390,   391,   392,   393,   394,     0,   395,     0,   396,
       0,     0,   399,     0,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,   412,   413,   414,   415,   416,
     417,   418,     0,     0,   419,   420,     0,   422,     0,     0,
     424,   425,   426,     0,     0,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   439,   440,   441,
     442,   443,   444,   445,   446,     0,   448,  6342,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,     0,   460,
     461,     0,   463,     0,   464,   465,   466,   467,   468,   469,
       0,   470,   471,   472,     0,     0,   473,   474,   475,     0,
       0,   476,   477,   478,     0,   480,     0,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,     0,
       0,   494,   495,   496,   497,   498,   499,   500,   501,   502,
       0,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,   513,   514,   515,   516,   517,   518,     0,   519,   520,
     521,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     531,     0,   532,   533,     0,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,     0,   551,   552,   553,   554,   555,     0,   556,   557,
     558,   559,   560,     0,   562,   563,   564,   565,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,     0,   583,   584,     0,
       0,   585,     0,   587,   588,   589,   590,   591,   592,     0,
     593,   594,   595,     0,     0,   596,   597,   598,   599,   600,
       0,   601,   602,   603,   604,   605,   606,   607,   608,   609,
       0,     0,   610,   611,   612,   613,   614,     0,     0,   615,
     616,   617,   618,   619,   620,   621,     0,   622,     0,   624,
     625,   626,   627,     0,     0,   628,     0,     0,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   656,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,     0,   245,   246,   247,     0,     0,
       0,     0,     0,     0,     0,   248,   249,   250,     0,   251,
     252,   253,   254,     0,   256,   257,   258,   259,   260,     0,
     262,   263,     0,   264,   265,   266,   267,   268,   269,   270,
       0,     0,   271,   272,   273,   274,   275,     0,   276,   277,
     278,   279,   280,     0,     0,     0,   282,   283,   284,   285,
     286,   287,     0,   289,   290,   291,   292,     0,   293,   294,
     295,   296,   297,   298,     0,     0,   300,   301,   302,     0,
       0,     0,     0,     0,     0,     0,   304,   305,   306,   307,
     308,   309,   310,   311,   312,     0,   313,     0,   314,   315,
     316,   317,   318,   319,   320,     0,   321,   322,   323,   324,
       0,     0,   325,   326,   327,   328,   329,     0,   330,   331,
     332,   333,     0,   334,   335,   336,   337,     0,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,     0,   348,
       0,   349,   350,   351,   352,   353,     0,   354,     0,   355,
     356,     0,     0,     0,   359,   360,   361,   362,     0,   363,
     364,     0,   365,     0,   367,     0,   368,   369,   370,   371,
     372,     0,   374,   375,   376,   377,     0,   378,   379,   380,
     381,   382,   383,   384,   385,     0,   386,     0,   388,   389,
     390,   391,   392,   393,   394,     0,   395,     0,   396,     0,
       0,   399,     0,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,     0,     0,   419,   420,     0,   422,     0,     0,   424,
     425,   426,     0,     0,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,     0,   448,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,     0,   460,   461,
       0,   463,     0,   464,   465,   466,   467,   468,   469,     0,
     470,   471,   472,     0,     0,   473,   474,   475,     0,     0,
     476,   477,   478,     0,   480,     0,   482,   483,   484,   485,
     486,   487,   488,   489,     0,   491,   492,   493,     0,     0,
     494,   495,   496,   497,   498,   499,   500,   501,   502,     0,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     0,
     513,   514,   515,   516,   517,   518,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
       0,   532,   533,     0,   535,   536,   537,   538,   539,   540,
       0,   542,   543,   544,   545,   546,   547,   548,   549,   550,
       0,   551,   552,   553,   554,   555,     0,   556,   557,   558,
     559,   560,     0,   562,   563,   564,   565,     0,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   580,   581,   582,     0,   583,   584,     0,     0,
     585,     0,   587,   588,   589,   590,   591,   592,     0,   593,
     594,   595,     0,     0,   596,   597,   598,   599,   600,     0,
     601,   602,   603,   604,   605,   606,   607,   608,   609,     0,
       0,   610,   611,   612,   613,   614,     0,     0,   615,   616,
     617,   618,   619,   620,   621,     0,   622,     0,   624,   625,
     626,   627,     0,     0,   628,     0,     0,   629,   630,   631,
     632,   633,   634,   635,   636,   637,   638,   639,   640,   641,
     642,   643,   644,   645,   646,   647,   648,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   885,   261,   886,
     887,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   888,   889,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   890,   891,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   893,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,  2739,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,  2740,   389,   390,
     391,   392,   894,   895,     0,   896,     0,   396,   397,   398,
     399,   400,   897,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   898,   447,   899,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   900,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,  2742,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     901,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,  2743,   559,
     560,   561,   562,   563,   903,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   904,
     905,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   906,  2744,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   885,   261,   886,   887,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   888,   889,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   890,   891,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   893,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   894,   895,     0,
     896,     0,   396,   397,   398,   399,   400,   897,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   898,   447,   899,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,  2824,     0,   465,   900,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   901,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  2743,   559,   560,   561,   562,   563,   903,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,  4638,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   904,   905,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   906,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   885,   261,   886,
     887,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   888,   889,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   890,   891,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   893,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   894,   895,     0,   896,     0,   396,   397,   398,
     399,   400,   897,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   898,   447,   899,   449,   450,   451,   452,   453,
     454,   455,   456,  2902,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   900,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     901,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   902,   559,
     560,   561,   562,   563,   903,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   904,
     905,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   906,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   885,   261,   886,   887,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   888,   889,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   890,   891,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   893,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   894,   895,     0,
     896,     0,   396,   397,   398,   399,   400,   897,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   898,   447,   899,
     449,   450,   451,   452,   453,   454,   455,   456,  4434,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   900,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   901,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   902,   559,   560,   561,   562,   563,   903,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   904,   905,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   906,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   885,   261,   886,
     887,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   888,   889,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   890,   891,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   893,   353,  6029,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   894,   895,     0,   896,     0,   396,   397,   398,
     399,   400,   897,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   898,   447,   899,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   900,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     901,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   902,   559,
     560,   561,   562,   563,   903,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   904,
     905,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   906,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   885,   261,   886,   887,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   888,   889,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   890,   891,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   893,   353,
    6385,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   894,   895,     0,
     896,     0,   396,   397,   398,   399,   400,   897,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   898,   447,   899,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   900,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   901,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   902,   559,   560,   561,   562,   563,   903,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   904,   905,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   906,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   885,   261,   886,
     887,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   888,   889,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   890,   891,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   893,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   894,   895,     0,   896,     0,   396,   397,   398,
     399,   400,   897,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   898,   447,   899,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   900,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     901,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   902,   559,
     560,   561,   562,   563,   903,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   904,
     905,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   906,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   885,   261,   886,   887,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   888,   889,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   890,   891,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   893,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,  1160,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   894,   895,     0,
     896,     0,   396,   397,   398,   399,   400,   897,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   898,   447,   899,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   900,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   901,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,   902,   559,   560,   561,   562,   563,   903,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   904,   905,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   906,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   885,   261,   886,
     887,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   888,   889,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   890,   891,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   893,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,  1192,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   894,   895,     0,   896,     0,   396,   397,   398,
     399,   400,   897,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   898,   447,   899,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   900,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     901,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,   902,   559,
     560,   561,   562,   563,   903,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   904,
     905,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   906,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,   885,   261,   886,   887,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,   888,   889,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,   890,   891,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   892,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,   893,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,   894,   895,     0,
     896,     0,   396,   397,   398,   399,   400,   897,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,   898,   447,   899,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,   900,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,   901,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,  2743,   559,   560,   561,   562,   563,   903,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,   904,   905,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,   906,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,   884,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,   244,     0,   245,   246,   247,     0,     0,     0,
       0,     0,     0,     0,   248,   249,   250,     0,   251,   252,
     253,   254,   255,   256,   257,   258,     0,   885,   261,   886,
     887,     0,   264,   265,   266,   267,   268,   269,   270,     0,
       0,   271,   272,   888,   889,   275,     0,   276,   277,   278,
     279,     0,     0,   281,     0,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,     0,   293,   294,   295,
     296,   297,   298,     0,   299,   300,   301,   302,     0,     0,
       0,   303,     0,     0,     0,   304,   305,   306,   307,   308,
     309,   890,   891,   312,     0,   313,     0,   314,   315,   316,
     317,   318,   319,   320,     0,   321,   322,   323,   324,     0,
       0,   325,   326,   892,   328,   329,     0,   330,   331,   332,
     333,     0,   334,   335,   336,   337,     0,   338,   339,   340,
     341,     0,   343,   344,   345,   346,     0,     0,   348,     0,
     349,   350,   351,   893,   353,     0,   354,     0,   355,   356,
     357,     0,   358,   359,   360,   361,   362,     0,   363,     0,
       0,     0,   366,   367,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,     0,   378,   379,   380,   381,
     382,   383,   384,   385,     0,   386,   387,     0,   389,   390,
     391,   392,   894,   895,     0,   896,     0,   396,   397,   398,
     399,   400,   897,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   412,   413,   414,   415,   416,   417,   418,
       0,     0,   419,     0,   421,   422,   423,     0,   424,   425,
     426,     0,     0,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,     0,   438,   439,   440,   441,   442,   443,
     444,   445,   898,   447,   899,   449,   450,   451,   452,   453,
     454,   455,   456,     0,     0,   459,     0,   460,   461,   462,
     463,     0,     0,   465,   900,   467,   468,   469,     0,   470,
     471,   472,     0,     0,   473,   474,   475,     0,     0,   476,
     477,     0,   479,   480,   481,     0,   483,   484,   485,   486,
     487,   488,   489,   490,   491,   492,   493,     0,     0,   494,
     495,   496,     0,   498,     0,   500,   501,   502,     0,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     901,   515,   516,   517,   518,     0,   519,   520,   521,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   531,     0,
     532,   533,   534,   535,   536,   537,   538,   539,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,     0,
     551,   552,   553,   554,   555,     0,   556,   557,     0,   559,
     560,   561,   562,   563,   903,   565,     0,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   576,   577,   578,
     579,   580,     0,   582,     0,   583,   584,     0,     0,   585,
     586,   587,   588,   589,   590,   591,   592,     0,   593,   904,
     905,     0,     0,   596,   597,     0,   599,     0,     0,   601,
     602,   603,   604,   605,   606,   607,   608,   609,     0,     0,
     610,   611,   612,   613,   614,     0,     0,   615,   616,   617,
     618,   619,     0,   906,     0,   622,   623,   624,   625,   626,
     627,     0,     0,   628,     0,     0,   629,   630,   631,   632,
     633,   634,   884,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   646,   647,   648,     0,     0,     0,   236,
     237,   238,   239,   240,   241,   242,   243,   244,     0,   245,
     246,   247,     0,     0,     0,     0,     0,     0,     0,   248,
     249,   250,     0,   251,   252,   253,   254,   255,   256,   257,
     258,     0,     0,   261,     0,     0,     0,   264,   265,   266,
     267,   268,   269,   270,     0,     0,   271,   272,     0,     0,
     275,     0,   276,   277,   278,   279,     0,     0,   281,     0,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,     0,   293,   294,   295,   296,   297,   298,     0,   299,
     300,   301,   302,     0,     0,     0,   303,     0,     0,     0,
     304,   305,   306,   307,   308,   309,     0,     0,   312,     0,
     313,     0,   314,   315,   316,   317,   318,   319,   320,     0,
     321,   322,   323,   324,     0,     0,   325,   326,   327,   328,
     329,     0,   330,   331,   332,   333,     0,   334,   335,   336,
     337,     0,   338,   339,   340,   341,     0,   343,   344,   345,
     346,     0,     0,   348,     0,   349,   350,   351,     0,   353,
       0,   354,     0,   355,   356,   357,     0,   358,   359,   360,
     361,   362,     0,   363,     0,     0,     0,   366,   367,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
       0,   378,   379,   380,   381,   382,   383,   384,   385,     0,
     386,   387,     0,   389,   390,   391,   392,     0,     0,     0,
       0,     0,   396,   397,   398,   399,   400,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   413,
     414,   415,   416,   417,   418,     0,     0,   419,     0,   421,
     422,   423,     0,   424,   425,   426,     0,     0,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,     0,   438,
     439,   440,   441,   442,   443,   444,   445,     0,   447,     0,
     449,   450,   451,   452,   453,   454,   455,   456,     0,     0,
     459,     0,   460,   461,   462,   463,     0,     0,   465,     0,
     467,   468,   469,     0,   470,   471,   472,     0,     0,   473,
     474,   475,     0,     0,   476,   477,     0,   479,   480,   481,
       0,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,     0,     0,   494,   495,   496,     0,   498,     0,
     500,   501,   502,     0,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,   513,     0,   515,   516,   517,   518,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,     0,   532,   533,   534,   535,   536,
     537,   538,   539,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,     0,   551,   552,   553,   554,   555,
       0,   556,   557,     0,   559,   560,   561,   562,   563,     0,
     565,     0,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,     0,   582,     0,
     583,   584,     0,     0,   585,   586,   587,   588,   589,   590,
     591,   592,     0,   593,     0,     0,     0,     0,   596,   597,
       0,   599,     0,     0,   601,   602,   603,   604,   605,   606,
     607,   608,   609,     0,     0,   610,   611,   612,   613,   614,
       0,     0,   615,   616,   617,   618,   619,     0,     0,     0,
     622,   623,   624,   625,   626,   627,     0,     0,   628,     0,
       0,   629,   630,   631,   632,   633,   634,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   646,   647,
     648
};

static const yytype_int16 yycheck[] =
{
       6,   947,     0,     0,     0,     0,  1055,     0,     0,    45,
       0,     0,    57,     0,     0,     0,     0,    23,  1046,    25,
       0,     0,     0,    29,    30,     0,    21,   212,    21,    35,
      36,    37,     0,    39,  1608,   684,    42,    43,     0,    45,
     212,    47,  1172,   190,  1018,  1673,   852,  1233,    54,    55,
      56,   797,   798,   799,     8,  1592,   854,   803,    46,  1050,
     921,    15,  1035,   207,     6,   902,    22,   941,   985,   943,
     663,   215,    28,  2850,   218,  2076,  1019,  2725,   757,  1592,
     890,   891,     0,   878,  1585,    37,  1044,  3438,   872,  3440,
     900,  1299,  1517,   198,  2726,  1286,  3078,  1912,   959,   845,
    1121,  3257,   858,   716,  3143,    30,   217,   761,   871,  1597,
      36,   905,  3948,  3932,  3530,  3618,  2683,    43,  3734,  1740,
     231,  1272,  1095,   716,  2066,  1276,  1099,  2103,  1279,  1280,
      23,  1104,   665,  1707,  1708,  1638,  1639,  2084,  1055,  1642,
    3680,  1114,  3682,   984,    37,  3043,  3981,  3045,  3046,  4281,
    2102,  2996,  3050,  3051,  3052,  1128,  3054,  3055,  3056,  3090,
    1585,  3488,  4838,  3884,  3540,  2974,  3959,  4324,  1009,  1984,
     763,   176,   762,  1014,  4303,  1048,   737,  4603,  1474,   740,
     752,  1925,  3652,  3105,  3654,  5232,  1159,  2141,  4571,  4365,
     226,     2,   198,   199,   200,  2747,  2748,   203,    36,  4626,
    5322,   207,   815,   209,  5362,  4609,   212,   970,  4410,   215,
    5452,   192,   218,  1701,  4614,   221,  3504,   223,  2117,  4741,
     226,  4743,   815,  1110,   230,  2626,   232,   192,  5488,  2630,
    4613,  5102,  4854,  5159,  4856,  2642,    42,  3482,   831,  1126,
    1728,    51,  3300,  5151,  2710,  3392,  3550,  2712,  5500,   944,
    2098,  2099,  2100,  2101,  5146,   944,  2104,  3946,  2106,  2107,
    5353,  5753,  4928,     6,     6,  3487,  3397,  3489,  3490,     6,
       0,    38,    21,     0,     0,  1558,    54,  3086,  5737,  5150,
      11,    11,  2689,   876,    13,  4779,     6,    78,     6,     6,
       6,     0,   968,  3538,    29,     0,  1059,    15,    16,    29,
      63,   888,   889,  4463,  5416,  5417,   148,    21,     0,    47,
       6,    95,   899,     6,    37,     6,  5409,   120,    37,    11,
      35,    72,    15,    16,    15,    16,    85,  1018,  2072,     6,
       6,   171,     6,  1009,    13,   120,  1027,    29,  1014,    43,
      43,    23,   157,  1089,  1261,   938,  1037,   184,  1265,  1266,
       6,     6,   122,     6,     6,    80,     5,    47,    47,     6,
     122,   222,    11,   113,   177,    63,    45,   115,     3,    88,
      80,     6,     3,   177,     5,     6,   177,   120,    89,   739,
      11,    15,    92,   177,   184,    80,    37,     6,  1891,    11,
     125,    21,  5441,   753,    11,    37,    63,    92,    63,    78,
       5,  5639,   153,     6,   308,   177,    11,  6134,  3620,  4705,
    4706,  4707,  1207,  4709,  4710,  4711,  4712,  4713,    80,    92,
      13,   132,   173,  6134,   206,  4627,   179,   324,    92,    21,
     309,   171,   818,   188,   177,    92,   346,  6009,    63,  1430,
     309,   667,   293,   351,   322,   193,   179,   177,   135,    63,
     177,   177,    64,   384,   112,    63,   226,  1111,   395,    29,
      72,   168,  1055,   120,  1422,  1486,    36,   179,   177,  5961,
     367,   201,   177,   155,   201,   201,   184,  5369,    13,    25,
     115,   216,    13,   359,   447,   177,   402,  1478,   124,   120,
     360,   177,   201,  5952,   384,  5755,   201,   434,   120,   684,
     447,   324,  6340,   124,   386,   402,   472,  1317,  1318,   201,
      45,    99,   354,  4939,    45,   482,    80,   332,    80,   152,
    6247,  6383,   292,   271,    80,  5380,   274,   172,    25,    32,
     384,   179,   389,   759,  1894,  1636,  6247,   322,  3105,  1349,
     363,   478,  4941,    78,   367,     5,   173,    78,   297,   734,
    4949,    11,  1653,  6002,  1914,     5,    59,   310,   193,  5652,
     184,    11,   419,   208,   418,   213,  1360,   534,   534,  5424,
     452,   682,  6410,    13,  6436,   538,   283,   688,    37,   402,
     470,  5489,    80,   297,  1379,   355,    63,   223,   372,   700,
     221,   538,     6,   344,   140,   183,  1587,   534,   310,   354,
     478,  1474,   223,   534,    29,   292,    29,   477,   484,   267,
     373,    36,   491,    36,   272,   348,   327,  1380,   177,   470,
     253,   847,   538,  1213,   534,   256,   534,   496,   532,   369,
     385,  6123,   536,  5871,  5449,   292,   271,   534,  1024,   274,
     243,  6368,  1255,   140,   256,   393,  1563,  1410,   178,   399,
    1445,  5700,   434,   447,   491,   534,  1573,  6368,   664,    37,
     395,   120,  1255,   125,   670,  1475,   672,   297,   674,   422,
     177,   677,  1265,  1266,   136,   373,   669,   538,   684,  1292,
     669,  3893,   669,   689,   142,   691,    23,   125,  5310,  4410,
     669,   697,   534,   478,   534,  1668,  6268,   512,  1671,  1292,
    5960,   538,   384,   462,   447,   297,   373,   669,   373,   447,
    1738,  1739,   474,   332,   465,   721,  1511,  4438,   763,  1306,
    1307,   524,   447,   405,   730,   538,   430,   430,   734,   440,
     534,   737,   447,   534,   740,   470,  1679,   447,   538,   477,
    6232,   532,   461,  1660,   481,   536,  1663,  1664,   373,   534,
     756,   669,   447,  4882,   538,  1642,   534,  1344,   393,   373,
    1439,   509,   767,  4582,  5258,   373,   538,   534,   538,   762,
      23,  6230,   495,   809,    23,   538,   495,    23,  1736,   452,
    4940,   524,  1623,   447,  5896,   447,  4622,   477,   477,   538,
     532,  4951,   534,   536,   536,   525,   526,   534,  2081,  1745,
     947,   530,   533,   809,  4623,  1692,  1693,   537,   814,  1504,
     537,   537,   818,   819,   534,  1504,   534,   534,   534,  1179,
    6312,   777,  1659,   779,   538,   781,  2012,   833,   537,  4445,
     538,   787,   537,   525,   526,  4451,   872,   791,   534,  5747,
     538,   534,   412,   534,   495,   537,   852,   853,   854,   855,
     856,   530,   538,   495,  6114,   314,  1986,   534,   534,  5751,
     534,   867,   515,   516,  1451,  1452,   872,  6359,   515,   516,
    1561,   538,   878,   538,   509,  6127,   525,   526,   534,   534,
    1240,   534,   534,   447,  1069,   447,   491,   534,   814,  2019,
     524,   447,   818,   819,   525,   526,   373,  1069,   532,  4369,
    6142,  2031,   536,   525,   526,   402,  4627,  1583,   525,   526,
     515,  1271,  3479,   538,   538,  3482,   952,  4244,  5214,   925,
     525,   526,  1066,   301,   538,   262,  1070,  1287,  1072,    25,
     538,   967,  1623,   939,   527,   528,   529,   530,  1855,   937,
     937,   937,   937,    63,   937,   937,   952,   937,   937,   447,
     937,   937,   937,   937,   935,  1060,  6049,   937,   937,   937,
    1636,   967,   937,  3530,  3862,   961,  5632,  3776,  3777,   937,
     935,  3538,  3781,   470,  6234,   937,  4123,  1653,  6071,   538,
     986,  1630,  4113,  4114,  4673,   991,   992,   412,  3919,   412,
     525,   526,   527,   528,   529,   530,   527,   528,   529,   530,
    1873,  3553,  6451,  3555,   534,  1892,   420,   421,   470,   262,
     388,  4256,  4316,   262,  6463,  4260,   262,  1023,  1024,   937,
      32,  4243,    32,  4245,  4246,  1558,    25,    10,  4531,   487,
      13,   538,   470,  5959,    17,    18,    19,    29,  4096,   163,
    1046,  1047,  3449,  3509,   140,  3510,  5472,    23,  5956,   855,
     856,  6311,   389,  5868,  1060,    51,  1062,   177,  5873,  5874,
    1066,   538,  4532,  1069,  1070,   524,  1072,  4198,  5939,   879,
     127,  1077,   125,   532,  2102,   534,   535,   536,   114,   538,
    6238,  6239,   201,   194,  5955,   525,   526,   527,   528,   529,
     530,  1538,  2083,   113,   156,  1101,  5479,  1023,  1024,   477,
     437,    10,  1108,  1109,    13,  6152,    63,  3916,    17,    18,
      19,   125,  6205,   171,  6043,   329,   155,    23,   186,    37,
      23,   177,   120,    22,  1130,  1131,  1132,   113,  1134,    28,
    1136,   468,  1138,  1139,   115,   125,   389,     3,   170,   256,
    3541,   140,  5689,   389,  5691,    25,   113,  2138,  5695,  5696,
    4438,    31,    10,   113,   379,  4658,   493,  6399,  2932,    17,
      18,    19,    35,   216,     6,   296,  1172,   189,  1174,  1175,
     206,  6293,   309,   266,   120,  1921,   177,   165,  4594,   389,
     288,  5383,  5358,   120,   437,  1023,   384,   311,   437,   386,
       6,   437,   488,   367,   308,  6417,  6449,   534,  6124,   292,
      27,  1207,   216,  6361,   177,  1639,  5828,  6115,  1642,   308,
     265,    23,   193,  6466,   103,   468,   312,  6439,   201,   468,
    1213,   125,   468,    50,    89,    91,   216,  1233,   201,  1235,
    2028,  2029,   178,  1239,   171,  1241,   434,   292,   155,  3013,
     493,   224,   538,    23,   493,  1838,   471,   493,    72,    10,
      63,   189,    13,    52,   268,   452,    17,    18,    19,   367,
     140,  1267,  1216,     6,  1218,   253,  1220,   132,  1222,   389,
    1224,  1225,  1226,   447,    35,   371,   372,  1231,   409,   145,
    1286,   534,     6,   156,  1290,   534,   262,  2082,   534,  2084,
     271,  3245,  2165,   274,   288,  2090,   120,   186,  1304,   297,
    6422,  2096,  2097,  5825,    40,  5141,   402,   339,  5734,   311,
    1989,   379,   216,  2108,  6240,   224,  5135,  5743,    54,  5719,
     534,   288,  2747,  2118,   534,   324,  2814,   310,   445,  2124,
     454,  2844,  3884,  1144,  1379,  5718,  6383,  5172,  5765,  2018,
    1346,  5745,   395,  2022,   336,  3089,   314,   293,  2027,  5749,
     288,  2030,     3,   389,   491,  5148,   262,   181,   370,   262,
     370,  6290,    28,   483,  3316,  5748,   405,  5793,   367,  1375,
    1376,  1377,  2135,  1379,   384,   111,   386,  1949,   374,    10,
      99,   314,    13,   301,  6310,  2681,    17,    18,    19,  6436,
     217,   447,  1953,   259,  1400,  6321,   432,   196,   434,   288,
     119,   310,   201,   402,    35,   397,  1996,  1968,  2896,  1981,
    1971,  3032,   393,   389,   434,   472,   373,   470,    25,   538,
     534,  1427,  3974,   534,    31,   487,    92,  4897,  1875,  1434,
     152,  3330,  3331,   491,  6360,  5982,  3335,   156,    23,  1445,
      91,    25,   452,  4365,   324,  1630,   447,   439,   434,   441,
     262,  4921,   310,   252,   476,   297,   470,  1891,   324,    23,
    2021,   437,   327,   224,  2025,  2026,  2115,  6393,   292,  5626,
    1506,    89,  1508,   297,   434,   288,   475,  3376,  3377,   215,
     470,   297,   262,   389,     3,  1491,   389,   367,   405,  1495,
    1496,  5620,   468,  6169,  3122,   146,     3,   156,   220,  6425,
    1506,  1507,  1508,  1509,  4880,  1511,    76,   120,  1489,  1490,
     299,  1492,  4839,   179,   132,  5941,   510,   493,   491,    26,
     344,   314,   402,   524,  1489,  1490,   472,  1492,   509,  1535,
     143,   437,   534,   140,   437,   536,   149,   361,   476,   522,
     523,   524,   525,   526,   527,   528,   529,   530,  2081,   310,
     163,   455,   288,   534,   297,   444,   140,   208,   534,  5099,
     373,   189,   468,   288,  1570,   468,   470,   535,   302,  1575,
     538,   437,  1578,   297,   440,   440,   120,   389,   369,    87,
     329,   178,     6,   122,    91,  1591,  1592,   493,   309,   402,
     493,   156,   314,   224,  1600,   329,  1956,  1603,  4843,  2627,
    4639,   120,    30,  4848,   389,   538,  4851,   302,   407,   389,
    1970,   434,   136,   522,   523,   524,   525,   526,   527,   528,
     529,   530,  4520,  1983,  1630,   437,  1632,  4525,   534,  1635,
     125,   534,  1638,  1639,   329,   309,  1642,    68,  2629,   146,
    3141,   465,  5478,   133,   363,   140,  1652,    72,  1644,  1655,
    1575,   189,  1658,  1649,   144,   391,   468,   437,   122,   167,
     288,  1697,  5383,   193,   522,   523,   524,   525,   526,   527,
     528,   529,   530,  4595,  1680,  5851,   395,   262,   177,   310,
     331,   493,   348,   472,   297,  6111,    42,   226,   468,  4256,
     122,  1697,   216,  4260,   201,   375,   324,  5490,   262,   171,
     491,   208,   201,  1709,  1710,  1711,  1712,  1713,    72,   327,
    1635,   183,  3137,   493,   271,   434,  3141,   324,  6120,  6121,
     386,  1727,   534,  2772,   515,   182,  1722,  1652,    92,   201,
    1726,   328,  1738,  1739,  1740,   305,   395,   239,  5870,   367,
     324,   271,   464,   180,   205,   538,    25,   538,   292,   534,
     288,   476,   168,   292,   534,   323,   343,  4602,   152,   478,
     367,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     491,   165,   491,   292,   312,   434,   402,   171,   297,  1964,
    1965,  4558,   165,   367,   450,   534,   452,  4596,   171,   217,
     456,   372,   323,  1965,   226,   402,   515,   402,  4365,   256,
     534,   324,  6228,   535,   389,   307,   538,   487,  2681,   266,
    1954,   408,   463,   332,   180,   534,   355,   491,   402,   478,
     471,   402,   440,   474,   331,   389,   220,   288,   240,   245,
     395,  1837,   491,   297,   324,   135,   393,   137,  1943,   534,
      39,   454,  1848,   199,   367,   389,   341,   266,   476,   402,
    1856,  1857,   437,   466,   242,  2772,   515,   288,  4410,   253,
     292,   140,   449,   393,   122,  2660,  1872,   292,    29,   434,
     253,   402,   379,   437,   403,   534,   288,   367,   777,   402,
     779,  6307,   781,   468,  1890,  1891,  4438,   122,   787,   788,
     789,   522,   523,   524,   525,   526,   527,   528,   529,   530,
    1906,  1907,  1908,  1909,   468,   377,  2743,   494,   493,  1915,
     304,  6313,   538,   478,  4836,   302,  1922,  5736,    29,  1925,
     314,   304,  6054,   355,   431,  2723,   491,  5763,   292,   493,
    2115,   130,    10,   538,  1940,    13,   171,  1943,   476,    17,
      18,    19,   329,   355,    15,    16,   383,  1953,  1954,   534,
     515,   240,   210,   390,    80,   534,   463,    35,  1964,  1965,
     397,  5754,  1968,   302,   471,  1971,    92,   474,  2942,   534,
     534,   779,   780,   781,   135,   210,   784,   785,   786,   411,
    1986,  1987,   439,   349,   441,   538,   794,  1993,    10,  1995,
     329,    13,   292,   405,   402,    17,    18,    19,   435,   288,
     201,    10,  2038,  1996,    13,   534,  2012,  2880,    17,    18,
      19,   468,   482,  2019,  5517,  2021,    38,   383,  2024,  2025,
    2026,   458,  2028,  2029,   135,  2031,    35,  4594,  4595,  2946,
     288,   397,  2038,  2906,   292,   449,  3166,  2954,  4039,   384,
    2957,   386,   324,   534,  1998,   324,  2000,   323,  2002,  5205,
    2004,   524,  2006,   288,  2099,   165,  2010,   292,   470,  4060,
     120,  5306,  2068,   536,   534,  2071,  2072,  6243,  2074,   435,
     464,  2077,  2078,  2066,   323,  4627,  2082,  2066,  2084,  2066,
    3026,  3027,  3028,  2089,  2090,   367,   985,  2066,   367,   120,
    2096,  2097,  2098,  2099,  2100,  2101,  2102,  2103,  2104,  2105,
    2106,  2107,  2108,   763,  2066,  2992,  2112,   452,  2114,  2115,
    2116,  2117,  2118,  2119,  2120,  2121,   405,  5953,  2124,  5101,
    2126,  2127,  2074,   402,  2130,  3550,   402,   402,   159,  4076,
     538,  3759,   333,  3006,  3635,  3560,  4112,  5972,   532,  2145,
    2146,  2147,   536,   253,   472,  4097,   224,   534,  2066,   178,
    4102,  2842,    13,   402,  2995,  3363,  1055,  2163,  5140,  2922,
    5511,  5954,   324,   194,     0,  5063,   367,  5065,  5066,  5067,
     371,   831,    69,    70,  2920,   312,  2922,  5717,  5334,  2772,
    5336,   470,   359,   212,  2077,  3158,   165,   324,  6364,  5120,
     100,    48,   171,   123,   304,   534,   447,  2203,   227,  3072,
    4015,   402,   224,  5125,   322,   367,   534,    13,   324,   371,
    3635,   154,    25,    25,    71,   224,   876,    78,    31,   396,
    3841,   250,  3109,  3110,  3111,  3112,  3847,  3114,   343,  3732,
     367,   491,   310,   314,   359,  4134,  4135,  4136,  4137,    45,
     402,  4140,  4141,  4142,  4143,  4144,  4145,  4146,  4147,  4148,
    4149,  2942,  3139,  4101,   537,   515,    29,   434,  4106,  4107,
     203,   292,   322,   538,   538,    33,    34,   197,   178,  4836,
     123,   396,    78,   524,   253,   324,  4843,   395,   938,    91,
    5089,  4848,  5091,   123,  4851,   536,   402,  5790,   310,  2980,
     491,  2970,  4234,  2972,   491,  3783,    80,  2976,  5768,  3216,
     324,   310,   212,   112,  2310,  4204,  4205,   484,    92,   434,
      83,   392,    35,    86,   515,   100,   434,   227,   367,    58,
      93,   133,   324,  6116,  3015,   304,  5742,   140,   140,  3246,
      10,    99,   144,    13,   449,   395,  3544,    17,    18,    19,
     250,   538,  3830,   367,   197,   100,   483,  5698,   121,   378,
    1644,   119,   491,   402,   346,  1649,  3229,   197,  2364,   484,
     478,   371,  1261,   172,   333,   367,  1265,  1266,   367,   279,
     152,   432,   452,   491,   434,  6389,   515,  6391,   402,   494,
     413,  3955,   439,   165,   441,   449,  3132,   367,   156,   171,
     129,   484,   402,   178,  4242,   534,   292,   515,   308,   208,
     402,   297,   371,   402,  5326,   438,  1214,   491,   181,  1217,
     471,  1219,   491,  1221,  2420,  1223,   534,   491,   478,  1227,
     208,   194,   402,   178,   301,  6244,    94,   212,  1722,   217,
     494,   491,  1726,   402,   207,  6051,  5358,  3091,   220,  6453,
    6233,   515,   227,   231,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   355,   538,   515,   352,   212,   267,   538,
     447,   392,  6438,   272,   538,   250,   368,   182,   378,   137,
     452,   253,   227,   171,   534,    27,  6452,  2674,  2675,  2676,
    2840,  3354,   324,    10,    38,   472,    13,  3360,    33,    34,
      17,    18,    19,  3439,   279,   250,   398,   195,    50,  5850,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   384,
     385,   171,   324,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   304,   308,   279,   367,  1013,    81,   171,   491,
     243,  5429,   314,     5,  3213,   195,  3299,  3332,   533,    11,
     282,   256,   532,   538,   224,  1032,   536,    19,  1035,  3344,
    1449,   363,   195,   515,   152,   367,   515,   516,  5125,  1458,
     534,  1460,   472,   533,   306,  1464,    38,   165,   538,   515,
     516,   270,  1471,   171,   527,   534,     5,  6396,  5500,   532,
     534,   534,    11,   536,   529,  3380,  6056,  6057,   534,   534,
     402,   536,   532,   378,   534,   363,   536,   409,  2604,  2605,
    2606,  2607,  2608,  2609,  2610,  2611,  2612,   527,  2614,   439,
     529,   441,   532,   392,   534,   534,   536,   536,  2624,  2625,
    2805,  2627,   220,   378,   384,   385,  5654,   395,  2634,  3424,
     310,  5659,  5660,  2805,   143,   294,  2642,  3788,  2644,   369,
     149,  2647,  2648,   266,   359,  2651,   419,  2653,  2643,   422,
    2656,  4550,    22,  3246,  2660,   253,   308,  5579,    28,   266,
    2804,   313,  2806,  2807,  1563,    96,   434,  3461,  3462,   206,
     308,  1009,    92,   270,  1573,   313,  1014,  2683,  3621,   534,
     195,   536,   464,  2689,  2690,  4686,  3442,   452,   535,   535,
    3551,   538,   538,   532,  2700,   534,  2801,   284,   285,   286,
     287,    87,  4703,  2709,  2710,  3343,   304,  3345,  3346,   535,
     478,    59,   538,  3656,   482,   484,   314,  2723,  1617,  1618,
     534,   392,   536,   491,   439,  2731,   441,  2733,  2839,  6199,
     535,  5770,  3495,   538,   535,   535,   395,   538,   538,  5306,
     535,  2683,   535,   538,  3735,   538,   535,   515,   243,   538,
    3399,  3561,   535,   468,  4382,   538,   534,  2763,  3944,  5326,
     535,  1660,   182,   538,  1663,  1664,   534,    11,  2774,   484,
    2776,   535,   482,   535,   538,   434,   538,  2813,   395,   535,
    4732,   432,   538,   310,  2790,   534,   206,  4739,  4740,  4604,
     535,  5358,   308,   538,   535,  2801,   152,   538,  2804,  2805,
    2806,  2807,   535,   538,  2810,   538,  4380,  2813,  4382,   165,
    2728,   535,   389,   535,   538,   171,   538,   434,   535,   478,
    2931,   538,  2774,    48,  2776,  5634,  2832,   535,     3,  6299,
     538,  5383,   491,  5642,  5643,  6186,   256,  2763,  2844,   439,
     411,   441,   522,   523,   524,   525,   526,   527,   528,   529,
     530,  2857,  2858,   439,  4367,   441,   515,   535,  2864,  4347,
     538,   478,   535,   311,   220,   538,   464,  2873,  4059,   535,
     293,   294,   538,   534,   491,   534,   535,   511,   537,   535,
    2916,   535,   538,  6415,   538,   535,  6418,   535,   538,  2895,
     538,  4316,  6048,   313,   682,  5365,  5366,   253,   515,  3578,
     688,  3012,   535,   535,  3925,   538,   538,  2832,   535,    59,
    2916,   538,   700,    48,  3887,   535,    91,   534,   538,   535,
     511,  1161,   538,  2929,     0,   535,   226,  1167,   538,  5851,
    4418,  3622,   535,  5500,   484,   538,   535,  1177,   311,   538,
     535,  1181,   491,   538,   493,  1185,  2952,  1187,   304,  2955,
     308,  5503,   535,  1193,   535,   538,  1855,   538,   314,  1199,
     535,   535,  1202,   538,   538,   535,   171,    43,   538,    38,
     145,   535,   395,   536,   538,  2981,  2982,   535,   535,  5611,
     538,   538,   535,   308,  3730,   538,  3599,   515,   516,  3735,
    2996,    60,  2998,  2999,  3881,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   535,   535,  3599,   538,   538,    60,
    3883,   434,  5579,  2969,  6365,   535,  3707,    38,   538,   439,
     135,   441,   137,    99,  3030,  3031,  3032,   491,   535,   493,
    3036,   538,   452,   491,   535,   493,  5958,   538,  3044,    60,
      48,   535,  4616,   112,   538,   465,   535,   226,   468,   538,
     152,  3057,   491,   535,   493,   478,   538,  3063,   535,  3065,
     511,   538,   535,   165,   535,   538,   527,   538,   491,   171,
     535,   176,  3078,   538,  4611,   535,   152,  3083,   538,   535,
    5817,  5818,   538,  3089,   259,   535,  3092,   534,   538,   165,
    6441,   112,   515,  4301,   535,   171,   538,   538,  3104,  3105,
     535,   177,   535,   538,   491,   538,   493,   183,   464,  3115,
     186,   534,  2128,   535,   190,  2131,   538,   481,   220,  3125,
    3264,  3127,  3266,  3267,   535,   340,   535,   538,  6110,   538,
     535,  4632,   534,   538,   535,   204,   535,   538,   535,   538,
     535,   538,   535,   538,   220,   538,   222,   384,   385,   324,
    4067,   253,   535,    37,   535,   538,  3261,   538,   333,   535,
    3166,   537,  3168,  3105,  3170,    59,   535,  3913,   535,   538,
     535,   538,   535,   538,   537,  5742,   535,   253,   535,   538,
    4366,   538,  4368,   204,   535,  4371,  4177,   538,   363,  4228,
     534,  4230,   367,  2092,  2093,   534,   371,  3203,   267,  5847,
     535,   535,   304,   272,   538,  6127,  3124,  4632,   384,   385,
    2109,  2110,   314,   535,  3399,  3575,  3576,   535,   535,   288,
     538,   538,   535,   535,   177,   538,   538,   402,   304,   222,
     535,   535,   308,   538,   538,   222,   535,   535,   314,   538,
     538,  2140,   535,   495,   535,   538,   267,   538,  6015,  6016,
     535,   272,  3931,   538,   323,  3261,  3262,    38,  3264,  4043,
    3266,  3267,   437,  3269,   534,   440,   535,   288,   535,   538,
    3276,   538,   534,  4231,   535,  3281,  3889,   538,  3891,    60,
    4826,   536,  4828,  4274,  5851,  5237,  5238,  3332,  1506,  4261,
    1508,  4263,   534,  5288,    72,  5290,  3889,  4170,  3891,   375,
      78,    10,   323,   372,    13,    55,    56,   534,   367,   201,
     157,   534,   536,   157,    92,  6237,   491,     6,   308,  3504,
    4311,  6243,   201,   367,  3330,  3331,  3332,   396,  4956,  3335,
     308,   112,   157,   157,  4129,  3380,    45,  3343,  3344,  3345,
    3346,   201,   120,    52,   122,  5244,   157,   308,   417,  4028,
     171,   372,  6129,  3359,   430,   367,  3362,   157,  3364,   122,
    3973,   251,   464,    10,  3724,   472,    13,   308,  4163,    78,
    3376,  3377,   534,   301,  3380,   396,   171,   535,    72,    54,
    3973,   292,    10,    38,   292,    13,  3746,   495,   464,   534,
     308,  5958,   292,  3399,    48,  3401,   417,  3403,    45,  3405,
     181,   292,    48,   181,   457,    52,   292,    91,  4381,  4922,
     324,   484,   488,   484,   490,   491,    87,    45,  3424,  4214,
     452,  3427,   171,   204,    52,  3431,   101,   347,   157,   157,
     532,    78,   210,   535,   536,   534,   512,  3482,   157,   157,
     495,   150,  6364,  3449,  3432,  3433,  3434,   157,   538,   157,
      78,   126,   157,   157,   157,   157,   157,   157,   171,   535,
     157,   537,   538,   308,   157,   157,   535,   157,   434,  4655,
     145,    10,   157,  3479,    13,   150,  3482,  3483,  4339,   103,
     534,  3487,  3488,  3489,  3490,   125,   267,   196,     0,  3534,
    3496,   272,   201,    38,   251,  3501,   308,   172,   171,   171,
     534,   176,     6,  4313,     6,   534,    45,   288,   534,   198,
    3516,   171,   534,    52,   292,   534,   191,   534,   207,   297,
       0,  4438,   150,   534,  3530,  5526,   215,   534,  3534,   218,
     534,  3537,  3538,     6,  3540,     6,  4409,  3479,  4411,    78,
    3482,    21,   323,   252,  3904,   534,  3906,     6,   534,   196,
     534,   534,   534,   534,   201,  4528,     6,   534,   534,   534,
    6127,   534,   534,  4506,  4437,   534,   344,   534,   196,   534,
    4516,    10,   534,   201,    13,  3581,   534,    57,    17,    18,
      19,   320,   534,   361,   534,  6362,   534,    99,  3530,   534,
     534,   372,   534,   299,   534,   534,  3538,   534,   534,  3605,
    3606,   310,   135,   534,   137,   252,    45,   534,   534,   534,
     492,   150,   166,    52,   222,   396,   538,   538,   135,    38,
     137,   251,   297,    38,   252,   534,    37,   445,   445,   532,
     163,   532,   447,   447,   447,  3641,   417,   534,   447,    78,
     152,   177,   538,   171,   171,   304,   163,   402,    68,   302,
     447,   447,  5551,   165,   389,   447,   483,   196,   447,   171,
     536,   447,   201,   310,   389,   177,   389,   447,   253,    79,
    6237,   183,   447,   371,   186,   447,  6243,   352,   190,   447,
      92,   524,   310,  5582,   248,   157,   308,   465,   447,   447,
     389,   297,  3698,   128,   447,   228,   437,   471,   407,  3884,
     329,   308,  4062,   394,   384,   302,   534,   447,   220,   447,
     194,   228,   192,   252,   534,    92,  3722,   157,   201,  1959,
     128,   324,   538,   447,   472,   472,  3732,  1967,   128,   114,
     447,   447,   447,   447,   128,   447,   447,    59,    59,   276,
     447,   253,   312,   329,    47,   329,  5171,   351,   538,   351,
     351,   284,   285,   286,   287,   539,   535,   196,   291,   292,
     407,   447,   201,  4680,   297,   447,   447,   284,   285,   286,
     287,   310,  2671,  2672,   291,   437,   224,   447,  2677,   407,
     297,   447,   447,   447,   447,   224,   225,   224,   308,   447,
     447,   447,   304,   224,   224,   447,   308,  6364,   447,   224,
     224,   224,   314,   224,   513,   308,   224,   224,   447,   457,
    2709,  2710,   534,   252,    38,  4688,   525,   526,   527,   528,
     529,   530,   157,   308,   157,   292,   120,   472,   157,   157,
     157,   308,   483,   259,   292,  3841,   292,   292,    38,   171,
      38,  3847,   243,   391,   157,   157,   534,   534,   157,   472,
     157,   534,  3858,   472,   301,   447,   295,   177,   296,   538,
     487,   535,   276,   375,    13,   534,   513,   276,   407,   447,
     538,   310,   186,  2772,   319,   449,   194,   194,   525,   526,
     527,   528,   529,   530,  4875,   513,   511,   393,   532,  3895,
    3896,  3897,   534,   534,   511,   274,   534,   525,   526,   527,
     528,   529,   530,   535,   535,   488,  3912,   405,    38,   535,
     220,   309,   472,   472,   535,   535,   240,   535,   317,    59,
    3926,   454,   434,   538,  5110,   538,  3962,   483,   389,   297,
     535,   297,   297,   466,   534,  1723,   447,   454,  3944,  3945,
    3946,   534,   447,   171,  3950,   297,   447,  5484,   308,   466,
     308,   240,   464,   534,  4791,   292,  3962,   240,  2857,   251,
     251,   251,   384,   308,   270,   447,   128,    10,   407,   437,
      13,   538,   308,   538,   513,   201,   488,   308,   490,   491,
     367,   491,  4777,   308,  4858,   195,   525,   526,   527,   528,
     529,   530,   399,   447,   447,  4674,  4675,  4676,  4677,  4678,
     512,   355,    45,   314,   535,   402,    38,  4043,   224,    52,
     472,   243,  4018,   157,   302,   472,   350,   524,   171,   484,
     532,    38,  2683,   535,   536,   537,  4032,  4033,   173,  4946,
     435,   157,   721,   157,   534,    78,   351,  4043,   399,   534,
    3958,   730,   157,   302,   472,   491,   292,  2946,   737,    38,
     292,   740,   308,  4059,    27,  2954,   308,   243,  2957,   302,
     192,   192,   171,    38,  4870,  4212,  5640,   172,   243,   399,
    2969,   171,  4078,   308,   513,   292,  3994,    59,   201,    62,
     201,  4087,   201,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   495,   201,   201,  4101,   538,   538,  5071,  4105,
    4106,  4107,   538,   536,   538,   447,  4112,   150,  1896,  4115,
     177,   491,  4118,   273,   308,    98,  1904,   301,  4124,   177,
    4126,   534,   538,  4129,  1912,   314,   512,   477,  4134,  4135,
    4136,  4137,   538,   535,  4140,  4141,  4142,  4143,  4144,  4145,
    4146,  4147,  4148,  4149,   535,   535,   535,  4153,  4154,  4155,
     538,   535,   375,   196,   535,   538,   538,  4163,   201,   535,
     535,   535,  4168,   535,   534,  4210,  4172,   538,   535,  1957,
     320,   535,   535,   535,  4180,   135,   330,  4183,   161,  4185,
     535,   177,   447,   534,   488,   511,   534,   291,    10,   669,
     534,    13,   266,   534,   533,  4201,  1984,   535,  4204,  4205,
     177,   186,   470,  4209,  4210,   261,   488,   478,  4214,   252,
    4216,  4217,  4861,   515,   533,   198,  4576,  4577,   534,  4225,
    4226,  4227,   308,    45,   524,  4410,   534,    59,   514,   534,
      52,   308,  4220,  4221,  4222,  4223,  4242,  4243,  4244,  4245,
    4246,  4234,  4248,  4249,   308,  4234,  4252,  4234,   311,   157,
    4256,   538,   447,  4438,  4260,  4234,    78,   447,   214,   447,
    4266,   297,   160,   292,   447,   248,   157,   310,   534,   206,
     534,   534,  4234,  6172,  6173,   422,   394,  6176,   157,   157,
     402,   394,   762,   763,   394,   251,   206,  4293,   160,   308,
     524,   447,   472,    62,   160,   389,   488,   331,   253,   469,
     331,   160,  4308,   419,  4310,   288,   447,   389,   447,   292,
     447,   447,   263,   263,  4256,   263,  4234,  3216,  4260,   447,
     447,   389,   447,   389,   389,   128,   402,   447,   150,    98,
     447,   292,   157,   447,    47,   447,   447,  5283,    47,   535,
     533,   324,   325,   224,  5090,  3244,  5771,  3246,   447,   447,
     333,  5030,  5031,   535,  5033,   224,   535,   535,   189,  4365,
    4366,  4367,  4368,   312,   407,  4371,   535,  4373,   457,     3,
    5316,  1060,   538,   171,   196,    48,   113,  1066,   535,   201,
     538,  1070,   171,  1072,   367,  4391,   534,    38,   371,   535,
     157,   157,   161,   376,   447,   524,   171,   302,   189,   534,
     472,  2641,   385,   472,   157,   389,   399,   155,   389,   389,
     389,   394,   155,   389,   224,   224,   224,   224,   224,   402,
     224,   147,   224,  4365,   224,   224,   532,   228,   465,   198,
     252,   308,   415,   535,   535,   538,    59,   465,   308,   535,
    4446,   424,  4627,   308,  3105,   308,   429,  1136,    13,  1138,
    1139,   538,   320,   483,   535,   935,   535,   937,   177,   227,
     535,   291,   535,   318,  6092,   535,   227,   538,   436,   315,
     513,   533,    59,    10,   535,   534,    13,   444,   535,   248,
     534,   375,   525,   526,   527,   528,   529,   530,   310,   534,
     190,   477,   534,    90,   457,  4501,  4452,   171,    38,   243,
     472,   472,    38,   486,   447,    59,   214,  4463,    45,   437,
     157,    86,   419,   472,   181,    52,   457,   447,   394,   288,
     160,   447,   447,   292,    60,   389,   447,   389,  4534,   447,
     535,   535,   535,   367,   534,   534,    59,   491,   437,   478,
     171,    78,  4548,   308,  4550,  5675,    78,  5677,   157,   113,
      86,  4557,   224,   457,   224,   324,   325,  4563,  4918,  3458,
     224,  5434,   224,   240,   333,   535,   209,   447,  4574,   534,
     534,   495,   534,   308,    38,   329,   112,   113,   535,   308,
     538,   305,     3,  4589,   120,   407,   538,   534,  4594,  4595,
     457,    44,   538,   447,   534,   183,  4602,   535,   367,   184,
     113,   177,   371,   399,   224,  4611,   535,   376,   241,  3508,
    3509,   145,   241,   150,   297,  4621,   385,   297,   535,   535,
    5299,   297,   297,   159,   535,   394,   177,  4633,  4634,   535,
      59,  5310,   489,   402,   535,   538,  5822,  5686,  4644,   489,
     535,   320,   329,   535,   227,   181,   415,   534,   538,  4655,
    4656,   534,  4594,  4595,   490,   424,   444,   302,   177,   196,
     429,  5021,   457,  5461,   201,   447,   524,  4673,   204,   208,
     491,    78,   297,   534,   195,   195,  4861,    38,   297,   524,
      59,  5867,   437,   447,    72,   538,   538,   447,   447,   157,
     160,   513,   535,   224,   534,   447,   127,   179,   120,    38,
     201,   302,  4620,   525,   526,   527,   528,   529,   530,  4715,
    5359,   534,    38,   399,   472,   252,   173,   486,   292,   491,
     302,   399,    59,   437,    84,  4731,    38,  5913,  5914,   491,
     177,   267,   171,  1213,   362,   308,   272,   534,   211,   311,
     177,   222,   535,  4749,   538,   535,  5395,   477,   535,   534,
     416,   535,   288,    59,   392,    38,   292,    81,  5118,   535,
     534,   534,  5557,    92,   136,   308,   447,   202,   361,  5686,
      38,  4777,   535,   310,  4780,   157,  5571,   157,   534,   447,
     171,    38,  4788,  4789,   534,   534,   297,   323,   534,  4795,
    4796,   399,   534,   534,  4800,   534,   534,   264,  5593,  4805,
     534,   472,  4808,  4809,   535,  5600,   157,    38,   113,  4815,
     535,   177,   312,  4819,  4820,  4821,  4822,   535,  3479,   414,
    1300,  3482,   457,   414,   171,    38,   538,   205,   308,   535,
    4836,   535,   112,  4839,    38,   534,   372,  4843,   534,   534,
    1320,   538,  4848,    35,   538,  4851,  4852,   477,  4854,   534,
    4856,   437,   534,  4859,   194,  4861,  5905,   472,    10,   437,
     396,    13,   171,   288,  4870,    17,    18,    19,  4874,  3530,
     407,   534,  4878,   206,  4880,  5670,  5671,  3538,   308,   535,
       6,   417,   164,   419,   495,   534,   422,   385,   385,  4895,
      72,   311,    72,    45,  4836,   537,   136,   491,  6084,  1379,
      52,  4843,   491,   141,   149,   476,  4848,   487,   308,  4851,
     477,  5590,   168,   535,   535,  3155,  4922,  4923,   168,   330,
    3160,   538,  3162,  5796,   534,   402,    78,   534,   443,   265,
     177,  4937,  3172,   443,   437,  3175,   208,  3177,  3178,   358,
     297,  3181,   437,  4895,   308,  3185,   308,  3187,  2736,  5923,
    3190,   399,    38,   534,  4872,  4873,    38,   311,   311,  5832,
     202,   179,   179,   156,   534,   534,  2754,   495,   495,   353,
    2758,   384,   353,    81,  2762,   153,   513,   315,  6164,  6165,
      59,    59,    38,   368,  4940,  3884,    59,   535,   525,   526,
     527,   528,   529,   530,    59,  4951,   447,  5003,   534,  2787,
    5679,   125,   535,     6,  5010,   423,   399,   470,  3907,  1489,
    1490,   141,  1492,   308,   308,    35,   534,   495,  3258,   495,
     297,   535,   534,   293,  5384,   534,  5032,   402,   293,  5902,
     534,    24,   384,  2821,   308,   384,   538,   316,   388,   538,
     388,  5047,    81,   534,   196,  5840,   478,  5842,   447,   201,
     177,  2839,   425,   149,   425,   534,   156,     6,   414,   414,
     477,   120,   315,   538,   478,   491,   535,   491,   332,   179,
     179,   472,  5078,   534,   477,   534,    81,   535,   534,  5672,
    5510,   937,  1725,  3246,   977,  1266,  2980,  2889,  5094,  2877,
    3656,  4409,  4384,  5686,  6075,  5101,  3007,  3061,  3875,  5437,
     252,  5902,  6213,  4574,  5110,  5484,  4382,  4382,  5080,  5460,
    3644,  3582,  3203,  6055,  5358,  6202,  2904,  5933,  5932,  5125,
    6096,  6237,  2910,  3649,  5125,  4595,  5872,  4621,  4606,  4564,
    5875,  3075,  5138,  3075,  5140,  4404,  2924,  3923,  3681,  4590,
    5467,  3967,  5119,  2931,  1019,  4657,  2934,  5783,  6322,  6455,
    6430,  5451,  2940,  3883,  4629,  6108,  5397,  5657,   310,  1885,
    5166,  5885,  5400,    18,  6213,    28,  4685,  5625,  4067,   665,
    4032,  5177,  2960,  4688,  5359,  6318,  3091,  1929,  2966,  2748,
    4632,  1241,  3560,  5125,  1926,  2973,  1940,  5510,  3978,  5771,
     750,  1964,   717,  3815,  4437,  3006,  3732,  6134,  5383,  2987,
    6368,   866,  1542,  3037,  4661,  1838,  2690,  4663,  4874,  6295,
    5395,  4308,  5620,  3001,  5623,    41,  1438,     6,    41,  5137,
    5869,  4731,  1499,  5395,  3012,  5231,  1411,  6034,  3501,  1498,
    3516,  2700,  5844,  4244,  1501,  5241,  1496,  3482,  5244,  4262,
    5307,  5247,  5248,  5249,  5579,  3479,  5578,  3479,  4309,  6346,
    5394,  1940,  6028,  6177,  1943,   407,  5831,  3479,  6384,  5555,
    4172,  5845,  3422,    52,  1953,  1954,  5272,  5273,  1455,  2619,
    5276,  2620,  5846,  2119,  3404,  3036,  3277,  5795,  3402,  1968,
    6386,  3313,  1971,  3392,  4104,  2625,  5292,    -1,   925,    -1,
    5296,    -1,  2688,    -1,    -1,  5439,  5302,    -1,    -1,    -1,
    5306,    -1,    -1,    -1,  5310,    -1,    -1,  5313,    -1,  5315,
      -1,    -1,  5905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5326,    -1,    -1,  5329,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2021,    -1,    -1,    -1,  2025,  2026,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3585,    -1,    -1,    -1,    -1,
      -1,    -1,  5358,  5359,  5360,    -1,  5362,    -1,    -1,    -1,
      -1,   513,    -1,    -1,  5306,  5319,    -1,    -1,    -1,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,    -1,
      -1,  6409,    -1,    -1,  5326,    -1,    -1,    -1,  5394,  5395,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,
      -1,    -1,    -1,    -1,    -1,    -1,  5358,    -1,   207,   208,
      -1,    -1,    -1,    -1,    -1,  3665,   215,  3667,   217,   218,
      -1,    -1,    -1,  5439,    -1,    -1,    -1,    -1,    -1,  3227,
      -1,    -1,   231,    -1,    -1,  5451,    -1,    -1,    -1,    -1,
    5456,    -1,    -1,    -1,    -1,  5461,    -1,    -1,    -1,    -1,
      -1,    -1,  3250,  5499,  5470,    -1,    -1,    -1,    10,  3257,
      -1,    13,    -1,    -1,  5480,    17,    18,    19,  5484,    -1,
      -1,  5487,  6075,    -1,    -1,  6431,    -1,    -1,    -1,    -1,
      -1,    -1,  5498,  5499,  5500,    -1,    -1,    -1,  6371,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,  6302,    -1,    -1,
      52,  4410,  5510,  5510,  5510,  5510,  1996,  5510,  5510,    -1,
    5510,  5510,    -1,  5510,  5510,  5510,  5510,    -1,  5534,    -1,
    5510,  5510,  5510,    -1,    -1,  5510,    78,    -1,    -1,  4438,
      -1,    -1,  5510,    -1,    -1,  5551,    -1,  5465,  5510,  5555,
      -1,  5557,    -1,  4452,    -1,  5600,  6351,  6430,  5500,  6305,
    6306,    -1,    -1,    -1,  4463,  5571,    -1,    -1,    -1,    -1,
      -1,  3811,    -1,  5579,    -1,    -1,  5582,  3817,  5496,    -1,
    5586,    -1,  6455,    25,    -1,    -1,  2066,  5593,    -1,    31,
      -1,    -1,  5510,    -1,  5600,  4256,    -1,    -1,    -1,  4260,
      -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2099,
    6213,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,  5641,    -1,  5579,    -1,    -1,
    4539,  4540,  5648,  2123,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,  5664,   201,
      -1,    -1,    -1,    -1,  5670,  5671,    -1,    -1,    -1,  5675,
    5676,  5677,  5678,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,  5869,    -1,    -1,    -1,    -1,   131,
      25,   133,    -1,    -1,    -1,    -1,    31,    -1,   140,    -1,
    5706,    -1,   144,    -1,  4365,    -1,    -1,    -1,  5714,    -1,
     252,    46,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4627,    -1,
     172,    -1,    -1,  5739,    -1,    -1,  5742,    -1,    -1,    -1,
      -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5767,    -1,  4003,    -1,  4005,   208,  4007,   310,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5795,
      -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,   133,    -1,
    5742,  5807,    -1,    -1,    -1,   140,    -1,    -1,  3596,   144,
    5816,  5817,  5818,    -1,    -1,    -1,  5822,    -1,    -1,    -1,
      -1,    -1,  5828,    -1,    -1,  5831,  5744,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5840,  2315,  5842,   172,  5844,  5845,
      -1,    -1,  2102,  2103,    -1,  5851,   288,    -1,     0,    -1,
     292,    -1,  5858,    -1,    -1,    -1,    -1,  2117,    -1,    -1,
     302,  5867,    -1,  5869,    -1,   407,  2126,    -1,    -1,    -1,
     312,  5877,    -1,   208,   663,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   682,    -1,    -1,    -1,    -1,    -1,   688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5913,  5914,  5851,
      -1,   700,    -1,    -1,    -1,    -1,    -1,  3705,  6062,    -1,
      -1,    -1,    -1,    -1,    -1,   367,    -1,   716,   370,   371,
    5848,    -1,   721,  4594,  4595,    -1,    -1,   726,  5944,    -1,
      -1,   730,   731,    -1,    -1,    -1,    -1,    99,   737,    -1,
     739,   740,  5958,   288,    -1,    -1,    -1,   292,    -1,    -1,
     402,    -1,    -1,   752,   753,    -1,    -1,   302,    -1,    -1,
      -1,   513,    -1,    -1,   763,    -1,    -1,   312,    -1,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   324,
      -1,  6135,  6136,    -1,  2683,    -1,    -1,    -1,    -1,    -1,
     152,    -1,    -1,  6009,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   165,    -1,    -1,  5958,    -1,  6024,   171,
      -1,    -1,  6028,    -1,    -1,   177,   815,    -1,  6034,    -1,
      -1,   183,   367,   475,   186,   370,   371,  6043,   190,    -1,
      -1,  4940,   831,    -1,    -1,    -1,    -1,  4946,  3836,    -1,
      -1,    -1,  4951,    -1,    -1,    -1,  6062,    -1,    -1,    -1,
      -1,    -1,    -1,   852,   853,    -1,    -1,   402,   220,    -1,
      -1,  6077,    -1,    -1,    -1,    -1,    -1,    -1,  6084,  4978,
    4979,    -1,    -1,    -1,  4983,  4984,    -1,   876,    -1,   878,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   253,    -1,    -1,  6110,    -1,    -1,    -1,    -1,    -1,
      -1,  6117,  2801,   902,    -1,  2804,    -1,  2806,  2807,    -1,
      -1,  6127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6135,
    6136,  6137,    -1,    -1,    -1,  6141,   925,    -1,    -1,    -1,
     475,  6134,    -1,    -1,    -1,    -1,    -1,  6134,    -1,   938,
      -1,    -1,   304,    -1,    -1,  6134,   308,    -1,  6164,  6165,
    6166,    -1,   314,    -1,    -1,    -1,  6172,  6173,    -1,  2649,
    6176,    -1,  6134,  6179,    -1,  4836,    -1,    -1,    -1,    -1,
      -1,    -1,  4843,    -1,    -1,  6127,    -1,  4848,    -1,    -1,
    4851,  6109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6207,  6247,  2683,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6134,    -1,    -1,    -1,
      -1,    -1,    -1,   375,    -1,    -1,    -1,  4015,    -1,    -1,
      -1,  6237,  6238,  6239,    -1,    -1,    -1,  6243,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4034,    -1,  2728,    -1,
    4038,    -1,    -1,    -1,  6247,  6261,    -1,  1046,  1047,  1048,
    6247,    -1,  6268,    -1,    -1,    -1,  1055,    -1,  6247,    -1,
    6276,  1060,    -1,    -1,    -1,    -1,  1065,  1066,  6284,    -1,
      -1,  1070,   434,  1072,  6290,  6247,    -1,  1076,    -1,  6295,
      -1,    -1,    -1,    -1,    -1,  6237,  6302,    -1,    -1,  6443,
    6444,  6243,    -1,  1092,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   464,    -1,    -1,    -1,    -1,    -1,     0,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6247,
      -1,    -1,  6338,  6339,  6340,  6341,   488,    -1,   490,   491,
    6346,    -1,    -1,    -1,    -1,  6351,    -1,  1136,    -1,  1138,
    1139,    -1,    -1,    -1,    -1,  6361,    -1,    -1,  6364,    -1,
     512,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6368,    -1,    -1,  6384,    -1,
     532,  6368,    -1,   535,   536,   537,    -1,   726,    -1,  6368,
    1179,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6409,  6410,    -1,  6368,    -1,    -1,    -1,
      -1,    -1,    -1,   752,    -1,    -1,  3105,    99,  1207,    -1,
    6426,    -1,  6364,    -1,    -1,    -1,    -1,    -1,    -1,  4669,
      -1,    -1,  4672,    -1,    -1,    -1,    -1,  6443,  6444,    -1,
    2700,  6447,    -1,  6449,    -1,    -1,    -1,    -1,    -1,    -1,
    6368,  1240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6466,    -1,  4702,    -1,  5125,    -1,  1255,    -1,    -1,    -1,
     152,    -1,    -1,    -1,    -1,    -1,  1265,  1266,    -1,    -1,
    1269,    25,  1271,   165,  5383,    -1,    -1,    31,    -1,   171,
      -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,  1287,    -1,
      -1,   183,    46,  1292,   186,    -1,    -1,    -1,   190,    -1,
      -1,    -1,    -1,    -1,    -1,  1304,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,   220,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,  4342,    -1,    -1,  1346,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   253,  3261,    -1,    -1,  3264,    -1,  3266,  3267,    -1,
      -1,    -1,    -1,    -1,    -1,    78,  1375,  1376,  1377,   133,
    1379,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
     144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1400,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   304,    -1,    -1,    -1,   308,    -1,   172,    -1,
      -1,    -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3124,  5306,    -1,    -1,    23,    -1,
      -1,    -1,    -1,    28,    -1,    -1,  1445,    -1,    -1,    -1,
      -1,    -1,    -1,  4903,   208,  5326,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1474,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   375,    -1,  4483,    -1,  5358,  4486,    -1,
      -1,    -1,  1491,   196,    79,    80,  1495,  1496,   201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4959,
    4960,    96,  1511,    -1,    -1,    -1,  1065,    -1,  1517,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,  1076,    -1,   114,
      -1,    -1,    10,    -1,   288,    13,    -1,    -1,   292,    17,
      18,    19,   434,  1092,    -1,    -1,    -1,    -1,   302,   252,
      -1,    -1,    -1,   138,    -1,    -1,    -1,    35,   312,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    45,    -1,    -1,
     324,    -1,   464,    -1,    52,   160,    -1,  5686,    -1,    -1,
    3479,    -1,    -1,  3482,    -1,    -1,  1585,    -1,   173,  4587,
      -1,    -1,   295,    -1,   179,    -1,   488,    -1,   490,   491,
      78,    -1,    -1,  5053,  5054,    -1,  4604,   310,    -1,    -1,
     313,    -1,    -1,   367,    -1,    -1,   370,   371,    -1,    -1,
     512,   206,    -1,    -1,    -1,    -1,    -1,  1626,    -1,  5500,
      -1,  3530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3538,
     532,    -1,  3332,   535,   536,   537,    -1,    -1,   402,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
    1659,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,   266,    -1,    -1,    -1,    -1,    -1,  4685,    -1,    -1,
    3380,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,   407,    -1,    -1,    -1,  5579,    52,
      -1,    -1,    -1,    -1,  3404,    -1,    -1,    -1,   196,    -1,
    1269,   475,    -1,   201,  1723,    -1,    -1,    -1,    -1,    -1,
    3420,    -1,    -1,  5183,    -1,    78,  5186,  5187,    -1,  1738,
    1739,  1740,    -1,    -1,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5207,    -1,    -1,
      -1,    -1,   347,   348,    -1,    -1,   351,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5894,    -1,    -1,    -1,  3479,
      -1,    -1,  3482,    -1,   379,    25,    -1,   382,    -1,    -1,
      -1,    31,    -1,    -1,   389,    -1,    -1,    -1,    -1,    -1,
     513,   396,    -1,    -1,   399,    -1,    -1,   295,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
      -1,    -1,   310,    -1,   419,   313,   539,    -1,    -1,  1838,
    3530,    -1,   427,    -1,  3534,    -1,    76,    -1,  3538,   434,
      -1,  1850,   437,   196,    -1,    -1,    -1,   442,   201,    -1,
    3330,  3331,  1861,    -1,    -1,  3335,    -1,    -1,    -1,    -1,
      -1,  5742,   457,    -1,  1873,    -1,    -1,    -1,  1877,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1896,    -1,   484,
      -1,    -1,    -1,   133,    -1,  1904,  3376,  3377,    -1,   252,
     140,    -1,    -1,  1912,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,   407,
      -1,    -1,  1931,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1940,   172,    -1,  1943,    -1,    -1,  1946,    -1,    -1,
    1949,  1950,   295,    -1,  1953,  1954,    -1,  1956,  1957,    -1,
      -1,    98,    -1,    -1,    -1,    -1,    -1,   310,    -1,  1968,
     313,  1970,  1971,    -1,    -1,    -1,    -1,  4975,   208,    -1,
    5851,  1980,  1981,    -1,  1983,  1984,    -1,    -1,    -1,  4987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2021,    -1,   161,    -1,  2025,  2026,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,   527,
     528,   529,   530,    -1,    -1,    -1,    -1,   535,   288,    -1,
     538,   198,   292,    -1,   407,    -1,    -1,    -1,    -1,    38,
      -1,    -1,   302,    -1,    -1,    -1,    -1,  1626,    -1,    -1,
      -1,    -1,   312,  2082,    -1,  2084,    -1,  5958,    -1,    -1,
    2089,  2090,    -1,    62,   324,    -1,    -1,  2096,  2097,  2098,
    2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,
      -1,   248,    -1,  2112,    -1,  2114,    -1,  2116,  2117,  2118,
    2119,  2120,  2121,    -1,    -1,  2124,    -1,  2126,  2127,    98,
      -1,  2130,    -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,
     370,   371,    -1,    -1,    -1,  2144,  2145,  2146,  2147,    -1,
      -1,    25,    -1,    -1,    -1,   292,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    -1,  2163,    -1,  2165,    -1,    -1,    -1,
     513,    -1,   402,    -1,    -1,    -1,    -1,  5627,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,   325,    -1,
      -1,    -1,   161,    -1,    -1,   538,   333,    -1,    -1,    -1,
      -1,    17,    76,    -1,    -1,    10,    -1,  5205,    13,    -1,
      26,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   198,
      35,  5681,    -1,    -1,   371,    -1,   373,    -1,    -1,   376,
      45,    -1,    -1,    -1,    -1,   475,    -1,    52,   385,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6127,   394,    -1,   133,
      -1,    -1,  6371,    -1,    -1,   402,   140,    -1,  3958,    -1,
     144,    -1,    -1,    78,   243,    -1,    -1,    -1,   415,   248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   424,    -1,    -1,
      -1,    -1,   429,    -1,    -1,    -1,    -1,    -1,   172,    -1,
      10,  1850,    -1,    13,  3994,    -1,    -1,    17,    18,    19,
      -1,  2310,  1861,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6430,    -1,   292,    -1,    35,    -1,    -1,  1877,    -1,
      -1,    -1,    -1,    -1,   208,    45,  5334,    -1,  5336,    -1,
      -1,    -1,    52,    -1,  5794,    -1,  6455,    -1,    -1,   486,
      -1,    -1,    -1,    -1,    -1,    -1,   325,  4256,    -1,    -1,
      -1,  4260,    -1,    -1,   333,  2364,  6237,    -1,    78,    -1,
      -1,    -1,  6243,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1931,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,   201,  1946,    -1,    -1,
    1949,  1950,   371,    -1,    -1,    -1,    -1,   376,    -1,    -1,
      -1,    -1,    -1,    -1,   288,    -1,   385,    -1,   292,   224,
     225,  2420,    -1,    -1,    -1,   394,    -1,    -1,   302,    -1,
      -1,  1980,  1981,   402,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   415,   252,    -1,    -1,
     324,    -1,    -1,    -1,    -1,   424,    -1,    -1,    -1,    -1,
     429,    -1,    -1,    -1,    -1,    -1,  4365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   450,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
     295,   201,    -1,  6364,    -1,    -1,   370,   371,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,   313,    -1,
      -1,    -1,    -1,    -1,   224,   225,    -1,   486,    -1,    -1,
    4210,   490,    -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,  4234,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4256,    -1,    -1,    -1,
    4260,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    13,    -1,    -1,   295,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,  2144,    -1,    -1,    -1,    -1,
     310,   475,   407,   313,    35,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,    45,  2614,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,  2625,    -1,  2627,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4112,    -1,    -1,  2644,    -1,    78,    -1,  2648,
      -1,    -1,  2651,    -1,  2653,    -1,    -1,  2656,    -1,    -1,
      -1,  2660,    -1,    -1,  4134,  4135,  4136,  4137,    -1,    -1,
    4140,  4141,  4142,  4143,  4144,  4145,  4146,  4147,  4148,  4149,
      -1,    -1,  2681,    -1,  2683,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4594,  4595,   407,  4168,    -1,
      -1,  2700,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,
    2709,  2710,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   538,  4204,  4205,    -1,  2736,    -1,    -1,
      -1,    -1,    -1,    -1,  2743,    -1,  6196,    -1,  2747,  2748,
      -1,    -1,    -1,    -1,    -1,  2754,    -1,    -1,    -1,  2758,
      -1,    -1,    -1,  2762,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,  2772,    -1,    -1,    -1,    -1,  4248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2787,    -1,
      -1,  2790,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2801,   513,  2803,  2804,    -1,  2806,  2807,    -1,
    2809,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   252,  2821,    25,    38,   535,    -1,    -1,    -1,    31,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2839,  2840,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,
     666,    -1,    -1,    -1,    -1,  2854,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    -1,    -1,  2876,  2877,   310,
      -1,  2880,   313,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     716,   717,    -1,    -1,  4594,  2904,    -1,  2906,    -1,    -1,
      -1,  2910,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2924,    -1,    -1,    -1,    -1,
    4620,   133,  2931,    -1,    -1,  2934,    -1,  4836,   140,    -1,
      -1,  2940,   144,    -1,  4843,    -1,    -1,   161,    -1,  4848,
      -1,    -1,  4851,  4852,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2960,    -1,    -1,    -1,    -1,    -1,  2966,    -1,    -1,
     172,    -1,    -1,    -1,  2973,    -1,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   198,    -1,    -1,    -1,  2987,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   812,   813,    -1,   815,
     816,    -1,  3001,    -1,    -1,    -1,   208,  3006,    -1,    -1,
      -1,   827,    -1,  3012,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,
     846,  3030,  3031,  3032,   248,    -1,    -1,  3036,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6048,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    -1,    -1,    -1,  3063,  3064,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3072,    -1,    -1,    -1,    -1,   292,    -1,
    4550,    -1,   513,    -1,    -1,    -1,   288,    -1,    -1,    -1,
     292,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     302,    -1,    76,    -1,   535,    -1,  3105,    -1,    -1,    10,
     312,   325,    13,    -1,    -1,    -1,    17,    18,    19,   333,
      -1,    -1,   324,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,  3137,    -1,
      -1,    -1,  3141,    -1,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,  4843,    -1,    -1,    -1,   371,  4848,   133,
      -1,  4851,   376,    -1,    -1,   367,   140,    -1,   370,   371,
     144,   385,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,
     394,    -1,  4872,  4873,    -1,    -1,    -1,    -1,   402,    -1,
      -1,    -1,    -1,    -1,    -1,  5094,    -1,    -1,   172,    -1,
     402,   415,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     424,    -1,    -1,    -1,    -1,   429,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5125,    -1,  3227,    -1,
    3229,    -1,    -1,    -1,   208,    -1,   450,    -1,    -1,  1055,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3246,    -1,  3248,
      -1,  3250,    -1,    -1,  2803,    -1,    -1,    -1,  3257,    -1,
    2809,    -1,  3261,    -1,  3263,  3264,    -1,  3266,  3267,  3268,
      -1,    -1,   486,   475,    -1,    -1,   490,  3276,    -1,    -1,
      -1,    -1,  3281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,  3298,
     201,    -1,    -1,    -1,    -1,  2854,    -1,    -1,    -1,    -1,
    4780,    -1,    -1,    -1,   288,    -1,    -1,    -1,   292,    -1,
      -1,    25,    -1,   224,   225,    -1,    -1,    31,   302,    -1,
      -1,  3330,  3331,  3332,    38,    -1,  3335,    -1,   312,    -1,
      -1,    -1,    -1,    -1,  3343,  3344,  3345,  3346,    -1,    -1,
     324,   252,    -1,    -1,    -1,  3354,    60,    -1,    -1,    -1,
    3359,  3360,    -1,  3362,    -1,  3364,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,  3376,  3377,    -1,
      -1,  3380,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   367,   295,    -1,   370,   371,    -1,    -1,
      -1,    -1,  3401,    -1,  3403,    -1,  3405,  5306,   112,   310,
      -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3424,    -1,  5326,   402,   133,
    1246,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,  1255,
     144,    -1,    -1,    -1,    -1,  1261,  1262,  5137,    -1,  1265,
    1266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5358,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1292,    -1,    -1,    -1,
    3479,    -1,    -1,  3482,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5394,    -1,  3496,    -1,    -1,
     204,   475,  3501,    -1,   208,    -1,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3064,    -1,  3516,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,
      -1,  3530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3538,
    5439,    25,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,  3550,    -1,    -1,  3553,    -1,  3555,    -1,    -1,    -1,
      -1,  3560,    -1,   267,    -1,  1381,    -1,    -1,   272,    -1,
      -1,    -1,    -1,    76,  1390,    -1,  3575,  3576,    -1,    -1,
      -1,    -1,  3581,    -1,   288,    -1,    -1,    -1,   292,    -1,
    1406,    -1,    76,    -1,    -1,    -1,    -1,  3596,   302,    -1,
    3599,  5500,    -1,  3602,    -1,    -1,    -1,    -1,   312,    -1,
      -1,  3610,   513,    -1,    -1,    -1,  5306,    -1,    -1,   323,
     324,   522,   523,   524,   525,   526,   527,   528,   529,   530,
     133,    -1,    -1,    -1,   535,    -1,  3635,   140,    -1,    -1,
      -1,   144,  3641,    -1,    -1,    -1,    -1,    -1,    -1,   133,
      -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
     144,    -1,    -1,   367,    -1,    -1,   370,   371,   372,   172,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5579,  3680,  3681,  3682,    -1,    -1,    -1,    -1,   172,    -1,
      -1,    -1,   396,    -1,    -1,    -1,    -1,    -1,   402,  3248,
      -1,    -1,    -1,    -1,    -1,   208,  3705,    -1,    -1,    -1,
      -1,    -1,    -1,   417,  3263,  3714,    -1,  3716,    -1,  3268,
      -1,    -1,    -1,    -1,   208,  3724,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3746,    -1,  3298,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
      -1,   475,    -1,    -1,  5244,  5465,    -1,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    -1,   288,    -1,    -1,    -1,   292,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,   302,
      -1,    -1,    -1,    -1,   288,    -1,  5496,    -1,   292,   312,
      -1,    -1,    -1,  3812,    -1,  5714,    -1,    -1,   302,    -1,
    5510,   324,    -1,    -1,    78,    -1,  5296,    -1,   312,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3836,    -1,    -1,
     324,    -1,  3841,  5742,    -1,    -1,    -1,    -1,  3847,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3856,    -1,    -1,
      -1,  1677,    -1,    -1,   367,    -1,    -1,   370,   371,  1685,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   367,  3883,  3884,   370,   371,    -1,    -1,
    3889,    -1,  3891,    -1,    -1,    -1,    -1,    -1,    -1,   402,
      -1,    -1,    -1,    -1,    -1,  3904,    -1,  3906,    -1,    -1,
    5600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   402,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3926,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,    -1,  5851,  3952,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   475,    -1,  3973,  3974,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   475,    -1,    -1,    -1,    -1,    -1,  3996,   252,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,  4015,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,  4034,    -1,    -1,    -1,  4038,
      45,   295,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,  5742,  3602,  5744,    -1,   310,    -1,    -1,  5958,
      -1,  3610,    -1,  4062,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,  4078,
      -1,  5551,  4081,  1899,    -1,    -1,    -1,  1903,  4087,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4101,    -1,    -1,    -1,  4105,  4106,  4107,    -1,
      -1,    -1,  5582,  4112,    -1,    -1,  4115,    -1,    -1,  4118,
      -1,    -1,    -1,    -1,    -1,  4124,    -1,  4126,    -1,    -1,
    4129,    -1,    -1,    -1,  4133,  4134,  4135,  4136,  4137,    -1,
      -1,  4140,  4141,  4142,  4143,  4144,  4145,  4146,  4147,  4148,
    4149,    -1,    -1,   407,  4153,  4154,  4155,    -1,  5848,  4158,
      -1,    -1,    -1,  6062,  4163,  3714,    -1,  3716,    -1,  4168,
      -1,  4170,    -1,  4172,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4180,    -1,    -1,  4183,    -1,  4185,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    25,    -1,   201,    -1,    -1,    -1,
      31,    -1,  4201,    -1,    -1,  4204,  4205,    -1,    -1,    -1,
    4209,  4210,    -1,    -1,    -1,  4214,    -1,  4216,    -1,   224,
     225,    -1,    -1,    -1,    -1,    -1,    -1,  2043,  6127,    -1,
      -1,    -1,    -1,  2049,    -1,    -1,  6135,  6136,    -1,    -1,
      -1,    -1,    -1,  4242,    -1,    76,    -1,   252,    -1,  4248,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4256,    -1,   513,
      -1,  4260,    -1,  3812,    -1,    -1,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,  2095,
      -1,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
     295,    -1,    -1,    -1,  4293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   133,    -1,    -1,   310,    -1,  3856,   313,   140,
      -1,  4310,    -1,   144,    -1,    -1,    -1,  4316,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6237,    -1,
      -1,   172,    -1,  4342,  6243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5831,  6261,    -1,    -1,    -1,  4365,    -1,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,   208,    -1,    17,
      18,    19,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,   407,  3952,    -1,  4404,    -1,    45,    52,    -1,
    4409,  4410,  4411,    -1,    52,    -1,    -1,    -1,    -1,  6109,
     198,    -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,  4437,  4438,
      78,  6340,    -1,    -1,  6134,    -1,    -1,  3996,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   288,    -1,    45,
      -1,   292,    -1,    -1,    -1,  6364,    52,    -1,    -1,    -1,
     248,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,  4483,    -1,    -1,  4486,    -1,    -1,
      -1,    -1,    78,   324,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,
     288,  6410,    -1,    -1,   292,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,  6426,    -1,    -1,
     535,    -1,  4081,    -1,    -1,    -1,   367,    -1,    -1,   370,
     371,    -1,    -1,    -1,  6443,  6444,   324,   325,    -1,    -1,
      -1,  4550,    -1,    -1,  6024,   333,    -1,  6247,   196,    -1,
      -1,    -1,    -1,   201,    -1,    -1,    -1,    -1,    25,    -1,
      -1,   402,    -1,    -1,    31,    -1,    -1,  4576,  4577,    -1,
      -1,  4580,    -1,    -1,  4133,    -1,   224,   225,  4587,   367,
      -1,    -1,    -1,   371,    -1,  4594,  4595,    -1,   376,    -1,
      -1,    -1,    -1,    -1,    -1,  4604,    -1,   385,    -1,  4158,
     196,    -1,    -1,    -1,   252,   201,   394,    -1,    -1,    76,
      -1,    -1,    -1,    -1,   402,    -1,    -1,    -1,  4627,    -1,
      -1,    -1,    -1,  4632,  4633,  4634,    -1,   415,   224,   225,
      -1,    -1,    -1,    -1,   475,  4644,   424,    -1,    -1,    -1,
      -1,   429,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,   310,    -1,    -1,   313,   133,    -1,  6368,    -1,
      -1,    -1,    -1,   140,    -1,    -1,  4685,   144,    -1,  4688,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6172,  6173,    -1,    -1,  6176,    -1,   486,   295,
      -1,    -1,    -1,    -1,    -1,   172,  4715,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   310,    -1,    -1,   313,    -1,    -1,
      -1,    -1,  4731,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4749,   208,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   407,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4777,    -1,
      -1,  4780,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4788,
    4789,    -1,  4791,    -1,    -1,    -1,  4795,  4796,    -1,    -1,
      -1,  4800,    -1,    -1,    -1,    -1,  4805,    -1,    -1,  4808,
    4809,    -1,    -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,
      -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,    -1,    -1,    -1,   292,    -1,  4836,    -1,    -1,
      -1,    -1,    -1,    -1,  4843,   302,    -1,    -1,    -1,  4848,
      -1,    -1,  4851,  4852,    -1,   312,    -1,    -1,    -1,    -1,
    4859,    -1,    -1,    -1,    -1,    -1,    -1,   324,    -1,    -1,
      -1,  4870,    -1,    -1,    -1,   513,    -1,    -1,    -1,  4878,
      -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,   527,
     528,   529,   530,    -1,    -1,    -1,    -1,   535,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4905,    -1,    -1,    -1,
     367,    -1,    -1,   370,   371,    -1,    -1,    -1,    -1,  4918,
      -1,    -1,    -1,    -1,  4923,    -1,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   402,    -1,    -1,    -1,   535,
      -1,    -1,    -1,    -1,    -1,    -1,  2772,    -1,    -1,  4958,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,  4975,    -1,    -1,    -1,
      -1,  4980,    -1,    -1,    -1,    -1,    -1,    -1,  4987,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,  5003,    -1,    -1,    -1,    52,    -1,
      -1,  5010,  2828,    -1,    -1,    -1,    -1,    -1,   475,    -1,
      -1,    -1,  5021,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4580,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5052,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5078,
      -1,    -1,   726,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,  5094,  2912,    17,    18,    19,
    5099,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   752,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,  5118,
    2936,    -1,    -1,    -1,    -1,    45,  5125,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5171,    -1,  5173,    -1,    -1,    -1,    -1,    -1,
     224,   225,    -1,    -1,  3000,    -1,    -1,    -1,  3004,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5205,    -1,   252,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3041,    -1,  3043,    -1,  3045,
    3046,    -1,  5231,    -1,  3050,  3051,  3052,    -1,  3054,  3055,
    3056,    -1,  5241,    -1,    -1,  5244,    -1,    -1,  5247,  5248,
    5249,   295,    -1,    -1,    -1,    -1,    -1,    -1,   902,    -1,
      -1,    -1,    -1,    -1,    52,    -1,   310,    -1,    -1,   313,
      -1,    -1,    -1,  5272,  5273,    -1,   196,  5276,    -1,    -1,
      -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3108,  5292,    -1,    -1,    -1,  5296,    -1,    -1,
      -1,    -1,    -1,  5302,   224,   225,    -1,  5306,    -1,    -1,
      -1,    -1,    -1,  5312,  5313,    -1,    -1,  3133,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5326,    -1,    -1,
    5329,    -1,   252,    -1,     8,  5334,    -1,  5336,    -1,    -1,
      14,    15,    -1,    -1,    -1,    -1,    20,    -1,    22,    -1,
      -1,    -1,    -1,    -1,    28,    -1,  4905,    31,    -1,  5358,
      -1,    -1,    -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   295,    50,    51,    -1,    -1,
      -1,    -1,    -1,    -1,  5383,  5384,    -1,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,  5394,    -1,    -1,    -1,    -1,
      -1,    -1,  1046,    -1,    -1,    -1,    -1,    -1,    -1,  4958,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3246,  4980,  1076,    -1,    -1,  5434,    -1,    -1,    -1,    -1,
    5439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1092,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   407,    -1,    -1,
      -1,   535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5500,    -1,  5052,  5503,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,    -1,    -1,
      -1,   205,    -1,    -1,    -1,  5534,    -1,    -1,    -1,   213,
      -1,    -1,   216,    -1,    -1,   219,   220,    -1,   222,    -1,
     224,    -1,  5551,   227,    -1,   229,  5555,    -1,  5557,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5571,    23,    -1,    -1,    -1,    -1,    28,    -1,
    5579,    -1,    -1,  5582,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,  5593,    -1,    -1,    -1,    -1,    -1,
      -1,  5600,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,   535,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5173,  1269,    -1,    -1,    -1,    79,
      80,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    -1,    -1,    -1,    96,    -1,    -1,  5648,
      -1,    -1,    -1,    -1,    -1,  5654,    -1,    -1,    -1,    -1,
    5659,  5660,    -1,    -1,   114,  5664,    -1,    10,    -1,    -1,
      13,  5670,  5671,  5672,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5686,   138,    -1,
      -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   151,    45,    -1,    -1,    -1,    -1,  5706,    -1,    52,
     160,    -1,    -1,    -1,    -1,  5714,    -1,    -1,  5717,    -1,
      -1,    -1,    -1,   173,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5742,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,    -1,
      -1,    52,    -1,  5312,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5771,  5772,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3599,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   244,    -1,  5795,  5796,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5807,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   266,  5816,  5817,  5818,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5831,  5832,    -1,    -1,  5835,    -1,    -1,    -1,
      -1,  5840,    -1,  5842,    -1,  5844,    -1,    -1,    -1,    -1,
      -1,    -1,  5851,   196,    -1,    -1,    -1,    -1,   201,  5858,
     310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3686,    -1,    -1,  1517,    -1,    -1,    -1,    -1,  5877,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,   337,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,   348,    -1,
      -1,   351,    52,  5902,    -1,    -1,  5905,    -1,    -1,   252,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3744,   379,
      -1,    -1,   382,    -1,    -1,    -1,   386,    -1,   726,   389,
      -1,  1585,    -1,    -1,    -1,    -1,   396,    -1,    -1,   399,
      -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,  5958,
      -1,    -1,    -1,    -1,   752,    -1,    -1,   310,    -1,   419,
     313,    -1,    -1,    -1,    -1,    -1,    -1,   427,    -1,    -1,
      -1,    -1,  1626,    -1,   434,    -1,    -1,   437,    -1,    52,
     664,    -1,   442,    -1,    -1,    -1,    -1,    -1,  3814,    -1,
     450,   675,   452,    -1,    -1,   679,    -1,   457,    -1,    -1,
    6009,    -1,   686,   687,    -1,  1659,   690,    -1,   692,   693,
      -1,    -1,    -1,    -1,    -1,  6024,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   707,   484,  6034,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3862,    -1,    -1,  6048,
      -1,   725,    -1,    -1,    -1,    -1,    -1,    -1,  3874,  3875,
      -1,    -1,    -1,  6062,   407,    -1,    -1,    -1,  3884,    -1,
      -1,    -1,   746,  3889,   748,  3891,  6075,    -1,    -1,    28,
      -1,    -1,    -1,    -1,   758,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1738,  1739,  1740,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5654,    -1,    -1,    -1,    -1,
    5659,  5660,    -1,    -1,   902,    -1,    -1,   791,  6117,    -1,
      -1,  3937,    -1,    -1,    -1,    -1,    -1,    -1,  6127,    -1,
      79,    -1,    -1,    -1,    -1,    -1,  6135,  6136,    -1,    -1,
      -1,    -1,  6141,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3972,  3973,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,    -1,    -1,
     513,   120,    -1,  6172,  6173,    -1,    -1,  6176,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,   138,
      -1,    -1,   535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151,    -1,    -1,   879,  1850,    -1,    -1,    -1,
      -1,   160,    -1,    -1,  6213,    -1,    -1,  1861,    -1,    -1,
      -1,    -1,    -1,  5772,   173,    -1,    -1,    -1,    -1,    -1,
     179,    -1,    -1,  1877,    -1,    -1,    -1,   186,  6237,    -1,
      -1,    -1,    -1,    -1,  6243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,  6261,    -1,    -1,    -1,    -1,    -1,    -1,  6268,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1065,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6284,  5835,  1931,  1076,    -1,
     964,    -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,    -1,
      -1,    -1,  1946,  6302,  1092,  1949,  1950,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,   266,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1980,  1981,    35,    -1,
      -1,  6340,    -1,    -1,    -1,    -1,  6345,    -1,    45,    -1,
      -1,    -1,  6351,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,   310,    -1,  4179,  1038,  6364,    -1,    -1,    -1,    -1,
      -1,    -1,  6371,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,   337,  1063,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,   348,
      -1,    -1,   351,    -1,  1078,    -1,  1080,    -1,    -1,    -1,
    6409,  6410,    -1,    -1,    -1,    -1,  1090,    -1,    -1,    -1,
      -1,    -1,    -1,  1097,    -1,    -1,    -1,  6426,    -1,    -1,
     379,  6430,    -1,   382,    -1,   726,    -1,   386,    -1,    -1,
     389,    -1,    -1,    -1,  6443,  6444,    -1,   396,    -1,    -1,
     399,    -1,    -1,    -1,    -1,    -1,  6455,    -1,  2102,    -1,
      -1,   752,    -1,    -1,    -1,    -1,  1140,    -1,  1142,    -1,
     419,    -1,  2116,  1261,    -1,  2119,    -1,    -1,   427,    -1,
      -1,  1269,    -1,   432,    -1,   434,    -1,    -1,   437,    -1,
      -1,    -1,    -1,   442,    -1,    -1,    -1,    -1,    -1,   196,
    2144,    -1,    -1,   452,   201,    -1,    -1,    -1,   457,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   471,    -1,    -1,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,   484,    -1,    -1,    -1,    -1,
      -1,    -1,  1216,    -1,  1218,    -1,  1220,    -1,  1222,    -1,
    1224,  1225,  1226,    -1,    -1,   252,    -1,  1231,    -1,     0,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1243,
      -1,    -1,    -1,    -1,    -1,    -1,   726,    -1,    -1,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      31,    -1,    33,    34,  4410,    -1,    -1,    -1,   295,    -1,
      -1,    -1,   752,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,   902,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,
      61,    -1,  4438,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    75,    76,    -1,  4453,    -1,    -1,
    4456,    82,  4458,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    99,    -1,
      -1,    -1,    -1,   726,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,   119,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4504,   752,
      -1,    -1,    -1,   134,    -1,   136,    -1,    -1,    -1,   140,
      -1,    -1,    -1,    -1,  4520,    -1,   147,    -1,    -1,  4525,
     407,    -1,    -1,    -1,    -1,   156,    -1,   158,    -1,    -1,
      -1,    -1,    -1,    -1,   165,    -1,    -1,    -1,    -1,  1517,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   183,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   902,    -1,    -1,    -1,    -1,    -1,    -1,   200,
      -1,    -1,    -1,    -1,  1438,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1065,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1076,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  6345,  1585,    -1,    -1,
      -1,  1092,    -1,    -1,    -1,    -1,    -1,    -1,  4624,    -1,
      -1,  4627,    -1,   254,   255,    -1,   513,    -1,    -1,   260,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   275,    -1,   533,    -1,  1626,   902,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   294,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4698,    -1,    -1,  1559,    -1,    -1,  4704,  4705,
    4706,  4707,   333,  4709,  4710,  4711,  4712,  4713,    -1,    -1,
      -1,   342,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1065,   357,    -1,    -1,    -1,
      -1,    -1,   363,   364,    -1,   366,  1076,    -1,    -1,    -1,
     371,    -1,    -1,    -1,    -1,    -1,   377,    -1,    -1,   380,
      -1,    -1,  1092,    -1,    -1,    -1,   387,    -1,    -1,    -1,
      -1,    -1,    -1,   394,   395,    -1,    -1,  1631,    -1,    -1,
      -1,   402,    -1,    -1,    -1,   406,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,  1269,    -1,
      -1,    -1,    -1,  2627,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   434,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4827,    -1,  1076,   455,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   467,    -1,    -1,  1092,
      -1,    -1,   473,    -1,    -1,    -1,    -1,   478,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1850,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1861,   515,    -1,   517,   518,   519,   520,
     521,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1877,
      -1,    -1,    -1,   534,    -1,    -1,   537,    -1,    -1,  2743,
      -1,    -1,    -1,  2747,  2748,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1931,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1946,  2803,
      -1,  1949,  1950,    -1,    -1,  2809,    -1,    -1,    -1,    -1,
      -1,    -1,  1846,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1980,  1981,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1269,  1881,    -1,    -1,
    2854,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1517,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5050,  5051,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5063,    -1,  5065,
    5066,  5067,    -1,  1927,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1947,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1585,    -1,    -1,    -1,    -1,  1973,
       0,  1975,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5131,  1990,    -1,  1992,    -1,
      20,    -1,    -1,    -1,  1998,    -1,  2000,    -1,  2002,    -1,
    2004,    31,  2006,    33,    34,  1626,  2010,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    51,    -1,    -1,  5170,    -1,  2144,    -1,    -1,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,  1517,  1659,    -1,
      -1,    -1,    -1,    73,    -1,    75,    76,    -1,    52,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,    -1,  3032,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2070,    97,  5214,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,   119,
    3064,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,  1585,   136,    -1,    -1,    -1,
     140,    -1,    -1,    -1,    -1,    -1,    -1,   147,    -1,    -1,
      -1,    -1,    -1,    -1,  1517,    -1,   156,    -1,   158,    10,
      -1,    -1,    13,    -1,    -1,   165,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1626,    -1,    -1,    -1,
      -1,    -1,    -1,   183,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3137,    45,    -1,    -1,  3141,    -1,    -1,
     200,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1659,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1585,    10,    -1,    -1,    13,    78,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,   254,   255,    -1,    -1,    45,  1850,
     260,    -1,    -1,  1626,    -1,    52,    -1,  5383,    -1,    -1,
    1861,    -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1877,    -1,    -1,    -1,
      -1,    78,    -1,    -1,   294,    -1,  1659,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5429,    -1,    -1,    -1,    52,    -1,  3263,
      -1,    -1,  5438,    -1,  3268,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   333,    -1,    -1,    -1,    -1,    -1,    -1,
    1931,    -1,   342,    -1,    -1,   196,    -1,    -1,    -1,    -1,
     201,    -1,    -1,    -1,  3298,  1946,    -1,   357,  1949,  1950,
      -1,    -1,    -1,   363,   364,    -1,   366,    -1,    -1,    -1,
      -1,   371,    -1,   224,   225,    -1,    -1,   377,    -1,    -1,
     380,    -1,    -1,    -1,    -1,    -1,    -1,   387,    -1,  1980,
    1981,    -1,    -1,    -1,   394,   395,    -1,    -1,    -1,    -1,
    1850,   252,   402,    -1,    -1,    -1,   406,    -1,    -1,   196,
      -1,  1861,    -1,    -1,   201,    -1,    -1,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1877,    -1,    -1,
      -1,    -1,    -1,    -1,   434,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   455,    -1,    -1,    -1,   310,
      -1,    52,   313,    -1,    -1,   252,    -1,   467,    -1,    -1,
      -1,    -1,    -1,   473,    -1,    -1,    -1,    -1,   478,    -1,
      -1,  1931,    -1,    -1,    -1,    -1,    -1,  1850,    -1,    -1,
      -1,   491,    -1,    -1,    -1,    -1,  1946,    -1,  1861,  1949,
    1950,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,    -1,  1877,   515,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,
    1980,  1981,    -1,    -1,   534,    -1,    -1,   537,    -1,    -1,
      -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,    -1,  2144,    -1,    -1,   407,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,  1931,    -1,
    5686,    -1,    -1,    -1,  5690,    -1,    -1,    45,    -1,    -1,
      -1,    -1,    -1,  1946,    52,    -1,  1949,  1950,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3550,    -1,    -1,  3553,
      78,  3555,    -1,    -1,    -1,    -1,  3560,  1980,  1981,    -1,
     407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2743,    -1,    -1,  3602,  2747,
    2748,    -1,   513,    -1,    -1,    -1,  3610,    -1,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,    -1,    -1,    -1,   535,    -1,    -1,    -1,    -1,    -1,
      -1,  3635,    -1,    -1,  2144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2803,    -1,    -1,    -1,    -1,
      -1,  2809,    -1,    -1,    -1,    -1,   513,    -1,   196,    -1,
      -1,    -1,    -1,   201,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,    -1,    -1,   535,    -1,
      -1,    -1,   726,    -1,    -1,    -1,   224,   225,    -1,    -1,
      -1,    -1,    -1,  2737,  2738,    -1,  2854,    -1,    -1,    -1,
    3714,    -1,  3716,    -1,    -1,    -1,    -1,    -1,   752,    -1,
      -1,  2144,  2756,  2757,   252,  2759,  2760,    -1,    -1,  5905,
      -1,  2765,  2766,  5909,    -1,  5911,    -1,    -1,    -1,  5915,
    5916,    -1,    -1,    -1,    -1,    -1,  2780,    -1,    -1,    -1,
    2784,    -1,    -1,    -1,  2788,  2789,    -1,    -1,  2792,  2793,
      -1,    -1,    -1,    -1,    -1,  2799,    -1,   295,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2811,    -1,    -1,
      -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,  2823,
      -1,    -1,    -1,    -1,  2828,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2841,  3812,    -1,
      -1,  2845,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2856,    -1,    -1,  2859,    -1,  2861,  2862,  2863,
      -1,    -1,    -1,    -1,  2868,  2869,    -1,  3841,    -1,    -1,
      -1,    -1,    -1,  3847,  2878,    -1,    -1,    -1,    -1,    -1,
    2884,    -1,  3856,    -1,  2888,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2900,  2901,   902,    -1,
      -1,  2905,    -1,    -1,    -1,    -1,    -1,  2911,  2912,   407,
    3884,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2925,    -1,    -1,  2928,    -1,    -1,    -1,    -1,    -1,
      -1,  2935,  2936,    -1,    -1,    -1,    -1,  2941,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3064,    -1,    -1,  2953,
      -1,    -1,  2956,    -1,    -1,    -1,    -1,  2961,    -1,    -1,
      -1,   726,    -1,  2967,  2968,    -1,    -1,    -1,    -1,    -1,
      -1,  2975,    -1,    -1,    -1,  2979,    -1,    -1,  3952,  2983,
    2984,  2985,  2986,    -1,  2988,    -1,    -1,   752,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3002,  3003,
    3974,  3005,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3016,  3017,  3018,   513,    -1,    -1,    -1,  3137,
      -1,    -1,  3996,  3141,   522,   523,   524,   525,   526,   527,
     528,   529,   530,    10,    -1,    -1,    13,   535,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,  1065,    -1,    -1,    -1,    -1,    -1,  6213,    45,  3073,
      -1,    -1,  1076,    -1,    -1,    52,    -1,  3081,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1092,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3100,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,   726,    -1,  4081,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2743,    -1,    -1,    -1,  2747,  2748,    -1,    -1,
    3248,   752,    -1,    -1,    -1,    -1,    -1,   902,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3263,  3150,    -1,    -1,    -1,
    3268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4133,
      -1,    -1,    -1,    -1,    -1,  3169,    10,  3171,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,    -1,
    3298,    -1,  2803,    -1,  4158,    -1,    -1,    -1,  2809,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,
      -1,    -1,    -1,    -1,   201,  6371,    -1,    -1,    -1,    -1,
      -1,    -1,  6378,  2854,    78,    -1,  6382,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,  2743,    -1,  1269,  3270,  2747,  2748,    -1,
    6416,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    10,
      -1,   902,    13,    -1,  6430,    -1,    17,    18,    19,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1065,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,  6455,
      -1,  1076,  6458,    -1,    45,    -1,    -1,    -1,   295,    -1,
      -1,    52,    -1,  2803,    -1,    -1,    -1,  1092,    -1,  2809,
      -1,    -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,
      -1,    -1,  4316,    -1,    -1,    -1,    -1,    78,    -1,    -1,
    2743,    -1,   196,    -1,  2747,  2748,    -1,   201,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2854,    -1,    -1,    -1,    -1,    -1,
     224,   225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,
    2803,    -1,    -1,    -1,    -1,    -1,  2809,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,    -1,  3550,    -1,    -1,  3553,  4410,  3555,    -1,    -1,
      -1,    -1,  3560,  3064,  1065,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,    -1,    -1,  1076,    -1,    -1,    -1,    -1,
      -1,  2854,    -1,    -1,  4438,   196,   310,    -1,    -1,   313,
     201,  1092,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3602,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3610,   224,   225,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1517,    -1,    -1,  3137,  3635,    -1,    -1,
    3141,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,    -1,    -1,   535,    -1,
      -1,    -1,    -1,   407,   295,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,
      -1,  1585,   313,    -1,  3064,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3597,    -1,    -1,  3714,    -1,  3716,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4580,    -1,    -1,    -1,
    3614,    -1,    -1,    -1,  3618,    -1,    -1,    -1,    -1,  3623,
    3624,  3625,  1626,    -1,    25,    -1,    -1,  3248,    -1,    -1,
      31,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,    -1,
      -1,  3645,  3263,    -1,    -1,    -1,    -1,  3268,  1269,    -1,
      -1,    -1,    -1,  4627,    -1,  1659,    -1,  3137,  4632,    60,
      -1,  3141,    -1,    -1,  3668,  3669,  3670,  3671,    -1,   513,
      -1,  3064,    -1,    -1,    -1,    76,   407,  3298,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,    -1,
      -1,   535,    -1,    -1,  3812,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3706,    -1,  3708,  3709,  3710,    -1,    -1,    -1,
      -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   133,    -1,    -1,    -1,    -1,    -1,  3856,   140,
      -1,    -1,    -1,   144,  3137,    -1,    -1,    -1,  3141,    -1,
      -1,    -1,  1517,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3884,    -1,  3248,    -1,
      -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   513,  3263,    -1,    -1,    -1,    -1,  3268,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,    -1,    -1,   204,   535,    -1,    -1,   208,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4791,  3298,    -1,
    1585,    -1,    -1,    -1,  3828,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3837,  3952,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1850,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3248,  3974,  1861,    -1,  3863,
    3864,  1626,    -1,    -1,  3868,    -1,   267,    -1,    -1,    -1,
    3263,   272,    -1,  1877,    -1,  3268,    -1,    -1,  3996,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3890,   288,    -1,    -1,
      -1,   292,    -1,    -1,  1659,    -1,  1517,    -1,    -1,    -1,
      -1,   302,    -1,    -1,    -1,  3298,    -1,    -1,    -1,    -1,
      -1,   312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   323,   324,    -1,    -1,    -1,  1931,    -1,  3550,
      -1,  4905,  3553,    -1,  3555,   726,    -1,    -1,  3942,  3560,
      -1,    -1,  1946,  3947,    -1,  1949,  1950,    -1,    -1,  3953,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   752,    -1,  4081,  1585,    -1,   367,    -1,    -1,   370,
     371,   372,    -1,    -1,    -1,    -1,  1980,  1981,    -1,  3983,
      -1,  3602,    -1,    -1,  4958,    -1,    -1,    -1,    -1,  3610,
      -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,    -1,    -1,
      -1,   402,    -1,    -1,    -1,  1626,  4980,    -1,  4012,    -1,
    4014,    -1,    -1,    -1,  3635,  4133,   417,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1659,    -1,
    4158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3550,    -1,    -1,  3553,   475,  3555,    -1,    -1,  5052,    -1,
    3560,    -1,    -1,    -1,    -1,  1850,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3714,    -1,  3716,  1861,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   902,  1877,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3602,    -1,    -1,    -1,    -1,    -1,    10,    -1,
    3610,    13,    -1,    -1,    -1,    17,    18,    19,    -1,    -1,
    2144,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    -1,  3635,    -1,  3550,    -1,    -1,
    3553,    -1,  3555,    45,    -1,    -1,  1931,  3560,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1946,    -1,    -1,  1949,  1950,    -1,    -1,    -1,    -1,
      -1,  3812,    -1,    -1,    -1,    -1,    78,  5171,  4316,  5173,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,
      -1,    -1,    -1,    -1,    -1,  1980,  1981,  3610,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1850,
      -1,    -1,    -1,    -1,  3714,  3856,  3716,    -1,    -1,    -1,
    1861,    -1,  3635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1877,    -1,    -1,    -1,
      -1,    -1,    -1,  3884,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1065,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1076,    -1,    -1,    -1,   171,
      -1,    -1,  4410,    -1,    -1,   177,    -1,    -1,    -1,    -1,
      -1,  1092,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1931,    -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,
    4438,  3714,    -1,  3716,  4328,  1946,  4330,    -1,  1949,  1950,
      -1,  3952,  3812,    -1,    -1,    -1,    -1,    -1,  5312,  4343,
      -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4355,    -1,  3974,    -1,  4359,    -1,    -1,    -1,  1980,
    1981,    -1,    -1,    -1,    10,    -1,  4370,    13,    -1,    -1,
     252,    17,    18,    19,    -1,  3996,  3856,    -1,    -1,  2144,
      -1,    -1,    -1,    -1,    -1,  4389,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,  4407,  3884,    -1,    52,    -1,    -1,  5383,
      -1,  4415,    -1,   295,    -1,    -1,    -1,    -1,    -1,  3812,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,
      -1,   313,    78,    -1,    -1,    -1,  4440,    -1,    -1,    -1,
    4444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4459,  4460,  4461,  4462,    -1,
    4081,    -1,  4580,  3856,    -1,  4469,  4470,  4471,  4472,    -1,
      -1,    -1,  3952,    -1,  4478,  4479,    -1,    -1,  1269,    -1,
    4484,  4485,    -1,  4487,  4488,  4489,  4490,  4491,  4492,  4493,
      -1,  3884,    -1,    -1,  3974,    -1,    -1,    -1,    -1,  4503,
      -1,    -1,    -1,  4507,  4508,  4509,  4510,    -1,    -1,  4627,
      -1,    -1,  4133,    -1,  4632,    -1,  3996,    -1,    -1,    -1,
      -1,    -1,    -1,  2144,    -1,   407,    -1,  4531,    -1,  5503,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4158,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4549,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,  3952,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
      -1,  3974,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
      -1,  4081,    52,  3996,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4625,    -1,    -1,    -1,    -1,    -1,    -1,    78,    -1,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   295,
      -1,    -1,    -1,  4133,  4658,    -1,    -1,    -1,    -1,    -1,
      -1,  4665,    -1,  4667,   310,    -1,    -1,   313,    -1,    -1,
      -1,    -1,    -1,  4791,    -1,    -1,    -1,    -1,  4158,    -1,
    5654,    -1,    -1,    -1,    -1,  5659,  5660,    -1,  4081,    -1,
      -1,  4695,    -1,    -1,    -1,  4316,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,  1517,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,  2743,
    4133,    -1,    -1,  2747,  2748,    45,   196,    -1,    -1,    -1,
      -1,   201,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,    -1,    -1,    -1,  4158,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4905,    -1,  4410,
      -1,    -1,    -1,    -1,  1585,    -1,    -1,  5771,  5772,  2803,
      -1,    -1,   252,    -1,    -1,  2809,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4438,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   207,   208,  1626,  4316,    -1,    -1,    -1,
    4958,   215,    -1,   217,   218,   295,    -1,    -1,    -1,    -1,
    2854,    -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,    -1,
     310,  5835,  4980,   313,    -1,    -1,    -1,   513,  1659,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,   535,
      -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,    -1,    -1,
      -1,   201,  4906,  4907,  4908,    -1,    -1,    -1,  4912,  4913,
    4914,  4915,    -1,    -1,    -1,  4919,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4316,   224,   225,    -1,    -1,    -1,    -1,
    4410,    -1,    -1,    -1,  5052,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,   407,  4438,  4580,
      -1,    -1,    -1,    -1,    -1,    -1,  4970,  4971,  4972,  4973,
    4974,    -1,  4976,  4977,    -1,    -1,    -1,    -1,  2743,    -1,
      -1,    -1,  2747,  2748,  4988,  4989,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4627,    -1,    -1,    -1,
     310,  4632,    -1,   313,    -1,    -1,    -1,  4410,  5022,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2803,    -1,
      -1,    -1,    -1,    -1,  2809,  4438,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5173,    -1,    -1,    -1,  1850,
    3064,    -1,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,
    1861,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,   535,  1877,    -1,    -1,  2854,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4580,    -1,    -1,    -1,    -1,    -1,    -1,   407,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5124,    -1,  2743,    -1,    -1,    -1,  2747,  2748,    -1,    -1,
      -1,    -1,    -1,  3137,    -1,    -1,    -1,  3141,    -1,    -1,
    1931,    -1,    -1,    -1,    -1,    -1,    -1,  4627,    -1,    -1,
      -1,    -1,  4632,    -1,    -1,  1946,    -1,    -1,  1949,  1950,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4791,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2803,    -1,    -1,  5189,    -1,  4580,  2809,  1980,
    1981,    -1,    -1,    -1,  5312,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   513,    -1,    -1,    -1,    -1,  5222,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,  2854,  4627,   535,    -1,    -1,    -1,  4632,
      -1,    -1,    -1,    -1,  3248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,
      -1,    -1,    -1,    -1,  3268,  5383,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4905,    -1,    -1,    -1,    -1,   663,
      -1,    -1,    -1,    -1,  3298,    -1,    -1,    -1,    -1,  3064,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   682,    -1,
      -1,  4791,    -1,    -1,   688,  5319,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   700,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4958,    -1,    -1,
      -1,    -1,   716,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2144,    -1,    -1,   730,   731,    -1,  4980,
      -1,    -1,    -1,   737,    -1,   739,   740,    -1,    -1,    -1,
      -1,  6345,  3137,    -1,    -1,    -1,  3141,    -1,    -1,   753,
      -1,  5385,    -1,    -1,    -1,  5503,    -1,    -1,    -1,   763,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4791,    -1,
    5404,    -1,    -1,    -1,    -1,    -1,  5410,  5411,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5420,    -1,    -1,    -1,
      -1,    -1,    -1,  5427,    -1,  4905,    -1,    -1,    -1,    -1,
      -1,  5052,    -1,    -1,    -1,  6409,    -1,    -1,    -1,    -1,
      -1,   815,    -1,  3064,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,    -1,    -1,    17,    18,    19,   831,  5462,  5463,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5475,    35,  5477,    -1,    -1,    -1,    -1,  4958,    -1,
      -1,    -1,    45,  3248,    -1,    -1,    -1,    -1,  5492,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3263,    -1,
    4980,    -1,   876,  3268,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4905,  5517,    -1,    78,  3137,    -1,    -1,    -1,
    3141,  5525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3298,    -1,    -1,  5654,    -1,    -1,    -1,
      -1,  5659,  5660,    -1,    -1,    -1,  3550,    -1,    -1,  3553,
      -1,  3555,  5173,    -1,    -1,    -1,  3560,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   938,  4958,    -1,    -1,    -1,    -1,
      -1,    -1,  5052,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4980,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3602,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3610,    -1,    -1,    -1,
      -1,  5615,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5629,    -1,  3248,    -1,    -1,
      -1,  3635,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,
     199,   200,  3263,    -1,   203,    -1,    -1,  3268,    -1,  5653,
      -1,    -1,    -1,    -1,  5772,    -1,    -1,    -1,    -1,  5052,
      -1,   224,   225,    -1,   223,    -1,    -1,    -1,    -1,    -1,
      -1,   230,    -1,    -1,  1048,    -1,    -1,  3298,    -1,    -1,
      -1,  1055,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,  5312,  1066,  5173,    -1,    -1,  1070,    -1,  1072,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3714,    -1,  3716,    -1,    -1,    -1,  5720,  5835,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,
     313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5173,    -1,    -1,    -1,    -1,  3550,  5790,    -1,  3553,    -1,
    3555,    -1,    -1,    -1,    -1,  3560,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1179,    -1,    -1,  3812,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5824,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,    17,
      18,    19,  5312,    -1,    -1,    -1,    -1,  3602,    -1,    -1,
      -1,    -1,    -1,    -1,   407,  3610,    -1,    35,    -1,    -1,
      -1,    -1,  3856,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,  5865,    -1,    -1,    52,    -1,  1240,    -1,    -1,    -1,
    3635,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3884,  1255,  5503,    -1,    -1,  5889,    -1,    -1,    -1,    -1,
      78,  1265,  1266,    -1,    -1,    -1,    -1,  1271,    -1,    -1,
      -1,    -1,    -1,  5383,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1287,    -1,    -1,    -1,    -1,  1292,  5312,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3550,
      -1,    -1,  3553,    -1,  3555,    -1,    -1,    -1,    -1,  3560,
      -1,    -1,    -1,    -1,    -1,  5949,    -1,    -1,  3952,  3714,
     513,  3716,  2743,    -1,    -1,    -1,  2747,  2748,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
    3974,    -1,   535,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,  3602,    17,    18,    19,    -1,    -1,    -1,    -1,  3610,
    5383,    -1,  3996,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      45,    -1,  2803,   201,  3635,    -1,    -1,    52,  2809,    -1,
      -1,    -1,    -1,  5503,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5654,    -1,    -1,   224,   225,  5659,  5660,
      -1,    -1,    -1,    78,    -1,    -1,    -1,  3812,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6061,    -1,    -1,
      -1,    -1,    -1,  2854,   252,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4081,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6094,  3856,    -1,  3714,    -1,  3716,    -1,    -1,    -1,    -1,
    1474,  6105,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,
    5503,    -1,    -1,   672,    -1,   674,    -1,    -1,   677,  3884,
      -1,    -1,   310,    -1,    -1,   313,    -1,    -1,    -1,  4133,
      -1,    -1,   691,    -1,    -1,    -1,    -1,    -1,   697,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5772,    -1,    -1,  4158,    -1,    -1,    -1,    -1,    -1,
      -1,   196,    -1,    -1,    -1,    -1,   201,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5654,    -1,    -1,    -1,    -1,  5659,
    5660,    -1,    -1,    -1,    -1,    -1,    -1,  3952,    -1,   224,
     225,  3812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3974,
      -1,    -1,    -1,    -1,  5835,    -1,    -1,   252,    -1,   407,
     208,    -1,    -1,  6227,    -1,    -1,    -1,  6345,    -1,   217,
      -1,  3996,    -1,    -1,    -1,  3856,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     295,  5654,    -1,  3884,    -1,    -1,  5659,  5660,    -1,    -1,
      -1,    -1,    -1,  3064,    -1,   310,    -1,    -1,   313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5772,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4316,    -1,    -1,    -1,  4081,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   513,    -1,    -1,    -1,    -1,
      -1,  3952,    -1,    -1,   522,   523,   524,   525,   526,   527,
     528,   529,   530,    -1,    -1,    -1,  3137,   535,    -1,  1723,
    3141,    -1,    -1,  3974,    -1,  5835,    10,    -1,    -1,    13,
      -1,    -1,    -1,    17,    18,    19,    -1,    -1,  4133,    -1,
      -1,    -1,   407,    -1,    -1,  3996,    -1,    10,    -1,  5772,
      13,    35,    -1,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    45,    -1,  4158,    -1,    -1,    -1,    -1,    52,    -1,
      -1,    -1,    35,    -1,    -1,    -1,  4410,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,  6433,
      -1,    -1,   991,   992,  4438,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5835,    -1,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3248,    -1,    -1,
    4081,    -1,    -1,    -1,  1838,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3263,    -1,    -1,    -1,    -1,  3268,   513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,  1873,
     535,    -1,    -1,  1062,    -1,    -1,    -1,  3298,    -1,    -1,
      -1,    -1,  4133,    -1,    -1,    -1,    -1,    -1,  1077,    -1,
      -1,    -1,  1896,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1904,    -1,    -1,    -1,    -1,    -1,    -1,  4158,  1912,    -1,
      -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,  1108,
    1109,  4316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   196,    -1,    -1,    -1,    -1,   201,    -1,
     224,   225,    -1,    -1,    -1,  1134,  4580,    -1,    -1,  1953,
    1954,    -1,  1956,  1957,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,    -1,  1968,    -1,  1970,  1971,   252,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1983,
    1984,    -1,    -1,    -1,    -1,  1174,  1175,    -1,    -1,   252,
      -1,    -1,    -1,  4627,    -1,    -1,    -1,    -1,  4632,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    -1,    -1,    -1,  4410,    -1,  2021,    -1,    -1,
      -1,  2025,  2026,    -1,    -1,    -1,   310,    -1,    -1,   313,
      -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4438,    -1,   663,    -1,   310,    -1,    -1,
     313,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   209,   682,  4316,    -1,    -1,    -1,    -1,
     688,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,
      -1,    -1,   700,    -1,    10,    -1,   232,    13,    -1,    -1,
      -1,    17,    18,    19,  6345,    -1,    -1,    -1,   716,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      -1,    -1,    -1,   731,    -1,    -1,    -1,    -1,    -1,    45,
      -1,   739,    -1,   407,    -1,    -1,    52,    -1,    -1,  3550,
      -1,    -1,  3553,    -1,  3555,   753,    -1,    -1,    -1,  3560,
      -1,    -1,    -1,    -1,   407,   763,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    -1,    -1,    -1,    -1,  4791,    -1,  4410,
      -1,  2165,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3602,    -1,    -1,    -1,  4580,    -1,  4438,    -1,  3610,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   815,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   831,  3635,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      -1,    -1,  4627,    -1,    -1,  6345,    -1,  4632,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,    -1,
     513,   535,    -1,    -1,    -1,    -1,    -1,    -1,   876,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
     196,  4905,   535,    -1,    -1,   201,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3714,    -1,  3716,    -1,    -1,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     938,    -1,  6345,    -1,  4958,    -1,   252,    -1,    -1,  4580,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4980,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,
      -1,    -1,    -1,    -1,    -1,    -1,  4627,    -1,    -1,    -1,
      -1,  4632,    -1,    -1,   310,    -1,    -1,   313,    -1,  1578,
      -1,  3812,    -1,    -1,    -1,    -1,  4791,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1603,    -1,    -1,    -1,  5052,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1048,    -1,    -1,    -1,    -1,  3856,    -1,  1055,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3884,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4905,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   664,    -1,
    1709,  1710,  1711,  1712,   670,    -1,    -1,    -1,    -1,    -1,
      -1,  3952,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5173,
    4791,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3974,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1179,    -1,  4958,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3996,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4980,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,   535,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1255,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1265,  1266,    -1,
      -1,    -1,    -1,  1271,  4905,    -1,    -1,  5052,    -1,    -1,
    4081,    -1,    -1,    10,    -1,    -1,    13,  1856,  1857,  1287,
      17,    18,    19,    -1,  1292,    -1,    -1,  2681,  5312,    -1,
      -1,    -1,    -1,  1872,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,  4958,   854,    -1,
      -1,    -1,  4133,    -1,    -1,    -1,    -1,  1906,  1907,  1908,
    1909,   867,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4980,
      -1,    78,  2736,    -1,    -1,    -1,    -1,  4158,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5383,
    2754,    -1,    -1,    -1,  2758,    -1,    -1,    -1,  2762,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2772,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5173,    -1,
      -1,    -1,    -1,  2787,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   939,    -1,    -1,    -1,    -1,  1987,    -1,
    2804,  5052,  2806,  2807,  1993,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,  2821,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2839,  2840,    -1,    35,    -1,
     986,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,   196,
      -1,    -1,    -1,    -1,   201,    52,  1474,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5503,
      -1,    -1,  2876,  2877,    -1,    -1,  2880,   224,   225,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4316,    -1,    -1,    -1,    -1,
    2904,    -1,  2906,    -1,    10,   252,  2910,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,  5312,    -1,    -1,
    2924,    -1,  5173,    -1,    -1,    -1,    -1,  2931,    -1,    35,
    2934,    -1,    -1,   130,    -1,    -1,  2940,    -1,    -1,    45,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,  1101,  2960,    -1,    -1,    -1,
      -1,    -1,  2966,   310,    -1,    -1,   313,    -1,    -1,  2973,
      -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2987,  1130,  1131,  1132,    -1,  5383,  4410,
      -1,    -1,    -1,    -1,   341,    -1,    -1,  3001,    -1,   196,
      -1,    -1,  3006,    -1,   201,    -1,    -1,    -1,  3012,    -1,
      -1,    -1,    -1,    -1,  2203,    -1,    -1,  4438,    -1,    -1,
    5654,    -1,    -1,    -1,    -1,  5659,  5660,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,
     407,  5312,    -1,    -1,   170,    -1,    -1,    -1,  3072,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,  1239,    -1,   201,    -1,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,  1723,    -1,    -1,  5503,    -1,
      -1,    -1,    -1,   310,    -1,    -1,   313,    -1,   224,   225,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,
      -1,    -1,  5383,    17,    18,    19,    -1,    -1,  5772,    -1,
    1286,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    35,    -1,    -1,    38,    -1,    -1,    -1,    -1,  4580,
      -1,    45,    -1,    -1,    -1,    -1,   513,    -1,    52,    -1,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,    -1,    -1,    -1,   295,
      -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,  5835,    -1,    -1,   310,    -1,  4627,   313,    -1,    -1,
     407,  4632,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    10,
    1838,    -1,    13,  3227,    -1,  3229,    17,    18,    19,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3246,    -1,    35,    -1,  3250,    -1,    -1,    -1,
      -1,    -1,  5503,  3257,    45,  1873,    -1,    -1,    -1,  5654,
    3264,    52,  3266,  3267,  5659,  5660,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   472,    -1,    -1,  1896,    -1,
      -1,  1427,    -1,    -1,    -1,    -1,  1904,    78,    -1,    -1,
      -1,    -1,    -1,    -1,  1912,    -1,    -1,    -1,    -1,    -1,
      -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    10,   196,    -1,    13,    -1,   513,   201,    17,    18,
      19,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,    35,    -1,  1956,  1957,
     224,   225,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
    3354,    -1,  1970,    52,    -1,    -1,  3360,    -1,    -1,    -1,
      -1,  1507,    -1,    -1,    -1,  1983,  1984,    -1,   252,    -1,
    4791,    -1,    -1,    -1,    -1,    -1,    -1,  5772,    -1,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5654,    -1,   196,    -1,   513,  5659,  5660,
     201,   295,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,   310,    -1,    -1,   313,
      -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,    -1,
    5835,    -1,    -1,    -1,    -1,  1591,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1600,    -1,    -1,    -1,  2647,    -1,
      -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4905,    -1,  1632,    -1,    -1,    -1,
      -1,    -1,  1638,  1639,    -1,    -1,  1642,   196,    -1,    -1,
      -1,    -1,   201,    -1,   295,    -1,    -1,    -1,    -1,  1655,
      -1,    -1,  1658,    -1,    -1,    -1,    -1,    -1,    -1,   310,
      -1,  5772,   313,   407,    -1,   224,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,  4958,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,  2165,    -1,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,    35,  4980,
      -1,    38,    -1,    -1,    -1,    -1,    -1,  1713,    45,    -1,
      -1,  3575,  3576,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,  1727,    -1,    -1,  5835,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3596,    -1,    -1,  3599,   295,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,    -1,    -1,   313,    -1,   407,    -1,    -1,    -1,
      -1,  2810,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   513,
      -1,  5052,    -1,    -1,    -1,   334,    -1,    -1,   522,   523,
     524,   525,   526,   527,   528,   529,   530,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3680,  3681,  3682,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3705,  1848,    -1,    -1,    -1,    -1,    -1,   407,    -1,
      -1,  6345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,
    3724,   512,   513,    -1,   201,    -1,    -1,    -1,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
      -1,    -1,  3746,    -1,  1890,  1891,    -1,   224,   225,    -1,
      -1,    -1,  5173,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2952,    -1,    -1,  2955,    -1,    -1,  1915,
      -1,    -1,    -1,    -1,    -1,   252,  1922,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   513,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,  3836,   310,    -1,    -1,   313,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1995,
      -1,    -1,    -1,    -1,    -1,  3044,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3057,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3065,    -1,    -1,  3883,
      -1,    -1,  2028,  2029,    -1,  3889,    -1,  3891,    -1,    -1,
      -1,  5312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3904,    -1,  3906,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,  3104,    -1,    17,    18,    19,
      -1,    -1,  2068,    -1,    -1,  2071,    -1,    -1,    -1,    -1,
     407,    -1,    -1,    -1,    -1,    35,  3125,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,
    6345,    -1,    52,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      13,    -1,  5383,    -1,    17,    18,    19,    -1,    -1,  3973,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,  3168,
      -1,  3170,    35,    -1,    -1,    38,    -1,    10,    -1,    -1,
      13,    -1,    45,    -1,    17,    18,    19,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4015,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    78,    -1,    -1,    -1,    52,
    4034,    -1,    -1,    -1,  4038,    -1,   513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    78,    -1,    -1,  4062,    -1,
      -1,    -1,    -1,  2681,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3262,    -1,    -1,    -1,   177,    -1,    -1,
    3269,    -1,  5503,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6345,    -1,   196,    -1,    -1,    -1,
      -1,   201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2736,    -1,
      -1,    -1,    -1,    -1,   224,   225,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2754,    -1,    -1,    -1,
    2758,    -1,    -1,   196,  2762,    -1,    -1,    -1,   201,    -1,
      -1,    -1,   252,    -1,  2772,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4170,    -1,    -1,  2787,
      -1,   224,   225,   196,    -1,    -1,    -1,    -1,   201,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,   252,
      -1,   224,   225,  2821,    -1,    -1,    -1,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2839,  2840,    -1,    -1,    -1,    -1,    -1,    -1,   252,
      -1,    -1,    -1,  5654,    -1,    -1,    -1,    -1,  5659,  5660,
      -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   852,   853,    -1,    -1,   310,  2876,  2877,
     313,    -1,  2880,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2904,   310,  2906,    -1,
     313,    -1,  2910,    -1,    -1,    10,    -1,    -1,    13,    -1,
      -1,    -1,    17,    18,    19,    -1,  2924,   407,    -1,    -1,
      -1,    -1,    -1,  2931,    -1,    -1,  2934,    -1,    -1,    -1,
      35,    -1,  2940,    38,    -1,    -1,   925,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    52,  4342,    -1,
      -1,    -1,  2960,    -1,    -1,    -1,    -1,    -1,  2966,    -1,
      -1,  5772,    -1,    -1,   407,  2973,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,  2987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3001,   407,    -1,    -1,    -1,  3006,    -1,
      -1,    -1,    -1,    -1,  3012,    -1,    -1,    -1,    -1,    -1,
    4404,    -1,    -1,    -1,    -1,  4409,    -1,  4411,    -1,    -1,
      -1,    -1,    -1,   513,  5835,    -1,  3605,  3606,    -1,    -1,
     443,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,  4437,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1046,  1047,    -1,
      -1,    -1,    -1,    -1,  3072,    -1,    -1,    -1,    -1,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,  2624,  4483,
      -1,   196,  4486,    -1,    -1,    -1,   201,    -1,  2634,    -1,
     513,    -1,    -1,    -1,    -1,    -1,  2642,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,   224,
     225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,
      -1,    -1,    -1,  2689,  2690,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    10,    -1,    -1,
      13,    -1,    52,    -1,    17,    18,    19,    -1,    -1,    -1,
      -1,    -1,  4576,  4577,    -1,    -1,    -1,  2723,    -1,    -1,
     295,    -1,    35,  4587,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    45,    -1,    -1,   310,    -1,    -1,   313,    52,
    4604,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3227,
      -1,  3229,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,  3246,    -1,
      -1,    -1,  3250,    10,    -1,    -1,    13,    -1,    -1,  3257,
      17,    18,    19,    -1,    -1,    -1,    -1,  1392,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    35,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    45,  3858,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    35,    -1,
      -1,  4685,    -1,    -1,  4688,    -1,    -1,    -1,    45,    -1,
    1435,    -1,   407,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,    -1,  1304,   196,    -1,    -1,    -1,
      -1,   201,  2858,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    -1,    -1,   177,    -1,    -1,  2873,    -1,    -1,
      -1,    -1,    -1,    -1,   224,   225,  3354,    -1,    -1,    -1,
      -1,    -1,  3360,   196,    -1,    -1,    -1,  1346,   201,  2895,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,    -1,    -1,    -1,  1375,  1376,  1377,    -1,
    1379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   150,    -1,    -1,    -1,    -1,   513,   252,
     177,  1400,    -1,    -1,    -1,   295,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,   196,
     310,    -1,    -1,   313,   201,    -1,    -1,    -1,    -1,  4018,
      -1,    -1,    -1,    -1,    -1,  2981,  2982,    -1,    -1,   196,
     330,    -1,   295,    -1,   201,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,
     313,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,    -1,
      -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1491,    -1,    -1,   252,  1495,  1496,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4918,    -1,    -1,   407,   295,    -1,
      -1,    -1,    -1,    -1,  6345,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   310,    -1,    -1,   313,  3083,   295,    -1,
      10,    -1,    -1,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,   310,   407,    -1,   313,  3575,  3576,    -1,
      -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,  4975,    -1,    -1,    -1,    45,    -1,    -1,  3596,    -1,
      -1,  3599,    52,  4987,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1744,
      -1,    -1,    -1,  1748,    -1,    -1,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5021,    -1,    -1,
      -1,    -1,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,
     407,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     513,    -1,  3680,  3681,  3682,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3705,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5099,    -1,    -1,    -1,    -1,
      -1,   171,    -1,    -1,    -1,    -1,  3724,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5118,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,  3746,    -1,
      -1,   201,    -1,    -1,    -1,    -1,   513,    -1,    -1,  1738,
    1739,  1740,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,   224,   225,   513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    -1,   252,    13,    -1,    -1,    -1,    17,    18,    19,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5205,    -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,  3836,    -1,
      -1,    -1,    52,    -1,    10,   295,    -1,    13,    -1,    -1,
      -1,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    78,    35,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    13,    45,
      -1,    -1,    17,    18,    19,  3883,    52,    -1,    -1,    -1,
      -1,  3889,    -1,  3891,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    -1,    -1,    38,    -1,  3431,  3904,    -1,  3906,    -1,
      45,    -1,    78,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,  3449,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
    5334,    -1,  5336,    -1,    -1,    -1,    -1,   407,    -1,    -1,
      -1,    -1,  2087,    -1,    -1,  4534,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3973,    -1,    -1,    -1,  4548,
      -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,  2113,    -1,
      -1,   201,  2117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5384,    -1,    -1,    -1,    -1,   171,    -1,  2132,  2133,  2134,
    5394,  2136,    -1,    -1,   224,   225,    -1,  4015,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    -1,    -1,    -1,    -1,   201,  4034,    -1,    -1,    -1,
    4038,    -1,   252,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5434,    -1,    -1,    -1,    -1,  5439,    -1,    -1,   224,   225,
      -1,   196,    -1,   513,  4062,    -1,   201,    -1,    -1,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,   295,   252,    -1,    -1,   224,
     225,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     310,    -1,    -1,   313,    -1,    -1,    -1,    -1,    -1,    -1,
    2089,    -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,  2098,
    2099,  2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,   295,
      -1,    -1,    -1,  2112,    -1,  2114,    -1,  2116,    -1,    -1,
    2119,  2120,  2121,    -1,   310,    -1,    -1,   313,  2127,    -1,
      -1,  2130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     295,    -1,    -1,    -1,    -1,    -1,  2145,  2146,  2147,    -1,
      -1,    -1,  4170,    -1,    -1,   310,    -1,    -1,   313,    -1,
      -1,    -1,    -1,    -1,  2163,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3722,   407,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3732,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    13,    -1,    -1,    -1,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   407,    -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,   407,    -1,    -1,    -1,    -1,   487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5672,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5686,   513,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   522,   523,   524,   525,   526,   527,   528,   529,
     530,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2310,    -1,  5717,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4342,    -1,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,
     526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,  3895,
    3896,  3897,    -1,    -1,    -1,    -1,    -1,    -1,   513,    -1,
      -1,    -1,    -1,    -1,    -1,  2364,  3912,   522,   523,   524,
     525,   526,   527,   528,   529,   530,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4404,    -1,    -1,   196,
      -1,  4409,  5796,  4411,   201,    -1,    -1,    -1,    -1,  3945,
    3946,    -1,    -1,    -1,  3950,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,  4437,
      -1,  2420,    -1,    -1,    -1,    -1,    -1,    -1,  5832,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5032,    -1,   252,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5047,    -1,
      -1,    -1,    -1,    -1,    23,  4483,    -1,    -1,  4486,    28,
      -1,    -1,    -1,    -1,    -1,    -1,  2621,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5902,    -1,
      -1,  5905,    -1,   310,    -1,    -1,   313,    66,    -1,    -1,
      -1,    -1,    -1,  4059,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5138,
      -1,  2696,    -1,    -1,    -1,   114,    -1,    -1,  4576,  4577,
      -1,    -1,    -1,  2708,    -1,    -1,    -1,    -1,  2713,  4587,
      -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,    -1,    -1,  4604,    -1,    -1,    -1,
      -1,    -1,   151,    41,    -1,    -1,    -1,    -1,    -1,    -1,
     407,   160,    -1,    -1,    -1,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,   173,  2614,    -1,    -1,    66,    -1,
     179,    -1,    -1,    -1,    -1,    -1,  2625,   186,  2627,    -1,
      -1,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  6048,  2644,    -1,   206,    96,  2648,
      -1,    -1,  2651,    -1,  2653,    -1,    -1,  2656,  6062,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,  4685,    -1,    -1,
    4688,  6075,   120,    -1,    -1,    -1,    -1,    -1,    -1,  4225,
    4226,  4227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     138,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   151,    -1,    -1,   513,   266,    -1,    -1,
    2709,  2710,   160,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    -1,   173,    -1,    -1,    -1,    -1,
      -1,  6135,  6136,    -1,   182,    -1,    -1,    -1,   186,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   310,    -1,    -1,    -1,    -1,    -1,    -1,   206,    -1,
      -1,    -1,    -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,
      -1,  5360,    -1,  5362,    -1,    -1,    -1,    -1,   337,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   347,   348,
      -1,  2790,   351,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   256,  6213,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,
     379,    -1,    -1,   382,    -1,    -1,    -1,   386,    -1,    -1,
     389,    -1,    -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,
     399,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     419,    -1,   310,    -1,    -1,   313,    -1,    -1,   427,    -1,
      -1,    -1,    -1,    -1,    -1,   434,    -1,    -1,   437,    -1,
      -1,    -1,    -1,   442,    -1,    -1,    -1,    -1,    -1,   337,
      -1,   450,    -1,   452,    -1,    -1,    -1,    -1,   457,    -1,
    4918,    -1,    -1,   351,    -1,    -1,    -1,    -1,    -1,  5498,
      -1,   359,   471,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   484,    -1,    -1,    -1,    -1,
      -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   389,    -1,    -1,    -1,    -1,    -1,    -1,   396,    -1,
      -1,   399,    -1,    -1,    -1,    -1,    -1,  4975,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6371,    -1,  4987,
      -1,   419,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   427,
      -1,    -1,    -1,    -1,    -1,    -1,   434,    -1,    -1,   437,
      -1,   439,    -1,   441,   442,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5021,    -1,    -1,    -1,    -1,    -1,   457,
      -1,  4557,    -1,    -1,    -1,    -1,    -1,   465,    -1,    -1,
     468,    -1,    -1,   471,    -1,    -1,  6430,    -1,    -1,    -1,
      -1,  3030,  3031,  3032,    -1,    -1,   484,  3036,    -1,  6443,
    6444,    -1,    -1,  4589,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  6455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3063,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4621,    -1,    -1,    -1,    -1,
      -1,  5099,    -1,    -1,    -1,    -1,    -1,  5676,    -1,  5678,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5118,    -1,    23,    -1,    -1,    -1,    -1,    28,    -1,    -1,
    4656,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4673,    -1,    -1,
      -1,    -1,    -1,    -1,  3279,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,  3296,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
      -1,  3306,    -1,    -1,    -1,    -1,    -1,  3312,    -1,    -1,
    3315,    -1,    -1,    -1,    -1,    96,    -1,  3322,  3323,    -1,
    3325,    -1,    -1,    -1,    -1,  3330,  3331,  5205,  3333,    -1,
    3335,    -1,    -1,   114,  3339,    -1,    -1,  3342,    -1,    -1,
      -1,    -1,  3347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3356,    -1,    -1,    -1,    -1,  3361,   138,    -1,    -1,
      -1,    -1,    -1,  3368,  3369,  3370,  3371,    -1,    -1,    -1,
     151,  3376,  3377,    -1,  3379,    -1,    -1,    -1,    -1,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   173,  3398,    -1,  3400,    -1,    -1,   179,    -1,
      -1,    -1,  3407,  3408,  3409,  3410,  3411,  3412,  3413,  3414,
    3415,  3416,    -1,  4819,  4820,  4821,  4822,  3276,    -1,    -1,
      -1,    -1,  3281,    -1,    -1,   206,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3450,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5334,    -1,  5336,    -1,
      -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    31,  3332,    33,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3343,   266,  3345,  3346,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5944,    -1,    -1,    -1,    -1,
    3359,    -1,    61,  3362,    -1,  3364,  5384,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    76,    -1,    -1,
      -1,    -1,    -1,    82,    -1,    84,    -1,    -1,    -1,   310,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,
      99,    -1,  3401,    -1,  3403,    -1,  3405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5434,   116,    -1,    -1,
     119,    -1,    -1,    -1,    -1,    -1,   347,   348,    -1,    -1,
     351,    -1,    -1,    -1,    -1,   134,    -1,   136,    -1,    -1,
      -1,   140,    -1,    -1,    -1,  3590,    -1,    -1,   147,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,   379,   158,
      -1,   382,    -1,    -1,    -1,    -1,   165,    -1,   389,    -1,
      -1,    -1,    -1,    -1,    -1,   396,    -1,    -1,   399,    -1,
      -1,    -1,    -1,    -1,   183,    -1,    -1,    -1,  6077,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3496,   419,    -1,
      -1,   200,  3501,    -1,    -1,    -1,   427,    -1,    -1,    -1,
      -1,    -1,    -1,   434,    -1,    -1,   437,  3516,    -1,    -1,
      -1,   442,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   450,
      -1,    -1,    -1,    -1,    -1,    -1,   457,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   254,   255,    -1,    -1,    -1,
      -1,   260,    -1,   484,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   275,    -1,    -1,    -1,
      -1,    -1,  3581,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   294,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6207,    -1,
    5166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5177,    -1,    -1,   333,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3641,   342,    -1,    -1,    -1,    -1,    -1,  6238,
    6239,    -1,    -1,    -1,  5672,    -1,    -1,    -1,   357,    -1,
      -1,    -1,    -1,    -1,   363,   364,    -1,   366,  5686,    -1,
      -1,    -1,   371,    -1,    -1,   374,    -1,    -1,   377,    -1,
      -1,   380,    -1,    -1,    -1,    -1,    -1,    -1,   387,    -1,
      -1,    -1,    -1,    -1,    -1,   394,   395,    -1,    -1,  5717,
    3845,  3846,    -1,   402,    -1,  3850,    -1,   406,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3879,   434,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   455,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   467,    -1,
      -1,    -1,  6361,    -1,   473,    -1,    -1,    -1,  5796,   478,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   491,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5832,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,    -1,    -1,   537,    -1,
      -1,    -1,  3841,    -1,    -1,    -1,    -1,    -1,  3847,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5902,    -1,    -1,  5905,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5456,    -1,    -1,    -1,    -1,  5461,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3926,    -1,    -1,
      -1,    -1,  4077,    -1,  5480,    -1,    -1,    -1,  4083,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4130,  4131,    -1,    -1,  4134,
    4135,  4136,  4137,    -1,    -1,  4140,  4141,  4142,  4143,  4144,
    4145,  4146,  4147,  4148,  4149,  4150,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4173,    -1,
    6048,  4176,    -1,  4178,    -1,    -1,  4181,  4182,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6075,  4203,  4204,
    4205,  4206,    -1,  4208,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4078,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4087,    -1,
      -1,    -1,    -1,    -1,    -1,  5641,    -1,    -1,    -1,    -1,
      -1,    -1,  4101,    -1,    -1,    -1,  4105,  4106,  4107,    -1,
      -1,    -1,    -1,  4112,    -1,    -1,  4115,    -1,    -1,  4118,
      -1,    -1,    -1,    -1,    -1,  4124,    -1,  4126,    -1,    -1,
    4275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4153,  4154,  4155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4172,    -1,    -1,    -1,    -1,    -1,    -1,
    4325,  4180,    -1,    -1,  4183,    -1,  4185,    -1,    -1,    -1,
      -1,    -1,    -1,  5739,    -1,  6213,    -1,    -1,    -1,    -1,
      -1,    -1,  4201,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4209,  4210,    -1,    -1,    -1,  4360,    -1,  4216,    -1,    -1,
      -1,  5767,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4242,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4310,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6371,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4550,    -1,    -1,    -1,    -1,
      -1,    -1,  6430,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6455,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4593,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4716,    -1,    -1,    -1,  4720,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4733,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4741,    -1,  4743,    -1,
    4745,  4746,    -1,    -1,    -1,    -1,  4751,  4752,  4753,  4754,
      -1,    -1,    -1,  4758,  4759,  4760,  4761,  4762,  4763,  4764,
    4765,  4766,  4767,  4768,  4769,  4770,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4633,  4634,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4644,    -1,    -1,    -1,  4794,
      -1,    -1,  4797,    -1,  4799,    -1,    -1,    -1,  4803,    -1,
      -1,  4806,  4807,    -1,    -1,  4810,  4811,    -1,    -1,    -1,
      -1,  4816,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4715,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4869,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  4731,    -1,    -1,    -1,    -1,    -1,  4883,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4749,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4788,
    4789,    -1,    -1,    -1,    -1,    -1,  4795,  4796,    -1,    -1,
      -1,  4800,    -1,    -1,    -1,    -1,  4805,    -1,    -1,  4808,
    4809,    -1,    -1,    -1,    -1,    -1,  4815,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4859,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4870,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4878,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4923,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5081,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5003,    -1,    -1,    -1,    -1,    -1,
      -1,  5010,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5168,  5169,    -1,    -1,    -1,    -1,    -1,
      -1,  5176,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5220,    -1,    -1,    -1,  5078,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5243,  5244,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5262,    -1,  5264,
      -1,    -1,    -1,  5268,  5269,  5270,  5271,    -1,    -1,  5274,
    5275,    -1,    -1,    -1,    -1,  5280,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5296,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5314,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5328,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5356,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5241,    -1,    -1,    -1,    -1,    -1,  5247,  5248,
    5249,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5405,    -1,  5407,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5272,  5273,    -1,    -1,  5276,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5292,    -1,    -1,    -1,  5442,    -1,    -1,
      -1,    -1,    -1,  5302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5313,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5329,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5548,    -1,  5550,  5551,  5552,  5553,  5554,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5567,  5568,  5569,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5577,    -1,    -1,    -1,    -1,  5582,    -1,    -1,
    5585,    -1,    -1,    -1,  5589,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  5607,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5624,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5534,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5555,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5600,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5648,
      -1,    -1,  5797,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5808,    -1,  5664,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  5829,    -1,  5831,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5706,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  5876,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  5888,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    5925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  5795,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5807,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  5816,  5817,  5818,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  5844,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5858,
    6005,    -1,    -1,    -1,    -1,    -1,    -1,  6012,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  5877,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6045,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6060,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6009,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  6172,  6173,    -1,
      -1,  6176,    -1,    -1,    -1,  6034,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    6235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  6260,    -1,    -1,  6117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  6278,  6279,    -1,  6281,    -1,    -1,    -1,
      -1,    -1,  6141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  6347,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  6268,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,  6284,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,   135,    -1,   137,   138,   139,   140,   141,
    6409,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   525,   526,   527,    -1,    -1,    -1,    -1,
      -1,    -1,   534,   535,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   534,   535,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,   535,
       3,    -1,     5,     6,    -1,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   525,   526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   534,   535,     3,    -1,     5,     6,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   534,   535,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   535,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    -1,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
     158,   159,   160,   161,    -1,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,    -1,    -1,    -1,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,    -1,   250,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,    -1,   291,    -1,   293,   294,   295,   296,    -1,
      -1,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
      -1,   339,    -1,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,    -1,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
      -1,   429,    -1,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,    -1,   452,    -1,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
      -1,   479,   480,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   509,   510,   511,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,   535,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,    -1,   158,   159,   160,   161,
      -1,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,    -1,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,    -1,   291,
      -1,   293,   294,   295,   296,    -1,    -1,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,    -1,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,    -1,   429,    -1,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,    -1,
     452,    -1,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,    -1,   479,   480,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,    -1,     3,    -1,     5,
       6,    -1,     8,     9,    10,    11,    12,   509,   510,   511,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,   535,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   513,    -1,   515,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,   515,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,
      -1,     3,    -1,     5,     6,   534,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,   177,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,   247,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,   448,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,
       5,     6,   534,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    36,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,   513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    36,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,
      -1,    -1,     3,    -1,     5,     6,   534,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,    -1,
      -1,   532,   533,   534,     3,    -1,     5,     6,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,   527,    -1,
      -1,     3,    -1,     5,     6,   534,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,
       5,     6,   534,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,   513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,
      -1,    -1,     3,    -1,     5,     6,   534,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,   177,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,
      -1,     5,     6,   534,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,   447,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,   465,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,   513,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,
     534,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,
      -1,    -1,    -1,     3,    -1,     5,     6,   534,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,   465,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,
       3,    -1,     5,     6,   534,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
     433,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
     513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,     5,
       6,   534,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,   433,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,    -1,
      -1,     3,    -1,     5,     6,   534,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,    -1,
       5,     6,   534,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,   433,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
     465,   466,   467,   468,   469,   470,   471,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,   513,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,   534,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,   433,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,   465,   466,   467,
     468,   469,   470,   471,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,
      -1,    -1,     3,    -1,     5,     6,   534,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,   433,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,   465,   466,   467,   468,   469,   470,
     471,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,   513,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   525,   526,    -1,    -1,    -1,     3,
      -1,     5,     6,   534,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,   433,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   525,   526,    -1,    -1,    -1,     3,    -1,     5,     6,
     534,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,    -1,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,   465,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,   513,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,
      -1,    -1,    -1,     3,    -1,     5,     6,   534,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,   433,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,   471,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   525,   526,     3,    -1,     5,
       6,    -1,     8,     9,   534,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,   433,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,
     526,     3,    -1,     5,     6,    -1,     8,     9,   534,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,
      -1,     8,     9,    -1,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,     5,     6,    -1,     8,     9,    -1,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,   309,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,   515,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    66,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,   433,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,   471,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,
     527,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,   434,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
     512,    -1,    -1,   515,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   395,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,   434,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,   515,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,   309,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,   434,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   534,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   534,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    13,    -1,    -1,   534,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      -1,    -1,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,    -1,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,    -1,    -1,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,    -1,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,   272,   273,    -1,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,   313,    -1,   315,   316,   317,   318,
      -1,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,    -1,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,    -1,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,    -1,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,    -1,   482,   483,   484,   485,   486,   487,    -1,
     489,    -1,    -1,    -1,    -1,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
      -1,   510,   511,    -1,   513,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,     3,    -1,     5,     6,    -1,    -1,    -1,    10,
      11,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,    -1,   186,    -1,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,    -1,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,   292,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,    -1,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
       3,    -1,     5,     6,    -1,    -1,    -1,    10,    11,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    -1,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,    -1,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,    -1,   186,    -1,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
      -1,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,    -1,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,    -1,   291,   292,
     293,   294,   295,   296,   297,    -1,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,    -1,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,   334,   335,   336,   337,    -1,   339,    -1,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,    -1,   429,   430,   431,   432,
     433,   434,   435,   436,   437,   438,   439,   440,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
     473,   474,   475,   476,   477,    -1,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   509,   510,   511,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   522,   523,   524,   525,   526,   527,   528,
     529,   530,     3,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   522,   523,   524,   525,   526,   527,   528,   529,   530,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   522,   523,   524,
     525,   526,   527,   528,   529,   530,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   522,   523,   524,   525,   526,
     527,   528,   529,   530,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   527,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     527,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   527,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,   314,   315,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,   480,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,   527,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    -1,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    -1,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,    -1,   158,   159,   160,   161,    -1,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,    -1,    -1,    -1,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,    -1,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,    -1,   291,    -1,
     293,   294,   295,   296,    -1,    -1,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,   314,   315,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,    -1,   339,    -1,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,    -1,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,    -1,   429,    -1,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,    -1,   452,
      -1,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,    -1,   479,   480,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   509,   510,   511,     3,
      -1,     5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,
      -1,    -1,    -1,    -1,   527,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,   308,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
       5,     6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,
      -1,   525,   526,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,   308,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,     5,
       6,    -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,
     525,   526,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,   308,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,     5,     6,
      -1,    -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,   525,
     526,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,   308,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    11,    -1,    -1,    -1,    -1,   525,   526,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,   177,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   525,   526,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    33,    34,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,   512,     3,    -1,     5,     6,    -1,    -1,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   439,   440,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     471,   472,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    66,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,   433,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,   471,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,     5,     6,    -1,     8,     9,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,   106,   107,    -1,    -1,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,   106,   107,    -1,    -1,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
     106,   107,    -1,    -1,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,   471,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,   106,
     107,    -1,    -1,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,   186,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,     6,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
     308,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,   106,   107,    -1,
      -1,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    79,    -1,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,   100,   101,
     102,   103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
     212,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,   250,   251,
     252,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,   295,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,   436,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
     482,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,   100,   101,   102,
     103,    -1,    -1,   106,   107,    -1,    -1,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,   212,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,   250,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,   295,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,   436,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,   482,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    79,    -1,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,   212,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,   250,   251,   252,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,   295,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,   436,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,   482,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,   100,   101,   102,   103,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,   212,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,   250,   251,   252,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
     295,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,   436,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,   482,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,   295,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,
     107,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,   212,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,   250,   251,   252,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,   295,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
     407,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,   436,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,   482,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    79,    -1,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,   212,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,   250,   251,   252,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,   295,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,   436,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,   482,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,   212,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,   250,   251,   252,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,   295,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,   436,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,   482,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    79,
      -1,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
     100,   101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,   212,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,   251,   252,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,   295,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,   436,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,   482,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,   295,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    -1,    -1,    80,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,   173,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,   465,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
     173,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,   252,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,   465,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    99,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,   183,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    99,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,   183,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,   173,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,   465,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    99,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,   395,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,   107,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,   309,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,   434,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,   173,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,   434,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    99,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,   309,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,   434,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,   309,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,   471,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,   471,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
     309,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,   309,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,   434,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    38,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      38,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,    -1,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,   188,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    -1,    49,    50,    51,    52,    53,    -1,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    77,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
      -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,   185,
      -1,   187,   188,   189,    -1,   191,   192,   193,   194,   195,
      -1,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,    -1,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,
     226,    -1,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,    -1,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,    -1,   293,   294,    -1,
     296,    -1,   298,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,    -1,   319,    -1,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,   338,   339,   340,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,    -1,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,    -1,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,    -1,   431,   432,    -1,    -1,   435,
      -1,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,   451,   452,   453,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,   478,   479,    -1,   481,    -1,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    -1,    49,    50,    51,    52,    53,    -1,    55,    56,
      -1,    58,    59,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    -1,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    81,    82,    83,    84,    85,    86,
      -1,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    -1,   121,    -1,   123,   124,   125,   126,
     127,   128,   129,    -1,   131,   132,   133,   134,    -1,    -1,
     137,   138,   139,   140,   141,    -1,   143,   144,   145,   146,
      -1,   148,   149,   150,   151,    -1,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,    -1,   166,
     167,   168,   169,   170,    -1,   172,    -1,   174,   175,    -1,
      -1,    -1,   179,   180,   181,   182,    -1,   184,   185,    -1,
     187,   188,   189,    -1,   191,   192,   193,   194,   195,    -1,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,   206,
     207,   208,   209,    -1,   211,    -1,   213,   214,   215,   216,
     217,   218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,
      -1,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,    -1,
      -1,   248,   249,    -1,   251,    -1,    -1,   254,   255,   256,
      -1,    -1,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    -1,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,    -1,   293,   294,    -1,   296,
      -1,   298,   299,   300,   301,   302,   303,    -1,   305,   306,
     307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,
     317,    -1,   319,    -1,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,    -1,    -1,   335,   336,
     337,   338,   339,   340,   341,   342,   343,    -1,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,    -1,   362,   363,   364,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,    -1,   379,   380,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,   392,   393,   394,    -1,   396,
     397,   398,   399,   400,    -1,   402,   403,   404,   405,   406,
      -1,   408,   409,   410,   411,    -1,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,
     437,   438,   439,   440,   441,   442,    -1,   444,   445,   446,
      -1,    -1,   449,   450,   451,   452,   453,    -1,   455,   456,
     457,   458,   459,   460,   461,   462,   463,    -1,    -1,   466,
     467,   468,   469,   470,    -1,    -1,   473,   474,   475,   476,
     477,   478,   479,    -1,   481,    -1,   483,   484,   485,   486,
      -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   506,
     507,   508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    50,    51,    52,    53,    -1,    55,    56,    -1,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    -1,    73,    74,    75,    76,    77,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      88,    89,    90,    91,    -1,    93,    94,    95,    96,    97,
      98,    -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   111,   112,   113,   114,   115,   116,   117,
     118,   119,    -1,   121,    -1,   123,   124,   125,   126,   127,
     128,   129,    -1,   131,   132,   133,   134,    -1,    -1,   137,
     138,   139,   140,   141,    -1,   143,   144,   145,   146,    -1,
     148,   149,   150,   151,    -1,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,    -1,   164,    -1,   166,   167,
     168,   169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,
      -1,   179,   180,   181,   182,    -1,   184,   185,    -1,   187,
     188,   189,    -1,   191,   192,   193,   194,   195,    -1,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,   206,   207,
     208,   209,    -1,   211,    -1,   213,   214,   215,   216,   217,
     218,   219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,    -1,    -1,
     248,   249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,
      -1,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,    -1,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,    -1,   293,   294,    -1,   296,    -1,
     298,   299,   300,   301,   302,   303,    -1,   305,   306,   307,
      -1,    -1,   310,   311,   312,    -1,    -1,   315,   316,   317,
      -1,   319,    -1,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    -1,    -1,   335,   336,   337,
     338,   339,   340,   341,   342,   343,    -1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
      -1,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,    -1,   396,   397,
     398,   399,   400,    -1,   402,   403,   404,   405,   406,    -1,
     408,   409,   410,   411,    -1,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,   425,   426,   427,
     428,   429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,
     438,   439,   440,   441,   442,    -1,   444,   445,   446,    -1,
      -1,   449,   450,   451,   452,   453,    -1,   455,   456,   457,
     458,   459,   460,   461,   462,   463,    -1,    -1,   466,   467,
     468,   469,   470,    -1,    -1,   473,   474,   475,   476,   477,
     478,   479,    -1,   481,    -1,   483,   484,   485,   486,    -1,
      -1,   489,    -1,    -1,   492,   493,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    50,    51,    52,    53,    -1,    55,    56,    -1,    58,
      59,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    -1,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    81,    82,    83,    84,    85,    86,    -1,    88,
      89,    90,    91,    -1,    93,    94,    95,    96,    97,    98,
      -1,    -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   111,   112,   113,   114,   115,   116,   117,   118,
     119,    -1,   121,    -1,   123,   124,   125,   126,   127,   128,
     129,    -1,   131,   132,   133,   134,    -1,    -1,   137,   138,
     139,   140,   141,    -1,   143,   144,   145,   146,    -1,   148,
     149,   150,   151,    -1,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,    -1,   166,   167,   168,
     169,   170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,
     179,   180,   181,   182,    -1,   184,   185,    -1,   187,   188,
     189,    -1,   191,   192,   193,   194,   195,    -1,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,   206,   207,   208,
     209,    -1,   211,    -1,   213,   214,   215,   216,   217,   218,
     219,    -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,    -1,    -1,   248,
     249,    -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      -1,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,    -1,   293,   294,    -1,   296,    -1,   298,
     299,   300,   301,   302,   303,    -1,   305,   306,   307,    -1,
      -1,   310,   311,   312,    -1,    -1,   315,   316,   317,    -1,
     319,    -1,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,    -1,    -1,   335,   336,   337,   338,
     339,   340,   341,   342,   343,    -1,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,    -1,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,    -1,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   393,   394,    -1,   396,   397,   398,
     399,   400,    -1,   402,   403,   404,   405,   406,    -1,   408,
     409,   410,   411,    -1,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,   427,   428,
     429,    -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,
     439,   440,   441,   442,    -1,   444,   445,   446,    -1,    -1,
     449,   450,   451,   452,   453,    -1,   455,   456,   457,   458,
     459,   460,   461,   462,   463,    -1,    -1,   466,   467,   468,
     469,   470,    -1,    -1,   473,   474,   475,   476,   477,   478,
     479,    -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,
     489,    -1,    -1,   492,   493,   494,   495,   496,   497,   498,
     499,   500,   501,   502,   503,   504,   505,   506,   507,   508,
     509,   510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      50,    51,    52,    53,    -1,    55,    56,    -1,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    -1,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    88,    89,
      90,    91,    -1,    93,    94,    95,    96,    97,    98,    -1,
      -1,   101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   111,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,    -1,   123,   124,   125,   126,   127,   128,   129,
      -1,   131,   132,   133,   134,    -1,    -1,   137,   138,   139,
     140,   141,    -1,   143,   144,   145,   146,    -1,   148,   149,
     150,   151,    -1,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,    -1,   166,   167,   168,   169,
     170,    -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,
     180,   181,   182,    -1,   184,   185,    -1,   187,   188,   189,
      -1,   191,   192,   193,   194,   195,    -1,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,   206,   207,   208,   209,
      -1,   211,    -1,   213,   214,   215,   216,   217,   218,   219,
      -1,   221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
      -1,   251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,    -1,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,    -1,   293,   294,    -1,   296,    -1,   298,   299,
     300,   301,   302,   303,    -1,   305,   306,   307,    -1,    -1,
     310,   311,   312,    -1,    -1,   315,   316,   317,    -1,   319,
      -1,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,    -1,    -1,   335,   336,   337,   338,   339,
     340,   341,   342,   343,    -1,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,    -1,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,    -1,   396,   397,   398,   399,
     400,    -1,   402,   403,   404,   405,   406,    -1,   408,   409,
     410,   411,    -1,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
      -1,   431,   432,    -1,    -1,   435,    -1,   437,   438,   439,
     440,   441,   442,    -1,   444,   445,   446,    -1,    -1,   449,
     450,   451,   452,   453,    -1,   455,   456,   457,   458,   459,
     460,   461,   462,   463,    -1,    -1,   466,   467,   468,   469,
     470,    -1,    -1,   473,   474,   475,   476,   477,   478,   479,
      -1,   481,    -1,   483,   484,   485,   486,    -1,    -1,   489,
      -1,    -1,   492,   493,   494,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    50,
      51,    52,    53,    -1,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,
      81,    82,    83,    84,    85,    86,    -1,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,    -1,
     101,   102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,
     181,   182,    -1,   184,   185,    -1,   187,   188,   189,    -1,
     191,   192,   193,   194,   195,    -1,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,    -1,   213,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,   249,    -1,
     251,    -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,    -1,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,    -1,   293,   294,    -1,   296,    -1,   298,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,   338,   339,   340,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,    -1,   379,   380,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,    -1,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,   428,   429,    -1,
     431,   432,    -1,    -1,   435,    -1,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
     451,   452,   453,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,   478,   479,    -1,
     481,    -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   509,   510,
     511,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    -1,    49,    50,    51,
      52,    53,    -1,    55,    56,    -1,    58,    59,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      -1,    73,    74,    75,    76,    77,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    88,    89,    90,    91,
      -1,    93,    94,    95,    96,    97,    98,    -1,    -1,   101,
     102,   103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
     112,   113,   114,   115,   116,   117,   118,   119,    -1,   121,
      -1,   123,   124,   125,   126,   127,   128,   129,    -1,   131,
     132,   133,   134,    -1,    -1,   137,   138,   139,   140,   141,
      -1,   143,   144,   145,   146,    -1,   148,   149,   150,   151,
      -1,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,    -1,   166,   167,   168,   169,   170,    -1,
     172,    -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,
     182,    -1,   184,   185,    -1,   187,   188,   189,    -1,   191,
     192,   193,   194,   195,    -1,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,   206,   207,   208,   209,    -1,   211,
      -1,   213,   214,   215,   216,   217,   218,   219,    -1,   221,
      -1,   223,    -1,    -1,   226,    -1,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,    -1,    -1,   248,   249,    -1,   251,
      -1,    -1,   254,   255,   256,    -1,    -1,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,    -1,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
      -1,   293,   294,    -1,   296,    -1,   298,   299,   300,   301,
     302,   303,    -1,   305,   306,   307,    -1,    -1,   310,   311,
     312,    -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,    -1,    -1,   335,   336,   337,   338,   339,   340,   341,
     342,   343,    -1,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,    -1,   379,   380,   381,
     382,   383,   384,   385,   386,   387,   388,   389,   390,   391,
     392,   393,   394,    -1,   396,   397,   398,   399,   400,    -1,
     402,   403,   404,   405,   406,    -1,   408,   409,   410,   411,
      -1,   413,   414,   415,   416,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   428,   429,    -1,   431,
     432,    -1,    -1,   435,    -1,   437,   438,   439,   440,   441,
     442,    -1,   444,   445,   446,    -1,    -1,   449,   450,   451,
     452,   453,    -1,   455,   456,   457,   458,   459,   460,   461,
     462,   463,    -1,    -1,   466,   467,   468,   469,   470,    -1,
      -1,   473,   474,   475,   476,   477,   478,   479,    -1,   481,
      -1,   483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,
     492,   493,   494,   495,   496,   497,   498,   499,   500,   501,
     502,   503,   504,   505,   506,   507,   508,   509,   510,   511,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    50,    51,    52,
      53,    -1,    55,    56,    -1,    58,    59,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    -1,    -1,    -1,    81,    82,
      83,    84,    85,    86,    -1,    88,    89,    90,    91,    -1,
      93,    94,    95,    96,    97,    98,    -1,    -1,   101,   102,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,
     113,   114,   115,   116,   117,   118,   119,    -1,   121,    -1,
     123,   124,   125,   126,   127,   128,   129,    -1,   131,   132,
     133,   134,    -1,    -1,   137,   138,   139,   140,   141,    -1,
     143,   144,   145,   146,    -1,   148,   149,   150,   151,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,    -1,   166,   167,   168,   169,   170,    -1,   172,
      -1,   174,   175,    -1,    -1,    -1,   179,   180,   181,   182,
      -1,   184,   185,    -1,   187,   188,   189,    -1,   191,   192,
     193,   194,   195,    -1,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,   206,   207,   208,   209,    -1,   211,    -1,
     213,   214,   215,   216,   217,   218,   219,    -1,   221,    -1,
     223,    -1,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,
      -1,   254,   255,   256,    -1,    -1,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,    -1,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,    -1,
     293,   294,    -1,   296,    -1,   298,   299,   300,   301,   302,
     303,    -1,   305,   306,   307,    -1,    -1,   310,   311,   312,
      -1,    -1,   315,   316,   317,    -1,   319,    -1,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
      -1,    -1,   335,   336,   337,   338,   339,   340,   341,   342,
     343,    -1,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,    -1,   379,   380,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   392,
     393,   394,    -1,   396,   397,   398,   399,   400,    -1,   402,
     403,   404,   405,   406,    -1,   408,   409,   410,   411,    -1,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,   425,   426,   427,   428,   429,    -1,   431,   432,
      -1,    -1,   435,    -1,   437,   438,   439,   440,   441,   442,
      -1,   444,   445,   446,    -1,    -1,   449,   450,   451,   452,
     453,    -1,   455,   456,   457,   458,   459,   460,   461,   462,
     463,    -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,
     473,   474,   475,   476,   477,   478,   479,    -1,   481,    -1,
     483,   484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,
      44,    45,    46,    47,    -1,    49,    50,    51,    52,    53,
      -1,    55,    56,    -1,    58,    59,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    -1,    73,
      74,    75,    76,    77,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    88,    89,    90,    91,    -1,    93,
      94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,    -1,   121,    -1,   123,
     124,   125,   126,   127,   128,   129,    -1,   131,   132,   133,
     134,    -1,    -1,   137,   138,   139,   140,   141,    -1,   143,
     144,   145,   146,    -1,   148,   149,   150,   151,    -1,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,    -1,   166,   167,   168,   169,   170,    -1,   172,    -1,
     174,   175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,
     184,   185,    -1,   187,   188,   189,    -1,   191,   192,   193,
     194,   195,    -1,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,   206,   207,   208,   209,    -1,   211,    -1,   213,
     214,   215,   216,   217,   218,   219,    -1,   221,    -1,   223,
      -1,    -1,   226,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,
     254,   255,   256,    -1,    -1,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,    -1,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,    -1,   293,
     294,    -1,   296,    -1,   298,   299,   300,   301,   302,   303,
      -1,   305,   306,   307,    -1,    -1,   310,   311,   312,    -1,
      -1,   315,   316,   317,    -1,   319,    -1,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,    -1,
      -1,   335,   336,   337,   338,   339,   340,   341,   342,   343,
      -1,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,    -1,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    -1,   396,   397,   398,   399,   400,    -1,   402,   403,
     404,   405,   406,    -1,   408,   409,   410,   411,    -1,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,    -1,   431,   432,    -1,
      -1,   435,    -1,   437,   438,   439,   440,   441,   442,    -1,
     444,   445,   446,    -1,    -1,   449,   450,   451,   452,   453,
      -1,   455,   456,   457,   458,   459,   460,   461,   462,   463,
      -1,    -1,   466,   467,   468,   469,   470,    -1,    -1,   473,
     474,   475,   476,   477,   478,   479,    -1,   481,    -1,   483,
     484,   485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    50,    51,    52,    53,    -1,
      55,    56,    -1,    58,    59,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    -1,    73,    74,
      75,    76,    77,    -1,    -1,    -1,    81,    82,    83,    84,
      85,    86,    -1,    88,    89,    90,    91,    -1,    93,    94,
      95,    96,    97,    98,    -1,    -1,   101,   102,   103,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   111,   112,   113,   114,
     115,   116,   117,   118,   119,    -1,   121,    -1,   123,   124,
     125,   126,   127,   128,   129,    -1,   131,   132,   133,   134,
      -1,    -1,   137,   138,   139,   140,   141,    -1,   143,   144,
     145,   146,    -1,   148,   149,   150,   151,    -1,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
      -1,   166,   167,   168,   169,   170,    -1,   172,    -1,   174,
     175,    -1,    -1,    -1,   179,   180,   181,   182,    -1,   184,
     185,    -1,   187,    -1,   189,    -1,   191,   192,   193,   194,
     195,    -1,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,   206,   207,   208,   209,    -1,   211,    -1,   213,   214,
     215,   216,   217,   218,   219,    -1,   221,    -1,   223,    -1,
      -1,   226,    -1,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,    -1,    -1,   248,   249,    -1,   251,    -1,    -1,   254,
     255,   256,    -1,    -1,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    -1,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    -1,   293,   294,
      -1,   296,    -1,   298,   299,   300,   301,   302,   303,    -1,
     305,   306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,
     315,   316,   317,    -1,   319,    -1,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,    -1,    -1,
     335,   336,   337,   338,   339,   340,   341,   342,   343,    -1,
     345,   346,   347,   348,   349,   350,   351,   352,   353,    -1,
     355,   356,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,    -1,   379,   380,   381,   382,   383,   384,
      -1,   386,   387,   388,   389,   390,   391,   392,   393,   394,
      -1,   396,   397,   398,   399,   400,    -1,   402,   403,   404,
     405,   406,    -1,   408,   409,   410,   411,    -1,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,    -1,   431,   432,    -1,    -1,
     435,    -1,   437,   438,   439,   440,   441,   442,    -1,   444,
     445,   446,    -1,    -1,   449,   450,   451,   452,   453,    -1,
     455,   456,   457,   458,   459,   460,   461,   462,   463,    -1,
      -1,   466,   467,   468,   469,   470,    -1,    -1,   473,   474,
     475,   476,   477,   478,   479,    -1,   481,    -1,   483,   484,
     485,   486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,   213,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,   480,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,   297,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,   434,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,   171,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
     171,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    53,    54,    55,    56,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,   117,   118,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,   169,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,   218,   219,    -1,
     221,    -1,   223,   224,   225,   226,   227,   228,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,   300,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,   445,   446,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,   479,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511,    -1,    -1,    -1,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    -1,    53,    54,    55,
      56,    -1,    58,    59,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    -1,    73,    74,    75,
      76,    -1,    -1,    79,    -1,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    -1,    93,    94,    95,
      96,    97,    98,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,   107,    -1,    -1,    -1,   111,   112,   113,   114,   115,
     116,   117,   118,   119,    -1,   121,    -1,   123,   124,   125,
     126,   127,   128,   129,    -1,   131,   132,   133,   134,    -1,
      -1,   137,   138,   139,   140,   141,    -1,   143,   144,   145,
     146,    -1,   148,   149,   150,   151,    -1,   153,   154,   155,
     156,    -1,   158,   159,   160,   161,    -1,    -1,   164,    -1,
     166,   167,   168,   169,   170,    -1,   172,    -1,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,    -1,   184,    -1,
      -1,    -1,   188,   189,    -1,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
     206,   207,   208,   209,    -1,   211,   212,    -1,   214,   215,
     216,   217,   218,   219,    -1,   221,    -1,   223,   224,   225,
     226,   227,   228,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,   240,   241,   242,   243,   244,   245,
      -1,    -1,   248,    -1,   250,   251,   252,    -1,   254,   255,
     256,    -1,    -1,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,    -1,   291,    -1,   293,   294,   295,
     296,    -1,    -1,   299,   300,   301,   302,   303,    -1,   305,
     306,   307,    -1,    -1,   310,   311,   312,    -1,    -1,   315,
     316,    -1,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,    -1,    -1,   335,
     336,   337,    -1,   339,    -1,   341,   342,   343,    -1,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,   382,   383,    -1,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,    -1,
     396,   397,   398,   399,   400,    -1,   402,   403,    -1,   405,
     406,   407,   408,   409,   410,   411,    -1,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,    -1,   429,    -1,   431,   432,    -1,    -1,   435,
     436,   437,   438,   439,   440,   441,   442,    -1,   444,   445,
     446,    -1,    -1,   449,   450,    -1,   452,    -1,    -1,   455,
     456,   457,   458,   459,   460,   461,   462,   463,    -1,    -1,
     466,   467,   468,   469,   470,    -1,    -1,   473,   474,   475,
     476,   477,    -1,   479,    -1,   481,   482,   483,   484,   485,
     486,    -1,    -1,   489,    -1,    -1,   492,   493,   494,   495,
     496,   497,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   509,   510,   511,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      41,    42,    -1,    44,    45,    46,    47,    48,    49,    50,
      51,    -1,    -1,    54,    -1,    -1,    -1,    58,    59,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    -1,    -1,
      71,    -1,    73,    74,    75,    76,    -1,    -1,    79,    -1,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    -1,    93,    94,    95,    96,    97,    98,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,   107,    -1,    -1,    -1,
     111,   112,   113,   114,   115,   116,    -1,    -1,   119,    -1,
     121,    -1,   123,   124,   125,   126,   127,   128,   129,    -1,
     131,   132,   133,   134,    -1,    -1,   137,   138,   139,   140,
     141,    -1,   143,   144,   145,   146,    -1,   148,   149,   150,
     151,    -1,   153,   154,   155,   156,    -1,   158,   159,   160,
     161,    -1,    -1,   164,    -1,   166,   167,   168,    -1,   170,
      -1,   172,    -1,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,    -1,   184,    -1,    -1,    -1,   188,   189,    -1,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,   206,   207,   208,   209,    -1,
     211,   212,    -1,   214,   215,   216,   217,    -1,    -1,    -1,
      -1,    -1,   223,   224,   225,   226,   227,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,   240,
     241,   242,   243,   244,   245,    -1,    -1,   248,    -1,   250,
     251,   252,    -1,   254,   255,   256,    -1,    -1,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,   277,    -1,   279,    -1,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,    -1,
     291,    -1,   293,   294,   295,   296,    -1,    -1,   299,    -1,
     301,   302,   303,    -1,   305,   306,   307,    -1,    -1,   310,
     311,   312,    -1,    -1,   315,   316,    -1,   318,   319,   320,
      -1,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,    -1,    -1,   335,   336,   337,    -1,   339,    -1,
     341,   342,   343,    -1,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    -1,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,   382,   383,    -1,   385,   386,   387,   388,   389,   390,
     391,   392,   393,   394,    -1,   396,   397,   398,   399,   400,
      -1,   402,   403,    -1,   405,   406,   407,   408,   409,    -1,
     411,    -1,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   427,    -1,   429,    -1,
     431,   432,    -1,    -1,   435,   436,   437,   438,   439,   440,
     441,   442,    -1,   444,    -1,    -1,    -1,    -1,   449,   450,
      -1,   452,    -1,    -1,   455,   456,   457,   458,   459,   460,
     461,   462,   463,    -1,    -1,   466,   467,   468,   469,   470,
      -1,    -1,   473,   474,   475,   476,   477,    -1,    -1,    -1,
     481,   482,   483,   484,   485,   486,    -1,    -1,   489,    -1,
      -1,   492,   493,   494,   495,   496,   497,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   509,   510,
     511
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    20,    31,    33,    34,    51,    61,    73,    75,    76,
      82,    84,    97,    99,   116,   119,   134,   136,   140,   147,
     156,   158,   165,   183,   200,   254,   255,   260,   275,   294,
     333,   342,   357,   363,   364,   366,   371,   377,   380,   387,
     394,   395,   402,   406,   417,   434,   455,   467,   473,   478,
     491,   515,   517,   518,   519,   520,   521,   534,   541,   542,
     543,   544,   549,   550,   556,   557,   559,   560,   561,   562,
     564,   567,   579,   584,   585,   588,   589,   590,   610,   613,
     614,   629,   680,   683,   684,   687,   690,   691,   692,   700,
     707,   709,   710,   713,   716,   717,   721,   730,   734,   735,
     736,   739,   741,   742,   743,   744,   752,   754,   774,   778,
     780,   781,   791,   793,   800,   801,   804,   805,   806,   807,
     808,   817,   819,   821,   824,   828,   829,   839,   840,   845,
     850,   861,   893,   896,   897,   898,   903,   906,   908,   910,
     912,   913,   917,   918,   921,   923,   924,   928,   929,   930,
     933,   934,   935,   936,   937,   944,   946,   947,   948,   949,
     955,   957,   958,   964,   965,   966,   969,   970,   971,   972,
     974,   975,   977,   978,   980,   981,   983,   995,   997,  1000,
    1002,  1003,  1012,  1014,  1019,  1024,  1034,  1038,  1039,  1040,
    1041,  1042,  1043,  1049,  1085,   449,   494,   950,    28,    79,
      96,   114,   120,   138,   151,   160,   173,   179,   186,   206,
     244,   266,   310,   337,   347,   348,   351,   379,   382,   386,
     389,   396,   399,   419,   427,   432,   434,   437,   442,   452,
     457,   471,   484,   706,   950,     3,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    30,    31,    32,    40,    41,
      42,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    58,    59,    60,    61,    62,    63,
      64,    67,    68,    69,    70,    71,    73,    74,    75,    76,
      77,    79,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    93,    94,    95,    96,    97,    98,   100,
     101,   102,   103,   107,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   121,   123,   124,   125,   126,   127,   128,
     129,   131,   132,   133,   134,   137,   138,   139,   140,   141,
     143,   144,   145,   146,   148,   149,   150,   151,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   164,   166,
     167,   168,   169,   170,   172,   174,   175,   176,   178,   179,
     180,   181,   182,   184,   185,   187,   188,   189,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   202,   203,
     204,   205,   206,   207,   208,   209,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   221,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   248,
     249,   250,   251,   252,   254,   255,   256,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     293,   294,   295,   296,   298,   299,   300,   301,   302,   303,
     305,   306,   307,   310,   311,   312,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   362,
     363,   364,   365,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   396,   397,   398,   399,   400,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   429,   431,   432,   435,   436,   437,   438,   439,
     440,   441,   442,   444,   445,   446,   449,   450,   451,   452,
     453,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     466,   467,   468,   469,   470,   473,   474,   475,   476,   477,
     478,   479,   481,   482,   483,   484,   485,   486,   489,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   511,  1153,
    1246,  1258,  1259,  1263,  1264,  1265,     3,    29,  1035,  1243,
    1258,  1263,   482,   534,   988,   308,   343,   950,    54,   534,
     621,    23,    41,    66,    79,   114,   120,   138,   151,   160,
     173,   182,   186,   256,   310,   313,   337,   351,   379,   389,
     399,   419,   427,   437,   439,   441,   442,   457,   465,   468,
     471,   630,   689,   796,   851,   862,    29,   342,  1243,  1035,
      29,   336,   397,   439,   441,     6,   243,   904,   905,  1249,
      23,    28,    66,    79,    96,   114,   138,   151,   160,   173,
     179,   186,   206,   266,   310,   323,   337,   348,   351,   379,
     382,   386,   389,   396,   399,   419,   427,   434,   437,   442,
     450,   452,   457,   471,   484,   706,   809,   811,   812,   950,
    1243,    99,   482,   534,   684,   687,   690,   983,   996,  1000,
    1003,  1012,  1019,  1024,  1034,  1038,    11,    22,    29,    49,
     168,   175,   177,   201,   245,   283,   345,   365,   525,   526,
     825,   826,  1035,  1248,  1250,    29,    31,    99,   361,   395,
     830,   831,   832,  1258,   173,  1258,  1245,  1249,   434,  1052,
     825,  1258,    67,   277,   371,   379,   389,   400,   402,   406,
     445,   449,   497,   569,   570,   571,  1258,   449,  1243,   323,
     266,   534,   916,   387,  1258,    29,   400,   445,   449,   571,
     580,   581,   183,   830,   831,  1258,   343,   950,  1258,   242,
      29,   135,  1054,  1055,    93,   256,   400,   402,   449,   568,
     570,    29,   400,   445,   449,   571,   449,   309,  1097,  1098,
    1241,  1258,  1052,   527,  1258,   178,   534,   989,   534,   359,
    1044,  1045,  1243,  1044,     3,    53,    55,    56,    69,    70,
     117,   118,   139,   169,   218,   219,   221,   228,   278,   280,
     300,   356,   404,   410,   445,   446,   479,  1126,  1128,  1130,
    1132,  1134,  1136,  1137,  1138,  1140,  1141,  1142,  1144,  1145,
    1149,  1259,  1263,  1054,  1055,  1056,  1254,    12,  1255,  1256,
    1258,  1255,  1255,  1039,  1040,  1043,     0,   537,   534,   988,
     152,   220,   314,   464,  1057,  1058,  1039,  1041,  1042,   125,
     216,   268,   470,   538,    35,   954,   878,  1246,   814,  1258,
     814,  1243,   346,   814,   452,  1243,   113,   434,   866,  1246,
    1258,  1265,     3,   106,   110,   401,  1251,  1252,  1260,  1263,
    1264,  1265,    29,   195,  1241,   301,   484,    10,    17,    18,
      19,    74,   164,   522,   523,   524,   525,   526,   527,   528,
     529,   530,   900,   902,  1184,  1185,  1258,   195,  1243,   866,
    1243,    29,  1251,  1252,   866,  1243,  1243,   195,  1241,  1243,
     195,   814,  1243,   371,   402,    29,   195,  1097,  1243,   392,
    1243,   814,    29,   263,  1251,  1252,   195,  1241,   243,   122,
     226,   292,   355,   951,   952,   953,   534,   532,   536,  1210,
    1212,   512,   982,   983,   984,   985,  1260,  1241,  1243,  1258,
      28,    66,    80,    92,   114,   138,   179,   206,   244,   310,
     348,   379,   382,   427,   437,   450,   457,   809,   810,   811,
     812,  1249,   954,   999,  1003,  1012,  1019,  1024,  1038,  1241,
     270,   814,   534,   195,   814,  1243,   814,   452,   195,  1243,
     113,   434,   439,   441,  1251,  1252,   439,   441,    74,   164,
     900,   369,  1243,  1243,  1251,   195,   545,  1258,   195,  1243,
     195,   546,   814,  1243,  1243,   392,   814,   263,  1251,   359,
     396,   434,   484,   266,    96,   206,    28,    92,   179,   348,
     386,   450,   452,   456,   701,    29,  1243,  1036,   578,  1249,
    1260,   905,   270,   195,   878,   879,   195,   909,   195,  1243,
     195,   816,  1126,   452,   113,   434,   195,   865,   866,   195,
    1252,  1253,    87,   484,    74,   164,   195,   901,   902,    59,
     195,   865,   195,  1253,   195,   865,   195,  1243,   195,  1243,
     392,   909,   195,   816,   195,   263,  1253,   243,   195,   813,
     814,   195,  1242,  1243,   195,  1243,   954,   534,  1001,   630,
     996,   478,   982,   988,  1250,   826,   827,    29,   827,  1250,
     827,    29,   827,  1250,   827,   827,   827,  1250,  1248,  1248,
    1035,   827,   346,   534,   432,   534,   657,   657,   657,   308,
     447,   538,   657,   389,  1097,  1099,   538,   945,  1249,   120,
     577,  1249,   581,   578,  1249,    48,    60,   569,   571,    29,
     571,   511,   411,   311,   177,   447,   524,   536,  1249,   534,
     998,    59,   484,   982,   114,   206,   389,   432,   434,   914,
     915,  1258,    48,   511,   226,   311,   308,   177,   311,  1249,
     447,   954,   171,   822,   308,     5,     8,     9,    10,    12,
      37,    53,    55,    56,    65,    66,    69,    70,    77,    79,
     104,   105,   106,   107,   108,   109,   110,   117,   118,   120,
     157,   162,   163,   169,   185,   187,   218,   219,   221,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   238,   249,
     257,   258,   269,   278,   280,   290,   292,   297,   298,   300,
     310,   321,   338,   356,   384,   401,   410,   428,   433,   445,
     446,   451,   453,   454,   465,   471,   479,   499,   500,   501,
     502,   504,   505,   506,   507,   513,   525,   526,   527,   534,
    1039,  1129,  1132,  1135,  1136,  1137,  1139,  1140,  1141,  1144,
    1145,  1149,  1150,  1152,  1153,  1154,  1156,  1180,  1181,  1182,
    1186,  1204,  1209,  1235,  1238,  1239,  1246,  1247,  1248,  1249,
    1258,  1237,  1238,    29,   586,  1240,  1241,   400,   568,    71,
     568,    60,   952,    48,   511,   226,   953,   534,  1241,   527,
    1212,  1099,   982,   176,   990,  1150,  1189,  1044,   538,   534,
     991,   481,  1143,  1143,  1143,   534,  1131,  1131,   340,   534,
    1133,    69,    70,  1143,  1131,  1128,   515,   516,   534,  1146,
     534,  1146,    37,  1127,   534,   115,   193,   271,   274,   393,
     509,   534,  1147,  1148,   536,   815,  1131,  1237,  1213,   535,
     535,   543,   982,   992,   993,   994,  1241,    29,   135,  1053,
    1053,    59,  1053,   165,   171,   253,   304,  1061,  1063,  1064,
    1079,  1081,  1082,  1083,  1057,  1058,   177,   222,   222,  1097,
    1100,   534,    68,   288,   324,   367,   402,   534,   876,   324,
     363,   367,   402,   815,   324,   367,   402,     3,    91,   145,
     259,   324,   333,   363,   367,   402,   437,   440,   491,   579,
     582,   959,   960,   961,   962,   846,    25,   140,   324,   367,
     402,   475,   595,  1243,    25,   140,   402,   470,   563,   495,
     195,  1097,    62,    98,   161,   198,   248,   288,   292,   324,
     325,   367,   376,   385,   394,   402,   415,   424,   429,   486,
     579,   583,   882,   894,   922,   534,   863,  1212,   367,   563,
     201,   157,    25,    31,    46,    76,   133,   140,   144,   172,
     208,   288,   292,   302,   312,   324,   367,   370,   371,   402,
     475,   591,   593,   594,   724,   922,     5,   525,   526,   698,
    1250,    29,   195,  1241,   814,   814,   534,   899,   324,   402,
     536,   157,   308,   324,   367,   402,   894,   922,    25,   140,
     324,   367,   402,   201,   558,   367,   491,   515,   551,   558,
     324,   367,   402,   894,   922,   308,   324,   367,   157,    38,
      60,   112,   204,   267,   272,   288,   323,   367,   372,   396,
     402,   417,   591,   695,   696,   324,   367,   483,   724,   732,
     157,   324,   367,   402,    25,    91,   133,   140,   144,   324,
     363,   367,   402,   409,   581,   569,   201,   157,    46,   131,
     288,   367,   402,   591,   592,   324,   367,   371,   402,    89,
     132,   327,   440,   308,    25,    31,   140,   324,   367,   402,
     611,   612,   558,   171,   367,   551,   558,   157,   367,   402,
     591,  1243,   251,   122,   309,   496,   538,   951,    29,   135,
     480,   527,   535,   871,  1150,  1190,  1191,  1259,  1150,  1211,
       3,    29,    33,    34,    35,    36,    37,    38,    39,    43,
      57,    65,    66,    72,    78,    80,    92,    99,   104,   105,
     106,   108,   109,   110,   120,   122,   130,   135,   136,   142,
     147,   152,   163,   165,   171,   173,   177,   183,   186,   190,
     201,   210,   220,   222,   246,   247,   253,   257,   258,   292,
     297,   304,   308,   309,   313,   314,   334,   344,   361,   375,
     395,   401,   412,   430,   433,   434,   443,   447,   448,   454,
     464,   465,   471,   472,   480,   487,   488,   490,   491,   527,
    1244,  1261,  1263,  1264,  1265,  1266,  1210,   535,   538,   163,
     308,   454,   575,   578,   698,   986,   472,   979,   308,   878,
     534,   814,  1243,  1126,   866,   301,    74,   164,   902,   866,
     866,   171,  1126,   814,  1243,  1243,   535,   657,  1243,    72,
    1126,   292,   177,   534,   782,   551,    38,   973,  1243,   292,
     551,   495,   195,  1241,   551,   814,   814,   782,   468,   630,
     308,   171,   491,   890,   551,   292,    48,   565,   292,   457,
     731,   292,   991,    91,   324,   708,    89,   132,   327,   440,
      38,   782,   171,   195,   551,   484,   195,  1241,   195,   685,
    1241,  1241,   484,   814,    87,   547,  1246,   452,  1246,  1246,
    1243,   171,  1243,   706,    40,    54,   111,   215,   288,   391,
     157,    63,   373,   538,   548,   157,   534,   157,   551,   157,
     538,   548,   495,   157,   538,   548,   157,   538,   195,   813,
     195,   814,   195,   814,   157,   538,   548,  1253,   157,   548,
     157,   157,   548,   157,   548,   157,    89,   132,   327,   440,
     171,   157,   548,   157,   171,   195,   157,   538,   548,   157,
     538,   548,   157,   308,  1189,   434,   535,   996,   827,  1035,
     827,  1035,   827,  1035,   827,  1035,   827,  1035,  1035,  1035,
     827,  1035,   534,   658,   659,  1258,   658,    29,   114,   138,
     173,   179,   243,   244,   326,   348,   382,   389,   396,   434,
     437,   457,   835,  1240,  1253,   832,  1243,   201,   538,  1015,
    1249,   120,   578,   125,     3,   120,   256,   576,   698,  1145,
    1249,  1249,    94,   137,  1162,   103,   120,   572,   573,   575,
     698,   120,   572,  1258,  1126,  1193,    38,  1253,   547,   535,
     547,   547,   547,   251,   171,   835,  1253,   171,   387,  1258,
     578,   308,   534,  1213,   532,  1039,  1194,  1150,  1208,   534,
     534,   171,   534,   534,  1039,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   534,  1150,   534,   534,   534,   534,   534,   534,
     534,   534,   299,   646,   534,   534,   534,   534,   534,   534,
     534,   534,  1150,  1150,  1150,  1039,  1150,  1189,  1212,  1249,
     534,  1249,     3,    10,    13,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   167,   168,   169,
     170,   172,   173,   174,   175,   176,   178,   179,   180,   181,
     182,   184,   185,   187,   188,   189,   191,   192,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   221,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   272,   273,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   305,   306,   307,   309,   310,   311,   312,
     313,   315,   316,   317,   318,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   334,   335,   336,
     337,   338,   339,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   392,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   448,   449,   450,
     451,   452,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   482,
     483,   484,   485,   486,   487,   489,   494,   495,   496,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   510,   511,   513,   522,   523,   524,   525,   526,   527,
     528,   529,   530,  1184,  1186,  1188,  1262,  1267,   492,  1167,
     320,  1150,   166,  1168,   222,   538,  1050,   534,  1249,  1212,
    1050,   123,   197,   587,   538,    71,    38,   251,  1241,    95,
     372,   818,   535,   988,    35,    45,    52,    78,   196,   201,
     224,   252,   310,   313,   407,   535,   538,  1045,  1242,    38,
     534,  1189,  1248,  1143,  1143,    37,  1127,   445,   445,  1248,
    1248,   532,   532,  1248,   447,   447,   447,   534,   447,  1248,
    1244,   536,  1131,   177,  1086,    15,   524,  1210,  1257,   535,
     538,   991,  1041,  1041,  1059,  1060,  1150,  1041,   168,   283,
    1070,   240,   288,   355,   405,   470,    29,  1065,  1150,   525,
     526,  1066,  1067,  1150,  1152,  1079,  1080,  1064,  1063,  1061,
    1062,   171,  1082,   302,  1084,  1061,  1079,  1100,  1004,  1241,
    1100,    38,  1258,   402,  1189,    68,   447,   447,   389,   201,
     213,   314,   317,   404,   480,   527,   869,   870,   871,   873,
     875,   877,  1126,  1259,   447,   483,   447,   389,   447,   447,
     389,   253,   447,   371,    79,   447,   437,   568,   324,   959,
     961,   524,   963,   171,   183,   201,   377,   847,   848,    72,
      92,   292,   654,   655,    92,   120,   292,   447,    92,   447,
     120,   292,   389,    92,   133,   144,   324,   367,   779,   389,
     714,    28,    66,   138,   179,   310,   348,   382,   450,   457,
     809,   810,  1243,   157,   367,   402,   591,   308,   698,   394,
     248,   447,  1258,   447,   297,   698,   124,   223,   389,   570,
     814,   373,   402,   882,   895,   128,   535,   864,   869,   447,
     471,   437,  1241,    72,    80,    92,   153,   173,   195,   344,
     465,   637,   652,   653,  1258,    80,    92,   919,   329,   308,
     384,   386,   452,    92,   919,    32,   370,   384,   386,   452,
     384,  1241,   172,   208,   302,   814,   534,   447,   447,   194,
     534,   599,    23,   262,   437,   468,   493,   599,    92,   538,
     128,     5,     5,   324,   201,   157,   367,   402,   591,   922,
     472,   472,   289,  1126,   447,   389,   534,   900,  1243,  1241,
     447,   447,   389,   895,   128,   107,   434,   435,   931,   932,
    1098,  1241,  1258,   932,   447,   447,   782,   932,   114,   402,
     582,   447,   553,   582,   447,   447,   389,   895,   128,  1241,
     447,   447,  1241,  1128,   698,    59,   697,   698,   698,   112,
     267,   272,    59,   447,   551,   276,   389,   551,   288,   696,
     447,   447,   297,  1249,   724,   814,   447,   447,   389,   419,
     351,  1249,   351,   447,   351,   447,   351,   782,   782,   437,
    1097,   329,   329,    92,   447,   919,   389,   447,   447,   599,
     599,   814,   814,   814,   814,  1241,    47,   477,    47,    47,
     477,   447,    47,   447,   477,   389,   534,   538,   582,   471,
     740,  1252,   447,   553,   582,  1241,   447,   919,   389,   324,
     367,   355,   368,   398,   574,   951,  1190,  1190,  1191,   535,
      15,    16,   538,  1057,  1058,   533,   539,  1241,   984,  1243,
    1241,   224,  1126,   224,   308,   224,   224,   698,   814,   814,
     224,   224,   224,  1126,   224,   224,   224,   308,   447,   177,
     447,   615,   457,   534,    38,   157,   814,   783,   784,  1261,
     959,  1126,   308,   157,   711,  1243,   292,   329,   534,   552,
     796,   472,   359,   484,  1241,    29,   932,   782,   552,   157,
    1252,    99,   183,   566,   629,   691,   754,   828,   850,   955,
     157,  1249,   732,   733,   157,   308,  1249,  1252,   259,   814,
     814,   814,   814,   148,   354,   534,   740,   292,   552,  1241,
     292,   693,   695,   292,    38,   302,   329,   534,   657,   657,
     195,   688,  1241,   171,   195,   545,  1258,   534,   786,   876,
    1243,   534,   867,   867,    38,  1126,    27,    50,   217,   755,
     243,   491,   493,  1037,   391,   879,   878,  1126,  1243,   534,
     816,  1126,   865,   866,  1253,  1252,   157,   548,   157,   472,
     157,   472,   901,   902,   548,   865,  1253,   865,  1243,  1243,
    1126,   816,  1253,   740,   157,   813,   814,  1242,  1243,  1243,
     814,   535,   195,  1241,   996,  1035,  1035,  1035,  1035,  1035,
    1035,   658,   535,   538,   535,   180,   349,   383,   397,   435,
    1242,   813,   113,   399,   865,  1242,   301,   833,   834,  1258,
     865,   865,  1242,  1240,  1240,  1242,   813,   447,   184,   491,
     844,   152,   253,   737,   738,    23,   155,   384,   405,  1016,
    1097,   296,  1017,  1249,   534,  1249,   538,   535,   538,   999,
     447,  1241,  1243,  1241,   545,   830,   831,   177,   844,   831,
    1258,    28,    80,   138,   179,   244,   348,   382,   457,   809,
     810,  1189,   533,  1189,  1194,  1195,   487,  1205,  1206,  1150,
    1189,   534,  1248,  1248,     3,   115,   193,   271,   274,   393,
     509,  1196,  1197,  1249,  1189,  1189,  1150,  1223,   375,  1039,
    1040,  1223,  1227,  1234,  1223,  1223,  1150,  1152,  1190,  1227,
    1230,  1231,  1150,  1231,  1223,  1150,  1223,  1223,  1189,  1248,
    1248,   535,  1150,  1150,   900,  1150,  1190,  1192,  1199,   384,
     525,   526,   534,  1151,  1152,  1186,  1200,   535,  1189,  1150,
    1192,  1201,  1150,    57,   177,   247,   448,  1150,  1189,  1202,
     135,   292,  1039,  1189,   276,  1152,  1150,  1160,  1161,  1162,
     276,  1150,  1162,   535,   538,  1248,  1147,  1126,  1150,  1150,
    1150,  1150,  1261,   256,   445,    43,   430,  1214,   814,  1150,
     534,  1039,  1203,   135,   137,   163,   228,   284,   285,   286,
     287,   291,   292,   297,   454,   466,  1198,  1228,  1150,   534,
    1150,   447,    52,   196,   201,   252,   407,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,    29,    36,   412,
    1183,   186,  1168,   384,   534,  1180,   534,   319,  1172,   182,
     256,   434,   439,   441,   468,  1051,  1241,  1239,  1086,  1190,
    1086,  1241,   449,   535,   194,   194,   548,   994,   983,   987,
    1150,   535,   266,   292,  1046,  1189,   535,   535,   532,   511,
     511,   535,   535,  1248,   533,  1248,   535,   193,   271,  1148,
     271,  1148,  1148,  1248,   274,   535,  1244,   228,   237,   246,
     385,   508,   534,  1039,  1087,  1088,  1089,  1097,  1103,  1113,
    1120,  1153,  1155,  1156,  1235,  1258,   488,  1108,  1254,   994,
     992,   538,    39,   130,   472,   859,   384,   385,   525,   526,
    1067,  1069,  1152,   405,   240,   309,   538,     5,  1068,  1248,
    1068,   384,   385,  1069,  1240,   296,   409,  1018,  1080,  1062,
     472,  1013,   120,   322,   534,  1005,  1038,    38,   472,  1258,
     534,  1020,  1021,  1022,  1258,   535,  1252,  1243,  1243,   317,
      59,  1259,   535,   871,   873,   870,   873,  1259,   314,   535,
     538,   815,  1252,  1243,  1243,  1252,  1243,  1243,  1252,   483,
    1243,  1243,   120,   575,   698,   379,   471,   830,   389,   183,
     830,   534,  1243,   297,   195,  1243,   297,  1252,  1243,  1243,
    1150,   297,  1243,  1243,    32,   370,   447,   447,  1243,   447,
     715,   878,   534,  1126,   866,    74,   164,   902,   866,   866,
     171,  1126,   814,  1243,   189,   288,   324,   367,   476,   718,
     719,   720,  1097,   447,   919,   389,   297,   124,   223,  1252,
    1243,   308,  1243,   308,   535,   538,  1251,  1253,  1243,   367,
     591,   534,   195,   637,  1243,   472,   852,   240,   292,   240,
     472,   646,   679,  1126,  1243,  1248,  1258,  1241,  1243,   251,
    1243,    29,   471,  1243,   195,  1243,   195,  1258,   386,   452,
     386,   452,   251,  1243,    29,   471,  1243,   251,   384,  1241,
      25,   140,   402,   725,   726,   727,   728,  1261,  1252,  1243,
     120,   178,   293,   472,   598,   601,   602,  1261,   270,  1243,
      76,   305,  1243,   594,   308,   447,   437,  1241,   447,   919,
     389,   128,  1243,  1243,   538,   535,   538,  1252,  1243,   925,
     926,  1261,   308,   367,   447,   748,  1252,  1243,  1243,   308,
    1097,   201,   538,   657,   657,  1212,  1252,  1243,  1243,  1251,
       3,    91,   146,   208,   331,   463,   471,   474,   554,  1252,
    1243,  1243,   308,   367,  1252,  1243,   367,   402,   591,   695,
     698,   814,  1243,   698,   814,  1243,   698,  1252,  1243,   402,
    1252,  1243,  1243,   120,   605,  1250,  1242,  1242,  1252,   890,
    1243,  1242,  1243,   367,   402,   591,   592,  1241,  1241,  1243,
    1243,  1243,  1243,  1252,  1243,    25,    31,   140,   324,   367,
     402,   324,   367,   402,   782,   367,   402,   367,   402,   367,
     922,  1112,  1258,   195,   792,  1258,   195,  1258,  1249,  1252,
    1243,  1243,  1249,  1243,   925,    25,   140,   612,   399,  1251,
     367,   402,   591,  1243,  1243,  1243,   447,   447,    85,   462,
     355,   538,  1057,  1057,  1057,  1150,  1150,   480,  1191,   535,
    1150,  1211,   979,   297,   820,  1249,    38,   820,   138,   814,
     820,   820,   224,   472,   472,   820,   820,   820,   243,   820,
     820,   820,   814,   350,   616,   616,   206,   434,   753,  1150,
    1126,   814,   535,   538,   524,   643,  1261,  1243,    63,   177,
     389,   483,   712,   719,   720,   157,   302,   252,   631,   633,
     635,   637,   649,   652,    26,   201,   379,   431,   554,   555,
     171,  1243,   484,  1241,    38,   749,   435,   890,   545,  1258,
     565,   630,   862,  1243,   173,   814,   534,   681,   682,  1155,
    1258,   351,  1249,   782,   782,   782,   782,   534,   782,  1110,
    1111,  1112,   399,   157,   534,   157,   157,   156,  1038,   814,
     302,   631,  1258,   472,   674,   491,   600,   292,    38,   657,
    1249,   292,   308,     3,   787,   788,   782,    27,   535,   868,
     869,   874,    38,   243,   376,   450,   490,   880,   881,   882,
     883,   880,   308,   243,   302,   125,   216,   455,   470,   756,
     757,  1243,   192,   192,   171,   548,    38,   551,   172,   967,
     968,   548,   548,   813,   814,  1243,   814,  1243,   548,   548,
     548,   548,   243,   548,   399,   171,   548,   548,   308,   548,
     292,   535,   659,   201,   201,   201,   201,   201,   495,  1242,
     698,   699,   538,   536,   186,   836,   837,  1252,    59,   841,
     842,  1261,   447,   534,   177,   155,   405,   155,   405,   384,
     470,   273,  1248,  1147,   573,  1126,  1252,   491,   686,   308,
     836,   548,   177,   878,   814,  1126,   866,   301,   866,   866,
    1126,   814,  1243,   535,   533,   533,   538,  1150,   142,  1206,
    1207,    38,   535,  1150,   535,   535,   535,   177,   535,   535,
     512,  1224,  1225,   491,   493,  1229,  1126,  1225,   535,    21,
     297,   538,  1233,   314,  1236,   538,   539,   477,   535,   535,
      21,   297,   538,  1232,  1232,   538,   535,  1227,   538,   535,
     535,   535,   535,   538,   538,   535,   334,   535,   535,   534,
    1151,  1151,  1189,    13,    17,    18,    19,   201,   224,   310,
     522,   523,   524,   525,   526,   527,   528,   529,   530,  1186,
    1151,   535,   535,   171,   177,   407,   535,   535,    38,  1202,
    1189,  1202,  1202,   177,   535,   135,   535,  1261,   330,  1165,
      38,   535,   538,  1150,  1261,   538,  1150,  1213,  1150,   535,
     511,  1151,  1151,   150,  1189,   177,    37,   301,   388,   477,
     135,   137,   163,   291,   297,   454,   466,  1198,  1228,   291,
    1229,   150,   900,  1150,   430,  1214,  1150,  1203,  1150,   447,
     534,  1039,   534,  1172,   534,  1189,   488,   534,  1173,  1258,
     439,   441,   439,   441,  1241,  1052,  1052,  1052,  1108,  1057,
    1108,   952,   994,   266,   534,   535,  1248,  1146,  1146,   533,
     533,   535,   534,  1039,  1103,  1113,  1120,   177,   534,  1039,
    1088,  1089,    38,  1090,  1091,  1258,   538,   100,   178,   212,
     227,   250,   279,   378,  1094,  1091,    38,  1090,  1093,  1258,
    1091,  1091,   515,  1107,  1212,  1150,   186,  1071,  1060,   310,
    1184,  1187,   514,   860,     5,  1248,  1069,   309,   491,   470,
    1066,   261,  1087,   488,  1109,   478,   432,   471,  1006,  1007,
    1008,  1258,   308,  1009,  1258,  1088,  1022,  1023,   538,  1086,
     524,  1213,   877,   815,   873,   873,    59,   875,   529,  1253,
    1253,   308,  1242,   311,   308,  1150,   655,   772,   157,   548,
     447,  1252,  1243,   578,  1126,   814,   814,  1126,   702,  1243,
     189,   476,   447,   447,   702,   718,   724,   367,   402,   591,
    1243,  1243,  1243,   214,   297,   160,   869,   323,   402,   447,
    1150,   292,   153,   653,  1243,   534,   534,   157,   534,   679,
     206,   534,   772,   422,   641,   642,   772,   402,    25,   140,
     371,   372,   402,   595,   603,   604,   724,   920,   394,   157,
     548,   157,   548,  1243,  1243,  1243,  1243,   394,   394,   251,
     727,   728,   727,   535,   538,   729,  1249,   206,   535,   538,
     524,   536,   120,   606,  1258,   160,  1252,  1243,   367,   402,
     591,  1243,  1243,  1243,   308,   324,   367,   402,    25,   140,
     324,   367,   402,  1126,   289,  1126,   535,   538,   524,  1241,
     447,  1253,   472,   745,   160,   657,   389,   931,   488,   664,
     664,   657,   253,   331,   297,  1249,   331,  1253,   469,   160,
     447,   447,   389,   419,   890,   890,   890,   323,   402,    92,
     447,   919,   389,   120,   171,   607,   167,   547,   447,   447,
     263,   263,   263,   447,   447,   389,   447,   447,   389,   447,
     389,   447,   389,   447,   128,   548,  1126,   292,  1249,   402,
     920,   157,   548,   447,   447,   535,  1243,   447,   919,   389,
     447,  1252,  1243,   535,   535,   535,  1191,   533,  1126,   814,
     224,   820,  1243,  1243,  1243,   224,   420,   421,   617,  1249,
     617,   189,   535,   535,   177,   782,   784,   289,   310,   525,
     526,   698,   785,   873,  1187,  1249,  1266,    72,    78,    92,
     120,   122,   181,   210,   292,   297,   344,   361,   465,   644,
     645,   648,   156,   487,   551,   578,  1243,   578,   312,   722,
    1241,  1241,  1241,   535,   538,  1253,   186,   379,  1253,  1248,
     457,  1241,   657,     3,   171,   750,   890,    48,   565,   434,
     731,   113,   991,  1150,   177,   538,  1242,   600,   789,   790,
    1249,   535,   538,  1243,   171,   658,  1241,   685,  1241,  1243,
     686,   534,   632,  1241,   535,  1243,   491,   493,   675,   599,
      38,   157,  1038,   674,   447,   157,  1097,   524,   535,   538,
     756,   535,   538,   120,   524,   884,  1249,   578,   434,   872,
     873,   171,   889,    51,   374,   885,   886,   883,   886,   125,
     216,   395,   470,   942,  1243,   302,   308,   313,   189,  1038,
    1126,   534,   535,   538,   548,   472,   548,   472,   548,  1243,
    1243,   740,   814,   157,   389,   389,   389,   389,   389,  1242,
     538,   834,  1258,  1252,   491,   538,   838,  1252,   538,   844,
     163,   311,   454,   843,  1099,   399,   155,   155,   535,   113,
     288,   835,   844,  1253,   224,   224,   224,   224,   698,   224,
     224,   224,   224,   224,  1194,   443,  1150,   147,  1126,   535,
    1150,   228,   465,   465,   535,  1225,  1227,   308,   308,  1223,
    1227,    59,  1233,  1150,  1223,  1223,   308,   308,  1231,  1229,
    1229,  1150,   535,  1150,  1198,  1150,  1150,   535,  1189,   538,
    1126,  1151,  1151,  1151,  1151,   135,   137,   292,  1151,  1151,
    1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1150,  1150,
    1150,  1126,   535,   535,   535,  1189,   535,   538,    59,  1152,
    1166,   535,  1261,  1161,   341,   426,  1164,   535,   538,   483,
    1157,    38,   535,  1249,  1150,    35,    35,  1150,   535,  1150,
     177,   291,  1229,  1150,   535,   150,  1151,  1151,   150,   150,
    1150,  1150,  1058,   535,  1189,   538,  1150,  1174,  1258,  1052,
    1052,  1052,  1052,  1241,  1241,  1241,  1071,   535,  1071,   999,
     533,  1223,  1091,  1093,  1091,  1091,   534,   503,  1152,   535,
    1258,   534,  1088,   227,   318,  1095,  1088,  1095,   227,  1094,
    1095,   227,   436,  1101,   534,  1258,   534,   315,    59,   190,
    1078,   534,   860,   168,   245,   309,   491,   444,   103,  1150,
     375,  1011,   477,   535,   538,  1213,    90,  1011,   308,   535,
     538,  1021,  1109,  1150,   535,   529,   877,   457,   180,   383,
     390,   397,   435,   458,   849,   171,   849,   535,   122,   210,
     288,   292,   773,  1243,  1243,    38,   472,   472,   243,   815,
    1252,  1243,   447,   919,   389,   447,   214,  1243,    59,   437,
    1243,   535,   157,   534,   662,   663,   855,  1155,  1258,   658,
     637,   658,   772,  1243,   658,   120,  1258,    86,   639,   640,
     419,   181,   159,   194,   292,   599,   551,   113,   159,   181,
     292,   419,   599,   639,   641,   696,   402,   604,   457,  1243,
    1258,   394,   726,  1243,   602,   785,  1261,  1243,   323,   402,
     447,   919,   389,   447,   160,   447,   447,   389,   179,   310,
     422,   794,   795,   179,   310,   802,   803,   447,   447,   389,
     535,   535,   535,   926,   289,   698,   873,   927,  1187,  1249,
    1266,   367,  1243,   534,   491,   746,  1243,   664,   107,  1258,
     534,   664,  1250,  1249,  1249,  1249,  1243,  1243,  1243,  1243,
     605,    59,   437,  1243,  1243,  1243,  1243,   478,  1243,  1243,
     171,   171,   369,   171,   195,  1252,  1243,  1243,  1252,  1243,
    1243,  1243,  1243,  1243,  1243,  1243,   308,    78,   596,   157,
      27,    50,   457,  1258,  1243,  1249,   724,  1243,  1243,  1243,
    1243,  1057,   535,   224,   820,   224,   224,   224,   820,   551,
     472,   622,   623,   702,   772,   491,   493,   814,   534,   814,
    1243,  1151,    32,    59,   647,   123,   197,   122,   297,   240,
    1241,   646,   179,   348,   768,   775,   776,  1258,   711,   534,
     329,   534,   632,   650,   209,   669,   635,  1253,  1253,  1126,
     534,   600,    29,   125,   216,   395,   470,   751,   447,   747,
    1252,   195,  1241,   733,   495,   308,   535,  1087,   682,   890,
     535,   538,  1112,   722,   740,   535,   693,    38,   302,   329,
     534,  1001,   634,   636,   638,   652,  1258,   329,   670,   671,
     632,   669,   599,   305,   308,   676,  1038,   688,   686,   600,
    1249,  1243,   852,   785,     3,   788,   308,   874,  1150,  1150,
     538,   534,   880,   457,   538,    44,  1150,   447,   534,   658,
    1241,   757,   702,   535,   967,   968,  1243,  1243,   548,   399,
     548,  1242,  1242,  1242,  1242,  1242,   698,   183,   837,   844,
     842,   535,  1243,  1249,   113,   177,   548,   844,   297,   823,
    1249,   823,   823,   823,   224,   823,   823,   823,   823,   823,
    1150,   535,   145,   241,   241,   535,   297,   297,   535,  1059,
    1227,   330,  1215,   297,   297,  1227,  1227,  1215,  1215,   535,
     535,   177,   535,  1150,   177,   135,   137,   177,   171,   150,
     535,   498,  1159,  1189,   360,   477,    59,  1166,  1152,   489,
     489,   535,  1150,   288,  1150,   538,  1158,  1128,  1150,  1150,
    1150,  1150,    35,    35,  1150,  1150,   150,   535,   535,   535,
    1150,   535,   329,  1175,  1241,  1241,  1241,  1241,  1078,  1249,
    1078,   535,   538,  1104,  1105,  1155,   534,  1165,  1090,   534,
    1242,  1088,   308,   472,  1096,  1088,   227,  1088,  1246,  1111,
     534,  1111,  1258,  1053,  1150,   490,  1169,   900,   444,   302,
    1238,  1038,   322,  1038,  1008,   308,   534,  1010,  1150,   524,
    1022,  1011,   457,   535,   447,   830,   177,   772,   123,   197,
     208,   122,   474,   548,  1126,  1243,  1243,  1243,  1243,  1243,
    1243,  1243,  1253,  1243,   772,   637,  1150,   535,   538,   491,
      78,   854,   858,   854,   535,   535,   535,   120,  1258,   722,
     605,   647,   195,   195,   297,   698,    38,   647,   297,   605,
    1126,   548,   548,   524,    59,   437,  1243,  1243,  1243,  1243,
    1243,  1252,  1243,  1243,  1248,  1248,  1126,   538,  1248,  1248,
     538,  1252,  1243,  1243,   447,  1150,    72,  1150,  1253,  1243,
     447,   447,   177,   201,   491,  1242,  1242,   814,  1242,   157,
     160,   814,  1249,  1249,  1126,   548,   548,   447,   535,   224,
     820,   820,   820,   820,   534,   618,   619,   551,   127,   179,
     213,   179,  1150,   292,   645,   120,    38,   890,   657,   890,
    1246,    35,   156,   201,   723,   727,   302,   631,   607,   154,
     203,   534,   399,   472,   658,    38,  1253,   745,   565,   292,
     534,   173,  1243,   681,  1249,   399,   600,   156,  1038,   814,
     302,   631,   686,   535,   538,   491,   643,    59,   674,   607,
     670,    84,   437,   677,   491,   956,    38,   677,   177,   308,
     534,  1241,  1249,   871,   891,   892,  1259,   886,  1126,   171,
     887,  1241,   177,   447,   911,   362,   758,   211,   703,   548,
     535,   548,   548,  1243,   311,   222,   836,   548,   823,  1243,
     535,  1216,  1217,  1223,   120,   143,   149,   163,   297,   454,
     466,  1219,  1220,  1222,   535,   535,  1227,  1227,  1150,   535,
    1151,   177,  1150,  1150,  1150,   534,   535,   538,   535,  1166,
     535,   477,   416,   535,   205,   288,  1163,  1150,  1150,  1150,
     535,    59,  1057,  1169,  1169,   392,  1047,  1150,   535,   538,
      38,  1106,   120,  1118,  1119,  1151,    81,  1242,   535,  1150,
     534,  1088,  1096,   534,   535,  1111,   535,   102,   187,   381,
     534,  1072,  1073,  1074,  1075,  1076,  1077,  1150,  1170,  1171,
    1258,  1057,   535,  1035,  1006,    92,   853,   855,   136,   487,
    1025,  1026,  1027,  1028,  1150,   836,   308,   836,   535,   447,
     402,  1017,   535,   202,   660,   663,   310,   900,   814,   546,
     814,   361,   660,   660,   643,    38,   157,   157,   534,   596,
     785,  1253,  1243,   447,   534,   866,   900,   902,   795,   534,
     534,   803,  1243,   535,   534,   535,   402,  1017,  1243,  1243,
     534,   534,   534,   491,   515,   976,   369,   976,   976,   171,
    1243,   596,  1243,   820,   624,   625,  1261,    54,   101,   126,
     145,   150,   172,   176,   191,   297,   352,   620,   618,  1249,
     866,    38,   907,   907,   535,   194,   534,   472,   678,   264,
     661,   678,   534,   776,   768,   534,   535,   538,  1241,   535,
     399,    29,    83,    86,    93,   121,   181,   194,   207,   419,
     422,   651,   651,  1240,  1243,  1243,   535,  1038,   746,   157,
     113,   722,   177,  1243,    38,  1243,   686,   632,  1241,   535,
     636,   312,  1258,   675,   670,   674,   125,   140,   341,  1243,
      64,    72,   256,  1038,   814,  1097,   853,   177,   771,   873,
     535,   538,   457,   147,   544,   885,   888,  1108,   414,   414,
     535,   282,   306,   759,   760,   761,   171,   764,   702,   288,
     476,   704,   705,  1243,   844,   538,    38,  1150,    37,   301,
     308,   535,   491,   493,  1218,  1219,  1221,   171,  1151,  1160,
    1189,   288,   510,   205,   535,  1189,   188,   354,   385,  1176,
      58,   129,   112,  1048,    38,  1121,  1107,  1104,   534,  1151,
     535,   538,    38,  1114,  1115,  1258,   535,  1242,  1189,   535,
     534,   403,   534,   535,   538,   538,    38,  1062,   477,  1243,
     535,   538,   293,   470,   265,   292,  1011,  1026,    35,  1029,
    1029,   838,   849,   548,  1243,   437,   854,   534,   890,   534,
     859,   599,  1241,   890,   890,   194,  1150,   472,   597,   402,
    1017,  1243,  1193,   171,   798,   798,  1193,  1193,  1150,   437,
    1189,  1189,   608,   609,  1260,   813,   814,   813,   814,  1242,
     548,   535,   538,   120,   527,   534,   575,   626,   698,   973,
    1249,   973,   292,   297,   352,   973,   973,  1108,   907,    42,
     199,   288,   656,   534,   694,  1150,   206,   178,   328,   408,
     308,   665,   666,   667,   535,  1246,     6,   777,   727,   632,
     669,  1243,   535,   722,   164,   797,   600,   956,  1241,   495,
    1087,   722,  1038,  1001,   670,   632,   669,   643,   534,   676,
     674,   675,   385,   385,    72,   311,    72,   686,   852,   535,
    1241,   772,   880,   891,  1126,   537,   136,   491,   491,   760,
     384,   434,   762,   141,   765,   487,   767,   476,   702,   722,
     548,  1217,  1261,   149,    37,    88,   461,   495,    37,   495,
     239,   307,  1226,   308,   535,  1150,   535,   535,   477,    52,
     103,   460,  1150,  1177,  1178,  1177,  1177,   535,   168,   168,
     658,  1243,  1215,  1111,   538,  1119,  1261,   535,   538,   171,
    1126,   535,   535,  1189,   534,  1189,  1073,  1171,  1173,  1080,
    1038,  1108,   855,   402,   265,  1150,   443,   443,   177,  1243,
     658,   678,   900,   860,   859,   657,   678,   678,   694,   535,
    1150,   437,   535,   314,   392,   358,   799,   799,   535,   535,
     535,  1243,   535,   535,   535,   538,  1248,   976,   625,   575,
     627,   628,  1249,  1249,   297,   527,   658,   527,   658,  1249,
    1249,   208,   695,   535,   437,   125,   470,   308,   667,   308,
     666,   534,   535,   538,   607,   399,   722,   814,    38,    38,
     534,  1243,   956,   686,   674,   607,   670,   534,   672,   673,
    1155,  1258,   677,   675,   676,   311,   311,   534,   202,   856,
     171,   886,    30,   217,   943,   179,   179,   973,   384,   418,
     766,   534,   156,   495,    37,   495,    37,   495,   495,   353,
     353,  1221,   143,   149,  1178,   384,   170,   339,   170,   339,
     153,  1179,  1179,  1179,    59,    59,   402,    81,   535,  1152,
    1115,   315,     3,   120,   292,   297,   332,  1116,  1117,    38,
    1092,   368,  1102,   535,  1072,   535,  1020,    59,   125,   136,
     470,  1030,  1031,   136,   216,  1032,   836,  1017,   535,   664,
     535,   860,   661,   772,   772,  1243,   866,    59,  1017,   447,
     608,   814,   535,   538,   527,   658,   535,   423,  1243,    63,
     288,   373,   402,   668,   668,   535,     6,   399,  1243,   794,
    1038,   722,   675,   670,   674,  1150,   535,   538,   858,   858,
     676,   677,   853,   534,   646,   141,   293,   534,   938,   940,
     944,  1003,  1012,  1019,  1038,  1049,   866,   866,   763,  1258,
    1150,   768,   495,   495,   308,   308,   535,  1219,    35,   103,
     186,   288,   444,   658,   658,  1258,   534,  1165,  1151,  1151,
     297,  1151,  1117,  1258,   534,   535,  1108,   413,   438,   293,
     402,   293,   120,   322,   478,   534,  1033,   548,   772,   665,
    1017,   814,   534,   628,    24,   120,   297,  1243,   722,   956,
     676,   674,   675,   535,   673,   546,   546,   677,   535,   855,
     857,   600,   384,   939,   940,   941,  1039,  1040,   538,   538,
     535,  1246,   388,   388,   308,  1178,   384,   316,   402,   402,
     447,   472,   281,  1122,  1123,  1258,    81,  1150,  1020,   478,
    1006,   534,  1007,   772,  1189,   657,   657,   722,   677,   675,
     676,   858,   856,   535,   538,   677,   767,   535,   537,   447,
     177,   534,   425,   425,   149,  1258,  1258,   228,  1246,  1247,
    1258,   332,  1124,   535,   538,   171,  1126,  1114,   535,   477,
    1189,   535,   535,   676,   677,   546,   646,   855,  1108,   156,
     941,   414,   414,     5,   769,   770,  1248,  1249,  1261,   534,
     120,  1249,  1222,  1123,   315,   157,   332,  1125,  1224,   535,
    1033,   535,   322,  1033,   677,   600,   768,   491,   491,   535,
     538,  1190,  1247,    38,    81,   535,  1125,  1249,  1218,  1125,
    1006,   677,  1246,   179,   179,   770,  1057,   472,  1243,   534,
    1222,  1226,  1218,   477,  1108,   534,   866,   866,   535,  1258,
      81,  1122,  1221,  1226,  1033,   769,   534,   535,  1221,   535,
    1122,   535
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   540,   541,   541,   541,   541,   541,   541,   542,   542,
     543,   543,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   544,   544,   544,
     544,   544,   544,   544,   544,   544,   544,   545,   545,   546,
     546,   547,   547,   548,   548,   548,   549,   550,   551,   551,
     551,   552,   552,   553,   553,   554,   554,   554,   554,   554,
     554,   554,   554,   554,   555,   555,   555,   555,   555,   555,
     556,   557,   557,   558,   558,   559,   559,   559,   559,   560,
     560,   560,   560,   560,   560,   561,   562,   563,   563,   564,
     564,   564,   564,   565,   565,   566,   566,   566,   566,   566,
     566,   567,   567,   567,   567,   567,   568,   568,   568,   569,
     569,   569,   569,   570,   570,   570,   570,   570,   570,   570,
     570,   570,   570,   570,   570,   571,   571,   572,   572,   573,
     573,   574,   574,   574,   574,   575,   575,   575,   575,   576,
     576,   576,   576,   576,   576,   576,   577,   577,   577,   578,
     578,   579,   579,   580,   580,   580,   580,   581,   581,   582,
     582,   583,   583,   584,   584,   584,   584,   584,   584,   584,
     585,   586,   586,   587,   587,   588,   589,   589,   589,   589,
     589,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   591,   591,   592,   592,   592,   593,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   594,
     594,   594,   594,   594,   594,   594,   594,   594,   594,   595,
     595,   596,   596,   597,   597,   598,   598,   598,   598,   599,
     600,   600,   601,   601,   602,   602,   602,   602,   603,   603,
     604,   604,   604,   604,   605,   605,   606,   606,   607,   607,
     607,   607,   608,   609,   609,   610,   611,   611,   612,   612,
     612,   612,   613,   613,   614,   614,   615,   615,   616,   616,
     617,   617,   617,   618,   618,   619,   619,   620,   620,   620,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     620,   620,   621,   621,   622,   622,   623,   623,   624,   624,
     625,   626,   626,   626,   626,   626,   626,   627,   627,   628,
     629,   629,   629,   629,   629,   629,   630,   630,   630,   630,
     630,   630,   630,   630,   631,   631,   632,   632,   633,   633,
     634,   634,   635,   635,   635,   636,   636,   637,   638,   638,
     639,   639,   640,   640,   641,   641,   642,   642,   643,   643,
     644,   644,   644,   644,   645,   645,   645,   645,   645,   645,
     645,   645,   645,   646,   646,   646,   647,   647,   648,   648,
     648,   648,   649,   650,   650,   650,   651,   651,   651,   651,
     651,   651,   651,   651,   651,   651,   652,   652,   653,   653,
     653,   653,   653,   653,   653,   654,   654,   655,   655,   656,
     656,   657,   657,   658,   658,   659,   660,   660,   661,   661,
     661,   661,   662,   662,   663,   663,   664,   664,   665,   665,
     665,   665,   665,   666,   667,   668,   668,   668,   668,   668,
     669,   669,   670,   670,   671,   672,   672,   673,   673,   673,
     674,   674,   675,   675,   675,   676,   676,   676,   676,   677,
     677,   678,   678,   679,   680,   680,   681,   681,   682,   682,
     682,   683,   683,   684,   684,   685,   686,   686,   686,   687,
     687,   688,   689,   689,   690,   691,   691,   692,   692,   693,
     693,   694,   694,   695,   695,   696,   696,   696,   696,   696,
     696,   696,   696,   696,   696,   696,   696,   696,   696,   697,
     697,   698,   698,   698,   698,   699,   699,   700,   700,   701,
     701,   702,   702,   703,   703,   704,   704,   705,   705,   706,
     706,   707,   708,   708,   709,   709,   710,   710,   711,   711,
     712,   712,   712,   712,   713,   714,   714,   715,   716,   716,
     716,   716,   716,   716,   716,   716,   716,   716,   716,   716,
     716,   717,   718,   718,   718,   718,   719,   719,   720,   720,
     721,   721,   722,   722,   723,   723,   724,   725,   725,   726,
     726,   726,   726,   727,   728,   729,   730,   730,   731,   731,
     732,   732,   733,   733,   734,   734,   734,   735,   735,   735,
     735,   736,   737,   737,   738,   738,   739,   739,   740,   740,
     741,   741,   742,   743,   744,   745,   745,   746,   746,   747,
     747,   748,   748,   749,   749,   750,   750,   751,   751,   751,
     751,   751,   752,   753,   753,   754,   754,   755,   755,   755,
     756,   756,   757,   757,   757,   757,   757,   758,   758,   759,
     759,   760,   761,   761,   762,   762,   763,   764,   764,   765,
     765,   766,   766,   767,   767,   768,   768,   769,   769,   769,
     770,   770,   770,   770,   771,   771,   772,   772,   773,   773,
     773,   773,   773,   773,   774,   774,   775,   775,   776,   777,
     777,   778,   779,   779,   779,   779,   780,   781,   781,   781,
     781,   781,   781,   781,   781,   781,   781,   781,   781,   781,
     781,   781,   781,   782,   783,   783,   784,   784,   785,   785,
     785,   785,   785,   785,   786,   787,   787,   788,   789,   789,
     790,   790,   791,   791,   791,   791,   791,   792,   792,   793,
     794,   794,   795,   795,   795,   795,   795,   796,   796,   797,
     797,   798,   798,   798,   799,   799,   800,   801,   801,   802,
     802,   803,   803,   804,   804,   805,   805,   806,   807,   808,
     808,   808,   808,   808,   808,   808,   808,   808,   808,   808,
     808,   809,   809,   809,   809,   809,   809,   809,   809,   809,
     809,   809,   809,   809,   810,   810,   810,   810,   810,   811,
     811,   811,   811,   811,   811,   811,   811,   812,   812,   812,
     813,   813,   814,   814,   815,   815,   816,   816,   817,   818,
     818,   818,   819,   819,   819,   819,   819,   819,   819,   819,
     819,   819,   819,   819,   819,   819,   819,   819,   819,   819,
     820,   820,   821,   821,   821,   821,   821,   821,   821,   821,
     821,   821,   822,   822,   823,   823,   824,   824,   825,   825,
     825,   825,   825,   825,   825,   825,   825,   825,   825,   825,
     825,   825,   825,   825,   826,   826,   827,   827,   828,   829,
     829,   830,   830,   830,   830,   830,   831,   831,   832,   832,
     832,   832,   832,   833,   833,   834,   834,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   835,   835,
     835,   835,   835,   835,   835,   835,   835,   835,   836,   836,
     837,   837,   838,   838,   839,   839,   840,   840,   841,   841,
     842,   843,   843,   843,   844,   844,   845,   846,   846,   847,
     847,   847,   848,   848,   848,   849,   849,   849,   849,   849,
     849,   850,   850,   851,   851,   852,   852,   853,   853,   854,
     854,   855,   855,   855,   856,   856,   857,   857,   858,   858,
     859,   859,   859,   860,   860,   860,   861,   861,   861,   861,
     862,   862,   863,   863,   864,   864,   865,   865,   866,   866,
     866,   866,   867,   867,   868,   868,   869,   869,   869,   869,
     869,   870,   870,   870,   870,   870,   871,   872,   873,   873,
     873,   874,   874,   874,   875,   876,   876,   876,   876,   877,
     877,   878,   879,   879,   880,   880,   881,   881,   882,   882,
     882,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   882,   882,   882,   883,   883,   883,   883,   883,
     884,   884,   885,   886,   886,   886,   887,   887,   888,   888,
     889,   889,   890,   890,   891,   892,   892,   893,   893,   893,
     894,   894,   895,   895,   896,   896,   896,   896,   896,   896,
     897,   897,   898,   898,   899,   899,   899,   899,   900,   900,
     901,   901,   902,   903,   904,   904,   905,   905,   906,   906,
     906,   907,   907,   907,   908,   909,   909,   910,   911,   911,
     911,   911,   912,   913,   913,   913,   914,   914,   915,   915,
     916,   916,   917,   917,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   918,
     918,   918,   918,   918,   918,   918,   918,   918,   918,   919,
     919,   920,   920,   921,   921,   921,   921,   921,   921,   922,
     922,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   923,   923,
     923,   923,   923,   923,   923,   923,   923,   923,   924,   925,
     925,   926,   926,   926,   927,   927,   927,   927,   927,   928,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   929,   929,   929,   929,   929,   929,
     929,   929,   929,   929,   930,   930,   930,   931,   931,   931,
     931,   931,   931,   931,   932,   932,   933,   933,   933,   933,
     934,   935,   935,   935,   935,   935,   935,   935,   935,   935,
     936,   936,   937,   938,   938,   938,   939,   939,   940,   940,
     940,   940,   940,   941,   941,   942,   942,   942,   942,   943,
     943,   943,   944,   945,   945,   946,   947,   947,   948,   948,
     948,   948,   948,   948,   948,   948,   948,   948,   948,   948,
     949,   949,   950,   950,   950,   951,   951,   951,   951,   951,
     952,   952,   952,   953,   953,   954,   954,   954,   955,   955,
     955,   955,   956,   956,   956,   956,   957,   958,   959,   959,
     960,   960,   961,   961,   961,   962,   962,   962,   962,   962,
     962,   962,   963,   963,   964,   964,   964,   964,   965,   966,
     966,   966,   966,   967,   967,   968,   969,   970,   970,   971,
     972,   972,   972,   972,   972,   972,   972,   973,   973,   974,
     975,   975,   975,   975,   975,   975,   976,   976,   977,   978,
     978,   978,   978,   978,   979,   979,   980,   980,   981,   981,
     982,   982,   983,   983,   984,   985,   985,   985,   986,   986,
     986,   987,   987,   988,   988,   989,   989,   990,   990,   991,
     991,   992,   993,   993,   994,   994,   995,   995,   995,   995,
     996,   996,   996,   996,   996,   996,   996,   996,   996,   996,
     997,   998,   998,   999,   999,   999,   999,   999,  1000,  1000,
    1000,  1001,  1001,  1002,  1002,  1002,  1002,  1003,  1004,  1004,
    1005,  1005,  1005,  1005,  1005,  1006,  1006,  1007,  1007,  1008,
    1009,  1009,  1009,  1010,  1010,  1010,  1011,  1011,  1012,  1013,
    1013,  1014,  1015,  1015,  1016,  1016,  1016,  1016,  1016,  1016,
    1016,  1016,  1017,  1017,  1018,  1018,  1018,  1019,  1020,  1020,
    1021,  1021,  1022,  1023,  1023,  1024,  1025,  1025,  1026,  1026,
    1026,  1026,  1026,  1027,  1027,  1028,  1028,  1029,  1029,  1030,
    1031,  1032,  1032,  1032,  1032,  1032,  1033,  1034,  1035,  1036,
    1036,  1036,  1036,  1036,  1036,  1037,  1037,  1037,  1038,  1038,
    1039,  1039,  1040,  1040,  1040,  1040,  1040,  1040,  1040,  1040,
    1041,  1041,  1042,  1042,  1042,  1042,  1042,  1042,  1042,  1043,
    1043,  1043,  1044,  1044,  1045,  1046,  1046,  1046,  1047,  1047,
    1047,  1048,  1048,  1048,  1049,  1049,  1050,  1050,  1051,  1051,
    1051,  1051,  1051,  1051,  1051,  1051,  1051,  1052,  1052,  1053,
    1053,  1053,  1054,  1054,  1055,  1055,  1056,  1056,  1057,  1057,
    1058,  1059,  1059,  1060,  1060,  1061,  1061,  1061,  1061,  1062,
    1062,  1063,  1063,  1063,  1063,  1063,  1063,  1064,  1064,  1065,
    1065,  1066,  1067,  1067,  1067,  1068,  1068,  1069,  1069,  1070,
    1070,  1071,  1071,  1072,  1072,  1073,  1073,  1073,  1073,  1073,
    1074,  1075,  1076,  1077,  1078,  1078,  1079,  1079,  1080,  1080,
    1081,  1081,  1082,  1083,  1083,  1083,  1083,  1084,  1084,  1085,
    1085,  1086,  1086,  1087,  1087,  1088,  1088,  1088,  1088,  1088,
    1088,  1088,  1088,  1088,  1088,  1088,  1088,  1089,  1089,  1089,
    1089,  1089,  1089,  1090,  1090,  1090,  1090,  1091,  1091,  1092,
    1092,  1093,  1093,  1093,  1093,  1093,  1094,  1094,  1094,  1094,
    1095,  1095,  1096,  1096,  1097,  1097,  1098,  1098,  1098,  1099,
    1099,  1100,  1100,  1100,  1101,  1102,  1102,  1103,  1103,  1104,
    1105,  1105,  1106,  1106,  1107,  1107,  1108,  1108,  1109,  1109,
    1109,  1110,  1110,  1111,  1111,  1112,  1113,  1113,  1114,  1114,
    1115,  1115,  1115,  1116,  1116,  1117,  1117,  1117,  1117,  1117,
    1118,  1118,  1119,  1119,  1120,  1121,  1121,  1122,  1122,  1123,
    1123,  1123,  1123,  1123,  1123,  1124,  1124,  1125,  1125,  1126,
    1126,  1126,  1126,  1126,  1126,  1127,  1127,  1127,  1128,  1128,
    1128,  1128,  1128,  1128,  1128,  1128,  1129,  1129,  1129,  1129,
    1129,  1130,  1130,  1131,  1131,  1132,  1132,  1132,  1132,  1132,
    1132,  1132,  1132,  1132,  1132,  1132,  1133,  1133,  1134,  1134,
    1135,  1135,  1136,  1137,  1138,  1138,  1139,  1139,  1140,  1141,
    1142,  1142,  1142,  1142,  1142,  1142,  1143,  1143,  1144,  1144,
    1144,  1144,  1145,  1146,  1146,  1146,  1147,  1147,  1147,  1147,
    1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,  1147,
    1148,  1148,  1149,  1150,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,  1150,
    1150,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,
    1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,  1151,
    1151,  1151,  1151,  1152,  1152,  1152,  1152,  1152,  1152,  1152,
    1152,  1152,  1152,  1152,  1152,  1152,  1152,  1153,  1153,  1153,
    1153,  1153,  1153,  1153,  1154,  1154,  1154,  1155,  1155,  1155,
    1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,  1156,
    1157,  1157,  1158,  1158,  1158,  1158,  1159,  1160,  1160,  1161,
    1161,  1162,  1162,  1163,  1163,  1163,  1164,  1164,  1164,  1165,
    1165,  1165,  1165,  1166,  1166,  1167,  1167,  1168,  1168,  1169,
    1169,  1170,  1170,  1171,  1172,  1172,  1172,  1173,  1174,  1174,
    1175,  1175,  1176,  1176,  1176,  1176,  1177,  1177,  1178,  1178,
    1178,  1178,  1178,  1179,  1179,  1179,  1179,  1179,  1180,  1180,
    1180,  1181,  1181,  1182,  1183,  1183,  1183,  1184,  1184,  1185,
    1185,  1185,  1185,  1185,  1185,  1185,  1185,  1185,  1185,  1185,
    1185,  1186,  1186,  1187,  1187,  1188,  1188,  1188,  1188,  1188,
    1188,  1189,  1189,  1190,  1190,  1191,  1191,  1191,  1192,  1192,
    1193,  1193,  1194,  1194,  1194,  1195,  1195,  1196,  1197,  1197,
    1197,  1197,  1197,  1197,  1197,  1197,  1198,  1198,  1198,  1198,
    1199,  1199,  1200,  1201,  1201,  1201,  1201,  1201,  1202,  1202,
    1202,  1203,  1203,  1204,  1205,  1205,  1206,  1207,  1207,  1208,
    1208,  1209,  1209,  1210,  1210,  1210,  1210,  1211,  1211,  1212,
    1212,  1213,  1213,  1214,  1214,  1215,  1215,  1216,  1216,  1217,
    1218,  1218,  1218,  1218,  1218,  1218,  1218,  1218,  1218,  1219,
    1219,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1220,  1221,
    1221,  1221,  1221,  1222,  1222,  1223,  1224,  1224,  1225,  1225,
    1226,  1226,  1226,  1226,  1226,  1227,  1227,  1228,  1228,  1228,
    1228,  1228,  1229,  1229,  1229,  1229,  1229,  1230,  1230,  1231,
    1231,  1232,  1232,  1232,  1233,  1233,  1233,  1234,  1234,  1235,
    1235,  1236,  1236,  1237,  1237,  1238,  1238,  1239,  1239,  1239,
    1239,  1240,  1240,  1241,  1241,  1242,  1242,  1243,  1244,  1245,
    1246,  1246,  1247,  1247,  1247,  1247,  1247,  1247,  1247,  1247,
    1247,  1247,  1247,  1247,  1247,  1248,  1249,  1250,  1250,  1250,
    1251,  1252,  1252,  1252,  1252,  1253,  1253,  1254,  1255,  1256,
    1256,  1257,  1257,  1258,  1258,  1258,  1259,  1259,  1259,  1260,
    1260,  1260,  1260,  1261,  1261,  1261,  1261,  1261,  1262,  1262,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,  1263,
    1263,  1263,  1263,  1263,  1263,  1263,  1263,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,  1264,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,  1265,
    1265,  1265,  1265,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,  1266,
    1266,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     2,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       0,     1,     0,     1,     1,     0,     2,     5,     1,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       3,     3,     2,     1,     1,     2,     2,     2,     3,     3,
       5,     5,     5,     0,     3,     5,     5,     5,     5,     3,
       5,     3,     5,     3,     5,     5,     6,     1,     1,     6,
       4,     9,     7,     2,     0,     1,     1,     1,     1,     1,
       1,     3,     2,     2,     3,     3,     2,     5,     1,     3,
       3,     3,     3,     1,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     4,     1,     3,     1,     3,     1,
       1,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     1,     1,     1,     1,     1,     0,     1,
       1,     2,     3,     1,     2,     3,     2,     1,     1,     2,
       1,     2,     1,     3,     3,     2,     3,     4,     3,     2,
       4,     1,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     4,     6,     4,     6,    10,    13,     4,     6,     4,
      10,    13,     4,     6,     4,     6,     5,     7,    11,    14,
       5,     7,     1,     3,     4,     4,     4,     3,     2,     5,
       3,     6,     4,     6,     6,     9,     5,     7,     6,     6,
       5,     5,     5,     5,     9,     4,     5,     7,     6,     4,
       8,     4,     2,     4,     3,     6,     4,     3,     3,     3,
       2,     2,     3,     4,     4,     3,     3,     3,     3,     3,
       3,     4,     4,     3,     2,     3,     2,     2,     3,     4,
       3,     2,     2,     3,     4,     4,     4,     5,     1,     3,
       2,     2,     0,     2,     0,     1,     1,     1,     3,     3,
       2,     0,     1,     3,     3,     1,     5,     3,     1,     2,
       1,     3,     2,     3,     1,     1,     1,     1,     6,     6,
      10,     1,     2,     1,     3,     4,     1,     3,     4,     6,
       4,     8,     2,     2,    11,     9,     1,     1,     1,     0,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     3,
       3,     1,     1,     3,     3,     3,     3,     4,     4,     3,
       3,     2,     1,     0,     3,     0,     1,     0,     1,     3,
       2,     1,     1,     1,     1,     3,     0,     1,     3,     1,
      13,    16,    12,    15,    14,    17,     1,     1,     2,     2,
       2,     2,     1,     0,     1,     0,     3,     0,     1,     3,
       1,     3,     1,     1,     1,     1,     1,     6,     2,     4,
       2,     2,     1,     0,     2,     2,     1,     0,     2,     0,
       3,     1,     1,     2,     2,     1,     4,     4,     5,     2,
       5,     7,     5,     2,     3,     0,     1,     2,     1,     2,
       2,     2,     3,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     5,     9,
       3,     9,     4,    10,    11,     3,     1,     5,     3,     2,
       0,     3,     0,     1,     3,     1,     4,     0,     2,     2,
       2,     0,     1,     3,     3,     6,     4,     0,     1,     1,
       2,     2,     0,     3,     3,     2,     1,     1,     3,     3,
       4,     0,     1,     0,     6,     1,     3,     3,     3,     5,
       2,     0,     2,     2,     0,     3,     4,     4,     0,     2,
       0,     4,     0,     3,     8,    11,     1,     3,     1,     1,
       3,     6,     8,     7,    10,     6,     2,     3,     0,     8,
      11,     5,     1,     0,     6,     5,     8,     4,     6,     1,
       0,     3,     0,     1,     2,     2,     2,     1,     2,     3,
       2,     2,     2,     2,     3,     3,     3,     1,     3,     1,
       0,     1,     2,     2,     1,     1,     3,     6,    10,     1,
       0,     1,     2,     2,     0,     2,     2,     1,     0,     1,
       0,     7,     2,     0,     3,     5,     5,     8,     2,     0,
       2,     2,     2,     1,     5,     2,     0,     2,     6,     6,
       6,    10,     6,     6,     6,     9,     9,     6,     6,     9,
       6,     7,     2,     2,     2,     2,     1,     2,     1,     0,
       7,     6,     4,     0,     1,     3,     4,     1,     3,     1,
       2,     2,     2,     2,     1,     1,    10,    13,     2,     0,
       2,     2,     1,     0,     5,     4,     4,    11,    14,    12,
      15,    11,     2,     1,     4,     0,     8,    11,     1,     1,
       7,     9,     8,    10,     8,     4,     0,     5,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     1,     1,     1,
       1,     1,     8,     1,     1,    17,    21,     1,     1,     2,
       1,     3,     1,     1,     1,     3,     1,     2,     0,     1,
       2,     4,     1,     1,     1,     1,     1,     3,     0,     1,
       0,     1,     1,     4,     0,     1,     1,     1,     3,     0,
       1,     1,     1,     1,     2,     0,     0,     2,     2,     1,
       2,     2,     2,     2,    11,    13,     1,     3,     5,     1,
       3,     5,     1,     2,     2,     1,     8,     6,     5,     4,
       4,     3,     7,     8,     6,     6,     6,     6,     6,     4,
       7,     5,     8,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     3,     1,     0,
       1,     3,     7,     9,     9,     8,     6,     3,     0,    13,
       1,     3,     5,     5,     3,     6,     2,     1,     0,     2,
       0,     2,     4,     0,     1,     0,     6,     8,     8,     1,
       3,     5,     5,     7,     9,     7,     9,     5,     6,     6,
       4,     6,     4,     6,     8,     4,     6,     4,     6,     5,
       7,     1,     1,     1,     2,     1,     2,     1,     1,     1,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     2,
       2,     1,     3,     2,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     2,     3,     1,     3,     5,     2,
       2,     0,     6,     6,     6,     6,     6,     6,     6,     6,
       8,     9,     8,     6,     6,     9,     9,     9,     7,    10,
       1,     1,     8,     8,     8,     8,     8,     8,     8,     9,
       8,     8,     2,     0,     1,     1,     2,     2,     1,     2,
       3,     3,     3,     3,     4,     4,     3,     3,     3,     4,
       4,     3,     4,     4,     1,     1,     1,     0,     8,     8,
      11,     1,     1,     2,     4,     5,     1,     3,     2,     2,
       2,     2,     2,     1,     3,     1,     3,     1,     2,     2,
       4,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     5,     5,     5,     5,     5,     1,     3,
       1,     2,     3,     0,     5,     7,     6,     9,     3,     1,
       2,     1,     1,     1,     3,     0,     5,     2,     0,     3,
       3,     3,     7,     7,    10,     1,     1,     1,     1,     1,
       1,    16,    19,     1,     0,     2,     0,     1,     3,     4,
       5,     2,     2,     4,     4,     0,     1,     3,     2,     0,
       1,     1,     0,     2,     2,     0,     9,    12,     7,     7,
       2,     0,     3,     2,     1,     3,     1,     3,     2,     1,
       1,     2,     3,     2,     1,     3,     3,     3,     2,     2,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     4,
       5,     1,     3,     3,     1,     3,     3,     5,     6,     1,
       3,     2,     1,     3,     1,     0,     1,     2,     4,     5,
       1,     1,     1,     1,     3,     3,     2,     2,     1,     2,
       2,     2,     2,     1,     2,     2,     2,     2,     1,     1,
       1,     3,     2,     1,     4,     0,     3,     0,     1,     1,
       3,     5,     2,     0,     2,     1,     3,     5,     5,     5,
       1,     2,     1,     0,     4,     6,     4,     6,     4,     6,
       4,     6,     4,     6,     3,     5,     5,     5,     1,     3,
       1,     3,     2,     2,     1,     2,     1,     2,    11,    10,
      10,     2,     2,     0,     9,     2,     0,    10,    11,    11,
       5,     5,     8,     5,     5,     5,     1,     1,     1,     1,
       3,     0,     5,     5,     6,     6,     6,     6,     6,     8,
       8,     6,     6,     7,     9,     9,     8,    10,     6,     6,
       6,     6,     6,     6,     6,     8,     6,     8,     6,     8,
       7,     9,     6,     8,     7,     9,     8,    10,     8,    10,
       9,    11,     8,    10,     9,    11,     8,     8,     7,     6,
       6,     6,     6,     8,     8,     8,     8,     6,     9,     1,
       0,     2,     0,     8,     8,     8,    10,     9,     8,     1,
       0,     6,     6,     6,     6,     6,     6,     6,     9,     9,
       6,     6,     6,     8,     6,     8,     8,     8,     8,     6,
       8,     6,     8,     7,     9,     7,     9,     6,     7,     1,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     7,
       6,     6,     6,     6,     6,     6,     7,     7,     6,     9,
       9,     6,     6,     6,     6,     6,     6,     8,     8,     8,
       6,     7,     6,     6,     4,     7,     6,     4,     4,     4,
       3,     4,     3,     1,     1,     3,     5,     5,     5,     5,
       8,     5,     5,     6,     7,     7,     7,     4,     4,     5,
       4,     6,    13,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     0,     3,     2,     0,     2,     2,     2,     3,     3,
       3,     3,     2,     3,     2,     5,     4,     3,     3,     3,
       3,     3,     1,     1,     0,     3,     2,     2,     1,     2,
       1,     3,     2,     1,     0,     2,     3,     0,     9,    11,
      12,    14,     3,     4,     4,     0,     2,     5,     1,     0,
       1,     2,     3,     3,     3,     1,     2,     1,     1,     1,
       1,     1,     1,     0,     5,     4,     6,     6,     4,     3,
       5,     7,     9,     1,     3,     1,     5,     4,     4,     6,
       4,     6,     6,     5,     7,     9,     6,     1,     0,     6,
      11,    11,    11,    13,     9,    11,     1,     1,    10,     6,
       4,     4,     2,     5,     2,     0,     6,     5,     3,     5,
       1,     3,     1,     1,     2,     1,     1,     1,     1,     1,
       0,     1,     0,     1,     0,     1,     0,     1,     0,     3,
       0,     2,     1,     3,     1,     0,     2,     4,     3,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     3,     0,     1,     1,     1,     1,     1,     3,     9,
      12,     3,     0,     2,     3,     2,     3,     7,     1,     3,
       1,     4,     4,     7,     2,     1,     1,     1,     3,     2,
       8,     5,     0,     4,     3,     0,     2,     0,     7,     2,
       0,     5,     3,     0,     2,     2,     2,     3,     1,     3,
       1,     2,     1,     0,     1,     2,     0,     8,     1,     3,
       3,     5,     2,     1,     3,    10,     1,     2,     4,     4,
       4,     5,     5,     2,     5,     3,     5,     2,     0,     3,
       1,     2,     5,     5,     8,     3,     4,     7,     1,     0,
       3,     2,     2,     2,     2,     0,     2,     2,     1,     1,
       3,     3,     1,     2,     4,     4,     2,     3,     5,     5,
       1,     1,     9,     9,     1,     2,     4,     4,     4,     2,
       2,     3,     1,     3,     9,     1,     2,     0,     7,     7,
       0,    10,     6,     0,     1,     0,     2,     0,     3,     3,
       4,     4,     4,     4,     3,     2,     1,     1,     0,     1,
       1,     0,     1,     5,     1,     0,     1,     1,     1,     0,
       3,     1,     3,     4,     3,     2,     2,     1,     1,     1,
       0,     2,     4,     5,     6,     4,     5,     2,     3,     1,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     4,     0,     1,     3,     1,     1,     1,     1,     1,
       2,     4,     4,     5,     2,     0,     1,     3,     1,     0,
       1,     2,     3,     2,     4,     2,     3,     2,     0,     4,
       5,     2,     0,     1,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     1,     4,     2,     3,     3,     4,     5,
       4,     5,     4,     5,     2,     4,     1,     1,     0,     2,
       0,     1,     4,     5,     4,     0,     2,     2,     2,     1,
       1,     0,     5,     2,     1,     1,     2,     2,     4,     1,
       3,     1,     2,     3,     6,     4,     0,     2,     6,     2,
       1,     3,     4,     0,     2,     0,     2,     0,     2,     4,
       0,     1,     0,     1,     3,     3,     7,    12,     1,     3,
       2,     3,     3,     1,     2,     2,     2,     2,     1,     2,
       1,     3,     3,     2,    13,     2,     0,     1,     3,     3,
       6,     7,     5,     7,     9,     1,     0,     2,     0,     2,
       3,     5,     6,     2,     3,     3,     4,     0,     1,     1,
       1,     1,     1,     2,     4,     1,     1,     1,     1,     1,
       1,     2,     3,     3,     0,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     1,     3,     0,     1,     1,
       1,     1,     5,     2,     1,     1,     1,     1,     4,     1,
       2,     2,     1,     3,     3,     2,     1,     0,     5,     2,
       5,     2,     1,     3,     3,     0,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     0,
       1,     4,     1,     1,     3,     3,     5,     3,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     2,     2,     3,     5,
       4,     6,     3,     5,     4,     6,     4,     6,     5,     7,
       3,     2,     4,     2,     3,     3,     4,     3,     4,     3,
       4,     5,     6,     6,     7,     6,     7,     3,     4,     4,
       6,     3,     3,     4,     3,     4,     4,     5,     4,     5,
       1,     1,     3,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     5,
       6,     3,     4,     1,     1,     2,     4,     1,     1,     1,
       2,     2,     2,     2,     1,     1,     4,     3,     5,     6,
       8,     6,     6,     4,     4,     3,     1,     1,     1,     1,
       5,     1,     1,     4,     1,     4,     1,     4,     1,     4,
       1,     1,     1,     1,     1,     1,     1,     6,     4,     4,
       6,     4,     4,     4,     4,     4,     6,     5,     5,     5,
       4,     6,     4,     4,     4,     4,     5,     7,     7,     9,
       5,     4,     6,     5,     7,     7,     8,     4,     7,     4,
       6,     6,     4,     5,     4,     5,     3,    11,     8,     9,
       2,     3,     3,     3,     4,     0,     4,     1,     3,     3,
       1,     1,     1,     1,     2,     0,     2,     2,     0,     2,
       3,     3,     4,     2,     2,     5,     0,     5,     0,     2,
       0,     1,     3,     3,     2,     2,     0,     6,     1,     0,
       3,     0,     3,     3,     3,     0,     1,     4,     2,     2,
       2,     2,     2,     3,     2,     2,     3,     0,     4,     3,
       5,     4,     3,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     1,     4,     1,     4,     1,     2,     1,
       2,     1,     3,     1,     3,     1,     3,     3,     1,     0,
       1,     3,     3,     3,     2,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       7,     5,     3,     5,     5,     3,     3,     5,     3,     2,
       1,     1,     3,     5,     1,     2,     4,     2,     0,     1,
       0,     1,     2,     2,     2,     3,     5,     1,     0,     1,
       2,     0,     2,     1,     0,     2,     0,     1,     3,     3,
       2,     3,     2,     3,     4,     4,     3,     3,     0,     2,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     3,
       3,     6,     0,     3,     0,     2,     4,     2,     1,     0,
       5,     2,     5,     2,     0,     3,     0,     1,     2,     2,
       2,     2,     3,     2,     3,     2,     0,     1,     3,     3,
       3,     3,     3,     0,     3,     3,     0,     1,     3,     7,
       7,     3,     0,     1,     0,     1,     3,     3,     2,     1,
       1,     1,     3,     1,     2,     1,     3,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     6,     2,
       3,     5,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     1,     1,     1,     1,     1,     3,    10,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (core_yyscan_t yyscanner)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 954 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[0].list);
				(void) yynerrs;		/* suppress compiler warning */
			}
#line 30926 "gram.c" /* yacc.c:1646  */
    break;

  case 3:
#line 959 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree = list_make1((yyvsp[0].typnam));
			}
#line 30934 "gram.c" /* yacc.c:1646  */
    break;

  case 4:
#line 963 "gram.y" /* yacc.c:1646  */
    {
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((yyvsp[0].node), 0));
			}
#line 30943 "gram.c" /* yacc.c:1646  */
    break;

  case 5:
#line 968 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 1;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30955 "gram.c" /* yacc.c:1646  */
    break;

  case 6:
#line 976 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 2;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30967 "gram.c" /* yacc.c:1646  */
    break;

  case 7:
#line 984 "gram.y" /* yacc.c:1646  */
    {
				PLAssignStmt *n = (PLAssignStmt *) (yyvsp[0].node);

				n->nnames = 3;
				pg_yyget_extra(yyscanner)->parsetree =
					list_make1(makeRawStmt((Node *) n, 0));
			}
#line 30979 "gram.c" /* yacc.c:1646  */
    break;

  case 8:
#line 1004 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-2].list) != NIL)
					{
						/* update length of previous stmt */
						updateRawStmtEnd(llast_node(RawStmt, (yyvsp[-2].list)), (yylsp[-1]));
					}
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), makeRawStmt((yyvsp[0].node), (yylsp[-1]) + 1));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 30995 "gram.c" /* yacc.c:1646  */
    break;

  case 9:
#line 1016 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].node) != NULL)
						(yyval.list) = list_make1(makeRawStmt((yyvsp[0].node), 0));
					else
						(yyval.list) = NIL;
				}
#line 31006 "gram.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1159 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 31012 "gram.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1166 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31018 "gram.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1167 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31024 "gram.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1171 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 31030 "gram.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1172 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31036 "gram.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1176 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 31042 "gram.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1177 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 31048 "gram.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1181 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_CASCADE; }
#line 31054 "gram.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1182 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; }
#line 31060 "gram.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1183 "gram.y" /* yacc.c:1646  */
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ }
#line 31066 "gram.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1193 "gram.y" /* yacc.c:1646  */
    {
					CallStmt   *n = makeNode(CallStmt);

					n->funccall = castNode(FuncCall, (yyvsp[0].node));
					(yyval.node) = (Node *) n;
				}
#line 31077 "gram.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1209 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31090 "gram.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31096 "gram.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1232 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31102 "gram.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 31108 "gram.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1237 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31114 "gram.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1242 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 31123 "gram.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1247 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("password", NULL, (yylsp[-1]));
				}
#line 31131 "gram.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1251 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * These days, passwords are always stored in encrypted
					 * form, so there is no difference between PASSWORD and
					 * ENCRYPTED PASSWORD.
					 */
					(yyval.defelt) = makeDefElem("password",
									 (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31145 "gram.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1261 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNENCRYPTED PASSWORD is no longer supported"),
							 errhint("Remove UNENCRYPTED to store the password in encrypted form instead."),
							 parser_errposition((yylsp[-2]))));
				}
#line 31157 "gram.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1269 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 31165 "gram.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1273 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 31173 "gram.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1277 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 31181 "gram.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1282 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31189 "gram.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1286 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We handle identifiers that aren't parser keywords with
					 * the following special-case codes, to avoid bloating the
					 * size of the main parser.
					 */
					if (strcmp((yyvsp[0].str), "superuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nosuperuser") == 0)
						(yyval.defelt) = makeDefElem("superuser", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createrole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreaterole") == 0)
						(yyval.defelt) = makeDefElem("createrole", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "replication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noreplication") == 0)
						(yyval.defelt) = makeDefElem("isreplication", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "createdb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nocreatedb") == 0)
						(yyval.defelt) = makeDefElem("createdb", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "login") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nologin") == 0)
						(yyval.defelt) = makeDefElem("canlogin", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "bypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(true), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "nobypassrls") == 0)
						(yyval.defelt) = makeDefElem("bypassrls", (Node *) makeBoolean(false), (yylsp[0]));
					else if (strcmp((yyvsp[0].str), "noinherit") == 0)
					{
						/*
						 * Note that INHERIT is a keyword, so it's handled by main parser, but
						 * NOINHERIT is handled here.
						 */
						(yyval.defelt) = makeDefElem("inherit", (Node *) makeBoolean(false), (yylsp[0]));
					}
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized role option \"%s\"", (yyvsp[0].str)),
									 parser_errposition((yylsp[0]))));
				}
#line 31238 "gram.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1333 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = (yyvsp[0].defelt); }
#line 31244 "gram.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1336 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
				}
#line 31252 "gram.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1340 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31260 "gram.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1344 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 31268 "gram.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1348 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31276 "gram.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1352 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 31284 "gram.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1366 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31297 "gram.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1385 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 31310 "gram.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1394 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-2].rolespec);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 31323 "gram.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1405 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 31329 "gram.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1406 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31335 "gram.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1411 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31348 "gram.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1420 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31361 "gram.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1429 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = (yyvsp[-2].rolespec);
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31374 "gram.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1438 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);

					n->role = NULL;
					n->database = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 31387 "gram.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1460 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31399 "gram.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1468 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31411 "gram.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1476 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31423 "gram.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1484 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->roles = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 31435 "gram.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1492 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = false;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31447 "gram.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1500 "gram.y" /* yacc.c:1646  */
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);

					n->missing_ok = true;
					n->roles = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31459 "gram.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1518 "gram.y" /* yacc.c:1646  */
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);

					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 31472 "gram.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1537 "gram.y" /* yacc.c:1646  */
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);

					n->role = (yyvsp[-3].rolespec);
					n->action = (yyvsp[-2].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 31486 "gram.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1548 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = +1; }
#line 31492 "gram.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1549 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = -1; }
#line 31498 "gram.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1561 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* One can omit the schema name or the authorization id. */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31513 "gram.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1572 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not both */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 31528 "gram.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1583 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* schema name can be omitted here, too */
					n->schemaname = (yyvsp[-3].str);
					n->authrole = (yyvsp[-1].rolespec);
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31548 "gram.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1599 "gram.y" /* yacc.c:1646  */
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);

					/* ...but not here */
					n->schemaname = (yyvsp[-1].str);
					n->authrole = NULL;
					if ((yyvsp[0].list) != NIL)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE SCHEMA IF NOT EXISTS cannot include schema elements"),
								 parser_errposition((yylsp[0]))));
					n->schemaElts = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 31568 "gram.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1618 "gram.y" /* yacc.c:1646  */
    {
					if ((yyloc) < 0)			/* see comments for YYLLOC_DEFAULT */
						(yyloc) = (yylsp[0]);
					(yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node));
				}
#line 31578 "gram.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1624 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 31584 "gram.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1652 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31595 "gram.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1659 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolQueryCacheStmt; /* Hack to keep changes minimum */
					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31606 "gram.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1666 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31617 "gram.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1673 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = true;
					(yyval.node) = (Node *) n;
				}
#line 31628 "gram.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1680 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);

					n->is_local = false;
					(yyval.node) = (Node *) n;
				}
#line 31639 "gram.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1690 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31652 "gram.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1699 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31665 "gram.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1712 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31678 "gram.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1721 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[-2].str);
					n->args = (yyvsp[0].list);
					(yyval.vsetstmt) = n;
				}
#line 31691 "gram.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1730 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31703 "gram.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1738 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31715 "gram.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1748 "gram.y" /* yacc.c:1646  */
    {(yyval.vsetstmt) = (yyvsp[0].vsetstmt);}
#line 31721 "gram.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1750 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[-2].str);
					(yyval.vsetstmt) = n;
				}
#line 31733 "gram.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1759 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[0].node) != NULL)
						n->args = list_make1((yyvsp[0].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31749 "gram.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1771 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[0]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				}
#line 31761 "gram.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1779 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31774 "gram.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1788 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[0].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				}
#line 31790 "gram.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1800 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31803 "gram.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1809 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31816 "gram.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1818 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 31828 "gram.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1826 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[0].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31841 "gram.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1836 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION SNAPSHOT";
					n->args = list_make1(makeStringConst((yyvsp[0].str), (yylsp[0])));
					(yyval.vsetstmt) = n;
				}
#line 31854 "gram.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1846 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->name = (yyvsp[0].str);	/* query to delete query cache */
					(yyval.vsetstmt) = n;
				}
#line 31864 "gram.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1853 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31870 "gram.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1855 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str)); }
#line 31876 "gram.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1858 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 31882 "gram.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1859 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 31888 "gram.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1863 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0])); }
#line 31894 "gram.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1865 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 31900 "gram.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1868 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read uncommitted"; }
#line 31906 "gram.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1869 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "read committed"; }
#line 31912 "gram.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1870 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "repeatable read"; }
#line 31918 "gram.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1871 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "serializable"; }
#line 31924 "gram.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1875 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "true"; }
#line 31930 "gram.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1876 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "false"; }
#line 31936 "gram.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1877 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "on"; }
#line 31942 "gram.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1883 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 31948 "gram.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1896 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31956 "gram.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1900 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 31964 "gram.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1904 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					if ((yyvsp[0].list) != NIL)
					{
						A_Const    *n = (A_Const *) linitial((yyvsp[0].list));

						if ((n->val.ival.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[0]))));
					}
					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 31985 "gram.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1921 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 31997 "gram.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1928 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAConst((yyvsp[0].node), (yylsp[0])); }
#line 32003 "gram.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1929 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32009 "gram.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1930 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 32015 "gram.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1934 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32021 "gram.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1935 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32027 "gram.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1936 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 32033 "gram.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1940 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32039 "gram.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1941 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 32045 "gram.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1945 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].vsetstmt); }
#line 32051 "gram.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1947 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = (yyvsp[0].vsetstmt);
					n->type = T_PgpoolVariableSetStmt; /* Hack to keep the changes minimum */
					(yyval.node) = (Node *) n;
				}
#line 32061 "gram.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1955 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 32067 "gram.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1957 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.vsetstmt) = n;
				}
#line 32079 "gram.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1965 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.vsetstmt) = n;
				}
#line 32091 "gram.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1973 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				}
#line 32103 "gram.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1984 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET;
					n->name = (yyvsp[0].str);
					(yyval.vsetstmt) = n;
				}
#line 32115 "gram.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1992 "gram.y" /* yacc.c:1646  */
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);

					n->kind = VAR_RESET_ALL;
					(yyval.vsetstmt) = n;
				}
#line 32126 "gram.c" /* yacc.c:1646  */
    break;

  case 259:
#line 2002 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 32132 "gram.c" /* yacc.c:1646  */
    break;

  case 260:
#line 2003 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 32138 "gram.c" /* yacc.c:1646  */
    break;

  case 261:
#line 2008 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (yyvsp[0].vsetstmt); }
#line 32144 "gram.c" /* yacc.c:1646  */
    break;

  case 262:
#line 2009 "gram.y" /* yacc.c:1646  */
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[0].node); }
#line 32150 "gram.c" /* yacc.c:1646  */
    break;

  case 263:
#line 2016 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 32160 "gram.c" /* yacc.c:1646  */
    break;

  case 264:
#line 2022 "gram.y" /* yacc.c:1646  */
    {
				VariableShowStmt *n = (VariableShowStmt *)newNode(sizeof(VariableShowStmt),T_PgpoolVariableShowStmt);
				n->name = "all";
				(yyval.node) = (Node *) n;
			}
#line 32170 "gram.c" /* yacc.c:1646  */
    break;

  case 265:
#line 2028 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 32181 "gram.c" /* yacc.c:1646  */
    break;

  case 266:
#line 2035 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "timezone";
					(yyval.node) = (Node *) n;
				}
#line 32192 "gram.c" /* yacc.c:1646  */
    break;

  case 267:
#line 2042 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				}
#line 32203 "gram.c" /* yacc.c:1646  */
    break;

  case 268:
#line 2049 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				}
#line 32214 "gram.c" /* yacc.c:1646  */
    break;

  case 269:
#line 2056 "gram.y" /* yacc.c:1646  */
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);

					n->name = "all";
					(yyval.node) = (Node *) n;
				}
#line 32225 "gram.c" /* yacc.c:1646  */
    break;

  case 270:
#line 2067 "gram.y" /* yacc.c:1646  */
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);

					n->constraints = (yyvsp[-1].list);
					n->deferred = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32237 "gram.c" /* yacc.c:1646  */
    break;

  case 271:
#line 2077 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 32243 "gram.c" /* yacc.c:1646  */
    break;

  case 272:
#line 2078 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 32249 "gram.c" /* yacc.c:1646  */
    break;

  case 273:
#line 2082 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 32255 "gram.c" /* yacc.c:1646  */
    break;

  case 274:
#line 2083 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 32261 "gram.c" /* yacc.c:1646  */
    break;

  case 275:
#line 2092 "gram.y" /* yacc.c:1646  */
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);

					(yyval.node) = (Node *) n;
				}
#line 32271 "gram.c" /* yacc.c:1646  */
    break;

  case 276:
#line 2108 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				}
#line 32282 "gram.c" /* yacc.c:1646  */
    break;

  case 277:
#line 2115 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 32293 "gram.c" /* yacc.c:1646  */
    break;

  case 278:
#line 2122 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				}
#line 32304 "gram.c" /* yacc.c:1646  */
    break;

  case 279:
#line 2129 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				}
#line 32315 "gram.c" /* yacc.c:1646  */
    break;

  case 280:
#line 2136 "gram.y" /* yacc.c:1646  */
    {
					DiscardStmt *n = makeNode(DiscardStmt);

					n->target = DISCARD_SEQUENCES;
					(yyval.node) = (Node *) n;
				}
#line 32326 "gram.c" /* yacc.c:1646  */
    break;

  case 281:
#line 2156 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32340 "gram.c" /* yacc.c:1646  */
    break;

  case 282:
#line 2166 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32354 "gram.c" /* yacc.c:1646  */
    break;

  case 283:
#line 2176 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32368 "gram.c" /* yacc.c:1646  */
    break;

  case 284:
#line 2186 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32382 "gram.c" /* yacc.c:1646  */
    break;

  case 285:
#line 2196 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_TABLE;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32398 "gram.c" /* yacc.c:1646  */
    break;

  case 286:
#line 2208 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_TABLE;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32414 "gram.c" /* yacc.c:1646  */
    break;

  case 287:
#line 2220 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32428 "gram.c" /* yacc.c:1646  */
    break;

  case 288:
#line 2230 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_INDEX;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32442 "gram.c" /* yacc.c:1646  */
    break;

  case 289:
#line 2240 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = list_make1((yyvsp[0].node));
					n->objtype = OBJECT_INDEX;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32456 "gram.c" /* yacc.c:1646  */
    break;

  case 290:
#line 2250 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_INDEX;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32472 "gram.c" /* yacc.c:1646  */
    break;

  case 291:
#line 2262 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_INDEX;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32488 "gram.c" /* yacc.c:1646  */
    break;

  case 292:
#line 2274 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32502 "gram.c" /* yacc.c:1646  */
    break;

  case 293:
#line 2284 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_SEQUENCE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32516 "gram.c" /* yacc.c:1646  */
    break;

  case 294:
#line 2294 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32530 "gram.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2304 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_VIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32544 "gram.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2314 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32558 "gram.c" /* yacc.c:1646  */
    break;

  case 297:
#line 2324 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_MATVIEW;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32572 "gram.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2334 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-4].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = NIL;
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32588 "gram.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2346 "gram.y" /* yacc.c:1646  */
    {
					AlterTableMoveAllStmt *n =
						makeNode(AlterTableMoveAllStmt);

					n->orig_tablespacename = (yyvsp[-7].str);
					n->objtype = OBJECT_MATVIEW;
					n->roles = (yyvsp[-4].list);
					n->new_tablespacename = (yyvsp[-1].str);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 32604 "gram.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2358 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32618 "gram.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2368 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					n->relation = (yyvsp[-1].range);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_FOREIGN_TABLE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32632 "gram.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2380 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 32638 "gram.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2381 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 32644 "gram.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2387 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = (yyvsp[0].partboundspec);
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32661 "gram.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2401 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartition;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = (yyvsp[0].boolean);
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32678 "gram.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2414 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_DetachPartitionFinalize;
					cmd->name = (yyvsp[-1].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;
					(yyval.node) = (Node *) n;
				}
#line 32694 "gram.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2430 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					PartitionCmd *cmd = makeNode(PartitionCmd);

					n->subtype = AT_AttachPartition;
					cmd->name = (yyvsp[0].range);
					cmd->bound = NULL;
					cmd->concurrent = false;
					n->def = (Node *) cmd;

					(yyval.node) = (Node *) n;
				}
#line 32711 "gram.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2447 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32724 "gram.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2457 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32737 "gram.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2467 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32750 "gram.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2477 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[0].node);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32763 "gram.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2487 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[-1].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32776 "gram.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2497 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32788 "gram.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2506 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				}
#line 32800 "gram.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2515 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetExpression;
					n->name = (yyvsp[-6].str);
					n->def = (yyvsp[-1].node);
					(yyval.node) = (Node *) n;
				}
#line 32813 "gram.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2525 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-2].str);
					(yyval.node) = (Node *) n;
				}
#line 32825 "gram.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2534 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropExpression;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32838 "gram.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2544 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[-3].str);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32851 "gram.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2554 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					if ((yyvsp[-3].ival) <= 0 || (yyvsp[-3].ival) > PG_INT16_MAX)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("column number must be in range from 1 to %d", PG_INT16_MAX),
								 parser_errposition((yylsp[-3]))));

					n->subtype = AT_SetStatistics;
					n->num = (int16) (yyvsp[-3].ival);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 32870 "gram.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2570 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32883 "gram.c" /* yacc.c:1646  */
    break;

  case 321:
#line 2580 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32896 "gram.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2590 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetStorage;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32909 "gram.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2600 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetCompression;
					n->name = (yyvsp[-2].str);
					n->def = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 32922 "gram.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2610 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);

					c->contype = CONSTR_IDENTITY;
					c->generated_when = (yyvsp[-3].ival);
					c->options = (yyvsp[0].list);
					c->location = (yylsp[-4]);

					n->subtype = AT_AddIdentity;
					n->name = (yyvsp[-6].str);
					n->def = (Node *) c;

					(yyval.node) = (Node *) n;
				}
#line 32942 "gram.c" /* yacc.c:1646  */
    break;

  case 325:
#line 2627 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetIdentity;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 32955 "gram.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2637 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-2].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 32968 "gram.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2647 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropIdentity;
					n->name = (yyvsp[-4].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32981 "gram.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2657 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 32995 "gram.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2668 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33009 "gram.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2682 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = (yyvsp[0].node);
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 33028 "gram.c" /* yacc.c:1646  */
    break;

  case 331:
#line 2698 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnGenericOptions;
					n->name = (yyvsp[-1].str);
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33040 "gram.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2707 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[0].node);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33052 "gram.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2716 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					Constraint *c = makeNode(Constraint);
					n->subtype = AT_AlterConstraint;
					n->def = (Node *) c;
					c->contype = CONSTR_FOREIGN; /* others not supported, yet */
					c->conname = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "ALTER CONSTRAINT statement",
									&c->deferrable,
									&c->initdeferred,
									NULL, NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 33070 "gram.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2731 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ValidateConstraint;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33082 "gram.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2740 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33096 "gram.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2751 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33110 "gram.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2762 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOids;
					(yyval.node) = (Node *) n;
				}
#line 33121 "gram.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2770 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33133 "gram.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2779 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33145 "gram.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2788 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetLogged;
					(yyval.node) = (Node *) n;
				}
#line 33156 "gram.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2796 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetUnLogged;
					(yyval.node) = (Node *) n;
				}
#line 33167 "gram.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2804 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33179 "gram.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2813 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33191 "gram.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2822 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33203 "gram.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2831 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 33214 "gram.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2839 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 33225 "gram.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2847 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33237 "gram.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2856 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *) n;
				}
#line 33248 "gram.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2864 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *) n;
				}
#line 33259 "gram.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2872 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33271 "gram.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2881 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33283 "gram.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2890 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33295 "gram.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2899 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRule;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33307 "gram.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2908 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 33319 "gram.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2917 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[0].range);
					(yyval.node) = (Node *) n;
				}
#line 33331 "gram.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2926 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					TypeName   *def = makeTypeNameFromNameList((yyvsp[0].list));

					def->location = (yylsp[0]);
					n->subtype = AT_AddOf;
					n->def = (Node *) def;
					(yyval.node) = (Node *) n;
				}
#line 33345 "gram.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2937 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropOf;
					(yyval.node) = (Node *) n;
				}
#line 33356 "gram.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2945 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ChangeOwner;
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 33368 "gram.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2954 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetAccessMethod;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33380 "gram.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2963 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33392 "gram.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2972 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_SetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33404 "gram.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2981 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ResetRelOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33416 "gram.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2990 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ReplicaIdentity;
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 33428 "gram.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2999 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_EnableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33439 "gram.c" /* yacc.c:1646  */
    break;

  case 365:
#line 3007 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DisableRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33450 "gram.c" /* yacc.c:1646  */
    break;

  case 366:
#line 3015 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_ForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33461 "gram.c" /* yacc.c:1646  */
    break;

  case 367:
#line 3023 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_NoForceRowSecurity;
					(yyval.node) = (Node *) n;
				}
#line 33472 "gram.c" /* yacc.c:1646  */
    break;

  case 368:
#line 3030 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_GenericOptions;
					n->def = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 33484 "gram.c" /* yacc.c:1646  */
    break;

  case 369:
#line 3040 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33490 "gram.c" /* yacc.c:1646  */
    break;

  case 370:
#line 3041 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33496 "gram.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3046 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 33509 "gram.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3054 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33515 "gram.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3058 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 33521 "gram.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3059 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33527 "gram.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3064 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_NOTHING;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33539 "gram.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3072 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_FULL;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33551 "gram.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3080 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_DEFAULT;
					n->name = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33563 "gram.c" /* yacc.c:1646  */
    break;

  case 378:
#line 3088 "gram.y" /* yacc.c:1646  */
    {
					ReplicaIdentityStmt *n = makeNode(ReplicaIdentityStmt);

					n->identity_type = REPLICA_IDENTITY_INDEX;
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33575 "gram.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3098 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 33581 "gram.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3101 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 33587 "gram.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3102 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 33593 "gram.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3106 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33599 "gram.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3107 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 33605 "gram.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3113 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33613 "gram.c" /* yacc.c:1646  */
    break;

  case 385:
#line 3117 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 33621 "gram.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3121 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-4].str), (yyvsp[-2].str), (Node *) (yyvsp[0].node),
											 DEFELEM_UNSPEC, (yylsp[-4]));
				}
#line 33630 "gram.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3126 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[-2].str), (yyvsp[0].str), NULL, DEFELEM_UNSPEC, (yylsp[-2]));
				}
#line 33638 "gram.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3133 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 33644 "gram.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3135 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 33650 "gram.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3140 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 33658 "gram.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3144 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 33666 "gram.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3148 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].defelt)->defname, "as") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "restart") == 0 ||
						strcmp((yyvsp[0].defelt)->defname, "owned_by") == 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("sequence option \"%s\" not supported here", (yyvsp[0].defelt)->defname),
								 parser_errposition((yylsp[0]))));
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 33681 "gram.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("generated", (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-2]));
				}
#line 33689 "gram.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3165 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 33695 "gram.c" /* yacc.c:1646  */
    break;

  case 395:
#line 3166 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 33701 "gram.c" /* yacc.c:1646  */
    break;

  case 396:
#line 3170 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 33707 "gram.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3171 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 33713 "gram.c" /* yacc.c:1646  */
    break;

  case 398:
#line 3177 "gram.y" /* yacc.c:1646  */
    {
					ListCell   *lc;
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_HASH;
					n->modulus = n->remainder = -1;

					foreach (lc, (yyvsp[-1].list))
					{
						DefElem    *opt = lfirst_node(DefElem, lc);

						if (strcmp(opt->defname, "modulus") == 0)
						{
							if (n->modulus != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("modulus for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->modulus = defGetInt32(opt);
						}
						else if (strcmp(opt->defname, "remainder") == 0)
						{
							if (n->remainder != -1)
								ereport(ERROR,
										(errcode(ERRCODE_DUPLICATE_OBJECT),
										 errmsg("remainder for hash partition provided more than once"),
										 parser_errposition(opt->location)));
							n->remainder = defGetInt32(opt);
						}
						else
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized hash partition bound specification \"%s\"",
											opt->defname),
									 parser_errposition(opt->location)));
					}

					if (n->modulus == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("modulus for hash partition must be specified")));
					if (n->remainder == -1)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("remainder for hash partition must be specified")));

					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33768 "gram.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3230 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_LIST;
					n->is_default = false;
					n->listdatums = (yyvsp[-1].list);
					n->location = (yylsp[-3]);

					(yyval.partboundspec) = n;
				}
#line 33783 "gram.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3243 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->strategy = PARTITION_STRATEGY_RANGE;
					n->is_default = false;
					n->lowerdatums = (yyvsp[-5].list);
					n->upperdatums = (yyvsp[-1].list);
					n->location = (yylsp[-7]);

					(yyval.partboundspec) = n;
				}
#line 33799 "gram.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3257 "gram.y" /* yacc.c:1646  */
    {
					PartitionBoundSpec *n = makeNode(PartitionBoundSpec);

					n->is_default = true;
					n->location = (yylsp[0]);

					(yyval.partboundspec) = n;
				}
#line 33812 "gram.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3269 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem((yyvsp[-1].str), (Node *) makeInteger((yyvsp[0].ival)), (yylsp[-1]));
			}
#line 33820 "gram.c" /* yacc.c:1646  */
    break;

  case 403:
#line 3276 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1((yyvsp[0].defelt));
			}
#line 33828 "gram.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3280 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
			}
#line 33836 "gram.c" /* yacc.c:1646  */
    break;

  case 405:
#line 3294 "gram.y" /* yacc.c:1646  */
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);

					/* can't use qualified_name, sigh */
					n->relation = makeRangeVarFromAnyName((yyvsp[-1].list), (yylsp[-1]), yyscanner);
					n->cmds = (yyvsp[0].list);
					n->objtype = OBJECT_TYPE;
					(yyval.node) = (Node *) n;
				}
#line 33850 "gram.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3306 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 33856 "gram.c" /* yacc.c:1646  */
    break;

  case 407:
#line 3307 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 33862 "gram.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3313 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_AddColumn;
					n->def = (yyvsp[-1].node);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 33875 "gram.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3323 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 33889 "gram.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3334 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);

					n->subtype = AT_DropColumn;
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 33903 "gram.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3345 "gram.y" /* yacc.c:1646  */
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					ColumnDef *def = makeNode(ColumnDef);

					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[-5].str);
					n->def = (Node *) def;
					n->behavior = (yyvsp[0].dbehavior);
					/* We only use these fields of the ColumnDef node */
					def->typeName = (yyvsp[-2].typnam);
					def->collClause = (CollateClause *) (yyvsp[-1].node);
					def->raw_default = NULL;
					def->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 33923 "gram.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3372 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 33934 "gram.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3379 "gram.y" /* yacc.c:1646  */
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);

					n->portalname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 33945 "gram.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3415 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = (yyvsp[-8].range);
					n->query = NULL;
					n->attlist = (yyvsp[-7].list);
					n->is_from = (yyvsp[-6].boolean);
					n->is_program = (yyvsp[-5].boolean);
					n->filename = (yyvsp[-4].str);
					n->whereClause = (yyvsp[0].node);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-3]))));

					if (!n->is_from && n->whereClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("WHERE clause not allowed with COPY TO"),
								 parser_errposition((yylsp[0]))));

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[-9].defelt))
						n->options = lappend(n->options, (yyvsp[-9].defelt));
					if ((yyvsp[-3].defelt))
						n->options = lappend(n->options, (yyvsp[-3].defelt));
					if ((yyvsp[-1].list))
						n->options = list_concat(n->options, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 33983 "gram.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3449 "gram.y" /* yacc.c:1646  */
    {
					CopyStmt *n = makeNode(CopyStmt);

					n->relation = NULL;
					n->query = (yyvsp[-6].node);
					n->attlist = NIL;
					n->is_from = false;
					n->is_program = (yyvsp[-3].boolean);
					n->filename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);

					if (n->is_program && n->filename == NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("STDIN/STDOUT not allowed with PROGRAM"),
								 parser_errposition((yylsp[-4]))));

					(yyval.node) = (Node *) n;
				}
#line 34007 "gram.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3471 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34013 "gram.c" /* yacc.c:1646  */
    break;

  case 417:
#line 3472 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34019 "gram.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3476 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34025 "gram.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3477 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34031 "gram.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3486 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34037 "gram.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3487 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34043 "gram.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3488 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34049 "gram.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3491 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34055 "gram.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3492 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34061 "gram.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3497 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 34067 "gram.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34073 "gram.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3503 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 34081 "gram.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3507 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("freeze", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 34089 "gram.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3511 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 34097 "gram.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3515 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("null", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 34105 "gram.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("csv"), (yylsp[0]));
				}
#line 34113 "gram.c" /* yacc.c:1646  */
    break;

  case 432:
#line 3523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("header", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 34121 "gram.c" /* yacc.c:1646  */
    break;

  case 433:
#line 3527 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("quote", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 34129 "gram.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3531 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("escape", (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 34137 "gram.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3535 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 34145 "gram.c" /* yacc.c:1646  */
    break;

  case 436:
#line 3539 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 34153 "gram.c" /* yacc.c:1646  */
    break;

  case 437:
#line 3543 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) (yyvsp[0].list), (yylsp[-3]));
				}
#line 34161 "gram.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3547 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *) makeNode(A_Star), (yylsp[-3]));
				}
#line 34169 "gram.c" /* yacc.c:1646  */
    break;

  case 439:
#line 3551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 34177 "gram.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3555 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force_null", (Node *) makeNode(A_Star), (yylsp[-2]));
				}
#line 34185 "gram.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3559 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34193 "gram.c" /* yacc.c:1646  */
    break;

  case 442:
#line 3568 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("format", (Node *) makeString("binary"), (yylsp[0]));
				}
#line 34201 "gram.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3571 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 34207 "gram.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 34215 "gram.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3579 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = NULL; }
#line 34221 "gram.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3590 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 34229 "gram.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3594 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 34237 "gram.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3601 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 34245 "gram.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3607 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34251 "gram.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3608 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 34257 "gram.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3609 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeNode(A_Star); }
#line 34263 "gram.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3610 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString("default"); }
#line 34269 "gram.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3611 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 34275 "gram.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3612 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 34281 "gram.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3617 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34289 "gram.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3621 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34297 "gram.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3628 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 34303 "gram.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3642 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-11].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34325 "gram.c" /* yacc.c:1646  */
    break;

  case 461:
#line 3662 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-9].range)->relpersistence = (yyvsp[-14].ival);
					n->relation = (yyvsp[-9].range);
					n->tableElts = (yyvsp[-7].list);
					n->inhRelations = (yyvsp[-5].list);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34347 "gram.c" /* yacc.c:1646  */
    break;

  case 462:
#line 3682 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-10].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34370 "gram.c" /* yacc.c:1646  */
    break;

  case 463:
#line 3703 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-8].range)->relpersistence = (yyvsp[-13].ival);
					n->relation = (yyvsp[-8].range);
					n->tableElts = (yyvsp[-5].list);
					n->inhRelations = NIL;
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[-6].list));
					n->ofTypename->location = (yylsp[-6]);
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34393 "gram.c" /* yacc.c:1646  */
    break;

  case 464:
#line 3724 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-12].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 34416 "gram.c" /* yacc.c:1646  */
    break;

  case 465:
#line 3745 "gram.y" /* yacc.c:1646  */
    {
					CreateStmt *n = makeNode(CreateStmt);

					(yyvsp[-10].range)->relpersistence = (yyvsp[-15].ival);
					n->relation = (yyvsp[-10].range);
					n->tableElts = (yyvsp[-6].list);
					n->inhRelations = list_make1((yyvsp[-7].range));
					n->partbound = (yyvsp[-5].partboundspec);
					n->partspec = (yyvsp[-4].partspec);
					n->ofTypename = NULL;
					n->constraints = NIL;
					n->accessMethod = (yyvsp[-3].str);
					n->options = (yyvsp[-2].list);
					n->oncommit = (yyvsp[-1].oncommit);
					n->tablespacename = (yyvsp[0].str);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 34439 "gram.c" /* yacc.c:1646  */
    break;

  case 466:
#line 3776 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34445 "gram.c" /* yacc.c:1646  */
    break;

  case 467:
#line 3777 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34451 "gram.c" /* yacc.c:1646  */
    break;

  case 468:
#line 3778 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34457 "gram.c" /* yacc.c:1646  */
    break;

  case 469:
#line 3779 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_TEMP; }
#line 34463 "gram.c" /* yacc.c:1646  */
    break;

  case 470:
#line 3781 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 34474 "gram.c" /* yacc.c:1646  */
    break;

  case 471:
#line 3788 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-1]))));
					(yyval.ival) = RELPERSISTENCE_TEMP;
				}
#line 34485 "gram.c" /* yacc.c:1646  */
    break;

  case 472:
#line 3794 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 34491 "gram.c" /* yacc.c:1646  */
    break;

  case 473:
#line 3795 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 34497 "gram.c" /* yacc.c:1646  */
    break;

  case 474:
#line 3799 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 34503 "gram.c" /* yacc.c:1646  */
    break;

  case 475:
#line 3800 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34509 "gram.c" /* yacc.c:1646  */
    break;

  case 476:
#line 3804 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 34515 "gram.c" /* yacc.c:1646  */
    break;

  case 477:
#line 3805 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34521 "gram.c" /* yacc.c:1646  */
    break;

  case 478:
#line 3810 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34529 "gram.c" /* yacc.c:1646  */
    break;

  case 479:
#line 3814 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34537 "gram.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3821 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 34545 "gram.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3825 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 34553 "gram.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3831 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34559 "gram.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3832 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34565 "gram.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3833 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34571 "gram.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3837 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34577 "gram.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3838 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34583 "gram.c" /* yacc.c:1646  */
    break;

  case 487:
#line 3842 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->storage_name = (yyvsp[-3].str);
					n->compression = (yyvsp[-2].str);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					n->fdwoptions = (yyvsp[-1].list);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 34609 "gram.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3866 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-1].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34632 "gram.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3885 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-3].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collOid = InvalidOid;
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 34655 "gram.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3906 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34661 "gram.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3907 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 34667 "gram.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3911 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34673 "gram.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3912 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34679 "gram.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3916 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34685 "gram.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3917 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("default"); }
#line 34691 "gram.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3921 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 34697 "gram.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3922 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 34703 "gram.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3926 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 34709 "gram.c" /* yacc.c:1646  */
    break;

  case 499:
#line 3927 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 34715 "gram.c" /* yacc.c:1646  */
    break;

  case 500:
#line 3932 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 34727 "gram.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3939 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34733 "gram.c" /* yacc.c:1646  */
    break;

  case 502:
#line 3940 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 34739 "gram.c" /* yacc.c:1646  */
    break;

  case 503:
#line 3942 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Note: the CollateClause is momentarily included in
					 * the list built by ColQualList, but we split it out
					 * again in SplitColQualList.
					 */
					CollateClause *n = makeNode(CollateClause);

					n->arg = NULL;
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34757 "gram.c" /* yacc.c:1646  */
    break;

  case 504:
#line 3974 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34769 "gram.c" /* yacc.c:1646  */
    break;

  case 505:
#line 3982 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34781 "gram.c" /* yacc.c:1646  */
    break;

  case 506:
#line 3990 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-3]);
					n->nulls_not_distinct = !(yyvsp[-2].boolean);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34798 "gram.c" /* yacc.c:1646  */
    break;

  case 507:
#line 4003 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NULL;
					n->options = (yyvsp[-1].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 34814 "gram.c" /* yacc.c:1646  */
    break;

  case 508:
#line 4015 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->is_no_inherit = (yyvsp[0].boolean);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34831 "gram.c" /* yacc.c:1646  */
    break;

  case 509:
#line 4028 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[-1]);
					n->raw_expr = (yyvsp[0].node);
					n->cooked_expr = NULL;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34847 "gram.c" /* yacc.c:1646  */
    break;

  case 510:
#line 4040 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_IDENTITY;
					n->generated_when = (yyvsp[-3].ival);
					n->options = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 34861 "gram.c" /* yacc.c:1646  */
    break;

  case 511:
#line 4050 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_GENERATED;
					n->generated_when = (yyvsp[-5].ival);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					n->location = (yylsp[-6]);

					/*
					 * Can't do this in the grammar because of shift/reduce
					 * conflicts.  (IDENTITY allows both ALWAYS and BY
					 * DEFAULT, but generated columns only allow ALWAYS.)  We
					 * can also give a more useful error message and location.
					 */
					if ((yyvsp[-5].ival) != ATTRIBUTE_IDENTITY_ALWAYS)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("for a generated column, GENERATED ALWAYS must be specified"),
								 parser_errposition((yylsp[-5]))));

					(yyval.node) = (Node *) n;
				}
#line 34889 "gram.c" /* yacc.c:1646  */
    break;

  case 512:
#line 4074 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-4]);
					n->pktable = (yyvsp[-3].range);
					n->fk_attrs = NIL;
					n->pk_attrs = (yyvsp[-2].list);
					n->fk_matchtype = (yyvsp[-1].ival);
					n->fk_upd_action = ((yyvsp[0].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[0].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[0].keyactions))->deleteAction->cols;
					n->skip_validation = false;
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 34910 "gram.c" /* yacc.c:1646  */
    break;

  case 513:
#line 4093 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34916 "gram.c" /* yacc.c:1646  */
    break;

  case 514:
#line 4094 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 34922 "gram.c" /* yacc.c:1646  */
    break;

  case 515:
#line 4095 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 34928 "gram.c" /* yacc.c:1646  */
    break;

  case 516:
#line 4099 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_ALWAYS; }
#line 34934 "gram.c" /* yacc.c:1646  */
    break;

  case 517:
#line 4100 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ATTRIBUTE_IDENTITY_BY_DEFAULT; }
#line 34940 "gram.c" /* yacc.c:1646  */
    break;

  case 518:
#line 4120 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 34952 "gram.c" /* yacc.c:1646  */
    break;

  case 519:
#line 4128 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34964 "gram.c" /* yacc.c:1646  */
    break;

  case 520:
#line 4136 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34976 "gram.c" /* yacc.c:1646  */
    break;

  case 521:
#line 4144 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 34988 "gram.c" /* yacc.c:1646  */
    break;

  case 522:
#line 4156 "gram.y" /* yacc.c:1646  */
    {
					TableLikeClause *n = makeNode(TableLikeClause);

					n->relation = (yyvsp[-1].range);
					n->options = (yyvsp[0].ival);
					n->relationOid = InvalidOid;
					(yyval.node) = (Node *) n;
				}
#line 35001 "gram.c" /* yacc.c:1646  */
    break;

  case 523:
#line 4167 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | (yyvsp[0].ival); }
#line 35007 "gram.c" /* yacc.c:1646  */
    break;

  case 524:
#line 4168 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) & ~(yyvsp[0].ival); }
#line 35013 "gram.c" /* yacc.c:1646  */
    break;

  case 525:
#line 4169 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 35019 "gram.c" /* yacc.c:1646  */
    break;

  case 526:
#line 4173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; }
#line 35025 "gram.c" /* yacc.c:1646  */
    break;

  case 527:
#line 4174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_COMPRESSION; }
#line 35031 "gram.c" /* yacc.c:1646  */
    break;

  case 528:
#line 4175 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; }
#line 35037 "gram.c" /* yacc.c:1646  */
    break;

  case 529:
#line 4176 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; }
#line 35043 "gram.c" /* yacc.c:1646  */
    break;

  case 530:
#line 4177 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_IDENTITY; }
#line 35049 "gram.c" /* yacc.c:1646  */
    break;

  case 531:
#line 4178 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_GENERATED; }
#line 35055 "gram.c" /* yacc.c:1646  */
    break;

  case 532:
#line 4179 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; }
#line 35061 "gram.c" /* yacc.c:1646  */
    break;

  case 533:
#line 4180 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STATISTICS; }
#line 35067 "gram.c" /* yacc.c:1646  */
    break;

  case 534:
#line 4181 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; }
#line 35073 "gram.c" /* yacc.c:1646  */
    break;

  case 535:
#line 4182 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; }
#line 35079 "gram.c" /* yacc.c:1646  */
    break;

  case 536:
#line 4192 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 35091 "gram.c" /* yacc.c:1646  */
    break;

  case 537:
#line 4199 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35097 "gram.c" /* yacc.c:1646  */
    break;

  case 538:
#line 4204 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 35115 "gram.c" /* yacc.c:1646  */
    break;

  case 539:
#line 4219 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-8]);
					n->nulls_not_distinct = !(yyvsp[-7].boolean);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35136 "gram.c" /* yacc.c:1646  */
    break;

  case 540:
#line 4236 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[-2]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "UNIQUE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35156 "gram.c" /* yacc.c:1646  */
    break;

  case 541:
#line 4253 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-8]);
					n->keys = (yyvsp[-5].list);
					n->including = (yyvsp[-3].list);
					n->options = (yyvsp[-2].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-1].str);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35176 "gram.c" /* yacc.c:1646  */
    break;

  case 542:
#line 4269 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[-3]);
					n->keys = NIL;
					n->including = NIL;
					n->options = NIL;
					n->indexname = (yyvsp[-1].str);
					n->indexspace = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "PRIMARY KEY",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35196 "gram.c" /* yacc.c:1646  */
    break;

  case 543:
#line 4287 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[-9]);
					n->access_method = (yyvsp[-8].str);
					n->exclusions = (yyvsp[-6].list);
					n->including = (yyvsp[-4].list);
					n->options = (yyvsp[-3].list);
					n->indexname = NULL;
					n->indexspace = (yyvsp[-2].str);
					n->where_clause = (yyvsp[-1].node);
					processCASbits((yyvsp[0].ival), (yylsp[0]), "EXCLUDE",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 35218 "gram.c" /* yacc.c:1646  */
    break;

  case 544:
#line 4306 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[-10]);
					n->pktable = (yyvsp[-4].range);
					n->fk_attrs = (yyvsp[-7].list);
					n->pk_attrs = (yyvsp[-3].list);
					n->fk_matchtype = (yyvsp[-2].ival);
					n->fk_upd_action = ((yyvsp[-1].keyactions))->updateAction->action;
					n->fk_del_action = ((yyvsp[-1].keyactions))->deleteAction->action;
					n->fk_del_set_cols = ((yyvsp[-1].keyactions))->deleteAction->cols;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "FOREIGN KEY",
								   &n->deferrable, &n->initdeferred,
								   &n->skip_validation, NULL,
								   yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 35242 "gram.c" /* yacc.c:1646  */
    break;

  case 545:
#line 4340 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = castNode(Constraint, (yyvsp[0].node));

					n->conname = (yyvsp[-1].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 35254 "gram.c" /* yacc.c:1646  */
    break;

  case 546:
#line 4347 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 35260 "gram.c" /* yacc.c:1646  */
    break;

  case 547:
#line 4352 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_CHECK;
					n->location = (yylsp[-4]);
					n->raw_expr = (yyvsp[-2].node);
					n->cooked_expr = NULL;
					processCASbits((yyvsp[0].ival), (yylsp[0]), "CHECK",
								   NULL, NULL, &n->skip_validation,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = !n->skip_validation;
					(yyval.node) = (Node *) n;
				}
#line 35278 "gram.c" /* yacc.c:1646  */
    break;

  case 548:
#line 4366 "gram.y" /* yacc.c:1646  */
    {
					Constraint *n = makeNode(Constraint);

					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[-2]);
					n->keys = list_make1(makeString("value"));
					/* no NOT VALID support yet */
					processCASbits((yyvsp[0].ival), (yylsp[0]), "NOT NULL",
								   NULL, NULL, NULL,
								   &n->is_no_inherit, yyscanner);
					n->initially_valid = true;
					(yyval.node) = (Node *) n;
				}
#line 35296 "gram.c" /* yacc.c:1646  */
    break;

  case 549:
#line 4381 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = true; }
#line 35302 "gram.c" /* yacc.c:1646  */
    break;

  case 550:
#line 4382 "gram.y" /* yacc.c:1646  */
    {  (yyval.boolean) = false; }
#line 35308 "gram.c" /* yacc.c:1646  */
    break;

  case 551:
#line 4386 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35314 "gram.c" /* yacc.c:1646  */
    break;

  case 552:
#line 4387 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35320 "gram.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4391 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 35326 "gram.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4392 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 35332 "gram.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4396 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 35340 "gram.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4401 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35346 "gram.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4402 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35352 "gram.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4406 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			}
#line 35360 "gram.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4410 "gram.y" /* yacc.c:1646  */
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[-1]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			}
#line 35372 "gram.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4418 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 35380 "gram.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4422 "gram.y" /* yacc.c:1646  */
    {
				(yyval.ival) = FKCONSTR_MATCH_SIMPLE;
			}
#line 35388 "gram.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 35394 "gram.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4430 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 35400 "gram.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4434 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-2].ielem), (yyvsp[0].list));
			}
#line 35408 "gram.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4439 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make2((yyvsp[-5].ielem), (yyvsp[-1].list));
			}
#line 35416 "gram.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4445 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 35422 "gram.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4446 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 35428 "gram.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4451 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 35442 "gram.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4461 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 35456 "gram.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4471 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[-1].keyaction);
					n->deleteAction = (yyvsp[0].keyaction);
					(yyval.keyactions) = n;
				}
#line 35468 "gram.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4479 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = (yyvsp[0].keyaction);
					n->deleteAction = (yyvsp[-1].keyaction);
					(yyval.keyactions) = n;
				}
#line 35480 "gram.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4487 "gram.y" /* yacc.c:1646  */
    {
					KeyActions *n = palloc(sizeof(KeyActions));

					n->updateAction = palloc(sizeof(KeyAction));
					n->updateAction->action = FKCONSTR_ACTION_NOACTION;
					n->updateAction->cols = NIL;
					n->deleteAction = palloc(sizeof(KeyAction));
					n->deleteAction->action = FKCONSTR_ACTION_NOACTION;
					n->deleteAction->cols = NIL;
					(yyval.keyactions) = n;
				}
#line 35496 "gram.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4501 "gram.y" /* yacc.c:1646  */
    {
					if (((yyvsp[0].keyaction))->cols)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("a column list with %s is only supported for ON DELETE actions",
										((yyvsp[0].keyaction))->action == FKCONSTR_ACTION_SETNULL ? "SET NULL" : "SET DEFAULT"),
								 parser_errposition((yylsp[-2]))));
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 35510 "gram.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.keyaction) = (yyvsp[0].keyaction);
				}
#line 35518 "gram.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4520 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_NOACTION;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35530 "gram.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4528 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_RESTRICT;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35542 "gram.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4536 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_CASCADE;
					n->cols = NIL;
					(yyval.keyaction) = n;
				}
#line 35554 "gram.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4544 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETNULL;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 35566 "gram.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4552 "gram.y" /* yacc.c:1646  */
    {
					KeyAction *n = palloc(sizeof(KeyAction));

					n->action = FKCONSTR_ACTION_SETDEFAULT;
					n->cols = (yyvsp[0].list);
					(yyval.keyaction) = n;
				}
#line 35578 "gram.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4561 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 35584 "gram.c" /* yacc.c:1646  */
    break;

  case 581:
#line 4562 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35590 "gram.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4566 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = (yyvsp[0].partspec); }
#line 35596 "gram.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4567 "gram.y" /* yacc.c:1646  */
    { (yyval.partspec) = NULL; }
#line 35602 "gram.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4571 "gram.y" /* yacc.c:1646  */
    {
					PartitionSpec *n = makeNode(PartitionSpec);

					n->strategy = parsePartitionStrategy((yyvsp[-3].str));
					n->partParams = (yyvsp[-1].list);
					n->location = (yylsp[-5]);

					(yyval.partspec) = n;
				}
#line 35616 "gram.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4582 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].partelem)); }
#line 35622 "gram.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4583 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].partelem)); }
#line 35628 "gram.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4587 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = (yyvsp[-2].str);
					n->expr = NULL;
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35643 "gram.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4598 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-2].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-2]);
					(yyval.partelem) = n;
				}
#line 35658 "gram.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4609 "gram.y" /* yacc.c:1646  */
    {
					PartitionElem *n = makeNode(PartitionElem);

					n->name = NULL;
					n->expr = (yyvsp[-3].node);
					n->collation = (yyvsp[-1].list);
					n->opclass = (yyvsp[0].list);
					n->location = (yylsp[-4]);
					(yyval.partelem) = n;
				}
#line 35673 "gram.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4622 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35679 "gram.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4623 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35685 "gram.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4628 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 35691 "gram.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4629 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35697 "gram.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4630 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 35703 "gram.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4633 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DROP; }
#line 35709 "gram.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4634 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; }
#line 35715 "gram.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4635 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; }
#line 35721 "gram.c" /* yacc.c:1646  */
    break;

  case 598:
#line 4636 "gram.y" /* yacc.c:1646  */
    { (yyval.oncommit) = ONCOMMIT_NOOP; }
#line 35727 "gram.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4639 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35733 "gram.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4640 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35739 "gram.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4643 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35745 "gram.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4644 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 35751 "gram.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4647 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 35757 "gram.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4669 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 35773 "gram.c" /* yacc.c:1646  */
    break;

  case 605:
#line 4682 "gram.y" /* yacc.c:1646  */
    {
					CreateStatsStmt *n = makeNode(CreateStatsStmt);

					n->defnames = (yyvsp[-5].list);
					n->stat_types = (yyvsp[-4].list);
					n->exprs = (yyvsp[-2].list);
					n->relations = (yyvsp[0].list);
					n->stxcomment = NULL;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 35789 "gram.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4702 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].selem)); }
#line 35795 "gram.c" /* yacc.c:1646  */
    break;

  case 607:
#line 4703 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].selem)); }
#line 35801 "gram.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4707 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = (yyvsp[0].str);
					(yyval.selem)->expr = NULL;
				}
#line 35811 "gram.c" /* yacc.c:1646  */
    break;

  case 609:
#line 4713 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[0].node);
				}
#line 35821 "gram.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selem) = makeNode(StatsElem);
					(yyval.selem)->name = NULL;
					(yyval.selem)->expr = (yyvsp[-1].node);
				}
#line 35831 "gram.c" /* yacc.c:1646  */
    break;

  case 611:
#line 4736 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = false;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35844 "gram.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4745 "gram.y" /* yacc.c:1646  */
    {
					AlterStatsStmt *n = makeNode(AlterStatsStmt);

					n->defnames = (yyvsp[-3].list);
					n->missing_ok = true;
					n->stxstattarget = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 35857 "gram.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4767 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-5].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35875 "gram.c" /* yacc.c:1646  */
    break;

  case 614:
#line 4781 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-8].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35893 "gram.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4799 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-5].range);
					(yyval.into)->colNames = (yyvsp[-4].list);
					(yyval.into)->accessMethod = (yyvsp[-3].str);
					(yyval.into)->options = (yyvsp[-2].list);
					(yyval.into)->onCommit = (yyvsp[-1].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35909 "gram.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4813 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35915 "gram.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4814 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 35921 "gram.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4815 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 35927 "gram.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4828 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-6].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35945 "gram.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4842 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);

					ctas->query = (yyvsp[-1].node);
					ctas->into = (yyvsp[-3].into);
					ctas->objtype = OBJECT_MATVIEW;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-3].into)->rel->relpersistence = (yyvsp[-9].ival);
					(yyvsp[-3].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 35963 "gram.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4859 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[-4].range);
					(yyval.into)->colNames = (yyvsp[-3].list);
					(yyval.into)->accessMethod = (yyvsp[-2].str);
					(yyval.into)->options = (yyvsp[-1].list);
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = (yyvsp[0].str);
					(yyval.into)->viewQuery = NULL;		/* filled at analysis time */
					(yyval.into)->skipData = false;		/* might get changed later */
				}
#line 35979 "gram.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4872 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_UNLOGGED; }
#line 35985 "gram.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4873 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RELPERSISTENCE_PERMANENT; }
#line 35991 "gram.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4886 "gram.y" /* yacc.c:1646  */
    {
					RefreshMatViewStmt *n = makeNode(RefreshMatViewStmt);

					n->concurrent = (yyvsp[-2].boolean);
					n->relation = (yyvsp[-1].range);
					n->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) n;
				}
#line 36004 "gram.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4907 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-3].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36019 "gram.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4918 "gram.y" /* yacc.c:1646  */
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);

					(yyvsp[-1].range)->relpersistence = (yyvsp[-6].ival);
					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->ownerId = InvalidOid;
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36034 "gram.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4932 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 36047 "gram.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4941 "gram.y" /* yacc.c:1646  */
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);

					n->sequence = (yyvsp[-1].range);
					n->options = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 36060 "gram.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4952 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36066 "gram.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4953 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36072 "gram.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4956 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36078 "gram.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4957 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36084 "gram.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4960 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36090 "gram.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4961 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36096 "gram.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4965 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].typnam), (yylsp[-1]));
				}
#line 36104 "gram.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4969 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cache", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 36112 "gram.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4973 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 36120 "gram.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4977 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 36128 "gram.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("increment", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36136 "gram.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4985 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 36144 "gram.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4989 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 36152 "gram.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4993 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL, (yylsp[-1]));
				}
#line 36160 "gram.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4997 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL, (yylsp[-1]));
				}
#line 36168 "gram.c" /* yacc.c:1646  */
    break;

  case 644:
#line 5001 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 36176 "gram.c" /* yacc.c:1646  */
    break;

  case 645:
#line 5005 "gram.y" /* yacc.c:1646  */
    {
					/* not documented, only used by pg_dump */
					(yyval.defelt) = makeDefElem("sequence_name", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 36185 "gram.c" /* yacc.c:1646  */
    break;

  case 646:
#line 5010 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("start", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36193 "gram.c" /* yacc.c:1646  */
    break;

  case 647:
#line 5014 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", NULL, (yylsp[0]));
				}
#line 36201 "gram.c" /* yacc.c:1646  */
    break;

  case 648:
#line 5018 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("restart", (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 36209 "gram.c" /* yacc.c:1646  */
    break;

  case 651:
#line 5028 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 36215 "gram.c" /* yacc.c:1646  */
    break;

  case 652:
#line 5029 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeFloat((yyvsp[0].str)); }
#line 36221 "gram.c" /* yacc.c:1646  */
    break;

  case 653:
#line 5031 "gram.y" /* yacc.c:1646  */
    {
					Float	   *f = makeFloat((yyvsp[0].str));

					doNegateFloat(f);
					(yyval.node) = (Node *) f;
				}
#line 36232 "gram.c" /* yacc.c:1646  */
    break;

  case 654:
#line 5037 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeInteger((yyvsp[0].ival)); }
#line 36238 "gram.c" /* yacc.c:1646  */
    break;

  case 655:
#line 5040 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 36244 "gram.c" /* yacc.c:1646  */
    break;

  case 656:
#line 5041 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 36250 "gram.c" /* yacc.c:1646  */
    break;

  case 657:
#line 5054 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * We now interpret parameterless CREATE LANGUAGE as
				 * CREATE EXTENSION.  "OR REPLACE" is silently translated
				 * to "IF NOT EXISTS", which isn't quite the same, but
				 * seems more useful than throwing an error.  We just
				 * ignore TRUSTED, as the previous code would have too.
				 */
				CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

				n->if_not_exists = (yyvsp[-4].boolean);
				n->extname = (yyvsp[0].str);
				n->options = NIL;
				(yyval.node) = (Node *) n;
			}
#line 36270 "gram.c" /* yacc.c:1646  */
    break;

  case 658:
#line 5071 "gram.y" /* yacc.c:1646  */
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);

				n->replace = (yyvsp[-8].boolean);
				n->plname = (yyvsp[-4].str);
				n->plhandler = (yyvsp[-2].list);
				n->plinline = (yyvsp[-1].list);
				n->plvalidator = (yyvsp[0].list);
				n->pltrusted = (yyvsp[-7].boolean);
				(yyval.node) = (Node *) n;
			}
#line 36286 "gram.c" /* yacc.c:1646  */
    break;

  case 659:
#line 5085 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 36292 "gram.c" /* yacc.c:1646  */
    break;

  case 660:
#line 5086 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 36298 "gram.c" /* yacc.c:1646  */
    break;

  case 661:
#line 5094 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 36304 "gram.c" /* yacc.c:1646  */
    break;

  case 662:
#line 5095 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 36310 "gram.c" /* yacc.c:1646  */
    break;

  case 663:
#line 5099 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36316 "gram.c" /* yacc.c:1646  */
    break;

  case 664:
#line 5100 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36322 "gram.c" /* yacc.c:1646  */
    break;

  case 665:
#line 5104 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36328 "gram.c" /* yacc.c:1646  */
    break;

  case 666:
#line 5105 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36334 "gram.c" /* yacc.c:1646  */
    break;

  case 667:
#line 5109 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36340 "gram.c" /* yacc.c:1646  */
    break;

  case 668:
#line 5110 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36346 "gram.c" /* yacc.c:1646  */
    break;

  case 671:
#line 5126 "gram.y" /* yacc.c:1646  */
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);

					n->tablespacename = (yyvsp[-4].str);
					n->owner = (yyvsp[-3].rolespec);
					n->location = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36360 "gram.c" /* yacc.c:1646  */
    break;

  case 672:
#line 5137 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 36366 "gram.c" /* yacc.c:1646  */
    break;

  case 673:
#line 5138 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 36372 "gram.c" /* yacc.c:1646  */
    break;

  case 674:
#line 5152 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 36384 "gram.c" /* yacc.c:1646  */
    break;

  case 675:
#line 5160 "gram.y" /* yacc.c:1646  */
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);

					n->tablespacename = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 36396 "gram.c" /* yacc.c:1646  */
    break;

  case 676:
#line 5178 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = false;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36409 "gram.c" /* yacc.c:1646  */
    break;

  case 677:
#line 5187 "gram.y" /* yacc.c:1646  */
    {
					CreateExtensionStmt *n = makeNode(CreateExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->if_not_exists = true;
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36422 "gram.c" /* yacc.c:1646  */
    break;

  case 678:
#line 5199 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36428 "gram.c" /* yacc.c:1646  */
    break;

  case 679:
#line 5201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36434 "gram.c" /* yacc.c:1646  */
    break;

  case 680:
#line 5206 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schema", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36442 "gram.c" /* yacc.c:1646  */
    break;

  case 681:
#line 5210 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36450 "gram.c" /* yacc.c:1646  */
    break;

  case 682:
#line 5214 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE EXTENSION ... FROM is no longer supported"),
							 parser_errposition((yylsp[-1]))));
				}
#line 36461 "gram.c" /* yacc.c:1646  */
    break;

  case 683:
#line 5221 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cascade", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 36469 "gram.c" /* yacc.c:1646  */
    break;

  case 684:
#line 5233 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionStmt *n = makeNode(AlterExtensionStmt);

					n->extname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36481 "gram.c" /* yacc.c:1646  */
    break;

  case 685:
#line 5244 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36487 "gram.c" /* yacc.c:1646  */
    break;

  case 686:
#line 5246 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36493 "gram.c" /* yacc.c:1646  */
    break;

  case 687:
#line 5251 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("new_version", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 36501 "gram.c" /* yacc.c:1646  */
    break;

  case 688:
#line 5264 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) makeString((yyvsp[0].str));
					(yyval.node) = (Node *) n;
				}
#line 36515 "gram.c" /* yacc.c:1646  */
    break;

  case 689:
#line 5274 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = (yyvsp[-1].objtype);
					n->object = (Node *) (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36529 "gram.c" /* yacc.c:1646  */
    break;

  case 690:
#line 5284 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36543 "gram.c" /* yacc.c:1646  */
    break;

  case 691:
#line 5294 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-7].str);
					n->action = (yyvsp[-6].ival);
					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam));
					(yyval.node) = (Node *) n;
				}
#line 36557 "gram.c" /* yacc.c:1646  */
    break;

  case 692:
#line 5304 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36571 "gram.c" /* yacc.c:1646  */
    break;

  case 693:
#line 5314 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36585 "gram.c" /* yacc.c:1646  */
    break;

  case 694:
#line 5324 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36599 "gram.c" /* yacc.c:1646  */
    break;

  case 695:
#line 5334 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36613 "gram.c" /* yacc.c:1646  */
    break;

  case 696:
#line 5344 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[0].str)), (yyvsp[-2].list));
					(yyval.node) = (Node *) n;
				}
#line 36627 "gram.c" /* yacc.c:1646  */
    break;

  case 697:
#line 5354 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36641 "gram.c" /* yacc.c:1646  */
    break;

  case 698:
#line 5364 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[0].objwithargs);
					(yyval.node) = (Node *) n;
				}
#line 36655 "gram.c" /* yacc.c:1646  */
    break;

  case 699:
#line 5374 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-6].str);
					n->action = (yyvsp[-5].ival);
					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-2].typnam), makeString((yyvsp[0].str)));
					(yyval.node) = (Node *) n;
				}
#line 36669 "gram.c" /* yacc.c:1646  */
    break;

  case 700:
#line 5384 "gram.y" /* yacc.c:1646  */
    {
					AlterExtensionContentsStmt *n = makeNode(AlterExtensionContentsStmt);

					n->extname = (yyvsp[-3].str);
					n->action = (yyvsp[-2].ival);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 36683 "gram.c" /* yacc.c:1646  */
    break;

  case 701:
#line 5403 "gram.y" /* yacc.c:1646  */
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36696 "gram.c" /* yacc.c:1646  */
    break;

  case 702:
#line 5414 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36702 "gram.c" /* yacc.c:1646  */
    break;

  case 703:
#line 5415 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("handler", NULL, (yylsp[-1])); }
#line 36708 "gram.c" /* yacc.c:1646  */
    break;

  case 704:
#line 5416 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", (Node *) (yyvsp[0].list), (yylsp[-1])); }
#line 36714 "gram.c" /* yacc.c:1646  */
    break;

  case 705:
#line 5417 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("validator", NULL, (yylsp[-1])); }
#line 36720 "gram.c" /* yacc.c:1646  */
    break;

  case 706:
#line 5421 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 36726 "gram.c" /* yacc.c:1646  */
    break;

  case 707:
#line 5422 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 36732 "gram.c" /* yacc.c:1646  */
    break;

  case 708:
#line 5426 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 36738 "gram.c" /* yacc.c:1646  */
    break;

  case 709:
#line 5427 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36744 "gram.c" /* yacc.c:1646  */
    break;

  case 710:
#line 5438 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-2].str);
					n->func_options = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36757 "gram.c" /* yacc.c:1646  */
    break;

  case 711:
#line 5447 "gram.y" /* yacc.c:1646  */
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);

					n->fdwname = (yyvsp[-1].str);
					n->func_options = (yyvsp[0].list);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 36770 "gram.c" /* yacc.c:1646  */
    break;

  case 712:
#line 5459 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36776 "gram.c" /* yacc.c:1646  */
    break;

  case 713:
#line 5460 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 36782 "gram.c" /* yacc.c:1646  */
    break;

  case 714:
#line 5465 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36790 "gram.c" /* yacc.c:1646  */
    break;

  case 715:
#line 5469 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36798 "gram.c" /* yacc.c:1646  */
    break;

  case 716:
#line 5476 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 36804 "gram.c" /* yacc.c:1646  */
    break;

  case 717:
#line 5481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 36812 "gram.c" /* yacc.c:1646  */
    break;

  case 718:
#line 5485 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 36820 "gram.c" /* yacc.c:1646  */
    break;

  case 719:
#line 5492 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 36828 "gram.c" /* yacc.c:1646  */
    break;

  case 720:
#line 5496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				}
#line 36837 "gram.c" /* yacc.c:1646  */
    break;

  case 721:
#line 5501 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				}
#line 36846 "gram.c" /* yacc.c:1646  */
    break;

  case 722:
#line 5506 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[0].str), NULL, DEFELEM_DROP, (yylsp[0]));
				}
#line 36854 "gram.c" /* yacc.c:1646  */
    break;

  case 723:
#line 5513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 36862 "gram.c" /* yacc.c:1646  */
    break;

  case 724:
#line 5519 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36868 "gram.c" /* yacc.c:1646  */
    break;

  case 725:
#line 5524 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 36874 "gram.c" /* yacc.c:1646  */
    break;

  case 726:
#line 5536 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 36890 "gram.c" /* yacc.c:1646  */
    break;

  case 727:
#line 5549 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);

					n->servername = (yyvsp[-7].str);
					n->servertype = (yyvsp[-6].str);
					n->version = (yyvsp[-5].str);
					n->fdwname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 36906 "gram.c" /* yacc.c:1646  */
    break;

  case 728:
#line 5563 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36912 "gram.c" /* yacc.c:1646  */
    break;

  case 729:
#line 5564 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36918 "gram.c" /* yacc.c:1646  */
    break;

  case 730:
#line 5569 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36924 "gram.c" /* yacc.c:1646  */
    break;

  case 731:
#line 5570 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36930 "gram.c" /* yacc.c:1646  */
    break;

  case 732:
#line 5574 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 36936 "gram.c" /* yacc.c:1646  */
    break;

  case 733:
#line 5575 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 36942 "gram.c" /* yacc.c:1646  */
    break;

  case 734:
#line 5586 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-2].str);
					n->version = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36956 "gram.c" /* yacc.c:1646  */
    break;

  case 735:
#line 5596 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->version = (yyvsp[0].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				}
#line 36969 "gram.c" /* yacc.c:1646  */
    break;

  case 736:
#line 5605 "gram.y" /* yacc.c:1646  */
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);

					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 36981 "gram.c" /* yacc.c:1646  */
    break;

  case 737:
#line 5625 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37004 "gram.c" /* yacc.c:1646  */
    break;

  case 738:
#line 5646 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-7].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-7].range);
					n->base.tableElts = (yyvsp[-5].list);
					n->base.inhRelations = (yyvsp[-3].list);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37027 "gram.c" /* yacc.c:1646  */
    break;

  case 739:
#line 5667 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = false;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37051 "gram.c" /* yacc.c:1646  */
    break;

  case 740:
#line 5689 "gram.y" /* yacc.c:1646  */
    {
					CreateForeignTableStmt *n = makeNode(CreateForeignTableStmt);

					(yyvsp[-8].range)->relpersistence = RELPERSISTENCE_PERMANENT;
					n->base.relation = (yyvsp[-8].range);
					n->base.inhRelations = list_make1((yyvsp[-5].range));
					n->base.tableElts = (yyvsp[-4].list);
					n->base.partbound = (yyvsp[-3].partboundspec);
					n->base.ofTypename = NULL;
					n->base.constraints = NIL;
					n->base.options = NIL;
					n->base.oncommit = ONCOMMIT_NOOP;
					n->base.tablespacename = NULL;
					n->base.if_not_exists = true;
					/* FDW-specific data */
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37075 "gram.c" /* yacc.c:1646  */
    break;

  case 741:
#line 5722 "gram.y" /* yacc.c:1646  */
    {
				ImportForeignSchemaStmt *n = makeNode(ImportForeignSchemaStmt);

				n->server_name = (yyvsp[-3].str);
				n->remote_schema = (yyvsp[-7].str);
				n->local_schema = (yyvsp[-1].str);
				n->list_type = (yyvsp[-6].importqual)->type;
				n->table_list = (yyvsp[-6].importqual)->table_names;
				n->options = (yyvsp[0].list);
				(yyval.node) = (Node *) n;
			}
#line 37091 "gram.c" /* yacc.c:1646  */
    break;

  case 742:
#line 5736 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_LIMIT_TO; }
#line 37097 "gram.c" /* yacc.c:1646  */
    break;

  case 743:
#line 5737 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FDW_IMPORT_SCHEMA_EXCEPT; }
#line 37103 "gram.c" /* yacc.c:1646  */
    break;

  case 744:
#line 5742 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));

				n->type = (yyvsp[-3].ival);
				n->table_names = (yyvsp[-1].list);
				(yyval.importqual) = n;
			}
#line 37115 "gram.c" /* yacc.c:1646  */
    break;

  case 745:
#line 5750 "gram.y" /* yacc.c:1646  */
    {
				ImportQual *n = (ImportQual *) palloc(sizeof(ImportQual));
				n->type = FDW_IMPORT_SCHEMA_ALL;
				n->table_names = NIL;
				(yyval.importqual) = n;
			}
#line 37126 "gram.c" /* yacc.c:1646  */
    break;

  case 746:
#line 5766 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = false;
					(yyval.node) = (Node *) n;
				}
#line 37140 "gram.c" /* yacc.c:1646  */
    break;

  case 747:
#line 5776 "gram.y" /* yacc.c:1646  */
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 37154 "gram.c" /* yacc.c:1646  */
    break;

  case 748:
#line 5788 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 37160 "gram.c" /* yacc.c:1646  */
    break;

  case 749:
#line 5789 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0])); }
#line 37166 "gram.c" /* yacc.c:1646  */
    break;

  case 750:
#line 5802 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 37179 "gram.c" /* yacc.c:1646  */
    break;

  case 751:
#line 5811 "gram.y" /* yacc.c:1646  */
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);

					n->user = (yyvsp[-2].rolespec);
					n->servername = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 37192 "gram.c" /* yacc.c:1646  */
    break;

  case 752:
#line 5829 "gram.y" /* yacc.c:1646  */
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);

					n->user = (yyvsp[-3].rolespec);
					n->servername = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37205 "gram.c" /* yacc.c:1646  */
    break;

  case 753:
#line 5856 "gram.y" /* yacc.c:1646  */
    {
					CreatePolicyStmt *n = makeNode(CreatePolicyStmt);

					n->policy_name = (yyvsp[-7].str);
					n->table = (yyvsp[-5].range);
					n->permissive = (yyvsp[-4].boolean);
					n->cmd_name = (yyvsp[-3].str);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37222 "gram.c" /* yacc.c:1646  */
    break;

  case 754:
#line 5873 "gram.y" /* yacc.c:1646  */
    {
					AlterPolicyStmt *n = makeNode(AlterPolicyStmt);

					n->policy_name = (yyvsp[-5].str);
					n->table = (yyvsp[-3].range);
					n->roles = (yyvsp[-2].list);
					n->qual = (yyvsp[-1].node);
					n->with_check = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 37237 "gram.c" /* yacc.c:1646  */
    break;

  case 755:
#line 5886 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 37243 "gram.c" /* yacc.c:1646  */
    break;

  case 756:
#line 5887 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37249 "gram.c" /* yacc.c:1646  */
    break;

  case 757:
#line 5891 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 37255 "gram.c" /* yacc.c:1646  */
    break;

  case 758:
#line 5892 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37261 "gram.c" /* yacc.c:1646  */
    break;

  case 759:
#line 5896 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37267 "gram.c" /* yacc.c:1646  */
    break;

  case 760:
#line 5897 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeRoleSpec(ROLESPEC_PUBLIC, -1)); }
#line 37273 "gram.c" /* yacc.c:1646  */
    break;

  case 761:
#line 5901 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37279 "gram.c" /* yacc.c:1646  */
    break;

  case 762:
#line 5902 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 37285 "gram.c" /* yacc.c:1646  */
    break;

  case 763:
#line 5907 "gram.y" /* yacc.c:1646  */
    {
					if (strcmp((yyvsp[0].str), "permissive") == 0)
						(yyval.boolean) = true;
					else if (strcmp((yyvsp[0].str), "restrictive") == 0)
						(yyval.boolean) = false;
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("unrecognized row security option \"%s\"", (yyvsp[0].str)),
								 errhint("Only PERMISSIVE or RESTRICTIVE policies are supported currently."),
								 parser_errposition((yylsp[0]))));

				}
#line 37303 "gram.c" /* yacc.c:1646  */
    break;

  case 764:
#line 5920 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37309 "gram.c" /* yacc.c:1646  */
    break;

  case 765:
#line 5924 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37315 "gram.c" /* yacc.c:1646  */
    break;

  case 766:
#line 5925 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 37321 "gram.c" /* yacc.c:1646  */
    break;

  case 767:
#line 5929 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "all"; }
#line 37327 "gram.c" /* yacc.c:1646  */
    break;

  case 768:
#line 5930 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "select"; }
#line 37333 "gram.c" /* yacc.c:1646  */
    break;

  case 769:
#line 5931 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "insert"; }
#line 37339 "gram.c" /* yacc.c:1646  */
    break;

  case 770:
#line 5932 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "update"; }
#line 37345 "gram.c" /* yacc.c:1646  */
    break;

  case 771:
#line 5933 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "delete"; }
#line 37351 "gram.c" /* yacc.c:1646  */
    break;

  case 772:
#line 5944 "gram.y" /* yacc.c:1646  */
    {
					CreateAmStmt *n = makeNode(CreateAmStmt);

					n->amname = (yyvsp[-4].str);
					n->handler_name = (yyvsp[0].list);
					n->amtype = (yyvsp[-2].chr);
					(yyval.node) = (Node *) n;
				}
#line 37364 "gram.c" /* yacc.c:1646  */
    break;

  case 773:
#line 5955 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_INDEX; }
#line 37370 "gram.c" /* yacc.c:1646  */
    break;

  case 774:
#line 5956 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = AMTYPE_TABLE; }
#line 37376 "gram.c" /* yacc.c:1646  */
    break;

  case 775:
#line 5970 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-15].boolean);
					n->isconstraint = false;
					n->trigname = (yyvsp[-13].str);
					n->relation = (yyvsp[-9].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = (yyvsp[-7].boolean);
					n->timing = (yyvsp[-12].ival);
					n->events = intVal(linitial((yyvsp[-11].list)));
					n->columns = (List *) lsecond((yyvsp[-11].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = (yyvsp[-8].list);
					n->deferrable = false;
					n->initdeferred = false;
					n->constrrel = NULL;
					(yyval.node) = (Node *) n;
				}
#line 37401 "gram.c" /* yacc.c:1646  */
    break;

  case 776:
#line 5994 "gram.y" /* yacc.c:1646  */
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);

					n->replace = (yyvsp[-19].boolean);
					if (n->replace) /* not supported, see CreateTrigger */
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CREATE OR REPLACE CONSTRAINT TRIGGER is not supported")));
					n->isconstraint = true;
					n->trigname = (yyvsp[-16].str);
					n->relation = (yyvsp[-12].range);
					n->funcname = (yyvsp[-3].list);
					n->args = (yyvsp[-1].list);
					n->row = true;
					n->timing = TRIGGER_TYPE_AFTER;
					n->events = intVal(linitial((yyvsp[-14].list)));
					n->columns = (List *) lsecond((yyvsp[-14].list));
					n->whenClause = (yyvsp[-6].node);
					n->transitionRels = NIL;
					processCASbits((yyvsp[-10].ival), (yylsp[-10]), "TRIGGER",
								   &n->deferrable, &n->initdeferred, NULL,
								   NULL, yyscanner);
					n->constrrel = (yyvsp[-11].range);
					(yyval.node) = (Node *) n;
				}
#line 37431 "gram.c" /* yacc.c:1646  */
    break;

  case 777:
#line 6022 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_BEFORE; }
#line 37437 "gram.c" /* yacc.c:1646  */
    break;

  case 778:
#line 6023 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_AFTER; }
#line 37443 "gram.c" /* yacc.c:1646  */
    break;

  case 779:
#line 6024 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = TRIGGER_TYPE_INSTEAD; }
#line 37449 "gram.c" /* yacc.c:1646  */
    break;

  case 780:
#line 6029 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37455 "gram.c" /* yacc.c:1646  */
    break;

  case 781:
#line 6031 "gram.y" /* yacc.c:1646  */
    {
					int			events1 = intVal(linitial((yyvsp[-2].list)));
					int			events2 = intVal(linitial((yyvsp[0].list)));
					List	   *columns1 = (List *) lsecond((yyvsp[-2].list));
					List	   *columns2 = (List *) lsecond((yyvsp[0].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				}
#line 37478 "gram.c" /* yacc.c:1646  */
    break;

  case 782:
#line 6053 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); }
#line 37484 "gram.c" /* yacc.c:1646  */
    break;

  case 783:
#line 6055 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); }
#line 37490 "gram.c" /* yacc.c:1646  */
    break;

  case 784:
#line 6057 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); }
#line 37496 "gram.c" /* yacc.c:1646  */
    break;

  case 785:
#line 6059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[0].list)); }
#line 37502 "gram.c" /* yacc.c:1646  */
    break;

  case 786:
#line 6061 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); }
#line 37508 "gram.c" /* yacc.c:1646  */
    break;

  case 787:
#line 6065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 37514 "gram.c" /* yacc.c:1646  */
    break;

  case 788:
#line 6066 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37520 "gram.c" /* yacc.c:1646  */
    break;

  case 789:
#line 6070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37526 "gram.c" /* yacc.c:1646  */
    break;

  case 790:
#line 6071 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 37532 "gram.c" /* yacc.c:1646  */
    break;

  case 791:
#line 6076 "gram.y" /* yacc.c:1646  */
    {
					TriggerTransition *n = makeNode(TriggerTransition);

					n->name = (yyvsp[0].str);
					n->isNew = (yyvsp[-3].boolean);
					n->isTable = (yyvsp[-2].boolean);
					(yyval.node) = (Node *) n;
				}
#line 37545 "gram.c" /* yacc.c:1646  */
    break;

  case 792:
#line 6087 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37551 "gram.c" /* yacc.c:1646  */
    break;

  case 793:
#line 6088 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37557 "gram.c" /* yacc.c:1646  */
    break;

  case 794:
#line 6092 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37563 "gram.c" /* yacc.c:1646  */
    break;

  case 795:
#line 6101 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37569 "gram.c" /* yacc.c:1646  */
    break;

  case 796:
#line 6105 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 37575 "gram.c" /* yacc.c:1646  */
    break;

  case 797:
#line 6110 "gram.y" /* yacc.c:1646  */
    {
					(yyval.boolean) = (yyvsp[0].boolean);
				}
#line 37583 "gram.c" /* yacc.c:1646  */
    break;

  case 798:
#line 6114 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = false;
				}
#line 37595 "gram.c" /* yacc.c:1646  */
    break;

  case 801:
#line 6129 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 37601 "gram.c" /* yacc.c:1646  */
    break;

  case 802:
#line 6130 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 37607 "gram.c" /* yacc.c:1646  */
    break;

  case 803:
#line 6134 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 37613 "gram.c" /* yacc.c:1646  */
    break;

  case 804:
#line 6135 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 37619 "gram.c" /* yacc.c:1646  */
    break;

  case 807:
#line 6144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 37625 "gram.c" /* yacc.c:1646  */
    break;

  case 808:
#line 6145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 37631 "gram.c" /* yacc.c:1646  */
    break;

  case 809:
#line 6146 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 37637 "gram.c" /* yacc.c:1646  */
    break;

  case 810:
#line 6151 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString(psprintf("%d", (yyvsp[0].ival)));
				}
#line 37645 "gram.c" /* yacc.c:1646  */
    break;

  case 811:
#line 6154 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37651 "gram.c" /* yacc.c:1646  */
    break;

  case 812:
#line 6155 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37657 "gram.c" /* yacc.c:1646  */
    break;

  case 813:
#line 6156 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 37663 "gram.c" /* yacc.c:1646  */
    break;

  case 814:
#line 6160 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 37669 "gram.c" /* yacc.c:1646  */
    break;

  case 815:
#line 6161 "gram.y" /* yacc.c:1646  */
    { (yyval.range) = NULL; }
#line 37675 "gram.c" /* yacc.c:1646  */
    break;

  case 816:
#line 6166 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 37681 "gram.c" /* yacc.c:1646  */
    break;

  case 817:
#line 6168 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We must complain about conflicting options.
					 * We could, but choose not to, complain about redundant
					 * options (ie, where $2's bit is already set in $1).
					 */
					int		newspec = (yyvsp[-1].ival) | (yyvsp[0].ival);

					/* special message for this case */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED)) == (CAS_NOT_DEFERRABLE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[0]))));
					/* generic message for other conflicts */
					if ((newspec & (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE)) == (CAS_NOT_DEFERRABLE | CAS_DEFERRABLE) ||
						(newspec & (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED)) == (CAS_INITIALLY_IMMEDIATE | CAS_INITIALLY_DEFERRED))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("conflicting constraint properties"),
								 parser_errposition((yylsp[0]))));
					(yyval.ival) = newspec;
				}
#line 37709 "gram.c" /* yacc.c:1646  */
    break;

  case 818:
#line 6194 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_DEFERRABLE; }
#line 37715 "gram.c" /* yacc.c:1646  */
    break;

  case 819:
#line 6195 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_DEFERRABLE; }
#line 37721 "gram.c" /* yacc.c:1646  */
    break;

  case 820:
#line 6196 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_IMMEDIATE; }
#line 37727 "gram.c" /* yacc.c:1646  */
    break;

  case 821:
#line 6197 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_INITIALLY_DEFERRED; }
#line 37733 "gram.c" /* yacc.c:1646  */
    break;

  case 822:
#line 6198 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NOT_VALID; }
#line 37739 "gram.c" /* yacc.c:1646  */
    break;

  case 823:
#line 6199 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CAS_NO_INHERIT; }
#line 37745 "gram.c" /* yacc.c:1646  */
    break;

  case 824:
#line 6214 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-7].str);
					n->eventname = (yyvsp[-5].str);
					n->whenclause = NULL;
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37759 "gram.c" /* yacc.c:1646  */
    break;

  case 825:
#line 6226 "gram.y" /* yacc.c:1646  */
    {
					CreateEventTrigStmt *n = makeNode(CreateEventTrigStmt);

					n->trigname = (yyvsp[-9].str);
					n->eventname = (yyvsp[-7].str);
					n->whenclause = (yyvsp[-5].list);
					n->funcname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 37773 "gram.c" /* yacc.c:1646  */
    break;

  case 826:
#line 6239 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 37779 "gram.c" /* yacc.c:1646  */
    break;

  case 827:
#line 6241 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 37785 "gram.c" /* yacc.c:1646  */
    break;

  case 828:
#line 6246 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-4].str), (Node *) (yyvsp[-1].list), (yylsp[-4])); }
#line 37791 "gram.c" /* yacc.c:1646  */
    break;

  case 829:
#line 6251 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 37797 "gram.c" /* yacc.c:1646  */
    break;

  case 830:
#line 6253 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 37803 "gram.c" /* yacc.c:1646  */
    break;

  case 831:
#line 6258 "gram.y" /* yacc.c:1646  */
    {
					AlterEventTrigStmt *n = makeNode(AlterEventTrigStmt);

					n->trigname = (yyvsp[-1].str);
					n->tgenabled = (yyvsp[0].chr);
					(yyval.node) = (Node *) n;
				}
#line 37815 "gram.c" /* yacc.c:1646  */
    break;

  case 832:
#line 6268 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_ORIGIN; }
#line 37821 "gram.c" /* yacc.c:1646  */
    break;

  case 833:
#line 6269 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ON_REPLICA; }
#line 37827 "gram.c" /* yacc.c:1646  */
    break;

  case 834:
#line 6270 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_FIRES_ALWAYS; }
#line 37833 "gram.c" /* yacc.c:1646  */
    break;

  case 835:
#line 6271 "gram.y" /* yacc.c:1646  */
    { (yyval.chr) = TRIGGER_DISABLED; }
#line 37839 "gram.c" /* yacc.c:1646  */
    break;

  case 836:
#line 6283 "gram.y" /* yacc.c:1646  */
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = NULL;
				}
#line 37851 "gram.c" /* yacc.c:1646  */
    break;

  case 837:
#line 6302 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->replace = (yyvsp[-4].boolean);
					n->defnames = (yyvsp[-2].list);
					n->args = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37867 "gram.c" /* yacc.c:1646  */
    break;

  case 838:
#line 6314 "gram.y" /* yacc.c:1646  */
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->replace = (yyvsp[-3].boolean);
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37884 "gram.c" /* yacc.c:1646  */
    break;

  case 839:
#line 6327 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37899 "gram.c" /* yacc.c:1646  */
    break;

  case 840:
#line 6338 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[-1].list);
					n->args = NIL;
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37914 "gram.c" /* yacc.c:1646  */
    break;

  case 841:
#line 6349 "gram.y" /* yacc.c:1646  */
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[0].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *) n;
				}
#line 37930 "gram.c" /* yacc.c:1646  */
    break;

  case 842:
#line 6361 "gram.y" /* yacc.c:1646  */
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);

					/* can't use qualified_name, sigh */
					n->typevar = makeRangeVarFromAnyName((yyvsp[-4].list), (yylsp[-4]), yyscanner);
					n->coldeflist = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37943 "gram.c" /* yacc.c:1646  */
    break;

  case 843:
#line 6370 "gram.y" /* yacc.c:1646  */
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);

					n->typeName = (yyvsp[-5].list);
					n->vals = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 37955 "gram.c" /* yacc.c:1646  */
    break;

  case 844:
#line 6378 "gram.y" /* yacc.c:1646  */
    {
					CreateRangeStmt *n = makeNode(CreateRangeStmt);

					n->typeName = (yyvsp[-3].list);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37967 "gram.c" /* yacc.c:1646  */
    break;

  case 845:
#line 6386 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37981 "gram.c" /* yacc.c:1646  */
    break;

  case 846:
#line 6396 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 37995 "gram.c" /* yacc.c:1646  */
    break;

  case 847:
#line 6406 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38009 "gram.c" /* yacc.c:1646  */
    break;

  case 848:
#line 6416 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38023 "gram.c" /* yacc.c:1646  */
    break;

  case 849:
#line 6426 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38037 "gram.c" /* yacc.c:1646  */
    break;

  case 850:
#line 6436 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-1].list);
					n->definition = (yyvsp[0].list);
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 38052 "gram.c" /* yacc.c:1646  */
    break;

  case 851:
#line 6447 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 38066 "gram.c" /* yacc.c:1646  */
    break;

  case 852:
#line 6457 "gram.y" /* yacc.c:1646  */
    {
					DefineStmt *n = makeNode(DefineStmt);

					n->kind = OBJECT_COLLATION;
					n->args = NIL;
					n->defnames = (yyvsp[-2].list);
					n->definition = list_make1(makeDefElem("from", (Node *) (yyvsp[0].list), (yylsp[0])));
					n->if_not_exists = true;
					(yyval.node) = (Node *) n;
				}
#line 38081 "gram.c" /* yacc.c:1646  */
    break;

  case 853:
#line 6469 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38087 "gram.c" /* yacc.c:1646  */
    break;

  case 854:
#line 6472 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38093 "gram.c" /* yacc.c:1646  */
    break;

  case 855:
#line 6473 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38099 "gram.c" /* yacc.c:1646  */
    break;

  case 856:
#line 6477 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 38107 "gram.c" /* yacc.c:1646  */
    break;

  case 857:
#line 6481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0]));
				}
#line 38115 "gram.c" /* yacc.c:1646  */
    break;

  case 858:
#line 6487 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 38121 "gram.c" /* yacc.c:1646  */
    break;

  case 859:
#line 6488 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 38127 "gram.c" /* yacc.c:1646  */
    break;

  case 860:
#line 6489 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 38133 "gram.c" /* yacc.c:1646  */
    break;

  case 861:
#line 6490 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 38139 "gram.c" /* yacc.c:1646  */
    break;

  case 862:
#line 6491 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 38145 "gram.c" /* yacc.c:1646  */
    break;

  case 863:
#line 6492 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 38151 "gram.c" /* yacc.c:1646  */
    break;

  case 864:
#line 6495 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 38157 "gram.c" /* yacc.c:1646  */
    break;

  case 865:
#line 6498 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 38163 "gram.c" /* yacc.c:1646  */
    break;

  case 866:
#line 6499 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 38169 "gram.c" /* yacc.c:1646  */
    break;

  case 867:
#line 6508 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2]));
				}
#line 38177 "gram.c" /* yacc.c:1646  */
    break;

  case 868:
#line 6514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38183 "gram.c" /* yacc.c:1646  */
    break;

  case 869:
#line 6515 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38189 "gram.c" /* yacc.c:1646  */
    break;

  case 870:
#line 6519 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 38195 "gram.c" /* yacc.c:1646  */
    break;

  case 871:
#line 6521 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 38201 "gram.c" /* yacc.c:1646  */
    break;

  case 872:
#line 6532 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-4].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-1].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38217 "gram.c" /* yacc.c:1646  */
    break;

  case 873:
#line 6544 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = false;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38233 "gram.c" /* yacc.c:1646  */
    break;

  case 874:
#line 6556 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-6].list);
				n->oldVal = NULL;
				n->newVal = (yyvsp[-2].str);
				n->newValNeighbor = (yyvsp[0].str);
				n->newValIsAfter = true;
				n->skipIfNewValExists = (yyvsp[-3].boolean);
				(yyval.node) = (Node *) n;
			}
#line 38249 "gram.c" /* yacc.c:1646  */
    break;

  case 875:
#line 6568 "gram.y" /* yacc.c:1646  */
    {
				AlterEnumStmt *n = makeNode(AlterEnumStmt);

				n->typeName = (yyvsp[-5].list);
				n->oldVal = (yyvsp[-2].str);
				n->newVal = (yyvsp[0].str);
				n->newValNeighbor = NULL;
				n->newValIsAfter = false;
				n->skipIfNewValExists = false;
				(yyval.node) = (Node *) n;
			}
#line 38265 "gram.c" /* yacc.c:1646  */
    break;

  case 876:
#line 6580 "gram.y" /* yacc.c:1646  */
    {
				/*
				 * The following problems must be solved before this can be
				 * implemented:
				 *
				 * - There must be no instance of the target value in
				 *   any table.
				 *
				 * - The value must not appear in any catalog metadata,
				 *   such as stored view expressions or column defaults.
				 *
				 * - The value must not appear in any non-leaf page of a
				 *   btree (and similar issues with other index types).
				 *   This is problematic because a value could persist
				 *   there long after it's gone from user-visible data.
				 *
				 * - Concurrent sessions must not be able to insert the
				 *   value while the preceding conditions are being checked.
				 *
				 * - Possibly more...
				 */
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("dropping an enum value is not implemented"),
						 parser_errposition((yylsp[-2]))));
			}
#line 38296 "gram.c" /* yacc.c:1646  */
    break;

  case 877:
#line 6608 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38302 "gram.c" /* yacc.c:1646  */
    break;

  case 878:
#line 6609 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38308 "gram.c" /* yacc.c:1646  */
    break;

  case 879:
#line 6627 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);

					n->opclassname = (yyvsp[-9].list);
					n->isDefault = (yyvsp[-8].boolean);
					n->datatype = (yyvsp[-5].typnam);
					n->amname = (yyvsp[-3].str);
					n->opfamilyname = (yyvsp[-2].list);
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38324 "gram.c" /* yacc.c:1646  */
    break;

  case 880:
#line 6641 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 38330 "gram.c" /* yacc.c:1646  */
    break;

  case 881:
#line 6642 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 38336 "gram.c" /* yacc.c:1646  */
    break;

  case 882:
#line 6647 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					ObjectWithArgs *owa = makeNode(ObjectWithArgs);

					owa->objname = (yyvsp[-2].list);
					owa->objargs = NIL;
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = owa;
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38353 "gram.c" /* yacc.c:1646  */
    break;

  case 883:
#line 6661 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[-2].objwithargs);
					n->number = (yyvsp[-3].ival);
					n->order_family = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38367 "gram.c" /* yacc.c:1646  */
    break;

  case 884:
#line 6671 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-1].ival);
					(yyval.node) = (Node *) n;
				}
#line 38380 "gram.c" /* yacc.c:1646  */
    break;

  case 885:
#line 6680 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[0].objwithargs);
					n->number = (yyvsp[-4].ival);
					n->class_args = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 38394 "gram.c" /* yacc.c:1646  */
    break;

  case 886:
#line 6690 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[0].typnam);
					(yyval.node) = (Node *) n;
				}
#line 38406 "gram.c" /* yacc.c:1646  */
    break;

  case 887:
#line 6699 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 38412 "gram.c" /* yacc.c:1646  */
    break;

  case 888:
#line 6700 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38418 "gram.c" /* yacc.c:1646  */
    break;

  case 889:
#line 6703 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38424 "gram.c" /* yacc.c:1646  */
    break;

  case 890:
#line 6704 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38430 "gram.c" /* yacc.c:1646  */
    break;

  case 891:
#line 6707 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38436 "gram.c" /* yacc.c:1646  */
    break;

  case 892:
#line 6708 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 38442 "gram.c" /* yacc.c:1646  */
    break;

  case 893:
#line 6709 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 38448 "gram.c" /* yacc.c:1646  */
    break;

  case 894:
#line 6713 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[0]))));
					(yyval.boolean) = true;
				}
#line 38466 "gram.c" /* yacc.c:1646  */
    break;

  case 895:
#line 6726 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 38472 "gram.c" /* yacc.c:1646  */
    break;

  case 896:
#line 6732 "gram.y" /* yacc.c:1646  */
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);

					n->opfamilyname = (yyvsp[-2].list);
					n->amname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 38484 "gram.c" /* yacc.c:1646  */
    break;

  case 897:
#line 6743 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = false;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38498 "gram.c" /* yacc.c:1646  */
    break;

  case 898:
#line 6753 "gram.y" /* yacc.c:1646  */
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);

					n->opfamilyname = (yyvsp[-4].list);
					n->amname = (yyvsp[-2].str);
					n->isDrop = true;
					n->items = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 38512 "gram.c" /* yacc.c:1646  */
    break;

  case 899:
#line 6765 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 38518 "gram.c" /* yacc.c:1646  */
    break;

  case 900:
#line 6766 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 38524 "gram.c" /* yacc.c:1646  */
    break;

  case 901:
#line 6771 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38537 "gram.c" /* yacc.c:1646  */
    break;

  case 902:
#line 6780 "gram.y" /* yacc.c:1646  */
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);

					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[-3].ival);
					n->class_args = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 38550 "gram.c" /* yacc.c:1646  */
    break;

  case 903:
#line 6793 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38565 "gram.c" /* yacc.c:1646  */
    break;

  case 904:
#line 6804 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPCLASS;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38580 "gram.c" /* yacc.c:1646  */
    break;

  case 905:
#line 6818 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38595 "gram.c" /* yacc.c:1646  */
    break;

  case 906:
#line 6829 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->objects = list_make1(lcons(makeString((yyvsp[-1].str)), (yyvsp[-3].list)));
					n->removeType = OBJECT_OPFAMILY;
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38610 "gram.c" /* yacc.c:1646  */
    break;

  case 907:
#line 6852 "gram.y" /* yacc.c:1646  */
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);

					n->roles = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 38622 "gram.c" /* yacc.c:1646  */
    break;

  case 908:
#line 6863 "gram.y" /* yacc.c:1646  */
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);

					n->roles = (yyvsp[-2].list);
					n->newrole = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 38634 "gram.c" /* yacc.c:1646  */
    break;

  case 909:
#line 6882 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38649 "gram.c" /* yacc.c:1646  */
    break;

  case 910:
#line 6893 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38664 "gram.c" /* yacc.c:1646  */
    break;

  case 911:
#line 6904 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38679 "gram.c" /* yacc.c:1646  */
    break;

  case 912:
#line 6915 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-2].objtype);
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38694 "gram.c" /* yacc.c:1646  */
    break;

  case 913:
#line 6926 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-4].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38709 "gram.c" /* yacc.c:1646  */
    break;

  case 914:
#line 6937 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = (yyvsp[-6].objtype);
					n->objects = list_make1(lappend((yyvsp[-1].list), makeString((yyvsp[-3].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38724 "gram.c" /* yacc.c:1646  */
    break;

  case 915:
#line 6948 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38739 "gram.c" /* yacc.c:1646  */
    break;

  case 916:
#line 6959 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TYPE;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38754 "gram.c" /* yacc.c:1646  */
    break;

  case 917:
#line 6970 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38769 "gram.c" /* yacc.c:1646  */
    break;

  case 918:
#line 6981 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_DOMAIN;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 38784 "gram.c" /* yacc.c:1646  */
    break;

  case 919:
#line 6992 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = false;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38799 "gram.c" /* yacc.c:1646  */
    break;

  case 920:
#line 7003 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_INDEX;
					n->missing_ok = true;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->concurrent = true;
					(yyval.node) = (Node *) n;
				}
#line 38814 "gram.c" /* yacc.c:1646  */
    break;

  case 921:
#line 7017 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLE; }
#line 38820 "gram.c" /* yacc.c:1646  */
    break;

  case 922:
#line 7018 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SEQUENCE; }
#line 38826 "gram.c" /* yacc.c:1646  */
    break;

  case 923:
#line 7019 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_VIEW; }
#line 38832 "gram.c" /* yacc.c:1646  */
    break;

  case 924:
#line 7020 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_MATVIEW; }
#line 38838 "gram.c" /* yacc.c:1646  */
    break;

  case 925:
#line 7021 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_INDEX; }
#line 38844 "gram.c" /* yacc.c:1646  */
    break;

  case 926:
#line 7022 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_TABLE; }
#line 38850 "gram.c" /* yacc.c:1646  */
    break;

  case 927:
#line 7023 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_COLLATION; }
#line 38856 "gram.c" /* yacc.c:1646  */
    break;

  case 928:
#line 7024 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_CONVERSION; }
#line 38862 "gram.c" /* yacc.c:1646  */
    break;

  case 929:
#line 7025 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_STATISTIC_EXT; }
#line 38868 "gram.c" /* yacc.c:1646  */
    break;

  case 930:
#line 7026 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSPARSER; }
#line 38874 "gram.c" /* yacc.c:1646  */
    break;

  case 931:
#line 7027 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSDICTIONARY; }
#line 38880 "gram.c" /* yacc.c:1646  */
    break;

  case 932:
#line 7028 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSTEMPLATE; }
#line 38886 "gram.c" /* yacc.c:1646  */
    break;

  case 933:
#line 7029 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; }
#line 38892 "gram.c" /* yacc.c:1646  */
    break;

  case 934:
#line 7039 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = (yyvsp[0].objtype); }
#line 38898 "gram.c" /* yacc.c:1646  */
    break;

  case 935:
#line 7040 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_DATABASE; }
#line 38904 "gram.c" /* yacc.c:1646  */
    break;

  case 936:
#line 7041 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ROLE; }
#line 38910 "gram.c" /* yacc.c:1646  */
    break;

  case 937:
#line 7042 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SUBSCRIPTION; }
#line 38916 "gram.c" /* yacc.c:1646  */
    break;

  case 938:
#line 7043 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TABLESPACE; }
#line 38922 "gram.c" /* yacc.c:1646  */
    break;

  case 939:
#line 7047 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_ACCESS_METHOD; }
#line 38928 "gram.c" /* yacc.c:1646  */
    break;

  case 940:
#line 7048 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EVENT_TRIGGER; }
#line 38934 "gram.c" /* yacc.c:1646  */
    break;

  case 941:
#line 7049 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_EXTENSION; }
#line 38940 "gram.c" /* yacc.c:1646  */
    break;

  case 942:
#line 7050 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FDW; }
#line 38946 "gram.c" /* yacc.c:1646  */
    break;

  case 943:
#line 7051 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_LANGUAGE; }
#line 38952 "gram.c" /* yacc.c:1646  */
    break;

  case 944:
#line 7052 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_PUBLICATION; }
#line 38958 "gram.c" /* yacc.c:1646  */
    break;

  case 945:
#line 7053 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_SCHEMA; }
#line 38964 "gram.c" /* yacc.c:1646  */
    break;

  case 946:
#line 7054 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_FOREIGN_SERVER; }
#line 38970 "gram.c" /* yacc.c:1646  */
    break;

  case 947:
#line 7059 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_POLICY; }
#line 38976 "gram.c" /* yacc.c:1646  */
    break;

  case 948:
#line 7060 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_RULE; }
#line 38982 "gram.c" /* yacc.c:1646  */
    break;

  case 949:
#line 7061 "gram.y" /* yacc.c:1646  */
    { (yyval.objtype) = OBJECT_TRIGGER; }
#line 38988 "gram.c" /* yacc.c:1646  */
    break;

  case 950:
#line 7065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 38994 "gram.c" /* yacc.c:1646  */
    break;

  case 951:
#line 7066 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 39000 "gram.c" /* yacc.c:1646  */
    break;

  case 952:
#line 7069 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39006 "gram.c" /* yacc.c:1646  */
    break;

  case 953:
#line 7070 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)); }
#line 39012 "gram.c" /* yacc.c:1646  */
    break;

  case 954:
#line 7074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 39018 "gram.c" /* yacc.c:1646  */
    break;

  case 955:
#line 7076 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 39024 "gram.c" /* yacc.c:1646  */
    break;

  case 956:
#line 7080 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 39030 "gram.c" /* yacc.c:1646  */
    break;

  case 957:
#line 7081 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 39036 "gram.c" /* yacc.c:1646  */
    break;

  case 958:
#line 7093 "gram.y" /* yacc.c:1646  */
    {
					TruncateStmt *n = makeNode(TruncateStmt);

					n->relations = (yyvsp[-2].list);
					n->restart_seqs = (yyvsp[-1].boolean);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39049 "gram.c" /* yacc.c:1646  */
    break;

  case 959:
#line 7104 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39055 "gram.c" /* yacc.c:1646  */
    break;

  case 960:
#line 7105 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 39061 "gram.c" /* yacc.c:1646  */
    break;

  case 961:
#line 7106 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 39067 "gram.c" /* yacc.c:1646  */
    break;

  case 962:
#line 7117 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39080 "gram.c" /* yacc.c:1646  */
    break;

  case 963:
#line 7126 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39093 "gram.c" /* yacc.c:1646  */
    break;

  case 964:
#line 7135 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39106 "gram.c" /* yacc.c:1646  */
    break;

  case 965:
#line 7144 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39119 "gram.c" /* yacc.c:1646  */
    break;

  case 966:
#line 7153 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39132 "gram.c" /* yacc.c:1646  */
    break;

  case 967:
#line 7162 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39145 "gram.c" /* yacc.c:1646  */
    break;

  case 968:
#line 7171 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39158 "gram.c" /* yacc.c:1646  */
    break;

  case 969:
#line 7180 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39171 "gram.c" /* yacc.c:1646  */
    break;

  case 970:
#line 7189 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TABCONSTRAINT;
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39184 "gram.c" /* yacc.c:1646  */
    break;

  case 971:
#line 7198 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_DOMCONSTRAINT;
					/*
					 * should use Typename not any_name in the production, but
					 * there's a shift/reduce conflict if we do that, so fix it
					 * up here.
					 */
					n->object = (Node *) list_make2(makeTypeNameFromNameList((yyvsp[-2].list)), makeString((yyvsp[-5].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39202 "gram.c" /* yacc.c:1646  */
    break;

  case 972:
#line 7212 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = (yyvsp[-5].objtype);
					n->object = (Node *) lappend((yyvsp[-2].list), makeString((yyvsp[-4].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39215 "gram.c" /* yacc.c:1646  */
    break;

  case 973:
#line 7221 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39228 "gram.c" /* yacc.c:1646  */
    break;

  case 974:
#line 7230 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39241 "gram.c" /* yacc.c:1646  */
    break;

  case 975:
#line 7239 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_TRANSFORM;
					n->object = (Node *) list_make2((yyvsp[-4].typnam), makeString((yyvsp[-2].str)));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39254 "gram.c" /* yacc.c:1646  */
    break;

  case 976:
#line 7248 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39267 "gram.c" /* yacc.c:1646  */
    break;

  case 977:
#line 7257 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-2].str)), (yyvsp[-4].list));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39280 "gram.c" /* yacc.c:1646  */
    break;

  case 978:
#line 7266 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39293 "gram.c" /* yacc.c:1646  */
    break;

  case 979:
#line 7275 "gram.y" /* yacc.c:1646  */
    {
					CommentStmt *n = makeNode(CommentStmt);

					n->objtype = OBJECT_CAST;
					n->object = (Node *) list_make2((yyvsp[-5].typnam), (yyvsp[-3].typnam));
					n->comment = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39306 "gram.c" /* yacc.c:1646  */
    break;

  case 980:
#line 7286 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39312 "gram.c" /* yacc.c:1646  */
    break;

  case 981:
#line 7287 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39318 "gram.c" /* yacc.c:1646  */
    break;

  case 982:
#line 7303 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39332 "gram.c" /* yacc.c:1646  */
    break;

  case 983:
#line 7314 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_COLUMN;
					n->object = (Node *) (yyvsp[-2].list);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39346 "gram.c" /* yacc.c:1646  */
    break;

  case 984:
#line 7325 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = (yyvsp[-3].objtype);
					n->object = (Node *) makeString((yyvsp[-2].str));
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39360 "gram.c" /* yacc.c:1646  */
    break;

  case 985:
#line 7336 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39374 "gram.c" /* yacc.c:1646  */
    break;

  case 986:
#line 7347 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-2].typnam);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39388 "gram.c" /* yacc.c:1646  */
    break;

  case 987:
#line 7358 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39402 "gram.c" /* yacc.c:1646  */
    break;

  case 988:
#line 7369 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39416 "gram.c" /* yacc.c:1646  */
    break;

  case 989:
#line 7380 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-6].str);
					n->objtype = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-2].node);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39430 "gram.c" /* yacc.c:1646  */
    break;

  case 990:
#line 7391 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39444 "gram.c" /* yacc.c:1646  */
    break;

  case 991:
#line 7402 "gram.y" /* yacc.c:1646  */
    {
					SecLabelStmt *n = makeNode(SecLabelStmt);

					n->provider = (yyvsp[-5].str);
					n->objtype = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-2].objwithargs);
					n->label = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 39458 "gram.c" /* yacc.c:1646  */
    break;

  case 992:
#line 7413 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39464 "gram.c" /* yacc.c:1646  */
    break;

  case 993:
#line 7414 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39470 "gram.c" /* yacc.c:1646  */
    break;

  case 994:
#line 7417 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 39476 "gram.c" /* yacc.c:1646  */
    break;

  case 995:
#line 7418 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 39482 "gram.c" /* yacc.c:1646  */
    break;

  case 996:
#line 7429 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = false;
					(yyval.node) = (Node *) n;
				}
#line 39493 "gram.c" /* yacc.c:1646  */
    break;

  case 997:
#line 7436 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[0].node);

					n->ismove = true;
					(yyval.node) = (Node *) n;
				}
#line 39504 "gram.c" /* yacc.c:1646  */
    break;

  case 998:
#line 7445 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39517 "gram.c" /* yacc.c:1646  */
    break;

  case 999:
#line 7454 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39530 "gram.c" /* yacc.c:1646  */
    break;

  case 1000:
#line 7463 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39543 "gram.c" /* yacc.c:1646  */
    break;

  case 1001:
#line 7472 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39556 "gram.c" /* yacc.c:1646  */
    break;

  case 1002:
#line 7481 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39569 "gram.c" /* yacc.c:1646  */
    break;

  case 1003:
#line 7490 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *) n;
				}
#line 39582 "gram.c" /* yacc.c:1646  */
    break;

  case 1004:
#line 7499 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39595 "gram.c" /* yacc.c:1646  */
    break;

  case 1005:
#line 7508 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39608 "gram.c" /* yacc.c:1646  */
    break;

  case 1006:
#line 7517 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39621 "gram.c" /* yacc.c:1646  */
    break;

  case 1007:
#line 7526 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39634 "gram.c" /* yacc.c:1646  */
    break;

  case 1008:
#line 7535 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39647 "gram.c" /* yacc.c:1646  */
    break;

  case 1009:
#line 7544 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39660 "gram.c" /* yacc.c:1646  */
    break;

  case 1010:
#line 7553 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39673 "gram.c" /* yacc.c:1646  */
    break;

  case 1011:
#line 7562 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *) n;
				}
#line 39686 "gram.c" /* yacc.c:1646  */
    break;

  case 1012:
#line 7571 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[-2].ival);
					(yyval.node) = (Node *) n;
				}
#line 39699 "gram.c" /* yacc.c:1646  */
    break;

  case 1013:
#line 7580 "gram.y" /* yacc.c:1646  */
    {
					FetchStmt *n = makeNode(FetchStmt);

					n->portalname = (yyvsp[0].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *) n;
				}
#line 39712 "gram.c" /* yacc.c:1646  */
    break;

  case 1018:
#line 7607 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grant_option = (yyvsp[-1].boolean);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 39730 "gram.c" /* yacc.c:1646  */
    break;

  case 1019:
#line 7625 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39749 "gram.c" /* yacc.c:1646  */
    break;

  case 1020:
#line 7641 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-6].list);
					n->targtype = ((yyvsp[-4].privtarget))->targtype;
					n->objtype = ((yyvsp[-4].privtarget))->objtype;
					n->objects = ((yyvsp[-4].privtarget))->objs;
					n->grantees = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 39768 "gram.c" /* yacc.c:1646  */
    break;

  case 1021:
#line 7668 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 39774 "gram.c" /* yacc.c:1646  */
    break;

  case 1022:
#line 7670 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39780 "gram.c" /* yacc.c:1646  */
    break;

  case 1023:
#line 7672 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 39786 "gram.c" /* yacc.c:1646  */
    break;

  case 1024:
#line 7674 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39798 "gram.c" /* yacc.c:1646  */
    break;

  case 1025:
#line 7682 "gram.y" /* yacc.c:1646  */
    {
					AccessPriv *n = makeNode(AccessPriv);

					n->priv_name = NULL;
					n->cols = (yyvsp[-1].list);
					(yyval.list) = list_make1(n);
				}
#line 39810 "gram.c" /* yacc.c:1646  */
    break;

  case 1026:
#line 7691 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].accesspriv)); }
#line 39816 "gram.c" /* yacc.c:1646  */
    break;

  case 1027:
#line 7692 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].accesspriv)); }
#line 39822 "gram.c" /* yacc.c:1646  */
    break;

  case 1028:
#line 7696 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39834 "gram.c" /* yacc.c:1646  */
    break;

  case 1029:
#line 7704 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39846 "gram.c" /* yacc.c:1646  */
    break;

  case 1030:
#line 7712 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = pstrdup((yyvsp[-1].keyword));
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39858 "gram.c" /* yacc.c:1646  */
    break;

  case 1031:
#line 7720 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup("alter system");
				n->cols = NIL;
				(yyval.accesspriv) = n;
			}
#line 39869 "gram.c" /* yacc.c:1646  */
    break;

  case 1032:
#line 7727 "gram.y" /* yacc.c:1646  */
    {
				AccessPriv *n = makeNode(AccessPriv);

				n->priv_name = (yyvsp[-1].str);
				n->cols = (yyvsp[0].list);
				(yyval.accesspriv) = n;
			}
#line 39881 "gram.c" /* yacc.c:1646  */
    break;

  case 1033:
#line 7738 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = list_make1(makeString((yyvsp[0].str)));
			}
#line 39889 "gram.c" /* yacc.c:1646  */
    break;

  case 1034:
#line 7742 "gram.y" /* yacc.c:1646  */
    {
				(yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str)));
			}
#line 39897 "gram.c" /* yacc.c:1646  */
    break;

  case 1035:
#line 7749 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = (yyvsp[0].str);
			}
#line 39905 "gram.c" /* yacc.c:1646  */
    break;

  case 1036:
#line 7753 "gram.y" /* yacc.c:1646  */
    {
				(yyval.str) = psprintf("%s.%s", (yyvsp[-2].str), (yyvsp[0].str));
			}
#line 39913 "gram.c" /* yacc.c:1646  */
    break;

  case 1037:
#line 7764 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39926 "gram.c" /* yacc.c:1646  */
    break;

  case 1038:
#line 7773 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39939 "gram.c" /* yacc.c:1646  */
    break;

  case 1039:
#line 7782 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39952 "gram.c" /* yacc.c:1646  */
    break;

  case 1040:
#line 7791 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FDW;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39965 "gram.c" /* yacc.c:1646  */
    break;

  case 1041:
#line 7800 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39978 "gram.c" /* yacc.c:1646  */
    break;

  case 1042:
#line 7809 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 39991 "gram.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 7818 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40004 "gram.c" /* yacc.c:1646  */
    break;

  case 1044:
#line 7827 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40017 "gram.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 7836 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DATABASE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40030 "gram.c" /* yacc.c:1646  */
    break;

  case 1046:
#line 7845 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_DOMAIN;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40043 "gram.c" /* yacc.c:1646  */
    break;

  case 1047:
#line 7854 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LANGUAGE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40056 "gram.c" /* yacc.c:1646  */
    break;

  case 1048:
#line 7863 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40069 "gram.c" /* yacc.c:1646  */
    break;

  case 1049:
#line 7872 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_PARAMETER_ACL;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40081 "gram.c" /* yacc.c:1646  */
    break;

  case 1050:
#line 7880 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_SCHEMA;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40094 "gram.c" /* yacc.c:1646  */
    break;

  case 1051:
#line 7889 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TABLESPACE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40107 "gram.c" /* yacc.c:1646  */
    break;

  case 1052:
#line 7898 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = OBJECT_TYPE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40120 "gram.c" /* yacc.c:1646  */
    break;

  case 1053:
#line 7907 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_TABLE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40133 "gram.c" /* yacc.c:1646  */
    break;

  case 1054:
#line 7916 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_SEQUENCE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40146 "gram.c" /* yacc.c:1646  */
    break;

  case 1055:
#line 7925 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_FUNCTION;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40159 "gram.c" /* yacc.c:1646  */
    break;

  case 1056:
#line 7934 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_PROCEDURE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40172 "gram.c" /* yacc.c:1646  */
    break;

  case 1057:
#line 7943 "gram.y" /* yacc.c:1646  */
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));

					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = OBJECT_ROUTINE;
					n->objs = (yyvsp[0].list);
					(yyval.privtarget) = n;
				}
#line 40185 "gram.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 7955 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 40191 "gram.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 7956 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 40197 "gram.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 7960 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40203 "gram.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 7961 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40209 "gram.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 7966 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40215 "gram.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 7967 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40221 "gram.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 7978 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-3].list);
					n->grantee_roles = (yyvsp[-1].list);
					n->opt = NIL;
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40236 "gram.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 7989 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = true;
					n->granted_roles = (yyvsp[-5].list);
					n->grantee_roles = (yyvsp[-3].list);
					n->opt = (yyvsp[-1].list);
					n->grantor = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 40251 "gram.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 8003 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);

					n->is_grant = false;
					n->opt = NIL;
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40267 "gram.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 8015 "gram.y" /* yacc.c:1646  */
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					DefElem *opt;

					opt = makeDefElem(pstrdup((yyvsp[-7].str)),
									  (Node *) makeBoolean(false), (yylsp[-7]));
					n->is_grant = false;
					n->opt = list_make1(opt);
					n->granted_roles = (yyvsp[-4].list);
					n->grantee_roles = (yyvsp[-2].list);
					n->grantor = (yyvsp[-1].rolespec);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40286 "gram.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 8032 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 40292 "gram.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 8033 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 40298 "gram.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 8038 "gram.y" /* yacc.c:1646  */
    {
				(yyval.defelt) = makeDefElem(pstrdup((yyvsp[-1].str)), (yyvsp[0].node), (yylsp[-1]));
			}
#line 40306 "gram.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 8044 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 40312 "gram.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 8045 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(true); }
#line 40318 "gram.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 8046 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeBoolean(false); }
#line 40324 "gram.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 8049 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = (yyvsp[0].rolespec); }
#line 40330 "gram.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 8050 "gram.y" /* yacc.c:1646  */
    { (yyval.rolespec) = NULL; }
#line 40336 "gram.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 8061 "gram.y" /* yacc.c:1646  */
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);

					n->options = (yyvsp[-1].list);
					n->action = (GrantStmt *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40348 "gram.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 8071 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 40354 "gram.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 8072 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40360 "gram.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 8077 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40368 "gram.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 8081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40376 "gram.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 8085 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("roles", (Node *) (yyvsp[0].list), (yylsp[-2]));
				}
#line 40384 "gram.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 8097 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->grant_option = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 40401 "gram.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 8111 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40419 "gram.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 8126 "gram.y" /* yacc.c:1646  */
    {
					GrantStmt *n = makeNode(GrantStmt);

					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[-5].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[-3].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 40437 "gram.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 8142 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TABLE; }
#line 40443 "gram.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 8143 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 40449 "gram.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 8144 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_FUNCTION; }
#line 40455 "gram.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 8145 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SEQUENCE; }
#line 40461 "gram.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 8146 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_TYPE; }
#line 40467 "gram.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 8147 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OBJECT_SCHEMA; }
#line 40473 "gram.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 8162 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-14].boolean);
					n->concurrent = (yyvsp[-12].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = false;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 40507 "gram.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 8194 "gram.y" /* yacc.c:1646  */
    {
					IndexStmt *n = makeNode(IndexStmt);

					n->unique = (yyvsp[-17].boolean);
					n->concurrent = (yyvsp[-15].boolean);
					n->idxname = (yyvsp[-11].str);
					n->relation = (yyvsp[-9].range);
					n->accessMethod = (yyvsp[-8].str);
					n->indexParams = (yyvsp[-6].list);
					n->indexIncludingParams = (yyvsp[-4].list);
					n->nulls_not_distinct = !(yyvsp[-3].boolean);
					n->options = (yyvsp[-2].list);
					n->tableSpace = (yyvsp[-1].str);
					n->whereClause = (yyvsp[0].node);
					n->excludeOpNames = NIL;
					n->idxcomment = NULL;
					n->indexOid = InvalidOid;
					n->oldNumber = InvalidRelFileNumber;
					n->oldCreateSubid = InvalidSubTransactionId;
					n->oldFirstRelfilelocatorSubid = InvalidSubTransactionId;
					n->primary = false;
					n->isconstraint = false;
					n->deferrable = false;
					n->initdeferred = false;
					n->transformed = false;
					n->if_not_exists = true;
					n->reset_default_tblspc = false;
					(yyval.node) = (Node *) n;
				}
#line 40541 "gram.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 8226 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40547 "gram.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 8227 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40553 "gram.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 8231 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 40559 "gram.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 8232 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = DEFAULT_INDEX_TYPE; }
#line 40565 "gram.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 8235 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 40571 "gram.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 8236 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 40577 "gram.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 8242 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-3].list);
			(yyval.ielem)->opclass = (yyvsp[-2].list);
			(yyval.ielem)->opclassopts = NIL;
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 40593 "gram.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 8254 "gram.y" /* yacc.c:1646  */
    {
			(yyval.ielem) = makeNode(IndexElem);
			(yyval.ielem)->name = NULL;
			(yyval.ielem)->expr = NULL;
			(yyval.ielem)->indexcolname = NULL;
			(yyval.ielem)->collation = (yyvsp[-4].list);
			(yyval.ielem)->opclass = (yyvsp[-3].list);
			(yyval.ielem)->opclassopts = (yyvsp[-2].list);
			(yyval.ielem)->ordering = (yyvsp[-1].ival);
			(yyval.ielem)->nulls_ordering = (yyvsp[0].ival);
		}
#line 40609 "gram.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 8273 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->name = (yyvsp[-1].str);
				}
#line 40618 "gram.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 8278 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-1].node);
				}
#line 40627 "gram.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 8283 "gram.y" /* yacc.c:1646  */
    {
					(yyval.ielem) = (yyvsp[0].ielem);
					(yyval.ielem)->expr = (yyvsp[-2].node);
				}
#line 40636 "gram.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 8289 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40642 "gram.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 8290 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40648 "gram.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 8293 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].ielem)); }
#line 40654 "gram.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 8294 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].ielem)); }
#line 40660 "gram.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 8297 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 40666 "gram.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 8298 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40672 "gram.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 8302 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_ASC; }
#line 40678 "gram.c" /* yacc.c:1646  */
    break;

  case 1111:
#line 8303 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DESC; }
#line 40684 "gram.c" /* yacc.c:1646  */
    break;

  case 1112:
#line 8304 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_DEFAULT; }
#line 40690 "gram.c" /* yacc.c:1646  */
    break;

  case 1113:
#line 8307 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_FIRST; }
#line 40696 "gram.c" /* yacc.c:1646  */
    break;

  case 1114:
#line 8308 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_LAST; }
#line 40702 "gram.c" /* yacc.c:1646  */
    break;

  case 1115:
#line 8309 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; }
#line 40708 "gram.c" /* yacc.c:1646  */
    break;

  case 1116:
#line 8327 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-7].boolean);
					n->funcname = (yyvsp[-5].list);
					n->parameters = (yyvsp[-4].list);
					n->returnType = (yyvsp[-2].typnam);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40725 "gram.c" /* yacc.c:1646  */
    break;

  case 1117:
#line 8341 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-10].boolean);
					n->funcname = (yyvsp[-8].list);
					n->parameters = mergeTableFuncParameters((yyvsp[-7].list), (yyvsp[-3].list));
					n->returnType = TableFuncTypeName((yyvsp[-3].list));
					n->returnType->location = (yylsp[-5]);
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40743 "gram.c" /* yacc.c:1646  */
    break;

  case 1118:
#line 8356 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = false;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40760 "gram.c" /* yacc.c:1646  */
    break;

  case 1119:
#line 8370 "gram.y" /* yacc.c:1646  */
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);

					n->is_procedure = true;
					n->replace = (yyvsp[-5].boolean);
					n->funcname = (yyvsp[-3].list);
					n->parameters = (yyvsp[-2].list);
					n->returnType = NULL;
					n->options = (yyvsp[-1].list);
					n->sql_body = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 40777 "gram.c" /* yacc.c:1646  */
    break;

  case 1120:
#line 8385 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 40783 "gram.c" /* yacc.c:1646  */
    break;

  case 1121:
#line 8386 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 40789 "gram.c" /* yacc.c:1646  */
    break;

  case 1122:
#line 8389 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40795 "gram.c" /* yacc.c:1646  */
    break;

  case 1123:
#line 8390 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40801 "gram.c" /* yacc.c:1646  */
    break;

  case 1124:
#line 8394 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40807 "gram.c" /* yacc.c:1646  */
    break;

  case 1125:
#line 8395 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40813 "gram.c" /* yacc.c:1646  */
    break;

  case 1126:
#line 8399 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 40819 "gram.c" /* yacc.c:1646  */
    break;

  case 1127:
#line 8401 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 40825 "gram.c" /* yacc.c:1646  */
    break;

  case 1128:
#line 8406 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractArgTypes((yyvsp[0].list));
					n->objfuncargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 40838 "gram.c" /* yacc.c:1646  */
    break;

  case 1129:
#line 8420 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString(pstrdup((yyvsp[0].keyword))));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40850 "gram.c" /* yacc.c:1646  */
    break;

  case 1130:
#line 8428 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = list_make1(makeString((yyvsp[0].str)));
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40862 "gram.c" /* yacc.c:1646  */
    break;

  case 1131:
#line 8436 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
												  yyscanner);
					n->args_unspecified = true;
					(yyval.objwithargs) = n;
				}
#line 40875 "gram.c" /* yacc.c:1646  */
    break;

  case 1132:
#line 8451 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 40881 "gram.c" /* yacc.c:1646  */
    break;

  case 1133:
#line 8452 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 40887 "gram.c" /* yacc.c:1646  */
    break;

  case 1134:
#line 8456 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 40893 "gram.c" /* yacc.c:1646  */
    break;

  case 1135:
#line 8458 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 40899 "gram.c" /* yacc.c:1646  */
    break;

  case 1136:
#line 8473 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-2].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40913 "gram.c" /* yacc.c:1646  */
    break;

  case 1137:
#line 8483 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-2].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40927 "gram.c" /* yacc.c:1646  */
    break;

  case 1138:
#line 8493 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40941 "gram.c" /* yacc.c:1646  */
    break;

  case 1139:
#line 8503 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = (yyvsp[-1].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40955 "gram.c" /* yacc.c:1646  */
    break;

  case 1140:
#line 8513 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = NULL;
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_DEFAULT;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 40969 "gram.c" /* yacc.c:1646  */
    break;

  case 1141:
#line 8525 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; }
#line 40975 "gram.c" /* yacc.c:1646  */
    break;

  case 1142:
#line 8526 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; }
#line 40981 "gram.c" /* yacc.c:1646  */
    break;

  case 1143:
#line 8527 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40987 "gram.c" /* yacc.c:1646  */
    break;

  case 1144:
#line 8528 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; }
#line 40993 "gram.c" /* yacc.c:1646  */
    break;

  case 1145:
#line 8529 "gram.y" /* yacc.c:1646  */
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; }
#line 40999 "gram.c" /* yacc.c:1646  */
    break;

  case 1147:
#line 8540 "gram.y" /* yacc.c:1646  */
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 41011 "gram.c" /* yacc.c:1646  */
    break;

  case 1148:
#line 8554 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 41017 "gram.c" /* yacc.c:1646  */
    break;

  case 1149:
#line 8556 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 41027 "gram.c" /* yacc.c:1646  */
    break;

  case 1150:
#line 8562 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-3].str)), (yyvsp[-2].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = true;
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 41038 "gram.c" /* yacc.c:1646  */
    break;

  case 1151:
#line 8572 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 41046 "gram.c" /* yacc.c:1646  */
    break;

  case 1152:
#line 8576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 41055 "gram.c" /* yacc.c:1646  */
    break;

  case 1153:
#line 8581 "gram.y" /* yacc.c:1646  */
    {
					(yyval.fun_param) = (yyvsp[-2].fun_param);
					(yyval.fun_param)->defexpr = (yyvsp[0].node);
				}
#line 41064 "gram.c" /* yacc.c:1646  */
    break;

  case 1154:
#line 8589 "gram.y" /* yacc.c:1646  */
    {
					if (!((yyvsp[0].fun_param)->mode == FUNC_PARAM_DEFAULT ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_IN ||
						  (yyvsp[0].fun_param)->mode == FUNC_PARAM_VARIADIC))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("aggregates cannot have output arguments"),
								 parser_errposition((yylsp[0]))));
					(yyval.fun_param) = (yyvsp[0].fun_param);
				}
#line 41079 "gram.c" /* yacc.c:1646  */
    break;

  case 1155:
#line 8631 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NIL, makeInteger(-1));
				}
#line 41087 "gram.c" /* yacc.c:1646  */
    break;

  case 1156:
#line 8635 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(-1));
				}
#line 41095 "gram.c" /* yacc.c:1646  */
    break;

  case 1157:
#line 8639 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-1].list), makeInteger(0));
				}
#line 41103 "gram.c" /* yacc.c:1646  */
    break;

  case 1158:
#line 8643 "gram.y" /* yacc.c:1646  */
    {
					/* this is the only case requiring consistency checking */
					(yyval.list) = makeOrderedSetArgs((yyvsp[-4].list), (yyvsp[-1].list), yyscanner);
				}
#line 41112 "gram.c" /* yacc.c:1646  */
    break;

  case 1159:
#line 8650 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].fun_param)); }
#line 41118 "gram.c" /* yacc.c:1646  */
    break;

  case 1160:
#line 8651 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param)); }
#line 41124 "gram.c" /* yacc.c:1646  */
    break;

  case 1161:
#line 8656 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = extractAggrArgTypes((yyvsp[0].list));
					n->objfuncargs = (List *) linitial((yyvsp[0].list));
					(yyval.objwithargs) = n;
				}
#line 41137 "gram.c" /* yacc.c:1646  */
    break;

  case 1162:
#line 8667 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 41143 "gram.c" /* yacc.c:1646  */
    break;

  case 1163:
#line 8669 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 41149 "gram.c" /* yacc.c:1646  */
    break;

  case 1165:
#line 8674 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41155 "gram.c" /* yacc.c:1646  */
    break;

  case 1166:
#line 8679 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41161 "gram.c" /* yacc.c:1646  */
    break;

  case 1167:
#line 8680 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41167 "gram.c" /* yacc.c:1646  */
    break;

  case 1168:
#line 8688 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(false), (yylsp[-3]));
				}
#line 41175 "gram.c" /* yacc.c:1646  */
    break;

  case 1169:
#line 8692 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[-4]));
				}
#line 41183 "gram.c" /* yacc.c:1646  */
    break;

  case 1170:
#line 8696 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("strict", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41191 "gram.c" /* yacc.c:1646  */
    break;

  case 1171:
#line 8700 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("immutable"), (yylsp[0]));
				}
#line 41199 "gram.c" /* yacc.c:1646  */
    break;

  case 1172:
#line 8704 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("stable"), (yylsp[0]));
				}
#line 41207 "gram.c" /* yacc.c:1646  */
    break;

  case 1173:
#line 8708 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *) makeString("volatile"), (yylsp[0]));
				}
#line 41215 "gram.c" /* yacc.c:1646  */
    break;

  case 1174:
#line 8712 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-2]));
				}
#line 41223 "gram.c" /* yacc.c:1646  */
    break;

  case 1175:
#line 8716 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-2]));
				}
#line 41231 "gram.c" /* yacc.c:1646  */
    break;

  case 1176:
#line 8720 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(true), (yylsp[-1]));
				}
#line 41239 "gram.c" /* yacc.c:1646  */
    break;

  case 1177:
#line 8724 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("security", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 41247 "gram.c" /* yacc.c:1646  */
    break;

  case 1178:
#line 8728 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41255 "gram.c" /* yacc.c:1646  */
    break;

  case 1179:
#line 8732 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("leakproof", (Node *) makeBoolean(false), (yylsp[-1]));
				}
#line 41263 "gram.c" /* yacc.c:1646  */
    break;

  case 1180:
#line 8736 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("cost", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 41271 "gram.c" /* yacc.c:1646  */
    break;

  case 1181:
#line 8740 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("rows", (Node *) (yyvsp[0].node), (yylsp[-1]));
				}
#line 41279 "gram.c" /* yacc.c:1646  */
    break;

  case 1182:
#line 8744 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("support", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41287 "gram.c" /* yacc.c:1646  */
    break;

  case 1183:
#line 8748 "gram.y" /* yacc.c:1646  */
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *) (yyvsp[0].vsetstmt), (yylsp[0]));
				}
#line 41296 "gram.c" /* yacc.c:1646  */
    break;

  case 1184:
#line 8753 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("parallel", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41304 "gram.c" /* yacc.c:1646  */
    break;

  case 1185:
#line 8760 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41312 "gram.c" /* yacc.c:1646  */
    break;

  case 1186:
#line 8764 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41320 "gram.c" /* yacc.c:1646  */
    break;

  case 1187:
#line 8768 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("transform", (Node *) (yyvsp[0].list), (yylsp[-1]));
				}
#line 41328 "gram.c" /* yacc.c:1646  */
    break;

  case 1188:
#line 8772 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("window", (Node *) makeBoolean(true), (yylsp[0]));
				}
#line 41336 "gram.c" /* yacc.c:1646  */
    break;

  case 1189:
#line 8776 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = (yyvsp[0].defelt);
				}
#line 41344 "gram.c" /* yacc.c:1646  */
    break;

  case 1190:
#line 8781 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 41350 "gram.c" /* yacc.c:1646  */
    break;

  case 1191:
#line 8783 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeString((yyvsp[-2].str)), makeString((yyvsp[0].str)));
				}
#line 41358 "gram.c" /* yacc.c:1646  */
    break;

  case 1192:
#line 8789 "gram.y" /* yacc.c:1646  */
    {
					ReturnStmt *r = makeNode(ReturnStmt);

					r->returnval = (Node *) (yyvsp[0].node);
					(yyval.node) = (Node *) r;
				}
#line 41369 "gram.c" /* yacc.c:1646  */
    break;

  case 1193:
#line 8799 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 41377 "gram.c" /* yacc.c:1646  */
    break;

  case 1194:
#line 8803 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * A compound statement is stored as a single-item list
					 * containing the list of statements as its member.  That
					 * way, the parse analysis code can tell apart an empty
					 * body from no body at all.
					 */
					(yyval.node) = (Node *) list_make1((yyvsp[-1].list));
				}
#line 41391 "gram.c" /* yacc.c:1646  */
    break;

  case 1195:
#line 8813 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = NULL;
				}
#line 41399 "gram.c" /* yacc.c:1646  */
    break;

  case 1196:
#line 8820 "gram.y" /* yacc.c:1646  */
    {
					/* As in stmtmulti, discard empty statements */
					if ((yyvsp[-1].node) != NULL)
						(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[-1].node));
					else
						(yyval.list) = (yyvsp[-2].list);
				}
#line 41411 "gram.c" /* yacc.c:1646  */
    break;

  case 1197:
#line 8828 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = NIL;
				}
#line 41419 "gram.c" /* yacc.c:1646  */
    break;

  case 1200:
#line 8839 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 41425 "gram.c" /* yacc.c:1646  */
    break;

  case 1201:
#line 8840 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-4].list), (yyvsp[0].typnam)); }
#line 41431 "gram.c" /* yacc.c:1646  */
    break;

  case 1202:
#line 8844 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 41437 "gram.c" /* yacc.c:1646  */
    break;

  case 1203:
#line 8845 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 41443 "gram.c" /* yacc.c:1646  */
    break;

  case 1204:
#line 8849 "gram.y" /* yacc.c:1646  */
    {
					FunctionParameter *n = makeNode(FunctionParameter);

					n->name = (yyvsp[-1].str);
					n->argType = (yyvsp[0].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				}
#line 41457 "gram.c" /* yacc.c:1646  */
    break;

  case 1205:
#line 8862 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].fun_param));
				}
#line 41465 "gram.c" /* yacc.c:1646  */
    break;

  case 1206:
#line 8866 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].fun_param));
				}
#line 41473 "gram.c" /* yacc.c:1646  */
    break;

  case 1207:
#line 8881 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_FUNCTION;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41486 "gram.c" /* yacc.c:1646  */
    break;

  case 1208:
#line 8890 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_PROCEDURE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41499 "gram.c" /* yacc.c:1646  */
    break;

  case 1209:
#line 8899 "gram.y" /* yacc.c:1646  */
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);

					n->objtype = OBJECT_ROUTINE;
					n->func = (yyvsp[-2].objwithargs);
					n->actions = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 41512 "gram.c" /* yacc.c:1646  */
    break;

  case 1210:
#line 8911 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41518 "gram.c" /* yacc.c:1646  */
    break;

  case 1211:
#line 8912 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41524 "gram.c" /* yacc.c:1646  */
    break;

  case 1214:
#line 8936 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41539 "gram.c" /* yacc.c:1646  */
    break;

  case 1215:
#line 8947 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_FUNCTION;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41554 "gram.c" /* yacc.c:1646  */
    break;

  case 1216:
#line 8958 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41569 "gram.c" /* yacc.c:1646  */
    break;

  case 1217:
#line 8969 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_PROCEDURE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41584 "gram.c" /* yacc.c:1646  */
    break;

  case 1218:
#line 8980 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41599 "gram.c" /* yacc.c:1646  */
    break;

  case 1219:
#line 8991 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_ROUTINE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41614 "gram.c" /* yacc.c:1646  */
    break;

  case 1220:
#line 9005 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41629 "gram.c" /* yacc.c:1646  */
    break;

  case 1221:
#line 9016 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_AGGREGATE;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41644 "gram.c" /* yacc.c:1646  */
    break;

  case 1222:
#line 9030 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41659 "gram.c" /* yacc.c:1646  */
    break;

  case 1223:
#line 9041 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_OPERATOR;
					n->objects = (yyvsp[-1].list);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41674 "gram.c" /* yacc.c:1646  */
    break;

  case 1224:
#line 9055 "gram.y" /* yacc.c:1646  */
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[0]))));
				}
#line 41686 "gram.c" /* yacc.c:1646  */
    break;

  case 1225:
#line 9063 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), (yyvsp[-1].typnam)); }
#line 41692 "gram.c" /* yacc.c:1646  */
    break;

  case 1226:
#line 9065 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-1].typnam)); }
#line 41698 "gram.c" /* yacc.c:1646  */
    break;

  case 1227:
#line 9067 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-3].typnam), NULL); }
#line 41704 "gram.c" /* yacc.c:1646  */
    break;

  case 1228:
#line 9072 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 41710 "gram.c" /* yacc.c:1646  */
    break;

  case 1229:
#line 9074 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lcons(makeString((yyvsp[-2].str)), (yyvsp[0].list)); }
#line 41716 "gram.c" /* yacc.c:1646  */
    break;

  case 1230:
#line 9078 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].objwithargs)); }
#line 41722 "gram.c" /* yacc.c:1646  */
    break;

  case 1231:
#line 9080 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].objwithargs)); }
#line 41728 "gram.c" /* yacc.c:1646  */
    break;

  case 1232:
#line 9085 "gram.y" /* yacc.c:1646  */
    {
					ObjectWithArgs *n = makeNode(ObjectWithArgs);

					n->objname = (yyvsp[-1].list);
					n->objargs = (yyvsp[0].list);
					(yyval.objwithargs) = n;
				}
#line 41740 "gram.c" /* yacc.c:1646  */
    break;

  case 1233:
#line 9104 "gram.y" /* yacc.c:1646  */
    {
					DoStmt *n = makeNode(DoStmt);

					n->args = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 41751 "gram.c" /* yacc.c:1646  */
    break;

  case 1234:
#line 9113 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 41757 "gram.c" /* yacc.c:1646  */
    break;

  case 1235:
#line 9114 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 41763 "gram.c" /* yacc.c:1646  */
    break;

  case 1236:
#line 9119 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("as", (Node *) makeString((yyvsp[0].str)), (yylsp[0]));
				}
#line 41771 "gram.c" /* yacc.c:1646  */
    break;

  case 1237:
#line 9123 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("language", (Node *) makeString((yyvsp[0].str)), (yylsp[-1]));
				}
#line 41779 "gram.c" /* yacc.c:1646  */
    break;

  case 1238:
#line 9136 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-7].typnam);
					n->targettype = (yyvsp[-5].typnam);
					n->func = (yyvsp[-1].objwithargs);
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41794 "gram.c" /* yacc.c:1646  */
    break;

  case 1239:
#line 9148 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = false;
					(yyval.node) = (Node *) n;
				}
#line 41809 "gram.c" /* yacc.c:1646  */
    break;

  case 1240:
#line 9160 "gram.y" /* yacc.c:1646  */
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);

					n->sourcetype = (yyvsp[-6].typnam);
					n->targettype = (yyvsp[-4].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[0].ival);
					n->inout = true;
					(yyval.node) = (Node *) n;
				}
#line 41824 "gram.c" /* yacc.c:1646  */
    break;

  case 1241:
#line 9172 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_IMPLICIT; }
#line 41830 "gram.c" /* yacc.c:1646  */
    break;

  case 1242:
#line 9173 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_ASSIGNMENT; }
#line 41836 "gram.c" /* yacc.c:1646  */
    break;

  case 1243:
#line 9174 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = COERCION_EXPLICIT; }
#line 41842 "gram.c" /* yacc.c:1646  */
    break;

  case 1244:
#line 9179 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_CAST;
					n->objects = list_make1(list_make2((yyvsp[-4].typnam), (yyvsp[-2].typnam)));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-6].boolean);
					n->concurrent = false;
					(yyval.node) = (Node *) n;
				}
#line 41857 "gram.c" /* yacc.c:1646  */
    break;

  case 1245:
#line 9191 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 41863 "gram.c" /* yacc.c:1646  */
    break;

  case 1246:
#line 9192 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 41869 "gram.c" /* yacc.c:1646  */
    break;

  case 1247:
#line 9203 "gram.y" /* yacc.c:1646  */
    {
					CreateTransformStmt *n = makeNode(CreateTransformStmt);

					n->replace = (yyvsp[-8].boolean);
					n->type_name = (yyvsp[-5].typnam);
					n->lang = (yyvsp[-3].str);
					n->fromsql = linitial((yyvsp[-1].list));
					n->tosql = lsecond((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 41884 "gram.c" /* yacc.c:1646  */
    break;

  case 1248:
#line 9216 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[-6].objwithargs), (yyvsp[0].objwithargs));
				}
#line 41892 "gram.c" /* yacc.c:1646  */
    break;

  case 1249:
#line 9220 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), (yyvsp[-6].objwithargs));
				}
#line 41900 "gram.c" /* yacc.c:1646  */
    break;

  case 1250:
#line 9224 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].objwithargs), NULL);
				}
#line 41908 "gram.c" /* yacc.c:1646  */
    break;

  case 1251:
#line 9228 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[0].objwithargs));
				}
#line 41916 "gram.c" /* yacc.c:1646  */
    break;

  case 1252:
#line 9235 "gram.y" /* yacc.c:1646  */
    {
					DropStmt *n = makeNode(DropStmt);

					n->removeType = OBJECT_TRANSFORM;
					n->objects = list_make1(list_make2((yyvsp[-3].typnam), makeString((yyvsp[-1].str))));
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = (yyvsp[-5].boolean);
					(yyval.node) = (Node *) n;
				}
#line 41930 "gram.c" /* yacc.c:1646  */
    break;

  case 1253:
#line 9257 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = (yyvsp[0].range);
					n->name = NULL;
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41947 "gram.c" /* yacc.c:1646  */
    break;

  case 1254:
#line 9270 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = REINDEX_OBJECT_SCHEMA;
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41964 "gram.c" /* yacc.c:1646  */
    break;

  case 1255:
#line 9283 "gram.y" /* yacc.c:1646  */
    {
					ReindexStmt *n = makeNode(ReindexStmt);

					n->kind = (yyvsp[-2].ival);
					n->relation = NULL;
					n->name = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					if ((yyvsp[-1].boolean))
						n->params = lappend(n->params,
											makeDefElem("concurrently", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 41981 "gram.c" /* yacc.c:1646  */
    break;

  case 1256:
#line 9297 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_INDEX; }
#line 41987 "gram.c" /* yacc.c:1646  */
    break;

  case 1257:
#line 9298 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_TABLE; }
#line 41993 "gram.c" /* yacc.c:1646  */
    break;

  case 1258:
#line 9301 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_SYSTEM; }
#line 41999 "gram.c" /* yacc.c:1646  */
    break;

  case 1259:
#line 9302 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = REINDEX_OBJECT_DATABASE; }
#line 42005 "gram.c" /* yacc.c:1646  */
    break;

  case 1260:
#line 9305 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 42011 "gram.c" /* yacc.c:1646  */
    break;

  case 1261:
#line 9306 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NULL; }
#line 42017 "gram.c" /* yacc.c:1646  */
    break;

  case 1262:
#line 9317 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = false;
					(yyval.node) = (Node *) n;
				}
#line 42031 "gram.c" /* yacc.c:1646  */
    break;

  case 1263:
#line 9327 "gram.y" /* yacc.c:1646  */
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);

					n->tablespacename = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					n->isReset = true;
					(yyval.node) = (Node *) n;
				}
#line 42045 "gram.c" /* yacc.c:1646  */
    break;

  case 1264:
#line 9345 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42059 "gram.c" /* yacc.c:1646  */
    break;

  case 1265:
#line 9355 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42073 "gram.c" /* yacc.c:1646  */
    break;

  case 1266:
#line 9365 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42087 "gram.c" /* yacc.c:1646  */
    break;

  case 1267:
#line 9375 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42101 "gram.c" /* yacc.c:1646  */
    break;

  case 1268:
#line 9385 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42115 "gram.c" /* yacc.c:1646  */
    break;

  case 1269:
#line 9395 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_DOMCONSTRAINT;
					n->object = (Node *) (yyvsp[-5].list);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42129 "gram.c" /* yacc.c:1646  */
    break;

  case 1270:
#line 9405 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42143 "gram.c" /* yacc.c:1646  */
    break;

  case 1271:
#line 9415 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42157 "gram.c" /* yacc.c:1646  */
    break;

  case 1272:
#line 9425 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42171 "gram.c" /* yacc.c:1646  */
    break;

  case 1273:
#line 9435 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42185 "gram.c" /* yacc.c:1646  */
    break;

  case 1274:
#line 9445 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42199 "gram.c" /* yacc.c:1646  */
    break;

  case 1275:
#line 9455 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42213 "gram.c" /* yacc.c:1646  */
    break;

  case 1276:
#line 9465 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42228 "gram.c" /* yacc.c:1646  */
    break;

  case 1277:
#line 9476 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_POLICY;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42243 "gram.c" /* yacc.c:1646  */
    break;

  case 1278:
#line 9487 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42257 "gram.c" /* yacc.c:1646  */
    break;

  case 1279:
#line 9497 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42271 "gram.c" /* yacc.c:1646  */
    break;

  case 1280:
#line 9507 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42285 "gram.c" /* yacc.c:1646  */
    break;

  case 1281:
#line 9517 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42299 "gram.c" /* yacc.c:1646  */
    break;

  case 1282:
#line 9527 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42313 "gram.c" /* yacc.c:1646  */
    break;

  case 1283:
#line 9537 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42327 "gram.c" /* yacc.c:1646  */
    break;

  case 1284:
#line 9547 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42342 "gram.c" /* yacc.c:1646  */
    break;

  case 1285:
#line 9558 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42357 "gram.c" /* yacc.c:1646  */
    break;

  case 1286:
#line 9569 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42372 "gram.c" /* yacc.c:1646  */
    break;

  case 1287:
#line 9580 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42387 "gram.c" /* yacc.c:1646  */
    break;

  case 1288:
#line 9591 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42402 "gram.c" /* yacc.c:1646  */
    break;

  case 1289:
#line 9602 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42417 "gram.c" /* yacc.c:1646  */
    break;

  case 1290:
#line 9613 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42432 "gram.c" /* yacc.c:1646  */
    break;

  case 1291:
#line 9624 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42447 "gram.c" /* yacc.c:1646  */
    break;

  case 1292:
#line 9635 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42462 "gram.c" /* yacc.c:1646  */
    break;

  case 1293:
#line 9646 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42477 "gram.c" /* yacc.c:1646  */
    break;

  case 1294:
#line 9657 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42492 "gram.c" /* yacc.c:1646  */
    break;

  case 1295:
#line 9668 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->subname = NULL;
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42507 "gram.c" /* yacc.c:1646  */
    break;

  case 1296:
#line 9679 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42523 "gram.c" /* yacc.c:1646  */
    break;

  case 1297:
#line 9691 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42539 "gram.c" /* yacc.c:1646  */
    break;

  case 1298:
#line 9703 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42555 "gram.c" /* yacc.c:1646  */
    break;

  case 1299:
#line 9715 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_VIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42571 "gram.c" /* yacc.c:1646  */
    break;

  case 1300:
#line 9727 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42587 "gram.c" /* yacc.c:1646  */
    break;

  case 1301:
#line 9739 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42603 "gram.c" /* yacc.c:1646  */
    break;

  case 1302:
#line 9751 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42618 "gram.c" /* yacc.c:1646  */
    break;

  case 1303:
#line 9762 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABCONSTRAINT;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42633 "gram.c" /* yacc.c:1646  */
    break;

  case 1304:
#line 9773 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42649 "gram.c" /* yacc.c:1646  */
    break;

  case 1305:
#line 9785 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_COLUMN;
					n->relationType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-5].range);
					n->subname = (yyvsp[-2].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 42665 "gram.c" /* yacc.c:1646  */
    break;

  case 1306:
#line 9797 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_RULE;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42680 "gram.c" /* yacc.c:1646  */
    break;

  case 1307:
#line 9808 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-3].range);
					n->subname = (yyvsp[-5].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42695 "gram.c" /* yacc.c:1646  */
    break;

  case 1308:
#line 9819 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 42708 "gram.c" /* yacc.c:1646  */
    break;

  case 1309:
#line 9828 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42722 "gram.c" /* yacc.c:1646  */
    break;

  case 1310:
#line 9838 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42736 "gram.c" /* yacc.c:1646  */
    break;

  case 1311:
#line 9848 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42750 "gram.c" /* yacc.c:1646  */
    break;

  case 1312:
#line 9858 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42764 "gram.c" /* yacc.c:1646  */
    break;

  case 1313:
#line 9868 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42778 "gram.c" /* yacc.c:1646  */
    break;

  case 1314:
#line 9878 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42792 "gram.c" /* yacc.c:1646  */
    break;

  case 1315:
#line 9888 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42806 "gram.c" /* yacc.c:1646  */
    break;

  case 1316:
#line 9898 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42820 "gram.c" /* yacc.c:1646  */
    break;

  case 1317:
#line 9908 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newname = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42834 "gram.c" /* yacc.c:1646  */
    break;

  case 1318:
#line 9918 "gram.y" /* yacc.c:1646  */
    {
					RenameStmt *n = makeNode(RenameStmt);

					n->renameType = OBJECT_ATTRIBUTE;
					n->relationType = OBJECT_TYPE;
					n->relation = makeRangeVarFromAnyName((yyvsp[-6].list), (yylsp[-6]), yyscanner);
					n->subname = (yyvsp[-3].str);
					n->newname = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42851 "gram.c" /* yacc.c:1646  */
    break;

  case 1321:
#line 9936 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 1; }
#line 42857 "gram.c" /* yacc.c:1646  */
    break;

  case 1322:
#line 9937 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 42863 "gram.c" /* yacc.c:1646  */
    break;

  case 1323:
#line 9948 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42877 "gram.c" /* yacc.c:1646  */
    break;

  case 1324:
#line 9958 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42891 "gram.c" /* yacc.c:1646  */
    break;

  case 1325:
#line 9968 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-5].objwithargs);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42905 "gram.c" /* yacc.c:1646  */
    break;

  case 1326:
#line 9978 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_TRIGGER;
					n->relation = (yyvsp[-5].range);
					n->object = (Node *) list_make1(makeString((yyvsp[-7].str)));
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42920 "gram.c" /* yacc.c:1646  */
    break;

  case 1327:
#line 9989 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42934 "gram.c" /* yacc.c:1646  */
    break;

  case 1328:
#line 9999 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectDependsStmt *n = makeNode(AlterObjectDependsStmt);

					n->objectType = OBJECT_INDEX;
					n->relation = (yyvsp[-5].range);
					n->extname = makeString((yyvsp[0].str));
					n->remove = (yyvsp[-4].boolean);
					(yyval.node) = (Node *) n;
				}
#line 42948 "gram.c" /* yacc.c:1646  */
    break;

  case 1329:
#line 10010 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 42954 "gram.c" /* yacc.c:1646  */
    break;

  case 1330:
#line 10011 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false;	}
#line 42960 "gram.c" /* yacc.c:1646  */
    break;

  case 1331:
#line 10022 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42974 "gram.c" /* yacc.c:1646  */
    break;

  case 1332:
#line 10032 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 42988 "gram.c" /* yacc.c:1646  */
    break;

  case 1333:
#line 10042 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43002 "gram.c" /* yacc.c:1646  */
    break;

  case 1334:
#line 10052 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43016 "gram.c" /* yacc.c:1646  */
    break;

  case 1335:
#line 10062 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_EXTENSION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43030 "gram.c" /* yacc.c:1646  */
    break;

  case 1336:
#line 10072 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43044 "gram.c" /* yacc.c:1646  */
    break;

  case 1337:
#line 10082 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43058 "gram.c" /* yacc.c:1646  */
    break;

  case 1338:
#line 10092 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43072 "gram.c" /* yacc.c:1646  */
    break;

  case 1339:
#line 10102 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43086 "gram.c" /* yacc.c:1646  */
    break;

  case 1340:
#line 10112 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43100 "gram.c" /* yacc.c:1646  */
    break;

  case 1341:
#line 10122 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43114 "gram.c" /* yacc.c:1646  */
    break;

  case 1342:
#line 10132 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43128 "gram.c" /* yacc.c:1646  */
    break;

  case 1343:
#line 10142 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43142 "gram.c" /* yacc.c:1646  */
    break;

  case 1344:
#line 10152 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43156 "gram.c" /* yacc.c:1646  */
    break;

  case 1345:
#line 10162 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSPARSER;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43170 "gram.c" /* yacc.c:1646  */
    break;

  case 1346:
#line 10172 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43184 "gram.c" /* yacc.c:1646  */
    break;

  case 1347:
#line 10182 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSTEMPLATE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43198 "gram.c" /* yacc.c:1646  */
    break;

  case 1348:
#line 10192 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43212 "gram.c" /* yacc.c:1646  */
    break;

  case 1349:
#line 10202 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43226 "gram.c" /* yacc.c:1646  */
    break;

  case 1350:
#line 10212 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43240 "gram.c" /* yacc.c:1646  */
    break;

  case 1351:
#line 10222 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43254 "gram.c" /* yacc.c:1646  */
    break;

  case 1352:
#line 10232 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43268 "gram.c" /* yacc.c:1646  */
    break;

  case 1353:
#line 10242 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43282 "gram.c" /* yacc.c:1646  */
    break;

  case 1354:
#line 10252 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_MATVIEW;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43296 "gram.c" /* yacc.c:1646  */
    break;

  case 1355:
#line 10262 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43310 "gram.c" /* yacc.c:1646  */
    break;

  case 1356:
#line 10272 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_FOREIGN_TABLE;
					n->relation = (yyvsp[-3].range);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 43324 "gram.c" /* yacc.c:1646  */
    break;

  case 1357:
#line 10282 "gram.y" /* yacc.c:1646  */
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newschema = (yyvsp[0].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 43338 "gram.c" /* yacc.c:1646  */
    break;

  case 1358:
#line 10301 "gram.y" /* yacc.c:1646  */
    {
					AlterOperatorStmt *n = makeNode(AlterOperatorStmt);

					n->opername = (yyvsp[-4].objwithargs);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43350 "gram.c" /* yacc.c:1646  */
    break;

  case 1359:
#line 10310 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 43356 "gram.c" /* yacc.c:1646  */
    break;

  case 1360:
#line 10311 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 43362 "gram.c" /* yacc.c:1646  */
    break;

  case 1361:
#line 10315 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2])); }
#line 43368 "gram.c" /* yacc.c:1646  */
    break;

  case 1362:
#line 10317 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) (yyvsp[0].node), (yylsp[-2])); }
#line 43374 "gram.c" /* yacc.c:1646  */
    break;

  case 1363:
#line 10319 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[0].str), NULL, (yylsp[0])); }
#line 43380 "gram.c" /* yacc.c:1646  */
    break;

  case 1364:
#line 10324 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].typnam); }
#line 43386 "gram.c" /* yacc.c:1646  */
    break;

  case 1365:
#line 10325 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString(pstrdup((yyvsp[0].keyword))); }
#line 43392 "gram.c" /* yacc.c:1646  */
    break;

  case 1366:
#line 10326 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].list); }
#line 43398 "gram.c" /* yacc.c:1646  */
    break;

  case 1367:
#line 10327 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 43404 "gram.c" /* yacc.c:1646  */
    break;

  case 1368:
#line 10328 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 43410 "gram.c" /* yacc.c:1646  */
    break;

  case 1369:
#line 10341 "gram.y" /* yacc.c:1646  */
    {
					AlterTypeStmt *n = makeNode(AlterTypeStmt);

					n->typeName = (yyvsp[-4].list);
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 43422 "gram.c" /* yacc.c:1646  */
    break;

  case 1370:
#line 10357 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_AGGREGATE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43435 "gram.c" /* yacc.c:1646  */
    break;

  case 1371:
#line 10366 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_COLLATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43448 "gram.c" /* yacc.c:1646  */
    break;

  case 1372:
#line 10375 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_CONVERSION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43461 "gram.c" /* yacc.c:1646  */
    break;

  case 1373:
#line 10384 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DATABASE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43474 "gram.c" /* yacc.c:1646  */
    break;

  case 1374:
#line 10393 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_DOMAIN;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43487 "gram.c" /* yacc.c:1646  */
    break;

  case 1375:
#line 10402 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FUNCTION;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43500 "gram.c" /* yacc.c:1646  */
    break;

  case 1376:
#line 10411 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LANGUAGE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43513 "gram.c" /* yacc.c:1646  */
    break;

  case 1377:
#line 10420 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_LARGEOBJECT;
					n->object = (Node *) (yyvsp[-3].node);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43526 "gram.c" /* yacc.c:1646  */
    break;

  case 1378:
#line 10429 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPERATOR;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43539 "gram.c" /* yacc.c:1646  */
    break;

  case 1379:
#line 10438 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPCLASS;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43552 "gram.c" /* yacc.c:1646  */
    break;

  case 1380:
#line 10447 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_OPFAMILY;
					n->object = (Node *) lcons(makeString((yyvsp[-3].str)), (yyvsp[-5].list));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43565 "gram.c" /* yacc.c:1646  */
    break;

  case 1381:
#line 10456 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PROCEDURE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43578 "gram.c" /* yacc.c:1646  */
    break;

  case 1382:
#line 10465 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_ROUTINE;
					n->object = (Node *) (yyvsp[-3].objwithargs);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43591 "gram.c" /* yacc.c:1646  */
    break;

  case 1383:
#line 10474 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SCHEMA;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43604 "gram.c" /* yacc.c:1646  */
    break;

  case 1384:
#line 10483 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TYPE;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43617 "gram.c" /* yacc.c:1646  */
    break;

  case 1385:
#line 10492 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TABLESPACE;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43630 "gram.c" /* yacc.c:1646  */
    break;

  case 1386:
#line 10501 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_STATISTIC_EXT;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43643 "gram.c" /* yacc.c:1646  */
    break;

  case 1387:
#line 10510 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43656 "gram.c" /* yacc.c:1646  */
    break;

  case 1388:
#line 10519 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (Node *) (yyvsp[-3].list);
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43669 "gram.c" /* yacc.c:1646  */
    break;

  case 1389:
#line 10528 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FDW;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43682 "gram.c" /* yacc.c:1646  */
    break;

  case 1390:
#line 10537 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43695 "gram.c" /* yacc.c:1646  */
    break;

  case 1391:
#line 10546 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_EVENT_TRIGGER;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43708 "gram.c" /* yacc.c:1646  */
    break;

  case 1392:
#line 10555 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_PUBLICATION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43721 "gram.c" /* yacc.c:1646  */
    break;

  case 1393:
#line 10564 "gram.y" /* yacc.c:1646  */
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);

					n->objectType = OBJECT_SUBSCRIPTION;
					n->object = (Node *) makeString((yyvsp[-3].str));
					n->newowner = (yyvsp[0].rolespec);
					(yyval.node) = (Node *) n;
				}
#line 43734 "gram.c" /* yacc.c:1646  */
    break;

  case 1394:
#line 10592 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43746 "gram.c" /* yacc.c:1646  */
    break;

  case 1395:
#line 10600 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-4].str);
					n->options = (yyvsp[0].list);
					n->for_all_tables = true;
					(yyval.node) = (Node *) n;
				}
#line 43759 "gram.c" /* yacc.c:1646  */
    break;

  case 1396:
#line 10609 "gram.y" /* yacc.c:1646  */
    {
					CreatePublicationStmt *n = makeNode(CreatePublicationStmt);

					n->pubname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					n->pubobjects = (List *) (yyvsp[-1].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 43773 "gram.c" /* yacc.c:1646  */
    break;

  case 1397:
#line 10635 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLE;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43786 "gram.c" /* yacc.c:1646  */
    break;

  case 1398:
#line 10644 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
					(yyval.publicationobjectspec)->name = (yyvsp[0].str);
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43797 "gram.c" /* yacc.c:1646  */
    break;

  case 1399:
#line 10651 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43807 "gram.c" /* yacc.c:1646  */
    break;

  case 1400:
#line 10657 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					/*
					 * If either a row filter or column list is specified, create
					 * a PublicationTable object.
					 */
					if ((yyvsp[-1].list) || (yyvsp[0].node))
					{
						/*
						 * The OptWhereClause must be stored here but it is
						 * valid only for tables. For non-table objects, an
						 * error will be thrown later via
						 * preprocess_pubobj_list().
						 */
						(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
						(yyval.publicationobjectspec)->pubtable->relation = makeRangeVar(NULL, (yyvsp[-2].str), (yylsp[-2]));
						(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
						(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					}
					else
					{
						(yyval.publicationobjectspec)->name = (yyvsp[-2].str);
					}
					(yyval.publicationobjectspec)->location = (yylsp[-2]);
				}
#line 43838 "gram.c" /* yacc.c:1646  */
    break;

  case 1401:
#line 10684 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = makeRangeVarFromQualifiedName((yyvsp[-3].str), (yyvsp[-2].list), (yylsp[-3]), yyscanner);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
					(yyval.publicationobjectspec)->location = (yylsp[-3]);
				}
#line 43852 "gram.c" /* yacc.c:1646  */
    break;

  case 1402:
#line 10695 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->pubtable = makeNode(PublicationTable);
					(yyval.publicationobjectspec)->pubtable->relation = (yyvsp[-2].range);
					(yyval.publicationobjectspec)->pubtable->columns = (yyvsp[-1].list);
					(yyval.publicationobjectspec)->pubtable->whereClause = (yyvsp[0].node);
				}
#line 43865 "gram.c" /* yacc.c:1646  */
    break;

  case 1403:
#line 10704 "gram.y" /* yacc.c:1646  */
    {
					(yyval.publicationobjectspec) = makeNode(PublicationObjSpec);
					(yyval.publicationobjectspec)->pubobjtype = PUBLICATIONOBJ_CONTINUATION;
					(yyval.publicationobjectspec)->location = (yylsp[0]);
				}
#line 43875 "gram.c" /* yacc.c:1646  */
    break;

  case 1404:
#line 10712 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].publicationobjectspec)); }
#line 43881 "gram.c" /* yacc.c:1646  */
    break;

  case 1405:
#line 10714 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].publicationobjectspec)); }
#line 43887 "gram.c" /* yacc.c:1646  */
    break;

  case 1406:
#line 10736 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43899 "gram.c" /* yacc.c:1646  */
    break;

  case 1407:
#line 10744 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_AddObjects;
					(yyval.node) = (Node *) n;
				}
#line 43913 "gram.c" /* yacc.c:1646  */
    break;

  case 1408:
#line 10754 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_SetObjects;
					(yyval.node) = (Node *) n;
				}
#line 43927 "gram.c" /* yacc.c:1646  */
    break;

  case 1409:
#line 10764 "gram.y" /* yacc.c:1646  */
    {
					AlterPublicationStmt *n = makeNode(AlterPublicationStmt);

					n->pubname = (yyvsp[-2].str);
					n->pubobjects = (yyvsp[0].list);
					preprocess_pubobj_list(n->pubobjects, yyscanner);
					n->action = AP_DropObjects;
					(yyval.node) = (Node *) n;
				}
#line 43941 "gram.c" /* yacc.c:1646  */
    break;

  case 1410:
#line 10783 "gram.y" /* yacc.c:1646  */
    {
					CreateSubscriptionStmt *n =
						makeNode(CreateSubscriptionStmt);
					n->subname = (yyvsp[-5].str);
					n->conninfo = (yyvsp[-3].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43955 "gram.c" /* yacc.c:1646  */
    break;

  case 1411:
#line 10802 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_OPTIONS;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43969 "gram.c" /* yacc.c:1646  */
    break;

  case 1412:
#line 10812 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_CONNECTION;
					n->subname = (yyvsp[-2].str);
					n->conninfo = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 43983 "gram.c" /* yacc.c:1646  */
    break;

  case 1413:
#line 10822 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_REFRESH;
					n->subname = (yyvsp[-3].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 43997 "gram.c" /* yacc.c:1646  */
    break;

  case 1414:
#line 10832 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ADD_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44012 "gram.c" /* yacc.c:1646  */
    break;

  case 1415:
#line 10843 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_DROP_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44027 "gram.c" /* yacc.c:1646  */
    break;

  case 1416:
#line 10854 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SET_PUBLICATION;
					n->subname = (yyvsp[-4].str);
					n->publication = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44042 "gram.c" /* yacc.c:1646  */
    break;

  case 1417:
#line 10865 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(true), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 44057 "gram.c" /* yacc.c:1646  */
    break;

  case 1418:
#line 10876 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_ENABLED;
					n->subname = (yyvsp[-1].str);
					n->options = list_make1(makeDefElem("enabled",
											(Node *) makeBoolean(false), (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 44072 "gram.c" /* yacc.c:1646  */
    break;

  case 1419:
#line 10887 "gram.y" /* yacc.c:1646  */
    {
					AlterSubscriptionStmt *n =
						makeNode(AlterSubscriptionStmt);

					n->kind = ALTER_SUBSCRIPTION_SKIP;
					n->subname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44086 "gram.c" /* yacc.c:1646  */
    break;

  case 1420:
#line 10905 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 44099 "gram.c" /* yacc.c:1646  */
    break;

  case 1421:
#line 10914 "gram.y" /* yacc.c:1646  */
    {
					DropSubscriptionStmt *n = makeNode(DropSubscriptionStmt);

					n->subname = (yyvsp[-1].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[0].dbehavior);
					(yyval.node) = (Node *) n;
				}
#line 44112 "gram.c" /* yacc.c:1646  */
    break;

  case 1422:
#line 10933 "gram.y" /* yacc.c:1646  */
    {
					RuleStmt   *n = makeNode(RuleStmt);

					n->replace = (yyvsp[-11].boolean);
					n->relation = (yyvsp[-4].range);
					n->rulename = (yyvsp[-9].str);
					n->whereClause = (yyvsp[-3].node);
					n->event = (yyvsp[-6].ival);
					n->instead = (yyvsp[-1].boolean);
					n->actions = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44129 "gram.c" /* yacc.c:1646  */
    break;

  case 1423:
#line 10948 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44135 "gram.c" /* yacc.c:1646  */
    break;

  case 1424:
#line 10949 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 44141 "gram.c" /* yacc.c:1646  */
    break;

  case 1425:
#line 10950 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 44147 "gram.c" /* yacc.c:1646  */
    break;

  case 1426:
#line 10956 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				  else
					(yyval.list) = (yyvsp[-2].list);
				}
#line 44157 "gram.c" /* yacc.c:1646  */
    break;

  case 1427:
#line 10962 "gram.y" /* yacc.c:1646  */
    { if ((yyvsp[0].node) != NULL)
					(yyval.list) = list_make1((yyvsp[0].node));
				  else
					(yyval.list) = NIL;
				}
#line 44167 "gram.c" /* yacc.c:1646  */
    break;

  case 1433:
#line 10978 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 44173 "gram.c" /* yacc.c:1646  */
    break;

  case 1434:
#line 10979 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 44179 "gram.c" /* yacc.c:1646  */
    break;

  case 1435:
#line 10982 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_SELECT; }
#line 44185 "gram.c" /* yacc.c:1646  */
    break;

  case 1436:
#line 10983 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_UPDATE; }
#line 44191 "gram.c" /* yacc.c:1646  */
    break;

  case 1437:
#line 10984 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_DELETE; }
#line 44197 "gram.c" /* yacc.c:1646  */
    break;

  case 1438:
#line 10985 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CMD_INSERT; }
#line 44203 "gram.c" /* yacc.c:1646  */
    break;

  case 1439:
#line 10989 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44209 "gram.c" /* yacc.c:1646  */
    break;

  case 1440:
#line 10990 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44215 "gram.c" /* yacc.c:1646  */
    break;

  case 1441:
#line 10991 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44221 "gram.c" /* yacc.c:1646  */
    break;

  case 1442:
#line 11004 "gram.y" /* yacc.c:1646  */
    {
					NotifyStmt *n = makeNode(NotifyStmt);

					n->conditionname = (yyvsp[-1].str);
					n->payload = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44233 "gram.c" /* yacc.c:1646  */
    break;

  case 1443:
#line 11014 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44239 "gram.c" /* yacc.c:1646  */
    break;

  case 1444:
#line 11015 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 44245 "gram.c" /* yacc.c:1646  */
    break;

  case 1445:
#line 11019 "gram.y" /* yacc.c:1646  */
    {
					ListenStmt *n = makeNode(ListenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44256 "gram.c" /* yacc.c:1646  */
    break;

  case 1446:
#line 11029 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44267 "gram.c" /* yacc.c:1646  */
    break;

  case 1447:
#line 11036 "gram.y" /* yacc.c:1646  */
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);

					n->conditionname = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44278 "gram.c" /* yacc.c:1646  */
    break;

  case 1448:
#line 11056 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44292 "gram.c" /* yacc.c:1646  */
    break;

  case 1449:
#line 11066 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44305 "gram.c" /* yacc.c:1646  */
    break;

  case 1450:
#line 11075 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44319 "gram.c" /* yacc.c:1646  */
    break;

  case 1451:
#line 11085 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44333 "gram.c" /* yacc.c:1646  */
    break;

  case 1452:
#line 11095 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_SAVEPOINT;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44346 "gram.c" /* yacc.c:1646  */
    break;

  case 1453:
#line 11104 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44359 "gram.c" /* yacc.c:1646  */
    break;

  case 1454:
#line 11113 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_RELEASE;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44372 "gram.c" /* yacc.c:1646  */
    break;

  case 1455:
#line 11122 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44385 "gram.c" /* yacc.c:1646  */
    break;

  case 1456:
#line 11131 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->savepoint_name = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44398 "gram.c" /* yacc.c:1646  */
    break;

  case 1457:
#line 11140 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44411 "gram.c" /* yacc.c:1646  */
    break;

  case 1458:
#line 11149 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44424 "gram.c" /* yacc.c:1646  */
    break;

  case 1459:
#line 11158 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[0].str);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 44437 "gram.c" /* yacc.c:1646  */
    break;

  case 1460:
#line 11170 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[0].list);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44450 "gram.c" /* yacc.c:1646  */
    break;

  case 1461:
#line 11179 "gram.y" /* yacc.c:1646  */
    {
					TransactionStmt *n = makeNode(TransactionStmt);

					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					n->chain = (yyvsp[0].boolean);
					n->location = -1;
					(yyval.node) = (Node *) n;
				}
#line 44464 "gram.c" /* yacc.c:1646  */
    break;

  case 1465:
#line 11197 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[0].str), (yylsp[0])), (yylsp[-2])); }
#line 44471 "gram.c" /* yacc.c:1646  */
    break;

  case 1466:
#line 11200 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(true, (yylsp[-1])), (yylsp[-1])); }
#line 44478 "gram.c" /* yacc.c:1646  */
    break;

  case 1467:
#line 11203 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 44485 "gram.c" /* yacc.c:1646  */
    break;

  case 1468:
#line 11206 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(true, (yylsp[0])), (yylsp[0])); }
#line 44492 "gram.c" /* yacc.c:1646  */
    break;

  case 1469:
#line 11209 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("transaction_deferrable",
									   makeIntConst(false, (yylsp[-1])), (yylsp[-1])); }
#line 44499 "gram.c" /* yacc.c:1646  */
    break;

  case 1470:
#line 11216 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 44505 "gram.c" /* yacc.c:1646  */
    break;

  case 1471:
#line 11218 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt)); }
#line 44511 "gram.c" /* yacc.c:1646  */
    break;

  case 1472:
#line 11220 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 44517 "gram.c" /* yacc.c:1646  */
    break;

  case 1474:
#line 11226 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44523 "gram.c" /* yacc.c:1646  */
    break;

  case 1475:
#line 11230 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 44529 "gram.c" /* yacc.c:1646  */
    break;

  case 1476:
#line 11231 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44535 "gram.c" /* yacc.c:1646  */
    break;

  case 1477:
#line 11232 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 44541 "gram.c" /* yacc.c:1646  */
    break;

  case 1478:
#line 11246 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44558 "gram.c" /* yacc.c:1646  */
    break;

  case 1479:
#line 11260 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-5].range);
					n->view->relpersistence = (yyvsp[-7].ival);
					n->aliases = (yyvsp[-4].list);
					n->query = (yyvsp[-1].node);
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 44575 "gram.c" /* yacc.c:1646  */
    break;

  case 1480:
#line 11274 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = false;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 44597 "gram.c" /* yacc.c:1646  */
    break;

  case 1481:
#line 11293 "gram.y" /* yacc.c:1646  */
    {
					ViewStmt   *n = makeNode(ViewStmt);

					n->view = (yyvsp[-7].range);
					n->view->relpersistence = (yyvsp[-10].ival);
					n->aliases = (yyvsp[-5].list);
					n->query = makeRecursiveViewSelect(n->view->relname, n->aliases, (yyvsp[-1].node));
					n->replace = true;
					n->options = (yyvsp[-3].list);
					n->withCheckOption = (yyvsp[0].ival);
					if (n->withCheckOption != NO_CHECK_OPTION)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("WITH CHECK OPTION not supported on recursive views"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) n;
				}
#line 44619 "gram.c" /* yacc.c:1646  */
    break;

  case 1482:
#line 11313 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44625 "gram.c" /* yacc.c:1646  */
    break;

  case 1483:
#line 11314 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CASCADED_CHECK_OPTION; }
#line 44631 "gram.c" /* yacc.c:1646  */
    break;

  case 1484:
#line 11315 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LOCAL_CHECK_OPTION; }
#line 44637 "gram.c" /* yacc.c:1646  */
    break;

  case 1485:
#line 11316 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = NO_CHECK_OPTION; }
#line 44643 "gram.c" /* yacc.c:1646  */
    break;

  case 1486:
#line 11327 "gram.y" /* yacc.c:1646  */
    {
					LoadStmt   *n = makeNode(LoadStmt);

					n->filename = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 44654 "gram.c" /* yacc.c:1646  */
    break;

  case 1487:
#line 11344 "gram.y" /* yacc.c:1646  */
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 44666 "gram.c" /* yacc.c:1646  */
    break;

  case 1488:
#line 11354 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 44672 "gram.c" /* yacc.c:1646  */
    break;

  case 1489:
#line 11355 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 44678 "gram.c" /* yacc.c:1646  */
    break;

  case 1490:
#line 11359 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 44684 "gram.c" /* yacc.c:1646  */
    break;

  case 1491:
#line 11360 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 44690 "gram.c" /* yacc.c:1646  */
    break;

  case 1492:
#line 11365 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (yyvsp[0].node), (yylsp[-2]));
				}
#line 44698 "gram.c" /* yacc.c:1646  */
    break;

  case 1493:
#line 11369 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), (Node *) makeString((yyvsp[0].str)), (yylsp[-2]));
				}
#line 44706 "gram.c" /* yacc.c:1646  */
    break;

  case 1494:
#line 11373 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-2].str), NULL, (yylsp[-2]));
				}
#line 44714 "gram.c" /* yacc.c:1646  */
    break;

  case 1495:
#line 11390 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 44720 "gram.c" /* yacc.c:1646  */
    break;

  case 1496:
#line 11391 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup("connection_limit"); }
#line 44726 "gram.c" /* yacc.c:1646  */
    break;

  case 1497:
#line 11392 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44732 "gram.c" /* yacc.c:1646  */
    break;

  case 1498:
#line 11393 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44738 "gram.c" /* yacc.c:1646  */
    break;

  case 1499:
#line 11394 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44744 "gram.c" /* yacc.c:1646  */
    break;

  case 1500:
#line 11395 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44750 "gram.c" /* yacc.c:1646  */
    break;

  case 1501:
#line 11396 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 44756 "gram.c" /* yacc.c:1646  */
    break;

  case 1504:
#line 11416 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-2].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44768 "gram.c" /* yacc.c:1646  */
    break;

  case 1505:
#line 11424 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-1].str);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				 }
#line 44780 "gram.c" /* yacc.c:1646  */
    break;

  case 1506:
#line 11432 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);

					n->dbname = (yyvsp[-3].str);
					n->options = list_make1(makeDefElem("tablespace",
														(Node *) makeString((yyvsp[0].str)), (yylsp[0])));
					(yyval.node) = (Node *) n;
				 }
#line 44793 "gram.c" /* yacc.c:1646  */
    break;

  case 1507:
#line 11441 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseRefreshCollStmt *n = makeNode(AlterDatabaseRefreshCollStmt);

					n->dbname = (yyvsp[-3].str);
					(yyval.node) = (Node *) n;
				 }
#line 44804 "gram.c" /* yacc.c:1646  */
    break;

  case 1508:
#line 11451 "gram.y" /* yacc.c:1646  */
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);

					n->dbname = (yyvsp[-1].str);
					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44816 "gram.c" /* yacc.c:1646  */
    break;

  case 1509:
#line 11469 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = false;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44829 "gram.c" /* yacc.c:1646  */
    break;

  case 1510:
#line 11478 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[0].str);
					n->missing_ok = true;
					n->options = NULL;
					(yyval.node) = (Node *) n;
				}
#line 44842 "gram.c" /* yacc.c:1646  */
    break;

  case 1511:
#line 11487 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = false;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44855 "gram.c" /* yacc.c:1646  */
    break;

  case 1512:
#line 11496 "gram.y" /* yacc.c:1646  */
    {
					DropdbStmt *n = makeNode(DropdbStmt);

					n->dbname = (yyvsp[-4].str);
					n->missing_ok = true;
					n->options = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 44868 "gram.c" /* yacc.c:1646  */
    break;

  case 1513:
#line 11508 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((Node *) (yyvsp[0].defelt));
				}
#line 44876 "gram.c" /* yacc.c:1646  */
    break;

  case 1514:
#line 11512 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (Node *) (yyvsp[0].defelt));
				}
#line 44884 "gram.c" /* yacc.c:1646  */
    break;

  case 1515:
#line 11523 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem("force", NULL, (yylsp[0]));
				}
#line 44892 "gram.c" /* yacc.c:1646  */
    break;

  case 1516:
#line 11535 "gram.y" /* yacc.c:1646  */
    {
					AlterCollationStmt *n = makeNode(AlterCollationStmt);

					n->collname = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 44903 "gram.c" /* yacc.c:1646  */
    break;

  case 1517:
#line 11553 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44914 "gram.c" /* yacc.c:1646  */
    break;

  case 1518:
#line 11560 "gram.y" /* yacc.c:1646  */
    {
					AlterSystemStmt *n = makeNode(AlterSystemStmt);

					n->setstmt = (yyvsp[0].vsetstmt);
					(yyval.node) = (Node *) n;
				}
#line 44925 "gram.c" /* yacc.c:1646  */
    break;

  case 1519:
#line 11577 "gram.y" /* yacc.c:1646  */
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);

					n->domainname = (yyvsp[-3].list);
					n->typeName = (yyvsp[-1].typnam);
					SplitColQualList((yyvsp[0].list), &n->constraints, &n->collClause,
									 yyscanner);
					(yyval.node) = (Node *) n;
				}
#line 44939 "gram.c" /* yacc.c:1646  */
    break;

  case 1520:
#line 11591 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'T';
					n->typeName = (yyvsp[-1].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44952 "gram.c" /* yacc.c:1646  */
    break;

  case 1521:
#line 11601 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'N';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44964 "gram.c" /* yacc.c:1646  */
    break;

  case 1522:
#line 11610 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'O';
					n->typeName = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 44976 "gram.c" /* yacc.c:1646  */
    break;

  case 1523:
#line 11619 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'C';
					n->typeName = (yyvsp[-2].list);
					n->def = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 44989 "gram.c" /* yacc.c:1646  */
    break;

  case 1524:
#line 11629 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-4].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 45004 "gram.c" /* yacc.c:1646  */
    break;

  case 1525:
#line 11641 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'X';
					n->typeName = (yyvsp[-6].list);
					n->name = (yyvsp[-1].str);
					n->behavior = (yyvsp[0].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 45019 "gram.c" /* yacc.c:1646  */
    break;

  case 1526:
#line 11653 "gram.y" /* yacc.c:1646  */
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);

					n->subtype = 'V';
					n->typeName = (yyvsp[-3].list);
					n->name = (yyvsp[0].str);
					(yyval.node) = (Node *) n;
				}
#line 45032 "gram.c" /* yacc.c:1646  */
    break;

  case 1529:
#line 11676 "gram.y" /* yacc.c:1646  */
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);

					n->dictname = (yyvsp[-1].list);
					n->options = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45044 "gram.c" /* yacc.c:1646  */
    break;

  case 1530:
#line 11687 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ADD_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 45060 "gram.c" /* yacc.c:1646  */
    break;

  case 1531:
#line 11699 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_ALTER_MAPPING_FOR_TOKEN;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[-2].list);
					n->dicts = (yyvsp[0].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node *) n;
				}
#line 45076 "gram.c" /* yacc.c:1646  */
    break;

  case 1532:
#line 11711 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 45092 "gram.c" /* yacc.c:1646  */
    break;

  case 1533:
#line 11723 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_REPLACE_DICT_FOR_TOKEN;
					n->cfgname = (yyvsp[-8].list);
					n->tokentype = (yyvsp[-4].list);
					n->dicts = list_make2((yyvsp[-2].list),(yyvsp[0].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node *) n;
				}
#line 45108 "gram.c" /* yacc.c:1646  */
    break;

  case 1534:
#line 11735 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-4].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				}
#line 45122 "gram.c" /* yacc.c:1646  */
    break;

  case 1535:
#line 11745 "gram.y" /* yacc.c:1646  */
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);

					n->kind = ALTER_TSCONFIG_DROP_MAPPING;
					n->cfgname = (yyvsp[-6].list);
					n->tokentype = (yyvsp[0].list);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				}
#line 45136 "gram.c" /* yacc.c:1646  */
    break;

  case 1538:
#line 11774 "gram.y" /* yacc.c:1646  */
    {
				CreateConversionStmt *n = makeNode(CreateConversionStmt);

				n->conversion_name = (yyvsp[-6].list);
				n->for_encoding_name = (yyvsp[-4].str);
				n->to_encoding_name = (yyvsp[-2].str);
				n->func_name = (yyvsp[0].list);
				n->def = (yyvsp[-8].boolean);
				(yyval.node) = (Node *) n;
			}
#line 45151 "gram.c" /* yacc.c:1646  */
    break;

  case 1539:
#line 11797 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = (yyvsp[-3].list);
					(yyval.node) = (Node *) n;
				}
#line 45164 "gram.c" /* yacc.c:1646  */
    break;

  case 1540:
#line 11806 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 45177 "gram.c" /* yacc.c:1646  */
    break;

  case 1541:
#line 11816 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[-1].range);
					n->indexname = (yyvsp[0].str);
					n->params = NIL;
					if ((yyvsp[-2].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-2])));
					(yyval.node) = (Node *) n;
				}
#line 45192 "gram.c" /* yacc.c:1646  */
    break;

  case 1542:
#line 11828 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = NULL;
					n->indexname = NULL;
					n->params = NIL;
					if ((yyvsp[0].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[0])));
					(yyval.node) = (Node *) n;
				}
#line 45207 "gram.c" /* yacc.c:1646  */
    break;

  case 1543:
#line 11840 "gram.y" /* yacc.c:1646  */
    {
					ClusterStmt *n = makeNode(ClusterStmt);

					n->relation = (yyvsp[0].range);
					n->indexname = (yyvsp[-2].str);
					n->params = NIL;
					if ((yyvsp[-3].boolean))
						n->params = lappend(n->params, makeDefElem("verbose", NULL, (yylsp[-3])));
					(yyval.node) = (Node *) n;
				}
#line 45222 "gram.c" /* yacc.c:1646  */
    break;

  case 1544:
#line 11853 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45228 "gram.c" /* yacc.c:1646  */
    break;

  case 1545:
#line 11854 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 45234 "gram.c" /* yacc.c:1646  */
    break;

  case 1546:
#line 11867 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-4].boolean))
						n->options = lappend(n->options,
											 makeDefElem("full", NULL, (yylsp[-4])));
					if ((yyvsp[-3].boolean))
						n->options = lappend(n->options,
											 makeDefElem("freeze", NULL, (yylsp[-3])));
					if ((yyvsp[-2].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("analyze", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 45259 "gram.c" /* yacc.c:1646  */
    break;

  case 1547:
#line 11888 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = true;
					(yyval.node) = (Node *) n;
				}
#line 45272 "gram.c" /* yacc.c:1646  */
    break;

  case 1548:
#line 11899 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = NIL;
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 45288 "gram.c" /* yacc.c:1646  */
    break;

  case 1549:
#line 11911 "gram.y" /* yacc.c:1646  */
    {
					VacuumStmt *n = makeNode(VacuumStmt);

					n->options = (yyvsp[-2].list);
					n->rels = (yyvsp[0].list);
					n->is_vacuumcmd = false;
					(yyval.node) = (Node *) n;
				}
#line 45301 "gram.c" /* yacc.c:1646  */
    break;

  case 1550:
#line 11923 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].defelt));
				}
#line 45309 "gram.c" /* yacc.c:1646  */
    break;

  case 1551:
#line 11927 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].defelt));
				}
#line 45317 "gram.c" /* yacc.c:1646  */
    break;

  case 1554:
#line 11939 "gram.y" /* yacc.c:1646  */
    {
					(yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1]));
				}
#line 45325 "gram.c" /* yacc.c:1646  */
    break;

  case 1555:
#line 11945 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 45331 "gram.c" /* yacc.c:1646  */
    break;

  case 1556:
#line 11946 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "analyze"; }
#line 45337 "gram.c" /* yacc.c:1646  */
    break;

  case 1557:
#line 11947 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "format"; }
#line 45343 "gram.c" /* yacc.c:1646  */
    break;

  case 1558:
#line 11951 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeString((yyvsp[0].str)); }
#line 45349 "gram.c" /* yacc.c:1646  */
    break;

  case 1559:
#line 11952 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[0].node); }
#line 45355 "gram.c" /* yacc.c:1646  */
    break;

  case 1560:
#line 11953 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 45361 "gram.c" /* yacc.c:1646  */
    break;

  case 1561:
#line 11957 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45367 "gram.c" /* yacc.c:1646  */
    break;

  case 1562:
#line 11958 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45373 "gram.c" /* yacc.c:1646  */
    break;

  case 1563:
#line 11962 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45379 "gram.c" /* yacc.c:1646  */
    break;

  case 1564:
#line 11963 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45385 "gram.c" /* yacc.c:1646  */
    break;

  case 1565:
#line 11966 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45391 "gram.c" /* yacc.c:1646  */
    break;

  case 1566:
#line 11967 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45397 "gram.c" /* yacc.c:1646  */
    break;

  case 1567:
#line 11970 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45403 "gram.c" /* yacc.c:1646  */
    break;

  case 1568:
#line 11971 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45409 "gram.c" /* yacc.c:1646  */
    break;

  case 1569:
#line 11975 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45415 "gram.c" /* yacc.c:1646  */
    break;

  case 1570:
#line 11976 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45421 "gram.c" /* yacc.c:1646  */
    break;

  case 1571:
#line 11981 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeVacuumRelation((yyvsp[-1].range), InvalidOid, (yyvsp[0].list));
				}
#line 45429 "gram.c" /* yacc.c:1646  */
    break;

  case 1572:
#line 11988 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 45435 "gram.c" /* yacc.c:1646  */
    break;

  case 1573:
#line 11990 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 45441 "gram.c" /* yacc.c:1646  */
    break;

  case 1574:
#line 11994 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45447 "gram.c" /* yacc.c:1646  */
    break;

  case 1575:
#line 11995 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45453 "gram.c" /* yacc.c:1646  */
    break;

  case 1576:
#line 12009 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				}
#line 45465 "gram.c" /* yacc.c:1646  */
    break;

  case 1577:
#line 12017 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("analyze", NULL, (yylsp[-2])));
					if ((yyvsp[-1].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 45480 "gram.c" /* yacc.c:1646  */
    break;

  case 1578:
#line 12028 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = list_make1(makeDefElem("verbose", NULL, (yylsp[-1])));
					(yyval.node) = (Node *) n;
				}
#line 45492 "gram.c" /* yacc.c:1646  */
    break;

  case 1579:
#line 12036 "gram.y" /* yacc.c:1646  */
    {
					ExplainStmt *n = makeNode(ExplainStmt);

					n->query = (yyvsp[0].node);
					n->options = (yyvsp[-2].list);
					(yyval.node) = (Node *) n;
				}
#line 45504 "gram.c" /* yacc.c:1646  */
    break;

  case 1590:
#line 12066 "gram.y" /* yacc.c:1646  */
    {
					PrepareStmt *n = makeNode(PrepareStmt);

					n->name = (yyvsp[-3].str);
					n->argtypes = (yyvsp[-2].list);
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 45517 "gram.c" /* yacc.c:1646  */
    break;

  case 1591:
#line 12076 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45523 "gram.c" /* yacc.c:1646  */
    break;

  case 1592:
#line 12077 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45529 "gram.c" /* yacc.c:1646  */
    break;

  case 1598:
#line 12096 "gram.y" /* yacc.c:1646  */
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-1].str);
					n->params = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 45541 "gram.c" /* yacc.c:1646  */
    break;

  case 1599:
#line 12105 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = false;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-7].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 45562 "gram.c" /* yacc.c:1646  */
    break;

  case 1600:
#line 12123 "gram.y" /* yacc.c:1646  */
    {
					CreateTableAsStmt *ctas = makeNode(CreateTableAsStmt);
					ExecuteStmt *n = makeNode(ExecuteStmt);

					n->name = (yyvsp[-2].str);
					n->params = (yyvsp[-1].list);
					ctas->query = (Node *) n;
					ctas->into = (yyvsp[-5].into);
					ctas->objtype = OBJECT_TABLE;
					ctas->is_select_into = false;
					ctas->if_not_exists = true;
					/* cram additional flags into the IntoClause */
					(yyvsp[-5].into)->rel->relpersistence = (yyvsp[-10].ival);
					(yyvsp[-5].into)->skipData = !((yyvsp[0].boolean));
					(yyval.node) = (Node *) ctas;
				}
#line 45583 "gram.c" /* yacc.c:1646  */
    break;

  case 1601:
#line 12141 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 45589 "gram.c" /* yacc.c:1646  */
    break;

  case 1602:
#line 12142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45595 "gram.c" /* yacc.c:1646  */
    break;

  case 1603:
#line 12153 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 45608 "gram.c" /* yacc.c:1646  */
    break;

  case 1604:
#line 12162 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = (yyvsp[0].str);
						n->isall = false;
						n->location = (yylsp[0]);
						(yyval.node) = (Node *) n;
					}
#line 45621 "gram.c" /* yacc.c:1646  */
    break;

  case 1605:
#line 12171 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45634 "gram.c" /* yacc.c:1646  */
    break;

  case 1606:
#line 12180 "gram.y" /* yacc.c:1646  */
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);

						n->name = NULL;
						n->isall = true;
						n->location = -1;
						(yyval.node) = (Node *) n;
					}
#line 45647 "gram.c" /* yacc.c:1646  */
    break;

  case 1607:
#line 12200 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].istmt)->relation = (yyvsp[-3].range);
					(yyvsp[-2].istmt)->onConflictClause = (yyvsp[-1].onconflict);
					(yyvsp[-2].istmt)->returningList = (yyvsp[0].list);
					(yyvsp[-2].istmt)->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) (yyvsp[-2].istmt);
				}
#line 45659 "gram.c" /* yacc.c:1646  */
    break;

  case 1608:
#line 12217 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 45667 "gram.c" /* yacc.c:1646  */
    break;

  case 1609:
#line 12221 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].range)->alias = makeAlias((yyvsp[0].str), NIL);
					(yyval.range) = (yyvsp[-2].range);
				}
#line 45676 "gram.c" /* yacc.c:1646  */
    break;

  case 1610:
#line 12229 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45686 "gram.c" /* yacc.c:1646  */
    break;

  case 1611:
#line 12235 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45697 "gram.c" /* yacc.c:1646  */
    break;

  case 1612:
#line 12242 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-2].list);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45707 "gram.c" /* yacc.c:1646  */
    break;

  case 1613:
#line 12248 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[-5].list);
					(yyval.istmt)->override = (yyvsp[-2].ival);
					(yyval.istmt)->selectStmt = (yyvsp[0].node);
				}
#line 45718 "gram.c" /* yacc.c:1646  */
    break;

  case 1614:
#line 12255 "gram.y" /* yacc.c:1646  */
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				}
#line 45728 "gram.c" /* yacc.c:1646  */
    break;

  case 1615:
#line 12263 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_USER_VALUE; }
#line 45734 "gram.c" /* yacc.c:1646  */
    break;

  case 1616:
#line 12264 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = OVERRIDING_SYSTEM_VALUE; }
#line 45740 "gram.c" /* yacc.c:1646  */
    break;

  case 1617:
#line 12269 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 45746 "gram.c" /* yacc.c:1646  */
    break;

  case 1618:
#line 12271 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 45752 "gram.c" /* yacc.c:1646  */
    break;

  case 1619:
#line 12276 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[-1]);
				}
#line 45764 "gram.c" /* yacc.c:1646  */
    break;

  case 1620:
#line 12287 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_UPDATE;
					(yyval.onconflict)->infer = (yyvsp[-5].infer);
					(yyval.onconflict)->targetList = (yyvsp[-1].list);
					(yyval.onconflict)->whereClause = (yyvsp[0].node);
					(yyval.onconflict)->location = (yylsp[-7]);
				}
#line 45777 "gram.c" /* yacc.c:1646  */
    break;

  case 1621:
#line 12297 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = makeNode(OnConflictClause);
					(yyval.onconflict)->action = ONCONFLICT_NOTHING;
					(yyval.onconflict)->infer = (yyvsp[-2].infer);
					(yyval.onconflict)->targetList = NIL;
					(yyval.onconflict)->whereClause = NULL;
					(yyval.onconflict)->location = (yylsp[-4]);
				}
#line 45790 "gram.c" /* yacc.c:1646  */
    break;

  case 1622:
#line 12306 "gram.y" /* yacc.c:1646  */
    {
					(yyval.onconflict) = NULL;
				}
#line 45798 "gram.c" /* yacc.c:1646  */
    break;

  case 1623:
#line 12313 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = (yyvsp[-2].list);
					(yyval.infer)->whereClause = (yyvsp[0].node);
					(yyval.infer)->conname = NULL;
					(yyval.infer)->location = (yylsp[-3]);
				}
#line 45810 "gram.c" /* yacc.c:1646  */
    break;

  case 1624:
#line 12322 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = makeNode(InferClause);
					(yyval.infer)->indexElems = NIL;
					(yyval.infer)->whereClause = NULL;
					(yyval.infer)->conname = (yyvsp[0].str);
					(yyval.infer)->location = (yylsp[-2]);
				}
#line 45822 "gram.c" /* yacc.c:1646  */
    break;

  case 1625:
#line 12330 "gram.y" /* yacc.c:1646  */
    {
					(yyval.infer) = NULL;
				}
#line 45830 "gram.c" /* yacc.c:1646  */
    break;

  case 1626:
#line 12336 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45836 "gram.c" /* yacc.c:1646  */
    break;

  case 1627:
#line 12337 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45842 "gram.c" /* yacc.c:1646  */
    break;

  case 1628:
#line 12350 "gram.y" /* yacc.c:1646  */
    {
					DeleteStmt *n = makeNode(DeleteStmt);

					n->relation = (yyvsp[-3].range);
					n->usingClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-6].with);
					(yyval.node) = (Node *) n;
				}
#line 45857 "gram.c" /* yacc.c:1646  */
    break;

  case 1629:
#line 12363 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45863 "gram.c" /* yacc.c:1646  */
    break;

  case 1630:
#line 12364 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 45869 "gram.c" /* yacc.c:1646  */
    break;

  case 1631:
#line 12376 "gram.y" /* yacc.c:1646  */
    {
					LockStmt   *n = makeNode(LockStmt);

					n->relations = (yyvsp[-2].list);
					n->mode = (yyvsp[-1].ival);
					n->nowait = (yyvsp[0].boolean);
					(yyval.node) = (Node *) n;
				}
#line 45882 "gram.c" /* yacc.c:1646  */
    break;

  case 1632:
#line 12386 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival); }
#line 45888 "gram.c" /* yacc.c:1646  */
    break;

  case 1633:
#line 12387 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 45894 "gram.c" /* yacc.c:1646  */
    break;

  case 1634:
#line 12390 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessShareLock; }
#line 45900 "gram.c" /* yacc.c:1646  */
    break;

  case 1635:
#line 12391 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowShareLock; }
#line 45906 "gram.c" /* yacc.c:1646  */
    break;

  case 1636:
#line 12392 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = RowExclusiveLock; }
#line 45912 "gram.c" /* yacc.c:1646  */
    break;

  case 1637:
#line 12393 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareUpdateExclusiveLock; }
#line 45918 "gram.c" /* yacc.c:1646  */
    break;

  case 1638:
#line 12394 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareLock; }
#line 45924 "gram.c" /* yacc.c:1646  */
    break;

  case 1639:
#line 12395 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ShareRowExclusiveLock; }
#line 45930 "gram.c" /* yacc.c:1646  */
    break;

  case 1640:
#line 12396 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ExclusiveLock; }
#line 45936 "gram.c" /* yacc.c:1646  */
    break;

  case 1641:
#line 12397 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = AccessExclusiveLock; }
#line 45942 "gram.c" /* yacc.c:1646  */
    break;

  case 1642:
#line 12400 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 45948 "gram.c" /* yacc.c:1646  */
    break;

  case 1643:
#line 12401 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 45954 "gram.c" /* yacc.c:1646  */
    break;

  case 1644:
#line 12405 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitError; }
#line 45960 "gram.c" /* yacc.c:1646  */
    break;

  case 1645:
#line 12406 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitSkip; }
#line 45966 "gram.c" /* yacc.c:1646  */
    break;

  case 1646:
#line 12407 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LockWaitBlock; }
#line 45972 "gram.c" /* yacc.c:1646  */
    break;

  case 1647:
#line 12423 "gram.y" /* yacc.c:1646  */
    {
					UpdateStmt *n = makeNode(UpdateStmt);

					n->relation = (yyvsp[-5].range);
					n->targetList = (yyvsp[-3].list);
					n->fromClause = (yyvsp[-2].list);
					n->whereClause = (yyvsp[-1].node);
					n->returningList = (yyvsp[0].list);
					n->withClause = (yyvsp[-7].with);
					(yyval.node) = (Node *) n;
				}
#line 45988 "gram.c" /* yacc.c:1646  */
    break;

  case 1648:
#line 12436 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 45994 "gram.c" /* yacc.c:1646  */
    break;

  case 1649:
#line 12437 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_concat((yyvsp[-2].list),(yyvsp[0].list)); }
#line 46000 "gram.c" /* yacc.c:1646  */
    break;

  case 1650:
#line 12442 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].target)->val = (Node *) (yyvsp[0].node);
					(yyval.list) = list_make1((yyvsp[-2].target));
				}
#line 46009 "gram.c" /* yacc.c:1646  */
    break;

  case 1651:
#line 12447 "gram.y" /* yacc.c:1646  */
    {
					int			ncolumns = list_length((yyvsp[-3].list));
					int			i = 1;
					ListCell   *col_cell;

					/* Create a MultiAssignRef source for each target */
					foreach(col_cell, (yyvsp[-3].list))
					{
						ResTarget  *res_col = (ResTarget *) lfirst(col_cell);
						MultiAssignRef *r = makeNode(MultiAssignRef);

						r->source = (Node *) (yyvsp[0].node);
						r->colno = i;
						r->ncolumns = ncolumns;
						res_col->val = (Node *) r;
						i++;
					}

					(yyval.list) = (yyvsp[-3].list);
				}
#line 46034 "gram.c" /* yacc.c:1646  */
    break;

  case 1652:
#line 12471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[-1].str);
					(yyval.target)->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[-1]);
				}
#line 46046 "gram.c" /* yacc.c:1646  */
    break;

  case 1653:
#line 12481 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 46052 "gram.c" /* yacc.c:1646  */
    break;

  case 1654:
#line 12482 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].target)); }
#line 46058 "gram.c" /* yacc.c:1646  */
    break;

  case 1655:
#line 12499 "gram.y" /* yacc.c:1646  */
    {
					MergeStmt  *m = makeNode(MergeStmt);

					m->withClause = (yyvsp[-9].with);
					m->relation = (yyvsp[-6].range);
					m->sourceRelation = (yyvsp[-4].node);
					m->joinCondition = (yyvsp[-2].node);
					m->mergeWhenClauses = (yyvsp[-1].list);
					m->returningList = (yyvsp[0].list);

					(yyval.node) = (Node *) m;
				}
#line 46075 "gram.c" /* yacc.c:1646  */
    break;

  case 1656:
#line 12514 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46081 "gram.c" /* yacc.c:1646  */
    break;

  case 1657:
#line 12515 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list),(yyvsp[0].node)); }
#line 46087 "gram.c" /* yacc.c:1646  */
    break;

  case 1658:
#line 12526 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 46098 "gram.c" /* yacc.c:1646  */
    break;

  case 1659:
#line 12533 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 46109 "gram.c" /* yacc.c:1646  */
    break;

  case 1660:
#line 12540 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[0].mergewhen)->matchKind = (yyvsp[-3].mergematch);
					(yyvsp[0].mergewhen)->condition = (yyvsp[-2].node);

					(yyval.node) = (Node *) (yyvsp[0].mergewhen);
				}
#line 46120 "gram.c" /* yacc.c:1646  */
    break;

  case 1661:
#line 12547 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 46134 "gram.c" /* yacc.c:1646  */
    break;

  case 1662:
#line 12557 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *m = makeNode(MergeWhenClause);

					m->matchKind = (yyvsp[-4].mergematch);
					m->commandType = CMD_NOTHING;
					m->condition = (yyvsp[-3].node);

					(yyval.node) = (Node *) m;
				}
#line 46148 "gram.c" /* yacc.c:1646  */
    break;

  case 1663:
#line 12569 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_MATCHED; }
#line 46154 "gram.c" /* yacc.c:1646  */
    break;

  case 1664:
#line 12570 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_SOURCE; }
#line 46160 "gram.c" /* yacc.c:1646  */
    break;

  case 1665:
#line 12574 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 46166 "gram.c" /* yacc.c:1646  */
    break;

  case 1666:
#line 12575 "gram.y" /* yacc.c:1646  */
    { (yyval.mergematch) = MERGE_WHEN_NOT_MATCHED_BY_TARGET; }
#line 46172 "gram.c" /* yacc.c:1646  */
    break;

  case 1667:
#line 12579 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46178 "gram.c" /* yacc.c:1646  */
    break;

  case 1668:
#line 12580 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 46184 "gram.c" /* yacc.c:1646  */
    break;

  case 1669:
#line 12585 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_UPDATE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[0].list);
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 46198 "gram.c" /* yacc.c:1646  */
    break;

  case 1670:
#line 12598 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_DELETE;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;

					(yyval.mergewhen) = n;
				}
#line 46212 "gram.c" /* yacc.c:1646  */
    break;

  case 1671:
#line 12611 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46225 "gram.c" /* yacc.c:1646  */
    break;

  case 1672:
#line 12620 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = NIL;
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46238 "gram.c" /* yacc.c:1646  */
    break;

  case 1673:
#line 12629 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = (yyvsp[-2].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46251 "gram.c" /* yacc.c:1646  */
    break;

  case 1674:
#line 12638 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = (yyvsp[-2].ival);
					n->targetList = (yyvsp[-5].list);
					n->values = (yyvsp[0].list);
					(yyval.mergewhen) = n;
				}
#line 46264 "gram.c" /* yacc.c:1646  */
    break;

  case 1675:
#line 12647 "gram.y" /* yacc.c:1646  */
    {
					MergeWhenClause *n = makeNode(MergeWhenClause);
					n->commandType = CMD_INSERT;
					n->override = OVERRIDING_NOT_SET;
					n->targetList = NIL;
					n->values = NIL;
					(yyval.mergewhen) = n;
				}
#line 46277 "gram.c" /* yacc.c:1646  */
    break;

  case 1676:
#line 12659 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[-1].list);
				}
#line 46285 "gram.c" /* yacc.c:1646  */
    break;

  case 1677:
#line 12671 "gram.y" /* yacc.c:1646  */
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);

					n->portalname = (yyvsp[-5].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[-4].ival) | (yyvsp[-2].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 46299 "gram.c" /* yacc.c:1646  */
    break;

  case 1678:
#line 12682 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 46305 "gram.c" /* yacc.c:1646  */
    break;

  case 1679:
#line 12685 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46311 "gram.c" /* yacc.c:1646  */
    break;

  case 1680:
#line 12686 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-2].ival) | CURSOR_OPT_NO_SCROLL; }
#line 46317 "gram.c" /* yacc.c:1646  */
    break;

  case 1681:
#line 12687 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_SCROLL; }
#line 46323 "gram.c" /* yacc.c:1646  */
    break;

  case 1682:
#line 12688 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_BINARY; }
#line 46329 "gram.c" /* yacc.c:1646  */
    break;

  case 1683:
#line 12689 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_ASENSITIVE; }
#line 46335 "gram.c" /* yacc.c:1646  */
    break;

  case 1684:
#line 12690 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[-1].ival) | CURSOR_OPT_INSENSITIVE; }
#line 46341 "gram.c" /* yacc.c:1646  */
    break;

  case 1685:
#line 12693 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46347 "gram.c" /* yacc.c:1646  */
    break;

  case 1686:
#line 12694 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CURSOR_OPT_HOLD; }
#line 46353 "gram.c" /* yacc.c:1646  */
    break;

  case 1687:
#line 12695 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 46359 "gram.c" /* yacc.c:1646  */
    break;

  case 1690:
#line 12748 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46365 "gram.c" /* yacc.c:1646  */
    break;

  case 1691:
#line 12749 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 46371 "gram.c" /* yacc.c:1646  */
    break;

  case 1692:
#line 12764 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46377 "gram.c" /* yacc.c:1646  */
    break;

  case 1693:
#line 12766 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46388 "gram.c" /* yacc.c:1646  */
    break;

  case 1694:
#line 12773 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46400 "gram.c" /* yacc.c:1646  */
    break;

  case 1695:
#line 12781 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46412 "gram.c" /* yacc.c:1646  */
    break;

  case 1696:
#line 12789 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[0].node), NULL, NIL,
										NULL,
										(yyvsp[-1].with),
										yyscanner);
					(yyval.node) = (yyvsp[0].node);
				}
#line 46424 "gram.c" /* yacc.c:1646  */
    break;

  case 1697:
#line 12797 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-1].node), (yyvsp[0].list), NIL,
										NULL,
										(yyvsp[-2].with),
										yyscanner);
					(yyval.node) = (yyvsp[-1].node);
				}
#line 46436 "gram.c" /* yacc.c:1646  */
    break;

  case 1698:
#line 12805 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[-1].list),
										(yyvsp[0].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46448 "gram.c" /* yacc.c:1646  */
    break;

  case 1699:
#line 12813 "gram.y" /* yacc.c:1646  */
    {
					insertSelectOptions((SelectStmt *) (yyvsp[-3].node), (yyvsp[-2].list), (yyvsp[0].list),
										(yyvsp[-1].selectlimit),
										(yyvsp[-4].with),
										yyscanner);
					(yyval.node) = (yyvsp[-3].node);
				}
#line 46460 "gram.c" /* yacc.c:1646  */
    break;

  case 1700:
#line 12823 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46466 "gram.c" /* yacc.c:1646  */
    break;

  case 1701:
#line 12824 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46472 "gram.c" /* yacc.c:1646  */
    break;

  case 1702:
#line 12859 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 46490 "gram.c" /* yacc.c:1646  */
    break;

  case 1703:
#line 12875 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-7].list);
					n->targetList = (yyvsp[-6].list);
					n->intoClause = (yyvsp[-5].into);
					n->fromClause = (yyvsp[-4].list);
					n->whereClause = (yyvsp[-3].node);
					n->groupClause = ((yyvsp[-2].groupclause))->list;
					n->groupDistinct = ((yyvsp[-2].groupclause))->distinct;
					n->havingClause = (yyvsp[-1].node);
					n->windowClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 46509 "gram.c" /* yacc.c:1646  */
    break;

  case 1704:
#line 12889 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 46515 "gram.c" /* yacc.c:1646  */
    break;

  case 1705:
#line 12891 "gram.y" /* yacc.c:1646  */
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef  *cr = makeNode(ColumnRef);
					ResTarget  *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *) cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[0].range));
					(yyval.node) = (Node *) n;
				}
#line 46538 "gram.c" /* yacc.c:1646  */
    break;

  case 1706:
#line 12910 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 46546 "gram.c" /* yacc.c:1646  */
    break;

  case 1707:
#line 12914 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 46554 "gram.c" /* yacc.c:1646  */
    break;

  case 1708:
#line 12918 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[-1].setquantifier) == SET_QUANTIFIER_ALL, (yyvsp[-3].node), (yyvsp[0].node));
				}
#line 46562 "gram.c" /* yacc.c:1646  */
    break;

  case 1709:
#line 12933 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 46573 "gram.c" /* yacc.c:1646  */
    break;

  case 1710:
#line 12940 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[-1]);
			}
#line 46584 "gram.c" /* yacc.c:1646  */
    break;

  case 1711:
#line 12947 "gram.y" /* yacc.c:1646  */
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[0].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[-2]);
			}
#line 46595 "gram.c" /* yacc.c:1646  */
    break;

  case 1712:
#line 12956 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 46601 "gram.c" /* yacc.c:1646  */
    break;

  case 1713:
#line 12957 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 46607 "gram.c" /* yacc.c:1646  */
    break;

  case 1714:
#line 12961 "gram.y" /* yacc.c:1646  */
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);

				n->ctename = (yyvsp[-8].str);
				n->aliascolnames = (yyvsp[-7].list);
				n->ctematerialized = (yyvsp[-5].ival);
				n->ctequery = (yyvsp[-3].node);
				n->search_clause = castNode(CTESearchClause, (yyvsp[-1].node));
				n->cycle_clause = castNode(CTECycleClause, (yyvsp[0].node));
				n->location = (yylsp[-8]);
				(yyval.node) = (Node *) n;
			}
#line 46624 "gram.c" /* yacc.c:1646  */
    break;

  case 1715:
#line 12976 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeAlways; }
#line 46630 "gram.c" /* yacc.c:1646  */
    break;

  case 1716:
#line 12977 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeNever; }
#line 46636 "gram.c" /* yacc.c:1646  */
    break;

  case 1717:
#line 12978 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = CTEMaterializeDefault; }
#line 46642 "gram.c" /* yacc.c:1646  */
    break;

  case 1718:
#line 12983 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = false;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46656 "gram.c" /* yacc.c:1646  */
    break;

  case 1719:
#line 12993 "gram.y" /* yacc.c:1646  */
    {
				CTESearchClause *n = makeNode(CTESearchClause);

				n->search_col_list = (yyvsp[-2].list);
				n->search_breadth_first = true;
				n->search_seq_column = (yyvsp[0].str);
				n->location = (yylsp[-6]);
				(yyval.node) = (Node *) n;
			}
#line 46670 "gram.c" /* yacc.c:1646  */
    break;

  case 1720:
#line 13003 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 46678 "gram.c" /* yacc.c:1646  */
    break;

  case 1721:
#line 13010 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-8].list);
				n->cycle_mark_column = (yyvsp[-6].str);
				n->cycle_mark_value = (yyvsp[-4].node);
				n->cycle_mark_default = (yyvsp[-2].node);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-9]);
				(yyval.node) = (Node *) n;
			}
#line 46694 "gram.c" /* yacc.c:1646  */
    break;

  case 1722:
#line 13022 "gram.y" /* yacc.c:1646  */
    {
				CTECycleClause *n = makeNode(CTECycleClause);

				n->cycle_col_list = (yyvsp[-4].list);
				n->cycle_mark_column = (yyvsp[-2].str);
				n->cycle_mark_value = makeBoolAConst(true, -1);
				n->cycle_mark_default = makeBoolAConst(false, -1);
				n->cycle_path_column = (yyvsp[0].str);
				n->location = (yylsp[-5]);
				(yyval.node) = (Node *) n;
			}
#line 46710 "gram.c" /* yacc.c:1646  */
    break;

  case 1723:
#line 13034 "gram.y" /* yacc.c:1646  */
    {
				(yyval.node) = NULL;
			}
#line 46718 "gram.c" /* yacc.c:1646  */
    break;

  case 1724:
#line 13040 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = (yyvsp[0].with); }
#line 46724 "gram.c" /* yacc.c:1646  */
    break;

  case 1725:
#line 13041 "gram.y" /* yacc.c:1646  */
    { (yyval.with) = NULL; }
#line 46730 "gram.c" /* yacc.c:1646  */
    break;

  case 1726:
#line 13046 "gram.y" /* yacc.c:1646  */
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[0].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
					(yyval.into)->viewQuery = NULL;
					(yyval.into)->skipData = false;
				}
#line 46745 "gram.c" /* yacc.c:1646  */
    break;

  case 1727:
#line 13057 "gram.y" /* yacc.c:1646  */
    { (yyval.into) = NULL; }
#line 46751 "gram.c" /* yacc.c:1646  */
    break;

  case 1728:
#line 13066 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46760 "gram.c" /* yacc.c:1646  */
    break;

  case 1729:
#line 13071 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46769 "gram.c" /* yacc.c:1646  */
    break;

  case 1730:
#line 13076 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46778 "gram.c" /* yacc.c:1646  */
    break;

  case 1731:
#line 13081 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46787 "gram.c" /* yacc.c:1646  */
    break;

  case 1732:
#line 13086 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46799 "gram.c" /* yacc.c:1646  */
    break;

  case 1733:
#line 13094 "gram.y" /* yacc.c:1646  */
    {
					ereport(WARNING,
							(errmsg("GLOBAL is deprecated in temporary table creation"),
							 parser_errposition((yylsp[-3]))));
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_TEMP;
				}
#line 46811 "gram.c" /* yacc.c:1646  */
    break;

  case 1734:
#line 13102 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_UNLOGGED;
				}
#line 46820 "gram.c" /* yacc.c:1646  */
    break;

  case 1735:
#line 13107 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46829 "gram.c" /* yacc.c:1646  */
    break;

  case 1736:
#line 13112 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->relpersistence = RELPERSISTENCE_PERMANENT;
				}
#line 46838 "gram.c" /* yacc.c:1646  */
    break;

  case 1739:
#line 13123 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_ALL; }
#line 46844 "gram.c" /* yacc.c:1646  */
    break;

  case 1740:
#line 13124 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DISTINCT; }
#line 46850 "gram.c" /* yacc.c:1646  */
    break;

  case 1741:
#line 13125 "gram.y" /* yacc.c:1646  */
    { (yyval.setquantifier) = SET_QUANTIFIER_DEFAULT; }
#line 46856 "gram.c" /* yacc.c:1646  */
    break;

  case 1742:
#line 13132 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(NIL); }
#line 46862 "gram.c" /* yacc.c:1646  */
    break;

  case 1743:
#line 13133 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 46868 "gram.c" /* yacc.c:1646  */
    break;

  case 1746:
#line 13142 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46874 "gram.c" /* yacc.c:1646  */
    break;

  case 1747:
#line 13143 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46880 "gram.c" /* yacc.c:1646  */
    break;

  case 1748:
#line 13147 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46886 "gram.c" /* yacc.c:1646  */
    break;

  case 1749:
#line 13148 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 46892 "gram.c" /* yacc.c:1646  */
    break;

  case 1750:
#line 13152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 46898 "gram.c" /* yacc.c:1646  */
    break;

  case 1751:
#line 13156 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].sortby)); }
#line 46904 "gram.c" /* yacc.c:1646  */
    break;

  case 1752:
#line 13157 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].sortby)); }
#line 46910 "gram.c" /* yacc.c:1646  */
    break;

  case 1753:
#line 13161 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-3].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = (yyvsp[-1].list);
					(yyval.sortby)->location = (yylsp[-1]);
				}
#line 46923 "gram.c" /* yacc.c:1646  */
    break;

  case 1754:
#line 13170 "gram.y" /* yacc.c:1646  */
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[-2].node);
					(yyval.sortby)->sortby_dir = (yyvsp[-1].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[0].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				}
#line 46936 "gram.c" /* yacc.c:1646  */
    break;

  case 1755:
#line 13183 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[-1].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[0].node);
				}
#line 46945 "gram.c" /* yacc.c:1646  */
    break;

  case 1756:
#line 13188 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
					((yyval.selectlimit))->limitOffset = (yyvsp[-1].node);
				}
#line 46954 "gram.c" /* yacc.c:1646  */
    break;

  case 1757:
#line 13193 "gram.y" /* yacc.c:1646  */
    {
					(yyval.selectlimit) = (yyvsp[0].selectlimit);
				}
#line 46962 "gram.c" /* yacc.c:1646  */
    break;

  case 1758:
#line 13197 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = (yyvsp[0].node);
					n->limitCount = NULL;
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 46975 "gram.c" /* yacc.c:1646  */
    break;

  case 1759:
#line 13208 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = (yyvsp[0].selectlimit); }
#line 46981 "gram.c" /* yacc.c:1646  */
    break;

  case 1760:
#line 13209 "gram.y" /* yacc.c:1646  */
    { (yyval.selectlimit) = NULL; }
#line 46987 "gram.c" /* yacc.c:1646  */
    break;

  case 1761:
#line 13214 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[0].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 47000 "gram.c" /* yacc.c:1646  */
    break;

  case 1762:
#line 13223 "gram.y" /* yacc.c:1646  */
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[-3]))));
				}
#line 47013 "gram.c" /* yacc.c:1646  */
    break;

  case 1763:
#line 13239 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-2].node);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 47026 "gram.c" /* yacc.c:1646  */
    break;

  case 1764:
#line 13248 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = (yyvsp[-3].node);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 47039 "gram.c" /* yacc.c:1646  */
    break;

  case 1765:
#line 13257 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_COUNT;
					(yyval.selectlimit) = n;
				}
#line 47052 "gram.c" /* yacc.c:1646  */
    break;

  case 1766:
#line 13266 "gram.y" /* yacc.c:1646  */
    {
					SelectLimit *n = (SelectLimit *) palloc(sizeof(SelectLimit));

					n->limitOffset = NULL;
					n->limitCount = makeIntConst(1, -1);
					n->limitOption = LIMIT_OPTION_WITH_TIES;
					(yyval.selectlimit) = n;
				}
#line 47065 "gram.c" /* yacc.c:1646  */
    break;

  case 1767:
#line 13278 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47071 "gram.c" /* yacc.c:1646  */
    break;

  case 1768:
#line 13281 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 47077 "gram.c" /* yacc.c:1646  */
    break;

  case 1769:
#line 13285 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47083 "gram.c" /* yacc.c:1646  */
    break;

  case 1770:
#line 13287 "gram.y" /* yacc.c:1646  */
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 47092 "gram.c" /* yacc.c:1646  */
    break;

  case 1771:
#line 13294 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47098 "gram.c" /* yacc.c:1646  */
    break;

  case 1772:
#line 13314 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47104 "gram.c" /* yacc.c:1646  */
    break;

  case 1773:
#line 13316 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 47110 "gram.c" /* yacc.c:1646  */
    break;

  case 1774:
#line 13318 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 47116 "gram.c" /* yacc.c:1646  */
    break;

  case 1775:
#line 13322 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst((yyvsp[0].ival),(yylsp[0])); }
#line 47122 "gram.c" /* yacc.c:1646  */
    break;

  case 1776:
#line 13323 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeFloatConst((yyvsp[0].str),(yylsp[0])); }
#line 47128 "gram.c" /* yacc.c:1646  */
    break;

  case 1777:
#line 13327 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 47134 "gram.c" /* yacc.c:1646  */
    break;

  case 1778:
#line 13328 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 47140 "gram.c" /* yacc.c:1646  */
    break;

  case 1779:
#line 13331 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 47146 "gram.c" /* yacc.c:1646  */
    break;

  case 1780:
#line 13332 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 47152 "gram.c" /* yacc.c:1646  */
    break;

  case 1781:
#line 13358 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = (yyvsp[-1].setquantifier) == SET_QUANTIFIER_DISTINCT;
					n->list = (yyvsp[0].list);
					(yyval.groupclause) = n;
				}
#line 47164 "gram.c" /* yacc.c:1646  */
    break;

  case 1782:
#line 13366 "gram.y" /* yacc.c:1646  */
    {
					GroupClause *n = (GroupClause *) palloc(sizeof(GroupClause));

					n->distinct = false;
					n->list = NIL;
					(yyval.groupclause) = n;
				}
#line 47176 "gram.c" /* yacc.c:1646  */
    break;

  case 1783:
#line 13376 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47182 "gram.c" /* yacc.c:1646  */
    break;

  case 1784:
#line 13377 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list),(yyvsp[0].node)); }
#line 47188 "gram.c" /* yacc.c:1646  */
    break;

  case 1785:
#line 13381 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47194 "gram.c" /* yacc.c:1646  */
    break;

  case 1786:
#line 13382 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47200 "gram.c" /* yacc.c:1646  */
    break;

  case 1787:
#line 13383 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47206 "gram.c" /* yacc.c:1646  */
    break;

  case 1788:
#line 13384 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47212 "gram.c" /* yacc.c:1646  */
    break;

  case 1789:
#line 13385 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47218 "gram.c" /* yacc.c:1646  */
    break;

  case 1790:
#line 13390 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_EMPTY, NIL, (yylsp[-1]));
				}
#line 47226 "gram.c" /* yacc.c:1646  */
    break;

  case 1791:
#line 13403 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_ROLLUP, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47234 "gram.c" /* yacc.c:1646  */
    break;

  case 1792:
#line 13410 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_CUBE, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 47242 "gram.c" /* yacc.c:1646  */
    break;

  case 1793:
#line 13417 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeGroupingSet(GROUPING_SET_SETS, (yyvsp[-1].list), (yylsp[-4]));
				}
#line 47250 "gram.c" /* yacc.c:1646  */
    break;

  case 1794:
#line 13423 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47256 "gram.c" /* yacc.c:1646  */
    break;

  case 1795:
#line 13424 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47262 "gram.c" /* yacc.c:1646  */
    break;

  case 1796:
#line 13428 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47268 "gram.c" /* yacc.c:1646  */
    break;

  case 1797:
#line 13429 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47274 "gram.c" /* yacc.c:1646  */
    break;

  case 1798:
#line 13433 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47280 "gram.c" /* yacc.c:1646  */
    break;

  case 1799:
#line 13434 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47286 "gram.c" /* yacc.c:1646  */
    break;

  case 1800:
#line 13438 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47292 "gram.c" /* yacc.c:1646  */
    break;

  case 1801:
#line 13439 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 47298 "gram.c" /* yacc.c:1646  */
    break;

  case 1802:
#line 13444 "gram.y" /* yacc.c:1646  */
    {
					LockingClause *n = makeNode(LockingClause);

					n->lockedRels = (yyvsp[-1].list);
					n->strength = (yyvsp[-2].ival);
					n->waitPolicy = (yyvsp[0].ival);
					(yyval.node) = (Node *) n;
				}
#line 47311 "gram.c" /* yacc.c:1646  */
    break;

  case 1803:
#line 13455 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORUPDATE; }
#line 47317 "gram.c" /* yacc.c:1646  */
    break;

  case 1804:
#line 13456 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORNOKEYUPDATE; }
#line 47323 "gram.c" /* yacc.c:1646  */
    break;

  case 1805:
#line 13457 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORSHARE; }
#line 47329 "gram.c" /* yacc.c:1646  */
    break;

  case 1806:
#line 13458 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = LCS_FORKEYSHARE; }
#line 47335 "gram.c" /* yacc.c:1646  */
    break;

  case 1807:
#line 13462 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47341 "gram.c" /* yacc.c:1646  */
    break;

  case 1808:
#line 13463 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47347 "gram.c" /* yacc.c:1646  */
    break;

  case 1809:
#line 13474 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->valuesLists = list_make1((yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 47358 "gram.c" /* yacc.c:1646  */
    break;

  case 1810:
#line 13481 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[-4].node);

					n->valuesLists = lappend(n->valuesLists, (yyvsp[-1].list));
					(yyval.node) = (Node *) n;
				}
#line 47369 "gram.c" /* yacc.c:1646  */
    break;

  case 1811:
#line 13499 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 47375 "gram.c" /* yacc.c:1646  */
    break;

  case 1812:
#line 13500 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47381 "gram.c" /* yacc.c:1646  */
    break;

  case 1813:
#line 13504 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 47387 "gram.c" /* yacc.c:1646  */
    break;

  case 1814:
#line 13505 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 47393 "gram.c" /* yacc.c:1646  */
    break;

  case 1815:
#line 13512 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-1].range)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-1].range);
				}
#line 47402 "gram.c" /* yacc.c:1646  */
    break;

  case 1816:
#line 13517 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = (RangeTableSample *) (yyvsp[0].node);

					(yyvsp[-2].range)->alias = (yyvsp[-1].alias);
					/* relation_expr goes inside the RangeTableSample node */
					n->relation = (Node *) (yyvsp[-2].range);
					(yyval.node) = (Node *) n;
				}
#line 47415 "gram.c" /* yacc.c:1646  */
    break;

  case 1817:
#line 13526 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 47427 "gram.c" /* yacc.c:1646  */
    break;

  case 1818:
#line 13534 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = (RangeFunction *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = linitial((yyvsp[0].list));
					n->coldeflist = lsecond((yyvsp[0].list));
					(yyval.node) = (Node *) n;
				}
#line 47440 "gram.c" /* yacc.c:1646  */
    break;

  case 1819:
#line 13543 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47451 "gram.c" /* yacc.c:1646  */
    break;

  case 1820:
#line 13550 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = (RangeTableFunc *) (yyvsp[-1].node);

					n->lateral = true;
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47463 "gram.c" /* yacc.c:1646  */
    break;

  case 1821:
#line 13558 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = false;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47476 "gram.c" /* yacc.c:1646  */
    break;

  case 1822:
#line 13567 "gram.y" /* yacc.c:1646  */
    {
					RangeSubselect *n = makeNode(RangeSubselect);

					n->lateral = true;
					n->subquery = (yyvsp[-1].node);
					n->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) n;
				}
#line 47489 "gram.c" /* yacc.c:1646  */
    break;

  case 1823:
#line 13576 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) (yyvsp[0].jexpr);
				}
#line 47497 "gram.c" /* yacc.c:1646  */
    break;

  case 1824:
#line 13580 "gram.y" /* yacc.c:1646  */
    {
					(yyvsp[-2].jexpr)->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) (yyvsp[-2].jexpr);
				}
#line 47506 "gram.c" /* yacc.c:1646  */
    break;

  case 1825:
#line 13585 "gram.y" /* yacc.c:1646  */
    {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					(yyval.node) = (Node *) jt;
				}
#line 47517 "gram.c" /* yacc.c:1646  */
    break;

  case 1826:
#line 13592 "gram.y" /* yacc.c:1646  */
    {
					JsonTable  *jt = castNode(JsonTable, (yyvsp[-1].node));

					jt->alias = (yyvsp[0].alias);
					jt->lateral = true;
					(yyval.node) = (Node *) jt;
				}
#line 47529 "gram.c" /* yacc.c:1646  */
    break;

  case 1827:
#line 13621 "gram.y" /* yacc.c:1646  */
    {
					(yyval.jexpr) = (yyvsp[-1].jexpr);
				}
#line 47537 "gram.c" /* yacc.c:1646  */
    break;

  case 1828:
#line 13625 "gram.y" /* yacc.c:1646  */
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL;
					n->join_using_alias = NULL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				}
#line 47555 "gram.c" /* yacc.c:1646  */
    break;

  case 1829:
#line 13639 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-3].jtype);
					n->isNatural = false;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						 /* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 47580 "gram.c" /* yacc.c:1646  */
    break;

  case 1830:
#line 13660 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = false;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[-1].node);
					if ((yyvsp[0].node) != NULL && IsA((yyvsp[0].node), List))
					{
						/* USING clause */
						n->usingClause = linitial_node(List, castNode(List, (yyvsp[0].node)));
						n->join_using_alias = lsecond_node(Alias, castNode(List, (yyvsp[0].node)));
					}
					else
					{
						/* ON clause */
						n->quals = (yyvsp[0].node);
					}
					(yyval.jexpr) = n;
				}
#line 47606 "gram.c" /* yacc.c:1646  */
    break;

  case 1831:
#line 13682 "gram.y" /* yacc.c:1646  */
    {
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = (yyvsp[-2].jtype);
					n->isNatural = true;
					n->larg = (yyvsp[-4].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47623 "gram.c" /* yacc.c:1646  */
    break;

  case 1832:
#line 13695 "gram.y" /* yacc.c:1646  */
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr   *n = makeNode(JoinExpr);

					n->jointype = JOIN_INNER;
					n->isNatural = true;
					n->larg = (yyvsp[-3].node);
					n->rarg = (yyvsp[0].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->join_using_alias = NULL;
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				}
#line 47641 "gram.c" /* yacc.c:1646  */
    break;

  case 1833:
#line 13712 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47651 "gram.c" /* yacc.c:1646  */
    break;

  case 1834:
#line 13718 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47660 "gram.c" /* yacc.c:1646  */
    break;

  case 1835:
#line 13723 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[-3].str);
					(yyval.alias)->colnames = (yyvsp[-1].list);
				}
#line 47670 "gram.c" /* yacc.c:1646  */
    break;

  case 1836:
#line 13729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
				}
#line 47679 "gram.c" /* yacc.c:1646  */
    break;

  case 1837:
#line 13735 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = (yyvsp[0].alias); }
#line 47685 "gram.c" /* yacc.c:1646  */
    break;

  case 1838:
#line 13736 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 47691 "gram.c" /* yacc.c:1646  */
    break;

  case 1839:
#line 13747 "gram.y" /* yacc.c:1646  */
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[0].str);
					/* the column name list will be inserted later */
				}
#line 47701 "gram.c" /* yacc.c:1646  */
    break;

  case 1840:
#line 13752 "gram.y" /* yacc.c:1646  */
    { (yyval.alias) = NULL; }
#line 47707 "gram.c" /* yacc.c:1646  */
    break;

  case 1841:
#line 13761 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2((yyvsp[0].alias), NIL);
				}
#line 47715 "gram.c" /* yacc.c:1646  */
    break;

  case 1842:
#line 13765 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, (yyvsp[-1].list));
				}
#line 47723 "gram.c" /* yacc.c:1646  */
    break;

  case 1843:
#line 13769 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47734 "gram.c" /* yacc.c:1646  */
    break;

  case 1844:
#line 13776 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *a = makeNode(Alias);

					a->aliasname = (yyvsp[-3].str);
					(yyval.list) = list_make2(a, (yyvsp[-1].list));
				}
#line 47745 "gram.c" /* yacc.c:1646  */
    break;

  case 1845:
#line 13783 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(NULL, NIL);
				}
#line 47753 "gram.c" /* yacc.c:1646  */
    break;

  case 1846:
#line 13788 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_FULL; }
#line 47759 "gram.c" /* yacc.c:1646  */
    break;

  case 1847:
#line 13789 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_LEFT; }
#line 47765 "gram.c" /* yacc.c:1646  */
    break;

  case 1848:
#line 13790 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_RIGHT; }
#line 47771 "gram.c" /* yacc.c:1646  */
    break;

  case 1849:
#line 13791 "gram.y" /* yacc.c:1646  */
    { (yyval.jtype) = JOIN_INNER; }
#line 47777 "gram.c" /* yacc.c:1646  */
    break;

  case 1852:
#line 13812 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) list_make2((yyvsp[-2].list), (yyvsp[0].alias));
				}
#line 47785 "gram.c" /* yacc.c:1646  */
    break;

  case 1853:
#line 13816 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 47793 "gram.c" /* yacc.c:1646  */
    break;

  case 1854:
#line 13824 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, implicitly */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47804 "gram.c" /* yacc.c:1646  */
    break;

  case 1855:
#line 13831 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47812 "gram.c" /* yacc.c:1646  */
    break;

  case 1856:
#line 13838 "gram.y" /* yacc.c:1646  */
    {
					/* inheritance query, explicitly */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = true;
					(yyval.range)->alias = NULL;
				}
#line 47823 "gram.c" /* yacc.c:1646  */
    break;

  case 1857:
#line 13845 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[0].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47834 "gram.c" /* yacc.c:1646  */
    break;

  case 1858:
#line 13852 "gram.y" /* yacc.c:1646  */
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[-1].range);
					(yyval.range)->inh = false;
					(yyval.range)->alias = NULL;
				}
#line 47845 "gram.c" /* yacc.c:1646  */
    break;

  case 1859:
#line 13862 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 47851 "gram.c" /* yacc.c:1646  */
    break;

  case 1860:
#line 13863 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 47857 "gram.c" /* yacc.c:1646  */
    break;

  case 1861:
#line 13877 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = (yyvsp[0].range);
				}
#line 47865 "gram.c" /* yacc.c:1646  */
    break;

  case 1862:
#line 13881 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-1].range)->alias = alias;
					(yyval.range) = (yyvsp[-1].range);
				}
#line 47877 "gram.c" /* yacc.c:1646  */
    break;

  case 1863:
#line 13889 "gram.y" /* yacc.c:1646  */
    {
					Alias	   *alias = makeNode(Alias);

					alias->aliasname = (yyvsp[0].str);
					(yyvsp[-2].range)->alias = alias;
					(yyval.range) = (yyvsp[-2].range);
				}
#line 47889 "gram.c" /* yacc.c:1646  */
    break;

  case 1864:
#line 13903 "gram.y" /* yacc.c:1646  */
    {
					RangeTableSample *n = makeNode(RangeTableSample);

					/* n->relation will be filled in later */
					n->method = (yyvsp[-4].list);
					n->args = (yyvsp[-2].list);
					n->repeatable = (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 47904 "gram.c" /* yacc.c:1646  */
    break;

  case 1865:
#line 13916 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].node); }
#line 47910 "gram.c" /* yacc.c:1646  */
    break;

  case 1866:
#line 13917 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 47916 "gram.c" /* yacc.c:1646  */
    break;

  case 1867:
#line 13933 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = false;
					n->functions = list_make1(list_make2((yyvsp[-1].node), NIL));
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47931 "gram.c" /* yacc.c:1646  */
    break;

  case 1868:
#line 13944 "gram.y" /* yacc.c:1646  */
    {
					RangeFunction *n = makeNode(RangeFunction);

					n->lateral = false;
					n->ordinality = (yyvsp[0].boolean);
					n->is_rowsfrom = true;
					n->functions = (yyvsp[-2].list);
					/* alias and coldeflist are set by table_ref production */
					(yyval.node) = (Node *) n;
				}
#line 47946 "gram.c" /* yacc.c:1646  */
    break;

  case 1869:
#line 13957 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-1].node), (yyvsp[0].list)); }
#line 47952 "gram.c" /* yacc.c:1646  */
    break;

  case 1870:
#line 13961 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].list)); }
#line 47958 "gram.c" /* yacc.c:1646  */
    break;

  case 1871:
#line 13962 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].list)); }
#line 47964 "gram.c" /* yacc.c:1646  */
    break;

  case 1872:
#line 13965 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 47970 "gram.c" /* yacc.c:1646  */
    break;

  case 1873:
#line 13966 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 47976 "gram.c" /* yacc.c:1646  */
    break;

  case 1874:
#line 13969 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 47982 "gram.c" /* yacc.c:1646  */
    break;

  case 1875:
#line 13970 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 47988 "gram.c" /* yacc.c:1646  */
    break;

  case 1876:
#line 13975 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 47994 "gram.c" /* yacc.c:1646  */
    break;

  case 1877:
#line 13976 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48000 "gram.c" /* yacc.c:1646  */
    break;

  case 1878:
#line 13981 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 48006 "gram.c" /* yacc.c:1646  */
    break;

  case 1879:
#line 13983 "gram.y" /* yacc.c:1646  */
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);

					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[0].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				}
#line 48019 "gram.c" /* yacc.c:1646  */
    break;

  case 1880:
#line 13991 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48025 "gram.c" /* yacc.c:1646  */
    break;

  case 1881:
#line 13996 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 48031 "gram.c" /* yacc.c:1646  */
    break;

  case 1882:
#line 13997 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48037 "gram.c" /* yacc.c:1646  */
    break;

  case 1883:
#line 14002 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 48045 "gram.c" /* yacc.c:1646  */
    break;

  case 1884:
#line 14006 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 48053 "gram.c" /* yacc.c:1646  */
    break;

  case 1885:
#line 14012 "gram.y" /* yacc.c:1646  */
    {
					ColumnDef *n = makeNode(ColumnDef);

					n->colname = (yyvsp[-2].str);
					n->typeName = (yyvsp[-1].typnam);
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->is_from_type = false;
					n->storage = 0;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->collClause = (CollateClause *) (yyvsp[0].node);
					n->collOid = InvalidOid;
					n->constraints = NIL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48076 "gram.c" /* yacc.c:1646  */
    break;

  case 1886:
#line 14037 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = NIL;
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48091 "gram.c" /* yacc.c:1646  */
    break;

  case 1887:
#line 14049 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFunc *n = makeNode(RangeTableFunc);

					n->rowexpr = (yyvsp[-4].node);
					n->docexpr = (yyvsp[-3].node);
					n->columns = (yyvsp[-1].list);
					n->namespaces = (yyvsp[-7].list);
					n->location = (yylsp[-11]);
					(yyval.node) = (Node *) n;
				}
#line 48106 "gram.c" /* yacc.c:1646  */
    break;

  case 1888:
#line 14061 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48112 "gram.c" /* yacc.c:1646  */
    break;

  case 1889:
#line 14062 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 48118 "gram.c" /* yacc.c:1646  */
    break;

  case 1890:
#line 14067 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-1].str);
					fc->for_ordinality = false;
					fc->typeName = (yyvsp[0].typnam);
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-1]);

					(yyval.node) = (Node *) fc;
				}
#line 48136 "gram.c" /* yacc.c:1646  */
    break;

  case 1891:
#line 14081 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);
					ListCell   *option;
					bool		nullability_seen = false;

					fc->colname = (yyvsp[-2].str);
					fc->typeName = (yyvsp[-1].typnam);
					fc->for_ordinality = false;
					fc->is_not_null = false;
					fc->colexpr = NULL;
					fc->coldefexpr = NULL;
					fc->location = (yylsp[-2]);

					foreach(option, (yyvsp[0].list))
					{
						DefElem   *defel = (DefElem *) lfirst(option);

						if (strcmp(defel->defname, "default") == 0)
						{
							if (fc->coldefexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one DEFAULT value is allowed"),
										 parser_errposition(defel->location)));
							fc->coldefexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "path") == 0)
						{
							if (fc->colexpr != NULL)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("only one PATH value per column is allowed"),
										 parser_errposition(defel->location)));
							fc->colexpr = defel->arg;
						}
						else if (strcmp(defel->defname, "is_not_null") == 0)
						{
							if (nullability_seen)
								ereport(ERROR,
										(errcode(ERRCODE_SYNTAX_ERROR),
										 errmsg("conflicting or redundant NULL / NOT NULL declarations for column \"%s\"", fc->colname),
										 parser_errposition(defel->location)));
							fc->is_not_null = boolVal(defel->arg);
							nullability_seen = true;
						}
						else
						{
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("unrecognized column option \"%s\"",
											defel->defname),
									 parser_errposition(defel->location)));
						}
					}
					(yyval.node) = (Node *) fc;
				}
#line 48197 "gram.c" /* yacc.c:1646  */
    break;

  case 1892:
#line 14138 "gram.y" /* yacc.c:1646  */
    {
					RangeTableFuncCol *fc = makeNode(RangeTableFuncCol);

					fc->colname = (yyvsp[-2].str);
					fc->for_ordinality = true;
					/* other fields are ignored, initialized by makeNode */
					fc->location = (yylsp[-2]);

					(yyval.node) = (Node *) fc;
				}
#line 48212 "gram.c" /* yacc.c:1646  */
    break;

  case 1893:
#line 14152 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].defelt)); }
#line 48218 "gram.c" /* yacc.c:1646  */
    break;

  case 1894:
#line 14154 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].defelt)); }
#line 48224 "gram.c" /* yacc.c:1646  */
    break;

  case 1895:
#line 14159 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem((yyvsp[-1].str), (yyvsp[0].node), (yylsp[-1])); }
#line 48230 "gram.c" /* yacc.c:1646  */
    break;

  case 1896:
#line 14161 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("default", (yyvsp[0].node), (yylsp[-1])); }
#line 48236 "gram.c" /* yacc.c:1646  */
    break;

  case 1897:
#line 14163 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(true), (yylsp[-1])); }
#line 48242 "gram.c" /* yacc.c:1646  */
    break;

  case 1898:
#line 14165 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("is_not_null", (Node *) makeBoolean(false), (yylsp[0])); }
#line 48248 "gram.c" /* yacc.c:1646  */
    break;

  case 1899:
#line 14167 "gram.y" /* yacc.c:1646  */
    { (yyval.defelt) = makeDefElem("path", (yyvsp[0].node), (yylsp[-1])); }
#line 48254 "gram.c" /* yacc.c:1646  */
    break;

  case 1900:
#line 14172 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 48260 "gram.c" /* yacc.c:1646  */
    break;

  case 1901:
#line 14174 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 48266 "gram.c" /* yacc.c:1646  */
    break;

  case 1902:
#line 14179 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 48278 "gram.c" /* yacc.c:1646  */
    break;

  case 1903:
#line 14187 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (yyvsp[0].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 48290 "gram.c" /* yacc.c:1646  */
    break;

  case 1904:
#line 14203 "gram.y" /* yacc.c:1646  */
    {
					JsonTable *n = makeNode(JsonTable);
					char	  *pathstring;

					n->context_item = (JsonValueExpr *) (yyvsp[-10].node);
					if (!IsA((yyvsp[-8].node), A_Const) ||
						castNode(A_Const, (yyvsp[-8].node))->val.node.type != T_String)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("only string constants are supported in JSON_TABLE path specification"),
								 parser_errposition((yylsp[-8]))));
					pathstring = castNode(A_Const, (yyvsp[-8].node))->val.sval.sval;
					n->pathspec = makeJsonTablePathSpec(pathstring, (yyvsp[-7].str), (yylsp[-8]), (yylsp[-7]));
					n->passing = (yyvsp[-6].list);
					n->columns = (yyvsp[-3].list);
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-12]);
					(yyval.node) = (Node *) n;
				}
#line 48314 "gram.c" /* yacc.c:1646  */
    break;

  case 1905:
#line 14225 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 48320 "gram.c" /* yacc.c:1646  */
    break;

  case 1906:
#line 14226 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 48326 "gram.c" /* yacc.c:1646  */
    break;

  case 1907:
#line 14231 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 48332 "gram.c" /* yacc.c:1646  */
    break;

  case 1908:
#line 14233 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 48338 "gram.c" /* yacc.c:1646  */
    break;

  case 1909:
#line 14238 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FOR_ORDINALITY;
					n->name = (yyvsp[-2].str);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 48351 "gram.c" /* yacc.c:1646  */
    break;

  case 1910:
#line 14251 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_REGULAR;
					n->name = (yyvsp[-5].str);
					n->typeName = (yyvsp[-4].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 48371 "gram.c" /* yacc.c:1646  */
    break;

  case 1911:
#line 14271 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_FORMATTED;
					n->name = (yyvsp[-6].str);
					n->typeName = (yyvsp[-5].typnam);
					n->format = (JsonFormat *) (yyvsp[-4].node);
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-3].node);
					n->wrapper = (yyvsp[-2].ival);
					n->quotes = (yyvsp[-1].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[0].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[0].list));
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48391 "gram.c" /* yacc.c:1646  */
    break;

  case 1912:
#line 14289 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_EXISTS;
					n->name = (yyvsp[-4].str);
					n->typeName = (yyvsp[-3].typnam);
					n->format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
					n->wrapper = JSW_NONE;
					n->quotes = JS_QUOTES_UNSPEC;
					n->pathspec = (JsonTablePathSpec *) (yyvsp[-1].node);
					n->on_empty = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[0].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 48411 "gram.c" /* yacc.c:1646  */
    break;

  case 1913:
#line 14306 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-4].str), NULL, (yylsp[-4]), -1);
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 48426 "gram.c" /* yacc.c:1646  */
    break;

  case 1914:
#line 14318 "gram.y" /* yacc.c:1646  */
    {
					JsonTableColumn *n = makeNode(JsonTableColumn);

					n->coltype = JTC_NESTED;
					n->pathspec = (JsonTablePathSpec *)
						makeJsonTablePathSpec((yyvsp[-6].str), (yyvsp[-4].str), (yylsp[-6]), (yylsp[-4]));
					n->columns = (yyvsp[-1].list);
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 48441 "gram.c" /* yacc.c:1646  */
    break;

  case 1917:
#line 14337 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonTablePathSpec((yyvsp[0].str), NULL, (yylsp[0]), -1); }
#line 48447 "gram.c" /* yacc.c:1646  */
    break;

  case 1918:
#line 14339 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 48453 "gram.c" /* yacc.c:1646  */
    break;

  case 1919:
#line 14353 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
				}
#line 48462 "gram.c" /* yacc.c:1646  */
    break;

  case 1920:
#line 14358 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[0].list);
					(yyval.typnam)->setof = true;
				}
#line 48472 "gram.c" /* yacc.c:1646  */
    break;

  case 1921:
#line 14365 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
				}
#line 48481 "gram.c" /* yacc.c:1646  */
    break;

  case 1922:
#line 14370 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-4].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[-1].ival)));
					(yyval.typnam)->setof = true;
				}
#line 48491 "gram.c" /* yacc.c:1646  */
    break;

  case 1923:
#line 14376 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				}
#line 48500 "gram.c" /* yacc.c:1646  */
    break;

  case 1924:
#line 14381 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = true;
				}
#line 48510 "gram.c" /* yacc.c:1646  */
    break;

  case 1925:
#line 14390 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-2].list), makeInteger(-1)); }
#line 48516 "gram.c" /* yacc.c:1646  */
    break;

  case 1926:
#line 14392 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = lappend((yyvsp[-3].list), makeInteger((yyvsp[-1].ival))); }
#line 48522 "gram.c" /* yacc.c:1646  */
    break;

  case 1927:
#line 14394 "gram.y" /* yacc.c:1646  */
    {  (yyval.list) = NIL; }
#line 48528 "gram.c" /* yacc.c:1646  */
    break;

  case 1928:
#line 14398 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48534 "gram.c" /* yacc.c:1646  */
    break;

  case 1929:
#line 14399 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48540 "gram.c" /* yacc.c:1646  */
    break;

  case 1930:
#line 14400 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48546 "gram.c" /* yacc.c:1646  */
    break;

  case 1931:
#line 14401 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48552 "gram.c" /* yacc.c:1646  */
    break;

  case 1932:
#line 14402 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48558 "gram.c" /* yacc.c:1646  */
    break;

  case 1933:
#line 14404 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-1].typnam);
					(yyval.typnam)->typmods = (yyvsp[0].list);
				}
#line 48567 "gram.c" /* yacc.c:1646  */
    break;

  case 1934:
#line 14409 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[-3].typnam);
					(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											 makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 48577 "gram.c" /* yacc.c:1646  */
    break;

  case 1935:
#line 14414 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48583 "gram.c" /* yacc.c:1646  */
    break;

  case 1936:
#line 14429 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48589 "gram.c" /* yacc.c:1646  */
    break;

  case 1937:
#line 14430 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48595 "gram.c" /* yacc.c:1646  */
    break;

  case 1938:
#line 14431 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48601 "gram.c" /* yacc.c:1646  */
    break;

  case 1939:
#line 14432 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48607 "gram.c" /* yacc.c:1646  */
    break;

  case 1940:
#line 14433 "gram.y" /* yacc.c:1646  */
    { (yyval.typnam) = (yyvsp[0].typnam); }
#line 48613 "gram.c" /* yacc.c:1646  */
    break;

  case 1941:
#line 14445 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeName((yyvsp[-1].str));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48623 "gram.c" /* yacc.c:1646  */
    break;

  case 1942:
#line 14451 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[-2].str)), (yyvsp[-1].list)));
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-2]);
				}
#line 48633 "gram.c" /* yacc.c:1646  */
    break;

  case 1943:
#line 14458 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 48639 "gram.c" /* yacc.c:1646  */
    break;

  case 1944:
#line 14459 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 48645 "gram.c" /* yacc.c:1646  */
    break;

  case 1945:
#line 14466 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48654 "gram.c" /* yacc.c:1646  */
    break;

  case 1946:
#line 14471 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48663 "gram.c" /* yacc.c:1646  */
    break;

  case 1947:
#line 14476 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48672 "gram.c" /* yacc.c:1646  */
    break;

  case 1948:
#line 14481 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48681 "gram.c" /* yacc.c:1646  */
    break;

  case 1949:
#line 14486 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48690 "gram.c" /* yacc.c:1646  */
    break;

  case 1950:
#line 14491 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48699 "gram.c" /* yacc.c:1646  */
    break;

  case 1951:
#line 14496 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48708 "gram.c" /* yacc.c:1646  */
    break;

  case 1952:
#line 14501 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48718 "gram.c" /* yacc.c:1646  */
    break;

  case 1953:
#line 14507 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48728 "gram.c" /* yacc.c:1646  */
    break;

  case 1954:
#line 14513 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[0].list);
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48738 "gram.c" /* yacc.c:1646  */
    break;

  case 1955:
#line 14519 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48747 "gram.c" /* yacc.c:1646  */
    break;

  case 1956:
#line 14526 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[-1].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[-1]))));
					else if ((yyvsp[-1].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[-1].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[-1]))));
				}
#line 48772 "gram.c" /* yacc.c:1646  */
    break;

  case 1957:
#line 14547 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("float8");
				}
#line 48780 "gram.c" /* yacc.c:1646  */
    break;

  case 1958:
#line 14557 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48788 "gram.c" /* yacc.c:1646  */
    break;

  case 1959:
#line 14561 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48796 "gram.c" /* yacc.c:1646  */
    break;

  case 1960:
#line 14569 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48804 "gram.c" /* yacc.c:1646  */
    break;

  case 1961:
#line 14573 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48813 "gram.c" /* yacc.c:1646  */
    break;

  case 1962:
#line 14581 "gram.y" /* yacc.c:1646  */
    {
					char *typname;

					typname = (yyvsp[-3].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[-1].list);
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48826 "gram.c" /* yacc.c:1646  */
    break;

  case 1963:
#line 14593 "gram.y" /* yacc.c:1646  */
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[0].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48844 "gram.c" /* yacc.c:1646  */
    break;

  case 1964:
#line 14614 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48852 "gram.c" /* yacc.c:1646  */
    break;

  case 1965:
#line 14618 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48860 "gram.c" /* yacc.c:1646  */
    break;

  case 1966:
#line 14624 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = (yyvsp[0].typnam);
				}
#line 48868 "gram.c" /* yacc.c:1646  */
    break;

  case 1967:
#line 14628 "gram.y" /* yacc.c:1646  */
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[0].typnam);
					(yyval.typnam)->typmods = NIL;
				}
#line 48883 "gram.c" /* yacc.c:1646  */
    break;

  case 1968:
#line 14641 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[-3].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
					(yyval.typnam)->location = (yylsp[-3]);
				}
#line 48893 "gram.c" /* yacc.c:1646  */
    break;

  case 1969:
#line 14649 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName((yyvsp[0].str));
					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[0].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 48905 "gram.c" /* yacc.c:1646  */
    break;

  case 1970:
#line 14659 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48911 "gram.c" /* yacc.c:1646  */
    break;

  case 1971:
#line 14661 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48917 "gram.c" /* yacc.c:1646  */
    break;

  case 1972:
#line 14663 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "varchar"; }
#line 48923 "gram.c" /* yacc.c:1646  */
    break;

  case 1973:
#line 14665 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48929 "gram.c" /* yacc.c:1646  */
    break;

  case 1974:
#line 14667 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48935 "gram.c" /* yacc.c:1646  */
    break;

  case 1975:
#line 14669 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].boolean) ? "varchar": "bpchar"; }
#line 48941 "gram.c" /* yacc.c:1646  */
    break;

  case 1976:
#line 14673 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 48947 "gram.c" /* yacc.c:1646  */
    break;

  case 1977:
#line 14674 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 48953 "gram.c" /* yacc.c:1646  */
    break;

  case 1978:
#line 14682 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48966 "gram.c" /* yacc.c:1646  */
    break;

  case 1979:
#line 14691 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 48978 "gram.c" /* yacc.c:1646  */
    break;

  case 1980:
#line 14699 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.typnam)->location = (yylsp[-4]);
				}
#line 48991 "gram.c" /* yacc.c:1646  */
    break;

  case 1981:
#line 14708 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[-1]);
				}
#line 49003 "gram.c" /* yacc.c:1646  */
    break;

  case 1982:
#line 14719 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 49012 "gram.c" /* yacc.c:1646  */
    break;

  case 1983:
#line 14726 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 49018 "gram.c" /* yacc.c:1646  */
    break;

  case 1984:
#line 14727 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49024 "gram.c" /* yacc.c:1646  */
    break;

  case 1985:
#line 14728 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 49030 "gram.c" /* yacc.c:1646  */
    break;

  case 1986:
#line 14733 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[0]))); }
#line 49036 "gram.c" /* yacc.c:1646  */
    break;

  case 1987:
#line 14735 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[0]))); }
#line 49042 "gram.c" /* yacc.c:1646  */
    break;

  case 1988:
#line 14737 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[0]))); }
#line 49048 "gram.c" /* yacc.c:1646  */
    break;

  case 1989:
#line 14739 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[0]))); }
#line 49054 "gram.c" /* yacc.c:1646  */
    break;

  case 1990:
#line 14741 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[0]))); }
#line 49060 "gram.c" /* yacc.c:1646  */
    break;

  case 1991:
#line 14743 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 49066 "gram.c" /* yacc.c:1646  */
    break;

  case 1992:
#line 14745 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[-2])));
				}
#line 49075 "gram.c" /* yacc.c:1646  */
    break;

  case 1993:
#line 14750 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[-2])));
				}
#line 49084 "gram.c" /* yacc.c:1646  */
    break;

  case 1994:
#line 14755 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 49094 "gram.c" /* yacc.c:1646  */
    break;

  case 1995:
#line 14761 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 49106 "gram.c" /* yacc.c:1646  */
    break;

  case 1996:
#line 14769 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[-2])));
				}
#line 49115 "gram.c" /* yacc.c:1646  */
    break;

  case 1997:
#line 14774 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 49126 "gram.c" /* yacc.c:1646  */
    break;

  case 1998:
#line 14781 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = (yyvsp[0].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[-2]));
				}
#line 49136 "gram.c" /* yacc.c:1646  */
    break;

  case 1999:
#line 14787 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 49142 "gram.c" /* yacc.c:1646  */
    break;

  case 2000:
#line 14792 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[0])));
				}
#line 49150 "gram.c" /* yacc.c:1646  */
    break;

  case 2001:
#line 14796 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[-3])),
									makeIntConst((yyvsp[-1].ival), (yylsp[-1])));
				}
#line 49159 "gram.c" /* yacc.c:1646  */
    break;

  case 2002:
#line 14804 "gram.y" /* yacc.c:1646  */
    {
					(yyval.typnam) = SystemTypeName("json");
					(yyval.typnam)->location = (yylsp[0]);
				}
#line 49168 "gram.c" /* yacc.c:1646  */
    break;

  case 2003:
#line 14838 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49174 "gram.c" /* yacc.c:1646  */
    break;

  case 2004:
#line 14840 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 49180 "gram.c" /* yacc.c:1646  */
    break;

  case 2005:
#line 14842 "gram.y" /* yacc.c:1646  */
    {
					CollateClause *n = makeNode(CollateClause);

					n->arg = (yyvsp[-2].node);
					n->collname = (yyvsp[0].list);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49193 "gram.c" /* yacc.c:1646  */
    break;

  case 2006:
#line 14851 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make2((yyvsp[0].node), (yyvsp[-4].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 49204 "gram.c" /* yacc.c:1646  */
    break;

  case 2007:
#line 14858 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("timezone"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   -1);
				}
#line 49215 "gram.c" /* yacc.c:1646  */
    break;

  case 2008:
#line 14874 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49221 "gram.c" /* yacc.c:1646  */
    break;

  case 2009:
#line 14876 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 49227 "gram.c" /* yacc.c:1646  */
    break;

  case 2010:
#line 14878 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49233 "gram.c" /* yacc.c:1646  */
    break;

  case 2011:
#line 14880 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49239 "gram.c" /* yacc.c:1646  */
    break;

  case 2012:
#line 14882 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49245 "gram.c" /* yacc.c:1646  */
    break;

  case 2013:
#line 14884 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49251 "gram.c" /* yacc.c:1646  */
    break;

  case 2014:
#line 14886 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49257 "gram.c" /* yacc.c:1646  */
    break;

  case 2015:
#line 14888 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49263 "gram.c" /* yacc.c:1646  */
    break;

  case 2016:
#line 14890 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49269 "gram.c" /* yacc.c:1646  */
    break;

  case 2017:
#line 14892 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49275 "gram.c" /* yacc.c:1646  */
    break;

  case 2018:
#line 14894 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49281 "gram.c" /* yacc.c:1646  */
    break;

  case 2019:
#line 14896 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49287 "gram.c" /* yacc.c:1646  */
    break;

  case 2020:
#line 14898 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49293 "gram.c" /* yacc.c:1646  */
    break;

  case 2021:
#line 14900 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49299 "gram.c" /* yacc.c:1646  */
    break;

  case 2022:
#line 14903 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49305 "gram.c" /* yacc.c:1646  */
    break;

  case 2023:
#line 14905 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49311 "gram.c" /* yacc.c:1646  */
    break;

  case 2024:
#line 14908 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeAndExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49317 "gram.c" /* yacc.c:1646  */
    break;

  case 2025:
#line 14910 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeOrExpr((yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49323 "gram.c" /* yacc.c:1646  */
    break;

  case 2026:
#line 14912 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 49329 "gram.c" /* yacc.c:1646  */
    break;

  case 2027:
#line 14914 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNotExpr((yyvsp[0].node), (yylsp[-1])); }
#line 49335 "gram.c" /* yacc.c:1646  */
    break;

  case 2028:
#line 14917 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 49344 "gram.c" /* yacc.c:1646  */
    break;

  case 2029:
#line 14922 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "~~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49357 "gram.c" /* yacc.c:1646  */
    break;

  case 2030:
#line 14931 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 49366 "gram.c" /* yacc.c:1646  */
    break;

  case 2031:
#line 14936 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_LIKE, "!~~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49379 "gram.c" /* yacc.c:1646  */
    break;

  case 2032:
#line 14945 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
				}
#line 49388 "gram.c" /* yacc.c:1646  */
    break;

  case 2033:
#line 14950 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "~~*",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49401 "gram.c" /* yacc.c:1646  */
    break;

  case 2034:
#line 14959 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
				}
#line 49410 "gram.c" /* yacc.c:1646  */
    break;

  case 2035:
#line 14964 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("like_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_ILIKE, "!~~*",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49423 "gram.c" /* yacc.c:1646  */
    break;

  case 2036:
#line 14974 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-2]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-3].node), (Node *) n, (yylsp[-2]));
				}
#line 49436 "gram.c" /* yacc.c:1646  */
    break;

  case 2037:
#line 14983 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "~",
												   (yyvsp[-5].node), (Node *) n, (yylsp[-4]));
				}
#line 49449 "gram.c" /* yacc.c:1646  */
    break;

  case 2038:
#line 14992 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make1((yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-4].node), (Node *) n, (yylsp[-3]));
				}
#line 49462 "gram.c" /* yacc.c:1646  */
    break;

  case 2039:
#line 15001 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall(SystemFuncName("similar_to_escape"),
												 list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_SIMILAR, "!~",
												   (yyvsp[-6].node), (Node *) n, (yylsp[-5]));
				}
#line 49475 "gram.c" /* yacc.c:1646  */
    break;

  case 2040:
#line 15020 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-2].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 49488 "gram.c" /* yacc.c:1646  */
    break;

  case 2041:
#line 15029 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49501 "gram.c" /* yacc.c:1646  */
    break;

  case 2042:
#line 15038 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-3].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 49514 "gram.c" /* yacc.c:1646  */
    break;

  case 2043:
#line 15047 "gram.y" /* yacc.c:1646  */
    {
					NullTest   *n = makeNode(NullTest);

					n->arg = (Expr *) (yyvsp[-1].node);
					n->nulltesttype = IS_NOT_NULL;
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49527 "gram.c" /* yacc.c:1646  */
    break;

  case 2044:
#line 15056 "gram.y" /* yacc.c:1646  */
    {
					if (list_length((yyvsp[-2].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
								 parser_errposition((yylsp[-2]))));
					if (list_length((yyvsp[0].list)) != 2)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
								 parser_errposition((yylsp[0]))));
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlaps"),
											   list_concat((yyvsp[-2].list), (yyvsp[0].list)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 49548 "gram.c" /* yacc.c:1646  */
    break;

  case 2045:
#line 15073 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_TRUE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49561 "gram.c" /* yacc.c:1646  */
    break;

  case 2046:
#line 15082 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_TRUE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49574 "gram.c" /* yacc.c:1646  */
    break;

  case 2047:
#line 15091 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_FALSE;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49587 "gram.c" /* yacc.c:1646  */
    break;

  case 2048:
#line 15100 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_FALSE;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49600 "gram.c" /* yacc.c:1646  */
    break;

  case 2049:
#line 15109 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-2].node);
					b->booltesttype = IS_UNKNOWN;
					b->location = (yylsp[-1]);
					(yyval.node) = (Node *) b;
				}
#line 49613 "gram.c" /* yacc.c:1646  */
    break;

  case 2050:
#line 15118 "gram.y" /* yacc.c:1646  */
    {
					BooleanTest *b = makeNode(BooleanTest);

					b->arg = (Expr *) (yyvsp[-3].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					b->location = (yylsp[-2]);
					(yyval.node) = (Node *) b;
				}
#line 49626 "gram.c" /* yacc.c:1646  */
    break;

  case 2051:
#line 15127 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 49634 "gram.c" /* yacc.c:1646  */
    break;

  case 2052:
#line 15131 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 49642 "gram.c" /* yacc.c:1646  */
    break;

  case 2053:
#line 15135 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN,
												   "BETWEEN",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49654 "gram.c" /* yacc.c:1646  */
    break;

  case 2054:
#line 15143 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN,
												   "NOT BETWEEN",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49666 "gram.c" /* yacc.c:1646  */
    break;

  case 2055:
#line 15151 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_BETWEEN_SYM,
												   "BETWEEN SYMMETRIC",
												   (yyvsp[-5].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-4]));
				}
#line 49678 "gram.c" /* yacc.c:1646  */
    break;

  case 2056:
#line 15159 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_BETWEEN_SYM,
												   "NOT BETWEEN SYMMETRIC",
												   (yyvsp[-6].node),
												   (Node *) list_make2((yyvsp[-2].node), (yyvsp[0].node)),
												   (yylsp[-5]));
				}
#line 49690 "gram.c" /* yacc.c:1646  */
    break;

  case 2057:
#line 15167 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-2].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-1]);
						(yyval.node) = (Node *) n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1]));
					}
				}
#line 49715 "gram.c" /* yacc.c:1646  */
    break;

  case 2058:
#line 15188 "gram.y" /* yacc.c:1646  */
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[0].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink	   *n = (SubLink *) (yyvsp[0].node);

						n->subLinkType = ANY_SUBLINK;
						n->subLinkId = 0;
						n->testexpr = (yyvsp[-3].node);
						n->operName = NIL;		/* show it's IN not = ANY */
						n->location = (yylsp[-2]);
						/* Stick a NOT on top; must have same parse location */
						(yyval.node) = makeNotExpr((Node *) n, (yylsp[-2]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[-3].node), (yyvsp[0].node), (yylsp[-2]));
					}
				}
#line 49742 "gram.c" /* yacc.c:1646  */
    break;

  case 2059:
#line 15211 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = (yyvsp[-1].ival);
					n->subLinkId = 0;
					n->testexpr = (yyvsp[-3].node);
					n->operName = (yyvsp[-2].list);
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-2]);
					(yyval.node) = (Node *) n;
				}
#line 49758 "gram.c" /* yacc.c:1646  */
    break;

  case 2060:
#line 15223 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[-3].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[-4].list), (yyvsp[-5].node), (yyvsp[-1].node), (yylsp[-4]));
				}
#line 49769 "gram.c" /* yacc.c:1646  */
    break;

  case 2061:
#line 15230 "gram.y" /* yacc.c:1646  */
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[-2]))));
				}
#line 49789 "gram.c" /* yacc.c:1646  */
    break;

  case 2062:
#line 15246 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 49798 "gram.c" /* yacc.c:1646  */
    break;

  case 2063:
#line 15251 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49808 "gram.c" /* yacc.c:1646  */
    break;

  case 2064:
#line 15257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make1((yyvsp[-2].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-1]));
				}
#line 49819 "gram.c" /* yacc.c:1646  */
    break;

  case 2065:
#line 15264 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("is_normalized"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-2]));
				}
#line 49830 "gram.c" /* yacc.c:1646  */
    break;

  case 2066:
#line 15271 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make1((yyvsp[-3].node)),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 49842 "gram.c" /* yacc.c:1646  */
    break;

  case 2067:
#line 15279 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr((Node *) makeFuncCall(SystemFuncName("is_normalized"),
														   list_make2((yyvsp[-4].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
														   COERCE_SQL_SYNTAX,
														   (yylsp[-3])),
									 (yylsp[-3]));
				}
#line 49854 "gram.c" /* yacc.c:1646  */
    break;

  case 2068:
#line 15288 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeJsonIsPredicate((yyvsp[-3].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-3]));
				}
#line 49864 "gram.c" /* yacc.c:1646  */
    break;

  case 2069:
#line 15306 "gram.y" /* yacc.c:1646  */
    {
					JsonFormat *format = makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);

					(yyval.node) = makeNotExpr(makeJsonIsPredicate((yyvsp[-4].node), format, (yyvsp[-1].ival), (yyvsp[0].boolean), (yylsp[-4])), (yylsp[-4]));
				}
#line 49874 "gram.c" /* yacc.c:1646  */
    break;

  case 2070:
#line 15323 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * The SQL spec only allows DEFAULT in "contextually typed
					 * expressions", but for us, it's easier to allow it in
					 * any a_expr and then throw error during parse analysis
					 * if it's in an inappropriate context.  This way also
					 * lets us say something smarter than "syntax error".
					 */
					SetToDefault *n = makeNode(SetToDefault);

					/* parse analysis will fill in the rest */
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 49893 "gram.c" /* yacc.c:1646  */
    break;

  case 2071:
#line 15349 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 49899 "gram.c" /* yacc.c:1646  */
    break;

  case 2072:
#line 15351 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-2].node), (yyvsp[0].typnam), (yylsp[-1])); }
#line 49905 "gram.c" /* yacc.c:1646  */
    break;

  case 2073:
#line 15353 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 49911 "gram.c" /* yacc.c:1646  */
    break;

  case 2074:
#line 15355 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = doNegate((yyvsp[0].node), (yylsp[-1])); }
#line 49917 "gram.c" /* yacc.c:1646  */
    break;

  case 2075:
#line 15357 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49923 "gram.c" /* yacc.c:1646  */
    break;

  case 2076:
#line 15359 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49929 "gram.c" /* yacc.c:1646  */
    break;

  case 2077:
#line 15361 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49935 "gram.c" /* yacc.c:1646  */
    break;

  case 2078:
#line 15363 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49941 "gram.c" /* yacc.c:1646  */
    break;

  case 2079:
#line 15365 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49947 "gram.c" /* yacc.c:1646  */
    break;

  case 2080:
#line 15367 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49953 "gram.c" /* yacc.c:1646  */
    break;

  case 2081:
#line 15369 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49959 "gram.c" /* yacc.c:1646  */
    break;

  case 2082:
#line 15371 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49965 "gram.c" /* yacc.c:1646  */
    break;

  case 2083:
#line 15373 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49971 "gram.c" /* yacc.c:1646  */
    break;

  case 2084:
#line 15375 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49977 "gram.c" /* yacc.c:1646  */
    break;

  case 2085:
#line 15377 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49983 "gram.c" /* yacc.c:1646  */
    break;

  case 2086:
#line 15379 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<>", (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49989 "gram.c" /* yacc.c:1646  */
    break;

  case 2087:
#line 15381 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), (yyvsp[-2].node), (yyvsp[0].node), (yylsp[-1])); }
#line 49995 "gram.c" /* yacc.c:1646  */
    break;

  case 2088:
#line 15383 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[-1].list), NULL, (yyvsp[0].node), (yylsp[-1])); }
#line 50001 "gram.c" /* yacc.c:1646  */
    break;

  case 2089:
#line 15385 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[-4].node), (yyvsp[0].node), (yylsp[-3]));
				}
#line 50009 "gram.c" /* yacc.c:1646  */
    break;

  case 2090:
#line 15389 "gram.y" /* yacc.c:1646  */
    {
                    (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", (yyvsp[-5].node), (yyvsp[0].node), (yylsp[-4]));
				}
#line 50017 "gram.c" /* yacc.c:1646  */
    break;

  case 2091:
#line 15393 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[-2].node)), (yylsp[-1]));
				}
#line 50026 "gram.c" /* yacc.c:1646  */
    break;

  case 2092:
#line 15398 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNotExpr(makeXmlExpr(IS_DOCUMENT, NULL, NIL,
												 list_make1((yyvsp[-3].node)), (yylsp[-2])),
									 (yylsp[-2]));
				}
#line 50036 "gram.c" /* yacc.c:1646  */
    break;

  case 2093:
#line 15413 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50042 "gram.c" /* yacc.c:1646  */
    break;

  case 2094:
#line 15414 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50048 "gram.c" /* yacc.c:1646  */
    break;

  case 2095:
#line 15416 "gram.y" /* yacc.c:1646  */
    {
					ParamRef   *p = makeNode(ParamRef);

					p->number = (yyvsp[-1].ival);
					p->location = (yylsp[-1]);
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				}
#line 50069 "gram.c" /* yacc.c:1646  */
    break;

  case 2096:
#line 15433 "gram.y" /* yacc.c:1646  */
    {
					if ((yyvsp[0].list))
					{
						A_Indirection *n = makeNode(A_Indirection);

						n->arg = (yyvsp[-2].node);
						n->indirection = check_indirection((yyvsp[0].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (yyvsp[-2].node);
				}
#line 50086 "gram.c" /* yacc.c:1646  */
    break;

  case 2097:
#line 15446 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50092 "gram.c" /* yacc.c:1646  */
    break;

  case 2098:
#line 15448 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50098 "gram.c" /* yacc.c:1646  */
    break;

  case 2099:
#line 15450 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[0]);
					(yyval.node) = (Node *) n;
				}
#line 50114 "gram.c" /* yacc.c:1646  */
    break;

  case 2100:
#line 15462 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink	   *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);

					n->subLinkType = EXPR_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[-1].node);
					n->location = (yylsp[-1]);
					a->arg = (Node *) n;
					a->indirection = check_indirection((yyvsp[0].list), yyscanner);
					(yyval.node) = (Node *) a;
				}
#line 50143 "gram.c" /* yacc.c:1646  */
    break;

  case 2101:
#line 15487 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = EXISTS_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50159 "gram.c" /* yacc.c:1646  */
    break;

  case 2102:
#line 15499 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subLinkType = ARRAY_SUBLINK;
					n->subLinkId = 0;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[0].node);
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50175 "gram.c" /* yacc.c:1646  */
    break;

  case 2103:
#line 15511 "gram.y" /* yacc.c:1646  */
    {
					A_ArrayExpr *n = castNode(A_ArrayExpr, (yyvsp[0].node));

					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[-1]);
					(yyval.node) = (Node *) n;
				}
#line 50187 "gram.c" /* yacc.c:1646  */
    break;

  case 2104:
#line 15519 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_EXPLICIT_CALL; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 50202 "gram.c" /* yacc.c:1646  */
    break;

  case 2105:
#line 15530 "gram.y" /* yacc.c:1646  */
    {
					RowExpr	   *r = makeNode(RowExpr);

					r->args = (yyvsp[0].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->colnames = NIL;	/* to be filled in during analysis */
					r->row_format = COERCE_IMPLICIT_CAST; /* abuse */
					r->location = (yylsp[0]);
					(yyval.node) = (Node *) r;
				}
#line 50217 "gram.c" /* yacc.c:1646  */
    break;

  case 2106:
#line 15541 "gram.y" /* yacc.c:1646  */
    {
				  GroupingFunc *g = makeNode(GroupingFunc);

				  g->args = (yyvsp[-1].list);
				  g->location = (yylsp[-3]);
				  (yyval.node) = (Node *) g;
			  }
#line 50229 "gram.c" /* yacc.c:1646  */
    break;

  case 2107:
#line 15551 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall((yyvsp[-2].list), NIL,
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-2]));
				}
#line 50239 "gram.c" /* yacc.c:1646  */
    break;

  case 2108:
#line 15557 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-4].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-4]));

					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50252 "gram.c" /* yacc.c:1646  */
    break;

  case 2109:
#line 15566 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), list_make1((yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50266 "gram.c" /* yacc.c:1646  */
    break;

  case 2110:
#line 15576 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-7].list), lappend((yyvsp[-5].list), (yyvsp[-2].node)),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-7]));

					n->func_variadic = true;
					n->agg_order = (yyvsp[-1].list);
					(yyval.node) = (Node *) n;
				}
#line 50280 "gram.c" /* yacc.c:1646  */
    break;

  case 2111:
#line 15586 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					(yyval.node) = (Node *) n;
				}
#line 50297 "gram.c" /* yacc.c:1646  */
    break;

  case 2112:
#line 15599 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = makeFuncCall((yyvsp[-5].list), (yyvsp[-2].list),
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-5]));

					n->agg_order = (yyvsp[-1].list);
					n->agg_distinct = true;
					(yyval.node) = (Node *) n;
				}
#line 50311 "gram.c" /* yacc.c:1646  */
    break;

  case 2113:
#line 15609 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall   *n = makeFuncCall((yyvsp[-3].list), NIL,
												 COERCE_EXPLICIT_CALL,
												 (yylsp[-3]));

					n->agg_star = true;
					(yyval.node) = (Node *) n;
				}
#line 50334 "gram.c" /* yacc.c:1646  */
    break;

  case 2114:
#line 15640 "gram.y" /* yacc.c:1646  */
    {
					FuncCall   *n = (FuncCall *) (yyvsp[-3].node);

					/*
					 * The order clause for WITHIN GROUP and the one for
					 * plain-aggregate ORDER BY share a field, so we have to
					 * check here that at most one is present.  We also check
					 * for DISTINCT and VARIADIC here to give a better error
					 * location.  Other consistency checks are deferred to
					 * parse analysis.
					 */
					if ((yyvsp[-2].list) != NIL)
					{
						if (n->agg_order != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use multiple ORDER BY clauses with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->agg_distinct)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use DISTINCT with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						if (n->func_variadic)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("cannot use VARIADIC with WITHIN GROUP"),
									 parser_errposition((yylsp[-2]))));
						n->agg_order = (yyvsp[-2].list);
						n->agg_within_group = true;
					}
					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) n;
				}
#line 50374 "gram.c" /* yacc.c:1646  */
    break;

  case 2115:
#line 15676 "gram.y" /* yacc.c:1646  */
    {
					JsonAggConstructor *n = IsA((yyvsp[-2].node), JsonObjectAgg) ?
						((JsonObjectAgg *) (yyvsp[-2].node))->constructor :
						((JsonArrayAgg *) (yyvsp[-2].node))->constructor;

					n->agg_filter = (yyvsp[-1].node);
					n->over = (yyvsp[0].windef);
					(yyval.node) = (Node *) (yyvsp[-2].node);
				}
#line 50388 "gram.c" /* yacc.c:1646  */
    break;

  case 2116:
#line 15686 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50394 "gram.c" /* yacc.c:1646  */
    break;

  case 2117:
#line 15696 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50400 "gram.c" /* yacc.c:1646  */
    break;

  case 2118:
#line 15697 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50406 "gram.c" /* yacc.c:1646  */
    break;

  case 2119:
#line 15698 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 50412 "gram.c" /* yacc.c:1646  */
    break;

  case 2120:
#line 15706 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50423 "gram.c" /* yacc.c:1646  */
    break;

  case 2121:
#line 15713 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_DATE, -1, (yylsp[0]));
				}
#line 50431 "gram.c" /* yacc.c:1646  */
    break;

  case 2122:
#line 15717 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, (yylsp[0]));
				}
#line 50439 "gram.c" /* yacc.c:1646  */
    break;

  case 2123:
#line 15721 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50447 "gram.c" /* yacc.c:1646  */
    break;

  case 2124:
#line 15725 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, (yylsp[0]));
				}
#line 50455 "gram.c" /* yacc.c:1646  */
    break;

  case 2125:
#line 15729 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50463 "gram.c" /* yacc.c:1646  */
    break;

  case 2126:
#line 15733 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME, -1, (yylsp[0]));
				}
#line 50471 "gram.c" /* yacc.c:1646  */
    break;

  case 2127:
#line 15737 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIME_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50479 "gram.c" /* yacc.c:1646  */
    break;

  case 2128:
#line 15741 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, (yylsp[0]));
				}
#line 50487 "gram.c" /* yacc.c:1646  */
    break;

  case 2129:
#line 15745 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, (yyvsp[-1].ival), (yylsp[-3]));
				}
#line 50495 "gram.c" /* yacc.c:1646  */
    break;

  case 2130:
#line 15749 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_ROLE, -1, (yylsp[0]));
				}
#line 50503 "gram.c" /* yacc.c:1646  */
    break;

  case 2131:
#line 15753 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_USER, -1, (yylsp[0]));
				}
#line 50511 "gram.c" /* yacc.c:1646  */
    break;

  case 2132:
#line 15757 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_SESSION_USER, -1, (yylsp[0]));
				}
#line 50519 "gram.c" /* yacc.c:1646  */
    break;

  case 2133:
#line 15761 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("system_user"),
											   NIL,
											   COERCE_SQL_SYNTAX,
											   (yylsp[0]));
				}
#line 50530 "gram.c" /* yacc.c:1646  */
    break;

  case 2134:
#line 15768 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_USER, -1, (yylsp[0]));
				}
#line 50538 "gram.c" /* yacc.c:1646  */
    break;

  case 2135:
#line 15772 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_CATALOG, -1, (yylsp[0]));
				}
#line 50546 "gram.c" /* yacc.c:1646  */
    break;

  case 2136:
#line 15776 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, (yylsp[0]));
				}
#line 50554 "gram.c" /* yacc.c:1646  */
    break;

  case 2137:
#line 15780 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeTypeCast((yyvsp[-3].node), (yyvsp[-1].typnam), (yylsp[-5])); }
#line 50560 "gram.c" /* yacc.c:1646  */
    break;

  case 2138:
#line 15782 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("extract"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50571 "gram.c" /* yacc.c:1646  */
    break;

  case 2139:
#line 15789 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make1((yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50582 "gram.c" /* yacc.c:1646  */
    break;

  case 2140:
#line 15796 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("normalize"),
											   list_make2((yyvsp[-3].node), makeStringConst((yyvsp[-1].str), (yylsp[-1]))),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-5]));
				}
#line 50593 "gram.c" /* yacc.c:1646  */
    break;

  case 2141:
#line 15803 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("overlay"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50604 "gram.c" /* yacc.c:1646  */
    break;

  case 2142:
#line 15810 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named overlay() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("overlay")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50619 "gram.c" /* yacc.c:1646  */
    break;

  case 2143:
#line 15821 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * position(A in B) is converted to position(B, A)
					 *
					 * We deliberately don't offer a "plain syntax" option
					 * for position(), because the reversal of the arguments
					 * creates too much risk of confusion.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("position"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50637 "gram.c" /* yacc.c:1646  */
    break;

  case 2144:
#line 15835 "gram.y" /* yacc.c:1646  */
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("substring"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50651 "gram.c" /* yacc.c:1646  */
    break;

  case 2145:
#line 15845 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * allow functions named substring() to be called without
					 * special syntax
					 */
					(yyval.node) = (Node *) makeFuncCall(list_make1(makeString("substring")),
											   (yyvsp[-1].list),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-3]));
				}
#line 50666 "gram.c" /* yacc.c:1646  */
    break;

  case 2146:
#line 15856 "gram.y" /* yacc.c:1646  */
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 *
					 * Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName(strVal(llast((yyvsp[-1].typnam)->names))),
											   list_make1((yyvsp[-3].node)),
											   COERCE_EXPLICIT_CALL,
											   (yylsp[-5]));
				}
#line 50686 "gram.c" /* yacc.c:1646  */
    break;

  case 2147:
#line 15872 "gram.y" /* yacc.c:1646  */
    {
					/* various trim expressions are defined in SQL
					 * - thomas 1997-07-19
					 */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50700 "gram.c" /* yacc.c:1646  */
    break;

  case 2148:
#line 15882 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("ltrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50711 "gram.c" /* yacc.c:1646  */
    break;

  case 2149:
#line 15889 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("rtrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50722 "gram.c" /* yacc.c:1646  */
    break;

  case 2150:
#line 15896 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("btrim"),
											   (yyvsp[-1].list),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-3]));
				}
#line 50733 "gram.c" /* yacc.c:1646  */
    break;

  case 2151:
#line 15903 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[-3].node), (yyvsp[-1].node), (yylsp[-5]));
				}
#line 50741 "gram.c" /* yacc.c:1646  */
    break;

  case 2152:
#line 15907 "gram.y" /* yacc.c:1646  */
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);

					c->args = (yyvsp[-1].list);
					c->location = (yylsp[-3]);
					(yyval.node) = (Node *) c;
				}
#line 50753 "gram.c" /* yacc.c:1646  */
    break;

  case 2153:
#line 15915 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50766 "gram.c" /* yacc.c:1646  */
    break;

  case 2154:
#line 15924 "gram.y" /* yacc.c:1646  */
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);

					v->args = (yyvsp[-1].list);
					v->op = IS_LEAST;
					v->location = (yylsp[-3]);
					(yyval.node) = (Node *) v;
				}
#line 50779 "gram.c" /* yacc.c:1646  */
    break;

  case 2155:
#line 15933 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[-1].list), (yylsp[-3]));
				}
#line 50787 "gram.c" /* yacc.c:1646  */
    break;

  case 2156:
#line 15937 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-1].str), NIL, NIL, (yylsp[-4]));
				}
#line 50795 "gram.c" /* yacc.c:1646  */
    break;

  case 2157:
#line 15941 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), (yyvsp[-1].list), NIL, (yylsp[-6]));
				}
#line 50803 "gram.c" /* yacc.c:1646  */
    break;

  case 2158:
#line 15945 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-3].str), NIL, (yyvsp[-1].list), (yylsp[-6]));
				}
#line 50811 "gram.c" /* yacc.c:1646  */
    break;

  case 2159:
#line 15949 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[-5].str), (yyvsp[-3].list), (yyvsp[-1].list), (yylsp[-8]));
				}
#line 50819 "gram.c" /* yacc.c:1646  */
    break;

  case 2160:
#line 15953 "gram.y" /* yacc.c:1646  */
    {
					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
					 * converted to xmlexists(A, B)*/
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("xmlexists"),
											   list_make2((yyvsp[-2].node), (yyvsp[-1].node)),
											   COERCE_SQL_SYNTAX,
											   (yylsp[-4]));
				}
#line 50832 "gram.c" /* yacc.c:1646  */
    break;

  case 2161:
#line 15962 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[-1].list), NIL, (yylsp[-3]));
				}
#line 50840 "gram.c" /* yacc.c:1646  */
    break;

  case 2162:
#line 15966 "gram.y" /* yacc.c:1646  */
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[-2].node), makeBoolAConst((yyvsp[-1].boolean), -1)),
									(yylsp[-5]));

					x->xmloption = (yyvsp[-3].ival);
					(yyval.node) = (Node *) x;
				}
#line 50854 "gram.c" /* yacc.c:1646  */
    break;

  case 2163:
#line 15976 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-1].str), NULL, NIL, (yylsp[-4]));
				}
#line 50862 "gram.c" /* yacc.c:1646  */
    break;

  case 2164:
#line 15980 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[-3].str), NULL, list_make1((yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50870 "gram.c" /* yacc.c:1646  */
    break;

  case 2165:
#line 15984 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[-1].node)), (yylsp[-6]));
				}
#line 50879 "gram.c" /* yacc.c:1646  */
    break;

  case 2166:
#line 15989 "gram.y" /* yacc.c:1646  */
    {
					XmlSerialize *n = makeNode(XmlSerialize);

					n->xmloption = (yyvsp[-5].ival);
					n->expr = (yyvsp[-4].node);
					n->typeName = (yyvsp[-2].typnam);
					n->indent = (yyvsp[-1].boolean);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 50894 "gram.c" /* yacc.c:1646  */
    break;

  case 2167:
#line 16000 "gram.y" /* yacc.c:1646  */
    {
					/* Support for legacy (non-standard) json_object() */
					(yyval.node) = (Node *) makeFuncCall(SystemFuncName("json_object"),
											   (yyvsp[-1].list), COERCE_EXPLICIT_CALL, (yylsp[-3]));
				}
#line 50904 "gram.c" /* yacc.c:1646  */
    break;

  case 2168:
#line 16009 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = (yyvsp[-4].list);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 50919 "gram.c" /* yacc.c:1646  */
    break;

  case 2169:
#line 16020 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectConstructor *n = makeNode(JsonObjectConstructor);

					n->exprs = NULL;
					n->absent_on_null = false;
					n->unique = false;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50934 "gram.c" /* yacc.c:1646  */
    break;

  case 2170:
#line 16035 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = (yyvsp[-3].list);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50948 "gram.c" /* yacc.c:1646  */
    break;

  case 2171:
#line 16050 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayQueryConstructor *n = makeNode(JsonArrayQueryConstructor);

					n->query = (yyvsp[-3].node);
					n->format = (JsonFormat *) (yyvsp[-2].node);
					n->absent_on_null = true;	/* XXX */
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-5]);
					(yyval.node) = (Node *) n;
				}
#line 50963 "gram.c" /* yacc.c:1646  */
    break;

  case 2172:
#line 16063 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayConstructor *n = makeNode(JsonArrayConstructor);

					n->exprs = NIL;
					n->absent_on_null = true;
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 50977 "gram.c" /* yacc.c:1646  */
    break;

  case 2173:
#line 16073 "gram.y" /* yacc.c:1646  */
    {
					JsonParseExpr *n = makeNode(JsonParseExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->unique_keys = (yyvsp[-1].boolean);
					n->output = NULL;
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 50991 "gram.c" /* yacc.c:1646  */
    break;

  case 2174:
#line 16083 "gram.y" /* yacc.c:1646  */
    {
					JsonScalarExpr *n = makeNode(JsonScalarExpr);

					n->expr = (Expr *) (yyvsp[-1].node);
					n->output = NULL;
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 51004 "gram.c" /* yacc.c:1646  */
    break;

  case 2175:
#line 16092 "gram.y" /* yacc.c:1646  */
    {
					JsonSerializeExpr *n = makeNode(JsonSerializeExpr);

					n->expr = (JsonValueExpr *) (yyvsp[-2].node);
					n->output = (JsonOutput *) (yyvsp[-1].node);
					n->location = (yylsp[-4]);
					(yyval.node) = (Node *) n;
				}
#line 51017 "gram.c" /* yacc.c:1646  */
    break;

  case 2176:
#line 16101 "gram.y" /* yacc.c:1646  */
    {
					MergeSupportFunc *m = makeNode(MergeSupportFunc);

					m->msftype = TEXTOID;
					m->location = (yylsp[-2]);
					(yyval.node) = (Node *) m;
				}
#line 51029 "gram.c" /* yacc.c:1646  */
    break;

  case 2177:
#line 16115 "gram.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_QUERY_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-8].node);
					n->pathspec = (yyvsp[-6].node);
					n->passing = (yyvsp[-5].list);
					n->output = (JsonOutput *) (yyvsp[-4].node);
					n->wrapper = (yyvsp[-3].ival);
					n->quotes = (yyvsp[-2].ival);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-10]);
					(yyval.node) = (Node *) n;
				}
#line 51049 "gram.c" /* yacc.c:1646  */
    break;

  case 2178:
#line 16134 "gram.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_EXISTS_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-5].node);
					n->pathspec = (yyvsp[-3].node);
					n->passing = (yyvsp[-2].list);
					n->output = NULL;
					n->on_error = (JsonBehavior *) (yyvsp[-1].node);
					n->location = (yylsp[-7]);
					(yyval.node) = (Node *) n;
				}
#line 51066 "gram.c" /* yacc.c:1646  */
    break;

  case 2179:
#line 16151 "gram.y" /* yacc.c:1646  */
    {
					JsonFuncExpr *n = makeNode(JsonFuncExpr);

					n->op = JSON_VALUE_OP;
					n->context_item = (JsonValueExpr *) (yyvsp[-6].node);
					n->pathspec = (yyvsp[-4].node);
					n->passing = (yyvsp[-3].list);
					n->output = (JsonOutput *) (yyvsp[-2].node);
					n->on_empty = (JsonBehavior *) linitial((yyvsp[-1].list));
					n->on_error = (JsonBehavior *) lsecond((yyvsp[-1].list));
					n->location = (yylsp[-8]);
					(yyval.node) = (Node *) n;
				}
#line 51084 "gram.c" /* yacc.c:1646  */
    break;

  case 2180:
#line 16171 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 51090 "gram.c" /* yacc.c:1646  */
    break;

  case 2181:
#line 16173 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeNullAConst(-1); }
#line 51096 "gram.c" /* yacc.c:1646  */
    break;

  case 2182:
#line 16177 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); }
#line 51102 "gram.c" /* yacc.c:1646  */
    break;

  case 2183:
#line 16179 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); }
#line 51108 "gram.c" /* yacc.c:1646  */
    break;

  case 2184:
#line 16181 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
#line 51114 "gram.c" /* yacc.c:1646  */
    break;

  case 2185:
#line 16183 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); }
#line 51120 "gram.c" /* yacc.c:1646  */
    break;

  case 2186:
#line 16186 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51126 "gram.c" /* yacc.c:1646  */
    break;

  case 2187:
#line 16189 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 51132 "gram.c" /* yacc.c:1646  */
    break;

  case 2188:
#line 16190 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 51138 "gram.c" /* yacc.c:1646  */
    break;

  case 2189:
#line 16194 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 51150 "gram.c" /* yacc.c:1646  */
    break;

  case 2190:
#line 16202 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 51162 "gram.c" /* yacc.c:1646  */
    break;

  case 2191:
#line 16211 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_DOCUMENT; }
#line 51168 "gram.c" /* yacc.c:1646  */
    break;

  case 2192:
#line 16212 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = XMLOPTION_CONTENT; }
#line 51174 "gram.c" /* yacc.c:1646  */
    break;

  case 2193:
#line 16215 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 51180 "gram.c" /* yacc.c:1646  */
    break;

  case 2194:
#line 16216 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51186 "gram.c" /* yacc.c:1646  */
    break;

  case 2195:
#line 16217 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51192 "gram.c" /* yacc.c:1646  */
    break;

  case 2196:
#line 16220 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 51198 "gram.c" /* yacc.c:1646  */
    break;

  case 2197:
#line 16221 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51204 "gram.c" /* yacc.c:1646  */
    break;

  case 2198:
#line 16222 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 51210 "gram.c" /* yacc.c:1646  */
    break;

  case 2199:
#line 16228 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51218 "gram.c" /* yacc.c:1646  */
    break;

  case 2200:
#line 16232 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51226 "gram.c" /* yacc.c:1646  */
    break;

  case 2201:
#line 16236 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51234 "gram.c" /* yacc.c:1646  */
    break;

  case 2202:
#line 16240 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[-1].node);
				}
#line 51242 "gram.c" /* yacc.c:1646  */
    break;

  case 2205:
#line 16255 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51248 "gram.c" /* yacc.c:1646  */
    break;

  case 2206:
#line 16256 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51254 "gram.c" /* yacc.c:1646  */
    break;

  case 2207:
#line 16260 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-1].node); }
#line 51260 "gram.c" /* yacc.c:1646  */
    break;

  case 2208:
#line 16261 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 51266 "gram.c" /* yacc.c:1646  */
    break;

  case 2209:
#line 16269 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51272 "gram.c" /* yacc.c:1646  */
    break;

  case 2210:
#line 16270 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51278 "gram.c" /* yacc.c:1646  */
    break;

  case 2211:
#line 16274 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].windef)); }
#line 51284 "gram.c" /* yacc.c:1646  */
    break;

  case 2212:
#line 16276 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].windef)); }
#line 51290 "gram.c" /* yacc.c:1646  */
    break;

  case 2213:
#line 16281 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					n->name = (yyvsp[-2].str);
					(yyval.windef) = n;
				}
#line 51301 "gram.c" /* yacc.c:1646  */
    break;

  case 2214:
#line 16290 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = (yyvsp[0].windef); }
#line 51307 "gram.c" /* yacc.c:1646  */
    break;

  case 2215:
#line 16292 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = (yyvsp[0].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[0]);
					(yyval.windef) = n;
				}
#line 51325 "gram.c" /* yacc.c:1646  */
    break;

  case 2216:
#line 16306 "gram.y" /* yacc.c:1646  */
    { (yyval.windef) = NULL; }
#line 51331 "gram.c" /* yacc.c:1646  */
    break;

  case 2217:
#line 16311 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->name = NULL;
					n->refname = (yyvsp[-4].str);
					n->partitionClause = (yyvsp[-3].list);
					n->orderClause = (yyvsp[-2].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[-1].windef)->frameOptions;
					n->startOffset = (yyvsp[-1].windef)->startOffset;
					n->endOffset = (yyvsp[-1].windef)->endOffset;
					n->location = (yylsp[-5]);
					(yyval.windef) = n;
				}
#line 51350 "gram.c" /* yacc.c:1646  */
    break;

  case 2218:
#line 16337 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51356 "gram.c" /* yacc.c:1646  */
    break;

  case 2219:
#line 16338 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = NULL; }
#line 51362 "gram.c" /* yacc.c:1646  */
    break;

  case 2220:
#line 16341 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51368 "gram.c" /* yacc.c:1646  */
    break;

  case 2221:
#line 16342 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51374 "gram.c" /* yacc.c:1646  */
    break;

  case 2222:
#line 16351 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51386 "gram.c" /* yacc.c:1646  */
    break;

  case 2223:
#line 16359 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51398 "gram.c" /* yacc.c:1646  */
    break;

  case 2224:
#line 16367 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[-1].windef);

					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_GROUPS;
					n->frameOptions |= (yyvsp[0].ival);
					(yyval.windef) = n;
				}
#line 51410 "gram.c" /* yacc.c:1646  */
    break;

  case 2225:
#line 16375 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51423 "gram.c" /* yacc.c:1646  */
    break;

  case 2226:
#line 16386 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = (yyvsp[0].windef);

					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[0]))));
					if (n->frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[0]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				}
#line 51445 "gram.c" /* yacc.c:1646  */
    break;

  case 2227:
#line 16404 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n1 = (yyvsp[-2].windef);
					WindowDef  *n2 = (yyvsp[0].windef);

					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[-2]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_OFFSET_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					if ((frameOptions & FRAMEOPTION_START_OFFSET_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_OFFSET_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[0]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				}
#line 51487 "gram.c" /* yacc.c:1646  */
    break;

  case 2228:
#line 16450 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51500 "gram.c" /* yacc.c:1646  */
    break;

  case 2229:
#line 16459 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51513 "gram.c" /* yacc.c:1646  */
    break;

  case 2230:
#line 16468 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51526 "gram.c" /* yacc.c:1646  */
    break;

  case 2231:
#line 16477 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_PRECEDING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51539 "gram.c" /* yacc.c:1646  */
    break;

  case 2232:
#line 16486 "gram.y" /* yacc.c:1646  */
    {
					WindowDef  *n = makeNode(WindowDef);

					n->frameOptions = FRAMEOPTION_START_OFFSET_FOLLOWING;
					n->startOffset = (yyvsp[-1].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				}
#line 51552 "gram.c" /* yacc.c:1646  */
    break;

  case 2233:
#line 16497 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_CURRENT_ROW; }
#line 51558 "gram.c" /* yacc.c:1646  */
    break;

  case 2234:
#line 16498 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_GROUP; }
#line 51564 "gram.c" /* yacc.c:1646  */
    break;

  case 2235:
#line 16499 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = FRAMEOPTION_EXCLUDE_TIES; }
#line 51570 "gram.c" /* yacc.c:1646  */
    break;

  case 2236:
#line 16500 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 51576 "gram.c" /* yacc.c:1646  */
    break;

  case 2237:
#line 16501 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = 0; }
#line 51582 "gram.c" /* yacc.c:1646  */
    break;

  case 2238:
#line 16515 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51588 "gram.c" /* yacc.c:1646  */
    break;

  case 2239:
#line 16516 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51594 "gram.c" /* yacc.c:1646  */
    break;

  case 2240:
#line 16517 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 51600 "gram.c" /* yacc.c:1646  */
    break;

  case 2241:
#line 16520 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51606 "gram.c" /* yacc.c:1646  */
    break;

  case 2242:
#line 16521 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51612 "gram.c" /* yacc.c:1646  */
    break;

  case 2243:
#line 16524 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-3].list), (yyvsp[-1].node)); }
#line 51618 "gram.c" /* yacc.c:1646  */
    break;

  case 2244:
#line 16527 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 51624 "gram.c" /* yacc.c:1646  */
    break;

  case 2245:
#line 16528 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ANY_SUBLINK; }
#line 51630 "gram.c" /* yacc.c:1646  */
    break;

  case 2246:
#line 16529 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = ALL_SUBLINK; }
#line 51636 "gram.c" /* yacc.c:1646  */
    break;

  case 2247:
#line 16532 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51642 "gram.c" /* yacc.c:1646  */
    break;

  case 2248:
#line 16533 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51648 "gram.c" /* yacc.c:1646  */
    break;

  case 2249:
#line 16536 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "+"; }
#line 51654 "gram.c" /* yacc.c:1646  */
    break;

  case 2250:
#line 16537 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "-"; }
#line 51660 "gram.c" /* yacc.c:1646  */
    break;

  case 2251:
#line 16538 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "*"; }
#line 51666 "gram.c" /* yacc.c:1646  */
    break;

  case 2252:
#line 16539 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "/"; }
#line 51672 "gram.c" /* yacc.c:1646  */
    break;

  case 2253:
#line 16540 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "%"; }
#line 51678 "gram.c" /* yacc.c:1646  */
    break;

  case 2254:
#line 16541 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "^"; }
#line 51684 "gram.c" /* yacc.c:1646  */
    break;

  case 2255:
#line 16542 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<"; }
#line 51690 "gram.c" /* yacc.c:1646  */
    break;

  case 2256:
#line 16543 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">"; }
#line 51696 "gram.c" /* yacc.c:1646  */
    break;

  case 2257:
#line 16544 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "="; }
#line 51702 "gram.c" /* yacc.c:1646  */
    break;

  case 2258:
#line 16545 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<="; }
#line 51708 "gram.c" /* yacc.c:1646  */
    break;

  case 2259:
#line 16546 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = ">="; }
#line 51714 "gram.c" /* yacc.c:1646  */
    break;

  case 2260:
#line 16547 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "<>"; }
#line 51720 "gram.c" /* yacc.c:1646  */
    break;

  case 2261:
#line 16551 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51726 "gram.c" /* yacc.c:1646  */
    break;

  case 2262:
#line 16553 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51732 "gram.c" /* yacc.c:1646  */
    break;

  case 2263:
#line 16558 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51738 "gram.c" /* yacc.c:1646  */
    break;

  case 2264:
#line 16560 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51744 "gram.c" /* yacc.c:1646  */
    break;

  case 2265:
#line 16565 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 51750 "gram.c" /* yacc.c:1646  */
    break;

  case 2266:
#line 16567 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[-1].list); }
#line 51756 "gram.c" /* yacc.c:1646  */
    break;

  case 2267:
#line 16569 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~")); }
#line 51762 "gram.c" /* yacc.c:1646  */
    break;

  case 2268:
#line 16571 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~")); }
#line 51768 "gram.c" /* yacc.c:1646  */
    break;

  case 2269:
#line 16573 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("~~*")); }
#line 51774 "gram.c" /* yacc.c:1646  */
    break;

  case 2270:
#line 16575 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString("!~~*")); }
#line 51780 "gram.c" /* yacc.c:1646  */
    break;

  case 2271:
#line 16587 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51788 "gram.c" /* yacc.c:1646  */
    break;

  case 2272:
#line 16591 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51796 "gram.c" /* yacc.c:1646  */
    break;

  case 2273:
#line 16598 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make1((yyvsp[0].node));
				}
#line 51804 "gram.c" /* yacc.c:1646  */
    break;

  case 2274:
#line 16602 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));
				}
#line 51812 "gram.c" /* yacc.c:1646  */
    break;

  case 2275:
#line 16608 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 51820 "gram.c" /* yacc.c:1646  */
    break;

  case 2276:
#line 16612 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51834 "gram.c" /* yacc.c:1646  */
    break;

  case 2277:
#line 16622 "gram.y" /* yacc.c:1646  */
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);

					na->name = (yyvsp[-2].str);
					na->arg = (Expr *) (yyvsp[0].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[-2]);
					(yyval.node) = (Node *) na;
				}
#line 51848 "gram.c" /* yacc.c:1646  */
    break;

  case 2278:
#line 16633 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 51854 "gram.c" /* yacc.c:1646  */
    break;

  case 2279:
#line 16634 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 51860 "gram.c" /* yacc.c:1646  */
    break;

  case 2280:
#line 16637 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].typnam)); }
#line 51866 "gram.c" /* yacc.c:1646  */
    break;

  case 2281:
#line 16638 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].typnam)); }
#line 51872 "gram.c" /* yacc.c:1646  */
    break;

  case 2282:
#line 16642 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51880 "gram.c" /* yacc.c:1646  */
    break;

  case 2283:
#line 16646 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr((yyvsp[-1].list), (yylsp[-2]));
				}
#line 51888 "gram.c" /* yacc.c:1646  */
    break;

  case 2284:
#line 16650 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[-1]));
				}
#line 51896 "gram.c" /* yacc.c:1646  */
    break;

  case 2285:
#line 16655 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 51902 "gram.c" /* yacc.c:1646  */
    break;

  case 2286:
#line 16656 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 51908 "gram.c" /* yacc.c:1646  */
    break;

  case 2287:
#line 16662 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[-2].str), (yylsp[-2])), (yyvsp[0].node));
				}
#line 51916 "gram.c" /* yacc.c:1646  */
    break;

  case 2288:
#line 16671 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51922 "gram.c" /* yacc.c:1646  */
    break;

  case 2289:
#line 16672 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "year"; }
#line 51928 "gram.c" /* yacc.c:1646  */
    break;

  case 2290:
#line 16673 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "month"; }
#line 51934 "gram.c" /* yacc.c:1646  */
    break;

  case 2291:
#line 16674 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "day"; }
#line 51940 "gram.c" /* yacc.c:1646  */
    break;

  case 2292:
#line 16675 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "hour"; }
#line 51946 "gram.c" /* yacc.c:1646  */
    break;

  case 2293:
#line 16676 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "minute"; }
#line 51952 "gram.c" /* yacc.c:1646  */
    break;

  case 2294:
#line 16677 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "second"; }
#line 51958 "gram.c" /* yacc.c:1646  */
    break;

  case 2295:
#line 16678 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 51964 "gram.c" /* yacc.c:1646  */
    break;

  case 2296:
#line 16682 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFC"; }
#line 51970 "gram.c" /* yacc.c:1646  */
    break;

  case 2297:
#line 16683 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFD"; }
#line 51976 "gram.c" /* yacc.c:1646  */
    break;

  case 2298:
#line 16684 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKC"; }
#line 51982 "gram.c" /* yacc.c:1646  */
    break;

  case 2299:
#line 16685 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = "NFKD"; }
#line 51988 "gram.c" /* yacc.c:1646  */
    break;

  case 2300:
#line 16691 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to overlay(A, B, C, D) */
					(yyval.list) = list_make4((yyvsp[-6].node), (yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 51997 "gram.c" /* yacc.c:1646  */
    break;

  case 2301:
#line 16696 "gram.y" /* yacc.c:1646  */
    {
					/* overlay(A PLACING B FROM C) is converted to overlay(A, B, C) */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52006 "gram.c" /* yacc.c:1646  */
    break;

  case 2302:
#line 16704 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[0].node), (yyvsp[-2].node)); }
#line 52012 "gram.c" /* yacc.c:1646  */
    break;

  case 2303:
#line 16726 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52020 "gram.c" /* yacc.c:1646  */
    break;

  case 2304:
#line 16730 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[0].node), (yyvsp[-2].node));
				}
#line 52029 "gram.c" /* yacc.c:1646  */
    break;

  case 2305:
#line 16735 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * Because we aren't restricting data types here, this
					 * syntax can end up resolving to textregexsubstr().
					 * We've historically allowed that to happen, so continue
					 * to accept it.  However, ruleutils.c will reverse-list
					 * such a call in regular function call syntax.
					 */
					(yyval.list) = list_make2((yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52044 "gram.c" /* yacc.c:1646  */
    break;

  case 2306:
#line 16746 "gram.y" /* yacc.c:1646  */
    {
					/* not legal per SQL */

					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[-2].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[0].node),
												 SystemTypeName("int4"), -1));
				}
#line 52065 "gram.c" /* yacc.c:1646  */
    break;

  case 2307:
#line 16763 "gram.y" /* yacc.c:1646  */
    {
					(yyval.list) = list_make3((yyvsp[-4].node), (yyvsp[-2].node), (yyvsp[0].node));
				}
#line 52073 "gram.c" /* yacc.c:1646  */
    break;

  case 2308:
#line 16768 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[0].list), (yyvsp[-2].node)); }
#line 52079 "gram.c" /* yacc.c:1646  */
    break;

  case 2309:
#line 16769 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52085 "gram.c" /* yacc.c:1646  */
    break;

  case 2310:
#line 16770 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52091 "gram.c" /* yacc.c:1646  */
    break;

  case 2311:
#line 16774 "gram.y" /* yacc.c:1646  */
    {
					SubLink	   *n = makeNode(SubLink);

					n->subselect = (yyvsp[0].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *) n;
				}
#line 52103 "gram.c" /* yacc.c:1646  */
    break;

  case 2312:
#line 16781 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) (yyvsp[-1].list); }
#line 52109 "gram.c" /* yacc.c:1646  */
    break;

  case 2313:
#line 16792 "gram.y" /* yacc.c:1646  */
    {
					CaseExpr   *c = makeNode(CaseExpr);

					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[-3].node);
					c->args = (yyvsp[-2].list);
					c->defresult = (Expr *) (yyvsp[-1].node);
					c->location = (yylsp[-4]);
					(yyval.node) = (Node *) c;
				}
#line 52124 "gram.c" /* yacc.c:1646  */
    break;

  case 2314:
#line 16806 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52130 "gram.c" /* yacc.c:1646  */
    break;

  case 2315:
#line 16807 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52136 "gram.c" /* yacc.c:1646  */
    break;

  case 2316:
#line 16812 "gram.y" /* yacc.c:1646  */
    {
					CaseWhen   *w = makeNode(CaseWhen);

					w->expr = (Expr *) (yyvsp[-2].node);
					w->result = (Expr *) (yyvsp[0].node);
					w->location = (yylsp[-3]);
					(yyval.node) = (Node *) w;
				}
#line 52149 "gram.c" /* yacc.c:1646  */
    break;

  case 2317:
#line 16823 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 52155 "gram.c" /* yacc.c:1646  */
    break;

  case 2318:
#line 16824 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52161 "gram.c" /* yacc.c:1646  */
    break;

  case 2319:
#line 16827 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 52167 "gram.c" /* yacc.c:1646  */
    break;

  case 2320:
#line 16828 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52173 "gram.c" /* yacc.c:1646  */
    break;

  case 2321:
#line 16832 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[0].str), NIL, (yylsp[0]), yyscanner);
				}
#line 52181 "gram.c" /* yacc.c:1646  */
    break;

  case 2322:
#line 16836 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeColumnRef((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 52189 "gram.c" /* yacc.c:1646  */
    break;

  case 2323:
#line 16843 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeString((yyvsp[0].str));
				}
#line 52197 "gram.c" /* yacc.c:1646  */
    break;

  case 2324:
#line 16847 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				}
#line 52205 "gram.c" /* yacc.c:1646  */
    break;

  case 2325:
#line 16851 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = false;
					ai->lidx = NULL;
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 52218 "gram.c" /* yacc.c:1646  */
    break;

  case 2326:
#line 16860 "gram.y" /* yacc.c:1646  */
    {
					A_Indices *ai = makeNode(A_Indices);

					ai->is_slice = true;
					ai->lidx = (yyvsp[-3].node);
					ai->uidx = (yyvsp[-1].node);
					(yyval.node) = (Node *) ai;
				}
#line 52231 "gram.c" /* yacc.c:1646  */
    break;

  case 2327:
#line 16871 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[0].node); }
#line 52237 "gram.c" /* yacc.c:1646  */
    break;

  case 2328:
#line 16872 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52243 "gram.c" /* yacc.c:1646  */
    break;

  case 2329:
#line 16876 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52249 "gram.c" /* yacc.c:1646  */
    break;

  case 2330:
#line 16877 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52255 "gram.c" /* yacc.c:1646  */
    break;

  case 2331:
#line 16881 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52261 "gram.c" /* yacc.c:1646  */
    break;

  case 2332:
#line 16882 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-1].list), (yyvsp[0].node)); }
#line 52267 "gram.c" /* yacc.c:1646  */
    break;

  case 2335:
#line 16891 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52273 "gram.c" /* yacc.c:1646  */
    break;

  case 2336:
#line 16892 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52279 "gram.c" /* yacc.c:1646  */
    break;

  case 2337:
#line 16896 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52285 "gram.c" /* yacc.c:1646  */
    break;

  case 2338:
#line 16897 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 52291 "gram.c" /* yacc.c:1646  */
    break;

  case 2339:
#line 16902 "gram.y" /* yacc.c:1646  */
    {
				JsonArgument *n = makeNode(JsonArgument);

				n->val = (JsonValueExpr *) (yyvsp[-2].node);
				n->name = (yyvsp[0].str);
				(yyval.node) = (Node *) n;
			}
#line 52303 "gram.c" /* yacc.c:1646  */
    break;

  case 2340:
#line 16913 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_NONE; }
#line 52309 "gram.c" /* yacc.c:1646  */
    break;

  case 2341:
#line 16914 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_NONE; }
#line 52315 "gram.c" /* yacc.c:1646  */
    break;

  case 2342:
#line 16915 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52321 "gram.c" /* yacc.c:1646  */
    break;

  case 2343:
#line 16916 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52327 "gram.c" /* yacc.c:1646  */
    break;

  case 2344:
#line 16917 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_CONDITIONAL; }
#line 52333 "gram.c" /* yacc.c:1646  */
    break;

  case 2345:
#line 16918 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52339 "gram.c" /* yacc.c:1646  */
    break;

  case 2346:
#line 16919 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_CONDITIONAL; }
#line 52345 "gram.c" /* yacc.c:1646  */
    break;

  case 2347:
#line 16920 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNCONDITIONAL; }
#line 52351 "gram.c" /* yacc.c:1646  */
    break;

  case 2348:
#line 16921 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSW_UNSPEC; }
#line 52357 "gram.c" /* yacc.c:1646  */
    break;

  case 2349:
#line 16926 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonBehavior(JSON_BEHAVIOR_DEFAULT, (yyvsp[0].node), (yylsp[-1])); }
#line 52363 "gram.c" /* yacc.c:1646  */
    break;

  case 2350:
#line 16928 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (Node *) makeJsonBehavior((yyvsp[0].ival), NULL, (yylsp[0])); }
#line 52369 "gram.c" /* yacc.c:1646  */
    break;

  case 2351:
#line 16932 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_ERROR; }
#line 52375 "gram.c" /* yacc.c:1646  */
    break;

  case 2352:
#line 16933 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_NULL; }
#line 52381 "gram.c" /* yacc.c:1646  */
    break;

  case 2353:
#line 16934 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_TRUE; }
#line 52387 "gram.c" /* yacc.c:1646  */
    break;

  case 2354:
#line 16935 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_FALSE; }
#line 52393 "gram.c" /* yacc.c:1646  */
    break;

  case 2355:
#line 16936 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_UNKNOWN; }
#line 52399 "gram.c" /* yacc.c:1646  */
    break;

  case 2356:
#line 16937 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 52405 "gram.c" /* yacc.c:1646  */
    break;

  case 2357:
#line 16938 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_OBJECT; }
#line 52411 "gram.c" /* yacc.c:1646  */
    break;

  case 2358:
#line 16940 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JSON_BEHAVIOR_EMPTY_ARRAY; }
#line 52417 "gram.c" /* yacc.c:1646  */
    break;

  case 2359:
#line 16945 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-2].node), NULL); }
#line 52423 "gram.c" /* yacc.c:1646  */
    break;

  case 2360:
#line 16947 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, (yyvsp[-2].node)); }
#line 52429 "gram.c" /* yacc.c:1646  */
    break;

  case 2361:
#line 16949 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2((yyvsp[-5].node), (yyvsp[-2].node)); }
#line 52435 "gram.c" /* yacc.c:1646  */
    break;

  case 2362:
#line 16951 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make2(NULL, NULL); }
#line 52441 "gram.c" /* yacc.c:1646  */
    break;

  case 2363:
#line 16956 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = (yyvsp[-2].node); }
#line 52447 "gram.c" /* yacc.c:1646  */
    break;

  case 2364:
#line 16958 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52453 "gram.c" /* yacc.c:1646  */
    break;

  case 2365:
#line 16963 "gram.y" /* yacc.c:1646  */
    {
				/* formatted_expr will be set during parse-analysis. */
				(yyval.node) = (Node *) makeJsonValueExpr((Expr *) (yyvsp[-1].node), NULL,
												castNode(JsonFormat, (yyvsp[0].node)));
			}
#line 52463 "gram.c" /* yacc.c:1646  */
    break;

  case 2366:
#line 16972 "gram.y" /* yacc.c:1646  */
    {
					int		encoding;

					if (!pg_strcasecmp((yyvsp[0].str), "utf8"))
						encoding = JS_ENC_UTF8;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf16"))
						encoding = JS_ENC_UTF16;
					else if (!pg_strcasecmp((yyvsp[0].str), "utf32"))
						encoding = JS_ENC_UTF32;
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("unrecognized JSON encoding: %s", (yyvsp[0].str))));

					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, encoding, (yylsp[-3]));
				}
#line 52484 "gram.c" /* yacc.c:1646  */
    break;

  case 2367:
#line 16989 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_JSON, JS_ENC_DEFAULT, (yylsp[-1]));
				}
#line 52492 "gram.c" /* yacc.c:1646  */
    break;

  case 2368:
#line 16996 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (yyvsp[0].node);
				}
#line 52500 "gram.c" /* yacc.c:1646  */
    break;

  case 2369:
#line 17000 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = (Node *) makeJsonFormat(JS_FORMAT_DEFAULT, JS_ENC_DEFAULT, -1);
				}
#line 52508 "gram.c" /* yacc.c:1646  */
    break;

  case 2370:
#line 17006 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_KEEP; }
#line 52514 "gram.c" /* yacc.c:1646  */
    break;

  case 2371:
#line 17007 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_KEEP; }
#line 52520 "gram.c" /* yacc.c:1646  */
    break;

  case 2372:
#line 17008 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_OMIT; }
#line 52526 "gram.c" /* yacc.c:1646  */
    break;

  case 2373:
#line 17009 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_OMIT; }
#line 52532 "gram.c" /* yacc.c:1646  */
    break;

  case 2374:
#line 17010 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_QUOTES_UNSPEC; }
#line 52538 "gram.c" /* yacc.c:1646  */
    break;

  case 2375:
#line 17015 "gram.y" /* yacc.c:1646  */
    {
					JsonOutput *n = makeNode(JsonOutput);

					n->typeName = (yyvsp[-1].typnam);
					n->returning = makeNode(JsonReturning);
					n->returning->format = (JsonFormat *) (yyvsp[0].node);
					(yyval.node) = (Node *) n;
				}
#line 52551 "gram.c" /* yacc.c:1646  */
    break;

  case 2376:
#line 17023 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = NULL; }
#line 52557 "gram.c" /* yacc.c:1646  */
    break;

  case 2377:
#line 17037 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 52563 "gram.c" /* yacc.c:1646  */
    break;

  case 2378:
#line 17038 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ANY; }
#line 52569 "gram.c" /* yacc.c:1646  */
    break;

  case 2379:
#line 17039 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_ARRAY; }
#line 52575 "gram.c" /* yacc.c:1646  */
    break;

  case 2380:
#line 17040 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_OBJECT; }
#line 52581 "gram.c" /* yacc.c:1646  */
    break;

  case 2381:
#line 17041 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = JS_TYPE_SCALAR; }
#line 52587 "gram.c" /* yacc.c:1646  */
    break;

  case 2382:
#line 17050 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52593 "gram.c" /* yacc.c:1646  */
    break;

  case 2383:
#line 17051 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52599 "gram.c" /* yacc.c:1646  */
    break;

  case 2384:
#line 17052 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52605 "gram.c" /* yacc.c:1646  */
    break;

  case 2385:
#line 17053 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52611 "gram.c" /* yacc.c:1646  */
    break;

  case 2386:
#line 17054 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52617 "gram.c" /* yacc.c:1646  */
    break;

  case 2387:
#line 17059 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52623 "gram.c" /* yacc.c:1646  */
    break;

  case 2388:
#line 17061 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node)); }
#line 52629 "gram.c" /* yacc.c:1646  */
    break;

  case 2389:
#line 17071 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52635 "gram.c" /* yacc.c:1646  */
    break;

  case 2390:
#line 17074 "gram.y" /* yacc.c:1646  */
    { (yyval.node) = makeJsonKeyValue((yyvsp[-2].node), (yyvsp[0].node)); }
#line 52641 "gram.c" /* yacc.c:1646  */
    break;

  case 2391:
#line 17079 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52647 "gram.c" /* yacc.c:1646  */
    break;

  case 2392:
#line 17080 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52653 "gram.c" /* yacc.c:1646  */
    break;

  case 2393:
#line 17081 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52659 "gram.c" /* yacc.c:1646  */
    break;

  case 2394:
#line 17085 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = false; }
#line 52665 "gram.c" /* yacc.c:1646  */
    break;

  case 2395:
#line 17086 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52671 "gram.c" /* yacc.c:1646  */
    break;

  case 2396:
#line 17087 "gram.y" /* yacc.c:1646  */
    { (yyval.boolean) = true; }
#line 52677 "gram.c" /* yacc.c:1646  */
    break;

  case 2397:
#line 17091 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].node)); }
#line 52683 "gram.c" /* yacc.c:1646  */
    break;

  case 2398:
#line 17092 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].node));}
#line 52689 "gram.c" /* yacc.c:1646  */
    break;

  case 2399:
#line 17102 "gram.y" /* yacc.c:1646  */
    {
					JsonObjectAgg *n = makeNode(JsonObjectAgg);

					n->arg = (JsonKeyValue *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-3].boolean);
					n->unique = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->agg_order = NULL;
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52706 "gram.c" /* yacc.c:1646  */
    break;

  case 2400:
#line 17120 "gram.y" /* yacc.c:1646  */
    {
					JsonArrayAgg *n = makeNode(JsonArrayAgg);

					n->arg = (JsonValueExpr *) (yyvsp[-4].node);
					n->absent_on_null = (yyvsp[-2].boolean);
					n->constructor = makeNode(JsonAggConstructor);
					n->constructor->agg_order = (yyvsp[-3].list);
					n->constructor->output = (JsonOutput *) (yyvsp[-1].node);
					n->constructor->location = (yylsp[-6]);
					(yyval.node) = (Node *) n;
				}
#line 52722 "gram.c" /* yacc.c:1646  */
    break;

  case 2401:
#line 17134 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52728 "gram.c" /* yacc.c:1646  */
    break;

  case 2402:
#line 17135 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52734 "gram.c" /* yacc.c:1646  */
    break;

  case 2403:
#line 17144 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = (yyvsp[0].list); }
#line 52740 "gram.c" /* yacc.c:1646  */
    break;

  case 2404:
#line 17145 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = NIL; }
#line 52746 "gram.c" /* yacc.c:1646  */
    break;

  case 2405:
#line 17149 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].target)); }
#line 52752 "gram.c" /* yacc.c:1646  */
    break;

  case 2406:
#line 17150 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].target)); }
#line 52758 "gram.c" /* yacc.c:1646  */
    break;

  case 2407:
#line 17154 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-2].node);
					(yyval.target)->location = (yylsp[-2]);
				}
#line 52770 "gram.c" /* yacc.c:1646  */
    break;

  case 2408:
#line 17162 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[0].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[-1].node);
					(yyval.target)->location = (yylsp[-1]);
				}
#line 52782 "gram.c" /* yacc.c:1646  */
    break;

  case 2409:
#line 17170 "gram.y" /* yacc.c:1646  */
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[0].node);
					(yyval.target)->location = (yylsp[0]);
				}
#line 52794 "gram.c" /* yacc.c:1646  */
    break;

  case 2410:
#line 17178 "gram.y" /* yacc.c:1646  */
    {
					ColumnRef  *n = makeNode(ColumnRef);

					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[0]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) n;
					(yyval.target)->location = (yylsp[0]);
				}
#line 52811 "gram.c" /* yacc.c:1646  */
    break;

  case 2411:
#line 17200 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].range)); }
#line 52817 "gram.c" /* yacc.c:1646  */
    break;

  case 2412:
#line 17201 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].range)); }
#line 52823 "gram.c" /* yacc.c:1646  */
    break;

  case 2413:
#line 17213 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVar(NULL, (yyvsp[0].str), (yylsp[0]));
				}
#line 52831 "gram.c" /* yacc.c:1646  */
    break;

  case 2414:
#line 17217 "gram.y" /* yacc.c:1646  */
    {
					(yyval.range) = makeRangeVarFromQualifiedName((yyvsp[-1].str), (yyvsp[0].list), (yylsp[-1]), yyscanner);
				}
#line 52839 "gram.c" /* yacc.c:1646  */
    break;

  case 2415:
#line 17223 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52845 "gram.c" /* yacc.c:1646  */
    break;

  case 2416:
#line 17225 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), makeString((yyvsp[0].str))); }
#line 52851 "gram.c" /* yacc.c:1646  */
    break;

  case 2417:
#line 17229 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52857 "gram.c" /* yacc.c:1646  */
    break;

  case 2418:
#line 17231 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52863 "gram.c" /* yacc.c:1646  */
    break;

  case 2419:
#line 17233 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 52869 "gram.c" /* yacc.c:1646  */
    break;

  case 2420:
#line 17244 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1(makeString((yyvsp[0].str))); }
#line 52875 "gram.c" /* yacc.c:1646  */
    break;

  case 2421:
#line 17246 "gram.y" /* yacc.c:1646  */
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[-1].str)), (yyvsp[0].list)),
											 yyscanner);
					}
#line 52884 "gram.c" /* yacc.c:1646  */
    break;

  case 2422:
#line 17257 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeIntConst((yyvsp[0].ival), (yylsp[0]));
				}
#line 52892 "gram.c" /* yacc.c:1646  */
    break;

  case 2423:
#line 17261 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeFloatConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52900 "gram.c" /* yacc.c:1646  */
    break;

  case 2424:
#line 17265 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52908 "gram.c" /* yacc.c:1646  */
    break;

  case 2425:
#line 17269 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52916 "gram.c" /* yacc.c:1646  */
    break;

  case 2426:
#line 17273 "gram.y" /* yacc.c:1646  */
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[0].str), (yylsp[0]));
				}
#line 52929 "gram.c" /* yacc.c:1646  */
    break;

  case 2427:
#line 17282 "gram.y" /* yacc.c:1646  */
    {
					/* generic type 'literal' syntax */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-1].list));

					t->location = (yylsp[-1]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52941 "gram.c" /* yacc.c:1646  */
    break;

  case 2428:
#line 17290 "gram.y" /* yacc.c:1646  */
    {
					/* generic syntax with a type modifier */
					TypeName   *t = makeTypeNameFromNameList((yyvsp[-5].list));
					ListCell   *lc;

					/*
					 * We must use func_arg_list and opt_sort_clause in the
					 * production to avoid reduce/reduce conflicts, but we
					 * don't actually wish to allow NamedArgExpr in this
					 * context, nor ORDER BY.
					 */
					foreach(lc, (yyvsp[-3].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have parameter name"),
									 parser_errposition(arg->location)));
					}
					if ((yyvsp[-2].list) != NIL)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("type modifier cannot have ORDER BY"),
									 parser_errposition((yylsp[-2]))));

					t->typmods = (yyvsp[-3].list);
					t->location = (yylsp[-5]);
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 52977 "gram.c" /* yacc.c:1646  */
    break;

  case 2429:
#line 17322 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), (yyvsp[-1].typnam));
				}
#line 52985 "gram.c" /* yacc.c:1646  */
    break;

  case 2430:
#line 17326 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-2].typnam);

					t->typmods = (yyvsp[0].list);
					(yyval.node) = makeStringConstCast((yyvsp[-1].str), (yylsp[-1]), t);
				}
#line 52996 "gram.c" /* yacc.c:1646  */
    break;

  case 2431:
#line 17333 "gram.y" /* yacc.c:1646  */
    {
					TypeName   *t = (yyvsp[-4].typnam);

					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
											makeIntConst((yyvsp[-2].ival), (yylsp[-2])));
					(yyval.node) = makeStringConstCast((yyvsp[0].str), (yylsp[0]), t);
				}
#line 53008 "gram.c" /* yacc.c:1646  */
    break;

  case 2432:
#line 17341 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(true, (yylsp[0]));
				}
#line 53016 "gram.c" /* yacc.c:1646  */
    break;

  case 2433:
#line 17345 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeBoolAConst(false, (yylsp[0]));
				}
#line 53024 "gram.c" /* yacc.c:1646  */
    break;

  case 2434:
#line 17349 "gram.y" /* yacc.c:1646  */
    {
					(yyval.node) = makeNullAConst((yylsp[0]));
				}
#line 53032 "gram.c" /* yacc.c:1646  */
    break;

  case 2435:
#line 17354 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 53038 "gram.c" /* yacc.c:1646  */
    break;

  case 2436:
#line 17355 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53044 "gram.c" /* yacc.c:1646  */
    break;

  case 2437:
#line 17357 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = (yyvsp[0].ival); }
#line 53050 "gram.c" /* yacc.c:1646  */
    break;

  case 2438:
#line 17358 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = + (yyvsp[0].ival); }
#line 53056 "gram.c" /* yacc.c:1646  */
    break;

  case 2439:
#line 17359 "gram.y" /* yacc.c:1646  */
    { (yyval.ival) = - (yyvsp[0].ival); }
#line 53062 "gram.c" /* yacc.c:1646  */
    break;

  case 2440:
#line 17364 "gram.y" /* yacc.c:1646  */
    {
					RoleSpec   *spc = (RoleSpec *) (yyvsp[0].rolespec);

					switch (spc->roletype)
					{
						case ROLESPEC_CSTRING:
							(yyval.str) = spc->rolename;
							break;
						case ROLESPEC_PUBLIC:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("role name \"%s\" is reserved",
											"public"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_SESSION_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"SESSION_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_USER:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_USER"),
									 parser_errposition((yylsp[0]))));
							break;
						case ROLESPEC_CURRENT_ROLE:
							ereport(ERROR,
									(errcode(ERRCODE_RESERVED_NAME),
									 errmsg("%s cannot be used as a role name here",
											"CURRENT_ROLE"),
									 parser_errposition((yylsp[0]))));
							break;
					}
				}
#line 53105 "gram.c" /* yacc.c:1646  */
    break;

  case 2441:
#line 17405 "gram.y" /* yacc.c:1646  */
    {
					/*
					 * "public" and "none" are not keywords, but they must
					 * be treated specially here.
					 */
					RoleSpec   *n;

					if (strcmp((yyvsp[0].str), "public") == 0)
					{
						n = (RoleSpec *) makeRoleSpec(ROLESPEC_PUBLIC, (yylsp[0]));
						n->roletype = ROLESPEC_PUBLIC;
					}
					else if (strcmp((yyvsp[0].str), "none") == 0)
					{
						ereport(ERROR,
								(errcode(ERRCODE_RESERVED_NAME),
								 errmsg("role name \"%s\" is reserved",
										"none"),
								 parser_errposition((yylsp[0]))));
					}
					else
					{
						n = makeRoleSpec(ROLESPEC_CSTRING, (yylsp[0]));
						n->rolename = pstrdup((yyvsp[0].str));
					}
					(yyval.rolespec) = n;
				}
#line 53137 "gram.c" /* yacc.c:1646  */
    break;

  case 2442:
#line 17433 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_ROLE, (yylsp[0]));
				}
#line 53145 "gram.c" /* yacc.c:1646  */
    break;

  case 2443:
#line 17437 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_CURRENT_USER, (yylsp[0]));
				}
#line 53153 "gram.c" /* yacc.c:1646  */
    break;

  case 2444:
#line 17441 "gram.y" /* yacc.c:1646  */
    {
					(yyval.rolespec) = makeRoleSpec(ROLESPEC_SESSION_USER, (yylsp[0]));
				}
#line 53161 "gram.c" /* yacc.c:1646  */
    break;

  case 2445:
#line 17447 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = list_make1((yyvsp[0].rolespec)); }
#line 53167 "gram.c" /* yacc.c:1646  */
    break;

  case 2446:
#line 17449 "gram.y" /* yacc.c:1646  */
    { (yyval.list) = lappend((yyvsp[-2].list), (yyvsp[0].rolespec)); }
#line 53173 "gram.c" /* yacc.c:1646  */
    break;

  case 2447:
#line 17466 "gram.y" /* yacc.c:1646  */
    {
					SelectStmt *n = makeNode(SelectStmt);

					n->distinctClause = (yyvsp[-9].list);
					n->targetList = (yyvsp[-8].list);
					n->fromClause = (yyvsp[-7].list);
					n->whereClause = (yyvsp[-6].node);
					n->groupClause = ((yyvsp[-5].groupclause))->list;
					n->groupDistinct = ((yyvsp[-5].groupclause))->distinct;
					n->havingClause = (yyvsp[-4].node);
					n->windowClause = (yyvsp[-3].list);
					n->sortClause = (yyvsp[-2].list);
					if ((yyvsp[-1].selectlimit))
					{
						n->limitOffset = (yyvsp[-1].selectlimit)->limitOffset;
						n->limitCount = (yyvsp[-1].selectlimit)->limitCount;
						if (!n->sortClause &&
							(yyvsp[-1].selectlimit)->limitOption == LIMIT_OPTION_WITH_TIES)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
						n->limitOption = (yyvsp[-1].selectlimit)->limitOption;
					}
					n->lockingClause = (yyvsp[0].list);
					(yyval.node) = (Node *) n;
				}
#line 53204 "gram.c" /* yacc.c:1646  */
    break;

  case 2448:
#line 17499 "gram.y" /* yacc.c:1646  */
    {
					PLAssignStmt *n = makeNode(PLAssignStmt);

					n->name = (yyvsp[-3].str);
					n->indirection = check_indirection((yyvsp[-2].list), yyscanner);
					/* nnames will be filled by calling production */
					n->val = (SelectStmt *) (yyvsp[0].node);
					n->location = (yylsp[-3]);
					(yyval.node) = (Node *) n;
				}
#line 53219 "gram.c" /* yacc.c:1646  */
    break;

  case 2449:
#line 17511 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53225 "gram.c" /* yacc.c:1646  */
    break;

  case 2450:
#line 17512 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = psprintf("$%d", (yyvsp[0].ival)); }
#line 53231 "gram.c" /* yacc.c:1646  */
    break;

  case 2453:
#line 17533 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53237 "gram.c" /* yacc.c:1646  */
    break;

  case 2454:
#line 17534 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53243 "gram.c" /* yacc.c:1646  */
    break;

  case 2455:
#line 17535 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53249 "gram.c" /* yacc.c:1646  */
    break;

  case 2456:
#line 17540 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53255 "gram.c" /* yacc.c:1646  */
    break;

  case 2457:
#line 17541 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53261 "gram.c" /* yacc.c:1646  */
    break;

  case 2458:
#line 17542 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53267 "gram.c" /* yacc.c:1646  */
    break;

  case 2459:
#line 17547 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53273 "gram.c" /* yacc.c:1646  */
    break;

  case 2460:
#line 17548 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53279 "gram.c" /* yacc.c:1646  */
    break;

  case 2461:
#line 17549 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53285 "gram.c" /* yacc.c:1646  */
    break;

  case 2462:
#line 17550 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53291 "gram.c" /* yacc.c:1646  */
    break;

  case 2463:
#line 17556 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53297 "gram.c" /* yacc.c:1646  */
    break;

  case 2464:
#line 17557 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53303 "gram.c" /* yacc.c:1646  */
    break;

  case 2465:
#line 17558 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53309 "gram.c" /* yacc.c:1646  */
    break;

  case 2466:
#line 17559 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53315 "gram.c" /* yacc.c:1646  */
    break;

  case 2467:
#line 17560 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53321 "gram.c" /* yacc.c:1646  */
    break;

  case 2468:
#line 17566 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 53327 "gram.c" /* yacc.c:1646  */
    break;

  case 2469:
#line 17567 "gram.y" /* yacc.c:1646  */
    { (yyval.str) = pstrdup((yyvsp[0].keyword)); }
#line 53333 "gram.c" /* yacc.c:1646  */
    break;


#line 53337 "gram.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 18579 "gram.y" /* yacc.c:1906  */


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static RawStmt *
makeRawStmt(Node *stmt, int stmt_location)
{
	RawStmt    *rs = makeNode(RawStmt);

	rs->stmt = stmt;
	rs->stmt_location = stmt_location;
	rs->stmt_len = 0;			/* might get changed later */
	return rs;
}

/* Adjust a RawStmt to reflect that it doesn't run to the end of the string */
static void
updateRawStmtEnd(RawStmt *rs, int end_location)
{
	/*
	 * If we already set the length, don't change it.  This is for situations
	 * like "select foo ;; select bar" where the same statement will be last
	 * in the string for more than one semicolon.
	 */
	if (rs->stmt_len > 0)
		return;

	/* OK, update length of RawStmt */
	rs->stmt_len = end_location - rs->stmt_location;
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int			nfields = 0;
	ListCell   *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast   *n = makeNode(TypeCast);

	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node       *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

Node *
makeIntConst(int val, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.ival.type = T_Integer;
	n->val.ival.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const    *n = makeNode(A_Const);

	n->val.fval.type = T_Float;
	n->val.fval.fval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBoolAConst(bool state, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.boolval.type = T_Boolean;
    n->val.boolval.boolval = state;
    n->location = location;

   return (Node *) n;
}

static Node *
makeBitStringConst(char *str, int location)
{
    A_Const    *n = makeNode(A_Const);

    n->val.bsval.type = T_BitString;
    n->val.bsval.bsval = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
    A_Const    *n = makeNode(A_Const);

    n->isnull = true;
    n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Node *v, int location)
{
	Node       *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(castNode(Float, v)->fval, location);
			break;

		case T_Integer:
			n = makeIntConst(castNode(Integer, v)->ival, location);
			break;

		default:
			/* currently not used */
			Assert(false);
			n = NULL;
	}

	return n;
}

/* makeRoleSpec
 * Create a RoleSpec with the given type
 */
static RoleSpec *
makeRoleSpec(RoleSpecType type, int location)
{
	RoleSpec   *spec = makeNode(RoleSpec);

	spec->roletype = type;
	spec->location = location;

	return spec;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(indirection, l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* extractAggrArgTypes()
 * As above, but work from the output of the aggr_args production.
 */
static List *
extractAggrArgTypes(List *aggrargs)
{
	Assert(list_length(aggrargs) == 2);
	return extractArgTypes((List *) linitial(aggrargs));
}

/* makeOrderedSetArgs()
 * Build the result of the aggr_args production (which see the comments for).
 * This handles only the case where both given lists are nonempty, so that
 * we have to deal with multiple VARIADIC arguments.
 */
static List *
makeOrderedSetArgs(List *directargs, List *orderedargs,
				   core_yyscan_t yyscanner)
{
	FunctionParameter *lastd = (FunctionParameter *) llast(directargs);
	Integer	   *ndirectargs;

	/* No restriction unless last direct arg is VARIADIC */
	if (lastd->mode == FUNC_PARAM_VARIADIC)
	{
		FunctionParameter *firsto = (FunctionParameter *) linitial(orderedargs);

		/*
		 * We ignore the names, though the aggr_arg production allows them;
		 * it doesn't allow default values, so those need not be checked.
		 */
		if (list_length(orderedargs) != 1 ||
			firsto->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 errmsg("an ordered-set aggregate with a VARIADIC direct argument must have one VARIADIC aggregated argument of the same data type"),
					 parser_errposition(exprLocation((Node *) firsto))));

		/* OK, drop the duplicate VARIADIC argument from the internal form */
		orderedargs = NIL;
	}

	/* don't merge into the next line, as list_concat changes directargs */
	ndirectargs = makeInteger(list_length(directargs));

	return list_make2(list_concat(directargs, orderedargs),
					  ndirectargs);
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					SelectLimit *limitClause,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitClause && limitClause->limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitOffset))));
		stmt->limitOffset = limitClause->limitOffset;
	}
	if (limitClause && limitClause->limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitClause->limitCount))));
		stmt->limitCount = limitClause->limitCount;
	}
	if (limitClause)
	{
		if (stmt->limitOption)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple limit options not allowed")));
		if (!stmt->sortClause && limitClause->limitOption == LIMIT_OPTION_WITH_TIES)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("WITH TIES cannot be specified without ORDER BY clause")));
		if (limitClause->limitOption == LIMIT_OPTION_WITH_TIES && stmt->lockingClause)
		{
			ListCell   *lc;

			foreach(lc, stmt->lockingClause)
			{
				LockingClause *lock = lfirst_node(LockingClause, lc);

				if (lock->waitPolicy == LockWaitSkip)
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("%s and %s options cannot be used together",
									"SKIP LOCKED", "WITH TIES")));
			}
		}
		stmt->limitOption = limitClause->limitOption;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}
/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const	   *con = (A_Const *) n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (IsA(&con->val, Integer))
		{
			con->val.ival.ival = -con->val.ival.ival;
			return n;
		}
		if (IsA(&con->val, Float))
		{
			doNegateFloat(&con->val.fval);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Float *v)
{
	char	   *oldval = v->fval;

	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->fval = oldval+1;	/* just strip the '-' */
	else
		v->fval = psprintf("-%s", oldval);
}

static Node *
makeAndExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a AND b AND c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == AND_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(AND_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeOrExpr(Node *lexpr, Node *rexpr, int location)
{
	/* Flatten "a OR b OR c ..." to a single BoolExpr on sight */
	if (IsA(lexpr, BoolExpr))
	{
		BoolExpr   *blexpr = (BoolExpr *) lexpr;

		if (blexpr->boolop == OR_EXPR)
		{
			blexpr->args = lappend(blexpr->args, rexpr);
			return (Node *) blexpr;
		}
	}
	return (Node *) makeBoolExpr(OR_EXPR, list_make2(lexpr, rexpr), location);
}

static Node *
makeNotExpr(Node *expr, int location)
{
	return (Node *) makeBoolExpr(NOT_EXPR, list_make1(expr), location);
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeSQLValueFunction(SQLValueFunctionOp op, int32 typmod, int location)
{
	SQLValueFunction *svf = makeNode(SQLValueFunction);

	svf->op = op;
	/* svf->type will be filled during parse analysis */
	svf->typmod = typmod;
	svf->location = location;
	return (Node *) svf;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr		*x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_DEFAULT &&
			p->mode != FUNC_PARAM_IN &&
			p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName   *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Convert a list of (dotted) names to a RangeVar (like
 * makeRangeVarFromNameList, but with position support).  The
 * "AnyName" refers to the any_name production in the grammar.
 */
static RangeVar *
makeRangeVarFromAnyName(List *names, int position, core_yyscan_t yyscanner)
{
	RangeVar   *r = makeNode(RangeVar);

	switch (list_length(names))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = NULL;
			r->relname = strVal(linitial(names));
			break;
		case 2:
			r->catalogname = NULL;
			r->schemaname = strVal(linitial(names));
			r->relname = strVal(lsecond(names));
			break;
		case 3:
			r->catalogname = strVal(linitial(names));
			r->schemaname = strVal(lsecond(names));
			r->relname = strVal(lthird(names));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
							NameListToString(names)),
					 parser_errposition(position)));
			break;
	}

	r->relpersistence = RELPERSISTENCE_PERMANENT;
	r->location = position;

	return r;
}

/*
 * Convert a relation_name with name and namelist to a RangeVar using
 * makeRangeVar.
 */
static RangeVar *
makeRangeVarFromQualifiedName(char *name, List *namelist, int location,
							  core_yyscan_t yyscanner)
{
	RangeVar   *r;

	check_qualified_name(namelist, yyscanner);
	r = makeRangeVar(NULL, NULL, location);

	switch (list_length(namelist))
	{
		case 1:
			r->catalogname = NULL;
			r->schemaname = name;
			r->relname = strVal(linitial(namelist));
			break;
		case 2:
			r->catalogname = name;
			r->schemaname = strVal(linitial(namelist));
			r->relname = strVal(lsecond(namelist));
			break;
		default:
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("improper qualified name (too many dotted names): %s",
						   NameListToString(lcons(makeString(name), namelist))),
						   parser_errposition(location)));
			break;
	}

	return r;
}

/* Separate Constraint nodes from COLLATE clauses in a ColQualList */
static void
SplitColQualList(List *qualList,
				 List **constraintList, CollateClause **collClause,
				 core_yyscan_t yyscanner)
{
	ListCell   *cell;

	*collClause = NULL;
	foreach(cell, qualList)
	{
		Node	   *n = (Node *) lfirst(cell);

		if (IsA(n, Constraint))
		{
			/* keep it in list */
			continue;
		}
		if (IsA(n, CollateClause))
		{
			CollateClause *c = (CollateClause *) n;

			if (*collClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("multiple COLLATE clauses not allowed"),
						 parser_errposition(c->location)));
			*collClause = c;
		}
		else
			elog(ERROR, "unexpected node type %d", (int) n->type);
		/* remove non-Constraint nodes from qualList */
		qualList = foreach_delete_current(qualList, cell);
	}
	*constraintList = qualList;
}

/*
 * Process result of ConstraintAttributeSpec, and set appropriate bool flags
 * in the output command node.  Pass NULL for any flags the particular
 * command doesn't support.
 */
static void
processCASbits(int cas_bits, int location, const char *constrType,
			   bool *deferrable, bool *initdeferred, bool *not_valid,
			   bool *no_inherit, core_yyscan_t yyscanner)
{
	/* defaults */
	if (deferrable)
		*deferrable = false;
	if (initdeferred)
		*initdeferred = false;
	if (not_valid)
		*not_valid = false;

	if (cas_bits & (CAS_DEFERRABLE | CAS_INITIALLY_DEFERRED))
	{
		if (deferrable)
			*deferrable = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_INITIALLY_DEFERRED)
	{
		if (initdeferred)
			*initdeferred = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked DEFERRABLE",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NOT_VALID)
	{
		if (not_valid)
			*not_valid = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NOT VALID",
							constrType),
					 parser_errposition(location)));
	}

	if (cas_bits & CAS_NO_INHERIT)
	{
		if (no_inherit)
			*no_inherit = true;
		else
			ereport(ERROR,
					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
					 /* translator: %s is CHECK, UNIQUE, or similar */
					 errmsg("%s constraints cannot be marked NO INHERIT",
							constrType),
					 parser_errposition(location)));
	}
}

/*
 * Parse a user-supplied partition strategy string into parse node
 * PartitionStrategy representation, or die trying.
 */
static PartitionStrategy
parsePartitionStrategy(char *strategy)
{
	if (pg_strcasecmp(strategy, "list") == 0)
		return PARTITION_STRATEGY_LIST;
	else if (pg_strcasecmp(strategy, "range") == 0)
		return PARTITION_STRATEGY_RANGE;
	else if (pg_strcasecmp(strategy, "hash") == 0)
		return PARTITION_STRATEGY_HASH;

	ereport(ERROR,
			(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
			 errmsg("unrecognized partitioning strategy \"%s\"",
					strategy)));
	return PARTITION_STRATEGY_LIST;		/* keep compiler quiet */

}

/*
 * Process pubobjspec_list to check for errors in any of the objects and
 * convert PUBLICATIONOBJ_CONTINUATION into appropriate PublicationObjSpecType.
 */
static void
preprocess_pubobj_list(List *pubobjspec_list, core_yyscan_t yyscanner)
{
	ListCell   *cell;
	PublicationObjSpec *pubobj;
	PublicationObjSpecType prevobjtype = PUBLICATIONOBJ_CONTINUATION;

	if (!pubobjspec_list)
		return;

	pubobj = (PublicationObjSpec *) linitial(pubobjspec_list);
	if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("invalid publication object list"),
				 errdetail("One of TABLE or TABLES IN SCHEMA must be specified before a standalone table or schema name."),
				 parser_errposition(pubobj->location)));

	foreach(cell, pubobjspec_list)
	{
		pubobj = (PublicationObjSpec *) lfirst(cell);

		if (pubobj->pubobjtype == PUBLICATIONOBJ_CONTINUATION)
			pubobj->pubobjtype = prevobjtype;

		if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLE)
		{
			/* relation name or pubtable must be set for this type of object */
			if (!pubobj->name && !pubobj->pubtable)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid table name"),
						 parser_errposition(pubobj->location)));

			if (pubobj->name)
			{
				/* convert it to PublicationTable */
				PublicationTable *pubtable = makeNode(PublicationTable);

				pubtable->relation =
					makeRangeVar(NULL, pubobj->name, pubobj->location);
				pubobj->pubtable = pubtable;
				pubobj->name = NULL;
			}
		}
		else if (pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_SCHEMA ||
				 pubobj->pubobjtype == PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA)
		{
			/* WHERE clause is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->whereClause)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("WHERE clause not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/* Column list is not allowed on a schema object */
			if (pubobj->pubtable && pubobj->pubtable->columns)
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("column specification not allowed for schema"),
						 parser_errposition(pubobj->location)));

			/*
			 * We can distinguish between the different type of schema
			 * objects based on whether name and pubtable is set.
			 */
			if (pubobj->name)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_SCHEMA;
			else if (!pubobj->name && !pubobj->pubtable)
				pubobj->pubobjtype = PUBLICATIONOBJ_TABLES_IN_CUR_SCHEMA;
			else
				ereport(ERROR,
						(errcode(ERRCODE_SYNTAX_ERROR),
						 errmsg("invalid schema name"),
						 parser_errposition(pubobj->location)));
		}

		prevobjtype = pubobj->pubobjtype;
	}
}

/*----------
 * Recursive view transformation
 *
 * Convert
 *
 *     CREATE RECURSIVE VIEW relname (aliases) AS query
 *
 * to
 *
 *     CREATE VIEW relname (aliases) AS
 *         WITH RECURSIVE relname (aliases) AS (query)
 *         SELECT aliases FROM relname
 *
 * Actually, just the WITH ... part, which is then inserted into the original
 * view definition as the query.
 * ----------
 */
static Node *
makeRecursiveViewSelect(char *relname, List *aliases, Node *query)
{
	SelectStmt *s = makeNode(SelectStmt);
	WithClause *w = makeNode(WithClause);
	CommonTableExpr *cte = makeNode(CommonTableExpr);
	List	   *tl = NIL;
	ListCell   *lc;

	/* create common table expression */
	cte->ctename = relname;
	cte->aliascolnames = aliases;
	cte->ctematerialized = CTEMaterializeDefault;
	cte->ctequery = query;
	cte->location = -1;

	/* create WITH clause and attach CTE */
	w->recursive = true;
	w->ctes = list_make1(cte);
	w->location = -1;

	/* create target list for the new SELECT from the alias list of the
	 * recursive view specification */
	foreach (lc, aliases)
	{
		ResTarget *rt = makeNode(ResTarget);

		rt->name = NULL;
		rt->indirection = NIL;
		rt->val = makeColumnRef(strVal(lfirst(lc)), NIL, -1, 0);
		rt->location = -1;

		tl = lappend(tl, rt);
	}

	/* create new SELECT combining WITH clause, target list, and fake FROM
	 * clause */
	s->withClause = w;
	s->targetList = tl;
	s->fromClause = list_make1(makeRangeVar(NULL, relname, -1));

	return (Node *) s;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

